\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("pol-pfrac.gp");
read("pol-ascend.gp");
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

gDO_total(x) = {
    4/17 * 1/(1 - x)
  - 1/4 * 1/(1 - 2*x)
  + 1/68 * (1 + 8*(2*x) + 4*(2*x)^2)/(1 - (2*x) - 2*(2*x)^3);
}
print("by gf ", gf_terms(gDO_total(x),16));

DO_total_by_n(k) = {
  sum(n=1,2^k,
      my(an=dragon_n_to_arm_and_other(n));
      if(an[1]==0 && an[2]<n, n-an[2]));
}
\\print("by n  ", vector(16,k,k--; DO_total_by_n(k)))

pol_ascending_print(pol_partial_fractions((1 + 8*(2*x) + 4*(2*x)^2)/(1 - (2*x) - 2*(2*x)^3)));
pol_ascending_print(pol_partial_fractions(1/4*gdJA(2*x)/x^2 + 4*gdJA(2*x)/x + 4*gdJA(2*x)));

DO_total(k) = {
  1/68 * 2^k * (4*dJA(k) + 8*dJA(k+1) + dJA(k+2) - 17) + 4/17;
}
print("by f  ", vector(16,k,k--; DO_total(k)))
check_exact(vector(100,k,k--; DO_total(k)), \
            gf_terms(gDO_total(x),100));

check_exact(vector(10,k,k--; DO_total_by_n(k)), \
            vector(10,k,k--; DO_total(k)));

gf_shift_down(g,n) = {
  my(x = variable(g));
  for(i=1,n, g -= gf_term(g,0); g /= x);
  g;
}
{
  check_exact(4*gdJA(x) + 8*gf_shift_down(gdJA(x),1) + gf_shift_down(gdJA(x),2),
              -10*gS(x) - 3*gf_shift_down(gS(x),1) + 6*gf_shift_down(gS(x),2));
}
check_exact(vector(100,k,k--; 4*dJA(k) + 8*dJA(k+1) + dJA(k+2)), \
            vector(100,k,k--; -10*S(k) -3*S(k+1) + 6*S(k+2)));

DO_total(k) = {
  1/68 * 2^k * (-10*S(k) -3*S(k+1) + 6*S(k+2) - 17) + 4/17;
}
check_exact(vector(100,k,k--; DO_total(k)), \
            gf_terms(gDO_total(x),100));

\\ S+2*D=2^k+1
check_exact(vector(100,k,k--; 2^k+1-2*D(k)), vector(100,k,k--; S(k)));
DO_total(k) = {
  1/68 * 2^k * (-10*(2^k+1-2*D(k)) -3*(2*2^k+1-2*D(k+1)) + 6*(4*2^k+1-2*D(k+2)) - 17) + 4/17;
}
check_exact(vector(100,k,k--; DO_total(k)), \
            gf_terms(gDO_total(x),100));

DO_total(k) = {
  1/68 * 2^k * (36*D(k) - 10*D(k+1) - 4*D(k+2) -16*D(k+3) + 8*D(k+4) - 24)
  + 4/17;
}
check_exact(vector(100,k,k--; DO_total(k)), \
            gf_terms(gDO_total(x),100));

{
  my(k=400);
  print(D(k+1)/D(k) *1.0);
  print(DO_total(k) / (2^k*D(k)) *1.0);
  print(log(DO_total(k+1)) - log(DO_total(k)));
  print(exp(1.221196090072956385746615703));
  print(2*r);
}
quit

\\-----------------------------------------------------------------------------
{
  my(k=7);
  print("k="k);
  my(seen=vector(2^k));
  for(n=1,2^k,
     my(an=dragon_n_to_arm_and_other(n));
     if(an[1]==0&&an[2]<n,
        my(l=valuation(n,2));
        my(m=BitAboveLowestOne(n));
        my(d=n-an[2]);
        print(an[2]"  "n"   "d"  m="m" l="l"  "binary_padded(n,k));
        seen[d]++));
  for(d=1,#seen,
      if(seen[d],
         print("d="d"  "seen[d]" times")));
}


\\                r
\\ k=4    !m=0 | 01 m=1 1
\\
\\                r=2
\\ k=5    | !m=1 01 m=0 1       21, 25  +4      k=4 m=0 at top         h=0
\\                 r=2
\\ k=5    | !m=0 01 m=1 1       7, 11  +4       k=4 again, shortened   h=0
\\                r=3
\\ k=5    !m=0 | 01 m=1 10      14, 22  +8      k=4 low 0              h=-1
\\                 r=2
\\ k=5    !m=0 | 011 m=1 1      15, 19  +4                             h=-1
\\
\\          l       r    
\\ notm 01111 m 01111 m 1 000

\\                5     2
\\ k=7    !m=0 | 01 m1 01 m1 1     2 runs

DO_total_by_low(k) =
{
  my(debug=0);
  if(debug,print("\nDO_total_by_low() k="k));

  \\ single run
  sum(l=2,k,              \\ low zeros
      sum(h=0,k-l-2,      \\ high arbitraries and m
          if(debug,print("h="h" l="l" is " 2*2^h * 2^(l+2)));
          2^(h+l)))
  \\ low run then recurse
  + 
  sum(l=0,k-3,
      my(t=DO_total(k-l-3) * 2^(l+3));
      if(t>0,
         if(debug,print("recurse l="l" "k-l-2"  t="t"  values "t+2^(l+2)","t-2^(l+2)));
         t+2^(l+2)  + t-2^(l+2)));
}
 DO_total_by_low(4)
 DO_total_by_low(5)
 DO_total_by_low(6)
 DO_total_by_low(7)
print("by f  ", vector(16,k,k--; DO_total_by_low(k)))

check_exact(vector(100,k,k--; DO_total_by_low(k)), \
            vector(100,k,k--; DO_total(k)));

\\ DO_odd_total_by_sum(k) = {
\\   my(t=DO_total_by_low(k-l));
\\   sum(l=3,k-1,
\\       my(t=DO_total_by_low(k-l));
\\       sum(r=2,l-3,
\\           if(t==0, 2^r,
\\              t>0, t+2^r + t-2^r)));
\\ }

\\-----------------------------------------------------------------------------
DO_single_run(k) =
{
  sum(l=2,k,              \\ low zeros
      sum(h=0,k-l-2,      \\ high arbitraries and m
          2^(h+l)));
}
print("single run ", vector(16,k,k--; DO_single_run(k)))
\\ A036799 a(n) = 2 + 2^(n+1)*(n-1)

DO_single_run_formula(k) = if(k<2,0, 4 + (k-4)*2^(k-1));
check_exact(vector(10,k,k--; DO_single_run_formula(k)), \
            vector(10,k,k--; DO_single_run(k)));

\\-----------------------------------------------------------------------------

