\\ Copyright 2015, 2016, 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");
recurrence_guess_variable = 'k;

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

 BlobI_y_8_factor = {(46)/(20825)};

 BlobI_y_8floor_factor = {(1)/(2205)};
 BlobI_y_8floor_vector = {[292,880,628,1468]};

 BlobI_y_4_factor = {-(1)/(53550)};
 BlobI_y_4_vector = {[2689,3517,5453,4625]};

 BlobI_y_2_factor = {(1)/(15300)};
 BlobI_y_2_vector = {[-209,915,4187,4967]};

 BlobI_y_2floor_factor = {-(1)/(630)};
 BlobI_y_2floor_vector = {[552,275,1197,2017]};

 BlobI_y_constant_factor = {(1)/(749700)};
 BlobI_y_constant_vector = {[791256,122084,1622961,2156564]};
 BlobI_y(k) = {
   BlobI_y_8_factor * 8^k
   + BlobI_y_8floor_factor
     * vector_modulo(BlobI_y_8floor_vector,k)   * 8^floor(k/2)
   + BlobI_y_4_factor
     * vector_modulo(BlobI_y_4_vector,k)         * 4^k
   + BlobI_y_2_factor
     * vector_modulo(BlobI_y_2_vector,k)         * 2^k
   + BlobI_y_2floor_factor
     * vector_modulo(BlobI_y_2floor_vector,k)   * 2^floor(k/2)
   + BlobI_y_constant_factor
     * vector_modulo(BlobI_y_constant_vector,k);
 }
BlobI_y_frac(k) = BlobI_y(k) / BlobSegments(k);

\\ {
\\   recurrence_guess(vector(100,k,k--;
\\      BlobI_y(k)
\\      - BlobSegments(k) * (
\\         23/4165*4^k
\\         + vector_modulo([-163/4410, -1229/22050, -1807/22050, -199/3150]/(2/5),k) * 2^k
\\         + vector_modulo([292/2205, 176/441/2, 628/2205, 1468/2205/2]/(2/5),k) * 2^floor(k/2)
\\         + vector_modulo([-176501/749700, -23867/124950, -347779/749700, -2591/7650]/(2/5),k)
\\ 
\\      )));
\\ }

BlobI_y_reduced(k) =
{
  23/4165*4^k
  - 1/8820 * vector_modulo([815, 1229, 1807, 1393],k) * 2^k
  + 1/441 * vector_modulo([146, 220, 314, 367],k) * 2^floor(k/2)
  - 1/299880 * vector_modulo([176501, 143202, 347779, 253918],k)
  + (
     1/882 * vector_modulo([-72, 407, 585, 259],k) * 2^floor(k/2)
     - 1/1764 * vector_modulo([630, 1229, 3546, 1199],k)
  ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_y_reduced(k)), \
            vector(100,k,k+=3;  BlobI_y_frac(k)));


\\-----------------------------------------------------------------------------

 BlobI_xy_4_factor = {-(16)/(20825)};

 BlobI_xy_2_factor = {(1)/(2205)};
 BlobI_xy_2_vector = {[337,316,358,652]};

 BlobI_xy_half_factor = {-(1)/(26775)};
 BlobI_xy_half_vector = {[491,347,439,583]};

 BlobI_xy_const_factor = {(1)/(15300)};
 BlobI_xy_const_vector = {[1,1364,101,6184]};

 BlobI_xy_fhalf_factor = {-(1)/(210)};
 BlobI_xy_fhalf_vector = {[144,127,349,501]};

 BlobI_xy_fconst_factor = {(1)/(49980)};
 BlobI_xy_fconst_vector = {[40080,17050,127951,47948]};
 BlobI_xy(k) = {
   BlobI_xy_4_factor * 8^k
   + BlobI_xy_2_factor
     * vector_modulo(BlobI_xy_2_vector,k)   * 8^floor(k/2)
   + BlobI_xy_half_factor
     * vector_modulo(BlobI_xy_half_vector,k)         * 4^k
   + BlobI_xy_const_factor
     * vector_modulo(BlobI_xy_const_vector,k)         * 2^k
   + BlobI_xy_fhalf_factor
     * vector_modulo(BlobI_xy_fhalf_vector,k)   * 2^floor(k/2)
   + BlobI_xy_fconst_factor
     * vector_modulo(BlobI_xy_fconst_vector,k);
 }
BlobI_xy_frac(k) = BlobI_xy(k) / BlobSegments(k);

\\ {
\\   recurrence_guess(vector(100,k,k--;
\\      BlobI_xy(k)
\\      - BlobSegments(k) * (
\\         -8/4165*4^k
\\         + vector_modulo([-253/4410, -181/4410, -257/4410, -47/630],k) * 2^k
\\         + vector_modulo([337/882, 79/441, 179/441, 163/441],k) * 2^floor(k/2)
\\         + vector_modulo([-20635/59976, 1145/29988, -30467/59976, 139/612],k)
\\      )));
\\ }

BlobI_xy_reduced(k) =
{
  -8/4165*4^k
  - 1/4410 * vector_modulo([253, 181, 257, 329],k) * 2^k
  + 1/882 * vector_modulo([337, 158, 358, 326],k) * 2^floor(k/2)
  + 1/59976 * vector_modulo([-20635, 2290, -30467, 13622],k)
  + (
     1/294 * vector_modulo([68, -83, -59, -245],k) * 2^floor(k/2)
     + 1/588 * vector_modulo([-14, 241, 430, 1125],k)
  ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_xy_reduced(k)), \
            vector(100,k,k+=3;  BlobI_xy_frac(k)));


\\-----------------------------------------------------------------------------

 BlobI_z_4_factor = {(152)/(20825)};

 BlobI_z_2_factor = {(1)/(2205)};
 BlobI_z_2_vector = {[610,1464,988,3480]};

 BlobI_z_half_factor = {-(1)/(26775)};
 BlobI_z_half_vector = {[4439,3597,5443,6285]};

 BlobI_z_const_factor = {(1)/(7650)};
 BlobI_z_const_vector = {[1351,1205,2967,4337]};

 BlobI_z_fhalf_factor = {-(1)/(315)};
 BlobI_z_fhalf_vector = {[440,277,1081,1775]};

 BlobI_z_fconst_factor = {(1)/(374850)};
 BlobI_z_fconst_vector = {[600536,142204,1879121,2022124]};
 BlobI_z(k) = {
   BlobI_z_4_factor * 8^k
   + BlobI_z_2_factor
     * vector_modulo(BlobI_z_2_vector,k)   * 8^floor(k/2)
   + BlobI_z_half_factor
     * vector_modulo(BlobI_z_half_vector,k)        * 4^k
   + BlobI_z_const_factor
     * vector_modulo(BlobI_z_const_vector,k)        * 2^k
   + BlobI_z_fhalf_factor
     * vector_modulo(BlobI_z_fhalf_vector,k)   * 2^floor(k/2)
   + BlobI_z_fconst_factor
     * vector_modulo(BlobI_z_fconst_vector,k);
 }
BlobI_z_frac(k) = BlobI_z(k) / BlobSegments(k);

{
  recurrence_guess(vector(100,k,k--;
     BlobI_z(k)
     - BlobSegments(k) * (
        76/4165*4^k
        - vector_modulo([269/882, 373/1470, 1517/4410, 83/210],k) * 2^k
        + 1/441 * vector_modulo([305, 366, 494, 870],k) * 2^floor(k/2)
        - 1/149940 * vector_modulo([208181, 112162, 318819, 409738],k)
     )));
}

BlobI_z_reduced(k) =
{
  76/4165*4^k
  - 1/4410 * vector_modulo([1345, 1119, 1517, 1743],k) * 2^k
  + 1/441 * vector_modulo([305, 366, 494, 870],k) * 2^floor(k/2)
  - 1/149940 * vector_modulo([208181, 112162, 318819, 409738],k)
  + (
     1/441 * vector_modulo([116, 271, 265, 1169],k) * 2^floor(k/2)
     - 1/882 * vector_modulo([1526, 853, 2330, 5365],k)
  ) / BlobSegments(k);
}
check_exact(vector(100,k,k+=3;  BlobI_z_reduced(k)), \
            vector(100,k,k+=3;  BlobI_z_frac(k)));
