\\ Copyright 2014, 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

{
  for(k=6,20,
     my(d = P5(k) - P6(k));
     my(g = gcd(real(d),imag(d)));

     my(d2 = P9(k) - P10(k));
     my(g2 = gcd(real(d2),imag(d2)));
     print(k"  "d"  g="g"   "d2"  g="g2);
  );
}

\\-----------------------------------------------------------------------------

P5_sub_P6(k) =
{
  (-5/6 - 1/6*I)* b^k
  - 1/3 * I*p(k+1)
  - 1/3 * p(k-1);
}
check_exact(vector(100,k,my(k=k+5); P5_sub_P6(k)), \
            vector(100,k,my(k=k+5); P5(k)-P6(k)))

vector(8,k,k--;  - 1/3 * I*p(k+1)  - 1/3 * p(k-1))

P5_sub_P6(k) =
{
  (-5/6 - 1/6*I)* b^k
  + 1/3* vector_modulo([-2 - 1*I, -1, -1 + 2*I,  I,
                         2 + 1*I,  1,  1 - 2*I, -I],k);
}
check_exact(vector(100,k,my(k=k+5); P5_sub_P6(k)), \
            vector(100,k,my(k=k+5); P5(k)-P6(k)))

b_real_sign_vector = [1,1,0,-1, -1,-1,0,1];
b_real_sign(k) = vector_modulo(b_real_sign_vector,k);
b_real(k) = b_real_sign(k) * 2^floor(k/2);
b_imag_sign_vector = [0,1,1,1, 0,-1,-1,-1];
b_imag_sign(k) = vector_modulo(b_imag_sign_vector,k);
b_imag(k) = b_imag_sign(k) * 2^floor(k/2);

P5_sub_P6_real(k) =
{
  (-5/6*b_real_sign(k) + 1/6 * b_imag_sign(k))
  * 2^floor(k/2)
  + 1/3* vector_modulo([-2, -1, -1, 0,
                         2,  1,  1, 0],k);
}
P5_sub_P6_imag(k) =
{
  (-5/6*b_imag_sign(k) - 1/6 * b_real_sign(k)
   )* 2^floor(k/2)
  + 1/3* vector_modulo([-1, 0,  2,  1,
                         1, 0, -2, -1],k);
}
check_exact(vector(100,k,my(k=k+5); P5_sub_P6_real(k)), \
            vector(100,k,my(k=k+5); real(P5(k)-P6(k))))
check_exact(vector(100,k,my(k=k+5); P5_sub_P6_imag(k)), \
            vector(100,k,my(k=k+5); imag(P5(k)-P6(k))))

vector(8,k,k--;  (-5/6*b_real_sign(k) + 1/6 * b_imag_sign(k)))*6
vector(8,k,k--;  (-5/6*b_imag_sign(k) - 1/6 * b_real_sign(k)))*6

P5_sub_P6_real(k) =
{
  1/6 * vector_modulo([-5, -4,  1,  6,
                        5,  4, -1, -6],k) * 2^floor(k/2)
  + 1/3* vector_modulo([-2, -1, -1, 0,
                         2,  1,  1, 0],k);
}
P5_sub_P6_imag(k) =
{
  1/6 * vector_modulo([-1, -6, -5, -4,
                        1,  6,  5,  4],k) * 2^floor(k/2)
  + 1/3* vector_modulo([-1, 0,  2,  1,
                         1, 0, -2, -1],k);
}
check_exact(vector(100,k,my(k=k+5); P5_sub_P6_real(k)), \
            vector(100,k,my(k=k+5); real(P5(k)-P6(k))))
check_exact(vector(100,k,my(k=k+5); P5_sub_P6_imag(k)), \
            vector(100,k,my(k=k+5); imag(P5(k)-P6(k))))

{
  for(i=0,3,
     my(k=1000+i);
     print(i"  "P5_sub_P6_real(k)/2^floor(k/2)*1.0
           "  "P5_sub_P6_imag(k)/2^floor(k/2)*1.0)
     );
}

vector(10,k,my(k=k+5); abs(P5_sub_P6_real(k)))
vector(10,k,my(k=k+5); abs(P5_sub_P6_imag(k)))

P5_sub_P6_x_ref(k) =
{
  max(abs(P5_sub_P6_real(k)),abs(P5_sub_P6_imag(k)));
}
P5_sub_P6_y_ref(k) =
{
  min(abs(P5_sub_P6_real(k)),abs(P5_sub_P6_imag(k)));
}
vector(10,k,my(k=k+7); (P5_sub_P6_x_ref(k)))
vector(10,k,my(k=k+7); (P5_sub_P6_y_ref(k)))

P5_sub_P6_x(k) =
{
  1/6 * vector_modulo([5, 6],k) * 2^floor(k/2)
  + 1/3* vector_modulo([2, 0, -2,  0],k);
}
P5_sub_P6_y(k) =
{
  1/6 * vector_modulo([1, 4],k) * 2^floor(k/2)
  + 1/3* vector_modulo([1, 1, -1, -1],k);
}
check_exact(vector(100,k,my(k=k+5); P5_sub_P6_x(k)), \
            vector(100,k,my(k=k+5); P5_sub_P6_x_ref(k)), \
            "x")
check_exact(vector(100,k,my(k=k+5); P5_sub_P6_y(k)), \
            vector(100,k,my(k=k+5); P5_sub_P6_y_ref(k)), \
            "y")
vector(10,k,k=2*k-1; 2*P5_sub_P6_x(k) - 3*P5_sub_P6_y(k))  \\ odd
vector(10,k,k=2*k; P5_sub_P6_x(k) - 5*P5_sub_P6_y(k))  \\ even
print();
vector(10,k,k=4*k;     P5_sub_P6_real(k) - 5*P5_sub_P6_imag(k))
vector(10,k,k=4*k+1; 3*P5_sub_P6_real(k) - 2*P5_sub_P6_imag(k)) 
vector(10,k,k=4*k+2; 5*P5_sub_P6_real(k) +   P5_sub_P6_imag(k))
vector(10,k,k=4*k+3; 2*P5_sub_P6_real(k) + 3*P5_sub_P6_imag(k))

\\-----------------------------------------------------------------------------

P9_sub_P10_real(k) =
{
  real(P9(k)-P10(k));
}
P9_sub_P10_imag(k) =
{
  imag(P9(k)-P10(k));
}
check_exact(vector(100,k,my(k=k+5); P9_sub_P10_real(k)), \
            vector(100,k,my(k=k+5); real(P9(k)-P10(k))))
check_exact(vector(100,k,my(k=k+5); P9_sub_P10_imag(k)), \
            vector(100,k,my(k=k+5); imag(P9(k)-P10(k))))

{
  for(i=0,3,
     my(k=1000+i);
     print(i"  "P9_sub_P10_real(k)/2^floor(k/2)*1.0
           "  "P9_sub_P10_imag(k)/2^floor(k/2)*1.0)
     );
}
print();
vector(10,k,k=4*k;   3*P9_sub_P10_real(k) - 2*P9_sub_P10_imag(k))
vector(10,k,k=4*k+1; 5*P9_sub_P10_real(k) +   P9_sub_P10_imag(k)) 
vector(10,k,k=4*k+2; 2*P9_sub_P10_real(k) + 3*P9_sub_P10_imag(k))
vector(10,k,k=4*k+3;   P9_sub_P10_real(k) - 5*P9_sub_P10_imag(k))


\\-----------------------------------------------------------------------------
polygon_boundary_points(v) =
{
  sum(i=1,#v, 
        my(z1 = vector_modulo(v,i),
           z2 = vector_modulo(v,i+1),
           d = z1 - z2);
        gcd(real(d), imag(d)));
}
polygon_boundary_points([0, 1, 1+I, I]) == 4
polygon_boundary_points([0, 2, 2+I, I]) == 6
polygon_boundary_points([0, 1, 3*I]) == 4 + 1
polygon_boundary_points([0, 2, 6*I]) == 7 + 2 + 1
polygon_boundary_points([0, 3, 9*I]) == 10 + 3 + 2

vector(20,k,k--; polygon_boundary_points(hull(k)))


hull_boundary_points(k) =
{
  if(k==1, return(3));
  1/6*(
       vector_modulo([14,19],k) * 2^floor(k/2)
       + vector_modulo([-2, -4, 2, 4],k)
      );
}
check_exact(vector(20,k,k--; hull_boundary_points(k)), \
            vector(20,k,k--; polygon_boundary_points(hull(k))))

14/6 == 7/3
19/6
