#!/usr/bin/perl -w

# Copyright 2015, 2017 Ryde

# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.006;
use strict;
use warnings;
use POSIX ();


foreach my $filename (@ARGV) {
  open my $fh, '<', $filename or die;
  my $displaybreak = 0;
  while (my $line = <$fh>) {
    if ($line =~ m{^\\displaybreak}) {
      $displaybreak = 1;
      next;
    }
    if ($line =~ m{^\\\\[^*]}) {
      if (! $displaybreak) {
        print "$filename:$.:\n";
      }
    }
    $displaybreak = 0;
  }
}
exit 0;
