\\ Copyright 2014, 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------
\\ find maximums

factor_vector(n) = concat(apply((r)->vector(r[2],i,r[1]), Vec(Col(factor(n)))));

P_funcs = [T_P1,T_P2,T_P3,T_P4, \
           T_P1o,T_P2o,T_P3o,T_P4o];
P(k,n) = P_funcs[n](k);
list=List([]);
{
  for(k=0,20,
     my(max_width = 0,
        max_a=-1,
        max_b=-1,
        max_c=-1);
     for(a=1,#P_funcs,
        for(b=a+1,#P_funcs,
              my(width = norm(P(k,a) - P(k,b)));
              if(width>max_width,
                 max_width = width;
                 max_a = a;
                 max_b = b)));
     print("k="k"  "max_a" "max_b" width "max_width" ="factor_vector(max_width));
     listput(list,max_width);
  );
}
Vec(list)

\\-----------------------------------------------------------------------------

P3_sub_P3o(k) =
{
  - (b^(k+2) + p(k+2))/3
  - ( b^(k+1) - (  - (b^(k+2) + p(k+2))/3));
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o(k)), \
            vector(64,k,my(k=k+6); T_P3(k)-T_P3o(k)));

P3_sub_P3o(k) =
{
  (-1 - 7/3*I)* b^k  - 2/3*p(k+2);
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o(k)), \
            vector(64,k,my(k=k+6); T_P3(k)-T_P3o(k)));


P3_sub_P3o(k) =
{
  (-1 - 7/3*I)* b^k
  - 2/3*vector_modulo([-2*I, -1 - 2*I, 1, 1 + I, 2*I, 1 + 2*I, -1, -1 - I],k);
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o(k)), \
            vector(64,k,my(k=k+6); T_P3(k)-T_P3o(k)));

\\ print("P3-P8 ",vector(10,k,norm(P3(k)-P8(k))))
\\ print("P3-P9 ",vector(10,k,norm(P3(k)-P9(k))))

P3_sub_P3o_norm(k) =
{
  norm((-1 - 7/3*I)* b^k
  - 2/3*vector_modulo([-2*I, -1 - 2*I, 1, 1 + I, 2*I, 1 + 2*I, -1, -1 - I],k));
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o_norm(k)), \
            vector(64,k,my(k=k+6); norm(T_P3(k)-T_P3o(k))));

P3_sub_P3o_norm(k) =
{
  norm(
       (-1 - 7/3*I)* (
                      vector_modulo([1,1,0,-1, -1,-1,0,1],k)*2^floor(k/2)
                      + I*vector_modulo([0,1,1,1, 0,-1,-1,-1],k)*2^floor(k/2)
       )
       - 2/3*vector_modulo([-2*I, -1 - 2*I, 1, 1 + I, 2*I, 1 + 2*I, -1, -1 - I],k));
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o_norm(k)), \
            vector(64,k,my(k=k+6); norm(T_P3(k)-T_P3o(k))));

P3_sub_P3o_norm(k) =
{
  norm(
       - vector_modulo([1,1,0,-1, -1,-1,0,1],k)*2^floor(k/2)
       - I*vector_modulo([0,1,1,1, 0,-1,-1,-1],k)*2^floor(k/2)

        - 7/3*I*vector_modulo([1,1,0,-1, -1,-1,0,1],k)*2^floor(k/2)
        - 7/3*I*I*vector_modulo([0,1,1,1, 0,-1,-1,-1],k)*2^floor(k/2)

       - 2/3*vector_modulo([-2*I, -1 - 2*I, 1, 1 + I, 2*I, 1 + 2*I, -1, -1 - I],k));
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o_norm(k)), \
            vector(64,k,my(k=k+6); norm(T_P3(k)-T_P3o(k))));

P3_sub_P3o_norm(k) =
{
  norm(
        vector_modulo( [-1, 4/3, 7/3, 10/3, 1, -4/3, -7/3, -10/3],k)*2^floor(k/2)
       + I*vector_modulo([-7/3, -10/3, -1, 4/3, 7/3, 10/3, 1, -4/3],k)*2^floor(k/2)

       - 2/3*vector_modulo([   0, -1      , 1, 1    ,   0, 1      , -1, -1    ],k)
       - 2/3*vector_modulo([-2*I,    - 2*I, 0,     I, 2*I,     2*I,  0,    - I],k));
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o_norm(k)), \
            vector(64,k,my(k=k+6); norm(T_P3(k)-T_P3o(k))));

P3_sub_P3o_norm(k) =
{
  norm(
       vector_modulo( [-1, 4/3, 7/3, 10/3, 1, -4/3, -7/3, -10/3],k)*2^floor(k/2)
       + vector_modulo([0, 2/3, -2/3, -2/3, 0, -2/3, 2/3, 2/3],k)

       + I*vector_modulo([-7/3, -10/3, -1, 4/3, 7/3, 10/3, 1, -4/3],k)*2^floor(k/2)
       + I*vector_modulo([4/3, 4/3, 0, -2/3, -4/3, -4/3, 0, 2/3],k));
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o_norm(k)), \
            vector(64,k,my(k=k+6); norm(T_P3(k)-T_P3o(k))));

P3_sub_P3o_norm(k) =
{
       vector_modulo( [-1, 4/3, 7/3, 10/3, 1, -4/3, -7/3, -10/3],k)^2*4^floor(k/2)
       + 2*vector_modulo([0, 2/3, -2/3, -2/3, 0, -2/3, 2/3, 2/3],k)
   * vector_modulo( [-1, 4/3, 7/3, 10/3, 1, -4/3, -7/3, -10/3],k)*2^floor(k/2)
       + vector_modulo([0, 2/3, -2/3, -2/3, 0, -2/3, 2/3, 2/3],k)^2

       + vector_modulo([-7/3, -10/3, -1, 4/3, 7/3, 10/3, 1, -4/3],k)^2*4^floor(k/2)
       + 2* vector_modulo([4/3, 4/3, 0, -2/3, -4/3, -4/3, 0, 2/3],k)
       * vector_modulo([-7/3, -10/3, -1, 4/3, 7/3, 10/3, 1, -4/3],k)*2^floor(k/2)
       + vector_modulo([4/3, 4/3, 0, -2/3, -4/3, -4/3, 0, 2/3],k)^2
  ;
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o_norm(k)), \
            vector(64,k,my(k=k+6); norm(T_P3(k)-T_P3o(k))));

P3_sub_P3o_norm(k) =
{
  58/9 *2^k
  - vector_modulo([56/9, 64/9, 28/9, 56/9],k) *2^floor(k/2)
  + vector_modulo([16/9, 20/9, 4/9, 8/9],k);
}
check_exact(vector(64,k,my(k=k+6); P3_sub_P3o_norm(k)), \
            vector(64,k,my(k=k+6); norm(T_P3(k)-T_P3o(k))));

\\-----------------------------------------------------------------------------
\\ b^k factors

b*b^k - T_P1(10)

P_bk_factor = { 1/3*[
                     -b*b^3,  \\ 1
                     -b*b^2,
                     -b*b,    \\ 3
                     -b*1,
                     3*b - (-b*b^3),  \\ 1o
                     3*b - (-b*b^2),
                     3*b - (-b*b),    \\ 3o
                     3*b - (-b*1)
                ]; }
my(k=20); vector(#P_bk_factor,n, abs(P(k,n) - b^k*P_bk_factor[n]))
my(k=1000); check_exact(vector(#P_bk_factor,n, abs(P(k,n) - b^k*P_bk_factor[n]) < 5), \
                        vector(#P_bk_factor,n, 1));

lex_vector_first(a,b) = lex(a[1],b[1]);

{
  my(l=List([]));
  for(a=1,#P_bk_factor,
     for(b=a+1,#P_bk_factor,
        listput(l, [ norm(P_bk_factor[a] - P_bk_factor[b]), (P_bk_factor[a] - P_bk_factor[b]), Str(a,",",b) ])));
  l = Vec(l);
  l = vecsort(l,lex_vector_first);
  l = Vecrev(l);
  print(l);
  print("max    ",l[1]);
  print("second ",l[2]);
  diff = l[1][1] - l[2][1];
  print("diff   ",diff);
}

diff=sqrt(diff);
print("abs(b^4) * diff = ",diff*abs(b^4))
print("abs(b^6) * diff = ",diff*abs(b^6))
print("abs(b^7) * diff = ",diff*abs(b^7))
print("2*max abs p = ", vecmax(vector(8,k, 2*abs(p(k)/3))))

\\-----------------------------------------------------------------------------

THD_by_twindragon_points(k) =
{
  my(v=twindragon_points(k));
  my(max_norm = 0);
  for(a=1,#v,
     for(b=a+1,#v,
        max_norm=max(max_norm, norm(v[a] - v[b]))));
  max_norm;
}

\\ not in OEIS, apparently
print("by points  ",vector(9,k,my(k=k-1); THD_by_twindragon_points(k)))
print("by formula ",vector(14,k,my(k=k-1); P3_sub_P3o_norm(k)))

THD = P3_sub_P3o_norm;
for(k=0,100000,if(issquare(THD(k)),print("square k="k" THD="THD(k))))