\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

conj_real(z) = -real(z) + I*imag(z);
real_imag_transpose(z) = imag(z) + I*real(z);

\\-----------------------------------------------------------------------------
\\ sum x^2
\\ sum (x-d)^2
\\ = sum x^2 + 2*x*d + d^2
\\ = (sum x^2) + 2*d*sum(x) + m*d^2

\\ sum x*y
\\ sum (x-d)*y
\\ = (sum x*y)- d*sum(y)


\\-----------------------------------------------------------------------------


\\-----------------------------------------------------------------------------

\\-----------------------------------------------------------------------------

my(k=63); hull = twindragon_hull(k)/b^(k+1);
\\ print(hull);
G = geom_centroid_of_polygon(hull);
if(abs(G) < 1e20, print("centroid ",G));
hull = apply(z->z-G, hull);
\\ hull = geom_inertia__polygon_split_into_quadrants(hull);
hull

print("hull inertia");
m = geom_inertia_of_polygon(hull)
\\geom_inertia__print(m);

print("I principal xydir");
I_principal_xydir = geom_inertia_principal_xydir(m)

print("I_arctan_fraction");
I_arctan_fraction = geom_point_y(I_principal_xydir)/geom_point_x(I_principal_xydir)
1/2*I_arctan_fraction * 180/Pi

\\plothraw(real(hull), imag(hull), 1);

\\ radians limit 23/27
\\ degrees
\\ %83 = 0.85185185185185185185185185
\\ %84 = 

\\ Ix_formula(k) =
\\ {
\\   (5/486)
\\   + 2^floor(k/2) * vector_modulo([-34/243, -52/243, -44/243, -56/243],k)
\\   + 2^k * vector_modulo([103/162, 46/81, 127/162, 73/81],k)
\\   + 2^k*2^floor(k/2) * vector_modulo([-406/243, -392/243, -638/243, -1012/243],k)
\\   + 4^k * vector_modulo([364/243, 190/243, 502/243, 676/243],k)
\\   ;
\\ }
gIx_formula(x) =
{
     + (1/486)/(1 - 1/2*x)
     + (41/72)/(1 - x)
     + (17/648)/(1 + x)
     + (-11/108 - 7/108*x)/(1 - 1/2*x^2)
     + (11/108 + 5/54*x)/(1 + x^2)
     + (-35/972 - 7/972*x)/(1 + 1/2*x^2)
     + (1/648 - 1/648*x)/(1 + 1/4*x^2)
     + (-277/162 - 181/81*x)/(1 - 2*x^2)
     + (23/486 - 37/243*x)/(1 + 2*x^2)

     + (338/243)/(1 - 2*x)
  ;
}

\\ check_exact(gf_terms((-512/9 - 6656/81*x)/(1 - 2*x^2),10), \
\\             vector(10,k,k--; 2^floor(k/2) * vector_modulo([-512/9, -6656/81],k)))
\\ check_exact(gf_terms((512/243 - 2560/243*x)/(1 + 2*x^2), 10), \
\\             vector(10,k,k--; (-2)^floor(k/2) * vector_modulo([512/243, -2560/243],k)))
\\ 
\\ check_exact(gf_terms((-65536/3 + 524288/27*x)/(1 + 4*x^2), 10), \
\\             vector(10,k,k--; (-4)^floor(k/2) * vector_modulo([-65536/3, 524288/27],k)))
\\              
\\ check_exact(gf_terms((-17179869184 + 1580547964928/81*x)/(1 + 16*x^2),10), \
\\             vector(10,k,k--; (-16)^floor(k/2) * vector_modulo([-17179869184, 1580547964928/81],k)))
             

\\ check_exact(gf_terms(gIx_formula(x), 500), \
\\             vector(500,k,k--; polygon_Ix(twindragon_hull(k))));
\\ check_exact(vector(500,k,k--; Ix_formula(k)), \
\\             vector(500,k,k--; polygon_Ix(twindragon_hull(k))));

\\ Iy_formula(k) =
\\ {
\\   (5/486)
\\   + 2^floor(k/2) * vector_modulo([-34/243, -52/243, -44/243, -56/243],k)
\\   + 2^k * vector_modulo([103/162, 46/81, 127/162, 73/81],k)
\\   + 2^k*2^floor(k/2) * vector_modulo([-406/243, -392/243, -638/243, -1012/243],k)
\\   + 4^k * vector_modulo([364/243, 190/243, 502/243, 676/243],k)
\\   ;
\\ }
gIy_formula(x) =
{
     + (1/486)/(1 - 1/2*x)
     + (31/72)/(1 - x)
     + (-1/648)/(1 + x)
     + (-13/108 - 2/27*x)/(1 - 1/2*x^2)
     + (-17/108 - 4/27*x)/(1 + x^2)
     + (73/972 + 5/243*x)/(1 + 1/2*x^2)
     + (-1/648 + 1/648*x)/(1 + 1/4*x^2)
     + (-55/81 - 80/81*x)/(1 - 2*x^2)
     + (25/243 + 44/243*x)/(1 + 2*x^2)

     + (95/243)/(1 - 2*x)
  ;
}

\\ check_exact(gf_terms(gIy_formula(x), 500), \
\\             vector(500,k,k--; polygon_Iy(twindragon_hull(k))));
\\ check_exact(vector(500,k,k--; Iy_formula(k)), \
\\             vector(500,k,k--; polygon_Iy(twindragon_hull(k))));

\\ vector(300,k,k--; polygon_Iy(twindragon_hull(k)/b^(k+1)) * 2^(k+1))

gIxy_formula(x) =
{
     + (1/24)/(1 - x)
     + (-7/216)/(1 + x)
     + (1/108 - 1/216*x)/(1 - 1/2*x^2)
     + (17/108 - 4/27*x)/(1 + x^2)
     + (-5/162 + 23/648*x)/(1 + 1/2*x^2)
     + (-1/324 - 1/1296*x)/(1 + 1/4*x^2)
     + (-13/108 + 4/27*x)/(1 + 2*x^2)
     + (-53/324 - 23/81*x)/(1 - 2*x^2)

     + (23/162)/(1 - 2*x)
  ;
}

d = ((338/243) - (95/243)) + (23/162)*I;
print("d=" d);

print("k=255");
my(k=255); gf_term(gIxy_formula(x),k) / (gf_term(gIx_formula(x),k) - gf_term(gIy_formula(x),k)) + 0.0
my(k=255); geom_inertia_principal_xydir(geom_inertia_of_polygon(twindragon_hull(k))*1.0)

check_exact(imag(d)/real(d)/2,  23/324)
23/324.0

zz_is_anticlockwise(z1,z2) =
{
  (arg(z2) - arg(z1)) % (2*Pi) < Pi;
}

polygon_is_anticlockwise(v) =
{
  for(i=1,#v,
     my(z1 = v[i],
        z2 = v[(i%#v) + 1]);
     if(! zz_is_anticlockwise(z1,z2), return(0)));
  1;
}     

\\-----------------------------------------------------------------------------
\\ of twindragon fractal hull

print();
print("fractal_hull");
fractal_hull = twindragon_hull_fractal;
check_exact(polygon_is_anticlockwise(fractal_hull), 1);
\\fractal_hull += [-50,-50,-50,-50, 50,50,50,50];
\\ fractal_hull -= 9/10*[-1/3,-1/3,-1/3,-1/3, 1/3,1/3,1/3,1/3];
print(fractal_hull);
\\ my(v=concat(fractal_hull,[fractal_hull[1]])); plothraw(real(v), imag(v), 1);
check_exact(polygon_is_anticlockwise(fractal_hull), 1);

print("  centroid ",geom_centroid_of_polygon(fractal_hull));
m = geom_inertia_of_polygon(fractal_hull);
\\f*=1.0;
geom_inertia__print(m);
d = geom_inertia_principal_xydir(m);
d=d[1]+d[2]*I;
print("d " d);
print("d slope " imag(d)/real(d), " ", imag(d)/real(d)*1.0, "   cf 3/4");
print("d sqrt " sqrt(d));
alpha_min = geom_inertia_principal_xyangle(m) + Pi/2;
alpha_max = geom_inertia_principal_xyangle(m);
print("degrees min ",alpha_min*180/Pi,"   max ",alpha_max*180/Pi);
print("radians min ",alpha_min-Pi,"   max ",alpha_max);
print("I       min ",geom_inertia_I_at_xyangle(m,alpha_min))
print("I       max ",geom_inertia_I_at_xyangle(m,alpha_max))

\\ by point counting
\\ Ix = 0.19456844
\\ Iy = 0.27957694
\\ Ixy = 0.0702515

\\ I_by_D(m,alpha) =
\\ {
\\   my(d = geom_inertia_principal_xydir(m),
\\      D = abs(d),
\\      delta = arg(d));
\\   (geom_inertia_Ix(m) + geom_inertia_Iy(m))/2 + D*cos(2*alpha-delta);
\\ }
\\ print("I_by_D  min ",I_by_D(m,alpha_min))
\\ print("I_by_D  max ",I_by_D(m,alpha_max))


\\-----------------------------------------------------------------------------
points_rotate(v, angle) = v * exp(angle*I);
points_translate(v, offset) = apply(z->z+offset, v);

twindragon_midpoints(k) =
{
  my(v = twindragon_points(k));
  v = concat(v, [v[1]]);
  vector_midpoints(v);
}

print();
print("twindragon segment midpoints");

m = geom_inertia_Ix_Iy_Ixy_to_m(1, 3/2, -1/2);

print(" values");
m = geom_inertia_Ix_Iy_Ixy_to_m(12992, 19648, -13056 );
geom_inertia__print(m);

print(" twindragon_midpoints()");
{
  my(k=9);
  points = twindragon_midpoints(k) / b^(k+1);
  points = points_translate(points, -vector_mean(points));
  check_exact(vector_mean(points), 0);
  m = geom_inertia_of_points(points) * 2^k;
  geom_inertia__print(m);
}

d = geom_inertia_principal_xydir(m);
d=d[1]+d[2]*I;
print("d " d);
print("d slope " imag(d)/real(d), " = ", imag(d)/real(d)*1.0, "   cf 3/4");
print("d sqrt " sqrt(d));
alpha_max = geom_inertia_principal_xyangle(m);
alpha_min = alpha_max + Pi/2;
print("degrees min ",alpha_min*180/Pi,"   max ",alpha_max*180/Pi);
print("radians min ",alpha_min,"   max ",alpha_max);
print("I       min ",geom_inertia_I_at_xyangle(m,alpha_min))
print("I       max ",geom_inertia_I_at_xyangle(m,alpha_max))
forstep(alpha=degrees(-10),degrees(60), degrees(2), \
       print(geom_inertia_I_at_xyangle(m,alpha),"   at alpha=", alpha*180/Pi));
quit

print();
print("of hull by points");
m = geom_inertia_Ix_Iy_Ixy_to_m(16.1116440055746, 22.8960587852788, -5.86809967741942);
d = geom_inertia_principal_xydir(m);
d=d[1]+d[2]*I;
alpha_min = geom_inertia_principal_xyangle(m) + Pi/2;
alpha_max = geom_inertia_principal_xyangle(m);
print("degrees min ",alpha_min*180/Pi,"   max ",alpha_max*180/Pi);
print("radians min ",alpha_min,"   max ",alpha_max);
print("I       min ",geom_inertia_I_at_xyangle(m,alpha_min))
print("I       max ",geom_inertia_I_at_xyangle(m,alpha_max))



 quit

print("first rect");
f = geom_inertia_of_intformal_rows(0, 1/3,  0, 5/6);
print("first top");
f += geom_inertia_of_intformal_rows(1/3, 2/3,  0, 5/6-(y-1/3));
print("second");
f += geom_inertia_of_intformal_rows(0, 2/3,  -5/6+y,0);
\\ print("fourth");
\\ f += parts(-2/3, 0,  0, 5/6+(y-1/3));
f *= 2;  \\ rotate 180
print("total"); geom_inertia__print(f);
d = geom_inertia_principal_xydir(f);
d=d[1]+d[2]*I;
print("degrees ",1/2*arg(d)*180/Pi);

print();
print("top one");
f = geom_inertia_of_intformal_rows(0, 1/3,  -5/6+y, 5/6);
print("top two");
f += geom_inertia_of_intformal_rows(1/3, 2/3,  -5/6+y, 5/6-(y-1/3));
\\ print("bottom one");
\\ f = parts(-1/3, 0,  -5/6, 5/6+y);
\\ print("bottom two");
\\ f += 2*parts(-2/3, -1/3,  -5/6-(y+1/3), 5/6+y);
f *= 2;
print("total"); geom_inertia__print(f);
d = geom_inertia_principal_xydir(f);
d=d[1]+d[2]*I;
print("degrees ",1/2*arg(d)*180/Pi);


\\ {
\\   ploth(alpha=0,360,
\\         alpha = alpha*Pi/180;
\\         geom_inertia_I_at_xyangle(m,alpha))
\\ }

ellipse(alpha) =
{
  my(d = exp((alpha-.5)*I));
  d = real(d) + I*imag(d)*.5;
  d *= (1+I)/sqrt(2);
  d;
}


{
  \\ ploth(X=0,2*Pi,[sin(X),cos(X)], "Parametric")
     \\ plotscale(0, -5,5, -5,5);
  \\ ploth(X=0,2*Pi,[sin(X),cos(X)], 1);

  \\ s = plothsizes();
  \\ plotinit(0, s[2]-1, s[2]-1);
  \\ plotscale(0, -1,1, -1,1);
  \\ plotrecth(0, t=0,2*Pi, [cos(t),sin(t)], "Parametric|no_Rescale");
  \\ plotdraw([0, -1,1]);

  s = plothsizes();
  plotinit(0, s[2]-1, s[2]-1);
  plotscale(0, -1,1, -1,1);
  plotrecth(0, t=0,2*Pi,
            [ real(ellipse(t)), imag(ellipse(t)) ],
            "Parametric|no_Rescale");
  plotdraw([0, -1,1]);

  \\ s = plothsizes();
  \\ plotinit(0, s[2]-1, s[2]-1);
  \\ plotscale(0, -5,5, -5,5);
  \\ plotrecth(0, alpha=0, 360,
  \\           alpha = alpha*Pi/180;
  \\           ,
  \\           "Parametric|no_Rescale");
  \\ plotdraw([0, -50,50]);
}
