\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------
\\ -2-I -1 == -3-I
\\ (-3-I)/b == -2+I
\\ dragon_point(1) == 1
\\ (-2+I)*b + dragon_point(1) == -2-I

\\ 
\\ a=z mod b
\\ newz=(z-a)/b
\\ 

n=5;
z=I*dragon_point(n);
v=[z,-1];
{
  print("n="n"  at "z"  s="v[2]);
  my(l=List([]));
  my(k=#l);
  my(n=from_binary_vector(Vecrev(l)));
  my(zz=b^k*v[1] + dragon_point(n));
  print("initial k="k"  n=",n," kn="kn" zz="zz);
  
  for(i=1,9,
     my(a=z_mod_b(v[1]));
     listput(l,a);
     my(new_v=unpoint_iterate(v));
     my(n=from_binary_vector(Vecrev(l)));
     my(k=#l);
     my(kn=2^k-n);
     my(zz=b^k*new_v[1] + dragon_point(n) * if(a,-1,1));
     print(v," ",a,"  k="k"  n=",n," kn="kn" zz="zz);
     v=new_v;
  );
}
quit

\\-----------------------------------------------------------------------------

b_digits(z) =
{
  my(l=List([]));
  while(z!=0 && z!=I,
        \\ print("at z=",z);
        if(!z_is_integer(z),error(""));
        my(a=z_mod_b(z));
        listput(l,a);
        z-=a;
        z/=b);
  listput(l,z);
  l=Vecrev(l);
  l;
}

\\ I*point(2^k-n) = b^k + -I*point(n)     extra high 1-bit

\\ I*point(n) = point(2^k-n) + I*b^k
\\ I*point(n) = point(2^(k+2)-n) + I*b^(k+4) + b^(k+2) + I*b^k
\\ I*point(n) = point(2^(k+2)-n) + -b^(k+2) + I*b^k
{
  for(k=3,9,
     for(n=5,5,
        my(p1=I*dragon_point(n));
        my(p0=dragon_point(2^k-n));
        my(diff=p1-p0);
        \\ my(dd = I*b^(k+2) + b^k + I*b^2);   \\ I,0,1,...,I
        my(dd = -b^k + I*b^2);   \\ I,0,1,...,I
        print(n,"  p1=",p1,"  p0=",p0,"  diff=",diff,"   ",b_digits(diff),"  dd=",dd)));
}

z=sum(i=2,5,b^i)+I*b^7
b_digits(z)
z+= -I*b^2
b_digits(z)

z=sum(i=0,5,b^i)
(b^6-1)/(b-1)
-I*(b^6-1)
z==-I*b^6 + I

check_exact(I*b^2+1, -1)