#!/usr/bin/perl -w

# Copyright 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib "$FindBin::Bin/../tools";
use MyDragon '@fVisits_adjacent_list','fVisits_expand_bit';
use MyLineSegments;
use MyPrintwrap ':all';


print "% generated by tools/$FindBin::Script\n";

print "% GP-DEFINE  fVisits_expand_bit_matrix = {[\n";
foreach my $s (1 .. $#fVisits_adjacent_list) {
  my $str0 = '[' . join(',',fVisits_expand_bit($s, 0)) . '],';
  my $str1 = '[' . join(',',fVisits_expand_bit($s, 1)) . ']'
    . ($s==$#fVisits_adjacent_list ? " ]};" : ";");
  printf "%% GP-DEFINE    %-6s %-8s  \\\\ s%d\n", $str0, $str1, $s;
}

print "% end generated\n";
exit 0;
