#!/usr/bin/perl -w

# Copyright 2014, 2015, 2016 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.006;
use strict;
use warnings;
use FindBin;

my %macros = (cite => 1,
              label => 1,
              autoref => 1,
              eqref => 1,
              hyphenation => 1,
              bibitem => 1,
             );

foreach my $filename (@ARGV) {
  open my $fh, '<', $filename or die "$filename: $!";
  my $in_tikz = 0;
  while (defined (my $line = readline $fh)) {
    $line =~ s/((^|[^\\])(\\\\)*)%.*/$1/;  # strip comments
    if ($line =~ /^[ \t]*\\(begin|end)\{tikz/) { $in_tikz = ($1 eq 'begin'); }
    next if $in_tikz;
    if ($line =~ /(\\([[:alpha:]]+)\{)?([[:alpha:]]+-[[:alpha:]]+)/) {
      my $macro = $2;
      my $words = $3;
      next if defined $macro && $macros{$macro};
      print "$filename:$.: $words\n";
    }
  }
  close $fh or die "$filename: $!";
}
