#!/usr/bin/perl -w

# Copyright 2014, 2015, 2016 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


#------------------------------------------------------------------------------
# without forward/reverse, WRONG

my @state_to_segs = ($segs_initial);

use constant::defer make_fBpred_surround_flats => sub {
  my $segs_to_state = sub {
    my ($segs) = @_;
    foreach my $i (0 .. $#state_to_segs) {
      if (segs_is_equal($segs, $state_to_segs[$i])) { return $i; }
    }
    push @state_to_segs, $segs;
    # print "new state $#state_to_segs\n";
    return $#state_to_segs;
  };

  my @state_table;
  for (my $from = 0; $from <= $#state_to_segs; $from++) {
    my $from_segs = $state_to_segs[$from];
    print "########################################\n";
    print "from $from\n";
    segs_print($from_segs);
    foreach my $bit (0,1) {
      my $to_segs = $segs_expand_func[$bit]->($from_segs);
      $to_segs = segs_intersection($to_segs, $segs_all);
      my $to = $segs_to_state->($to_segs);
      $state_table[$from]->[$bit] = $to;

      print "bit $bit to $to\n";
      segs_print($to_segs);
    }
    # print "  $from=>{0=>$state_table[$from]->[0],1=>$state_table[$from]->[1]},\n";
    # {
    #   my $f = $from + 1;
    #   my $t0 = $state_table[$from]->[0] + 1;
    #   my $t1 = $state_table[$from]->[1] + 1;
    #   print "  $f=>{0=>$t0,1=>$t1},\n";
    # }
  }
  # segs_print($state_to_segs[3]);
  # segs_print($state_to_segs[7]);
  # segs_print(segs_intersection($state_to_segs[3],$state_to_segs[7]));

  my $num_states = scalar(@state_table);
  print "fBpred states $num_states\n";

  my @state_is_enclosed = map {segs_has_all_of($_,$segs_all)} @state_to_segs;
  my @enclosed_list;
  foreach my $i (0 .. $#state_to_segs) {
    if ($state_is_enclosed[$i]) {
      print "  enc $i\n";
      push @enclosed_list, $i;
    }
  }
  foreach my $i (0 .. $#state_to_segs) {
    next unless $state_is_enclosed[$i];
    foreach my $bit (0,1) {
      my $to = $state_table[$i]->[$bit];
      $state_is_enclosed[$to]
        or die "oops, enclosed $i bit=$bit didn't remain so";
    }
  }

  my @state_is_enclosed_eventually = @state_is_enclosed;
  {
    my $depth = 0;
    my $more = 1;
    while ($more) {
      $more = 0;
      foreach my $i (0 .. $#state_table) {
        next if $state_is_enclosed_eventually[$i];
        if ($state_is_enclosed_eventually[$state_table[$i]->[0]]
            && $state_is_enclosed_eventually[$state_table[$i]->[1]]) {
          $state_is_enclosed_eventually[$i] = 1;
          $more = 1;
        }
      }
      $depth++;
    }
    print "  enclosed eventually (depth=$depth) ";
    foreach my $i (0 .. $#state_table) {
      if ($state_is_enclosed_eventually[$i]) { print " $i"; }
    }
    print "\n";
  }

  require FLAT::DFA;
  {
    my $f = aref_to_FLAT_DFA(\@state_table,
                             name => 'fNonBpred_surround',
                             accepting_list => \@enclosed_list,
                             # accepting_list => [grep {$state_is_enclosed_eventually[$_]}
                             #                    0 .. $#state_table ],
                            );
    # print "minimize fNonBpred_surround_flat ... ";
    # $f = $f->as_min_dfa;
    # print "done, ",$f->num_states," states\n";
    $fNonBpred_surround_flat = $f;

    $f = $f->complement;
    $f->{'name'} = 'fBpred_surround';
    $fBpred_surround_flat = $f;
  }
  {
    my $f = aref_to_FLAT_DFA(\@state_table,
                             name => 'NonBpred_by_surround',
                             accepting_list => [ grep {segs_has_all_of($state_to_segs[$_],$segs_B)}
                                                 0 .. $#state_table ],
                            );;
    $NonBpred_by_surround_flat = $f;

    $f = $f->complement;
    $f->{'name'} = 'Bpred_by_surround';
    $Bpred_by_surround_flat = $f;
  }
};



#------------------------------------------------------------------------------
# internal iconf 7 segments, WRONG

sub iconf_is_RL_enclosed {
  my ($iconf) = @_;
  my $segs = $iconf->{'segs'};
  my $enclosed_B = segs_has_all_of($segs,$segs_internal);
  return ($enclosed_B, $enclosed_B);

  my $boundary_R = 0;
  foreach my $sq (@R_squares) {
    my $intersect = segs_intersection($segs, $sq);
    my $num_sides = scalar @$intersect;
    if ($num_sides >= 1 && $num_sides <= 3) {
      $boundary_R = 1;
    }
  }
  my $boundary_L = 0;
  foreach my $sq (@L_squares) {
    my $intersect = segs_intersection($segs, $sq);
    my $num_sides = scalar @$intersect;
    # segs_print($segs);
    # segs_print($intersect);
    # ### $num_sides
    if ($num_sides >= 1 && $num_sides <= 3) {
      $boundary_L = 1;
    }
  }
  if ($iconf->{'side'}) {
    ($boundary_R,$boundary_L) = ($boundary_L,$boundary_R);
  }
  ### $boundary_R
  ### $boundary_L
  return (1-$boundary_R, 1-$boundary_L);
}

my ($fBpred_internal_flat, $fNonBpred_internal_flat);
my ($fRpred_internal_flat, $fNonRpred_internal_flat);
my ($fLpred_internal_flat, $fNonLpred_internal_flat);
my ($Bpred_by_internal_flat, $NonBpred_by_internal_flat);
my ($Rpred_by_internal_flat, $NonRpred_by_internal_flat);
my ($Lpred_by_internal_flat, $NonLpred_by_internal_flat);
my @state_to_iconf = ({ side => 0, segs => $segs_initial },
                     # { side => 1, segs => $segs_initial },
                    );
sub iconf_to_state {
  my ($iconf, $noadd) = @_;
  foreach my $i (0 .. $#state_to_iconf) {
    if (conf_is_equal($iconf, $state_to_iconf[$i])) { return $i; }
  }
  if ($noadd) { return -1; }
  push @state_to_iconf, $iconf;
  # print "new iconf $#state_to_iconfs\n";
  return $#state_to_iconf;
}
sub iconf_print {
  my ($iconf) = @_;
  my $state = iconf_to_state($iconf);
  print "iconf $state side $iconf->{side} RLenc ",
    join(',',iconf_is_RL_enclosed($iconf)),
    " ";
  segs_print($iconf->{'segs'});
}
use constant::defer make_internal_flats => sub {
  my $iconf_transition = sub {
    my ($iconf,$bit) = @_;
    die unless $bit==0 || $bit==1;
    my $segs;
    # state 0 right side enc, state 1 left side enc
    #  0 ------> 1         1 ------> 0
    #   0\     /1           1\     /0
    # 0a  \   /  1b       1a  \   /  0b
    #     1v v0               0v v1
    if ($iconf->{'side'} == $bit) {
      # a  0,0 or 1,1
      $segs = segs_expand0($iconf->{'segs'});
    } else {
      # b  0,1 or 1,0a  0,0 or 1,1
      $segs = segs_expand1($iconf->{'segs'});
    }
    $segs = segs_intersection($segs, $segs_internal);
    return { side => $bit, segs => $segs };
  };
  my @state_table;
  for (my $from = 0; $from <= $#state_to_iconf; $from++) {
    my $from_iconf = $state_to_iconf[$from];
    # print "########################################\n";
    # print "from $from\n";
    # $iconf_print->($from_iconf);
    foreach my $bit (0,1) {
      my $to_iconf = $iconf_transition->($from_iconf,$bit);
      my $to = iconf_to_state($to_iconf);
      $state_table[$from]->[$bit] = $to;

      # print "bit $bit to $to\n";
      # segs_print($to_segs);
    }
    # print "  $from=>{0=>$state_table[$from]->[0],1=>$state_table[$from]->[1]},\n";
    # {
    #   my $f = $from + 1;
    #   my $t0 = $state_table[$from]->[0] + 1;
    #   my $t1 = $state_table[$from]->[1] + 1;
    #   print "  $f=>{0=>$t0,1=>$t1},\n";
    # }
  }

  my $num_states = scalar(@state_table);
  print "fBpred internal state_table length $num_states\n";

  # print "R_squares\n";
  # foreach my $segs (@R_squares) { segs_print($segs); }
  # print "L_squares\n";
  # foreach my $segs (@L_squares) { segs_print($segs); }

  my @state_is_RL_enclosed;
  foreach my $i (0 .. $#state_to_iconf) {
    my $iconf = $state_to_iconf[$i];
    $state_is_RL_enclosed[$i] = [ iconf_is_RL_enclosed($iconf) ];
  }
  my @istate_enclosed_lists = ([], [], []);
  foreach my $i (0 .. $#state_table) {
    my $both = 1;
    foreach my $side (0, 1) {
      if ($state_is_RL_enclosed[$i]->[$side]) {
        push @{$istate_enclosed_lists[$side]}, $i;
      } else {
        $both = 0;
      }
    }
    if ($both) {
      push @{$istate_enclosed_lists[2]}, $i;
    }
  }
  print "  enclosed R = ",join(',',@{$istate_enclosed_lists[0]}),"\n";
  print "  enclosed L = ",join(',',@{$istate_enclosed_lists[1]}),"\n";
  print "  enclosed B = ",join(',',@{$istate_enclosed_lists[2]}),"\n";

  foreach my $side (0, 1) {
    foreach my $i (@{$istate_enclosed_lists[$side]}) {
      foreach my $bit (0,1) {
        my $to = $state_table[$i]->[$bit];
        $state_is_RL_enclosed[$to]->[$side]
          or die "oops, side=$side enclosed $i bit=$bit didn't remain so";
      }
    }
  }

  my @state_is_RL_enclosed_eventually = map {[@$_]} @state_is_RL_enclosed; # clone
  {
    my $depth = 0;
    my $more = 1;
    while ($more) {
      $more = 0;
      foreach my $i (0 .. $#state_to_iconf) {
        foreach my $side (0,1) {
          next if $state_is_RL_enclosed_eventually[$i]->[$side];
          if ($state_is_RL_enclosed_eventually[$state_table[$i]->[0]]->[$side]
              && $state_is_RL_enclosed_eventually[$state_table[$i]->[1]]->[$side]) {
            $state_is_RL_enclosed_eventually[$i]->[$side] = 1;
            $more = 1;
          }
        }
      }
      $depth++;
    }
    foreach my $side (0, 1) {
      print "  eventually enclosed(depth=$depth, side=$side)  ";
      foreach my $i (0 .. $#state_to_iconf) {
        if ($state_is_RL_enclosed_eventually[$i]->[$side]) { print " $i"; }
      }
      print "\n";
    }
  }

  {
    # R
    my $f = aref_to_FLAT_DFA(\@state_table,
                             name => 'fNonRpred_internal',
                             accepting_list => $istate_enclosed_lists[0],
                             # accepting_list => [ grep {$state_is_RL_enclosed_eventually[$_]->[0]}
                             #                     0 .. $#state_table ],
                            );
    $fNonRpred_internal_flat = $f;
    print "$f->{name} accepting ",join(' ',$f->get_accepting),"\n";

    $f = $f->complement;
    $f->{'name'} = 'fRpred_internal';
    $fRpred_internal_flat = $f;
  }
  {
    # L
    my $f = aref_to_FLAT_DFA(\@state_table, name => 'fNonLpred_internal',
                             starting => 0,
                             accepting_list => $istate_enclosed_lists[1],
                             # accepting_list => [ grep {$state_is_RL_enclosed_eventually[$_]->[1]}
                             #                     0 .. $#state_table ],
                            );
    $fNonLpred_internal_flat = $f;

    $f = $f->complement;
    $f->{'name'} = 'fLpred_internal';
    $fLpred_internal_flat = $f;
  }
  {
    # B
    my $f = aref_to_FLAT_DFA(\@state_table, name => 'fNonBpred_internal',
                             starting => 0,
                             accepting_list => $istate_enclosed_lists[2]);
    $fNonBpred_internal_flat = $f;
    print "$f->{name} accepting ",join(' ',$f->get_accepting),"\n";

    $f = $f->complement;
    $f->{'name'} = 'fBpred_internal';
    $fBpred_internal_flat = $f;
  }

  # finite iterations
  {
    my @NonR_accepting;
    my @NonL_accepting;
    my @NonB_accepting;
    my @B_accepting;
    foreach my $i (0 .. $#state_table) {
      my $iconf = $state_to_iconf[$i];
      my $segs = $iconf->{'segs'};
      my $NonR = segs_has_all_of($segs,$segs_R);
      my $NonL = segs_has_all_of($segs,$segs_L);
      my $NonB = segs_has_all_of($segs,$segs_B);
      if ($iconf->{'side'}) { ($NonR,$NonL) = ($NonL,$NonR); }
      if ($NonR) { push @NonR_accepting, $i; }
      if ($NonL) { push @NonL_accepting, $i; }
      if ($NonB) { push @NonB_accepting, $i; }
      if (! $NonB) { push @B_accepting, $i; }
    }
    # print "R_accepting ",join(' ',@NonR_accepting->get_accepting),"\n";
    my $f = aref_to_FLAT_DFA(\@state_table, name => 'NonRpred_by_internal',
                             starting => 0,
                             accepting_list => \@NonR_accepting);
    $NonRpred_by_internal_flat = $f;
    $f = $f->complement;
    $f->{'name'} = 'Rpred_by_internal';
    $Rpred_by_internal_flat = $f;

    $f = aref_to_FLAT_DFA(\@state_table, name => 'NonLpred_by_internal',
                          starting => 0,
                          accepting_list => \@NonL_accepting);
    $NonLpred_by_internal_flat = $f;
    $f = $f->complement;
    $f->{'name'} = 'Lpred_by_internal';
    $Lpred_by_internal_flat = $f;

    $f = aref_to_FLAT_DFA(\@state_table, name => 'NonBpred_by_internal',
                          starting => 0,
                          accepting_list => \@NonB_accepting);
    $NonBpred_by_internal_flat = $f;

    $f = aref_to_FLAT_DFA(\@state_table, name => 'Bpred_by_internal',
                          starting => 0,
                          accepting_list => \@B_accepting);
    $Bpred_by_internal_flat = $f;
  }
};

  make_internal_flats();
  FLAT_check_is_equal($fNonBpred_internal_flat,
                      MyFLAT::eventually_accepting($fNonBpred_internal_flat));
  FLAT_check_is_equal($fBpred_internal_flat,
                      MyFLAT::eventually_accepting($fBpred_internal_flat));

  {
    my $str = '110001011100111';
    my $n = cnv($str,2,10);
    print "path N=$n right boundary ",$path->_UNDOCUMENTED__n_segment_is_right_boundary($n)?1:0, "\n";
    print "fNonBpred_internal_flat contains ",$fNonBpred_internal_flat->contains($str)?1:0, "\n";
    print "fNonBpred_surround_eventually_flat contains ",$fNonBpred_surround_eventually_flat->contains($str)?1:0, "\n";
    FLAT_show_transitions($fNonBpred_internal_flat, $str);
    FLAT_show_transitions($fNonBpred_surround_eventually_flat, $str);
    iconf_print($state_to_iconf[20]);
    conf_print($state_to_conf[70]);
    print "path "; conf_print(path_str_to_conf($str));
  }


{
  make_surround_flats();

  # $fNonBpred_surround_eventually_flat
  #   = $fNonBpred_surround_eventually_flat->MyFLAT::minimize;
  # MyFLAT::view($fNonBpred_surround_eventually_flat);
  #  print $fNonBpred_surround_eventually_flat->as_summary;

  FLAT_check_is_subset($fNonBpred_internal_flat,
                       MyFLAT::eventually_accepting(NonBpred_k_flat()));
  # FLAT_check_is_subset($fNonRpred_internal_flat,
  #                      MyFLAT::eventually_accepting(NonRpred_flat()));
  # FLAT_check_is_subset($fNonLpred_internal_flat,
  #                      MyFLAT::eventually_accepting(NonLpred_k_flat()));
  # FLAT_check_is_subset(MyFLAT::eventually_accepting(Bpred_k_flat()),
  #                      $fBpred_internal_flat);

  make_surround_flats();

  FLAT_check_is_equal($fNonBpred_internal_flat,
                      $fNonBpred_surround_eventually_flat);
  FLAT_check_is_equal($fBpred_internal_flat,
                      MyFLAT::eventually_accepting($fBpred_surround_flat));

  exit 0;
}


# possible partial $str at the end.
sub re_repeating {
  my ($str) = @_;
  my $re = "($str)* ([]";
  foreach my $len (1 .. length($str)-1) {
    $re .= " | ".substr($str,0,$len);
  }
  $re .= ')';
  return $re;
}
{
  print "re_repeating ",re_repeating('1011'),"\n";
  my $f = FLAT::Regex->new(re_repeating('1011'));
  $f->contains('') or die;
  $f->contains('1') or die;
  $f->contains('10') or die;
  $f->contains('101') or die;
  $f->contains('1011') or die;
  $f->contains('10111') or die;
  $f->contains('101110') or die;
  $f->contains('1011101') or die;
}

# Return a FLAT::Regex string which matches repeated copies of $str, and
# re_concat_optional($re1, $re2, ...) takes FLAT::Regex style strings and
# returns a new such string which is a concat, but permitting matches to
# stop after any given $re, so that the remainder are optional.
sub re_concat_optional {
  my $re = '';
  while (@_) {
    my $part = pop @_;
    if (length($re)) { $re = "($re)"; }
    $re = "[] | $part $re";
  }
  return $re;
}
print "re_concat_optional ",re_concat_optional('f','o','o'),"\n";




    @state_is_RL_enclosed_eventually
      = map {[@$_]} @state_is_RL_enclosed;  # clone
    {
      foreach my $side (0,1) {
        print "eventually enclosing side $side\n";
        my $depth = 0;
        my $more = 1;
        while ($more) {
          $depth++;
          $more = 0;
          print " depth $depth more bits: ";
          foreach my $i (0 .. $#state_to_conf) {
            next if $state_is_RL_enclosed_eventually[$i]->[$side];
            if ($state_is_RL_enclosed_eventually[$fBpred_state_table[$i]->[0]]->[$side]
                && $state_is_RL_enclosed_eventually[$fBpred_state_table[$i]->[1]]->[$side]) {
              $state_is_RL_enclosed_eventually[$i]->[$side] = 1;
              print " $i";
              $more = 1;
            }
          }
          print "\n";
        }
      }
      foreach my $i (0 .. $#state_to_conf) {
        $state_is_RL_enclosed_eventually[$i]->[2]  # B
          = ($state_is_RL_enclosed_eventually[$i]->[0]
             && $state_is_RL_enclosed_eventually[$i]->[1]
             ? 1 : 0);
      }
      foreach my $side (0, 1, 2) {
        print "  eventually enclosed(side=$side)  ";
        my $count = 0;
        foreach my $i (0 .. $#state_to_conf) {
          if ($state_is_RL_enclosed_eventually[$i]->[$side]) {
            print " $i";
            $count++;
            push @{$state_enclosed_eventually_lists[$side]}, $i;
          }
        }
        print " count $count\n";
      }
    }

    # configurations with all 7 internals are sometimes not eventually enclosing
    # {
    #   my $bad = 0;
    #   my $side = 2;
    #   foreach my $state (0 .. $#fBpred_state_table) {
    #     my $conf = $state_to_conf[$state];
    #     my $enc = $state_is_RL_enclosed_eventually[$state]->[$side];
    #     my $int = segs_has_all_of($conf->{'segs'},$segs_internal) ? 1 : 0;
    #     if ($enc != $int) {
    #       print "state $state enc $enc  int $int\n";
    #       conf_print($conf);
    #       $bad++;
    #     }
    #   }
    #   #    if ($bad) { exit 1; }
    # }


    # finite iterations
    {
      my @NonR_accepting;
      my @NonL_accepting;
      my @NonB_accepting;
      my @B_accepting;
      foreach my $i (0 .. $#fBpred_state_table) {
        my $conf = $state_to_conf[$i];
        my $NonR = $R_square_segs->is_subset($conf);
        my $NonL = $L_square_segs->is_subset($conf);
        my $NonB = $B_squares_segs->is_subset($conf);
        if ($conf->{'side'}) { ($NonR,$NonL) = ($NonL,$NonR); }
        if ($NonR) { push @NonR_accepting, $i; }
        if ($NonL) { push @NonL_accepting, $i; }
        if ($NonB) { push @NonB_accepting, $i; }
        if (! $NonB) { push @B_accepting, $i; }
      }
      # print "R_accepting ",join(' ',@NonR_accepting->get_accepting),"\n";
      my $f = aref_to_FLAT_DFA(\@fBpred_state_table, name => 'NonRpred_by_surround',
                               starting => 0,
                               accepting_list => \@NonR_accepting);
      $NonRpred_by_surround_flat = $f;
      $f = $f->complement;
      $f->{'name'} = 'Rpred_by_surround';
      $Rpred_by_surround_flat = $f;

      $f = aref_to_FLAT_DFA(\@fBpred_state_table, name => 'NonLpred_by_surround',
                            starting => 0,
                            accepting_list => \@NonL_accepting);
      $NonLpred_by_surround_flat = $f;
      $f = $f->complement;
      $f->{'name'} = 'Lpred_by_surround';
      $Lpred_by_surround_flat = $f;

      $f = aref_to_FLAT_DFA(\@fBpred_state_table, name => 'NonBpred_by_surround',
                            starting => 0,
                            accepting_list => \@NonB_accepting);
      $NonBpred_by_surround_flat = $f;

      $f = aref_to_FLAT_DFA(\@fBpred_state_table, name => 'Bpred_by_surround',
                            starting => 0,
                            accepting_list => \@B_accepting);
      $Bpred_by_surround_flat = $f;
    }


    $fNonBpred_surround_eventually_flat
      = MyFLAT::eventually_accepting($fNonBpred_surround_flat);
    $fNonRpred_surround_eventually_flat
      = MyFLAT::eventually_accepting($fNonRpred_surround_flat);
    $fNonLpred_surround_eventually_flat
      = MyFLAT::eventually_accepting($fNonLpred_surround_flat);


my @R_squares = (MyDragonConf->new
                 (side => 0,
                  segs => [
                           "0,0,0",       # below m
                           "0,0,3",
                           "1,-1,2",
                           "1,-1,1"
                          ]),
                 MyDragonConf->new
                 (side => 0,
                  segs => [
                           "-1,1,0",       # top left
                           "-1,1,3",
                           "0,0,2",
                           "0,0,1"
                          ]),
                 MyDragonConf->new
                 (side => 0,
                  segs => [
                           "1,1,0",       # top right
                           "1,1,3",
                           "2,0,2",
                           "2,0,1"
                          ]),
                );
my $R_squares_all = $R_squares[0]->union(@R_squares)
  ->set_within($surround_segs_all)
  ->set_name('surround R squares');
! $R_squares_all->is_boundary(0) or die;
  $R_squares_all->is_boundary(1) or die;

my @L_squares = (MyDragonConf->new
                 (side => 0,
                  segs => [
                           "0,0,0",      # above m
                           "0,0,1",
                           "1,1,2",
                           "1,1,3"
                          ]),
                 MyDragonConf->new
                 (side => 0,
                  segs => [
                           "-1,-1,0",      # left of m
                           "-1,-1,1",
                           "0,0,2",
                           "0,0,3"
                          ]),
                 MyDragonConf->new
                 (side => 0,
                  segs => [
                           "1,-1,0",      # right of m
                           "1,-1,1",
                           "2,0,2",
                           "2,0,3"
                          ]),
                 MyDragonConf->new
                 (segs => [
                           "0,-2,0",      # below m
                           "0,-2,1",
                           "1,-1,2",
                           "1,-1,3"
                          ]),
                );
my $L_squares_all = $L_squares[0]->union(@L_squares)
  ->set_within($surround_segs_all)
  ->set_name('surround L squares');
  $L_squares_all->is_boundary(0) or die;
! $L_squares_all->is_boundary(1) or die;

my @state_to_conf;
{
  my %conf_to_state;
  sub conf_to_state {
    my ($conf) = @_;
    my $key = $conf->key;
    my $state = $conf_to_state{$key};
    if (! defined $state) {
      push @state_to_conf, $conf;
      $state = $#state_to_conf;
      $conf_to_state{$key} = $state;
      # print "new state $state\n";
    }
    return $state;
  }
}
conf_to_state(MyDragonConf->initial(within => $surround_segs_all));
### @state_to_conf
$state_to_conf[0]->is_boundary(0) or die;
$state_to_conf[0]->is_boundary(1) or die;


#----------------

use constant::defer fNonRpred_cases_flat => sub {
  print "fNonRpred_cases_flat difference ...\n";
  my $f = MyFLAT::eventually_accepting (NonRpred_flat());

  foreach my $extra (@extras_R_array) {
    $f = $f->difference($extra);
  }
  $f->{'name'} = 'fNonRpred_cases';
  $f = $f->MyFLAT::minimize;
  $f;
};
use constant::defer fRpred_cases_flat => sub {
  my $f = fNonRpred_cases_flat->complement;
  $f->{'name'} = 'fRpred_cases';
  $f;
};

#----------------

use constant::defer NonLpred_k_eventually_flat => sub {
  return MyFLAT::eventually_accepting (NonLpred_k_eventually_flat());
};
use constant::defer fNonLpred_cases_flat => sub {
  print "fNonLpred_cases_flat difference ...\n";
  my $f = MyFLAT::eventually_accepting (NonLpred_k_flat());

  foreach my $extra (@extras_L_array) {
    $f = $f->difference($extra);
  }
  $f->{'name'} = 'fNonLpred_cases';
  $f = $f->MyFLAT::minimize;
  $f;
};
use constant::defer fLpred_cases_flat => sub {
  my $f = fNonLpred_cases_flat->complement;
  $f->{'name'} = 'fLpred_cases';
  $f;
};

use constant::defer NonBpred_k_eventually_flat => sub {
  return MyFLAT::eventually_accepting (NonBpred_k_eventually_flat());
};
use constant::defer fNonBpred_cases_flat => sub {
  print "fNonBpred_cases_flat difference ... ";
  my $f = MyFLAT::eventually_accepting (NonBpred_k_flat());
  $f = $f->difference(fBpred_cases_extras_flat());
  $f->{'name'} = 'fNonBpred_cases';
  print "done ",$f->num_states," states\n";
  $f;
};
use constant::defer fBpred_cases_flat => sub {
  # print "fBpred_cases_flat union ... ";
  # my $f = Bpred_k_flat()->union(fBpred_cases_extras_flat())->as_dfa;
  # $f->{'name'} = 'fBpred_cases';
  # print "done ",$f->num_states," states\n";
  # $f;

  my $f = fNonBpred_cases_flat()->complement;
  $f->{'name'} = 'fBpred_cases';
  $f;
};


my @extras_R_array = (
                      # # $extra_plus1_left_flat,     # $extra_plus1_right_flat,
                      # $extra_plus11_left_flat,    # $extra_plus11_right_flat,
                      # $extra_minus1_left_flat,    # $extra_minus1_right_flat,
                      # # $extra_minus11_left_flat,   # $extra_minus11_right_flat,
                      # $extra_plus7_left_flat,     # $extra_minus7_right_flat,
                      # $extra_7_15_flat,
                     );
my @extras_L_array = (
                      # $extra_plus1_right_flat,    # $extra_plus1_left_flat,
                      # # $extra_plus11_right_flat,   # $extra_plus11_left_flat,
                      # # $extra_minus1_right_flat,   # $extra_minus1_left_flat,
                      # $extra_minus11_right_flat,  # $extra_minus11_left_flat,
                      # $extra_minus7_right_flat,   # $extra_plus7_left_flat,
                     );
my @extras_array = (@extras_R_array,
                    @extras_L_array);

use constant::defer fBpred_cases_extras_flat => sub {
  # $extra_plus1_left_flat->MyFLAT::as_nfa->union(@extras_array);
  print "cases extras union\n";

  # foreach my $extra (@extras_array) {
  #   $extra = $extra->MyFLAT::minimize;
  # }

  my $f = $extras_array[0];
  foreach my $extra (@extras_array) {
    $f = $f->union($extra)->as_dfa;
    $f = $f->MyFLAT::minimize;
  }
  # print $f->num_states," states ";
  # print "minimize ... ";
  # $f = $f->as_min_dfa;

  $f->{'name'} = 'fBpred_cases_extras';
  print "$f->{name} ",$f->num_states," states\n";
  $f;
};

{
  # equality of cases and surround
  fBpred_surround_init();

  {
    # R
    my $s = $fRpred_surround_flat;
    my $c = MyFLAT::eventually_accepting(fRpred_cases_flat());
    $s = $s->MyFLAT::minimize;
    $c = $c->MyFLAT::minimize;
    print "$s->{name} num states ", $s->num_states,"\n";
    print "$c->{name} num states ", $c->num_states,"\n";
    FLAT_check_is_equal($s, $c);
  }
  {
    # L
    my $s = $fLpred_surround_flat;
    my $c = MyFLAT::eventually_accepting(fLpred_cases_flat());
    $s = FLAT_minimize($s);
    $c = FLAT_minimize($c);
    print "$s->{name} num states ", $s->num_states,"\n";
    print "$c->{name} num states ", $c->num_states,"\n";
    FLAT_check_is_equal($s, $c);
  }
  {
    # B
    my $s = $fBpred_surround_flat;
    my $c = MyFLAT::eventually_accepting(fBpred_cases_flat());
    $s = FLAT_minimize($s);
    $c = FLAT_minimize($c);
    print "$s->{name} num states ", $s->num_states,"\n";
    print "$c->{name} num states ", $c->num_states,"\n";

    FLAT_check_is_equal($s, $c);
  }

  {
    # R
    my $s = $fNonRpred_surround_flat;
    my $c = MyFLAT::eventually_accepting(fNonRpred_cases_flat());
    # $s = FLAT_minimize($s);
    # $c = FLAT_minimize($c);
    print "$s->{name} num states ", $s->num_states,"\n";
    print "$c->{name} num states ", $c->num_states,"\n";
    FLAT_check_is_equal($s, $c);
  }
  {
    # L
    my $s = $fNonLpred_surround_flat;
    my $c = MyFLAT::eventually_accepting(fNonLpred_cases_flat());
    # $s = FLAT_minimize($s);
    # $c = FLAT_minimize($c);
    print "$s->{name} num states ", $s->num_states,"\n";
    print "$c->{name} num states ", $c->num_states,"\n";
    FLAT_check_is_equal($s, $c);
  }
  {
    # B
    my $s = $fNonBpred_surround_flat;
    my $c = MyFLAT::eventually_accepting(fNonBpred_cases_flat());
    $s = FLAT_minimize($s);
    $c = FLAT_minimize($c);
    print "$s->{name} num states ", $s->num_states,"\n";
    print "$c->{name} num states ", $c->num_states,"\n";

    FLAT_check_is_equal($s, $c);
  }
  exit 0;
}


  # # only eventually disjoint
  # foreach my $i (0 .. $#extras_array) {
  #   foreach my $j ($i+1 .. $#extras_array) {
  #     FLAT_check_disjoint($extras_array[$i], $extras_array[$j]);
  #   }
  # }


# 15-11 == 4
# to_binary(from_binary(01000000000000000000000) - \
#           from_binary(00010111011101110111011)) == \
#                       00101000100010001000101
# to_binary(from_binary(01000000000000000000000000) - \
#           from_binary(00000010111011101110111011)) == \
#                       00111101000100010001000101

# 2n+7/15  no need match n=0 as 2n+1
# = 2n+1 - 8/15
# to_binary(from_binary(0100000000000000000000) - \
#           from_binary(0010001000100010001000)) == \
#                       0001110111011101111000
# FLAT::Regex->new('1*'),
#

#------------------------------------------------------------------------------

# should not match:
#      011000011 0001 0001

# n=from_binary(11100100)
# n=from_binary(01000100)  \\ =2n  2n+1 = 01000101 = SpredLeft
# Spred(8,n+1)
# turn(n+1)
# my(len=15); binary_padded(floor(2^len*  (n+1 - 1/15)/2^8  ), len)
# $extra_minus1_left_flat->contains('010001001110111') or die;
# $extra_minus1_left_flat->contains('1010000111') or die;
# $extra_minus1_left_flat->contains('1110010011101110') or die;
# print "str path "; conf_print(path_bitstr_to_conf('01000100'));
# print "str path "; conf_print(path_bitstr_to_conf('010001001'));
# print "str path "; conf_print(path_bitstr_to_conf('0100010011'));
# print "str path "; conf_print(path_bitstr_to_conf('01000100111'));
# print "str path "; conf_print(path_bitstr_to_conf('010001001110'));
# print "str path "; conf_print(path_bitstr_to_conf('0100010011101'));
# print "str path "; conf_print(path_bitstr_to_conf('01000100111011'));
# print "str path "; conf_print(path_bitstr_to_conf('010001001110111'));
# exit;
#
# 0111011101
# 01   1110 1110 1
# 011  1110 1110 1
# 0111 1110 1110 1
# Spred(2,1) == 1
# (1+14/15)/4 == (2-1/15)/4
# binary_padded(floor(2^16*  (2-1/15)/4  ), 16)
# $extra_minus1_left_flat->contains('01') or die;
# $extra_minus1_left_flat->contains('01') or die;
# $extra_minus1_left_flat->contains('011110') or die;
# $extra_minus1_left_flat->contains('01111011101') or die;
# $extra_minus1_left_flat->contains('0111111011101') or die;

# $surround_segs_all->print;

my $segs_eventually_B = MyDragonConf->new
  (name => 'surround eventually B',
   segs => [
            "0,0,0",

            "0,0,1",  # start
            "0,0,2",
            "0,0,3",

            "1,1,0",  # top to right
            "1,1,3",  # end
            "1,-1,1",

            "-1,-1,0", # below left
            "-1,-1,1",

            "1,-1,2", # below
            "1,-1,3", # below down
           ]);
my $segs_triples = MyDragonConf->new
  (name => 'all triples',
   side => 0,
   segs => [
            $segs_eventually_B->segs_list,
            "2,0,2",  # end right completing expand
           ]);
foreach my $bit (0,1) {
  $segs_triples->is_subset( $segs_triples->expand($bit) ) or die;
}

# $flat is a FLAT::FA, $re is a FLAT::Regex style regular expression string.
# Return a new FLAT which accepts $flat followed by $re.
sub FLAT_concat_re {
  my ($flat, $re, %options) = @_;
  my $f = FLAT_concat($flat, FLAT::Regex->new($re));
  $f->{'name'} = $options{'name'};
  return $f;
}

