\\ Copyright 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ THIS IS A GENERATED FILE
\\ Extracted from dragon.tex by gp-inline.
\\
\\ These are Pari/GP functions and definitions used in dragon.tex for
\\ various self-tests and formula checking there.  Names and styles are
\\ highly specific to the calculations there, and many things will change or
\\ disappear, etc, but some of the functions might be useful for
\\ experimenting or testing.


/* ------------------------------------------------------------------------- */
/* gp-inline test boilerplate begin */
gp_inline__location = "";
gp_inline__good = 0;
gp_inline__bad = 0;
gp_inline__check(location,bool) =
{
  gp_inline__location = location;
  check(bool);
}
/* this is thinking about a check() for use in loops or "GP-Inline ..."
   testing, but it's not settled so don't rely on it */
check(bool) =
{
  /* use "===" so that a vector like [1] or float 1.0 not reckoned success */
  if(bool===1, gp_inline__good++,
     bool===0, gp_inline__bad++;
               print(gp_inline__location": gp-inline fail"),
     gp_inline__bad++;
     print(gp_inline__location": gp-inline expected result 0 or 1, got ",
           bool));
}
/* gp-inline test boilerplate end */
/* ------------------------------------------------------------------------- */

gp_inline__location="../dragon.tex:290";
 default(strictargs,1);

gp_inline__location="../dragon.tex:294";
 \\ my http://user42.tuxfamily.org/pari-geom/index.html
 iferr(read("tools/geom.gp"),e, \
    read("../tools/geom.gp"));
 iferr(read("tools/geom-inertia.gp"),e, \
    read("../tools/geom-inertia.gp"));
 iferr(read("tools/geom-wip.gp"),e, \
    read("../tools/geom-wip.gp"));

gp_inline__location="../dragon.tex:302";
 \\ my http://user42.tuxfamily.org/pari-memoize/index.html
 iferr(read("tools/memoize.gp"),e, \
    read("../tools/memoize.gp"));

gp_inline__location="../dragon.tex:306";
 \\ my http://user42.tuxfamily.org/pari-vpar/index.html
 iferr(read("tools/vpar.gp"),e, \
    read("../tools/vpar.gp"));

gp_inline__location="../dragon.tex:310";
 \\ my http://user42.tuxfamily.org/pari-vecper/index.html
 iferr(read("tools/vecper.gp"),e, \
    read("../tools/vecper.gp"));

gp_inline__location="../dragon.tex:314";
 iferr(read("tools/interval.gp"),e, \
    read("../tools/interval.gp"));

gp_inline__location="../dragon.tex:317";
 \\ for many functions compared against OEIS sample values
 iferr(read("tools/dragon-oeis-samples.gp"),e, \
    read("../tools/dragon-oeis-samples.gp"));

gp_inline__location="../dragon.tex:322";
 nearly_equal_epsilon = 1e-15;
 nearly_equal(x,y, epsilon=nearly_equal_epsilon) = {
   \\ print(type(x)," ",type(y)," ",x," ",y);
   my(d=x-y); \\ ensure compatible types
   if(type(x)=="t_MAT",x=Vec(x);y=Vec(y));
   if(type(x)=="t_VEC" || type(x)=="t_COL",
        sum(i=1,max(#x,#y), !nearly_equal(x[i],y[i],epsilon)) == 0,
      type(x)=="t_QUAD" || type(x)=="t_COMPLEX",
           nearly_equal(real(x-y),0,epsilon)
        && nearly_equal(imag(x-y),0,epsilon),
      abs(d) < epsilon);
 }

gp_inline__location="../dragon.tex:335";
 cbrt(x) = x^(1/3);

gp_inline__location="../dragon.tex:337";
 \\ x is an angle in degrees.  Return as radians.
 degrees(x) = x/180*Pi; /* x in degrees, return radians */
 to_degrees(x) = x*180/Pi; /* x in radians, return degrees */

gp_inline__location="../dragon.tex:341";
 sqrt2  = quadgen(4*2);
 sqrt3i = quadgen(-12);  /* sqrt(3)*I */
 sqrt5  = geom_sqrt_as_quad(5);
 sqrt7  = geom_sqrt_as_quad(7);
 sqrt7i = geom_sqrt_as_quad(-7);
 sqrt10 = geom_sqrt_as_quad(10);
 sqrt13 = geom_sqrt_as_quad(13);
 sqrt26 = geom_sqrt_as_quad(26);

gp_inline__location="../dragon.tex:359";
 quad_to_root(q) = my(d=q.disc); d%4==0 || error(); d/4;

gp_inline__location="../dragon.tex:364";
 to_symbolic(x) = {
   if(type(x)=="t_QUAD",
      real(x) + imag(x)*eval(Str("'sqrt",quad_to_root(x))),
      x);
 }

gp_inline__location="../dragon.tex:375";
 symbolic_reduce_squares(p) = {
   p=substpol(p, 'sqrt2^2, 2);
   p=substpol(p, 'sqrt5^2, 5);
   p=substpol(p, 'sqrt10^2, 10);
   p=substpol(p, 'sqrt13^2, 13);
   p;
 }
 symbolic_reduce(p) = {
   p=substpol(p, 'sqrt2*'sqrt10, 2*'sqrt5);
   \\ p=substpol(p, 'sqrt5*'sqrt10, 5*'sqrt2);
   p=symbolic_reduce_squares(p);
   if(denominator(p=='sqrt2),
      p*='sqrt2^2;
      p=substpol(p, 'sqrt2^2, 2);
      p/=2);
   p;
 }

gp_inline__location="../dragon.tex:397";
 symbolic_to_inexact(p) = {
   p=subst(p, 'sqrt2,  sqrt(2));
   p=subst(p, 'sqrt5,  sqrt(5));
   p=subst(p, 'sqrt10, sqrt(10));
   p=subst(p, 'sqrt13, sqrt(13));
   p=subst(p, 'sqrt17, sqrt(17));
   p=subst(p, 'sqrt26, sqrt(26));
   p;
 }

gp_inline__location="../dragon.tex:407";
 mp_one = [-1,1];

gp_inline__location="../dragon.tex:409";
 \\ return 1 or 0 according as x is an integer or not
 is_integer(x) = (x==floor(x)) && variable(x)==0;

gp_inline__location="../dragon.tex:416";
 \\ Return 1 if x is an integer power of 2, so 2^0, 2^1, etc.
 \\ Return 0 if not.
 is_power_of_2(x) = \
   is_integer(x) && x>=1 && valuation(x,2)==logint(x,2);

gp_inline__location="../dragon.tex:441";
 \\ Jacobsthals A001045
 Jacobsthal(k) = (2^k - (-1)^k)/3;

gp_inline__location="../dragon.tex:446";
 \\ Return true if a,b,c is a primitive Pythagorean triple.
 is_primitive_Pythagorean_triple(a,b,c) = {
   is_integer(a) && is_integer(b) && is_integer(c)
   && a^2 + b^2 == c^2
   && gcd(a,b) == 1;
 }

gp_inline__location="../dragon.tex:455";
 \\ z is geom.gp style point.  Return true if
 \\ x,y,hypot is a primitive Pythagorean triple.
 is_primitive_Pythagorean_triple_point(p) = {
   my(c = geom_norm(p));
   issquare(c,&c) &&
   is_primitive_Pythagorean_triple
     (geom_point_x(p), geom_point_y(p), c);
 }

gp_inline__location="../dragon.tex:467";
 vector_mean(v) = vecsum(v)/#v;
 vector_modulo(v,i) = v[(i% #v)+1];

gp_inline__location="../dragon.tex:470";
 \\ v is a vector, return 1 if all elements are >=0
 vector_is_ge0(v) = for(i=1,#v, v[i]>=0 || return(0)); 1;

gp_inline__location="../dragon.tex:473";
 \\ v is a vector, return its middle value.
 \\ If #v is odd then it has a single middle element.
 \\ If #v is even then return the mean of the two middle elements.
 vector_middle(v) = if(#v%2, v[#v\2+1], (v[#v\2]+v[#v\2+1])/2);

gp_inline__location="../dragon.tex:483";
 vector_differences(v) = \
   if(#v==0,[], vector(#v-1,i,v[i+1]-v[i]));

gp_inline__location="../dragon.tex:490";
 \\ ret[1] = v[1]
 \\ ret[2] = v[1] + v[2]
 \\ ret[3] = v[1] + v[2] + v[3]
 \\ etc
 \\ So each ret is sum of i many terms.
 vector_cumulative(v) = for(i=2,#v,v[i]+=v[i-1]); v;

gp_inline__location="../dragon.tex:501";
 \\ ret[1] = 0
 \\ ret[2] = v[1]
 \\ ret[3] = v[1] + v[2]
 \\ ret[4] = v[1] + v[2] + v[3]
 \\ etc
 \\ So a vector of sum 0 to n-1 many terms from v.
 \\ v[#v] is unused.
 vector_cumulative0(v) = {
   my(ret=vector(#v));
   for(i=2,#v, ret[i]=ret[i-1] + v[i-1]);
   ret;
 }

gp_inline__location="../dragon.tex:518";
 \\ vector_is_all_equal(v) returns true if all elements of v
 \\ are equal, as compared with ==.
 vector_is_all_equal(v) = \
   for(i=2,#v, if(v[i]!=v[1],return(0))); \
   1;

gp_inline__location="../dragon.tex:524";
 \\ vector_is_ascending(v) returns true if all elements of v
 \\ are in strictly ascending order
 vector_is_ascending(v) = \
   for(i=2,#v, if(v[i]<=v[i-1], return(0))); \
   1;

gp_inline__location="../dragon.tex:530";
 \\ v is a vector.  Return 1 if it contains elem.
 \\ v doesn't have to be sorted, comparison is by ==.
 vector_contains(v,elem) = for(i=1,#v,if(v[i]==elem,return(1))); 0;

gp_inline__location="../dragon.tex:534";
 \\ Return v shortened to its first n elements.
 \\ If n==0 then return an empty vector.
 vector_shorten_to(v,n) = if(n,v[1..n],[]);

gp_inline__location="../dragon.tex:538";
 \\ sub and super are Set()s.
 \\ Return 1 if sub is a subset or equal to super.
 set_is_subset(sub,super) = {
   if(!(setisset(sub) && setisset(super)), error("not a Set"));
   setintersect(sub,super) == sub;
 }

gp_inline__location="../dragon.tex:548";
 \\ Like fromdigits(), but accepting any base, not just integers.
 \\ Would probably like the actual fromdigits() to be this way.
 \\ Terms must not use symbol 'x.
 fromdigits_any(v,base=10) = subst(Pol(v),'x,base);

gp_inline__location="../dragon.tex:555";
 \\ v is a vector of bits [1,0,1,0,1,1,0] high to low.
 \\ Return them as an integer.
 \\ This uses subst() so bits can be negatives and other unusual
 \\ values, not just 0 and 1.
 from_binary_vector(v) = fromdigits_any(v,2);

gp_inline__location="../dragon.tex:577";
 \\ n is an integer.  Return an integer whose decimal digits
 \\ are the bits of n.
 to_binary(n)=fromdigits(binary(n))*sign(n);

gp_inline__location="../dragon.tex:583";
 \\ n is an integer with decimal digits representing bits.
 \\ Return the value of those bits.
 from_binary(n) = fromdigits(digits(n),2);

gp_inline__location="../dragon.tex:589";
 \\ Return integer whose decimal digits are the ternary digits of n.
 to_ternary(n) = fromdigits(digits(n,3),10);

gp_inline__location="../dragon.tex:595";
 \\ n is an integer whose decimal digits are in the range 0-2
 \\ and are taken to be ternary.  The return is their value
 \\ in ternary.
 from_ternary(n)=fromdigits(digits(n,10),3);

gp_inline__location="../dragon.tex:602";
 \\ character ASCII integer values as per Vecsmall(str) breaking
 \\ a string into integer characters
 chr_dot  =Vecsmall(".")[1];
 chr_zero =Vecsmall("0")[1];
 chr_one  =Vecsmall("1")[1];
 chr_minus=Vecsmall("-")[1];
 chr_space=Vecsmall(" ")[1];

gp_inline__location="../dragon.tex:610";
 \\ str is a binary string such as "0101.1110 0001 0000"
 \\ Digits are 0,1, binary point is ".", spaces are ignored.
 \\ The return is a fraction (t_FRAC) for the value.
 \\ Or if no binary point or only 0s below the binary point then
 \\ the return is an integer.
 from_binary_str(str) =
 {
   my(v=Vec(Vecsmall(str)),
      d=0);
   v=select(c->c!=chr_space, v);
   my(minus=1);
   if(#v && v[1]==chr_minus, v=v[^1];minus=-1);
   forstep(i=#v,1,-1,
      if(v[i]==chr_dot,
         d=#v-i;
         v=v[^i];
         break));
   v=apply(c->if(c==chr_zero,0,
                 c==chr_one,1,
                 error("from_binary_str(): bad char "Strchr(c))),
           Vec(v));
   \\ print(v" "d);
   fromdigits(v,2) / (1<<d) * minus;
 }

gp_inline__location="../dragon.tex:640";
 \\ v is a vector of fractional decimal digits high to low.
 \\ Eg. [1,2,3] is 123/1000 = 0.123
 \\ Return them as a rational like 12981/10^5.
 \\ If v is longer than the current floating point
 \\ precision() then use only that much of v.
 \\ "point" is how many digits before the decimal point.
 \\ "add" is an amount to add at the low end of the digits.
 fromdigits_to_precision(v,point=0, add=0) = {
   my(p = precision(1.0) - 4);
   if(#v>p, v = v[1..p]);
   (fromdigits(v)+add) / 10^(#v-point);
 }

gp_inline__location="../dragon.tex:656";
 \\ n is an integer.  Return its bits as a vector high to low
 \\ padded out with high 0s to make k many bits.
 \\ n must fit within k bits, ie. 0 <= n < 2^k.
 binary_padded(n,k) = {
   my(v = binary(n));
   if(#v>k, error("binary_padded() n=",n," is bigger than k=",k," bits"));
   concat(vector(max(0,k-#v)),v);
 }

gp_inline__location="../dragon.tex:668";
 \\ Like digits() but pad with high 0s to make k many digits.
 \\ Must have n < base^k.
 digits_padded(n,k,base=10) = {
   my(v = digits(n,base));
   if(#v>k, error("digits_padded() n=",n," is bigger than k=",k," digits"));
   concat(vector(max(0,k-#v)),v);
 }

gp_inline__location="../dragon.tex:680";
 BitAboveLowestOne(n) = {
   n>=1 || error("BitAboveLowestOne() is for n>=1");
   bittest(n, valuation(n,2)+1);
 }
 BitAboveLowestOne_allow_zero(n) = {
   n>=0 || error("BitAboveLowestOne_allow_zero() is for n>=0");
   if(n==0,0, BitAboveLowestOne(n));
 }

gp_inline__location="../dragon.tex:689";
 \\ A038189 is BitAboveLowestOne with extra initial A038189(0)=0
 \\ reckoning n=0 as having 0 bit
 A038189(n) = BitAboveLowestOne_allow_zero(n);

gp_inline__location="../dragon.tex:695";
 \\ A000120
 CountOneBits(n) = hammingweight(n);
 A000120(n) = hammingweight(n);

gp_inline__location="../dragon.tex:706";
 \\ A007814
 CountLowZeros(n) = {
   n>=1 || error("CountLowZeros() is for n>=1");
   valuation(n,2);
 }

gp_inline__location="../dragon.tex:718";
 A007814(n) = CountLowZeros(n);

gp_inline__location="../dragon.tex:728";
 A001511(n) = CountLowZeros(n) + 1;

gp_inline__location="../dragon.tex:736";
 \\ Joseph Rosenbaum, Elementary Problem E319,
 \\ American Mathematical Monthly, volume 45, number 10, December 1938, pages 694-696.
 \\ https://doi.org/10.2307/2302451
 \\ binary case indices of the "A"s, P expansion at equation 1
 Rosenbaum_P(n) = {
   n>=1 || error();
   if(n==1,[1], concat([Rosenbaum_P(n-1), n, Rosenbaum_P(n-1)]));
 }

gp_inline__location="../dragon.tex:748";
 \\ general case indices of the "A"s, P expansion at eqns 1', 2'
 Rosenbaum_Pp(n,p) = {
   n>=1 || error();
   p>=1 || error();
   if(n==1, return(vector(p-1,i,1)));
   my(ret=[]);
   for(i=1,p,
     ret=concat(ret,Rosenbaum_Pp(n-1,p));
     if(i!=p, ret=concat(ret,[n])));
   ret;
 }

gp_inline__location="../dragon.tex:786";
 CountLowOnes(n) = CountLowZeros(n+1);

gp_inline__location="../dragon.tex:807";
 \\ A000265
 OddPart(n) = n / 2^CountLowZeros(n);
 A000265(n) = OddPart(n);

gp_inline__location="../dragon.tex:818";
 \\ Return the bit position of the highest 1-bit in n.
 \\ Must have n>=1.
 \\ Lowest bit is position 0, so return power k such that 2^k
 \\ is the highest 1-bit.  2^k <= n < 2^{k+1}
 high_bit_k(n) = logint(n,2);

gp_inline__location="../dragon.tex:831";
 \\ Return the most significant bit from n, with all other bits
 \\ cleared to 0s.
 \\ Eg. n = binary 10110 -> 10000.
 high_bit(n) = if(n==0,0, 1<<high_bit_k(n));

gp_inline__location="../dragon.tex:838";
 sans_high_bit(n) = if(n==0,0, n - high_bit(n));
 A053645(n) = {
   n>=1 || error("A053645() is for n>=1");
   sans_high_bit(n);
 }

gp_inline__location="../dragon.tex:850";
 \\ vector_midpoints(v) looks at the elements of vector v
 \\ and returns a new vector which is their successive
 \\ midpoints, ie. the arithmetic mean of adjacent
 \\ v[i] and v[i+1].
 vector_midpoints(v) = if(#v==0,return([])); \
   vector(#v-1,i,(v[i+1]+v[i])/2);

gp_inline__location="../dragon.tex:860";
 \\ vector_histogram(v) looks at the elements of v and
 \\ returns a vector h where h[i] is how many elements
 \\ of v there are which occur i many times.
 vector_histogram(v) = {
   if(#v==0,return([]));
   my(seen=List([]), count=List([]));
   for(i=1,#v,
     my(pos=setsearch(seen,v[i],1));
     if(pos, listinsert(seen,v[i], pos); /* new */
             listinsert(count,1, pos),
             count[setsearch(seen,v[i])]++));  /* already seen */
   count=Vec(count);
   my(histogram = vector(vecmax(count), i, 0));
   for(i=1,#count, histogram[count[i]]++);
   histogram;
 }

gp_inline__location="../dragon.tex:884";
 \\ vector_count_singles(v) looks at the elements of vector
 \\ v and returns the number of values which are unique,
 \\ ie. occur just once each.
 vector_count_singles(v) = if(#v==0,return(0)); vector_histogram(v)[1];

gp_inline__location="../dragon.tex:895";
 \\ vector_count_duplicates(v) looks at the elements of
 \\ vector v and returns the number of values which occur
 \\ 2 or more times each.  Elements are compared with ==.
 vector_count_duplicates(v) = if(#v==0,return(0)); \
   vecsum(vector_histogram(v)[^1]);

gp_inline__location="../dragon.tex:906";
 vector_run_lengths(v) = {
   if(#v==0,return([]));
   my(l=List([]),run=1);
   for(i=2,#v, if(v[i]==v[i-1],run++, listput(l,run);run=1));
   listput(l,run);
   Vec(l);
 }

gp_inline__location="../dragon.tex:918";
 \\ rectangle_points_at_angle(v,z) returns the number of points
 \\ which are on the rectangle oriented in the direction z and
 \\ which encloses all points of v.
 \\ v is a vector of complex-number points.
 \\ z is a complex number giving a direction.
 rectangle_points_at_angle(v,z) = {
   v = v/z;
   my(original_count = #v,
      min_real = vecmin(apply(real,v)),
      max_real = vecmax(apply(real,v)),
      min_imag = vecmin(apply(imag,v)),
      max_imag = vecmax(apply(imag,v)));
   v = select(y->real(y)!=min_real, v);
   v = select(y->real(y)!=max_real, v);
   v = select(y->imag(y)!=min_imag, v);
   v = select(y->imag(y)!=max_imag, v);
   original_count - #v;
 }
 vector_delete(v,x) = select(y->y!=x, v);

gp_inline__location="../dragon.tex:940";
 \\ vector_count_equal(v,x) returns a count of how many times
 \\ x occurs in v.  Comparison is by ==.
 vector_count_equal(v,x) = sum(i=1,#v, v[i]==x);

gp_inline__location="../dragon.tex:944";
 \\ Return a vector of the first n coefficients of
 \\ generating function g, starting from term x^0.
 \\ g is normally a polynomial fraction (type t_RFRAC)
 \\ but a plain polynomial is accepted too and returns
 \\ its lowest n coefficients.
 gf_terms(g,n) = {
   if(g==0,return(vector(n)));
   my(x = variable(g),
      zeros = min(n,valuation(g,x)),
      v = Vec(g + O(x^n)));
   if(zeros>=0, concat(vector(zeros,i,0), v),
                v[-zeros+1 .. #v]);
 }

gp_inline__location="../dragon.tex:965";
 gf_term(g,n) = gf_terms(g,n+1)[n+1];

gp_inline__location="../dragon.tex:967";
 \\ Generating function of all ones 1,1,1,1,1,1,...
 gOnes(x)=1/(1-x);

gp_inline__location="../dragon.tex:971";
 \\ Generating function of all ones 0,0,1,1,... k>=n
 gOnes_starting_at_n(x,n) = x^n * gOnes(x);

gp_inline__location="../dragon.tex:975";
 \\ Generating function of powers of 2, so 1,2,4,8,16,...
 gTwoPow(x)=1/(1-2*x);

gp_inline__location="../dragon.tex:981";
 \\ select_first_n(f,n) returns a vector of length n which are the
 \\ indices i for which function f(i) is true.
 \\ Indices checked start from 0 so i=0,1,2,...
 select_first_n(f,n) = {
   my(l=List([]), i=0);
   while(#l<n, if(f(i),listput(l,i)); i++);
   Vec(l);
 }

gp_inline__location="../dragon.tex:990";
 \\ Return a vector which is vector v repeated n times.
 \\ n=0 is an empty vector.
 concat_repeat(v,n) = concat(vector(n+1,i,if(i==1,[],v)));

gp_inline__location="../dragon.tex:996";
 \\ Return the number of integer points on the boundary of
 \\ polygon v.  v is a vector of complex number vertices.
 boundary_numint_of_polygon(v) = {
   v = geom_sides_of_polygon(v);
   sum(i=1,#v, gcd(geom_point_x(v[i]), geom_point_y(v[i])));
 }

gp_inline__location="../dragon.tex:1008";
 \\ Return the maximum norm(v[i]-v[j]).
 vector_max_pair_norm(v) = {
   my(m=0);
   for(i=1,#v, for(j=i+1,#v, m = max(m, norm(v[i]-v[j]))));
   m;
 }
 \\ Return [i,j] which are the maximum norm(v[i]-v[j]).
 vector_max_pair_norm_indices(v) = {
   my(m=-1, indices=0);
   for(i=1,#v, for(j=i+1,#v,
                   my(n = norm(v[i]-v[j]));
                   if(n > m, m=n; indices=[i,j])));
   indices;
 }

gp_inline__location="../dragon.tex:1023";
 \\ vector_unique(v) returns the unique elements from vector v.
 \\ Elements are compared with ==.  Elements can be in any order.
 \\ The first of each distinct element is kept for the return,
 \\ and in the original order of v.
 vector_unique(v) = {
   my(seen=List([]), result=List([]));
   for(i=1,#v,
       my(pos=setsearch(seen,v[i],1));  \\ where to insert
       if(pos,
          listinsert(seen,v[i], pos);
          listput(result,v[i])));
   Vec(result);
 }

gp_inline__location="../dragon.tex:1041";
 Manhattan(z) = abs(real(z)) + abs(imag(z));

gp_inline__location="../dragon.tex:1043";
 gf_shift_down(g,n) = {
   my(x = variable(g));
   for(i=1,n, g -= gf_term(g,0); g /= x);
   g;
 }
 gf_in_terms_of(g,h) = {        \\ g in terms of h
   my(gdenv = [denominator(g)]);
   for(len=1,200,
       \\ print("len="len);
       my(hv = vector(len,i, gf_shift_down(h,i-1)),
          d = lcm(concat(gdenv,apply(denominator,hv))),
          hvnums = hv*d,
          gnum = g*d);
       \\ for(i=1,#hv,pol_ascending_print(hv[i])); print(d);
       poldegree(gnum) < len || next();
       vecmax(apply(poldegree,hvnums)) < len || next();
       my(m = matrix(len,len,i,j, polcoeff(hvnums[j],i-1)),
          v = vectorv(len,i, polcoeff(gnum,i-1)),
          f = iferr(matsolve(m,v),e,[]));
       if(f!=[],
          \\ print(sum(i=1,#f, f[i]*hv[i])); print(g);
          while(#f>0 && f[#f]==0, f=f[1..-2]);
          sum(i=1,#f, f[i]*hv[i]) == g || error("oops wrong sum");
          return(f)));
   error("no solution found");
 }

gp_inline__location="../dragon.tex:1070";
 recurrence_coeffs_to_matrix(coeffs) = {
   matrix(#coeffs,#coeffs,r,c,
          if(c==r+1,1, r==#coeffs,coeffs[c]));
 }

gp_inline__location="../dragon.tex:1075";
 \\ coeffs[] is a vector of linear recurrence coefficients.
 \\ initial[] is a vector of initial values, where initial[1]
 \\ is the value at k=0, etc.
 \\ coeffs are applied low to high like
 \\   coeffs[1]*initial[1] + coeffs[2]*initial[2] = value at k=2
 \\
 \\ If initial[] is longer than coeffs[] then the extras at its
 \\ start are exceptions to the recurrence and are returned
 \\ directly.
 \\
 \\ If initial[] is the same length as coeffs[] then there are
 \\ no initial exceptions and can have k<0 to go backwards in
 \\ the recurrence.
 \\
 recurrence_eval(coeffs,initial,k) = {
   my(skip=#initial-#coeffs);
   if(skip && k<skip, return(initial[k+1]));
   initial=initial[skip+1 .. #initial];
   k-=skip;
   (recurrence_coeffs_to_matrix(coeffs)^k * Col(initial))[1];
 }

gp_inline__location="../dragon.tex:1101";
 \\ m is a map.  Return its value at key, or 0 if no such entry.
 mapget_or_zero(m,key) = my(v); if(mapisdefined(m,key,&v), v, 0);

gp_inline__location="../dragon.tex:1106";
 \\ v is a vector of continued fraction terms, as per contfrac().
 \\ Return the fraction it represents.
 \\ Eg. v=[9,8,7,6] gives 9 + 1/(8 + 1/(7 + 1/6))
 contfrac_to_rational(v) = {
   \\ contfracpnqn() gives matrix [ p[n], p[n-1];
   \\                               q[n], q[n-1] ]
   \\ where p[n]/q[n] is the last partial quotient,
   \\ and p[n-1],q[n-1] is the second last (unused here)
   my(m=contfracpnqn(v));
   m[1,1]/m[2,1];
 }

gp_inline__location="../dragon.tex:1122";
 \\ "table" is a matrix where each row is state transitions,
 \\ so new_state = table[state,digit].
 \\ Return a vector where v[state] = generating function for how
 \\ many digit strings are in state after k steps.
 \\ "initial" is the starting state.  The k=0 terms of the gfs are
 \\ 1 in v[initial] and 0 everywhere else.
 state_table_to_gfs(table,initial=1) = {
   my(m=state_table_to_matrix(table),
      l=matsize(m)[1],
      v=vectorv(l));
   v[initial]=1; \\ and all others 0 (index error on bad "initial")
   Vec(matsolve(matid(l)-m*'x, v));
 }
 \\ Memoize for the benefit of naive repeat calls to get the gfs
 \\ of the same state table.  This is a bit wasteful of memory,
 \\ but is a speedup on medium to large state tables.
 state_table_to_gfs = memoize(state_table_to_gfs);

gp_inline__location="../dragon.tex:1140";
 state_table_to_matrix(table) = {
   my(l=matsize(table)[1], w=matsize(table)[2], m=matrix(l,l));
   for(from=1,l,
     for(digit=1,w,
       m[table[from,digit],from]++));
   m;
 }

gp_inline__location="../dragon.tex:1152";
 A003149(n) = sum(k=0,n, k!*(n-k)!);

gp_inline__location="../dragon.tex:1156";
 \\ A003230 OFFSET=0 starting 1,4,11,28,67
 \\ cf Signature 4,-5,4,-6,4 descending order
 \\ A(k) = D(k), etc
 A003230(n) = {
   n>=0 || error("A003230() is for n>=0");
   recurrence_eval([4,-6,4,-5,4], [1,4,11,28,67], n);
 }

gp_inline__location="../dragon.tex:1168";
 \\ A003478 OFFSET=0
 gA003478(x) = 1/(2*x-1)/(-1+x+2*x^3);  \\ per Simon Plouffe

gp_inline__location="../dragon.tex:1172";
 \\ n AND floor(n/2),  low 1-bit of each 11 pair
 A048735(n) = bitand(n,n>>1);

gp_inline__location="../dragon.tex:1177";
 \\ n - (n AND floor(n/2)), 1-bit of each 01 pair, high 1 each run of 1s
 A292272(n) = n - bitand(n,n>>1);  \\ sequence definition

gp_inline__location="../dragon.tex:1202";
 \\ 1-bit at the 0 of each each 01 pair
 A213064(n) = bitnegimply(n<<1,n);

gp_inline__location="../dragon.tex:1217";
 \\ number of 01 bit pairs in n
 count_01(n) = my(v=binary(n)); sum(i=1,#v-1, v[i]==0 && v[i+1]==1);
 A037800(n) = count_01(n);

gp_inline__location="../dragon.tex:1229";
 \\ 1-bit kept below each run of 1s
 \\ is 1-bit at the 0 of a 10 bit pair in n
 \\ see also devel/test-CountOneBits-incr.gp
 A229762(n) = bitand(bitxor(n,n>>1), n>>1);

gp_inline__location="../dragon.tex:1254";
A203175(n) = {
  n>=1 || error("A203175() is for n>=1");  \\ OFFSET=1
  recurrence_eval([2,0,1],[1,1,2],n-1);
}

gp_inline__location="../dragon.tex:1262";
 \\ A203175 OFFSET=1
 \\ gA203175(x) first term at x^1
 \\ this expression per R. J. Mathar in A203175
 gA203175(x) = -x*(1+x^2)/(-1+x+2*x^3);

gp_inline__location="../dragon.tex:1275";
 A203175_is_permitted(aaL,aaR, aL,aR, L,R) = {
   \\ every 1 immediately preceded by 0 left or above
   if(L==1, aL==0 || return(0));
   if(R==1, L==0 || aR==0 || return(0));

   \\ no 0 immediately preceded by a 0
   if(L==0 && aL==0,           return(0));
   if(R==0 && (L==0 || aR==0), return(0));

   \\ every 2 immediately preceded by 0 1 to the left or above
   if(L==2, (aaL==0 && aL==1) || return(0));
   if(R==2, (aaR==0 && aR==1) || return(0));
   1;
 }

gp_inline__location="../dragon.tex:1292";
 A203175_validate(elem) = {
   my(aL='none, aR='none, aaL='none, aaR='none, L,R);
   for(i=1,#elem,
     [L,R] = elem[i];
     A203175_is_permitted(aaL,aaR, aL,aR, L,R) || error();
     [aaL,aaR] = [aL,aR];
     [aL,aR] = [L,R]);
 }

gp_inline__location="../dragon.tex:1301";
 A203175_extend_list(vec) = {
   my(l=List([]));
   for(i=1,#vec,
     my(elem=vec[i],
        aL='none, aR='none, aaL='none, aaR='none);
     if(#elem>=1, [aL,aR] = elem[#elem]);
     if(#elem>=2, [aaL,aaR] = elem[#elem-1]);
     for(L=0,2,
       for(R=0,2,
         if(A203175_is_permitted(aaL,aaR, aL,aR, L,R),
           listput(l,concat(elem,[[L,R]]))))));
   Vec(l);
 }
 A203175_extend_list_with_validate(vec) = {
   for(i=1,#vec, A203175_validate(vec[i]));
   A203175_extend_list(vec);
 }
 A203175_list(len) = {
   my(vec=[ [] ]);  \\ one empty array
   for(i=1,len, vec=A203175_extend_list(vec));
   vec;
 }

gp_inline__location="../dragon.tex:1364";
 A203175_state_to_end = {[
   [ ],             \\ 1
   [[0,1]],         \\ 2
   [[0,1],[1,0]],   \\ 3
   [[0,1],[1,2]],   \\ 4
   [[0,2],[1,0]],   \\ 5
   [[1,0],[0,1]],   \\ 6
   [[1,0],[2,1]],   \\ 7
   [[1,2],[0,1]],   \\ 8
   [[1,2],[2,0]],   \\ 9
   [[2,0],[0,1]],   \\ 10
   [[2,1],[0,1]],   \\ 11
   [[2,1],[0,2]]    \\ 12
 ]};
 A203175_num_states = #A203175_state_to_end;

gp_inline__location="../dragon.tex:1381";
 A203175_end_to_state = {
   Map(matrix(A203175_num_states,2,state,col,
              if(col==1,A203175_state_to_end[state], state)));
 }

gp_inline__location="../dragon.tex:1390";
 \\ last two terms from the vector "elem"
 A203175_elem_to_end(elem) = elem[max(1,#elem-1)..#elem];

gp_inline__location="../dragon.tex:1393";
 A203175_end_descendants(end) = \
   apply(A203175_elem_to_end, A203175_extend_list([end]));

gp_inline__location="../dragon.tex:1398";
 A203175_ends_matrix = \
   matrix(A203175_num_states,A203175_num_states);
 {
   for(state=1,A203175_num_states,
     my(end=A203175_state_to_end[state],
        descendants=A203175_end_descendants(end));
     for(i=1,#descendants,
       my(to_end=descendants[i],
          to=mapget(A203175_end_to_state, to_end));
       A203175_ends_matrix[to,state]++));
 }
 A203175_initial_counts = [1,0,0, 0,0,0, 0,0,0, 0,0,0]~;

gp_inline__location="../dragon.tex:1415";
 A203175_state_gfs = {
   Vec(matsolve(matid(A203175_num_states)
                  - A203175_ends_matrix*'x,
                A203175_initial_counts));
 }

gp_inline__location="../dragon.tex:1519";
 fractal_transform_U(z) = conj(b)/2 * z;
 fractal_transform_R(z) = 1 - b/2 * z;
 b = 1+I;

gp_inline__location="../dragon.tex:1523";
 \\ Return a vector which is the vertices of dragon curve
 \\ level k.  The vector has 2^k+1 integer complex numbers
 \\ (Gaussian integers).
 dragon_points(k) = {
   k>=0 || error("dragon_points() is for k>=0");
   my(v=[0,1]);
   for(i=1,k, my(end = (1+I)*v[#v]);
       v = concat(v, apply(c->(end - I*c), Vecrev(v[^-1]))));
   v;
 }

gp_inline__location="../dragon.tex:1537";
 \\ Return a vector which is the midpoints of the dragon
 \\ curve segments in level k.  There are 2^k segments so
 \\ the vector has 2^k complex number values.
 \\ The first point is at 1/2, being the midpoint of the
 \\ first segment 0 to 1.
 dragon_midpoints(k) = {
   k>=0 || error("dragon_midpoints() is for k>=0");
   my(v=[1/2], end=1);
   for(i=1,k,
       end *= 1+I;
       v = concat(v, apply(z->(end - I*z), Vecrev(v))));
   v;
 }

gp_inline__location="../dragon.tex:1556";
 dragon_n_to_z(n) = {
   my(z=0, d=1, v=concat(0,binary(n)));
   for(i=2,#v,  \\ high to low
       z *= b;
       if(v[i-1], if(v[i], z+=d*I, d*=I),  \\ odd, left side
                  if(v[i], z+=d; d*=I)));  \\ even, right side
   z;
 }

gp_inline__location="../dragon.tex:1567";
 \\ v is a vecper [ [bit,bit, ..., bit], [ bit,bit, ... ] ]
 \\ which are fixed and periodic bits as fractional binary.
 \\     f = 0.aaaaa (ppppp)repeat
 \\
 \\ Return a similar vector suitably mangled for a dragon curve
 \\ point when taken in base b=1+I by vecper_frac_fromdigits().
 \\
 \\ The mangling looks for bit pairs 0,1 negates to -1 all the bits
 \\ from there below, until the next 0,1 flips back to +1 again.
 \\ This is applied through both fixed and periodic parts.
 \\ The periodic part might increase in length to allow the
 \\ negations to be periodic.
 \\
 vecper_binary_to_dragon(v) = {
   vecper_apply_state((bit,state)->
                      \\ print("bit="bit" state "state);
                      my(prev_bit=state[1],
                         s=state[2]); \\ sign
                      [bit*s,    \\ transformed bit
                       [ bit,    \\ new state prev_bit
                         s*if(prev_bit==0 && bit==1,
                              -1,1) \\ negate below 0,1
                       ]],
                      v,
                      [ 0,    \\ initial 0-bit above binary point
                        1 ]); \\ initial +1
 }

gp_inline__location="../dragon.tex:1606";
 \\ f is a rational fraction 0 <= f <= 1
 \\ Return complex number z location in dragon fractal.
 dragon_fpoint(f) = {
   (0 <= f && f <= 1) || error("dragon_fpoint() is for 0<=f<=1");
   my(v=vecper_frac_digits(f,2));
   v=vecper_binary_to_dragon(v);
   vecper_frac_fromdigits(v,b);
 }

gp_inline__location="../dragon.tex:4765";
 w8_inexact = exp(2*Pi*I / 8);

gp_inline__location="../dragon.tex:4768";
 \\ w8_times_sqrt2 is eighth root of unity multiplied by sqrt2
 \\ so that it's represented exactly.
 w8_times_sqrt2 = b;

gp_inline__location="../dragon.tex:5899";
 \\ A110036 constant from partial quotients of sum 1/x^(2^n).
 \\ This code by Paul D. Hanna in OEIS A110036.
 A110036(n) = {
   subst(contfrac(1+sum(k=0, #binary(n+1), 1/'x^(2^k)))[n+1],
         'x,0);
 }

gp_inline__location="../dragon.tex:5908";
 \\ A088567 count non-squashing partitions.
 \\ This code per formula in A088567.
 A088567(n) = {
   n>=0 || error("A088567() is for n>=0, got ",n); \\ OFFSET=0
   my(m=n\2);
   if(n==0,1,
      n==1,1,
      n%2==0, A088567(2*m-1) + A088567(m) - 1,    \\ a(2*m)
              A088567(2*m) + 1);                  \\ a(2*m+1)
 }
 A088567=memoize(A088567);

gp_inline__location="../dragon.tex:5928";
 \\ A090678 definition  = 1-TurnRunSpred
 A090678(n) = {
   n>=0 || error("A090678() is for n>=0");
   A088567(n) % 2;
 }

gp_inline__location="../dragon.tex:6010";
 \\ A110037 = signs on top of A090678 0s and 1s
 A110037(n) = (-1)^floor(n/2) * A090678(n);

gp_inline__location="../dragon.tex:6018";
 \\ Return the turn at dragon curve point n>=1, +1=left, -1=right.
 turn(n) = {
   n>=1 || error("turn() is for n>=1, got ",n);
   1 - 2*bittest(n, valuation(n,2)+1);
 }

gp_inline__location="../dragon.tex:6024";
 turn_from_path_samples = [ 1,1,-1,1,1,-1,-1,1,1,1,-1,-1,1,-1,-1,1,1,1,-1,1,1,-1,-1,-1,1,1,-1,-1,1,-1,-1,1,1,1,-1,1,1,-1,-1,1,1,1,-1,-1,1,-1,-1,-1,1,1,-1,1,1,-1,-1,-1,1,1,-1,-1,1,-1,-1,1 ];

gp_inline__location="../dragon.tex:6083";
 turn_samples = [ 1,1, -1, 1,1, -1,-1, 1,1,1, -1,-1, 1, -1,-1, 1 ];

gp_inline__location="../dragon.tex:6089";
 A034947(n) = turn(n);  \\ OFFSET=1

gp_inline__location="../dragon.tex:6094";
 A088585(n) = A088567(2*n+1);

gp_inline__location="../dragon.tex:6104";
 A121238(n) = {
   n>=0 || error("A121238() is for n>=0");
   (-1)^(1 + n + A088585(n));
 }

gp_inline__location="../dragon.tex:6116";
 \\ A099545 turn sequence 1=left,3=right
 A099545(n) = OddPart(n) % 4;

gp_inline__location="../dragon.tex:6208";
 gturn_term(x,k) = x^(2^k) / (1 + x^(2^(k+1)));
 gturn(x,k_limit) = sum(k=0,k_limit, gturn_term(x,k));

gp_inline__location="../dragon.tex:6260";
 BitAboveLowestOne_samples = {[0,0,1,0,0,1,1,0,0,0,1,1]};

gp_inline__location="../dragon.tex:6272";
 A014707(n) = BitAboveLowestOne(n+1);

gp_inline__location="../dragon.tex:6293";
 next_turn(n) = if(BitAboveLowestZero(n), -1, 1);
 BitAboveLowestZero(n) = n+=1; bittest(n, valuation(n,2)+1);

gp_inline__location="../dragon.tex:6368";
 MaskAboveLowestOne(n) = 1 + bitxor(n,n-1);

gp_inline__location="../dragon.tex:6371";
 MaskAboveLowestOne_samples = {[2,4,2,8,2,4,2,16,2,4,2,8,2,4,2,32]};

gp_inline__location="../dragon.tex:6379";
 A171977(n) = MaskAboveLowestOne(n);

gp_inline__location="../dragon.tex:6403";
 A035263(n) = {
   n>=1 || error("A035263() is for n>=1");
   1 - valuation(n,2)%2;
 }

gp_inline__location="../dragon.tex:6528";
 TurnLpred(n) = {
   if(n>=1, 1-BitAboveLowestOne(n));
 }

gp_inline__location="../dragon.tex:6533";
 TurnLpred_samples = {[1,1,0,1,1,0,0,1,1,1,0,0,1,0,0]};

gp_inline__location="../dragon.tex:6541";
 \\ A014577 OFFSET=0 makes it "next left"
 A014577(n) = {
   n>=0 || error("A014577() is for n>=0");
   TurnLpred(n+1);
 }

gp_inline__location="../dragon.tex:6552";
 A082410(n) = TurnLpred(n-1);  /* PrevTurnLpred */

gp_inline__location="../dragon.tex:6561";
 TurnRpred(n) = {
   if(n>=1, BitAboveLowestOne(n));
 }

gp_inline__location="../dragon.tex:6571";
 A089013(n) = if(n==0,1,TurnRpred(n));

gp_inline__location="../dragon.tex:6577";
 n_odd_part(n) = while(n!=0 && n%2==0, n /= 2); n;

gp_inline__location="../dragon.tex:6602";
 TurnRpred_morphism4(n) = {
   my(above=if(n,BitAboveLowestOne(n)));
   2*above + bitxor(above,n%2);
 }

gp_inline__location="../dragon.tex:6625";
 KRSS_table = [1,2;4,3];
 KRSS(n) = {
   n>=1 || error("KRSS() is for n>=1");
   n--; KRSS_table[if(n,bittest(n,1+valuation(n,2)))+1, n%2+1];
 }
 A125047(n) = KRSS(n);

gp_inline__location="../dragon.tex:6699";
 A122002_morphism_table = { [[5,3], 0,    \\ 1
                             [7,3], 0,    \\ 3
                             [5,1], 0,    \\ 5
                             [7,1]] };    \\ 7
 A122002_vector(len) = {
   my(v=[5]);
   while(#v<len, v=concat(apply(a->A122002_morphism_table[a], v)));
   v[1..len];
 }

gp_inline__location="../dragon.tex:6716";
 Carpi_rest(n,m) = n % m;
 Carpi_a(n,p,m) = {
   m>=0 || error();
   if(n==0,return(p^(2*(m+1)) + 1));
   my(P=p^(m+1));
   if(n % P, return(Carpi_rest(n, p^(2*(m+1)))));
   while(n%P==0, n/=P);
   p^(2*(m+1)) + Carpi_rest(n, p^(2*(m+1)));
 }

gp_inline__location="../dragon.tex:6732";
 A122002_twobit_table = [5,7;1,3];
 A122002(n) = {
   A122002_twobit_table[n%2+1, bittest(n,1+if(n,valuation(n,2)))+1];
 }

gp_inline__location="../dragon.tex:6759";
 { my(table=[5,7;1,3]);
   table == A122002_twobit_table || error();
   A122002_compact(n) = table[n%2+1, bittest(n,1+if(n,valuation(n,2)))+1];
 }

gp_inline__location="../dragon.tex:6770";
 \\ Validate e as a member of the set A of lemma 3.2
 \\ (e is given the letter "n" there).
 Carpi_validate_elem(e, p,m) = {
   if(e % p^(m+1) == 0,
      error("element e=",e," is multiple of ",p^(m+1)));
   0 < e
      || error("element e=",e," too small");
   e < 2*p^(2*(m+1))
      || error("element e=",e," want < ",2*p^(2*(m+1)));
 }

gp_inline__location="../dragon.tex:6781";
 \\ h(n) at remark on page 237.
 \\ h: A* -> A*    A* = free monoid A* on letters alph(w)
 \\ n is a value 0 < n < 2*p^(2*(m+1))  p^(m+1) not divide n
 \\ eg. binary p=2,m=0  0 < n < 2*2^(2*1) = 8 and 2^1=2 not div n
 Carpi_h(n, p,m) = {
   Carpi_validate_elem(n, p,m);
   if(n<p^(2*(m+1)), apply(i->Carpi_a(i,p,m),
                           [p^(m+1)*n .. p^(m+1)*(n+1) - 1]),
                     concat(n,[1..p^(m+1)-1]));
 }

gp_inline__location="../dragon.tex:6808";
 A025480(n) = n >> (valuation(n+1,2)+1);

gp_inline__location="../dragon.tex:6830";
 A153733(n) = n >> valuation(n+1,2);

gp_inline__location="../dragon.tex:6846";
 A173732(n) = n=3*(2*n+1)+1; ((n >> valuation(n,2)) - 1)/2;

gp_inline__location="../dragon.tex:6862";
 A020988(n) = (2/3)*(4^n-1);

gp_inline__location="../dragon.tex:6872";
 A337580(k) = fromdigits(vector(2^k-1,n, TurnLpred(n)),2);

gp_inline__location="../dragon.tex:6888";
 \\ Martin Gardner, "Mathematical Games", Scientific American,
 \\ volume 216, number 4, April 1967, pages 116-123.
 \\
 Gardner_turns_binary_samples = {[
   0, \\ empty
   1,
   110,
   1101100,
   110110011100100,
   1101100111001001 110110001100100,
   1101100111001001 1101100011001001
   1101100111001000 110110001100100
 ]};

gp_inline__location="../dragon.tex:6904";
 bit_reversal(n) = fromdigits(Vecrev(binary(n)),2);
 A030101(n) = bit_reversal(n);

gp_inline__location="../dragon.tex:6947";
 Paper(n) = TurnLpred(n);

gp_inline__location="../dragon.tex:6965";
 PaperConst_to_n(limit) = sum(n=1,limit, Paper(n)/2^n);

gp_inline__location="../dragon.tex:6967";
 \\ Return a vector [lo,hi] which is an interval of the first n
 \\ bits of PaperConst.  The limit value is somewhere strictly
 \\    lo < actual < hi
 \\ Omitting bits 1/2^(n+1) + ... is at most all 1s = 1/2^n
 PaperConst_interval_to_n(n) = \
   my(p=PaperConst_to_n(n)); [p, p+1/2^n];

gp_inline__location="../dragon.tex:6978";
 PaperConst_binary_sample = {(110110011100100/1000000000000000)};

gp_inline__location="../dragon.tex:6982";
 PaperConst_binary_sample_vector = \
   digits(PaperConst_binary_sample*10^15);

gp_inline__location="../dragon.tex:6995";
 PaperConst_decimal = {(850736188/1000000000)};

gp_inline__location="../dragon.tex:7067";
 gTurnLpred_term(x,k) = x^(2^k)/(1 - x^(4*2^k));

gp_inline__location="../dragon.tex:7070";
 gTurnLpred_to_k(x,k_limit) = \
   sum(k=0,k_limit, gTurnLpred_term(x,k));

gp_inline__location="../dragon.tex:7078";
 gA014577_to_k(x,k_limit) = \
   sum(k=0,k_limit, x^(2^k-1)/(1 - x^(4*2^k)));

gp_inline__location="../dragon.tex:7097";
 gTurnLpred_next_pos(k) = 2^(k+1);

gp_inline__location="../dragon.tex:7105";
 gTurnLpred_to_k_check(k) = {
   my(pos=gTurnLpred_next_pos(k));

   \\ equal for n < pos
   gf_terms(gTurnLpred_to_k(x,k), pos) ==
     vector(pos,n,n--; TurnLpred(n))
   &&
   \\ different at n = pos
   gf_term(gTurnLpred_to_k(x,k), pos) != TurnLpred(pos);
 }

gp_inline__location="../dragon.tex:7157";
 gdirPaper_interval_to_n(n) = \
   interval_add_constant(2*PaperConst_interval_to_n(n), -1);

gp_inline__location="../dragon.tex:7240";
 gTurnRpred_term(x,k) = x^(3*2^k)/(1 - x^(4*2^k));
 gTurnRpred_to_k(x,k_limit) = \
   sum(k=0,k_limit, gTurnRpred_term(x,k));
 gTurnRpred(x) = gTurnRpred_to_k(x,9);
 gTurnRpred = memoize(gTurnRpred);

gp_inline__location="../dragon.tex:7267";
 gTurnRpred_next_pos(k) = 3*2^(k+1);

gp_inline__location="../dragon.tex:7270";
 gTurnRpred_to_k_check(k) = {
   my(pos=gTurnRpred_next_pos(k));

   \\ equal for n < pos
   gf_terms(gTurnRpred_to_k(x,k), pos) ==
   vector(pos,n,n--; BitAboveLowestOne_allow_zero(n))
   &&
   \\ different at n = pos
   gf_term(gTurnRpred_to_k(x,k),pos) != BitAboveLowestOne(pos);
 }

gp_inline__location="../dragon.tex:7514";
 BitAboveLowestOne_HtoL_state_table = {[0,1; 0,3; 2,1; 2,3]};
 BitAboveLowestOne_HtoL_state_to_result = {[0,0,1,1]};
 BitAboveLowestOne_LtoH_state_table = {[0,1; 2,3; 2,2; 3,3]};
 BitAboveLowestOne_LtoH_state_to_result = {[0,0,0,1]};
 BitAboveLowestOne_LtoH_S = 0;
 BitAboveLowestOne_LtoH_T = 1;
 BitAboveLowestOne_LtoH_r0 = 2;
 BitAboveLowestOne_LtoH_r1 = 3;

gp_inline__location="../dragon.tex:7524";
 BitAboveLowestOne_HtoL_transition(state,bit) = \
   BitAboveLowestOne_HtoL_state_table[state+1,bit+1];
 BitAboveLowestOne_HtoL_transitions(state,v) = {
   for(i=1,#v,  /* high to low */
       state=BitAboveLowestOne_HtoL_transition(state,v[i]));
   state;
 }
 BitAboveLowestOne_by_HtoL(n) = {
   n>=0 || error("BitAboveLowestOne_by_HtoL() is for n>=0");
   my(state=BitAboveLowestOne_HtoL_transitions(0,binary(n)));
   BitAboveLowestOne_HtoL_state_to_result[state+1];
 }

gp_inline__location="../dragon.tex:7539";
 BitAboveLowestOne_LtoH_transition(state,bit) = \
   BitAboveLowestOne_LtoH_state_table[state+1,bit+1];
 BitAboveLowestOne_LtoH_transitions(state,v) = {
   for(i=1,#v,
       state=BitAboveLowestOne_LtoH_transition(state,v[i]));
   state;
 }
 BitAboveLowestOne_by_LtoH(n) = {
   n>=0 || error("BitAboveLowestOne_by_LtoH() is for n>=0");
   my(state=BitAboveLowestOne_LtoH_transitions(0,
                                               Vecrev(binary(n))));
   BitAboveLowestOne_LtoH_state_to_result[state+1];
 }

gp_inline__location="../dragon.tex:7776";
 Carpi(n) = {
   if(n==0,   5,
      n%2==1, n%4,
              4 + (OddPart(n) % 4));
 }

gp_inline__location="../dragon.tex:7782";
 Carpi_samples = {[5,1,5,3,5,1,7,3,5,1,5,3,7,1,7,3]};

gp_inline__location="../dragon.tex:7804";
 OddPart_samples = {[1,1,3,1,5,3,7,1,9,5,11,3,13,7,15]};

gp_inline__location="../dragon.tex:7916";
 vector_find_square_subword(v) = {
   for(i=1,#v,
     for(len=1,(#v-i+1)\2,
       for(j=i,i+len-1,
         if(v[j]!=v[j+len],next(2)));
       return([i,len])));
   'none;
 }
 vector_is_square_free_word(v) = \
   vector_find_square_subword(v)=='none;

gp_inline__location="../dragon.tex:8016";
 Omega21_state_table = {[0,1;   \\ 0
                         2,1;   \\ 1
                         0,3;   \\ 2
                         2,3]}; \\ 3.
 Omega21_vector(k) = {
   my(v=[0]);
   for(i=1,k,
     v=concat(apply(x->Omega21_state_table[x+1,], v)));
   v;
 }

gp_inline__location="../dragon.tex:8034";
 Omega21(n) = {
   n>=1 || error("Omega21() is for n>=1");
   n--;
   my(s=0, v=binary(n));
   for(i=1,#v, s=Omega21_state_table[s+1,v[i]+1]);
   s;
 }

gp_inline__location="../dragon.tex:8043";
 \\ A112658_compact
 A112658(n) = 2*bittest(n,valuation(n,2)+1) + !(n%2);

gp_inline__location="../dragon.tex:8068";
 Omega21_to_from_BitAboveLowestOne_state = [1,0, 3,2];

gp_inline__location="../dragon.tex:8154";
 Pagoda_R(n) = if(n<0,1-A038189(-n), A038189(n));

gp_inline__location="../dragon.tex:8159";
 \\ A301849
 Pagoda_K(n) = Pagoda_R(n) - Pagoda_R(n-2);

gp_inline__location="../dragon.tex:8178";
 Pagoda_V(n) = 2*Pagoda_R(n) + (n%2);

gp_inline__location="../dragon.tex:8199";
 vector_subword_find(within,v) = {
   for(o=0,#within-#v,
     for(i=1,#v,
       if(within[i+o]!=v[i], next(2)));
     return(o+1));
    0;
 }

gp_inline__location="../dragon.tex:8213";
 Paper_subword_find(v) = {
   my(within=vector(8<<logint(#v+1,2),n, Paper(n)));
   vector_subword_find(within,v);
 }
 Paper_subword_complexity_by_search(len) = {
   my(within=vector(len<<8,n, Paper(n)),
      ret=0);
   forvec(v=vector(len,i,[0,1]),
     if(vector_subword_find(within,v),ret++));
   ret;
 }

gp_inline__location="../dragon.tex:8232";
 Paper_subword_complexity(len) = {
   if(len==0, 1,
      len==1, 2,
      len==2, 4,
      len==3, 8,
      len==4, 12,
      len==5, 18,
      len==6, 23,
      len>=7, 4*len,
      error());
 }

gp_inline__location="../dragon.tex:8278";
 vector_is_every_nth_alternating(v,n) = {
   for(start=1,n,
     forstep(i=start+n,#v,n,
       if(v[i]==v[i-n], next(2)));
     return(1));
   0;
 }
 \\ Would want tighter: that having found (prospective) odds
 \\ with every 2nd alternating, the evens in between are to be
 \\ every 4th alternating, etc.
 vector_is_every_Paper_alternating(v) = {
   my(n=2);
   while(n<=#v,
     vector_is_every_nth_alternating(v,n) || return(0);
     n*=2);
   1;
 }

gp_inline__location="../dragon.tex:8347";
 \\ A214613
 Paper_Abelian_complexity(n) = {
   my(ret=0);
   while(1,
     \\ print("at n="n" ret="ret);
     n>=1 || error();
     is_integer(n)||error();
     if(n==1, ret+=2;break,
        n%4==0,   n/=2,
        n%4==2,   n\=4; n=2*n+1; ret++,
        n%16==1,  n\=16; n=8*n+1,
        n%16==3||n%16==7||n%16==9||n%16==13,
                  n\=16; n=2*n+1; ret += 2,
        n%16==5,  n\=16; n=4*n+1; ret += 2,
        n%16==11, n\=16; n=4*n+3; ret += 2,
        n%16==15, n\=16; n=2*n+2; ret += 1,
        error("n=",n)));
   ret;
 }

gp_inline__location="../dragon.tex:8383";
 Abelian_by_search(v,n) = {
   my(m=Map(),s=vecsum(v[1..n]));
   mapput(m,s,1);
   for(i=1,#v-n,
       s = s - v[i] + v[i+n];
       \\ s==vecsum(v[i+1..i+n]) || error("i=",i);
       mapput(m,s,1));
   #m;
 }

gp_inline__location="../dragon.tex:8404";
 Abelian_pow(k) = (64^k-1)/21;

gp_inline__location="../dragon.tex:8417";
 \\ WRONG
 \\ goes in 3s but sometimes only by 2s
 Paper_Abelian_complexity_octal(n) = {
   my(ret=0);
   while(n,
     \\ print("at n="n" ret="ret);
     n>=1 || error();
     is_integer(n)||error();
     my(m=n%8);
     if(m==7, ret++; n++; n>>=valuation(n,2)+1,
        m==3 || m==1 || m==6, ret+=2; n>>=3,
        m==5 || m==2,         ret++; n>>=3,
        m==0 || m==4, ret+=2; n>>=valuation(n,2)+1,
        error("n=",n)));
   ret;
 }

gp_inline__location="../dragon.tex:8501";
 Arithmetical_complexity_by_search(v,n) = {
   my(m=Map(),s=vecsum(v[1..n]));
   for(start=1,#v,
     for(d=1,#v,
       my(end=start+(n-1)*d);
       if(end>#v,break);
       my(sub=vector(n,i,i--; v[start+d*i]));
       \\ print(sub);
       mapput(m,sub,1)));
   #m;
 }

gp_inline__location="../dragon.tex:8516";
 Paper_arithmetical_complexity_initial = \
   [1, 2,4,8,16, 24,32,44,52, 64, 76,86,96,106,116];
 Paper_arithmetical_complexity_formula(n) = 8*n + 4;
 Paper_arithmetical_complexity(n) = {
   n>=0 || error();
   if(n<14, Paper_arithmetical_complexity_initial[n+1],
            Paper_arithmetical_complexity_formula(n));
 }

gp_inline__location="../dragon.tex:8648";
 \\ func is a function to be called func(i) for i>=start param.
 \\ Consecutive same values from f are runs.
 \\ Return the lengths of the first len many runs.
 \\ There's no limit to runs sought, so be sure func() does in
 \\ fact have len many changes of value.
 function_run_lengths(func,len, start=1) = {
   my(ret=vector(len), upto=0,
      prev=func(start), runlen=1, i=start);
   while(upto<#ret,
         my(value=func(i++));
         if(value==prev,
            runlen++;
            ,
            ret[upto++]=runlen; runlen=1; prev=value));
   ret;
 }

gp_inline__location="../dragon.tex:8687";
 TurnRun(m) = {
   if(m==0, 2,
      m%2==1, 2 - 1/2* ( turn(m) + turn(m+1) ),
              2 + 1/2* ( turn(m) + turn(m+1) ));
 }

gp_inline__location="../dragon.tex:8697";
 TurnRun_samples = {[2,1,2,2,3,2,1,2,3,1,2,3,2,2]};

gp_inline__location="../dragon.tex:8705";
 A088431(n) = {
   n>=1 || error("A088431() is for n>=1");
   TurnRun(n-1);
 }

gp_inline__location="../dragon.tex:8748";
 gTurnRun_by_gturn(x,k) = -1/2 + 2/(1-x) + 1/2*(1-1/x)*gturn(-x,k);

gp_inline__location="../dragon.tex:8761";
 gTurnRun_term(x,k) = x^(3*2^k-1)/(1 - x^(4*2^k));
 gTurnRun(x,k_limit) = {
   -1 + 2/(1-x) + (1-x)/(1-x^4)
   + (1-x)*sum(k=1,k_limit, gTurnRun_term(x,k));
 }

gp_inline__location="../dragon.tex:8773";
 run_lengths_to_vector(runs,values) = {
   concat(vector(#runs,i,
                 vector(runs[i],j, vector_modulo(values,i-1))));
 }

gp_inline__location="../dragon.tex:8813";
 sturn(n) = turn(n) + turn(n+1);

gp_inline__location="../dragon.tex:8823";
 sturn_samples = {[2,0,0,2,0,-2,0,2,2,0,-2,0,0,-2,0,2]};

gp_inline__location="../dragon.tex:8851";
 SecondLowestBit(n) = bittest(n,1);

gp_inline__location="../dragon.tex:8863";
 sBitAboveLowest(n) = {
   if(n<1, error("sBitAboveLowest() is for n >= 1"));
   BitAboveLowestZero(n) + BitAboveLowestOne(n);
 }

gp_inline__location="../dragon.tex:8896";
 sBitAboveLowest_samples = {[0,1,1,0,1,2,1,0,0,1,2,1,1,2,1,0,0,1,1,0]};

gp_inline__location="../dragon.tex:8909";
 SecondLowestBit_samples = {[0,0,1,1,0,0,1,1]};

gp_inline__location="../dragon.tex:8930";
 gsBitAboveLowest_term(x,k) = x^(3*2^k-1)/(1 - x^(4*2^k));
 gsBitAboveLowest_to_k(x,k_limit) = \
   (1+x)*sum(k=0,k_limit, gsBitAboveLowest_term(x,k));
 gsBitAboveLowest(x) = gsBitAboveLowest_to_k(x,9);
 gsBitAboveLowest = memoize(gsBitAboveLowest);

gp_inline__location="../dragon.tex:9157";
 \\  ... [h] [!=l] [l..l] s l
 TurnRun_3bit_hsl(n) = {
   my(l=bittest(n,0),
      s=bittest(n,1));
   for(i=1,if(n,logint(n,2))+5,
     if(bittest(n,i)!=l,
       return(4*bittest(n,i+1) + 2*s + l)));
   error("TurnRun_3bit_hsl() bit != l not found");
 }

gp_inline__location="../dragon.tex:9177";
 TurnRun_3bit_table = {[3,1,2,2,2,2,1,3]};

gp_inline__location="../dragon.tex:9217";
 \\ Return three bits hsl from n = ... h 1 000 s l
 \\                                    ^       ^ ^
 \\ s and l are the two lowest bits.
 \\ h is the bit above the lowest 1 at or above s
 \\ Must have n>=2 so that there is such a lowest 1.
 \\ If s=1 then h is the third lowest bit n = ... h s=1 l.
 \\
 \\     h 1 000 0 1      n>>1 low 0s = 4
 \\             s l      h bit pos 6
 TurnRun_m1_3bit_hsl(n) = {
   n>=2 || error("TurnRun_m1_3bit_hsl() is for n>=2");
   4*bittest(n,valuation(n>>1,2)+2) + bitand(n,3);
 }

gp_inline__location="../dragon.tex:9247";
 TurnRun_m1_3bit_table = [2,3, 1,2, 3,2, 2,1];

gp_inline__location="../dragon.tex:9309";
 n_turn_is_RLR(n) = \
   n>=2 && turn(n-1)==-1 && turn(n)==1  && turn(n+1)==-1;
 n_turn_is_LRL(n) = \
   n>=2 && turn(n-1)==1  && turn(n)==-1 && turn(n+1)==1;

gp_inline__location="../dragon.tex:9359";
 \\ v is a vector.
 \\ Return the starting index of the first repeat block length len.
 \\ This is somewhere i with v[i..i+len-1] == v[i+len..i+2*len-1].
 \\ If no such then return 0.
 find_repeat_sequence(v,len) = {
   for(i=1,#v-2*len+1,
       for(j=0,len-1,
           if(v[i+j]!=v[i+j+len],next(2)));
       return(i));
   0;
 }

gp_inline__location="../dragon.tex:9379";
 \\ v is a vector.
 \\ Return the number of repeat blocks of length len.
 \\ This is how many places v[i..i+len-1] == v[i+len..i+2*len-1].
 repeat_sequence_count(v,len) = {
   my(count=0);
   for(i=1,#v-2*len+1,
       for(j=0,len-1,
           if(v[i+j]!=v[i+j+len],next(2)));
       count++);
   count;
 }

gp_inline__location="../dragon.tex:9554";
 KMcfrac(j) = {
   j>=0 || error("KMcfrac() is for j>=0");
   if(j==0, 0,
      j==1, 1,
      2*TurnRun(j-2));
 }

gp_inline__location="../dragon.tex:9569";
 KM_continued_fraction_sample = {[1,4,2,4,4,6,4,2,4,6,2,4,6,4,4,2,4]};
 /* incl integer term */  KM_continued_fraction_sample = \
     concat(0,KM_continued_fraction_sample);

gp_inline__location="../dragon.tex:9580";
 A007400(n) = {
   n>=0 || error("A007400() is for n>=0");
   if(n<=1, n,
      n==2, 4,
        my(m=n-1);
        4
        + (-1)^( !bittest(m,0)
                 + bittest(m, 2+valuation(m>>1,2)) )
        + (-1)^bittest(m,1)
      );
 }

gp_inline__location="../dragon.tex:9622";
 KM_sum(k) = sum(i=0,k,1/2^2^i);

gp_inline__location="../dragon.tex:9624";
 \\ Return KM vector of first n bits below the binary point.
 KM_vector(n) = vector(n,i,is_power_of_2(i));

gp_inline__location="../dragon.tex:9632";
 \\ Return KM fraction with n bits below the binary point.
 KM_sum_for_bits(n) = fromdigits(KM_vector(n),2)/2^n;

gp_inline__location="../dragon.tex:9644";
 KM_interval_for_bits(n) = my(x=KM_sum_for_bits(n)); [x,x+1/2^n];

gp_inline__location="../dragon.tex:9655";
 KM_decimal_sample = {(081642150/100000000)};

gp_inline__location="../dragon.tex:9665";
 KM_binary_sample = {(011010001/100000000)};

gp_inline__location="../dragon.tex:9702";
 \\ Fredholm-Rueppel sequence, OFFSET=0
 \\ a(n)=1 iff n = 2^m - 1.
 A036987(n) = {
   n>=0 || error("A036987() is for n>=0");
   is_power_of_2(n+1);
 }

gp_inline__location="../dragon.tex:9787";
 A007400_compact(n) = {
   if(n<=2, [0,1,4][n+1],    \\ by bitand for the 2
      n--;
      my(m=n>>1);
      n++;
      4 + (-1)^n*(bitand(2,n) - bitand(2,m>>valuation(m,2))));
 }

gp_inline__location="../dragon.tex:9816";
 gen_contfrac_SB = {[ [1;2], [2;3], [3;4], [4;5], [5;6], [9;11],
   [13;16], [22;27], [31;38], [40;49] ]};
 gen_contfrac_SB_big = 5555236091107620549720829925823504960456071805917983267095811/6804372532716615926416944213365261517125362029569465435290564;

gp_inline__location="../dragon.tex:9823";
 sbL = [1,0; 1,1];
 sbR = [1,1; 0,1];
 SB(v) = prod(i=1,#v, if(v[i],sbR,sbL)) * [1;1];

gp_inline__location="../dragon.tex:9960";
 \\ Shallit's B(u,v) vector, including initial 0
 Shallit_B(u,v) = {
   if(v==0, return([0,u]));
   if(v==1, return([0,u-1,u+1]));
   my(vec=Shallit_B(u,v-1),
      rev=Vecrev(vec[^1]));
   vec[#vec]++;
   rev[1]--;
   concat(vec,rev);
 }

gp_inline__location="../dragon.tex:10034";
 alfcon_state_table = {[ 1, 2;     \\ 1 start
                         3, 4;     \\ 2
                         3, 2;     \\ 3
                         5, 4;     \\ 4
                         5, 2 ]};  \\ 5
 alfcon_transition(state,bit) = alfcon_state_table[state,bit+1];
 alfcon_transitions(state,v) = {
   for(i=1,#v,  /* high to low */
       state=alfcon_transition(state,v[i]));
   state;
 }
 alfcon_initial_state = 1;
 alfcon_sign_vector = [1,1,-1,-1,1];
 alfcon(n,x) = {
   n>=0 || error("alfcon() is for n>=0, got ",n);
   if(n==0,return(1));
   x*alfcon_sign_vector[alfcon_transitions(alfcon_initial_state,
                                           binary(n))];
 }

gp_inline__location="../dragon.tex:10067";
 vector_replace(v,from,to,repl) = {
   concat([if(from<=1,[],v[1..from-1]),
           repl,
           if(to>=#v,[],v[to+1..#v])]);
 }
 contfrac_normalize_negatives(v) = {
   my(i=3);
   while(i<=#v,
         my(a=v[i-2],b=-v[i-1],c=v[i]);
         if(a-1>=0 && b-2>=0,
            v=vector_replace(v,i-2,i,[a-1,1,b-2,1,c-1]));
         i++);
   v;
 }

gp_inline__location="../dragon.tex:10088";
 contfrac_normalize_zeros(v) = {
   my(i=3);
   while(i<=#v,
         my(a=v[i-2],b=-v[i-1],c=v[i]);
         if(v[i-1]==0,
            v=vector_replace(v,i-2,i,[v[i-2]+v[i]]),
            i++));
   v;
 }

gp_inline__location="../dragon.tex:10134";
 TurnRunSpred(n) = if(n==1 || turn(n)!=turn(n-1), 1, 0);

gp_inline__location="../dragon.tex:10157";
 TurnRunSpred_samples = {[1,0,1,1,0,1,0,1,0,0,1,0,1,1,0,1]};

gp_inline__location="../dragon.tex:10271";
 TurnRunStart(m) = {
   m>=0 || error("TurnRunStart() is for m>=0");
   if(m>=1&&turn(m)==(-1)^m, 2*m, 2*m+1);
 }

gp_inline__location="../dragon.tex:10308";
 TurnRunStart_samples = {[1,3,4,6,8,11,13,14,16,19,20,22,25]};

gp_inline__location="../dragon.tex:10336";
 TurnLeft_by_pred(m) = {
   m>=0 || error("TurnLeft_by_pred() is for m>=0, got m=",m);
   my(n=0); while(m>=0, n++;m-=TurnLpred(n)); n;
 }
 TurnRight_by_pred(m) = {
   m>=0 || error("TurnRight_by_pred() is for m>=0, got m=",m);
   my(n=0); while(m>=0, n++;m-=TurnRpred(n)); n;
 }

gp_inline__location="../dragon.tex:10349";
 TurnLeft_k_e(m) = {
   m>=1 || error("TurnLeft_k_e() is for m>=1, got m=",m);
   my(k=0,e);
   while(1, e=m-2^k; if(0<=e&&e<2^k,break()); k++);
   [k,e];
 }
 TurnRight_k_e(m) = {
   m>=0 || error("TurnRight_k_e() is for m>=0, got m=",m);
   my(k=0,e);
   while(1, e=m-(2^k-1); if(0<=e&&e<2^k,break()); k++);
   [k,e];
 }

gp_inline__location="../dragon.tex:10386";
 TurnLeft(m) = {
   m>=0 || error("TurnLeft() is for m>=0, got m=",m);
   if(m==0,return(1));
   my(k=logint(m,2));
   (2^k <= m && m < 2^(k+1)) || error();
   if(m == 2^k, 2^(k+1),
                2^(k+2) - TurnRight(2^(k+1) - 1 - m));
 }

gp_inline__location="../dragon.tex:10412";
 TurnLeft_samples = {[1,2,4,5,8,9,10,13,16,17,18,20]};

gp_inline__location="../dragon.tex:10421";
 A091072(n) = {
   n>=1 || error("A091072() is for n>=1");
   TurnLeft(n-1);
 }

gp_inline__location="../dragon.tex:10442";
 TurnRight(m) = {
   m>=0 || error("TurnRight() is for m>=0, got m=",m);
   my(k=logint(m+1,2));
   (2^k-1 <= m && m < 2^(k+1)-1) || error();
   2^(k+2) - TurnLeft(2^(k+1)-2 - m);
 }

gp_inline__location="../dragon.tex:10469";
 TurnRight_samples = {[3,6,7,11,12,14,15,19,22,23,24,27]};

gp_inline__location="../dragon.tex:10478";
 A091067(n) = {
   n>=1 || error("A091067() is for n>=1");
   TurnRight(n-1);
 }

gp_inline__location="../dragon.tex:10581";
 A255068(n) = TurnRight(n) - 1;

gp_inline__location="../dragon.tex:10586";
 TurnLeft_minus_1_samples = {[0,1,3,4,7,8,9,12]};

gp_inline__location="../dragon.tex:10605";
 TurnRight_minus_1_samples = {[2,5,6,10,11,13,14,18]};

gp_inline__location="../dragon.tex:10621";
 TurnLeft_plus_1_samples = {[2,3,5,6,9,10,11,14]};

gp_inline__location="../dragon.tex:10638";
 TurnRight_plus_1_samples = {[4,7,8,12,13,15,16,20]};

gp_inline__location="../dragon.tex:10648";
 A060833(n) = {
   n>=1 || error("A060833() is for n>=1");
   if(n==1, 1, TurnRight(n-2)+1);
 }

gp_inline__location="../dragon.tex:10716";
 TurnLeft_by_procedure(m) = {
   my(debug=0);
   my(n=2*m,t=1);
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     if(debug, print("  at n=",to_binary(n)," pos="pos" t="t));
     if(bittest(n,pos)==t,
        if(debug, print("    decrement"));
        n--; t=1-t;
     ));
   n+1;
 }

gp_inline__location="../dragon.tex:10758";
 TurnRight_by_procedure(m) = {
   my(n=2*m+2, t=1);
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     if(bittest(n,pos)==t,
        n++; t=1-t;
     ));
   n;
 }

gp_inline__location="../dragon.tex:10793";
 TurnLeft_by_TurnLeftRev(m) = {
   m>=0 || error("TurnLeft_by_TurnLeftRev() is for m>=0, got m=",m);
   if(m==0,return(1));
   my(k=max(0,logint(m,2)+1));
   (2^(k-1) <= m && m < 2^k) || error("oops, m range");
   if(m == 2^(k-1), 2^k,
                    2^k + TurnLeftRev(k, m - 2^(k-1) - 1));
 }

gp_inline__location="../dragon.tex:10813";
 TurnLeftRev_vector(k) = \
   select(n->turn(n+2^k)==1, [1 .. 2^k-1]);

gp_inline__location="../dragon.tex:10826";
 TurnLeftRev(k,m) = {
   k>=2 || error("TurnLeftRev() is for k>=1");
   m>=0 || error("TurnLeftRev() is for m>=0");
   m < 2^(k-1) - 1 || error("TurnLeftRev() m=",m," too big for k=",k);
   TurnLeft(2^(k-1)+1 + m) - 2^k;
 }

gp_inline__location="../dragon.tex:10959";
 TurnLeft2(p) = {
   \\ print("TurnLeft2 p="p);
   p>=0 || error("TurnLeft2() is for p>=0, got p=",p);
   p%2==0 || error("TurnLeft2() is for p even p=",p);
   if(p==0,return(1));
   my(k=logint(p,2));
   (2^k <= p && p < 2^(k+1)) || error();
   if(p==2^k, 2^k,
              \\ print("  to TurnLeftRev2 k="k" "p - 2^k - 2);
              2^k + TurnLeftRev2(k, p - 2^k - 1));
 }

gp_inline__location="../dragon.tex:10990";
 TurnLeftRev2(k,p) = {
   k>=1 || error("TurnLeftRev2() is for k>=1");
   p>=1 || error("TurnLeftRev2() is for p>=0, got p=",p);
   p<=2^k-3 || error("TurnLeftRev2() is for p<=2^k-2, got k=",k," p=",p);
   p%2==1 || error("TurnLeftRev2() is for p odd, got p=",p);
   if(p<2^(k-1), TurnLeft2(p - 1),
                 2^(k-1) + TurnLeftRev2(k-1, p - 2^(k-1)));
 }

gp_inline__location="../dragon.tex:11012";
 TurnLeft2_by_TurnRight2(p) = {
   p>=0 || error("TurnLeft2_by_TurnRight2() is for p>=0, got p=",p);
   p%2==0 || error("TurnLeft2_by_TurnRight2() is for p even p=",p);
   if(p==0,return(1));
   my(k=logint(p,2));
   (2^k <= p && p < 2^(k+1)) || error();
   if(p==2^k, 2^k,
              2^(k+1) - TurnRight2(2^(k+1)-1 - p + 1));
 }

gp_inline__location="../dragon.tex:11118";
 TurnRightRev_vector(k) = \
   select(n->turn(n+2^k)==-1, [1 .. 2^k-1]);

gp_inline__location="../dragon.tex:11129";
 TurnRightRev(k,m) = {
   k>=1 || error("TurnRightRev() is for k>=1");
   m>=0 || error("TurnRightRev() is for m>=0");
   m < 2^(k-1) || error("TurnRightRev() m too big");
   TurnRight(2^(k-1)-1 + m) - 2^k;
 }

gp_inline__location="../dragon.tex:11243";
 TurnRight2(p) = {
   p>=2 || error("TurnRight2() is for p>=2, got p=",p);
   p%2==0 || error("TurnRight2() is for p even, got p=",p);
   return(TurnRight((p-2)/2));
   my(k=logint(p,2));
   (2^k <= p && p < 2^(k+1)) || error();
   2^k + TurnRightRev2(k, p - 2^k + 1);
 }

gp_inline__location="../dragon.tex:11273";
 TurnRightRev2(k,p) = {
   k>=1 || error("TurnRightRev2() is for k>=1");
   p>=1 || error("TurnRightRev2() is for p>=0, got p=",p);
   p<=2^k || error("TurnRightRev2() p too big");
   p%2==1 || error("TurnRightRev2() is for p odd, got p=",p);
   if(p  < 2^(k-1)-1, TurnRight2(p + 1),
      p == 2^(k-1)-1, 2^(k-1),
                      2^(k-1) + TurnRightRev2(k-1, p - 2^(k-1)));
 }

gp_inline__location="../dragon.tex:11323";
 TurnLeft_by_bit_pairs(m) = {
   my(n=2*m);
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     if(bittest(n,pos+1)!=bittest(n,pos),
        n--;
        if(bittest(n,pos+1)==bittest(n,pos), break)));
   n+1;
 }

gp_inline__location="../dragon.tex:11334";
 TurnRight_by_bit_pairs(m) = {
   my(n=2*m+2);
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     \\ print("at n="to_binary(n));
     if(bittest(n,pos+1)!=bittest(n,pos),
        n++;
        if(bittest(n,pos+1)==bittest(n,pos),
           \\ print("stop at pos="pos);
           break)));
   n;
 }

gp_inline__location="../dragon.tex:11406";
 TurnLeftOff(m) = 2*m - TurnLeft(m);

gp_inline__location="../dragon.tex:11408";
 TurnLeftOff_samples = {[-1,0,0,1,0,1,2,1,0,1,2,2,3,1,2,1,0]};

gp_inline__location="../dragon.tex:11424";
 TurnRightOff(m) = TurnRight(m) - 2*m;

gp_inline__location="../dragon.tex:11426";
 TurnRightOff_samples = {[3,4,3,5,4,4,3,5,6,5,4,5,4,4,3,5,6]};

gp_inline__location="../dragon.tex:11458";
 TurnLeftOff_by_recurrence(m) = {
   if(m==0,return(-1));
   my(k,e);[k,e]=TurnLeft_k_e(m);
   if(e==0,0,
      TurnRightOff(2^k-1 - e) - 2);
 }

gp_inline__location="../dragon.tex:11472";
 TurnRightOff_by_recurrence(m) = {
   my(k,e);[k,e]=TurnRight_k_e(m);
   TurnLeftOff(2^k-1 - e) + 4;
 }

gp_inline__location="../dragon.tex:11489";
 high_run_k_l_e(m) = {
   my(k=high_bit_k(m),l=k,e=m);
   while(l>=0 && bittest(m,l),
         e-=2^l;
         l--);    \\ print(k," ",l,"  ",to_binary(e));
   k++; l++;
   [k,l,e];
 }

gp_inline__location="../dragon.tex:11576";
 TurnLeftOff_by_high_run(m) = {
   if(m==0,return(-1));
   my(k,l,e); [k,l,e]=high_run_k_l_e(m);
   if(e==0 && k==l+1, return(0));      \\ 100000  or 1
   if(e==0 && l==0,   return(1));      \\ 111111
   if(e==0 && l==1,   return(2));      \\ 111110
   if(e==0,           return(3));      \\ 111000
   TurnLeftOff(e-1) + 2;
 }

gp_inline__location="../dragon.tex:11600";
 TurnRightOff_by_high_run(m) = {
   my(k,l,e); [k,l,e]=high_run_k_l_e(m+1);
   if(l==0,         return(3));     \\ 1111111
   if(e==2^(l-1)-1, return(4));     \\ 1110111
   TurnRightOff(e) + 2;
 }

gp_inline__location="../dragon.tex:11627";
 TurnLeftOff_by_high_runP(m) = {
   if(m==0,return(-1));
   \\ if(m==1,return(0));
   \\ if(m==2,return(0));
   my(k,l,e); [k,l,e]=high_run_k_l_e(m);
   if(m==2^(k+1)-2 && k>=2, return(2));      \\ 111110
   if(m==2^(k+1)-1 && k>=1, return(1));      \\ 111111
   if(m==2^k,               return(0));      \\ 100000  or 1
   if(m==2^(k+1)-2^l,       return(3));      \\ 111000
   TurnLeftOff(e-1) + 2;
 }

gp_inline__location="../dragon.tex:11641";
 TurnLeftOff_by_high_run2(m) = {
   if(m==0,return(-1));
   \\ if(m==1,return(0));
   \\ if(m==2,return(0));
   my(k,l,e); [k,l,e]=high_run_k_l_e(m+1);
   if(e==1, return(0));      \\ 100000  or 1
   if(e==2, return(1));      \\ 100000  or 1
   if(e==0 && k==l+1, return(1));      \\ 100000  or 1
   if(e==0 && l==0,   return(2));      \\ 111111
   if(e==0 && l==1,   return(1));      \\ 111110
   if(e==0 && l==2,   return(1));      \\ 111110
   if(e==0 && l>=3,   return(4));      \\ 111110
   if(e==2^(l-1)-1,   return(3));      \\ 111000
   if(e==2^(l-1)-1,   return(3));      \\ 111000
   TurnLeftOff(e) + 2;
 }

gp_inline__location="../dragon.tex:11682";
 TurnRightOff_by_high_run2(m) = {
   if(m==0,return(3));
   if(m==1,return(4));
   my(k,l,e); [k,l,e]=high_run_k_l_e(m);
   if(l==0,         return(5));     \\ 1111111
   if(l==1,         return(3));     \\ 1111110
   if(l==2,         return(4));     \\ 1111100
   if(e==0,         return(6));     \\ 1110000
   if(e==2^(l-1)-2, return(4));     \\ 1110110
   if(e==2^(l-1)-1, return(5));     \\ 1110111
   TurnRightOff(e+1) + 2;
 }

gp_inline__location="../dragon.tex:11709";
 dTurnLeft(m) = TurnLeft(m+1) - TurnLeft(m);

gp_inline__location="../dragon.tex:11711";
 dTurnLeft_samples = {[1,2,1,3,1,1,3,3,1,1,2,1,4,1,3,3,1]};

gp_inline__location="../dragon.tex:11725";
 dTurnRight(m) = TurnRight(m+1) - TurnRight(m);

gp_inline__location="../dragon.tex:11727";
 dTurnRight_samples = {[3,1,4,1,2,1,4,3,1,1,3,1,2,1,4,3,1]};

gp_inline__location="../dragon.tex:11852";
 dTurnLeft_vector_by_turns_map(n) = {
   n+=(n%2); \\ to even
   my(v=vector(n,i,turn(i)));
   forstep(i=1,#v-1,2,
     if(v[i]== 1 && v[i+1]== 1, v[i]=[1,2,1],
        v[i]== 1 && v[i+1]==-1, v[i]=[1,3],
        v[i]==-1 && v[i+1]== 1, v[i]=[3,1],
        v[i]==-1 && v[i+1]==-1, v[i]=[4],
        error());
     v[i+1]=[]);
   concat(v);
 }

gp_inline__location="../dragon.tex:11879";
 turn_pairs_expand_map = {Map([ 'LL, ['LL, 'RL];
                                'LR, ['LL, 'RR];
                                'RL, ['LR, 'RL];
                                'RR, ['LR, 'RR] ])};
 turn_pair_to_pn_map = {Map([ 'LL, [1,1];
                              'LR, [1,-1];
                              'RL, [-1,1];
                              'RR, [-1,-1] ])};
 turn_pairs_by_expand(k) = {
   my(v=['LL]);
   for(i=1,k,
     v = concat(apply(p->mapget(turn_pairs_expand_map,p), v)));
   v;
 }

gp_inline__location="../dragon.tex:11910";
 dTurnLeft_vector_expand(v) = {
   my(l=List([]));
   for(i=1,#v,
     if(v[i]==1, if(v[i+1]==2, v[i+2]==1 || error();
                               listput(l,[1,2,1,3,1]); i+=2,
                    v[i+1]==3, listput(l,[1,2,1,4]); i++,
                    error()),
        v[i]==3, v[i+1]==1 || error();
                 listput(l,[1,3,3,1]); i++,
        v[i]==4, listput(l,[1,3,4]),
        error()));
   concat(Vec(l));
 }

gp_inline__location="../dragon.tex:11955";
 turn_pair_as_bits(m) = {
   my(n = 2*m+1);
   2*TurnRpred(n) + TurnRpred(n+1);
 }

gp_inline__location="../dragon.tex:11965";
 dturn_pair_as_bits(m) = \
   bitxor(turn_pair_as_bits(m), turn_pair_as_bits(m+1) );

gp_inline__location="../dragon.tex:12000";
 dTurnLeft_by_recurrence(m) = {
   if(m==0,return(1));
   if(m==1,return(2));
   my(k,e);[k,e]=TurnLeft_k_e(m);
   if(e==0,     1,
      e==2^k-1, 3,
      dTurnRight(2^k-2 - e));
 }

gp_inline__location="../dragon.tex:12023";
 dTurnRight_by_recurrence(m) = {
   if(m==0,return(3));
   my(k,e);[k,e]=TurnRight_k_e(m);
   if(e==2^k-1, 4,
      dTurnLeft(2^k-2 - e));
 }

gp_inline__location="../dragon.tex:12050";
 dNextL(n) = {
   for(d=1,4, if(TurnLpred(n+d),return(d)));
   error();
 }
 dNextR(n) = {
   for(d=1,4, if(TurnRpred(n+d),return(d)));
   error();
 }

gp_inline__location="../dragon.tex:12102";
 dNextL_is_1_by_bits(n) = {
   my(i=0);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==0, i+2, 0);
 }

gp_inline__location="../dragon.tex:12113";
 dNextL_is_2a_by_bits(n) = {
   if(n%4!=2, return(0));
   my(i=2);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==0, i+2, 0);
 }

gp_inline__location="../dragon.tex:12124";
 dNextL_is_2b_by_bits(n) = {
   if(n%4!=3, return(0));
   my(i=2);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==1, i+2, 0);
 }

gp_inline__location="../dragon.tex:12134";
 dNextL_is_3a_by_bits(n) = {
   if(n%8!=5, return(0));
   my(i=3);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==0, i+2, 0);
 }

gp_inline__location="../dragon.tex:12144";
 dNextL_is_3b_by_bits(n) = {
   if(n%4!=2, return(0));
   my(i=2);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==1, i+2, 0);
 }

gp_inline__location="../dragon.tex:12154";
 dNextL_is_4_by_bits(n) = {
   if(n%8!=5, return(0));
   my(i=3);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==1, i+2, 0);
 }

gp_inline__location="../dragon.tex:12164";
 dNextL_by_bits_funcs = {[ dNextL_is_1_by_bits,
                           dNextL_is_2a_by_bits,
                           dNextL_is_2b_by_bits,
                           dNextL_is_3a_by_bits,
                           dNextL_is_3b_by_bits,
                           dNextL_is_4_by_bits ]};
 dNextL_by_bits_funcs_d = [1,2,2,3,3,4];

gp_inline__location="../dragon.tex:12175";
 dNextL_and_length(n) = {
   for(i=1,#dNextL_by_bits_funcs,
     my(len=dNextL_by_bits_funcs[i](n));
     if(len,return([dNextL_by_bits_funcs_d[i], len])));
   error("oops");
 }

gp_inline__location="../dragon.tex:12225";
 dNextR_is_1_by_bits(n) = {
   my(i=0);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==1, i+2, 0);
 }

gp_inline__location="../dragon.tex:12234";
 dNextR_is_2_by_bits(n) = if(n%8==1 || n%8==4, 3, 0);

gp_inline__location="../dragon.tex:12240";
 dNextR_is_3_by_bits(n) = if(n%8==0, 3, n%16==3, 4, 0);

gp_inline__location="../dragon.tex:12246";
 dNextR_is_4_by_bits(n) = {
   if(n%8!=7, return(0));
   my(i=3);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==0, i+2, 0);
 }

gp_inline__location="../dragon.tex:12255";
 dNextR_by_bits_funcs = {[ dNextR_is_1_by_bits,
                           dNextR_is_2_by_bits,
                           dNextR_is_3_by_bits,
                           dNextR_is_4_by_bits ]};

gp_inline__location="../dragon.tex:12263";
 dNextR_and_length(n) = {
   for(i=1,#dNextR_by_bits_funcs,
     my(len=dNextR_by_bits_funcs[i](n));
     if(len,return([i,len])));
   error("oops");
 }

gp_inline__location="../dragon.tex:12274";
 dNextL_samples = {[1,1,2,1,1,3,2,1,1,1,3,2,1,3,2,1]};

gp_inline__location="../dragon.tex:12287";
 dNextR_samples = {[3,2,1,3,2,1,1,4,3,2,1,1,2,1,1,4]};

gp_inline__location="../dragon.tex:12409";
 dTurnLeft_d1a = 1;
 dTurnLeft_d1b = 2;
 dTurnLeft_d1c = 3;
 dTurnLeft_d2 = 4;
 dTurnLeft_d3a = 5;
 dTurnLeft_d3b = 6;
 dTurnLeft_d4 = 7;
 dTurnLeft_s1 = 8;
 dTurnLeft_s2 = 9;
 dTurnLeft_s3 = 10;
 dTurnLeft_s4 = 11;
 dTurnLeft_state_table = {[  1, 8;     \\  1 d1a
                             9, 2;     \\  2 d1b
                            11, 3;     \\  3 d1c
                             9, 2;     \\  4 d2
                             1, 8;     \\  5 d3a
                            11, 3;     \\  6 d3b
                             1, 8;     \\  7 d4
                             9, 4;     \\  8 s1
                             5,10;     \\  9 s2
                            11, 6;     \\ 10 s3
                             7,10 ]};  \\ 11 s4
 dTurnLeft_state_to_d = {[1,1,1,2,3,3,4,'none,'none,'none,'none]};
 dTurnLeft_state_to_decr = {[0,0,0,0,0,0,0,1,1,1,1]};
 dTurnLeft_is_final = {[1,1,1,1,1,1,1,0,0,0,0]};

gp_inline__location="../dragon.tex:12435";
 dTurnRight_d3a = 1;
 dTurnRight_d3b = 2;
 dTurnRight_d4 = 3;
 dTurnRight_d1a = 4;
 dTurnRight_d1b = 5;
 dTurnRight_d2 = 6;
 dTurnRight_s1 = 7;
 dTurnRight_s2 = 8;
 dTurnRight_s3 = 9;
 dTurnRight_state_table = {[ 1,7;     \\ 1 d3a
                             8,3;     \\ 2 d3b
                             8,3;     \\ 3 d4
                             6,7;     \\ 4 d1a
                             8,5;     \\ 5 d1b
                             1,7;     \\ 6 d2
                             8,2;     \\ 7 s1
                             4,9;     \\ 8 s2
                             8,5 ]};  \\ 9 s3
 dTurnRight_state_to_d = {[3,3,4,1,1,2,'none,'none,'none]};
 dTurnRight_state_to_incr = {[0,0,0,0,0,0,1,1,1]};
 dTurnRight_is_final = {[1,1,1,1,1,1,0,0,0]};

gp_inline__location="../dragon.tex:12458";
 dTurnLeft_transition(state,bit) = \
   dTurnLeft_state_table[state,bit+1];
 dTurnLeft_state_of_vec(v) = {
   my(state=dTurnLeft_d1a);
   for(i=1,#v, state=dTurnLeft_transition(state,v[i]));
   state;
 }
 dTurnLeft_of_nseen(nseen) = \
   dTurnLeft_state_to_d[dTurnLeft_state_of_vec(binary(nseen))];

gp_inline__location="../dragon.tex:12468";
 dTurnLeft_state_to_t = {[1,    \\  1 d1a start
                          0,    \\  2 d1b
                          0,    \\  3 d1c
                          0,    \\  4 d2
                          1,    \\  5 d3a
                          0,    \\  6 d3b
                          1,    \\  7 d4
                          0,    \\  8 s1
                          1,    \\  9 s2
                          0,    \\ 10 s3
                          1]};  \\ 11 s4

gp_inline__location="../dragon.tex:12481";
 \\ Change any low 0-bits of n to 1-bits.
 low_0s_to_1s(n) = n + 2^valuation(n,2)-1;

gp_inline__location="../dragon.tex:12487";
 dTurnLeft_n_to_nseen(n) = if(n%2==1, n-1, low_0s_to_1s(n));

gp_inline__location="../dragon.tex:12523";
 dTurnLeft_by_procedure(m) = {
   my(n=2*m, state=1, t=1, nseen=List([]));
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     t == dTurnLeft_state_to_t[state] || error();
     my(bit=bittest(n,pos));
     listput(nseen,bit);
     state=dTurnLeft_transition(state,bit);
     my(decr = (state>=dTurnLeft_s1));
     decr= == (bittest(n,pos)==t) || error("decr");
     if(decr, n--; t=1-t);
   );
   my(want_n=TurnLeft(m));
   n++;
   n == want_n || error();
   fromdigits(Vec(nseen),2) == dTurnLeft_n_to_nseen(n) || error();
   dTurnLeft_state_to_d[state];
 }

gp_inline__location="../dragon.tex:12552";
 \\ here "n" starts as index m and is then the working n
 { my(table=[1,8;9,2;11,3;9,2;1,8;11,3;1,8;9,4;5,10;11,6;7,10]);
   table==dTurnLeft_state_table || error();
   dTurnLeft_compact(n) = my(state=1); n*=2;
     forstep(pos=if(n,logint(n,2)),0,-1,
       state=table[state,bittest(n,pos)+1]; if(state>=8,n--));
     [1,1,1,2,3,3,4][state]; }

gp_inline__location="../dragon.tex:12595";
 \\ s1..s4 are not final states

gp_inline__location="../dragon.tex:12952";
 \\ If n is even then change its lowest 1-bit to a 0-bit.
 \\ Otherwise n is unchanged.
 dTurnRight_n_to_nseen(n) = \
   if(n!=0 && n%2==0, n-2^valuation(n,2), n);

gp_inline__location="../dragon.tex:12962";
 dTurnRight_transition(state,bit) = \
   dTurnRight_state_table[state,bit+1];
 dTurnRight_state_of_vec(v) = {
   my(state=1);
   for(i=1,#v, state=dTurnRight_transition(state,v[i]));
   state;
 }
 dTurnRight_of_nseen(nseen) = {
   my(v=binary(nseen),
      state=dTurnRight_state_of_vec(v));
   dTurnRight_state_to_d[state];
 }

gp_inline__location="../dragon.tex:12979";
 dTurnRight_state_to_t = {[1,    \\ 1 d3a
                           0,    \\ 2 d3b
                           0,    \\ 3 d4
                           1,    \\ 5 d1a
                           0,    \\ 6 d1b
                           1,    \\ 4 d2
                           0,    \\ 7 s1
                           1,    \\ 8 s2
                           0]};  \\ 9 s3

gp_inline__location="../dragon.tex:13035";
 dTurnRight_by_procedure(m) = {
   my(debug=0);
   my(n=2*m+2, state=1, t=1, nseen=List([]));
   if(debug,
      print("dTurnRight_by_procedure() m="m" n="n));
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     if(debug,
        print("  at pos="pos" n="to_binary(n)" state="state" t="t));
     t == dTurnRight_state_to_t[state] || error();
     my(bit=bittest(n,pos));
     listput(nseen,bit);
     state=dTurnRight_transition(state,bit);
     my(incr = (state>=dTurnRight_s1));
     incr= == (bittest(n,pos)==t) || error("incr");
     if(incr, n++; t=1-t);
   );
   if(debug,print("  final n="n" "to_binary(n)" state="state));
   my(want_n=TurnRight(m));
   n == want_n || error();
   fromdigits(Vec(nseen),2) == dTurnRight_n_to_nseen(n) || error();
   dTurnRight_state_to_d[state];
 }

gp_inline__location="../dragon.tex:13087";
 \\ here "n" starts as index m and is then the working n
 { my(table=[1,7; 8,3; 8,3; 6,7; 8,5; 1,7; 8,2; 4,9; 8,5]);
   table==dTurnRight_state_table || error();
   dTurnRight_compact(n) = my(state=1); n=2*n+2;
     forstep(pos=if(n,logint(n,2)),0,-1,
       state=table[state,bittest(n,pos)+1]; if(state>=7,n++));
     [3,3,4,1,1,2][state]; }

gp_inline__location="../dragon.tex:13119";
 \\ s1,s3 are not final states

gp_inline__location="../dragon.tex:13337";
 dTurnRight_is_1rep_by_bits(n) = {
   n%4==3 || return(0);
   my(i=2);
   while(bittest(n,i)==1, i++);
   if(bittest(n,i+1)==1, i+2, 0);
 }

gp_inline__location="../dragon.tex:13376";
 dTurnRight_is_3rep_by_bits(n) = {
   n%8==0 || return(0);
   my(i=3);
   while(bittest(n,i)==0, i++);
   if(bittest(n,i+1)==1, i+2, 0);
 }

gp_inline__location="../dragon.tex:13444";
 Count1010(n) = sum(k=0,if(n,logint(n,2)), (n>>k)%16==10);

gp_inline__location="../dragon.tex:13457";
 \\ A122045
 Euler_number(n) = polcoeff(lift(1/cosh(x + O(x^(n+1)))), n) * n!;

gp_inline__location="../dragon.tex:13548";
 CountBitTransitions(n) = {
   n>=0 || error("CountBitTransitions() is for n>=0");
   my(v=concat(0,binary(n)));  \\ with high zeros
   sum(i=1,#v-1, v[i]!=v[i+1]);
 }

gp_inline__location="../dragon.tex:13559";
 dir(n) = CountOneBits(Gray(n));

gp_inline__location="../dragon.tex:13561";
 \\ v is a vector of bits of n high to low.  Return dir(n).
 dir_of_bits(v) = vecsum(Gray_of_bits(v));

gp_inline__location="../dragon.tex:13567";
 dir_samples = {[0,1,2,1,2,3,2,1,2,3,4,3,2,3,2,1,2,3,4,3]};

gp_inline__location="../dragon.tex:13577";
 A005811(n) = dir(n);

gp_inline__location="../dragon.tex:13589";
 \\ Gray code = A003188
 Gray(n) = bitxor(n, floor(n/2));

gp_inline__location="../dragon.tex:13594";
 \\ v is a vector of bits of n high to low.  Return Gray(n).
 Gray_of_bits(v) = vector(#v,i, bitxor(if(i>1,v[i-1]), v[i]));

gp_inline__location="../dragon.tex:13604";
 Gray_samples = {[0,1,3,2,6,7,5,4,12,13,15,14,10,11]};

gp_inline__location="../dragon.tex:13612";
 A003188(n) = Gray(n);

gp_inline__location="../dragon.tex:13618";
 CountOneBits_samples = {[0,1,1,2,1,2,2,3,1,2,2,3,2,3]};

gp_inline__location="../dragon.tex:13635";
 \\ A079944 = second highest bit, except for offset
 A079944(n) = n+=2; bittest(n, logint(n,2)-1);

gp_inline__location="../dragon.tex:13640";
 second_highest_bit(n) = if(n<2, 0, bittest(n, logint(n,2)-1));

gp_inline__location="../dragon.tex:13650";
 A037834(n) = \
   sum(i=1,if(n,logint(n,2)), bittest(n,i)!=bittest(n,i-1));

gp_inline__location="../dragon.tex:13660";
 A088748(n) = dir(n) + 1;

gp_inline__location="../dragon.tex:13679";
 A088696(n) = {
   n>=1 || error();
   dir(sans_high_bit(n)) + 1;
 }

gp_inline__location="../dragon.tex:13730";
 \\ collapse bit runs
 \\ 0, 1, 2, 1, 2, 5, 2, 1, 2, 5, 10, 5
 A090079(n) = (2 << hammingweight(bitxor(n,n>>1))) \ 3;

gp_inline__location="../dragon.tex:13742";
 Gray_new_highs_vector(len) = {
   my(m=-1,n=0,l=List([]));
   while(#l<len,
     my(g=Gray(n));
     if(g>m, m=g;listput(l,g));
     n++);
   Vec(l);
 }

gp_inline__location="../dragon.tex:13773";
 \\ Flip bits below each 1, not including that 1, is UnGray.
 flip_below_1(n) = {
   my(v=binary(n),o=v);
   for(i=1,#v, if(v[i]==1, for(j=i+1,#o,o[j]=1-o[j])));
   fromdigits(o,2);
 }

gp_inline__location="../dragon.tex:13782";
 \\ Flip bits at and below each 1.
 flip_at_and_below_1(n) = {
   my(v=binary(n),o=v);
   for(i=1,#v, if(v[i]==1, for(j=i,#o,o[j]=1-o[j])));
   fromdigits(o,2);
 }

gp_inline__location="../dragon.tex:13800";
 A292600_state_table = {[ 1,2;
                          2,1 ]};
 A292600_output_table = {[ 0,0;
                           1,1 ]};
 A292600_by_states(n) = {
   my(v=binary(n), state=1);
   for(i=1,#v,
       my(bit=v[i]);
       v[i] = A292600_output_table[state,bit+1];
       state = A292600_state_table[state,bit+1]);
   fromdigits(v,2);
 }

gp_inline__location="../dragon.tex:13822";
 \\ n terms starting at 0
 GrayCumulative(n) = sum(i=0,n-1, Gray(i));
 A048641(n) = GrayCumulative(n);

gp_inline__location="../dragon.tex:13831";
 \\ Ralf Stephan's formula in A048641
 A048641_b(n) = {
   n>=0 || error();
   if(n==0, return(0));
   my(lo=n%2); n\=2;
   if(lo==0, 2*(A048641_b(n) + A048641_b(n-1) + ceil(n/2)),
             4*A048641_b(n) + n + 1);
 }

gp_inline__location="../dragon.tex:13852";
 Triangular(n) = n*(n+1)/2;
 A000217(n) = Triangular(n);

gp_inline__location="../dragon.tex:13905";
 Davis_Knuth_g(n) = dir(n-1);

gp_inline__location="../dragon.tex:13936";
 \\ A036044 except it takes 0 to be one bit
 BCR(n) = fromdigits(Vecrev(apply(b->1-b,binary(n))),2);

gp_inline__location="../dragon.tex:13956";
 gdir_term(x,k) = x^(2^k) / (1-x) / (1 + x^(2^(k+1)));

gp_inline__location="../dragon.tex:13958";
 gdir(x,k) = sum(j=0,k, gdir_term(x,j));

gp_inline__location="../dragon.tex:14021";
 dir_max(k) = k;

gp_inline__location="../dragon.tex:14023";
 \\ Return [d,vec].
 dir_max_and_DirMaxN_list_by_search(k) = {
   my(d_max=0, n_max=0, l=List([]));
   for(n=0,2^k-1,
     my(d=dir(n));
     if(d>d_max, d_max=d; l=List([]));
     if(d==d_max, listput(l,n)));
   [d_max, Vec(l)];
 }

gp_inline__location="../dragon.tex:14046";
 DirMaxN(k) = floor( 2/3 * 2^k );

gp_inline__location="../dragon.tex:14056";
 DirMaxN_samples = {[0,1,2,5,10,21,42,85]};

gp_inline__location="../dragon.tex:14066";
 A000975(n) = DirMaxN(n);

gp_inline__location="../dragon.tex:14077";
 DirMaxN_binary_samples = {[0,1,10,101,1010,10101,101010]};

gp_inline__location="../dragon.tex:14115";
 A005578(n) = {
   n>=0 || error("A005578() is for n>=0");
   ceil(1/3*2^n);
 }

gp_inline__location="../dragon.tex:14122";
 Collatz_list(n) = {
   my(l=List([]),seen=Map());
   while(!mapisdefined(seen,n),
     listput(l,n);
     mapput(seen,n,1);
     n = if(n%2,3*n+1,n/2));
   Vec(l);
 }

gp_inline__location="../dragon.tex:14567";
 TurnsL(n) = {
   n>=0 || error("TurnsL() is for n>=0");
   1/2*(n + dir(n));
 }

gp_inline__location="../dragon.tex:14572";
 TurnsR(n) = {
   n>=0 || error("TurnsR() is for n>=0");
   1/2*(n - dir(n));
 }

gp_inline__location="../dragon.tex:14590";
 TurnsL_samples = {[0,1,2,2,3,4,4,4,5,6,7,7,7,8,8]};

gp_inline__location="../dragon.tex:14609";
 TurnsR_samples = {[0,0,0,1,1,1,2,3,3,3,3,4,5,5,6]};

gp_inline__location="../dragon.tex:14621";
 A255070(n) = (n - hammingweight(bitxor(n,n>>1)))/2;

gp_inline__location="../dragon.tex:14643";
 gTurnsL_term(x,k) = x^(2^k) / (1-x) / (1 - x^(4*2^k));
 gTurnsL(x,k) = sum(j=0,k, gTurnsL_term(x,j));

gp_inline__location="../dragon.tex:14654";
 gTurnsR_term(x,k) = x^(3*2^k) /( (1-x)*(1 - x^(4*2^k)) );
 gTurnsR(x,k) = sum(j=0,k, gTurnsR_term(x,j));

gp_inline__location="../dragon.tex:14690";
 log2(x) = {
   if(is_integer(x)&&is_power_of_2(x), valuation(x,2),
      log(x)/log(2));
 }

gp_inline__location="../dragon.tex:14718";
 log2_ceil(n) = if(n==1,0, 1+logint(n-1,2));

gp_inline__location="../dragon.tex:14804";
 A236840(n) = n - CountBitTransitions(n);

gp_inline__location="../dragon.tex:14835";
 ThueMorse(n) = hammingweight(n)%2;

gp_inline__location="../dragon.tex:14839";
 A010060(n) = ThueMorse(n);

gp_inline__location="../dragon.tex:14854";
 ThueMorse_constant_hex(len) = \
   digits(fromdigits(vector(4*len,i,i--; ThueMorse(i)),2),16);

gp_inline__location="../dragon.tex:14871";
 dX(n) = real(I^dir(n));

gp_inline__location="../dragon.tex:14880";
 dY(n) = imag(I^dir(n));

gp_inline__location="../dragon.tex:14889";
 dSum(n) = dX(n)+dY(n);

gp_inline__location="../dragon.tex:14901";
 dDiff(n) = dX(n)-dY(n);

gp_inline__location="../dragon.tex:14916";
 TurnLeft_num_decrements(m) = {
   my(n=2*m,t=1,count=0);
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     if(bittest(n,pos)==t,
        n--; t=1-t; count++));
   count;
 }

gp_inline__location="../dragon.tex:14924";
 TurnRight_num_increments(m) = {
   my(n=2*m+2, t=1, count=0);
   forstep(pos=if(n,logint(n,2)),0,-1,   \\ high to low
     if(bittest(n,pos)==t,
        n++; t=1-t; count++));
   count;
 }

gp_inline__location="../dragon.tex:15027";
 TurnLeftOffH(k) = {
   k>=1 || error("TurnLeftOffH() is for k>=1");
   floor(1/3*2^k + k/2 - 1);
 }

gp_inline__location="../dragon.tex:15032";
 TurnLeftOffH_samples = {[0,1,3,6,12,23,45,88]};

gp_inline__location="../dragon.tex:15049";
 A086445(n) = {
   n>=0 || error("A086445() is for n>=0");
   2*2^n/3 + (-1)^n/12 + n/2 + 1/4;
 }

gp_inline__location="../dragon.tex:15092";
 TurnRightOffH(k) = {
   k>=2 || error("TurnRightOffH() is for k>=2");
   1/2 * (floor(2/3*2^k) + 1 - (k-1) ) - 1;
 }

gp_inline__location="../dragon.tex:15100";
 TurnRightOffH_samples = {[0,1,3,8,18,39,81,166]};

gp_inline__location="../dragon.tex:15148";
 dir_mod4_samples = {[0,1,2,1,2,3,2,1,2,3,0,3,2,3,2,1]};

gp_inline__location="../dragon.tex:15158";
 dir_mod4_0_at_n_samples = {[0,10,18,20,22,26,34,36,38,40]};

gp_inline__location="../dragon.tex:15176";
 dir_mod4_1_at_n_samples = {[1,3,7,15,21,31,37,41,43,45]};

gp_inline__location="../dragon.tex:15196";
 dir_mod4_2_at_n_samples = {[2,4,6,8,12,14,16,24,28,30]};

gp_inline__location="../dragon.tex:15217";
 dir_mod4_3_at_n_samples = {[5,9,11,13,17,19,23,25,27,29]};

gp_inline__location="../dragon.tex:15238";
 dir4_state_table = {[0,1; 2,1; 2,3; 0,3]};

gp_inline__location="../dragon.tex:15275";
 dir4_transition(state,bit) = dir4_state_table[state+1,bit+1];
 dir4_transitions(state,v) = {
   for(i=1,#v,  /* high to low */
       state=dir4_transition(state,v[i]));
   state;
 }
 dir_initial_state = 0;

gp_inline__location="../dragon.tex:15359";
 \\ count runs of 1s in n, code per Gheorghe Coserea in A069010
 A069010(n) = (hammingweight(bitxor(n,n>>1)) + 1) >> 1;

gp_inline__location="../dragon.tex:15376";
 A268411(n) = A069010(n) % 2;

gp_inline__location="../dragon.tex:15520";
 \\ n is an integer, s is +1 or -1.
 \\ Return a vector of digits, high to low, which are +1 and -1
 \\ alternating, and possible 0s.  s is the lowest non-zero in the
 \\ return (and thus determining the signs above).
 \\ The converse, returning powers to n, is from_binary_vector().
 n_to_folded(n,s) = {
   s==1 || s==-1 || error("n_to_folded() is for s=+/-1");
   my(k=0, l=List([]));
   while(n, my(a=(n%2)*s); listput(l,a);
            n -= a; if(a, s = -s); n /= 2);
   Vecrev(l);
 }

gp_inline__location="../dragon.tex:15550";
 n_to_folded_indices(n,s) = {
   my(v=n_to_folded(n,s));
   apply(i->#v-i, Vec(select(i->i,v,1)));
 }

gp_inline__location="../dragon.tex:15558";
 dragon_point_and_f_by_folded(n,s) = {
   my(v = n_to_folded(n,s), f=1, z=0);
   for(i=1,#v,
       if(v[i], z += f*b^(#v-i); f*=-I));
   [z,s];
 }
 dragon_point_by_folded(n,s) = dragon_point_and_f_by_folded(n,s)[1];

gp_inline__location="../dragon.tex:15571";
 point_samples = {[0,1,1+I,I,2*I,-1+2*I,-1+I,-2+I,-2+2*I]};

gp_inline__location="../dragon.tex:15676";
 \\ This as pairs of 1...-1 so the lowest is s=-1.
 n_to_folded_from_runs(n) = {
   if(n==0,return([]));
   my(v=concat(0,binary(n)));
   vector(#v,i,
          if(i<#v && v[i]==0 && v[i+1]==1,     1,  \\ top of run
             v[i]==1 && (i==#v || v[i+1]==0), -1,  \\ bottom of run
             0));
 }

gp_inline__location="../dragon.tex:15827";
 point_by_revPoint(n,k) = {
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   (n1>=0 && n1<2^k) || error("n="n" above k="k);
   if(n==0, 0,
      a==0, point_by_revPoint(n,k-1),
            b^(k-1) + I*revPoint(n1,k-1));
 }

gp_inline__location="../dragon.tex:15842";
 revPoint_ref(n,k) = b^k - dragon_point(2^k - n);

gp_inline__location="../dragon.tex:15855";
 revPoint(n,k) = {
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   if(n==0, 0,
      a==0, I*point_by_revPoint(n,k-1),
            I*b^(k-1) + revPoint(n1,k-1));
 }

gp_inline__location="../dragon.tex:15906";
 revPointRot_ref(n,k) = -I * revPoint_ref(n,k);

gp_inline__location="../dragon.tex:15919";
 point_by_revPointRot(n,k) = {
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   if(n==0, 0,
      a==0, point_by_revPointRot(n,k-1),
            b^(k-1) - revPointRot(n1,k-1));
 }

gp_inline__location="../dragon.tex:15940";
 revPointRot(n,k) = {
   (n>=0 && n<2^k) || error("n="n" above k="k);
   my(a=bittest(n,k-1),n1=n-a*2^(k-1));
   if(n==0, 0,
      a==0, point_by_revPointRot(n,k-1),
            b^(k-1) + revPointRot(n1,k-1));
 }

gp_inline__location="../dragon.tex:16114";
 dragon_point_new_low_bit(n) = {
   my(n1 = n \ 2);
   my(a = n % 2);
   dragon_point(n1)*b + I^dir(2*n1) * a;
 }

gp_inline__location="../dragon.tex:16192";
 point_expand_odd_offset(n) = I^dir(2*n);

gp_inline__location="../dragon.tex:16199";
 point_expand_odd_offset_samples = {[+1,-1,-1,-1,-1,+1,-1,-1,-1,+1,+1,+1,-1]};

gp_inline__location="../dragon.tex:16208";
 p1n1_to_01(n) = (1-n)/2;  /* 1 -> 0, -1 -> 1 */

gp_inline__location="../dragon.tex:16218";
 dy(n) = imag(I^dir(n));

gp_inline__location="../dragon.tex:16277";
 vector_initial(v,n) = if(n==0,[], v[1..n]);
 dragon_point_by_sum(n) = {
   my(v=binary(n));
   sum(i=1,#v, v[i] * b^(#v-i)
               * I^dir_of_bits(concat(vector_initial(v,i-1),[0])));
 }

gp_inline__location="../dragon.tex:16285";
 dragon_point_by_transitions(n) = {
   n>=0 || error("dragon_point_by_transitions() is for n>=0");
   my(v=binary(n));
   if(#v==0, return(0));
   my(d=1, ret=b^(#v-1));
   for(i=2,#v,
       \\ print("i="i" ret="ret" dir="d" bit="v[i]",prev="v[i-1]);
       if(v[i-1],                            \\ previous bit
          if(v[i],                           \\ this bit
             ret += b^(#v-i) * I^(d+1),      \\ expand on left
             d++),
          if(v[i],                           \\ this bit
             ret += b^(#v-i) * I^d;          \\ expand on right
             d++)));
   ret;
 }

gp_inline__location="../dragon.tex:16304";
 \\ an efficient form
 dragon_point(n) = dragon_point_by_transitions(n);

gp_inline__location="../dragon.tex:16335";
 dragon_point_by_folded_low_to_high(n,s) = {
   my(z=0, t=0, k=0, f=1);
   while(n,
         if(n%2,
            z += f*b^k;  \\ print("  power "f"*b^"k);
            n -= s;
            s = -s; f *= I;
            t++);
         n /= 2;
         k++);           \\ print("  end t="t" f="f);
   z * conj(f * -I);
 }

gp_inline__location="../dragon.tex:16355";
 dragon_point_by_high_to_low_state(n) = {
   my(v=binary(n));
   my(z=0, state="forward", f=1);
   for(i=1,#v,
       my(k=#v-i);
       if(state == "forward",
          if(v[i]==1,
             z = z + f*b^k;
             f = f * I;
             state = "reverse"),
       state == "reverse" || error();
          if(v[i]==0,
             state = "forward";
             f = f * I,
          v[i]==1 || error();
             z = z + f*I*b^k)));
   z;
 }

gp_inline__location="../dragon.tex:16378";
 dragon_point_and_s_by_high_to_low_expansion(n) = {
   my(a=binary(n), z=0, s=1);
   for(i=1,#a,  \\ high to low
       z = z*b + s*a[i];
       \\ z = z*b + I^dir_of_bits(concat(vector_initial(a,i-1),[0])) * a[i];
       if(a[i]==1 && if(i==1,0,a[i-1])==0, s = -s));
   [z,s];
 }
 dragon_point_by_high_to_low_expansion(n) = \
   dragon_point_and_s_by_high_to_low_expansion(n)[1];

gp_inline__location="../dragon.tex:16391";
 dir_mod_4_by_point_s(n) = \
  (dragon_point_and_s_by_high_to_low_expansion(n)[2] -1-(n%2)) % 4;

gp_inline__location="../dragon.tex:16415";
 dnorm(n) = norm(dragon_point(n+1)) - norm(dragon_point(n));

gp_inline__location="../dragon.tex:16428";
 XorY(n) = my(z=dragon_point(n)); if(n%2==0,real(z),imag(z));
 YorX(n) = my(z=dragon_point(n)); if(n%2==0,imag(z),real(z));

gp_inline__location="../dragon.tex:16546";
 \\ return true if z is an Gaussian integer
 z_is_integer(z) = is_integer(real(z)) && is_integer(imag(z));

gp_inline__location="../dragon.tex:16549";
 z_mod_b(z) = (real(z) + imag(z)) % 2;

gp_inline__location="../dragon.tex:16559";
 z_is_odd(z)  = z_mod_b(z);
 z_is_even(z) = ! z_is_odd(z);

gp_inline__location="../dragon.tex:16563";
 \\ Return 0,1,2,3 which is low bit l=z_mod_b(z), and second bit
 \\ s=z_mod_b(z) after dividing out (so (z-l)/b)
 z_mod_bsquared_bits(z) = [0,3;1,2][(real(z)%2)+1,(imag(z)%2)+1];

gp_inline__location="../dragon.tex:16584";
 z_mod_bsquared_bits_by_mod_b(z) = {
   my(lo=z_mod_b(z)); z -= lo; z /= b;
   2*z_mod_b(z) + lo;
 }

gp_inline__location="../dragon.tex:16593";
 \\ s = +1 or -1
 dragon_unpoint(z,s) = {
   my(debug=0);
   z_is_integer(z) || error("dragon_unpoint() should be integer z, got ",z);
   s==1 || s==-1 || error("dragon_unpoint() should be s=+/-1, got ",s);
   if(z==0,return([0,0]));
   my(v=List([]));  \\ bits low to high
   while(! (z==0 || z==I*s),
     my(bits = z_mod_bsquared_bits(z));
     if(debug,print("at z="z"  s="s"  bits="bits"  vHL="Vecrev(v)));
     if(bits==1, s = -s);
     if(bits%2, z -= s);
     z = z/b;
     if(! z_is_integer(z), error("oops, z=",z));
     listput(v,bits%2);
     );
   if(debug,print("end z="z" s="s" bits high to low "Vecrev(v)));
   if(z==0 && s==1,   [0, from_binary_vector(Vecrev(v))],
      z==0 && s==-1,  [2, from_binary_vector(Vecrev(v))],
      z==I && s==1,   [1, 2^#v-from_binary_vector(Vecrev(v))],
      z==-I && s==-1, [3, 2^#v-from_binary_vector(Vecrev(v))],
      error("oops, dragon_unpoint() end z=",z," s=",s));
 }

gp_inline__location="../dragon.tex:16649";
 \\ number of visits to location z
 z_count_visits(z,k=oo) = {
   my(ret=0);
   forstep(d=-1,1,2,
     my(an=dragon_unpoint(z,d));
     an[1]==0 || next;
     if(k<oo, an[2]<=2^k || next);
     ret++);
   ret;
 }

gp_inline__location="../dragon.tex:16682";
 unpoint_iterate(v) = {
   my(z=v[1], s=v[2]);
   my(bits=z_mod_bsquared_bits(z));
   if(bits==1, s=-s);
   if(bits%2, z-=s);
   z /= b;
   [z,s];
 }
 unpoint_iterations(n,v) = {
   my(result=vector(n));
   for(i=1,n, v = unpoint_iterate(v);
              result[i] = v);
   result;
 }

gp_inline__location="../dragon.tex:16731";
 dragon_unpoint_s_of_zd(z,d) = I^(d + if(z_mod_b(z),1));

gp_inline__location="../dragon.tex:16738";
 dragon_unpoint_of_d(z,d) = \
   dragon_unpoint(z, dragon_unpoint_s_of_zd(z,d));

gp_inline__location="../dragon.tex:16846";
 unpoint_v_ending(v) = {
   for(i=1,100, v=unpoint_iterate(v);
                if(v[1]==0, return(0));
                if(v==[I,1], return(v));
                if(v==[-I,-1], return(v)));
   ["other",v];
 }
 unpoint_v_ending_is_known(v) = {
   v = unpoint_v_ending(v);
   v==0 || v==[I,1] || v==[-I,-1];
 }
 unpoint_z_ending_is_known(z) = {
   unpoint_v_ending_is_known([z,1])==1
   && unpoint_v_ending_is_known([z,-1])==1;
 }

gp_inline__location="../dragon.tex:16955";
 \\ z is a Gaussian integer.
 \\ Return a vector of revolving digits +/-1, +/-I, 0.
 \\ The lowest non-zero digit is the given s.
 z_to_revolving(z,s) = {
   my(v=List([]));
   while(z,
         \\ print("at z="z" v="v);
         my(m=z_mod_b(z), d=m*s);
         listput(v,d);    \\ digit
         if(m, s*=I);     \\ revolve back for next higher digit
         z -= d;
         z /= b;
         z_is_integer(z) || error("oops, z_to_revolving() not Gaussian integer ",z));
   Vecrev(v);
 }

gp_inline__location="../dragon.tex:16980";
 revolving_to_z(v) = fromdigits_any(v,b);

gp_inline__location="../dragon.tex:16985";
 \\ v is a vector of digits high to low.
 \\ Return true if it is in a revolving representation of a
 \\ Gaussian integer, meaning each digit +/-1 or +/-I or 0
 \\ and at a given digit d the next lower non-zero is (-I)*d.
 is_revolving(v) = {
   my(i=1);
   while(i<=#v && v[i]==0, i++);
   my(want=v[i]*(-I));
   while(i<=#v,
         if(v[i],
            if(v[i] != want, return(0));
            want *= (-I)));
   1;
 }

gp_inline__location="../dragon.tex:17000";
 revolving_type_at_pos(v,pos) = {
   forstep(i=pos,1,-1, if(v[i],return(v[i])));
   for(i=pos+1,#v, if(v[i],return(I*v[i])));
   error("no revolving type for zero");
 }
 revolving_type(v) = revolving_type_at_pos(v,#v);

gp_inline__location="../dragon.tex:17007";
 vector_strip_leading_zeros(v) = \
   for(i=1,#v, if(v[i], return(v[i..-1]))); [];

gp_inline__location="../dragon.tex:17010";
 \\ T sigma=I  +90
 \\ S sigma=-I -90
 \\ R sigma=-1 180
 revolving_turn_map(v) = {
   if(v==[ I, 1, I], [0, I, 0],   \\ T
      v==[-1, I, I], [0,-1, 0],
      v==[-I,-1, I], [0,-I, 0],
      v==[ 1,-I, I], [0, 1, 0],

      v==[ 0, 1, -I], [ 1,-I, 0],   \\ S
      v==[ 0, I, -I], [ I, 1, 0],
      v==[ 0,-1, -I], [-1, I, 0],
      v==[ 0,-I, -I], [-I,-1, 0],

      v==[ 0, 1, I], [-1, I, -1],  \\ T to R
      v==[ 0, I, I], [-I,-1, -1],
      v==[ 0,-1, I], [ 1,-I, -1],
      v==[ 0,-I, I], [ I, 1, -1],

      v==[ I, 1, -I], [ 0,-I, -1],  \\ S to R
      v==[-1, I, -I], [ 0, 1, -1],
      v==[-I,-1, -I], [ 0, I, -1],
      v==[ 1,-I, -I], [ 0,-1, -1],
      error("oops, unrecognised revolving turn ",v));
 }
 revolving_turn(v,sig) = {
   my(debug=0);
   v=concat([0,0,0,0],v);
   my(new_v=v, pos=#v);
   while(pos >= 2,
           if(debug,print("at "v[pos-1]," ",v[pos]"  sigma "sig));
           if(sig==-1,  \\ type R
              if(v[pos]==0,
                 my(t = revolving_type_at_pos(v,pos));
                 if(debug,print("  R type "t));
                 new_v[pos] = -t; sig=-I,
                 new_v[pos]=0; sig=I);
              pos--; next());
           if(sig==0,break());
           if(v[pos]==0, pos--;next());
           my(rep = revolving_turn_map([v[pos-1],v[pos],sig]));
           if(debug,print("  replace ",rep));
           new_v[pos-1] = rep[1];
           new_v[pos]   = rep[2];
           sig          = rep[3];
           pos -= 2
         );
    if(debug,print("result ",new_v"  sigma "sig));
    vector_strip_leading_zeros(new_v);
 }

gp_inline__location="../dragon.tex:17146";
 dragon_n_to_arm_and_other(n) = {
   if(n<0,error("dragon_n_to_arm_and_other() is for n>=0"));
   my(v = concat([0,0,0],binary(n)));
   my(pos = #v);
   while(pos >= 1 && v[pos]==0, pos--); \\ skip low 0s
   if(pos < 1, return([0,0]));  \\ all zeros

   pos--;  \\ skip lowest 1 bit
   my(t = if(pos>=1,v[pos],0));
   my(flip=0);
   while(1,
         pos--;           \\ skip t bit
         if(pos < 1, break());
         \\ if(pos < 1, return(-1));

         my(bit = v[pos]);
         v[pos]=1-v[pos];  \\ flip
         pos--;
         while(pos >= 1 && v[pos]==bit,
               v[pos]=1-v[pos]; pos--);  \\ flip run
         if(pos < 1, flip=1; break());
         \\ if(pos < 1, return(-1));

         v[pos]=1-v[pos];  \\ flip one more
         pos--;
         if(pos < 1, flip=1; break());
         \\ if(pos < 1, return(-1));

         if(v[pos] != t,
            break());  \\ rest unchanged
        );
   my(other = from_binary_vector(v));
   if(flip, [2*t-1, 2^#v - other],
            [0, other]);
 }

gp_inline__location="../dragon.tex:17185";
 \\ Return other(n), or -1 if no other visit on the present arm.
 dragon_n_to_other(n) = {
   my(ao=dragon_n_to_arm_and_other(n));
   if(ao[1]==0, ao[2], -1);
 }

gp_inline__location="../dragon.tex:17191";
 cmp_arm_and_n(x,y) = \
   if(lex(x[1],y[1]),lex(x[1],y[1]), lex(x[2],y[2]));
 z_to_both_arm_and_n(z) = {
   vecsort([dragon_unpoint(z,1), dragon_unpoint(z,-1)],
           cmp_arm_and_n);
 }

gp_inline__location="../dragon.tex:17200";
 z_to_both_arm_and_n_by_other(z,s) = {
   if(z==0,return([[0,0],[0,0]]));
   my(an=dragon_unpoint(z,s));
   my(on=dragon_n_to_arm_and_other(an[2]));
   on[1] = (on[1] + an[1])%4; \\ arm increment
   \\ print([an,on]);
   vecsort([an,on], cmp_arm_and_n);
 }

gp_inline__location="../dragon.tex:17218";
 \\ z is a complex integer location.
 \\ Return a vector of n values at that location.
 \\ Empty vector if z never visited, otherwise 1 or 2 values.
 z_to_n_list(z) = {
   my(v=z_to_both_arm_and_n(z));
   v=select(an->an[1]==0,v);
   apply(an->an[2],v);
 }

gp_inline__location="../dragon.tex:17230";
 \\ z1 and z2 are two ends of a unit segment.
 \\ Return the n which traverses that segment.
 \\ z1,z2 can be either way around.
 \\ k restricts to n<2^k so within curve level k.
 \\ Default k = infinity is unrestricted n.
 \\ If z1,z2 segment is not traversed then return symbol 'none.
 segment_to_n(z1,z2,k=oo) = {
   my(n_limit=if(k==oo,oo,2^k),
      delta=z1-z2);
   if(abs(real(delta))+abs(imag(delta))!=1,
      error("not unit segment ",delta));
   my(v1=z_to_n_list(z1), v2=z_to_n_list(z2));
   for(i=1,#v1,
     v1[i] <= n_limit || next;
     for(j=1,#v2,
       v2[j] <= n_limit || next;
       if(abs(v1[i]-v2[j])==1,
         return(min(v1[i],v2[j])))));
   'none;
 }

gp_inline__location="../dragon.tex:17252";
 \\ z1,z2 are complex numbers given a unit length segment.
 \\ Return 1 if z1,z2 is traversed by the dragon curve.
 \\ k limits to curve level k, or default k=infinity unlimited.
 segment_is_traversed(z1,z2,k=oo) = segment_to_n(z1,z2,k)!='none;

gp_inline__location="../dragon.tex:17267";
 \\ z is the centre of a unit square.
 \\ Return a vector of the n segment numbers surrounding it.
 \\ k limits to curve level k segments, so n < 2^k.
 \\ Default k=infinity is unlimited.
 Q_to_n_list(z,k=oo) = {
   z_is_integer(z + 1/2+1/2*I) || error("not Q centre");
   vecsort(
   select(n->n!='none,
     vector(4,d,
            segment_to_n(z + (1/2+1/2*I)*I^d,
                         z + (1/2-1/2*I)*I^d, k))));
 }

gp_inline__location="../dragon.tex:17281";
 zz_to_plus90(z1,z2) = z1 + (z2-z1)*I;
 zz_to_minus90(z1,z2) = z1 + (z2-z1)*-I;
 zz_to_end_plus90(z1,z2) = z2 + (z2-z1)*I;
 zz_to_end_minus90(z1,z2) = z2 + (z2-z1)*-I;

gp_inline__location="../dragon.tex:17286";
 zz_to_right_centre(z1,z2) = z1 + (z2-z1)*(1/2-1/2*I);
 zz_to_left_centre(z1,z2)  = z1 + (z2-z1)*(1/2+1/2*I);

gp_inline__location="../dragon.tex:17291";
 zdir_to_right_centre(z,d) = zz_to_right_centre(z,z+I^d);
 zdir_to_left_centre(z,d)  = zz_to_left_centre(z,z+I^d);

gp_inline__location="../dragon.tex:17359";
 other_n_samples = [0,3,6,1,12,23,2,11,24,27,46,7,4,47,22];

gp_inline__location="../dragon.tex:17365";
 other_arm_samples = {[0,-1,-1,1,-1,-1,1,0,-1,-1,-1,0,1,-1,0]};

gp_inline__location="../dragon.tex:17456";
 n_to_arm_and_other_by_twiddling(n) = {
   if(n==0,return([0,0]));
   my(debug=0);
   my(mask = bitxor(n,n-1) + 1,   \\ bit above lowest 1
      t = bitand(n,mask));
   if(debug,printf("t=%s\n", binary(t)));
   while(1,
         mask *= 2;
         if(debug,printf("at n=%s mask=%s\n", binary(n), binary(mask)));
         my(add = 2*bitand(n,mask) - mask);    \\ +/- 2^pos
         if(debug,printf("  add %d %s\n", add, binary(add)));

         my(run_mask = bitxor(n, n + add));    \\ bits in run
         n += add;               \\ bit flip run
         if(n < 0, return([2*(t!=0)-1, -n]));

         if(debug,printf("  run mask %d %s\n", run_mask, binary(run_mask)));
         mask += run_mask;       \\ bit above run
         if(debug,printf("  above run %d %s  n=%d %s\n", mask,binary(mask), n,binary(n)));
         if((bitand(n,mask)!=0) != (t!=0), return([0,n]));
        );
 }

gp_inline__location="../dragon.tex:17531";
 n_to_other_by_delta_seen_delta = Set();
 n_to_arm_and_other_by_delta(n) = {
   if(n==0,return([0,0]));
   my(debug=0);
   my(v = concat([0,0,0],binary(n)));
   my(pos = #v);
   my(s = 1);
   my(h = -1);
   my(delta = 0);
   while(pos > 1,
         n_to_other_by_delta_seen_delta
           = setunion(n_to_other_by_delta_seen_delta,Set([delta]));

         \\ old_bit == old_bit_signed mod b^2
         my(a0 = v[pos]);
         my(a1 = v[pos-1]);
         if(a1==0 && a0==1, s = -s);

         my(z = a1*b + a0 + delta);
         if(z_mod_bsquared_bits(z) == 1, h = -h);

         my(c0 = z_mod_b(z));
         delta = (delta + a0*s - c0*h) / b;
         if(debug,print("  to c0="c0));

         v[pos] = c0;
         pos--;
        );
   \\ print("end "v" delta "delta" s="s" h="h"   n="from_binary_vector(v));
   v = v[^1];
   if(delta, [if(s==h,1,-1), 2^#v-from_binary_vector(v)],
             [0, from_binary_vector(v)]);
 }

gp_inline__location="../dragon.tex:17604";
 n_to_arm_and_other_state_transition(state,bit) = {
   my(s=state[1], h=state[2], delta=state[3], currentbit=state[4]);
   \\ old_bit == old_bit_signed mod b^2
   my(a0 = currentbit);
   my(a1 = bit);
   if(a1==0 && a0==1, s = -s);

   my(z = a1*b + a0 + delta);
   if(z_mod_bsquared_bits(z) == 1, h = -h);

   my(c0 = z_mod_b(z));
   delta = (delta + a0*s - c0*h) / b;

   [ [s,h,delta,bit], c0 ];
 }
 n_to_arm_and_other_by_states(n) = {
   if(n==0,return([0,0]));
   my(debug=0);
   my(v = concat([0,0,0],binary(n)));
   if(debug,print("v="v));
   my(pos = #v);
   my(state=[1,-1,0,v[#v]]);
   forstep(i=#v, 2, -1,
     my(bit=v[i-1]);
     my(ret=n_to_arm_and_other_state_transition(state,bit));
     if(debug,print("at state="state" bit="bit"  ret="ret));
     state=ret[1];
     v[i]=ret[2];
   );
   my(s=state[1], h=state[2], delta=state[3], currentbit=state[4]);
   v=v[^1];  \\ v[1] not set by loop
   if(debug,print("final v="v));
   if(delta, [if(s==h,1,-1), 2^#v-from_binary_vector(v)],
             [0, from_binary_vector(v)]);
 }

gp_inline__location="../dragon.tex:17696";
 Opred(d) = {
   if(d==0, return(0));
   while(d,
         if(d%4 != 0, return(0));  \\ must two 0-bits below +/-1
         d = n_odd_part(d);
         if(d%4 == 1, d--,         \\ is +1, subtract it
            d%4 == 3, d++);        \\ is -1, add it back
         d /= 2;
        );
   1;
 }

gp_inline__location="../dragon.tex:17708";
 Opred_samples = {[0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1]};

gp_inline__location="../dragon.tex:17727";
 Opred_at_samples = {[4,8,16,28,32,36,56,60,64,68,72]};

gp_inline__location="../dragon.tex:17740";
 Opred_by_search(d) = {
   my(n=1);
   for(n=1,16*abs(d),
       my(an=dragon_n_to_arm_and_other(n));
       if(an[1]==0 && abs(an[2]-n)==d, return(1)));
   0;
 }

gp_inline__location="../dragon.tex:17752";
 Opred_only_positives(d) = {
   if(d==0, return(0));
   while(d,
         if(d%4 != 0, return(0));  \\ must two 0-bits below +/-1
         d = n_odd_part(d);
         if(d%4 == 1, d--,         \\ is +1, subtract it
            d%4 == 3, return(0));  \\ is -1, disallow
         d /= 2;
        );
   1;
 }

gp_inline__location="../dragon.tex:17766";
 OXpred_list_by_n(k) = {
   my(m=Map(),limit=2^k);
   for(n=1,limit,
       my(o=dragon_n_to_other(n));
       if(o>=0&&o<=limit,mapput(m,bitxor(n,o),1)));
   m=Mat(m);
   if(matsize(m)[2],vecsort(Vec(m[,1])),[]);
 }

gp_inline__location="../dragon.tex:17776";
 \\ regexp 0*(11+0)+0+
 OXpred(n) = {
   my(v=binary(n));
   if(!(#v>2 && v[#v]==0 && v[#v-1]==0), return(0));
   while(#v>2 && v[#v]==0 && v[#v-1]==0, v=v[^#v]);
   my(i=1);
   while(1,
     if(i+2<=#v && v[i]==1 && v[i+1]==1 && v[i+2]==0, i+=3,
        i+2<=#v && v[i]==1 && v[i+1]==1 && v[i+2]==1, i++,
        return(i==#v+1)));
 }

gp_inline__location="../dragon.tex:17836";
 OXpred_at_samples = {[12,24,28,48,56,60,96,108,112,120,124]};

gp_inline__location="../dragon.tex:17843";
 OXpred_at_binary_samples = {[1100,11000,11100,110000,111000]};

gp_inline__location="../dragon.tex:17871";
 \\ i=1 for high bit, down to i=k
 BL_p(n,i) = {
   my(v=binary(n),k=#v);
   2^(k-i) / (1 + fromdigits(v[i..#v],2));
 }
 BL_P(n,i) = {
   my(v=binary(n),
      pi=BL_p(n,i),
      ei=v[i]);
   [ 1/2,  1/2,   0,   0;
     1/2,  1/2,   0,   0;
     pi*ei, 0,  1-ei, (1-pi)*ei;
     pi*ei, 0,  1-ei, (1-pi)*ei ];
 }

gp_inline__location="../dragon.tex:17899";
 BL_pi_initial = [0,0,1,0];
 BL_b_PrSwitch_at_i(pi,P) = {
     pi[1]*P[1,2]
   + pi[2]*P[2,1]
   + pi[3]*P[3,4]
   + pi[4]*(P[4,1] + P[4,3]);
 }
 BL_b_PrSwitch(n) = {
   my(k=#binary(n),total=0,pi=BL_pi_initial);
   for(i=1,k,
       my(P=BL_P(n,i));
       total+=BL_b_PrSwitch_at_i(pi,P);
       pi=pi*P);
   total/k;
 }
 BL_b_by_matrix(n) = {
   my(k=#binary(n));
   (n+1) * k * BL_b_PrSwitch(n);
 }

gp_inline__location="../dragon.tex:17951";
 DirCumul_samples = {[0,0,1,3,4,6,9,11,12,14,17]};

gp_inline__location="../dragon.tex:17961";
 \\ A173318 sum dir(0) + ... + dir(n) inclusive, OFFSET=0
 A173318(n) = DirCumul(n+1);

gp_inline__location="../dragon.tex:18009";
 gDirCumul_term(x,k) = \
   x^(2^k+1) / (1-x)^2 / (1 + x^(2^(k+1)));
 gDirCumul(x,k) = sum(j=0,k, gDirCumul_term(x,j));

gp_inline__location="../dragon.tex:18032";
 DirCumul_2k_plus_1_samples = {[1,3,6,14,34,82]};

gp_inline__location="../dragon.tex:18056";
 A099035(n) = (n+1)*2^(n-1) - 1;
 A131056(n) = {
   n>=1 || error();   \\ OFFSET=1
   \\ -0^n/2 + 2^(n-1)*(n+1) + 1;  \\ Paul Barry
   -0^(n-1)/2 + 2^(n-2)*n + 1;  \\ OFFSET=1
 }

gp_inline__location="../dragon.tex:18096";
 DirCumul_2k_samples = {[0,1,4,12,32,80]};

gp_inline__location="../dragon.tex:18127";
 DirCumul(n) = {
   n>=0 || error("DirCumul() is for n>=0");
   my(v=binary(n));
   sum(j=1,#v,
       my(k=#v-j);
       2^k * v[j] * (k/2
                     + dir_of_bits(concat(if(j>1,v[1..j-1],[]),
                                          [0]))));
 }

gp_inline__location="../dragon.tex:18442";
 PosPowers(n) = {
   my(k=#binary(n));
   1/2 * sum(j=0,k-1, bittest(n,j) * j * 2^j);
 }

gp_inline__location="../dragon.tex:18447";
 PosPowers_samples = {[0,0,1,1,4,4,5,5,12,12]};

gp_inline__location="../dragon.tex:18460";
 gA080277(x,k_limit) = \
   1/(1-x) * sum(k=0,k_limit, 2^k * x^2^k /(1-x^2^k));

gp_inline__location="../dragon.tex:18465";
 A080277(n) = {  \\ a(n)=n+2*a(floor(n/2)) per Vladeta Jovovic
   my(ret=0,f=1);
   while(n, ret+=n*f; f*=2; n\=2);
   ret;
 }

gp_inline__location="../dragon.tex:18478";
 PosPowers_vector(n) = {
   my(v=binary(n));
   for(i=1,#v, my(j=#v-i); v[i]*=j);
   v/2;
 }

gp_inline__location="../dragon.tex:18510";
 \\ Return a vector of length #binary(n).
 \\ Each entry is at a position with a 1-bit in n.
 \\ Each entry is how many runs of 1-bits are above that position,
 \\ not including the 1-bit at that position itself.
 runs_above_strictly_vector(n) = {
   my(v=concat(0,binary(n)),out=v,above=0);
   for(i=2,#v, out[i]=v[i]*above; if(v[i-1]==0&&v[i]!=0,above++));
   out[1]==0 || error();
   out[2..#out];
 }

gp_inline__location="../dragon.tex:18524";
 \\ Return runs_above_strictly_vector(n) interpreted as binary
 \\ digits at the respective position.
 runs_above_strictly(n) = \
   from_binary_vector(runs_above_strictly_vector(n));

gp_inline__location="../dragon.tex:18570";
 revDirCumul_by_sum(k,n) = {
   (0<=n&&n<2^k) || error();
   sum(j=0,n-1, dir(2^k-1 - j));
 }

gp_inline__location="../dragon.tex:18580";
 \\ return [k,r] where n == 2^k + r and 0<=r<2^k,
 \\ so the high bit of n as an exponent, and remainder r
 high_bit_k_and_remainder(n) = {
   if(n==0,error());
   my(v=binary(n));
   [#v-1, fromdigits(v[^1],2)];
 }

gp_inline__location="../dragon.tex:18604";
 DirCumul_forward(n) = {
   if(n==0,return(0));
   my(v=high_bit_k_and_remainder(n),k=v[1],r=v[2]);
   k++;
   n == 2^(k-1) + r || error();
   \\ print("forward ",k*2^(k-1)," plus ",r);
   (k-1)*2^(k-2) + r + revDirCumul(k-1,r);
 }

gp_inline__location="../dragon.tex:18642";
 revDirCumul(k,n) = {
   (0<=n&&n<2^k) || error("k=",k," n=",n);
   my(r=n-2^(k-1));
   if(r<0,
      \\ print("to forward "n" and "DirCumul(n));
      n + DirCumul(n),
      \\ print("rev k="k" term ",(k+1)*2^(k-2));
      (k-1)*2^(k-2) + 2^(k-1) + revDirCumul(k-1,r));
 }

gp_inline__location="../dragon.tex:18749";
 DirCumul_by_folded(n,s) = {
   my(v=n_to_folded_indices(n,s));
   sum(i=1,#v,my(j=i-1);  (-1)^j *( (1/2*v[i] + j)*2^v[i] ));
 }

gp_inline__location="../dragon.tex:18757";
 \\ PosPowersAll(k) is PosPowers(2^(k+1)-1),
 \\ so sum of terms over k+1 many 1-bits
 PosPowersAll(k) = (k-1)*2^k + 1;

gp_inline__location="../dragon.tex:18782";
 PosPowers_by_folded(n) = {
   my(v=n_to_folded_indices(n,-1));
   sum(i=1,#v, (-1)^(i-1) * PosPowersAll(v[i]-1));
 }

gp_inline__location="../dragon.tex:18818";
 A164910(n) = sum(j=0,n-1, dir(j)+1);

gp_inline__location="../dragon.tex:18829";
 \\ return n with just the highest bit of each run of 1-bits
 high_each_run(n) = {
   my(v=binary(n),out=v,above=1);
   for(i=2,#v, out[i] = (v[i]==1&&v[i-1]==0));
   from_binary_vector(out);
 }

gp_inline__location="../dragon.tex:18849";
 DirCumul_compact(n) = {
   my(k=logint(n,2),
      v=vector(k+1,i,i=k-i+2; if(bittest(n,i), i)),
      d=1);
   forstep(i=k-1,0,-1,
     if(bittest(n,i), v[k-i]+=d; d+=!bittest(n,i+1)));
   fromdigits(v,2);
 }

gp_inline__location="../dragon.tex:18888";
 \\ Blecksmith and Laud  delta_n
 DirRatio(n) = dir(n)/bitlength(n);

gp_inline__location="../dragon.tex:18894";
 DirRatio_samples = {[1,1,1/2,2/3,1,2/3,1/3,1/2,3/4,1,3/4,1/2]};

gp_inline__location="../dragon.tex:18917";
 bitlength(n) = if(n, logint(n,2)+1, 0);

gp_inline__location="../dragon.tex:18927";
 bitlength_samples = {[0,1,2,2,3,3,3,3,4,4]};

gp_inline__location="../dragon.tex:18942";
 logint_ceil(n,b) = if(n==1,0, 1+logint(n-1,b));
 \\ cf Michael Somos in A029837 with exponent()
 A029837(n) = {
   n>=1 || error("A029837() is for n>=0");
   logint_ceil(n,2);
 }

gp_inline__location="../dragon.tex:18957";
 A070939(n) = {
   n>=0 || error("A070939() is for n>=0");
   if(n==0,1, 1+logint(n,2));
 }

gp_inline__location="../dragon.tex:18969";
 \\ cf bitlength+1
 A070941(n) = bitlength(2*n+1);

gp_inline__location="../dragon.tex:18987";
 DirRatioCumul(n) = {
   my(k=bitlength(n));
   DirCumul(n+1)/k
   - 1/2
   + 2^(k-2)/k
   + sum(j=1,k-1, 2^(j-2)/j );
 }

gp_inline__location="../dragon.tex:19000";
 DirRatioCumul_samples = {[1,2,5/2,(19)/(6),(25)/(6),(29)/(6),(31)/(6),(17)/(3),(77)/(12),(89)/(12)]};

gp_inline__location="../dragon.tex:19013";
 \\ Blecksmith and Laud table page 902
 \\ their sum delta(j) = DirRatioCumul(n+1)
 \\ in blocks 10^k
 BL_DirRatioCumul_samples = {[
   7+5/12, 61+61/210, 562+521/630, 5420+8659/12870,
   54041.07, 530201.49, 5223784.09, 52609339.74, 520912798.65,
   5146376588.29
 ]};

gp_inline__location="../dragon.tex:19034";
 \\ Blecksmith and Laud S_{ij} = 1 when bit switch at i in j.
 \\ Here i bit positions with lowest as 0 (not 1).
 BL_S(i,j) = bittest(j,i) != bittest(j,i+1);

gp_inline__location="../dragon.tex:19050";
 DRCmean_samples = {[1,1,5/6,(19)/(24),5/6,(29)/(36),(31)/(42),(17)/(24),(77)/(108)]};

gp_inline__location="../dragon.tex:19130";
 DRC_block(p) = 1/2*2^(p-1) + 1/2*1/p*2^(p-1);

gp_inline__location="../dragon.tex:19141";
 DRC_block_samples = {[1,3/2,8/3,5,(48)/(5),(56)/(3),(256)/(7),72,(1280)/(9),(1408)/(5)]};

gp_inline__location="../dragon.tex:19200";
 DirRatioCumul_2k_sub_1_samples = {[1,5/2,(31)/(6),(61)/(6),(593)/(30),(1153)/(30)]};

gp_inline__location="../dragon.tex:19233";
 DirRatioCumul_E(k) = sum(p=1,k-1, 2^(p-2)/p);
 DirRatioCumul_E_samples = {[0,1/2,1,5/3,8/3,(64)/(15)]};

gp_inline__location="../dragon.tex:19363";
 DirRatioCumul_E_upper(k) = 2^(k-bitlength(k));

gp_inline__location="../dragon.tex:19437";
 DC_top(n) = {
   my(k=bitlength(n));
   DirCumul(n+1) - DirCumul(2^(k-1));
 }

gp_inline__location="../dragon.tex:19508";
 DC_top_F(n) = {
   my(a=binary(n), k=bitlength(n));
   k==#a || error();
   (dir(n) - 1/2*k)
   + sum(q=2,k,
         a[q] * 2^(k-q)
              * ( dir_of_bits(concat(a[1..q-1],[0]))
                  - 1/2*q ));
 }

gp_inline__location="../dragon.tex:19569";
 DC_top_Fk_upper_sumfracs(n) = {
   my(k=bitlength(n));
   1/2 + sum(q=2,k, 1/2*q/k*2^(k-q));
 }

gp_inline__location="../dragon.tex:19587";
 DC_top_Fk_upper_sumlens(n) = {
   my(k=bitlength(n));
   1/2 + sum(q=2,k, 2^(k - bitlength(k) - q + bitlength(q)));
 }

gp_inline__location="../dragon.tex:19680";
 DC_top_Fk_upper(n) = {
   my(k=bitlength(n));
   1/2 + 4*2^(k-bitlength(k));
 }

gp_inline__location="../dragon.tex:20231";
 A126674(n) = n!*sum(j=1,n, 2^(j-1)/j);

gp_inline__location="../dragon.tex:20268";
 A000165(n) = 2^n*n!;

gp_inline__location="../dragon.tex:20290";
 gA126674(x,limit) = sum(n=0,limit-1, A126674(n)*x^n) + O(x^limit);

gp_inline__location="../dragon.tex:20326";
 A054243(n) = 2^(n-bitlength(n));

gp_inline__location="../dragon.tex:20331";
 A126674_with_bitlengths(n) = n!*sum(j=1,n, 2^(j-1)/high_bit(j));

gp_inline__location="../dragon.tex:20385";
 DirRatioCumulFac(n) = bitlength(n)! * DirRatioCumul(n);

gp_inline__location="../dragon.tex:20392";
 A187735(n) = (n+2)*n!*2^(n-1);

gp_inline__location="../dragon.tex:20395";
 DirRatioCumulFacK(k) = DirRatioCumulFac(2^k-1);

gp_inline__location="../dragon.tex:20413";
 \\ A080791
 CountZeroBits(n) = bitlength(n) - CountOneBits(n);

gp_inline__location="../dragon.tex:20423";
 \\ bit lengths of first n integers = A001855
 bitlength_cumulative(n) = sum(i=0,n-1, bitlength(i));

gp_inline__location="../dragon.tex:20428";
 \\ total 1s in first n integers = A000788
 CountOneBits_cumulative(n) = sum(i=0,n-1, CountOneBits(i));

gp_inline__location="../dragon.tex:20433";
 \\ total 0s in first n integers = A181132
 CountZeroBits_cumulative(n) = \
   bitlength_cumulative(n) - CountOneBits_cumulative(n);

gp_inline__location="../dragon.tex:20469";
 Skd_by_b(k,d) = {
   k>=0 || error("Skd_by_b() is for k>=0");
   if(k==0,return(d%4==0));
   1/4*(2^k + b^k*(-I)^d + conj(b)^k*(I)^d);
 }

gp_inline__location="../dragon.tex:20483";
 Skd_by_norm(k,d) = \
   1/4*norm(b^k + I^d) - 1/4;

gp_inline__location="../dragon.tex:20488";
 Skd_by_abs(k,d) = \
   1/4*( geom_abs(b^k + I^d)^2 - 1 );

gp_inline__location="../dragon.tex:20503";
 Skd(k,d) = {
   k>=0 || error("Skd() is for k>=0");
   if(k==0,return(d%4==0));
   1/4*(2^k + s(k - 2*d) * 2^floor(k/2));
 }

gp_inline__location="../dragon.tex:20511";
 s_vector = {[2,2,0,-2,-2,-2,0,2]};
 s(m) = vector_modulo(s_vector,m);

gp_inline__location="../dragon.tex:20516";
 A046980_annotation_vector = {[0,1,1,1,0,-1,-1,-1]};

gp_inline__location="../dragon.tex:20541";
 S0_samples = {[1,1,1,1,2,6,16,36,72,136,256]};

gp_inline__location="../dragon.tex:20553";
 S1_samples = {[0,1,2,3,4,6,12,28,64,136,272]};

gp_inline__location="../dragon.tex:20565";
 S2_samples = {[0,0,1,3,6,10,16,28,56,120,256]};

gp_inline__location="../dragon.tex:20577";
 S3_samples = {[0,0,0,1,4,10,20,36,64,120,240]};

gp_inline__location="../dragon.tex:20625";
 Skd_by_binomial(k,d) = sum(j=0,k, binomial(k,4*j+d));

gp_inline__location="../dragon.tex:20643";
 s_by_b(m) =

gp_inline__location="../dragon.tex:20651";
 Skd_by_b2(k,d) = if(k==0,return((d%4)==0)); \
   1/4*(2^k + 2^(floor(k/2) - floor((k-2*d)/2)) \
              * ( b^(k-2*d) + conj(b)^(k-2*d) ));

gp_inline__location="../dragon.tex:20657";
 Skd_by_b3(k,d) = if(k==0,return((d%4)==0)); \
   1/4*(2^k + b^k*(-I)^d + conj(b)^k*(I)^d);

gp_inline__location="../dragon.tex:20662";
 round_near(x) = my(r=round(x)); if(abs(x-r) < 1e-12, r, x);
 S0_by_Cournot(k) = if(k==0,1, \
                    round_near(1/4*2^k + 1/2*sqrt2^k*cos(Pi/4*k)));
 S1_by_Cournot(k) = if(k==0,0, \
                    round_near(1/4*2^k + 1/2*sqrt2^k*sin(Pi/4*k)));
 S2_by_Cournot(k) = if(k==0,0, \
                    round_near(1/4*2^k - 1/2*sqrt2^k*cos(Pi/4*k)));
 S3_by_Cournot(k) = if(k==0,0, \
                    round_near(1/4*2^k - 1/2*sqrt2^k*sin(Pi/4*k)));

gp_inline__location="../dragon.tex:20686";
 S0_by_Ramus(k) = round_near(1/4*2^k + 1/2*sqrt2^k * cos(1/4*Pi*k));
 S1_by_Ramus(k) = round_near(1/4*2^k + 1/2*sqrt2^k * sin(1/4*Pi*k));
 S2_by_Ramus(k) = round_near(1/4*2^k - 1/2*sqrt2^k * cos(1/4*Pi*k));
 S3_by_Ramus(k) = round_near(1/4*2^k - 1/2*sqrt2^k * sin(1/4*Pi*k));

gp_inline__location="../dragon.tex:20720";
 s_maximum_difference(k) = vecmax(vector(4,d,s(k-2*d))) - vecmin(vector(4,d,s(k-2*d)));

gp_inline__location="../dragon.tex:20877";
 SN(n,d) = {
   1/4 * (n
          + 2*real((-I)^d * dragon_point(n))
          + if(n%2==1, (-1)^d)
         );
 }
 SN_by_count(n,d) = d%=4; sum(j=0,n-1, dir(j)%4==d);

gp_inline__location="../dragon.tex:20889";
 SN0_samples = {[0,1,1,1,1,1,1,1,1,1,1,2,2,2,2]};

gp_inline__location="../dragon.tex:20896";
 SN1_samples = {[0,0,1,1,2,2,2,2,3,3,3,3,3,3,3]};

gp_inline__location="../dragon.tex:20903";
 SN2_samples = {[0,0,0,1,1,2,2,3,3,4,4,4,4,5,5]};

gp_inline__location="../dragon.tex:20910";
 SN3_samples = {[0,0,0,0,0,0,1,1,1,1,2,2,3,3,4]};

gp_inline__location="../dragon.tex:21009";
 DirPred(n,d) = dir(n)%4 == d%4;

gp_inline__location="../dragon.tex:21013";
 DirPred0_samples = {[1,0,0,0,0,0,0,0,0,0,1,0,0]};

gp_inline__location="../dragon.tex:21020";
 DirPred1_samples = {[0,1,0,1,0,0,0,1,0,0,0,0,0]};

gp_inline__location="../dragon.tex:21027";
 DirPred2_samples = {[0,0,1,0,1,0,1,0,1,0,0,0,1]};

gp_inline__location="../dragon.tex:21034";
 DirPred3_samples = {[0,0,0,0,0,1,0,0,0,1,0,1,0]};

gp_inline__location="../dragon.tex:21053";
 A284932_initial = [0,0];
 A284932_expand(vec) = {
   my(ret=List([]), i=1);
   while(i<=#vec,
     if(vec[i]==0 && i<#vec && vec[i+1]==0,
        listput(ret,0); listput(ret,0); listput(ret,1); i+=2,
        vec[i]==0, listput(ret,0); i++,
        vec[i]==1, listput(ret,1); listput(ret,0); i++,
        error()));
   Vec(ret);
 }
 A284932_vector(n) = {
   my(vec=vector(n), new_vec);
   while(1,
         my(new_vec=A284932_expand(vec)[1..n]);
         if(new_vec==vec,break());
         vec=new_vec);
   vec;
 }

gp_inline__location="../dragon.tex:21095";
 z_to_DirPred(z,d) = \
   1/4*( 2 + 2*real((-I)^d*z) - 2*abs(imag((-I)^d*z)) );

gp_inline__location="../dragon.tex:21111";
 dpoint(n) = I^dir(n);

gp_inline__location="../dragon.tex:21118";
 SN_by_DirPred(n,d) = sum(j=0,n-1, DirPred(j,d));

gp_inline__location="../dragon.tex:21155";
 SN_by_dpoints(n,d) = {
   1/4*( sum(j=0,n-1,2)
       + 2*real( (-I)^d*sum(j=0,n-1,dpoint(j)) )
       - 2*sum(j=0,n-1, abs(imag( (-I)^d*dpoint(j) ))));
 }

gp_inline__location="../dragon.tex:21234";
 cubic(x) = x^3 - x^2 - 2;
 cubic_a0 = -2;
 cubic_a1 = 0;
 cubic_a2 = -1;

gp_inline__location="../dragon.tex:21241";
 cubic_p = ( 3*cubic_a1 - cubic_a2^2 )/3;
 cubic_q = ( 9*cubic_a1*cubic_a2 - 27*cubic_a0 - 2*cubic_a2^3 )/27;
 cubic_lambda = 1/3*cubic_a2;

gp_inline__location="../dragon.tex:21250";
 cubic_R = 1/2*cubic_q;
 cubic_Q = 1/3*cubic_p;
 cubic_D = cubic_Q^3 + cubic_R^2;

gp_inline__location="../dragon.tex:21258";
 cubic_discriminant(polynomial) = {
   my(p=polcoeff(polynomial,2),
      q=polcoeff(polynomial,1),
      r=polcoeff(polynomial,0));
   p /= polcoeff(polynomial,3);
   q /= polcoeff(polynomial,3);
   r /= polcoeff(polynomial,3);
   my(u = q - p^2);
   my(v = r - 1/3*p*q + 2/27*p^3);
   4*(u/3)^3 + v^2;
 }

gp_inline__location="../dragon.tex:21276";
 cubic_polynomial = x^3 - x^2 - 2;
 cubic_nf = nfinit(cubic_polynomial);

gp_inline__location="../dragon.tex:21293";
 cubic_C = cbrt(28 + sqrt(29*27));

gp_inline__location="../dragon.tex:21298";
 cubic_C_poly(x) = (x^3 - 28)^2 - 29*27;
 cubic_C_interval_to_bits(n) = \
   interval_solve_bisection([3,4],cubic_C_poly,n);

gp_inline__location="../dragon.tex:21307";
 cubic_C_sample = {(3825455/1000000)};

gp_inline__location="../dragon.tex:21319";
 lex_by_abs(x,y) = lex(abs(x),abs(y));
 lex_by_real(x,y) = lex(real(x),real(y));

gp_inline__location="../dragon.tex:21340";
 r = 1/3 * (1 + cubic_C + 1/cubic_C);
 r_from_C = 1/3*(1 + 'C + 1/'C);

gp_inline__location="../dragon.tex:21346";
 \\ cubic_nf_basis is a vector of the 3 basis elements of cubic_nf,
 \\ as inexact complex numbers.
 cubic_nf_basis = subst(cubic_nf.zk, 'x, r);

gp_inline__location="../dragon.tex:21350";
 \\ e is an element of cubic_nf, so a vector of length 3.
 \\ Return its value as an inexact complex number.
 \\ This is dot product with cubic_nf_basis.
 cubic_nfelt_value(e) = cubic_nf_basis * e;

gp_inline__location="../dragon.tex:21355";
 \\ r_nfelt is the root r as an element of cubic_nf,
 \\ so a column of length 3.  The basis in cubic_nf means this
 \\ is [0,1,0]~.  Other foo_nfelt are elements of cubic_nf for
 \\ other values.
 r_nfelt = nfeltpow(cubic_nf,'x,1);
 r_squared_nfelt = nfeltpow(cubic_nf, r_nfelt, 2);
 r_cubed_nfelt = nfeltpow(cubic_nf, r_nfelt, 3);
 one_over_r_nfelt = nfeltpow(cubic_nf, r_nfelt, -1);
 one_over_r_squared_nfelt = nfeltpow(cubic_nf, r_nfelt, -2);
 one_nfelt = nfeltmul(cubic_nf, r_nfelt, one_over_r_nfelt);

gp_inline__location="../dragon.tex:21371";
 r_polmod = Mod(x, x^3 - x^2 - 2);
 r_squared_polmod = r_polmod^2;
 r_squared_poly = modreverse(r_squared_polmod).mod;

gp_inline__location="../dragon.tex:21384";
 \\ Return an interval [lo,hi] which is root r to an accuracy
 \\ of about n bits.
 r_interval_to_bits(n) = interval_solve_bisection([1,2],cubic,n);

gp_inline__location="../dragon.tex:21393";
 r_sample = {(1695620/1000000)};

gp_inline__location="../dragon.tex:21412";
 \\ OEIS A-numbers of sequences growing as a power r^n
 OEIS_growing_as_r = {
   vecsort(['A003229, 'A003476, 'A003479, 'A052537, 'A077949,
        'A144181, 'A164395, 'A164399, 'A164410, 'A164414, 'A164471,
        'A203175, 'A227036, 'A289260
           ], cmp);
 }

gp_inline__location="../dragon.tex:21426";
 \\ g.f by Colin Barker in A289260
 gA289260(x) = {
   (1 + x)^2*(1 - x + x^2 - x^3 + x^4)
   / ((1 - x)*(1 - x - 2*x^3));
 }
 A289260(n) = gf_term(gA289260(x),n);

gp_inline__location="../dragon.tex:21452";
 r_continued_fraction = {[1,1,2,3,1,1,59,1,1,1,2,3,1,1,2,1,41]};

gp_inline__location="../dragon.tex:21487";
 cubic_r2 = 1/6*(2 - cubic_C - 1/cubic_C) \
          + sqrt(3)/6*(cubic_C - 1/cubic_C) * I;
 cubic_r2_real_interval_to_bits(n) = {
   my(t=cubic_C_interval_to_bits(n+4));
   interval_sub([2,2], t + interval_recip(t)) / 6;
 }
 cubic_r2_imag_interval_to_bits(n) = {
   my(t=cubic_C_interval_to_bits(n+4));
   t = interval_sub(t, interval_recip(t)) / 6;
   interval_mul(t, interval_solve_bisection([1,2],x->x^2-3,n));
 }

gp_inline__location="../dragon.tex:21503";
 cubic_r3 = 1/6*(2 - cubic_C - 1/cubic_C) \
          - sqrt(3)/6*(cubic_C - 1/cubic_C) * I;

gp_inline__location="../dragon.tex:21510";
 \\ polynomials in C
 cubic_r2_from_C = 1/6*(2-'C-1/'C) + sqrt3i/6*('C-1/'C);
 cubic_r3_from_C = 1/6*(2-'C-1/'C) - sqrt3i/6*('C-1/'C);

gp_inline__location="../dragon.tex:21518";
 r23_real_sample = {-(0347810/1000000)};

gp_inline__location="../dragon.tex:21523";
 r23_imag_sample = {(1028852/1000000)};

gp_inline__location="../dragon.tex:21528";
 r2_sample = r23_real_sample + r23_imag_sample*I;
 r3_sample = r23_real_sample - r23_imag_sample*I;

gp_inline__location="../dragon.tex:21554";
 cubic_D_fraction = 28/27 + sqrt(29/27);
 r_from_D = cbrt(cubic_D_fraction) + 1/(9*cbrt(cubic_D_fraction)) + 1/3;

gp_inline__location="../dragon.tex:21560";
 cubic_S = cbrt(cubic_R + sqrt(cubic_D));
 cubic_T = cbrt(cubic_R - sqrt(cubic_D));

gp_inline__location="../dragon.tex:21624";
 r23_abs_sample = {(1086052/1000000)};
 r23_abs = abs(cubic_r2);

gp_inline__location="../dragon.tex:21638";
 fractal_dimension = log(r)/log(sqrt(2));

gp_inline__location="../dragon.tex:21643";
 fractal_dimension_sample = {(1523627/1000000)};

gp_inline__location="../dragon.tex:21847";
 cubic_m = [1, 1, 1; 'r, 'r2, 'r3; 'r^2, 'r2^2, 'r3^2]^-1 * [0;0;1];
 cubic_X_from_r = cubic_m[1,1];
 cubic_Y_from_r = cubic_m[2,1];
 cubic_Z_from_r = cubic_m[3,1];

gp_inline__location="../dragon.tex:21864";
 cubic_X = 1/((r - cubic_r2)*(r - cubic_r3));

gp_inline__location="../dragon.tex:21869";
 cubic_X_from_C = 1/((r_from_C - cubic_r2_from_C)*(r_from_C - cubic_r3_from_C));

gp_inline__location="../dragon.tex:21873";
 cubic_X_sample = {(0191053/1000000)};

gp_inline__location="../dragon.tex:21882";
 cubic_Y = 1/((r - cubic_r2)*(cubic_r3 - cubic_r2));

gp_inline__location="../dragon.tex:21895";
 cubic_Y_from_C = {
   1/(
        (r_from_C - cubic_r2_from_C)
      * (cubic_r3_from_C - cubic_r2_from_C)
     );
 }

gp_inline__location="../dragon.tex:21907";
 cubic_Y_real_sample = {-(0095526/1000000)};

gp_inline__location="../dragon.tex:21914";
 cubic_Y_imag_sample = {(0189727/1000000)};

gp_inline__location="../dragon.tex:21926";
 cubic_Z = 1/((r - cubic_r3)*(cubic_r2 - cubic_r3));

gp_inline__location="../dragon.tex:22066";
 cubic_X_vector_by_matsolve = \
   matsolve([0, -2, 3;  6, 0, -2+3;  -4 +3*2, 3*2, -2 + 3]~, \
            [1,0,0]~);

gp_inline__location="../dragon.tex:22111";
 dJA_power_limit(k) = cubic_X * r^k;
 dJA_power_limit_5(k) = 0.19105 * 1.6956^k;

gp_inline__location="../dragon.tex:22125";
 mean_and_variance_of_func(n,func,start) = {
   my(mean = sum(i=0+start,n-1+start, func(i)) / n,
      variance = sum(i=0+start,n-1+start, (func(i)-mean)^2) / n);
   [mean,variance];
 }

gp_inline__location="../dragon.tex:22167";
 A144181(n) = {
   n>=0 || error("A144181() is for n>=0");
   recurrence_eval([2,0,1],[1,1,3,9],n);
 }
 gA144181(x) = (1+2*x^2+4*x^3) / (1-x-2*x^3); \\ Colin Barker

gp_inline__location="../dragon.tex:22179";
 A164410(n) = {
   n>=4 || error("A164410() is for n>=4");
   n-=4;
   recurrence_eval([2,0,1],[13, 22, 38],n);
 }
 gA164410(x) = x^4*(13+9*x+16*x^2)/(1-x-2*x^3); \\ R. J. Mathar

gp_inline__location="../dragon.tex:22192";
 A164414(n) = {
   n>=4 || error("A164414() is for n>=4");
   n-=4;
   recurrence_eval([2,0,1],[13, 22, 37],n);
 }
 gA164414(x) = -x^4*(13+9*x+15*x^2)/( -1+x+2*x^3 ); \\ R. J. Mathar

gp_inline__location="../dragon.tex:22212";
 A164399(n) = {
   n>=4 || error("A164399() is for n>=4");
   n-=4;
   recurrence_eval([-2,2,-1,2],[14, 24, 41, 70],n);
 }
 gA164399(x) = x^4*(-14+4*x-7*x^2+16*x^3) \
               / ((1-x)*(2*x^3+x-1)); \\ R. J. Mathar

gp_inline__location="../dragon.tex:22226";
 A164471(n) = {
   n>=4 || error("A164471() is for n>=4");
   n-=4;
   recurrence_eval([-2,2,-1,2],[13, 21, 35, 59],n);
 }
 gA164471(x) = -x^4*(-13+5*x-6*x^2+16*x^3)  \
               / ( (x-1)*(2*x^3+x-1) ); \\ R. J. Mathar

gp_inline__location="../dragon.tex:22263";
 L(k) = {
   k>=0 || error("L() is for k>=0");
   recurrence_eval([2,0,1],[1,2,4,8],k);
 }

gp_inline__location="../dragon.tex:22274";
 L_samples = {[1,2,4,8,12,20,36,60,100,172,292,492,836]};

gp_inline__location="../dragon.tex:22299";
 gL(x) = -1 + 2* (1 + x^2) / (1 - x - 2*x^3);

gp_inline__location="../dragon.tex:22308";
 L_recurrence(l0,l1,l2) = l2 + 2*l0;

gp_inline__location="../dragon.tex:22313";
 gL_k_plus_1(x) = (gL(x)-1)/x;  /* L[k+1], stripping first term */

gp_inline__location="../dragon.tex:22494";
 LQ_initial = {[1,1,2]};

gp_inline__location="../dragon.tex:22508";
 LQ_formula(k) = recurrence_eval([2,0,1],[1,1,2],k);
 LQ(k) = {
   k>=0 || error("LQ() is for k>=0");
   LQ_formula(k);
 }

gp_inline__location="../dragon.tex:22515";
 LQ_samples = {[1,1,2,4,6,10,18,30,50,86,146,246,418]};

gp_inline__location="../dragon.tex:22535";
 gLQ(x) = (1 + x^2) / (1 - x - 2*x^3);

gp_inline__location="../dragon.tex:22690";
 LQ1_initial = {[1,0,1,2]};

gp_inline__location="../dragon.tex:22698";
 LQ2_initial = {[0,1,0,0]};

gp_inline__location="../dragon.tex:22703";
 LQ3_initial = {[0,0,1,2]};

gp_inline__location="../dragon.tex:22712";
 LQ1=memoize((k)->if(k<=3,LQ1_initial[k+1], LQ1(k-1) + 2*LQ1(k-3)));
 LQ2=memoize((k)->if(k<=3,LQ2_initial[k+1], LQ2(k-1) + 2*LQ2(k-3)));
 LQ3=memoize((k)->if(k<=3,LQ3_initial[k+1], LQ3(k-1) + 2*LQ3(k-3)));

gp_inline__location="../dragon.tex:22719";
 LQ1_samples = {[1,0,1,2,2,4,8,12,20,36,60,100,172]};

gp_inline__location="../dragon.tex:22733";
 LQ2_samples = {[0,1,0,0,2,2,2,6,10,14,26,46,74]};

gp_inline__location="../dragon.tex:22747";
 LQ3_samples = {[0,0,1,2,2,4,8,12,20,36,60,100,172]};

gp_inline__location="../dragon.tex:22769";
 gLQ1(x) = 1/2 + 1/2*(1-x+2*x^2)/(1-x-2*x^3);

gp_inline__location="../dragon.tex:22786";
 gLQ2(x) = (x - x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:22800";
 gLQ3(x) = -1 + gLQ1(x);

gp_inline__location="../dragon.tex:23052";
 LQ1_over_LQ_limit = 2 / r^3;

gp_inline__location="../dragon.tex:23055";
 LQ1_over_LQ_limit_sample = {(0410245/1000000)};

gp_inline__location="../dragon.tex:23070";
 LQ2_over_LQ_limit = 1 - 4 / r^3;

gp_inline__location="../dragon.tex:23073";
 LQ2_over_LQ_limit_nfelt = one_nfelt - 4*nfeltpow(cubic_nf,x,-3);

gp_inline__location="../dragon.tex:23077";
 LQ2_over_LQ_limit_sample = {(0179509/1000000)};

gp_inline__location="../dragon.tex:23230";
 R_initial = {[1,2,4,8,16]};

gp_inline__location="../dragon.tex:23235";
 R_recurrence_coeffs = Vecrev([2, -1, 2, -2]);

gp_inline__location="../dragon.tex:23239";
 R(k) = recurrence_eval(R_recurrence_coeffs,R_initial,k);

gp_inline__location="../dragon.tex:23246";
 R_samples = {[1,2,4,8,16,28,48,84,144,244,416,708,1200,2036]};

gp_inline__location="../dragon.tex:23263";
 gR(x)= 1 - 2/(1-x) + 2*(1 + x + x^2)/(1-x-2*x^3);

gp_inline__location="../dragon.tex:23278";
 gR_k_plus_1(x) = (gR(x)-1)/x;  /* R[k+1], stripping first term */

gp_inline__location="../dragon.tex:23394";
 RQ_initial = {[1,2,3]};

gp_inline__location="../dragon.tex:23404";
 RQ(k) = {
   k>=0 || error("RQ() is for k>=0");
   recurrence_eval([2,0,1],RQ_initial,k);
 }

gp_inline__location="../dragon.tex:23411";
 RQ_samples = {[1,2,3,5,9,15,25,43,73,123,209,355,601]};

gp_inline__location="../dragon.tex:23422";
 A003476(n) = RQ(n-1);

gp_inline__location="../dragon.tex:23432";
 gRQ(x) = (1 + x + x^2) / (1-x-2*x^3);

gp_inline__location="../dragon.tex:23558";
 A227036(n) = B(n);

gp_inline__location="../dragon.tex:23613";
 L_from_R2_formula(k) = 2*R(k-2) + 4;
 L_from_R2(k) = if(k<3,L(k), L_from_R2_formula(k));

gp_inline__location="../dragon.tex:23712";
 L_over_R_limit = r - 1;
 L_over_R_limit_sample = {(0695620/1000000)};

gp_inline__location="../dragon.tex:23739";
 R_over_L_limit = r^2 / 2;
 R_over_L_limit_sample = {(1437564/1000000)};

gp_inline__location="../dragon.tex:23760";
 RQ1(k) = {
   k>=0 || error("RQ1() is for k>=0");
   recurrence_eval([-2,2,-1,2],[1,2,2,3,5],k);
 }

gp_inline__location="../dragon.tex:23768";
 RQ1_by_RQ_initial = {[1,2,2]};

gp_inline__location="../dragon.tex:23799";
 RQ1_samples = {[1,2,2,3,5,7,11,19,31,51,87,147]};

gp_inline__location="../dragon.tex:23809";
 RQ2(k) = sum(j=0,k-1, LQ2(j));
 RQ2 = memoize(RQ2);

gp_inline__location="../dragon.tex:23818";
 RQ2_samples = {[0,0,1,1,1,3,5,7,13,23,37,63]};

gp_inline__location="../dragon.tex:23841";
 RQ3(k) = sum(j=0,k-1, LQ3(j));
 RQ3 = memoize(RQ3);

gp_inline__location="../dragon.tex:23856";
 RQ3_samples = {[0,0,0,1,3,5,9,17,29,49,85,145]};

gp_inline__location="../dragon.tex:23867";
 gRQ1(x) = (1+x)*(1-x-x^3) / (1-x) / (1-x-2*x^3);

gp_inline__location="../dragon.tex:23877";
 gRQ2(x) = x^2/(1-x-2*x^3);

gp_inline__location="../dragon.tex:23884";
 gRQ3(x) = (1+x)*x^3 / (1-x) / (1-x-2*x^3);

gp_inline__location="../dragon.tex:23936";
 RQsides_initial = {[1,1,2]};

gp_inline__location="../dragon.tex:23965";
 \\ Return k where RQ(k-1) <= m < RQ(k)
 RQsides_k(m) = {
   m>=0 || error("RQsides_k() is for m>=0, got "m);
   my(k=3);
   while(! (m < RQ(k)), k++);
   k;
 }

gp_inline__location="../dragon.tex:23989";
 RQsides(m) = {
   my(debug=0);
   m>=0 || error("RQsides() is for m>=0, got "m);
   if(m<#RQsides_initial, return(RQsides_initial[m+1]));
   my(k=RQsides_k(m));
   if(debug, print("m="m" k="k));
   if(debug, print("  decrease m="m-RQ(k-1)" RQ(k-3) = "RQ(k-3)));
   if(m - RQ(k-1) < RQ(k-3),
      RQsides(m - RQ(k-1));
      ,
      if(debug, print("  reverse"));
      4 - RQsides(RQ(k)-1 - m));
 }

gp_inline__location="../dragon.tex:24008";
 RQsides_samples = {[1,1,2,1,3,1,1,3,3,1,1,2,2,3,3,1,1,2,1,3]};

gp_inline__location="../dragon.tex:24067";
 RQsides_vector_by_morphism(k) = {
   my(v=[1]);
   for(i=1,k,
     my(l=List([]));
     for(j=1,#v,
       if(v[j]==1 && j<#v && v[j+1]==1,  listput(l,[1,1,2]);j++,
          v[j]==1,                       listput(l,[1,1]),
          v[j]==2,                       listput(l,[1,3]),
          v[j]==3 && j<#v && v[j+1]==3,  listput(l,[2,3,3]);j++,
          v[j]==3,                       listput(l,[3,3]),
          error("oops ",v[j])));
     v=concat(Vec(l)));
   v;
 }

gp_inline__location="../dragon.tex:24099";
 B(k) = k>=0 || error("B() is for k>=0"); R(k+1);

gp_inline__location="../dragon.tex:24102";
 B_samples = {[2,4,8,16,28,48,84,144,244,416,708,1200]};

gp_inline__location="../dragon.tex:24117";
 gB(x) = (gR(x) - 1)/x;
 gB_k_plus_1(x) = (gB(x)-B(0))/x;  /* B[k+1], stripping first term */

gp_inline__location="../dragon.tex:24167";
 BQ(k) = {
   k>=0 || error("BQ() is for k>=0");
   RQ(k+1);
 }

gp_inline__location="../dragon.tex:24172";
 BQ_samples = {[2,3,5,9,15,25,43,73,123,209,355,601]};

gp_inline__location="../dragon.tex:24193";
 gBQ(x) = (2 + x + 2*x^2) / (1-x-2*x^3);

gp_inline__location="../dragon.tex:24202";
 BQ1(k) = {
   k>=0 || error("BQ1() is for k>=0, got",k);
   RQ1(k+1);
 }

gp_inline__location="../dragon.tex:24216";
 BQ2(k) = {
   k>=0 || error("BQ2() is for k>=0, got",k);
   RQ2(k+1);
 }

gp_inline__location="../dragon.tex:24229";
 BQ3(k) = {
   k>=0 || error("BQ3() is for k>=0, got",k);
   RQ3(k+1);
 }

gp_inline__location="../dragon.tex:24241";
 gBQ1(x) = 1/(1-x) * gLQ1(x)  + 1/(1-x);
 gBQ2(x) = 1/(1-x) * gLQ2(x);
 gBQ3(x) = 1/(1-x) * gLQ3(x);

gp_inline__location="../dragon.tex:24264";
 R_over_B_limit = 1 / r;
 R_over_B_limit_nfelt = one_over_r_nfelt;

gp_inline__location="../dragon.tex:24269";
 R_over_B_limit_sample = {(0589754/1000000)};

gp_inline__location="../dragon.tex:24283";
 RQ_from_BQ(k) = if(k<3,RQ(k), BQ(k-1));

gp_inline__location="../dragon.tex:24294";
 L_from_B(k) = if(k<3,L(k), 2*B(k-3) + 4);

gp_inline__location="../dragon.tex:24298";
 L_over_B_limit = 2 / r^3;
 L_over_B_limit_nfelt = 2 * nfeltpow(cubic_nf,r_nfelt,-3);

gp_inline__location="../dragon.tex:24304";
 L_over_B_limit_sample = {(0410245/1000000)};

gp_inline__location="../dragon.tex:24319";
 LQ_from_BQ(k) = if(k<3,LQ(k), 2*BQ(k-3));

gp_inline__location="../dragon.tex:24378";
 RQ_type_1e = 1;
 RQ_type_1o = 2;
 RQ_type_2  = 3;
 RQ_type_3e = 4;
 RQ_type_3o = 5;
 RQ_type_sides_vector = [1,1,2,3,3];
 RQ_type_name_vector = ["1e","1o","2","3e","3o"];
 RQ_type_name(t) = RQ_type_name_vector[t];
 RQ_type_name_LRT_vector = ['R,'L,'T,'L,'R];
 RQ_type_name_LRT(t) = RQ_type_name_LRT_vector[t];
 RQ_type_expand_vector = {[
   [RQ_type_1e,RQ_type_1o],   \\ 1e
   [RQ_type_2],               \\ 1o
   [RQ_type_1e,RQ_type_3o],   \\ 2
   [RQ_type_2],               \\ 3e
   [RQ_type_3e,RQ_type_3o]    \\ 3o
 ]};
 RQ_type_list_start = [RQ_type_1e];
 RQ_type_list_expand(v,reps=1) = {
   for(i=1,reps,
     v=concat(vecextract(RQ_type_expand_vector,v)));
   v;
 }

gp_inline__location="../dragon.tex:24402";
 \\ Return a vector of the right boundary square types in curve k,
 \\ in order from curve start to end.  Vector length is RQ(k).
 RQ_type_list(k) = RQ_type_list_expand(RQ_type_list_start,k);

gp_inline__location="../dragon.tex:24514";
 RQ1e(k) = {
   k>=0 || error("RQ1e() is for k>=0, got",k);
   1 + sum(j=0,k-1, RQ2(j));
 }
 RQ1e = memoize(RQ1e);

gp_inline__location="../dragon.tex:24522";
 RQ1o(k) = {
   k>=0 || error("RQ1o() is for k>=0, got",k);
   if(k==0,0, RQ1e(k-1));
 }
 gRQ1o(x) = x/2/(1-x) + x/2/(1-x-2*x^3);

gp_inline__location="../dragon.tex:24532";
 RQ3o(k) = {
   k>=0 || error("RQ3o() is for k>=0, got",k);
   sum(j=0,k-1, RQ2(j));
 }
 RQ3o = memoize(RQ3o);

gp_inline__location="../dragon.tex:24540";
 RQ3e(k) = {
   k>=0 || error("RQ3e() is for k>=0, got",k);
   if(k==0,0, RQ3o(k-1));
 }
 gRQ3e(x) = -x/2/(1-x) + x/2/(1-x-2*x^3);

gp_inline__location="../dragon.tex:24607";
 RQ1e_samples = {[1,1,1,2,3,4,7,12,19,32,55,92]};

gp_inline__location="../dragon.tex:24629";
 RQ3o_samples = {[0,0,0,1,2,3,6,11,18,31,54,91]};

gp_inline__location="../dragon.tex:24650";
 gRQ1e(x) = 1/2*(  1/(1-x) + 1/(1-x-2*x^3)  );

gp_inline__location="../dragon.tex:24657";
 gRQ3o(x) = 1/2*(  -1/(1-x) + 1/(1-x-2*x^3)  );

gp_inline__location="../dragon.tex:24708";
 BQ1e(k) = {
   k>=0 || error("BQ1e() is for k>=0, got",k);
   RQ1e(k+1);
 }

gp_inline__location="../dragon.tex:24715";
 BQ3e(k) = {
   k>=0 || error("BQ3e() is for k>=0, got",k);
   RQ3e(k+1);
 }

gp_inline__location="../dragon.tex:24721";
 BQ1o(k) = {
   k>=0 || error("BQ1o() is for k>=0, got",k);
   RQ1o(k+1);
 }

gp_inline__location="../dragon.tex:24729";
 BQ3o(k) = {
   k>=0 || error("BQ3o() is for k>=0, got",k);
   RQ3o(k+1);
 }

gp_inline__location="../dragon.tex:24734";
 gBQ3o(x) = x^2/((1-x)*(1-x-2*x^3));

gp_inline__location="../dragon.tex:24738";
 gBQ3e(x) = gRQ3o(x);

gp_inline__location="../dragon.tex:24750";
 RQ_type_vpar(rows) = {
   my(debug=0);
   if(rows==0,return([]));
   my(type_list=RQ_type_list(0),
      len=sum(k=0,rows-1,RQ(k)),
      vpar=vector(len),
      v_to_type=List([RQ_type_1e]));
   if(debug, print("len="len));
   for(v=1,#vpar,
     if(debug, print("v="v" upto="upto));
     if(#v_to_type>=len, break);
     my(child_types=RQ_type_expand_vector[v_to_type[v]]);
     for(i=1,#child_types,
       listput(v_to_type,child_types[i]);
       vpar[#v_to_type]=v));
   vpar;
 }

gp_inline__location="../dragon.tex:25006";
 \\ n is a boundary segment number of curve k.
 \\ Return the next segment number, or 'none if no more.
 Lnext_k(k,n) = {
   my(an=dragon_n_to_arm_and_other(n+1), t=turn(n+1),
      limit=2^k);
   if(t==-1 && an[1]==0 && an[2]<limit, an[2],
      n+1<limit, n+1,
      'none);
 }

gp_inline__location="../dragon.tex:25021";
 \\ Return a vector of the centre location z of each
 \\ left boundary square of curve k.
 LQZ_list(k) = {
   my(v=vector(LQ(k)), n=0, upto=0, prev_z='none);
   for(i=1,L(k),
      n!='none || error("LQZ_list() oops, n="n);
      my(z = zdir_to_left_centre(dragon_point(n),dir(n)));
      if(z!=prev_z, v[upto++]=z; prev_z=z);
      n=Lnext_k(k,n));
   n=='none || error("LQZ_list() oops, end n="n);
   v;
 }

gp_inline__location="../dragon.tex:25041";
 \\ Return a vector of the centre location z of each
 \\ right boundary square of curve k.
 RQZ_list(k) = {
   my(v=[1/2-1/2*I]);
   for(k=1,k,
     my(end=b^k);
     v=concat(v, apply(z->end-I*z, Vecrev(LQZ_list(k-1)))));
   v;
 }

gp_inline__location="../dragon.tex:25055";
 RQhalf_by_RQZ_list(k) = vector_middle(RQZ_list(k));

gp_inline__location="../dragon.tex:25058";
 \\ Return a vector of the centre of each boundary square,
 \\ in sequence first right same as RQZ_list() and then the
 \\ left squares continuing around anti-clockwise.
 BQZ_list(k) = concat(RQZ_list(k), Vecrev(LQZ_list(k)));

gp_inline__location="../dragon.tex:25065";
 BQhalf_by_BQZ_list(k) = vector_middle(BQZ_list(k));

gp_inline__location="../dragon.tex:25111";
 fRQhalf = {(3)/(10)-(4)/(10)*I};

gp_inline__location="../dragon.tex:25117";
 RQhalf_offset = {(3)/(10)+(1)/(10)*I};

gp_inline__location="../dragon.tex:25127";
 RQhalf_formula(k) = fRQhalf*b^k - RQhalf_offset*(-1)^k;
 RQhalf(k) = {
   k>=0 || error("RQhalf() is for k>=0");
   if(k==0, 1/2-1/2*I,
      k==2, 3/2 + 1/2*I,
      RQhalf_formula(k));
 }

gp_inline__location="../dragon.tex:25145";
 RQhalf_samples = {[1/2-1/2*I,1,3/2+1/2*I,1/2+3/2*I,-3/2+3/2*I,-5/2+1/2*I]};

gp_inline__location="../dragon.tex:25237";
 \\ t is RQ_type_1e etc value.
 \\ Return symbol 'R or 'L or 'T.
 RQ_type_to_RLT(t) = {
   [ 'R,    \\ 1e
     'L,    \\ 1o
     'T,    \\ 2
     'L,    \\ 3e
     'R ]   \\ 3o
   [t];
 }
 \\ v is a vector of symbols 'R or 'L or 'T.
 \\ Return expanded symbols likewise 'R,'L,'T.
 \\ RQt is RQ_type_1e or RQ_type_1o.
 \\ Each 'R in v expands R,L or L,R according to RQt.
 RLT_list_expand(v, RQt) = {
   concat(apply(t->if(t=='R, if(RQt==RQ_type_1e,['R,'L],
                                RQt==RQ_type_3o,['L,'R],
                                error("unrecognised RQt")),
                      t=='L, ['T],
                      t=='T, ['R,'R],
                      error("unknown RLT type: "t)),
                v));
 }

gp_inline__location="../dragon.tex:25501";
 BQhalf(k) = RQhalf(k+1);

gp_inline__location="../dragon.tex:25507";
 fBQhalf = b*fRQhalf;

gp_inline__location="../dragon.tex:25655";
 fRQhalfNS = {(9)/(28)};

gp_inline__location="../dragon.tex:25666";
 RQhalfNS_formula(k) = \
   fRQhalfNS*2^k - 1/7*vector_modulo([4,1,2],k);
 RQhalfNS(k) = {
   k>=0 || error("RQhalfNS() is for k>=0");
   if(k==0,0, k==1,1, RQhalfNS_formula(k));
 }

gp_inline__location="../dragon.tex:25681";
 RQhalfNS_samples = {[0,1,1,2,5,10,20,41,82,164]};

gp_inline__location="../dragon.tex:25704";
 fRQhalfNE = {(11)/(28)};

gp_inline__location="../dragon.tex:25714";
 RQhalfNE_formula(k) = \
   fRQhalfNE*2^k + vector_modulo([6/7, 12/7, 3/7],k);
 RQhalfNE(k) = {
   k>=0 || error("RQhalfNE() is for k>=0");
   if(k<=1,1, RQhalfNE_formula(k));
 }

gp_inline__location="../dragon.tex:25728";
 RQhalfNE_samples = {[1,1,2,4,8,13,26,52,101,202]};

gp_inline__location="../dragon.tex:25788";
 Rpred_at_samples = concat([ [0..20], \
                             [25..41], \
                             [50,51,52] ]);

gp_inline__location="../dragon.tex:25800";
 Rpred_non_at_samples = concat([ [21..24], \
                                 [42..49], \
                                 [53..56] ]);

gp_inline__location="../dragon.tex:25818";
 Rpred_locate_lowest_triplet(v) = {
   my(pos=0);
   for(i=1,#v-2,
       if(v[i]==0 && v[i+1]==0 && v[i+2]==0, pos=i);
       if(v[i]==1 && v[i+1]==0 && v[i+2]==1, pos=i);
       if(v[i]==1 && v[i+1]==1 && v[i+2]==0, pos=i);
       if(v[i]==1 && v[i+1]==1 && v[i+2]==1, pos=i));
   pos;
 }
 Rpred_by_fields(n) = {
   my(v = binary(n),
      i = Rpred_locate_lowest_triplet(v));
   while(i>=1,
         my(bit=v[i]); i--;
         while(i>=1 && v[i]==bit, i--); \\ run of "bit"
         i--;   \\ terminating bit
         if(i<1,return(1));
         if(v[i]==1,return(0));
         i--);
   1;
 }

gp_inline__location="../dragon.tex:25930";
 Rpred_1e = 1;
 Rpred_1o = 2;
 Rpred_2eA = 3;
 Rpred_2eB = 4;
 Rpred_3oA = 5;
 Rpred_3oB = 6;
 Rpred_3oC = 7;
 Rpred_3eA = 8;
 Rpred_3eB = 9;
 Rpred_3eC = 10;
 Rpred_non = 11;
 Rpred_state_table = {[  1, 2;     \\  1  1e
                         3, 4;     \\  2  1o
                         1, 5;     \\  3  2eA
                         6, 7;     \\  4  2eB
                         8, 9;     \\  5  3oA
                        10, 5;     \\  6  3oB
                         6, 7;     \\  7  3oC
                         3,11;     \\  8  3eA
                        11,11;     \\  9  3eB
                        11, 4;     \\ 10  3eC
                        11,11 ]};  \\ 11  non
 Rpred_state_to_name = {["1e","1o","2eA","2eB","3oA","3oB","3oC",
   "3eA","3eB","3eC","non"]};
 Rpred_state_to_sides = {[1,1,2,2,3,3,3,3,3,3,4]};

gp_inline__location="../dragon.tex:25960";
 \\ state is 1 to 11.  bit is 0 or 1.  Return new state.
 Rpred_transition(state,bit) = Rpred_state_table[state,bit+1];

gp_inline__location="../dragon.tex:25963";
 \\ state is 1 to 11.  v is a vector of bits 0 or 1.
 \\ Return new state.
 Rpred_transitions(state,v) = {
   for(i=1,#v, state=Rpred_transition(state,v[i]));
   state;
 }

gp_inline__location="../dragon.tex:25970";
 \\ v is a vector of bits of n, high to low.
 \\ Return the state after those bits.
 Rpred_state_of_vector(v) = Rpred_transitions(Rpred_1e,v);

gp_inline__location="../dragon.tex:25974";
 \\ v is a vector of bits of n, high to low.  Return Rpred(n).
 Rpred_of_vector(v) = Rpred_state_of_vector(v)!=Rpred_non;

gp_inline__location="../dragon.tex:25977";
 Rpred_state(n) = Rpred_state_of_vector(binary(n));

gp_inline__location="../dragon.tex:25979";
 \\ Return 1 if right boundary segment, return 0 if not.
 Rpred(n) = Rpred_state(n) != Rpred_non;

gp_inline__location="../dragon.tex:26234";
 gNonR(x) = 1/(1-2*x) - gR(x);

gp_inline__location="../dragon.tex:26364";
 Rpred_LtoH_state_table = {[ 2,3;    /* rm0, in 1-based indexes */
                             4,5;    /* rm1 */
                             6,5;    /* rm2 */
                             7,5;    /* rm3 */
                             6,8;    /* rm4 */
                             4,8;    /* rm5 */
                             7,9;    /* rm6 */
                             9,8;    /* rm7 */
                             10,11;  /* rm8 */
                             7,8;    /* rm9 */
                             11,11 ]}; /* non10 */
 Rpred_LtoH_transition(state,bit) \
   = Rpred_LtoH_state_table[state+1,bit+1] - 1;
 Rpred_LtoH_low_to_high(n) = {
   my(v=Vecrev(binary(n)),state=0);
   for(i=1,#v, state=Rpred_LtoH_transition(state,v[i]));
   state;
 }
 Rpred_by_low_to_high(n) = Rpred_LtoH_low_to_high(n)!=10;

gp_inline__location="../dragon.tex:26669";
 Rnon(k) = 2^k - R(k);
 Rnon_by_binomial(k) = {
   sum(l=5,k,
       2^(k-l)*sum(t=1,k,if(l-2>=3*t,
                   2^(t+1)*binomial(l-2-2*t,t))));
 }

gp_inline__location="../dragon.tex:26732";
 TwoRuns(l) = \
   sum(t=1,l, if(l-2-2*t>=t, 2^(t+1)*binomial(l-2-2*t,t)));

gp_inline__location="../dragon.tex:26739";
 TwoRuns_samples = {[0,0,0,0,0,4,8,12,24,44,72,124,216]};

gp_inline__location="../dragon.tex:26765";
 TwoRuns_from_OneRuns(l) = sum(h=2,l, if(l-h>=3, 2*OneRuns(l-h)));

gp_inline__location="../dragon.tex:26782";
 OneRuns(m) = sum(t=0,m, if(m-3-2*t>=t, 2^(t+1)*binomial(m-3-2*t,t)));

gp_inline__location="../dragon.tex:26787";
 OneRuns_samples = {[0,0,0,2,2,2,6,10,14,26,46,74,126,218,366,618]};

gp_inline__location="../dragon.tex:26903";
 Rsides(n) = Rpred_state_to_sides[Rpred_state(n)];

gp_inline__location="../dragon.tex:26910";
 Rsides_samples = {[1,1,2,2,1,3,3,3,1,1,3,3,3,3,3,3,1,1,2,2,2,4]};

gp_inline__location="../dragon.tex:26955";
 check_runs_0_lengths(f,limit) = {
   my(previous=1,run=0);
   for(i=0,limit,
       my(this=f(i));
       if(this==0,
          if(previous==0,run++,run=1),
          if(previous==0,if(run%4!=0,
               print("run="run" at i="i);
               return(0))));
       previous==this);
   1;
 }

gp_inline__location="../dragon.tex:26980";
 Rnext(n) = {
   my(an=dragon_n_to_arm_and_other(n+1), t=turn(n+1));
   if(t==1 && an[1]==0, an[2], n+1);
 }

gp_inline__location="../dragon.tex:27073";
 Rprev(n) = {
   my(an=dragon_n_to_arm_and_other(n), t=turn(n));
   if(t==1 && an[1]==0, an[2]-1, n-1);
 }

gp_inline__location="../dragon.tex:27093";
 Rturn_vector_by_RQsides(k) = {
   my(v=vector(RQ(k),m,m--;
               vector(RQsides(m)-1,i, -1)));
   for(i=1,#v-1, v[i]=concat(v[i],[1]));
   concat(v);
 }

gp_inline__location="../dragon.tex:27123";
 Rturn(m) = {
   \\ print("Rturn() m="m);
   m>=1 || error("Rturn() is for m>=1, got ",m);
   if(m<=2, return(1));
   my(k=Rturn_k(m));
   if(m < RJ(k),  Rturn(m - R(k)),
      m == RJ(k), -1,
                      Rturn(m - L(k)));
 }

gp_inline__location="../dragon.tex:27144";
 Rturn_k(m) = my(k=0); while(m>R(k+1), k++); k;

gp_inline__location="../dragon.tex:27167";
 RJ(k) = 1/2*R(k+2) - ceil(2/3*k);

gp_inline__location="../dragon.tex:27178";
 RJ_samples = {[2,3,6,12,21,38,68,117,202,348]};

gp_inline__location="../dragon.tex:27197";
 gRJ(x) = {
   -2/3*(2-x)/(1 - x)^2
   + (1/3 + 1/3*x)/(1 + x + x^2)
   + (3 + 2*x + 4*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:27295";
 R2eA(k) = if(k==0,1, R(k-1) + R3oA(k-1));

gp_inline__location="../dragon.tex:27301";
 R3oA(k) = if(k==0,1, R3eA(k-1) +  R3eB(k-1));

gp_inline__location="../dragon.tex:27309";
 R3eA(k) = if(k==0,1, R2eA(k-1));

gp_inline__location="../dragon.tex:27317";
 R3eB(k) = if(k==0,1, 0);

gp_inline__location="../dragon.tex:27321";
 R2eA_samples = {[1,2,4,5,10,20,33,58,104,177]};

gp_inline__location="../dragon.tex:27331";
 R3oA_samples = {[1,2,1,2,4,5,10,20,33,58]};

gp_inline__location="../dragon.tex:27339";
 R3eA_samples = {[1,1,2,4,5,10,20,33,58,104]};

gp_inline__location="../dragon.tex:27353";
 gR2eA(x) = {
   2/3/(1 - x)
   - 2/3/(1 - x)^2
   - 1/3*x/(1 + x + x^2)
   + (1 + 2*x + 2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:27555";
 Rn(m) = {
   m>=0 || error("Rn() is for m>=1, got ",m);
   if(m<=1, return(m));
   my(k=Rturn_k(m));
   if(m < RJ(k), 2^k + Rn(m - R(k)),
                 2^k + Rn(m - L(k)));
 }

gp_inline__location="../dragon.tex:27579";
 Rn_samples = concat([ [0..20], \
                       [25..41], \
                       [50,51,52] ]);

gp_inline__location="../dragon.tex:27791";
 Lpred_k(k,n) = {
   if(n>2^k, error("Lpred_k() n=",n," bigger than 2^",k));
   Rpred(2^(k+1)-1-n);
 }
 Lpred_of_vector(v) = \
   Rpred_of_vector(concat(1,apply(bit->1-bit,v)));

gp_inline__location="../dragon.tex:27882";
 Lpred_k_above_n(n) = length(binary(n));
 LpredInf(n) = my(k=Lpred_k_above_n(n)); Rpred(2^(k+2)-1-n);

gp_inline__location="../dragon.tex:27896";
 LpredInf_one_at_samples = concat([[0..6],[11..13],[22..27],[44..54]]);

gp_inline__location="../dragon.tex:27910";
 LpredInf_zero_at_samples = concat([[7..10],[14..21],[28..43],[55..90]]);

gp_inline__location="../dragon.tex:27954";
 LpredAny(n) = my(k=Lpred_k_above_n(n)); Lpred_k(k,n);

gp_inline__location="../dragon.tex:27966";
 LpredAny_one_at_samples = concat([[0..7],[11..15],[22..31],[44..63]]);

gp_inline__location="../dragon.tex:27979";
 LpredAny_zero_at_samples = concat([[8..10],[16..21],[32..43],[64..90]]);

gp_inline__location="../dragon.tex:27997";
 Lsides_k(k,n) = Rsides(2^(k+1) - 1 - n);

gp_inline__location="../dragon.tex:28006";
 Lsides_0_samples = {[1]};

gp_inline__location="../dragon.tex:28015";
 Lsides_1_samples = {[2,2]};

gp_inline__location="../dragon.tex:28024";
 Lsides_2_samples = {[3,3,3,1]};

gp_inline__location="../dragon.tex:28033";
 Lsides_3_samples = {[3,3,3,3,3,3,1,1]};

gp_inline__location="../dragon.tex:28045";
 LsidesInf(n) = {
   my(k=0);
   while(! (n<2^k), k++);
   Lsides_k(k+2, n);
 }

gp_inline__location="../dragon.tex:28054";
 Lsides_samples = {[3,3,3,3,3,3,2,4,4,4,4,2,3,3,4,4,4,4,4,4,4,4,3,1]};

gp_inline__location="../dragon.tex:28064";
 \\ Return a vector of the right boundary square types in curve k,
 \\ in order from curve start to end.  Vector length is RQ(k).
 LQ_k_type_list(k) = {
   my(v=RQ_type_list(k+1));
   Vecrev(v[RQ(k)+1..#v]);
 }

gp_inline__location="../dragon.tex:28080";
 LQsides_k(k,m) = {
   my(debug=0);
   k>=0 || error("LQsides_k() is for k>=0, got "m);
   m>=0 || error("LQsides_k() is for m>=0, got "m);
   m<LQ(k) || error("LQsides_k() is for m<LQ(k)");
   RQsides(RQ(k+1)-1 - m);
 }

gp_inline__location="../dragon.tex:28096";
 LQsides_0_samples = {[1]};

gp_inline__location="../dragon.tex:28106";
 LQsides_1_samples = {[2]};

gp_inline__location="../dragon.tex:28116";
 LQsides_2_samples = {[3,1]};

gp_inline__location="../dragon.tex:28126";
 LQsides_3_samples = {[3,3,1,1]};

gp_inline__location="../dragon.tex:28140";
 LQsidesInf(m) = {
   my(k=0);
   while(! (m < LQ(k)), k++);
   LQsides_k(k+2,m);
 }

gp_inline__location="../dragon.tex:28148";
 LQsidesInf_samples = {[3,3,2,3,1,3,3,1,1,3,3,2,2,1,1,3,3,2,3,1,3]};

gp_inline__location="../dragon.tex:28174";
 LnextInf(n) = {
   my(an=dragon_n_to_arm_and_other(n+1), t=turn(n+1));
   if(t==-1 && an[1]==0, an[2], n+1);
 }

gp_inline__location="../dragon.tex:28193";
 \\ Lnext_k() definition earlier for LQZ_list() locations.

gp_inline__location="../dragon.tex:28215";
 Lprev(n) = {
   my(an=dragon_n_to_arm_and_other(n), t=turn(n));
   if(t==-1 && an[1]==0 && an[2]<n, an[2]-1, n-1);
 }

gp_inline__location="../dragon.tex:28410";
 A(k) = 2^(k-1) - 1/4 * B(k);

gp_inline__location="../dragon.tex:28415";
 A_initial = {[0,0,0,0,1]};

gp_inline__location="../dragon.tex:28424";
 A_recurrence_terms = [4,-5,4,-6,4];
 A_recurrence_maker(f) = \
   (k)-> sum(i=1,#A_recurrence_terms, \
           A_recurrence_terms[i] * f(k-i));
 A_by_recurrence_formula = A_recurrence_maker(A);
 A_by_recurrence(k) = if(k<#A_initial, A_initial[k+1], \
   A_by_recurrence_formula(k));

gp_inline__location="../dragon.tex:28433";
 A_samples = {[0,0,0,0,1,4,11,28,67,152,335,724,1539]};

gp_inline__location="../dragon.tex:28451";
 gA(x)=x^4 / ((1-x)*(1-2*x)*(1 - x - 2*x^3));

gp_inline__location="../dragon.tex:28472";
 gA_k_plus_1(x) = gA(x)/x;  /* A[k+1] skipping first term */

gp_inline__location="../dragon.tex:28667";
 AR(k) = if(k==0,0, A(k-1));

gp_inline__location="../dragon.tex:28669";
 AR_samples = {[0,0,0,0,0,1,4,11,28,67,152,335,724]};

gp_inline__location="../dragon.tex:28681";
 gAR(x) = x*gA(x);

gp_inline__location="../dragon.tex:28701";
 AL(k) = if(k==0,0, A(k) - A(k-1));

gp_inline__location="../dragon.tex:28710";
 AL_samples = {[0,0,0,0,1,3,7,17,39,85,183,389,815]};

gp_inline__location="../dragon.tex:28720";
 A003478(n) = {
   n>=0 || error("A003478() is for n>=0");  \\ OFFSET=0
   2^(n+2) - 1/2*recurrence_eval([2,0,1],[1,2,4],n+3);
 }

gp_inline__location="../dragon.tex:28733";
 gAL(x)=x^4 / ((1 - x - 2*x^3)*(1-2*x));

gp_inline__location="../dragon.tex:28831";
 A_by_AL_cumulative(k) = sum(j=0,k,AL(j));

gp_inline__location="../dragon.tex:28863";
 A3left(k) = if(k<4,0, 2^(k-4));

gp_inline__location="../dragon.tex:28868";
 A3right(k) = if(k<4,0, 2^(k-4) - 1);

gp_inline__location="../dragon.tex:28870";
 Turn1left(k)  = if(k==1,1, k<4,0,      2^(k-4));
 Turn1right(k) = if(k<2,0,  k<4,1,      2^(k-4));
 Turn2left(k)  = if(k<2,0, k<4,2^(k-2), 2^(k-3));
 Turn2right(k) = if(k<3,0, k==3,1,      2^(k-3) + 1);

gp_inline__location="../dragon.tex:28879";
 \\ Look for runs of "value" within the turn() sequence.
 \\ Return vector [c1,c2,c3] counts of how many runs of length
 \\ 1,2,3 occur between n=1 to n=2^k-1 inclusive.
 turn_count_runs(k,value) = {
   my(prev=0, len=0, runs=[0,0,0]);
   for(n=1,2^k-1,
       my(t = turn(n));
       if(prev==value && t==value, len++,        \\ continue run
          prev==value && t!=value, runs[len]++,  \\ end run
          prev!=value && t==value, len=1);       \\ start run
       prev=t);
   if(prev==value, runs[len]++);
   runs;
 }

gp_inline__location="../dragon.tex:28903";
 Turn3Lpred(n) = TurnLpred(n) && TurnLpred(n+1) && TurnLpred(n+2);
 Turn3Rpred(n) = TurnRpred(n) && TurnRpred(n+1) && TurnRpred(n+2);

gp_inline__location="../dragon.tex:28910";
 Turn3Left_samples = {[8,16,32,40,64,72,80,104]};

gp_inline__location="../dragon.tex:28926";
 Turn3Right_samples = {[22,46,54,86,94,110,118,150]};

gp_inline__location="../dragon.tex:28936";
 A106838(n) = 8*TurnRight(n-1)-2;

gp_inline__location="../dragon.tex:29200";
 A3left_over_AL_limit = 1/4;

gp_inline__location="../dragon.tex:29206";
 A3right_over_AR_limit = 1/4;

gp_inline__location="../dragon.tex:29218";
 TurnRuns3pairs_LLLRRR(k) = {
   my(v=vector(2^k-1,n, turn(n)));
   sum(i=1,#v-5,
       v[i]  ==1  && v[i+1]==1  && v[i+2]==1 &&
       v[i+3]==-1 && v[i+4]==-1 && v[i+5]==-1);
 }

gp_inline__location="../dragon.tex:29227";
 TurnRuns3pairs_RRRLLL(k) = {
   my(v=vector(2^k-1,n, turn(n)));
   sum(i=1,#v-5,
       v[i]  ==-1 && v[i+1]==-1 && v[i+2]==-1 &&
       v[i+3]==1  && v[i+4]==1  && v[i+5]==1);
 }

gp_inline__location="../dragon.tex:29244";
 Turn2onlyLpred(n) = {
      ! TurnLpred(n-1)
   && TurnLpred(n) && TurnLpred(n+1)
   && ! TurnLpred(n+2);
 }

gp_inline__location="../dragon.tex:29261";
 Turn2onlyRpred(n) = {
      ! TurnRpred(n-1)
   && TurnRpred(n) && TurnRpred(n+1)
   && ! TurnRpred(n+2);
 }

gp_inline__location="../dragon.tex:29366";
 JA(k) = {
   k>=0 || error("JA() for k>=0");
   A(k+1) - 2*A(k);
 }

gp_inline__location="../dragon.tex:29388";
 JA_samples = {[0,0,0,1,2,3,6,11,18,31,54,91,154,263,446]};

gp_inline__location="../dragon.tex:29407";
 gJA(x) = x^3 / ((1 - x - 2*x^3)*(1-x));
 gAL_k_plus_1(x) = gAL(x)/x; /* AL[k+1] skipping first term */

gp_inline__location="../dragon.tex:29491";
 A_from_JA_sum(k) = sum(j=0,k-1, 2^(k-1-j) * JA(j));

gp_inline__location="../dragon.tex:29511";
 AL_from_JA_sum(k) = JA(k-1) + sum(j=0,k-2, 2^(k-2-j) * JA(j));

gp_inline__location="../dragon.tex:29546";
 \\ RQ_threes() is sum RQ(k) + RQ(k-3) + ...
 RQ_threes(k) = my(total=0); forstep(i=k,0,-3, total+=RQ(i)); total;
 gRQ_threes(x) = -1/2*1/(1 - x) + (3/2 + x + x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:29892";
 RQ_k_sub_3_over_JA_limit = 1 - 1/r^3;
 RQ_k_sub_3_over_JA_limit_sample = {(0794877/1000000)};

gp_inline__location="../dragon.tex:29913";
 JA_RQ_rest_over_JA_limit = 1/r^3;
 JA_RQ_rest_over_JA_limit_sample = {(0205122/1000000)};

gp_inline__location="../dragon.tex:30010";
 JN(k) = 1/7 * ( 6*2^k + 2^(k%3) );

gp_inline__location="../dragon.tex:30013";
 JN_by_ceil(k) = ceil(6/7*2^k);

gp_inline__location="../dragon.tex:30019";
 JN_samples = {[1,2,4,7,14,28,55,110,220,439,878]};

gp_inline__location="../dragon.tex:30028";
 A057744(n) = JN(n);

gp_inline__location="../dragon.tex:30069";
 JNother(k) = 1/7 * ( 10*2^k - 3*2^(k%3) );

gp_inline__location="../dragon.tex:30073";
 JNother_samples = {[1,2,4,11,22,44,91,182,364,731,1462]};

gp_inline__location="../dragon.tex:30105";
 JND(k) = {
   k>=0 || error("JND() is for k>=0");
   1/7 * ( 2^k - 2^(k%3) );
 }

gp_inline__location="../dragon.tex:30116";
 JND_samples = {[0,0,0,1,2,4,9,18,36,73,146,292]};

gp_inline__location="../dragon.tex:30178";
 \\ Return sum 2^k + 2^(k-3) + ...
 pow2_threes(k) = my(total=0); forstep(i=k,0,-3, total+=2^i); total;
 pow2_threes_by_power(k) = 1/7*(8*2^k - vector_modulo([1,2,4],k));

gp_inline__location="../dragon.tex:30236";
 JN_limit = {3/7};

gp_inline__location="../dragon.tex:30243";
 JNother_limit = {5/7};

gp_inline__location="../dragon.tex:30334";
 JPpred(k,n) = {
   if(n>2^k, error("JPpred() n=",n," bigger than 2^",k));
   my(an = dragon_n_to_arm_and_other(n));
   an[1]==0 && n < 2^k && an[2] >= 2^k;
 }

gp_inline__location="../dragon.tex:30341";
 JPpred_list(k) = select(n->JPpred(k,n),vector(2^k+1,n,n--));

gp_inline__location="../dragon.tex:30346";
 JPpred_at_samples_k3 = {[7]};

gp_inline__location="../dragon.tex:30353";
 JPpred_at_samples_k4 = {[14,15]};

gp_inline__location="../dragon.tex:30360";
 JPpred_at_samples_k5 = {[28,30,31]};

gp_inline__location="../dragon.tex:30367";
 JPpred_at_samples_k6 = {[55,56,59,60,62,63]};

gp_inline__location="../dragon.tex:30394";
 JPpredInf(n) = JPpred(length(binary(n)), n);
 JPpredInf_odd(n) = (n%2)==1 && JPpredInf(n);

gp_inline__location="../dragon.tex:30406";
 JA_by_JPpred(k) = sum(n=0,2^k, JPpred(k,n));

gp_inline__location="../dragon.tex:30536";
 dJA(k) = {
   k>=0 || error("dJA() is for k>=0, got k=",k);
   JA(k+1) - JA(k);
 }

gp_inline__location="../dragon.tex:30592";
 dJA_samples = {[0,0,1,1,1,3,5,7,13,23,37,63,109,183,309,527]};

gp_inline__location="../dragon.tex:30620";
 A003229(n) = {
   n>=0 || error("A003229() is for n>=0");
   dJA(n+3);
 }

gp_inline__location="../dragon.tex:30634";
 gdJA(x) = x^2 * 1/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:31277";
 JA_over_LQ_limit = 1/(1 + r);
 JA_over_LQ_nfelt = nfeltdiv(cubic_nf, 1, one_nfelt + r_nfelt);
 JA_over_LQ_polmod = 1/(1+r_polmod);

gp_inline__location="../dragon.tex:31286";
 JA_over_LQ_limit_sample = {(0370972/1000000)};

gp_inline__location="../dragon.tex:31315";
 JA_over_RQ_limit = 1/(1+r^2);

gp_inline__location="../dragon.tex:31321";
 JA_over_RQ_limit_sample = {(0258055/1000000)};

gp_inline__location="../dragon.tex:31353";
 JA_from_RQ(k) = 1/2*RQ(k+1) - RQ(k-1) - if(k>=1,1/2);
 JA_from_RQ_2(k) = RQ(k+1) - 1/2*RQ(k+2) - 1/2;

gp_inline__location="../dragon.tex:31845";
 JEQf = {(3+I)/(5)};

gp_inline__location="../dragon.tex:31855";
 JEQ(k) = {
   k>=0 || error("JEQ() is for k>=0, got k=",k);
   JEQf*b^k - (1 - 3*I)/10*(-1)^k;
 }
 gJEQ_by_powers(x) = (3/5 + 1/5*I)/(1-b*x) - (1/10 - 3/10*I)/(1+x);

gp_inline__location="../dragon.tex:31872";
 JEQ_samples = {[(1)/(2)+(1)/(2)*I,(1)/(2)+(1)/(2)*I,-(1)/(2)+(3)/(2)*I,-(3)/(2)+(1)/(2)*I,-(5)/(2)-(1)/(2)*I,-(3)/(2)-(7)/(2)*I]};

gp_inline__location="../dragon.tex:31888";
 JEC(k) = JEQ(k) - (1/2 + 1/2*I);

gp_inline__location="../dragon.tex:31891";
 JEC_samples = {[0,0,-1+I,-2,-3-I,-2-4*I,1-5*I,6-4*I]};

gp_inline__location="../dragon.tex:31911";
 gJEC_real(x) = \
   x^2 * -(1/2)/((1-x)*(1+x)*(x - (1/2+1/2*I))*(x - (1/2-1/2*I)));

gp_inline__location="../dragon.tex:32183";
 JEQ_by_recurrence(k) = b*(JEQ(k-1) + 1/2*I*(-1)^k);

gp_inline__location="../dragon.tex:32190";
 JEQ_by_sum(k) = b^k*JEQ(0) \
   - b*1/2*I*sum(j=0,k-1, b^j*(-1)^(k-1-j));

gp_inline__location="../dragon.tex:32199";
 JEQ_unsimplified(k) = b^k*(1/2+1/2*I) - b*1/2*I*(b^k - (-1)^k)/(b-(-1));

gp_inline__location="../dragon.tex:32220";
 JEQ_by_threes(k) = {
   my(s=1, total=0, final_j=k);
   forstep(j=k,3,-3, total += s*1/2*b^j; s=-s; final_j=j-3);
   total + s*JEQ(final_j);
 }

gp_inline__location="../dragon.tex:32519";
 S(k) = BQ(k);
 gS(x) = gBQ(x);

gp_inline__location="../dragon.tex:32534";
 D(k) = A(k);
 gD(x) = gA(x);

gp_inline__location="../dragon.tex:32697";
 Dodd(k) = if(k==0,0, A(k-1) + BQ3e(k-1));

gp_inline__location="../dragon.tex:32703";
 gDodd(x) = gAL(x);

gp_inline__location="../dragon.tex:32707";
 \\ number of new points going to D(k+1)
 dD(k) = dA(k);

gp_inline__location="../dragon.tex:32712";
 gdA(x) = gA(x)/x - gA(x);
 gdD(x) = gdA(x);

gp_inline__location="../dragon.tex:32723";
 Deven(k) = if(k==0,0, D(k-1));

gp_inline__location="../dragon.tex:32727";
 gDeven(x) = gD(x) - gDodd(x);

gp_inline__location="../dragon.tex:32771";
 Sodd(k) = if(k==0,1, BQ1e(k-1) + BQ2(k-1) + BQ3o(k-1));

gp_inline__location="../dragon.tex:32789";
 Seven(k) = if(k==0,1, S(k-1));

gp_inline__location="../dragon.tex:32922";
 Spred_k(k,n) = {
   if(n<0,   error("Spred_k() n=",n," negative"));
   if(n>2^k, error("Spred_k() n=",n," bigger than 2^",k));
   my(an = dragon_n_to_arm_and_other(n));
   n==0 || an[1]!=0 || an[2] > 2^k;
 }
 Spred_list(k) = select(n->Spred_k(k,n),vector(2^k+1,n,n-1));

gp_inline__location="../dragon.tex:32937";
 Dpred(k,n) = {
   if(n<0,   error("Dpred() n=",n," negative"));
   if(n>2^k, error("Dpred() n=",n," bigger than 2^",k));
   my(an = dragon_n_to_arm_and_other(n));
   n>0 && an[1]==0 && an[2] <= 2^k;
 }
 Dpred_list(k) = select(n->Dpred(k,n),vector(2^k+1,n,n-1));

gp_inline__location="../dragon.tex:33018";
 DpredLeft(k,n)  = Dpred(k,n) && turn(n)==1;

gp_inline__location="../dragon.tex:33023";
 DpredRight(k,n) = Dpred(k,n) && turn(n)==-1;

gp_inline__location="../dragon.tex:33099";
 SpredInf(n) = {
   my(an = dragon_n_to_arm_and_other(n));
   n==0 || an[1]!=0;
 }

gp_inline__location="../dragon.tex:33104";
 SpredInf_samples = {[1,1,1,1,1,1,1,0,1,1,1,0,1,1,0,0,1,1,1,0]};

gp_inline__location="../dragon.tex:33123";
 SpredInf_at_samples = concat([[0..6],[8..10],[12..13],[16..18],[20],[23..24]]);

gp_inline__location="../dragon.tex:33136";
 DpredInf(n) = {
   my(an = dragon_n_to_arm_and_other(n));
   n>0 && an[1]==0;
 }

gp_inline__location="../dragon.tex:33141";
 DpredInf_samples = {[0,0,0,0,0,0,0,1,0,0,0,1,0,0,1,1,0,0,0,1]};

gp_inline__location="../dragon.tex:33165";
 DpredInf_at_samples = concat([[7],[11],[14..15],[19],[21..22],[25],[28],[30..31],[35]]);

gp_inline__location="../dragon.tex:33173";
 \\ func is a function called x=func(i) for i=0 upwards.
 \\ Return a vector of the run lengths of the first n many runs of
 \\ "value" returned by func().
 FuncRunsOf(func,value,n) = {
   my(prev=func(0), l=List([]), i=1, run=(prev==value));
   while(#l<n,
         my(this=func(i)); i++;
         if(this==value,                run++,
            prev==value && this!=value, listput(l,run); run=0);
         prev=this);
   Vec(l);
 }

gp_inline__location="../dragon.tex:33221";
 VisitsInf(n) = DpredInf(n)+1;

gp_inline__location="../dragon.tex:33223";
 VisitsInf_samples = {[1,1,1,1,1,1,1,2,1,1,1,2,1,1,2,2,1,1,1,2,1]};

gp_inline__location="../dragon.tex:33266";
 P(k) = S(k) + A(k);

gp_inline__location="../dragon.tex:33270";
 P_from_sub(k) = 2^k + 1 - A(k);

gp_inline__location="../dragon.tex:33279";
 P_recurrence(k) =  if(k<5,P(k), \
   4*P(k-1) - 5*P(k-2) + 4*P(k-3) - 6*P(k-4) + 4*P(k-5));

gp_inline__location="../dragon.tex:33289";
 P_samples = {[2,3,5,9,16,29,54,101,190,361,690,1325,2558]};

gp_inline__location="../dragon.tex:33304";
 gP(x) = 1/2 * ( 1 /(1 - x)   \
               + 1 /(1 - 2*x) \
               + (2 + x + 2*x^2) /(1-x-2*x^3) );

gp_inline__location="../dragon.tex:33322";
 gPplus1(x) = (gP(x)-2)/x;    /* P[k+1] strip first term */

gp_inline__location="../dragon.tex:33410";
 \\ return the number of points in curve k with given parity p,
 \\ meaning x+y == p mod 2
 P_of_parity_by_count(k,p) = {
   vecsum(apply(z->z_is_odd(z)==p,
          vector_unique(dragon_points(k))));
 }

gp_inline__location="../dragon.tex:33431";
 Peven(k) = if(k==0,1, P(k-1));

gp_inline__location="../dragon.tex:33445";
 Podd(k)  = if(k==0,1, dP(k-1));

gp_inline__location="../dragon.tex:33460";
 dP(k) = P(k+1) - P(k);
 gdP(k) = gf_shift_down(gP(x),1) - gP(x);

gp_inline__location="../dragon.tex:33475";
 dA(k) = A(k+1) - A(k);

gp_inline__location="../dragon.tex:33480";
 dP_samples = {[1,2,4,7,13,25,47,89,171,329,635,1233]};

gp_inline__location="../dragon.tex:33511";
 Odistinct_list_by_n(k) = {
   my(s=Set());
   for(n=1,2^k,
       my(an=dragon_n_to_arm_and_other(n));
       if(an[1]==0 && an[2]<n, s=setunion(s,Set([n-an[2]]))));
   Vec(s);
 }

gp_inline__location="../dragon.tex:33545";
 Odistinct_by_Opred(k) = \
   if(k==0,0, sum(d=1,4*JND(k-1), d*Opred(d)));

gp_inline__location="../dragon.tex:33569";
 Odistinct_formula(k) = \
   1/68 * 2^k * (2*JA(k) - 13*JA(k+1) + 9*JA(k+2) - 1) - 4/17;
 Odistinct(k) = if(k==0,0, Odistinct_formula(k));

gp_inline__location="../dragon.tex:33579";
 Odistinct_samples = {[0,0,0,0,4,12,28,124,444,1340,4668]};

gp_inline__location="../dragon.tex:33598";
 gOdistinct(x) = 4*x^4 /( (1-x) * (1-2*x-2*(2*x)^3) );

gp_inline__location="../dragon.tex:33671";
 Odistinct_by_recurrence(k) = \
   if(k<4,0, Odistinct(k-1) + 4*2^(k-4) * dJA(k-2) );

gp_inline__location="../dragon.tex:33691";
 Odistinct_by_recurrence2(k) = {
   if(k<5, return(Odistinct(k)));
      3*Odistinct(k-1)
   -  2*Odistinct(k-2)
   + 16*Odistinct(k-3)
   - 16*Odistinct(k-4);
 }

gp_inline__location="../dragon.tex:33705";
 vector_middle_fraction(v) = vector_middle(v) / #v;

gp_inline__location="../dragon.tex:33723";
 Odistinct_mean(k) = Odistinct(k) / (2^k * JA(k-1));
 Odistinct_mean_by_list(k) = \
   vector_mean(Odistinct_list_by_n(k)) / 2^k;

gp_inline__location="../dragon.tex:33730";
 Odistinct_mean_limit = 1/68*(2*r - 13*r^2 + 9*r^3);

gp_inline__location="../dragon.tex:33733";
 Odistinct_mean_limit_nfelt = \
   1/68*( 2*r_nfelt - 13*r_squared_nfelt + 9*r_cubed_nfelt );

gp_inline__location="../dragon.tex:33749";
 Odistinct_mean_limit_sample = {(0145451/1000000)};

gp_inline__location="../dragon.tex:33812";
 JND4_limit = {2/7};

gp_inline__location="../dragon.tex:33817";
 JND4_limit_sample = {(0285714/1000000)};

gp_inline__location="../dragon.tex:33837";
 Odistinct_mean_JND4_limit = 7 / (2*r^2 + 8);

gp_inline__location="../dragon.tex:33843";
 Odistinct_mean_JND4_limit_sample = {(0509081/1000000)};

gp_inline__location="../dragon.tex:33864";
 DO_by_binomial(k) = \
   sum(t=1,k, if(k-1-2*t>=t, 2^(t-1)*binomial(k-1-2*t,t)));

gp_inline__location="../dragon.tex:33889";
 Oall_by_n(k) = {
   my(limit=2^k,total=0,count=0);
   for(n=1,limit,
       my(o=dragon_n_to_other(n));
       if(o>n&&o<limit, total+=o-n;count++));
   count==D(k)||error();
   total;
 }

gp_inline__location="../dragon.tex:33901";
 Oall_by_recurrence(k) = if(k==0,0, Odistinct(k) + 2*Oall(k-1));

gp_inline__location="../dragon.tex:33908";
 Oall_by_sum(k) = sum(j=0,k, 2^j*Odistinct(k-j));

gp_inline__location="../dragon.tex:33921";
 Oall(k) = \
   1/68 * 2^k * (-2*JA(k) - 4*JA(k+1) + 8*JA(k+2) - 16) + 4/17;

gp_inline__location="../dragon.tex:33925";
 Oall_samples = {[0,0,0,0,4,20,68,260,964,3268,11204]};

gp_inline__location="../dragon.tex:33943";
 gOall(x) = 4*x^4 /( (1-x) * (1-2*x) * (1-2*x-2*(2*x)^3) );

gp_inline__location="../dragon.tex:33951";
 Oall_by_dJA(k) = \
   1/68 * 2^k * (4*dJA(k) + 8*dJA(k+1) + dJA(k+2) - 17) + 4/17;

gp_inline__location="../dragon.tex:33978";
 DO_odd_total(k) = {
   sum(l=3,k-1,
       my(t=Oall_by_low(k-l));
       sum(r=2,l-3,
           if(t==0, 2^r,
              t>0, t+2^r + t-2^r)));
 }

gp_inline__location="../dragon.tex:33989";
 od_by_n(k) = {
   my(total=0,count=0,limit=2^k);
   for(n=1,limit,
       my(o=dragon_n_to_other(n));
       if(o>=n&&o<=limit,total+=o-n;count++));
   count==D(k)||error("k="k" count="count);
   total/count;
 }

gp_inline__location="../dragon.tex:34022";
 OdistinctX_by_n(k) = {
   my(total=0,count=0,limit=2^k,half=ceil(limit/2));
   for(n=half,limit,
       my(o=dragon_n_to_other(n));
       if(o<half&&o>0,
          total+=CountOneBits(bitxor(o,n));count++));
   count==if(k>1,JA(k-1))||error("k="k" count="count);
   total;
 }

gp_inline__location="../dragon.tex:34049";
 OdistinctX_by_binomial(k) = {
   1/2 * sum(m=1,k-1,
   sum(t=0,k,
       my(b=m-3-2*t);
       if(b>=0, (m-t-1)*2^(t+1)*binomial(b,t))));
 }

gp_inline__location="../dragon.tex:34067";
 OdistinctX(k) = \
   1/58*( -(k+3)*JA(k) - (16*k+6)*JA(k+1) + (19*k-20)*JA(k+2) + k);

gp_inline__location="../dragon.tex:34071";
 OdistinctX_samples = {[0,0,0,0,2,5,9,22,48,91,179,352]};

gp_inline__location="../dragon.tex:34087";
 gOdistinctX(x) = (2*x^4 - x^5) /( (1-x) * (1 - x - 2*x^3)^2 );

gp_inline__location="../dragon.tex:34129";
OdistinctX_mean(k) = if(k>=3, OdistinctX(k) / (k*JA(k-1)) );

gp_inline__location="../dragon.tex:34132";
 OdistinctX_mean_limit = 1/58*(-r - 16*r^2 + 19*r^3);

gp_inline__location="../dragon.tex:34136";
 OdistinctX_mean_limit_nfelt = \
   1/58*( -r_nfelt - 16*r_squared_nfelt + 19*r_cubed_nfelt );

gp_inline__location="../dragon.tex:34152";
 OdistinctX_mean_limit_sample = {(0774651/1000000)};

gp_inline__location="../dragon.tex:34180";
 OallX_by_n(k) = {
   my(total=0,count=0,limit=2^k);
   for(n=1,limit,
       my(o=dragon_n_to_other(n));
       if(o<n&&o>0,total+=CountOneBits(bitxor(o,n));count++));
   count==D(k)||error("k="k" count="count);
   total;
 }

gp_inline__location="../dragon.tex:34212";
 OallX(k) = {
  3*2^k - 3
  - 1/58*( (43*k+129)*JA(k) + (21*k+84)*JA(k+1) + (24*k+106)*JA(k+2)
           + 44*k );
 }

gp_inline__location="../dragon.tex:34218";
 OallX_samples = {[0,0,0,0,2,9,27,76,200,491,1161,2674]};

gp_inline__location="../dragon.tex:34236";
 gOallX(x) = (2*x^4 - x^5) /( (1-2*x) * (1-x) * (1 - x - 2*x^3)^2 );

gp_inline__location="../dragon.tex:34273";
 D_by_binomial(k) = {
   1/2*sum(h=0,k,
   2^h*sum(m=1,k-h-1,
   sum(t=0,k,
       my(b=m-3-2*t);
       if(b>=0, 2^(t+1)*binomial(b,t)))));
 }

gp_inline__location="../dragon.tex:34365";
 Horizontals_formula(k) = 1/2*(S(k)-1);
 Horizontals(k) = if(k==0, 1, Horizontals_formula(k));

gp_inline__location="../dragon.tex:34372";
 Horizontals_samples = {[1,1,2,4,7,12,21,36,61,104]};

gp_inline__location="../dragon.tex:34395";
 Verticals_formula(k) = Horizontals_formula(k);
 Verticals(k) = if(k==0,0, Verticals_formula(k));

gp_inline__location="../dragon.tex:34415";
 Lines(k) = S(k) - 1;

gp_inline__location="../dragon.tex:34419";
 Lines_samples = {[1,2,4,8,14,24,42,72,122,208]};

gp_inline__location="../dragon.tex:34433";
 my(m=[0,1,0,0; 0,0,1,0; 0,0,0,1; -2,2,-1,2], v=[1,2,4,8]~); \
 A164395(n) = (m^n*v)[1];

gp_inline__location="../dragon.tex:34438";
 A164395_pred(n,k) = {
   my(v=binary_padded(n,k));
   for(i=1,#v-3,
     if( (v[i]==0 && v[i+1]==0 && v[i+2]==0 && v[i+3]==1)
      || (v[i]==0 && v[i+1]==1 && v[i+2]==0 && v[i+3]==1),
        return(0)));
   1;
 }

gp_inline__location="../dragon.tex:34592";
 dragon_point_unrotated(k,n) = {
   (n>=0 && n<=2^k)
     || error("dragon_point_unrotated() out of range n="n" k="k);
   dragon_point(n)*conj(w8_times_sqrt2)^k;
 }
 CentrelinePointPred_by_point(k,n) = \
   imag(dragon_point_unrotated(k,n)) == 0;

gp_inline__location="../dragon.tex:34605";
 CentrelinePointPred_k0_samples = {[1,1]};

gp_inline__location="../dragon.tex:34614";
 CentrelinePointPred_k1_samples = {[1,0,1]};

gp_inline__location="../dragon.tex:34623";
 CentrelinePointPred_k2_samples = {[1,0,0,1,1]};

gp_inline__location="../dragon.tex:34641";
 CentrelineSegmentPred_by_point(k,n) = {
   (n>=0 && n<2^k)
     || error("CentrelineSegmentPred_by_point() out of range");
                CentrelinePointPred_by_point(k,n)
   || (n<2^k && CentrelinePointPred_by_point(k,n+1));
 }

gp_inline__location="../dragon.tex:34650";
 CentrelineSegmentPred_k0_samples = {[1]};

gp_inline__location="../dragon.tex:34659";
 CentrelineSegmentPred_k1_samples = {[1,1]};

gp_inline__location="../dragon.tex:34668";
 CentrelineSegmentPred_k2_samples = {[1,0,1,1]};

gp_inline__location="../dragon.tex:34690";
 CentrelineSegments_state_table = {[ 4, 7;     \\ 1 = h start
                                     1, 10;    \\ 2 = s1
                                     2, 11;    \\ 3 = s2
                                     3, 11;    \\ 4 = s3
                                     11, 9;    \\ 5 = e1 = a3
                                     11, 5;    \\ 6 = e2
                                     6,  8;    \\ 7 = e3 = a1
                                     2,  5;    \\ 8 = hr
                                     11, 7;    \\ 9 = a2
                                     4, 11;    \\ 10 = d2
                                     11,11]};  \\ 11 = non
 CentrelineSegments_state_h     = 1;
 CentrelineSegments_state_s1    = 2;
 CentrelineSegments_state_s2    = 3;
 CentrelineSegments_state_s3    = 4;
 CentrelineSegments_state_e1_a3 = 5;
 CentrelineSegments_state_e2    = 6;
 CentrelineSegments_state_e3_a1 = 7;
 CentrelineSegments_state_hr    = 8;
 CentrelineSegments_state_a2    = 9;
 CentrelineSegments_state_d2    = 10;
 CentrelineSegments_state_non   = 11;
 CentrelineSegments_transition(state,bit) = \
   CentrelineSegments_state_table[state,bit+1];
 CentrelineSegments_transitions(state,v) = {
   for(i=1,#v,  /* high to low */
       state=CentrelineSegments_transition(state,v[i]));
   state;
 }
 CentrelineSegmentPred_state(k,n) = {
   CentrelineSegments_transitions(CentrelineSegments_state_h,
                                  binary_padded(n,k));
 }
 CentrelineSegmentPred(k,n) = \
   CentrelineSegmentPred_state(k,n) != CentrelineSegments_state_non;

gp_inline__location="../dragon.tex:34850";
 CentrelineSegments_vectors = {[
   [0,0, 1,0,             0],  \\ h
   [0,0, 1/sqrt2,1/sqrt2, 0],  \\ s1
   [0,0, 0,1,             0],  \\ s2
   [0,0, -1/sqrt2,1/sqrt2,  0],  \\ s3
   [-1/sqrt2,-1/sqrt2, 0,0, 0],  \\ e1
   [0,-1, 0,0,              0],  \\ e2
   [1/sqrt2,-1/sqrt2, 0,0,  0],  \\ e3

   [1,0, 0,0,           1],  \\ hr
   [0,0, 0,-1,          1],  \\ a2
   [0,1, 0,0,           1],  \\ d2
   'non
 ]};

gp_inline__location="../dragon.tex:34945";
 centreline_vector_expand(v) = {
   if(v=='non, return(['non,'non]));
   my(x1,y1,x2,y2,odd); [x1,y1,x2,y2,odd]=v;
   x1 *= sqrt2;  x2 *= sqrt2;
   y1 *= sqrt2;  y2 *= sqrt2;
   my(dx = x2 - x1,
      by = y2 - y1,
      xm = (x1+x2)/2 + (y2-y1)/2,
      ym = (y1+y2)/2 - (x2-x1)/2,
      ret = [ [x1,y1, xm,ym, 0],
              [x2,y2, xm,ym, 1] ]);
   for(i=1,#ret,
     my(x=ret[i][1]);
     ret[i][1] -= x;
     ret[i][3] -= x);
   for(i=1,#ret,
     if(ret[i][2]<0 && ret[i][5]==0,
        for(j=1,4, ret[i][j] *= -1)));
   for(i=1,#ret,
     if(ret[i][2]!=0 && ret[i][4]!=0, ret[i]='non));
   if(odd,Vecrev(ret),ret);
 }

gp_inline__location="../dragon.tex:35079";
 CentrelineSegments_formula(k) = \
   vector_modulo([3/2,2],k) * 2^floor(k/2);
 CentrelineSegments(k) = \
   if(k==0,1, CentrelineSegments_formula(k));

gp_inline__location="../dragon.tex:35086";
 CentrelineSegments_samples = {[1,2,3,4,6,8,12,16,24,32,48,64]};

gp_inline__location="../dragon.tex:35097";
 gCentrelineSegments(x) = (1+x)^2/(1 - 2*x^2);

gp_inline__location="../dragon.tex:35113";
 CentrelinePointPred_accepting_states = {Set([
   CentrelineSegments_state_h,
    CentrelineSegments_state_s1,
    CentrelineSegments_state_s2,
    CentrelineSegments_state_s3,
   CentrelineSegments_state_hr,
    CentrelineSegments_state_d2
 ])};
 CentrelinePointPred(k,n) = {
   n==2^k ||
   setsearch(CentrelinePointPred_accepting_states,
             CentrelineSegmentPred_state(k,n)) != 0;
 }

gp_inline__location="../dragon.tex:35139";
 CentrelineVisits(k) = 2^floor(k/2) + 1;

gp_inline__location="../dragon.tex:35144";
 CentrelineVisits_samples = {[2,2,3,3,5,5,9,9,17,17]};

gp_inline__location="../dragon.tex:35155";
 gCentrelineVisits(x) = 1/(1-x) + (1+x)/(1 - 2*x^2);

gp_inline__location="../dragon.tex:35180";
 CentrelineH_formula(k) = 1/2 * 2^floor(k/2);
 CentrelineH(k) = if(k==0,1, k%2==0, CentrelineH_formula(k), 0);

gp_inline__location="../dragon.tex:35187";
 CentrelineH_samples = {[1,0,1,0,2,0,4,0,8,0]};

gp_inline__location="../dragon.tex:35204";
 gCentrelineH(x) = (1-x^2)/(1 - 2*x^2);

gp_inline__location="../dragon.tex:35210";
 CentrelineH_by_points(k) = {
   if(k%2, return(0));
   my(dz=I^(k/2), end=Manhattan(b^k), n_limit=2^k, ret=0);
   \\ print("dz="dz);
   for(x=-end,2*end,
     my(z=x*dz);
     \\ print("x="x" z="z" to "z+dz);
     if(segment_is_traversed(z,z+dz,k),
        \\ print(" yes");
        ret++));
   ret;
 }

gp_inline__location="../dragon.tex:35247";
 gOnesEven(x) = 1/(1-x^2);

gp_inline__location="../dragon.tex:35273";
 CentrelineS_formula(k) = \
   vector_modulo([5/3, 5/3, 3, 3],k) * 3^floor(k/4);
 CentrelineS(k) = \
   if(k==0||k==1, 2, CentrelineS_formula(k));

gp_inline__location="../dragon.tex:35281";
 CentrelineS_samples = {[2,2,3,3,5,5,9,9,15,15,27,27]};

gp_inline__location="../dragon.tex:35305";
 CentrelineD(k) = 1/2*(CentrelineVisits(k) - CentrelineS(k));

gp_inline__location="../dragon.tex:35311";
 CentrelineD_samples = {[0,0,0,0,0,0,0,0,1,1,3,3]};

gp_inline__location="../dragon.tex:35332";
 CentrelineP(k) = 1/2*(2^floor(k/2) + 1 + CentrelineS(k));

gp_inline__location="../dragon.tex:35339";
 CentrelineP_samples = {[2,2,3,3,5,5,9,9,16,16,30,30]};

gp_inline__location="../dragon.tex:35383";
 CentrelineLines(k) = {
   if(k==0, return(1));
   if(k%2==1, return(0));
   1/2*(CentrelineS(k)-1);
 }

gp_inline__location="../dragon.tex:35394";
 CentrelineLines_samples = {[1,0,1,0,2,0,4,0,7,0,13,0]};

gp_inline__location="../dragon.tex:35410";
 CentrelineLines_by_points(k) = {
   if(k%2, return(0));
   my(dz=I^(k/2), end=Manhattan(b^k), n_limit=2^k,
      prev=0, ret=0);
   for(x=-end,2*end,
     my(z=x*dz, this=segment_is_traversed(z,z+dz,k));
     if(this && !prev, ret++);
     prev=this);
   ret;
 }

gp_inline__location="../dragon.tex:35455";
 CentrelineLinesMean_samples = {[1,1,1,1,(8)/(7),(16)/(13),(16)/(11),(8)/(5),(128)/(67),(256)/(121)]};

gp_inline__location="../dragon.tex:35544";
 DiaglinePointPred_by_point(k,n) = {
   my(z=dragon_point_unrotated(k,n));
   real(z)==imag(z);
 }
 DiaglineSegmentPred_by_point(k,n) = {
   (n>=0 && n<2^k)
     || error("DiaglineSegmentPred_by_point() out of range");
                DiaglinePointPred_by_point(k,n)
   || (n<2^k && DiaglinePointPred_by_point(k,n+1));
 }

gp_inline__location="../dragon.tex:35555";
 DiaglineSegmentPred(k,n) = {
   CentrelineSegments_transitions(CentrelineSegments_state_s3,
                                  binary_padded(n,k))
     != CentrelineSegments_state_non;
 }

gp_inline__location="../dragon.tex:35563";
 OpplinePointPred_by_point(k,n) = {
   my(z=dragon_point_unrotated(k,n));
   real(z) == -imag(z);
 }
 OpplineSegmentPred_by_point(k,n) = {
   (n>=0 && n<2^k)
     || error("OpplineSegmentPred_by_point() out of range");
                OpplinePointPred_by_point(k,n)
   || (n<2^k && OpplinePointPred_by_point(k,n+1));
 }

gp_inline__location="../dragon.tex:35574";
 OpplineSegmentPred(k,n) = {
   CentrelineSegments_transitions(CentrelineSegments_state_s1,
                                  binary_padded(n,k))
     != CentrelineSegments_state_non;
 }

gp_inline__location="../dragon.tex:35582";
 PerplinePointPred_by_point(k,n) = {
   my(z=dragon_point_unrotated(k,n));
   real(z) == 0;
 }
 PerplineSegmentPred_by_point(k,n) = {
   (n>=0 && n<2^k)
     || error("PerplineSegmentPred_by_point() out of range");
                PerplinePointPred_by_point(k,n)
   || (n<2^k && PerplinePointPred_by_point(k,n+1));
 }

gp_inline__location="../dragon.tex:35593";
 PerplineSegmentPred(k,n) = {
   CentrelineSegments_transitions(CentrelineSegments_state_s2,
                                  binary_padded(n,k))
     != CentrelineSegments_state_non;
 }

gp_inline__location="../dragon.tex:35603";
 dragon_end_unrotated(k) = dragon_point_unrotated(k,2^k);
 EdiaglinePointPred_by_point(k,n) = {
   my(z = dragon_point_unrotated(k,n) - dragon_end_unrotated(k));
   real(z)==imag(z);
 }
 EdiaglineSegmentPred_by_point(k,n) = {
   (n>=0 && n<2^k)
     || error("EdiaglineSegmentPred_by_point() out of range");
                EdiaglinePointPred_by_point(k,n)
   || (n<2^k && EdiaglinePointPred_by_point(k,n+1));
 }

gp_inline__location="../dragon.tex:35615";
 EdiaglineSegmentPred(k,n) = {
   CentrelineSegments_transitions(CentrelineSegments_state_e3_a1,
                                  binary_padded(n,k))
     != CentrelineSegments_state_non;
 }

gp_inline__location="../dragon.tex:35623";
 EopplinePointPred_by_point(k,n) = {
   my(z = dragon_point_unrotated(k,n) - dragon_end_unrotated(k));
   real(z) == -imag(z);
 }
 EopplineSegmentPred_by_point(k,n) = {
   (n>=0 && n<2^k)
     || error("EopplineSegmentPred_by_point() out of range");
                EopplinePointPred_by_point(k,n)
   || (n<2^k && EopplinePointPred_by_point(k,n+1));
 }

gp_inline__location="../dragon.tex:35634";
 EopplineSegmentPred(k,n) = {
   CentrelineSegments_transitions(CentrelineSegments_state_e1_a3,
                                  binary_padded(n,k))
     != CentrelineSegments_state_non;
 }

gp_inline__location="../dragon.tex:35642";
 EperplinePointPred_by_point(k,n) = {
   my(z = dragon_point_unrotated(k,n) - dragon_end_unrotated(k));
   real(z) == 0;
 }
 EperplineSegmentPred_by_point(k,n) = {
   (n>=0 && n<2^k)
     || error("EperplineSegmentPred_by_point() out of range");
                EperplinePointPred_by_point(k,n)
   || (n<2^k && EperplinePointPred_by_point(k,n+1));
 }

gp_inline__location="../dragon.tex:35653";
 EperplineSegmentPred(k,n) = {
   CentrelineSegments_transitions(CentrelineSegments_state_e2,
                                  binary_padded(n,k))
     != CentrelineSegments_state_non;
 }

gp_inline__location="../dragon.tex:35725";
 gen_enclosure_right_samples = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1];

gp_inline__location="../dragon.tex:35767";
 gen_enclosure_left_samples = [0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0];

gp_inline__location="../dragon.tex:35801";
 DpredFirst(k,n) = Dpred(k,n) && n < dragon_n_to_other(n);

gp_inline__location="../dragon.tex:35809";
 DpredFirstInf(n) = DpredInf(n) && n < dragon_n_to_other(n);

gp_inline__location="../dragon.tex:35813";
 DpredFirstInf_samples = {[0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,1,0,0,0,0]};

gp_inline__location="../dragon.tex:35828";
 DpredFirstInf_at_samples = {[7,14,15,21,28,30,31,39,42,45,53]};

gp_inline__location="../dragon.tex:35842";
 DpredSecond(n) = DpredInf(n) && n > dragon_n_to_other(n);

gp_inline__location="../dragon.tex:35846";
 DpredSecond_samples = {[0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1]};

gp_inline__location="../dragon.tex:35864";
 DpredSecond_at_samples = {[11,19,22,25,35,38,43,44,49,50,57]};

gp_inline__location="../dragon.tex:35878";
 DpredFirstInf_across_join(n) = {
   my(k=length(binary(n)));
   DpredFirst(k+1,n);
 }

gp_inline__location="../dragon.tex:35894";
 D_by_DpredFirstInf(k) = sum(n=0,2^k, DpredFirst(k,n));

gp_inline__location="../dragon.tex:35899";
 D_by_DpredSecond(k) = sum(n=0,2^k, DpredSecond(n));

gp_inline__location="../dragon.tex:35944";
 DpredSecondL(n) = DpredSecond(n) && turn(n)==1;

gp_inline__location="../dragon.tex:35951";
 DpredSecondL_at_samples = {[25,49,50,57,89,97,98,100,113,114,121]};

gp_inline__location="../dragon.tex:35964";
 DpredSecondR(n) = DpredSecond(n) && turn(n)==-1;

gp_inline__location="../dragon.tex:35971";
 DpredSecondR_at_samples = {[11,19,22,35,38,43,44,67,70,75,76]};

gp_inline__location="../dragon.tex:36213";
 EpredL_ls0    = 1;
 EpredL_ls12   = 2;
 EpredL_ls3    = 3;
 EpredL_ls0rev = 4;
 EpredL_ls1rev = 5;
 EpredL_ls2rev = 6;
 EpredL_ls3rev = 7;
 \\                       bit 0 1
 EpredL_HtoL_state_table = {[ 1,5;   \\ 1 ls0
                              2,6;   \\ 2 ls12
                              2,7;   \\ 3 ls3
                              1,4;   \\ 4 ls0rev
                              2,4;   \\ 5 ls1rev
                              3,5;   \\ 6 ls2rev
                              3,7    \\ 7 ls3rev
                           ]};
 EpredL_HtoL_transition(state,bit) = \
   EpredL_HtoL_state_table[state,bit+1];
 EpredL_HtoL_transitions(state,v) = {
   for(i=1,#v, state=EpredL_HtoL_transition(state,v[i]));
   state;
 }
 EpredL_HtoL_n_to_state(n) = \
   EpredL_HtoL_transitions(EpredL_ls0, binary(n));
 EpredL(n) = {
   my(state=EpredL_HtoL_n_to_state(n));
   state==EpredL_ls3 || state==EpredL_ls3rev;
 }

gp_inline__location="../dragon.tex:36335";
 \\                       bit 0 1
 EpredL_LtoH_state_table = {[ 2,1;   \\ lm1
                              3,4;   \\ lm2
                              3,3;   \\ lm3
                              5,1;   \\ lm4
                              5,6;   \\ lm5
                              7,4;   \\ lm6
                              7,7    \\ lm7
                           ]};
 EpredL_LtoH_transition(state,bit) = \
   EpredL_LtoH_state_table[state,bit+1];

gp_inline__location="../dragon.tex:36347";
 EpredL_LtoH_n_to_state(n) = {
   my(v=binary(n),state=1);
   forstep(i=#v,1,-1,  \\ low to high
           state=EpredL_LtoH_transition(state,v[i]));
   state;
 }
 EpredL_by_low_to_high(n) = {
   my(state=EpredL_LtoH_n_to_state(n));
   state==6 || state==7;
 }

gp_inline__location="../dragon.tex:36448";
 EpredL_at_samples = {[10,18,21,34,37,42,43,66,69,74,75]};

gp_inline__location="../dragon.tex:36487";
 Epred(n) = DpredSecond(n+1);
 EpredR(n) = DpredSecondL(n+1);

gp_inline__location="../dragon.tex:36538";
 EpredL3(n) = n%8==5 && EpredL(n\8);
 EpredR3(n) = {
      (n%16==15 && EpredR(n\16))
   || (n%32== 7 && EpredR(n\16));
 }

gp_inline__location="../dragon.tex:36544";
 EpredR3_by_3(n) = EpredR(n) && EpredR(n+1) && EpredR(n+2);
 EpredL3_by_3(n) = EpredL(n) && EpredL(n+1) && EpredL(n+2);

gp_inline__location="../dragon.tex:36563";
 EpredR3_samples = {[391,399,775,783,799,903,911,1415]};

gp_inline__location="../dragon.tex:36580";
 EpredL3_samples = {[85,149,173,277,301,341,349,533]};

gp_inline__location="../dragon.tex:36588";
 func_is_consecutive(n,f,value,reps) = {
   while(reps > 0,
         if(f(n)!=value,return(0));
         reps--; n++);
   1;
 }
 func_first_consecutive(f,value,reps) = \
   for(n=0,oo, if(func_is_consecutive(n,f,value,reps),return(n)));

gp_inline__location="../dragon.tex:36822";
 EpredNine(n) = for(i=0,8, if(!Epred(n+i), return(0))); 1;

gp_inline__location="../dragon.tex:36828";
 EpredNine_samples = {[701,1213,1405,2237,2429,2749,2813,4285]};

gp_inline__location="../dragon.tex:36868";
 EncNine_vector = {[61,83,61,35]};

gp_inline__location="../dragon.tex:36878";
 EncNine_formula(k) = {
   7/3*2^(k-9)
   + 1/8*k
   - 1/96 * vector_modulo(EncNine_vector,k)
   - 1/32 * (dJA(k+1)+2*dJA(k));
 }
 EncNine(k) = if(k<=7,0, EncNine_formula(k));

gp_inline__location="../dragon.tex:36895";
 EncNine_samples = {[1,3,7,17,40,90,197,424,900,1889]};
 /*zeros*/ EncNine_samples = concat(vector(10),EncNine_samples);

gp_inline__location="../dragon.tex:36904";
 EncNine_generated_samples = {[0,0,0,0,0,0,0,0,0,0,1,3,7,17,40,90,197,424,900,1889,3929,8115,16668,34080,69421,140982,285596,577351,1165145,2348001,4726036,9502998,19092349,38331124,76910532,154242061,309197977,619606383,1241265196,2486010540,4977922093,9965850066,19948666316,39926100851,79900981689,159884675741,319909600292,640057009378,1280517252285,2561718235728,5124595820212]};

gp_inline__location="../dragon.tex:36908";
 EncNine_by_count(k) = {
   my(v=vector(2^k-1,n, DpredSecond(n)));
   v=vector_run_lengths(v);
   v=vector(#v\2,i,v[2*i]); \\ evens are the runs of 1s
   sum(i=1,#v, v[i]==9);
 }

gp_inline__location="../dragon.tex:36936";
 EncNine_over_A_limit = 21/2^8;

gp_inline__location="../dragon.tex:36946";
 EncNine_over_A_limit_sample = {(008203125/100000000)};

gp_inline__location="../dragon.tex:36958";
 \\ Return vector v of length len where v[n] = Epred(n).
 Epred_vector(len) = vector(len,n,n--; Epred(n));

gp_inline__location="../dragon.tex:36962";
 \\ Return vector v of length len where v[n] = EpredL(n).
 EpredL_vector(len) = vector(len,n,n--; EpredL(n));

gp_inline__location="../dragon.tex:36966";
 \\ Return vector v of length len where v[n] = EpredR(n).
 EpredR_vector(len) = vector(len,n,n--; EpredR(n));

gp_inline__location="../dragon.tex:36970";
 \\ Return a vector of first n terms of A(i), starting i=0.
 An_vector(len) = vector_cumulative0(Epred_vector(len));

gp_inline__location="../dragon.tex:36978";
 ARn_vector(len) = vector_cumulative0(EpredR_vector(len));
 ALn_vector(len) = vector_cumulative0(EpredL_vector(len));

gp_inline__location="../dragon.tex:36986";
 \\ Number of states occurring.
 gEpredLs0(x) = \
   5/8 + 1/4*x  + 1/8 /(1 - 2*x)  + 1/4*(1 + x)/(1 - x - 2*x^3);
 gEpredLs12(x) = \
   -1/4 +        1/4  /(1 - 2*x) + 1/2*(-x + x^2)/(1 - x - 2*x^3);
 gEpredLs3(x) = \
   1/8 - 1/4*x + 1/8  /(1 - 2*x) + (-1/4 + 1/4*x - 1/2*x^2)/(1 - x - 2*x^3);
 gEpredLs0rev(x) = \
   -3/8 - 1/4*x + 1/8 /(1 - 2*x) + (1/4 - 1/4*x + 1/2*x^2)/(1 - x - 2*x^3);
 gEpredLs1rev(x) = \
   1/8 + 1/4*x  + 1/8 /(1 - 2*x) + (-1/4 + 3/4*x)/(1 - x - 2*x^3);
 gEpredLs2rev(x) = \
   -3/8 - 1/4*x + 1/8 /(1 - 2*x) + (1/4 - 1/4*x - 1/2*x^2)/(1 - x - 2*x^3);
 gEpredLs3rev(x) = \
   1/8 + 1/4*x + (1/8)/(1 - 2*x) + (-1/4 - 1/4*x)/(1 - x - 2*x^3);
 gAL_of_state(state) = {
   my(v=state_table_to_gfs(EpredL_HtoL_state_table,state));
   v[EpredL_ls3] + v[EpredL_ls3rev];
 }

gp_inline__location="../dragon.tex:37020";
 gEpredL_starts = vector(7,i, gAL_of_state(i));

gp_inline__location="../dragon.tex:37036";
 An(n) = ALn(n) + ARn(n);

gp_inline__location="../dragon.tex:37067";
 AL_of_state_vector = {[
   AL, k->AL(k)+JA(k+1), k->AL(k)+LQ(k),
   AR, k->AR(k)+JA(k),   k->AR(k)+JA(k+1), k->AR(k)+RQ(k)
 ]};
 AL_of_state(state,k) = AL_of_state_vector[state](k);

gp_inline__location="../dragon.tex:37175";
 ALn(n) = {
   my(debug=0);
   my(v=binary(n), k=#v);
   sum(i=1,#v,
       my(state=EpredL_HtoL_transitions(EpredL_ls0,
                                        concat(v[1..i-1],[0])));
       if(debug, print("i="i" bit "v[i]" state "state" term "k-i" is "AL_of_state(state,k-i)));
       v[i] * AL_of_state(state,k-i);
       );
 }

gp_inline__location="../dragon.tex:37212";
 ARn(n) = sum(j=0,n-1, EpredR(j));

gp_inline__location="../dragon.tex:38333";
 gen_convex_hull_values = {[
   /* 0 */ [ 0,1 ],
   /* 1 */ [ 1,0,1+1*I ],
   /* 2 */ [ 1+1*I,1,0,2*I ],
   /* 3 */ [ 2*I,1+1*I,1,0,-2+1*I,-2+2*I ],
   /* 4 */ [ 2*I,1+1*I,1,-3-1*I,-4-1*I,-4,-3+2*I ],
   /* 5 */ [ -5,-3+2*I,2*I,1+1*I,1,-2-4*I,-3-5*I,-4-5*I,-5-1*I ],
   /* 6 */ [ -5-5*I,-5,-3+2*I,2*I,1+1*I,2-5*I,2-8*I,1-9*I,-9*I,-4-6*I ],
   /* 7 */ [ -10*I,-5-5*I,-5,-3+2*I,2*I,8-3*I,10-5*I,10-8*I,9-9*I,3-10*I ],
   /* 8 */ [ 11-10*I,-10*I,-5-5*I,-5,-3+2*I,11+5*I,16+5*I,18+3*I,18,13-8*I ],
   /* 9 */ [ 21,11-10*I,-10*I,-5-5*I,-5,6+16*I,11+21*I,16+21*I,18+19*I,21+5*I ],
   /* 10 */ [ 21+21*I,21,11-10*I,-10*I,-5-5*I,-10+21*I,-10+32*I,-5+37*I,37*I,16+26*I ],
   /* 11 */ [ 42*I,21+21*I,21,11-10*I,-10*I,-32+11*I,-42+21*I,-42+32*I,-37+37*I,-11+42*I ],
   /* 12 */ [ -43+42*I,42*I,21+21*I,21,11-10*I,-43-21*I,-64-21*I,-74-11*I,-74,-53+32*I ],
   /* 13 */ [ -85,-43+42*I,42*I,21+21*I,21,-22-64*I,-43-85*I,-64-85*I,-74-75*I,-85-21*I ],
   /* 14 */ [ -85-85*I,-85,-43+42*I,42*I,21+21*I,42-85*I,42-128*I,21-149*I,-149*I,-64-106*I ],
   /* 15 */ [ -170*I,-85-85*I,-85,-43+42*I,42*I,128-43*I,170-85*I,170-128*I,149-149*I,43-170*I ],
   /* 16 */ [ 171-170*I,-170*I,-85-85*I,-85,-43+42*I,171+85*I,256+85*I,298+43*I,298,213-128*I ],
   /* 17 */ [ 341,171-170*I,-170*I,-85-85*I,-85,86+256*I,171+341*I,256+341*I,298+299*I,341+85*I ],
   /* 18 */ [ 341+341*I,341,171-170*I,-170*I,-85-85*I,-170+341*I,-170+512*I,-85+597*I,597*I,256+426*I ],
   /* 19 */ [ 682*I,341+341*I,341,171-170*I,-170*I,-512+171*I,-682+341*I,-682+512*I,-597+597*I,-171+682*I ],
   /* 20 */ [ -683+682*I,682*I,341+341*I,341,171-170*I,-683-341*I,-1024-341*I,-1194-171*I,-1194,-853+512*I ],
   /* 21 */ [ -1365,-683+682*I,682*I,341+341*I,341,-342-1024*I,-683-1365*I,-1024-1365*I,-1194-1195*I,-1365-341*I ],
   /* 22 */ [ -1365-1365*I,-1365,-683+682*I,682*I,341+341*I,682-1365*I,682-2048*I,341-2389*I,-2389*I,-1024-1706*I ],
   /* 23 */ [ -2730*I,-1365-1365*I,-1365,-683+682*I,682*I,2048-683*I,2730-1365*I,2730-2048*I,2389-2389*I,683-2730*I ],
   /* 24 */ [ 2731-2730*I,-2730*I,-1365-1365*I,-1365,-683+682*I,2731+1365*I,4096+1365*I,4778+683*I,4778,3413-2048*I ],
   /* 25 */ [ 5461,2731-2730*I,-2730*I,-1365-1365*I,-1365,1366+4096*I,2731+5461*I,4096+5461*I,4778+4779*I,5461+1365*I ],
   /* 26 */ [ 5461+5461*I,5461,2731-2730*I,-2730*I,-1365-1365*I,-2730+5461*I,-2730+8192*I,-1365+9557*I,9557*I,4096+6826*I ],
   /* 27 */ [ 10922*I,5461+5461*I,5461,2731-2730*I,-2730*I,-8192+2731*I,-10922+5461*I,-10922+8192*I,-9557+9557*I,-2731+10922*I ],
   /* 28 */ [ -10923+10922*I,10922*I,5461+5461*I,5461,2731-2730*I,-10923-5461*I,-16384-5461*I,-19114-2731*I,-19114,-13653+8192*I ],
   /* 29 */ [ -21845,-10923+10922*I,10922*I,5461+5461*I,5461,-5462-16384*I,-10923-21845*I,-16384-21845*I,-19114-19115*I,-21845-5461*I ],
   /* 30 */ [ -21845-21845*I,-21845,-10923+10922*I,10922*I,5461+5461*I,10922-21845*I,10922-32768*I,5461-38229*I,-38229*I,-16384-27306*I ],
   /* 31 */ [ -43690*I,-21845-21845*I,-21845,-10923+10922*I,10922*I,32768-10923*I,43690-21845*I,43690-32768*I,38229-38229*I,10923-43690*I ],
   /* 32 */ [ 43691-43690*I,-43690*I,-21845-21845*I,-21845,-10923+10922*I,43691+21845*I,65536+21845*I,76458+10923*I,76458,54613-32768*I ],
   /* 33 */ [ 87381,43691-43690*I,-43690*I,-21845-21845*I,-21845,21846+65536*I,43691+87381*I,65536+87381*I,76458+76459*I,87381+21845*I ],
   /* 34 */ [ 87381+87381*I,87381,43691-43690*I,-43690*I,-21845-21845*I,-43690+87381*I,-43690+131072*I,-21845+152917*I,152917*I,65536+109226*I ],
   /* 35 */ [ 174762*I,87381+87381*I,87381,43691-43690*I,-43690*I,-131072+43691*I,-174762+87381*I,-174762+131072*I,-152917+152917*I,-43691+174762*I ],
   /* 36 */ [ -174763+174762*I,174762*I,87381+87381*I,87381,43691-43690*I,-174763-87381*I,-262144-87381*I,-305834-43691*I,-305834,-218453+131072*I ],
   /* 37 */ [ -349525,-174763+174762*I,174762*I,87381+87381*I,87381,-87382-262144*I,-174763-349525*I,-262144-349525*I,-305834-305835*I,-349525-87381*I ],
   /* 38 */ [ -349525-349525*I,-349525,-174763+174762*I,174762*I,87381+87381*I,174762-349525*I,174762-524288*I,87381-611669*I,-611669*I,-262144-436906*I ],
   /* 39 */ [ -699050*I,-349525-349525*I,-349525,-174763+174762*I,174762*I,524288-174763*I,699050-349525*I,699050-524288*I,611669-611669*I,174763-699050*I ],
   /* 40 */ [ 699051-699050*I,-699050*I,-349525-349525*I,-349525,-174763+174762*I,699051+349525*I,1048576+349525*I,1223338+174763*I,1223338,873813-524288*I ],
   /* 41 */ [ 1398101,699051-699050*I,-699050*I,-349525-349525*I,-349525,349526+1048576*I,699051+1398101*I,1048576+1398101*I,1223338+1223339*I,1398101+349525*I ],
   /* 42 */ [ 1398101+1398101*I,1398101,699051-699050*I,-699050*I,-349525-349525*I,-699050+1398101*I,-699050+2097152*I,-349525+2446677*I,2446677*I,1048576+1747626*I ],
   /* 43 */ [ 2796202*I,1398101+1398101*I,1398101,699051-699050*I,-699050*I,-2097152+699051*I,-2796202+1398101*I,-2796202+2097152*I,-2446677+2446677*I,-699051+2796202*I ],
   /* 44 */ [ -2796203+2796202*I,2796202*I,1398101+1398101*I,1398101,699051-699050*I,-2796203-1398101*I,-4194304-1398101*I,-4893354-699051*I,-4893354,-3495253+2097152*I ],
   /* 45 */ [ -5592405,-2796203+2796202*I,2796202*I,1398101+1398101*I,1398101,-1398102-4194304*I,-2796203-5592405*I,-4194304-5592405*I,-4893354-4893355*I,-5592405-1398101*I ],
   /* 46 */ [ -5592405-5592405*I,-5592405,-2796203+2796202*I,2796202*I,1398101+1398101*I,2796202-5592405*I,2796202-8388608*I,1398101-9786709*I,-9786709*I,-4194304-6990506*I ],
   /* 47 */ [ -11184810*I,-5592405-5592405*I,-5592405,-2796203+2796202*I,2796202*I,8388608-2796203*I,11184810-5592405*I,11184810-8388608*I,9786709-9786709*I,2796203-11184810*I ],
   /* 48 */ [ 11184811-11184810*I,-11184810*I,-5592405-5592405*I,-5592405,-2796203+2796202*I,11184811+5592405*I,16777216+5592405*I,19573418+2796203*I,19573418,13981013-8388608*I ],
   /* 49 */ [ 22369621,11184811-11184810*I,-11184810*I,-5592405-5592405*I,-5592405,5592406+16777216*I,11184811+22369621*I,16777216+22369621*I,19573418+19573419*I,22369621+5592405*I ],
   /* 50 */ [ 22369621+22369621*I,22369621,11184811-11184810*I,-11184810*I,-5592405-5592405*I,-11184810+22369621*I,-11184810+33554432*I,-5592405+39146837*I,39146837*I,16777216+27962026*I ]
 ]};
 HA_samples_planar = [ 0, 1/2, 3/2, 9/2, 23/2, 28, 121/2, 129, 539/2, 559, 2273/2, 2307, 9323/2, 9403, 37761/2, 37899, 151979/2, 152299, 609793/2, 610347, 2442923/2, 2444203, 9779201/2, 9781419, 39131819/2, 39136939, 156557313/2, 156566187, 626289323/2, 626309803, 2505277441/2, 2505312939, 10021350059/2, 10021431979, 40085880833/2, 40086022827, 160344484523/2, 160344812203, 641379860481/2, 641380428459, 2565523286699/2, 2565524597419, 10262100836353/2, 10262103108267, 41048418724523/2, 41048423967403, 164193705656321/2, 164193714743979, 656774884141739/2, 656774905113259, 2627099659599873/2 ];
 gen_convex_hull_values_PQ = {[
   /* 0 */ [ -1*I,1-1*I,1+1*I,1*I ],
   /* 1 */ [ 2,1-1*I,-1*I,1*I,2+1*I ],
   /* 2 */ [ 2+1*I,2,1-1*I,-1*I,-1+1*I,-1+2*I,1+2*I ],
   /* 3 */ [ 3*I,2+1*I,2,1-1*I,-1*I,-2,-3+1*I,-3+2*I,-1+3*I ],
   /* 4 */ [ -3+3*I,3*I,2+1*I,2,1-1*I,-3-2*I,-4-2*I,-5-1*I,-5,-4+2*I ],
   /* 5 */ [ -6,-3+3*I,3*I,2+1*I,2,-1-4*I,-3-6*I,-4-6*I,-5-5*I,-6-1*I ],
   /* 6 */ [ -6-5*I,-6,-3+3*I,3*I,2+1*I,3-5*I,3-8*I,1-10*I,-10*I,-4-7*I ],
   /* 7 */ [ -11*I,-6-5*I,-6,-3+3*I,3*I,8-2*I,11-5*I,11-8*I,9-10*I,3-11*I ],
   /* 8 */ [ 11-11*I,-11*I,-6-5*I,-6,-3+3*I,11+6*I,16+6*I,19+3*I,19,14-8*I ],
   /* 9 */ [ 22,11-11*I,-11*I,-6-5*I,-6,5+16*I,11+22*I,16+22*I,19+19*I,22+5*I ],
   /* 10 */ [ 22+21*I,22,11-11*I,-11*I,-6-5*I,-11+21*I,-11+32*I,-5+38*I,38*I,16+27*I ],
   /* 11 */ [ 43*I,22+21*I,22,11-11*I,-11*I,-32+10*I,-43+21*I,-43+32*I,-37+38*I,-11+43*I ],
   /* 12 */ [ -43+43*I,43*I,22+21*I,22,11-11*I,-43-22*I,-64-22*I,-75-11*I,-75,-54+32*I ],
   /* 13 */ [ -86,-43+43*I,43*I,22+21*I,22,-21-64*I,-43-86*I,-64-86*I,-75-75*I,-86-21*I ],
   /* 14 */ [ -86-85*I,-86,-43+43*I,43*I,22+21*I,43-85*I,43-128*I,21-150*I,-150*I,-64-107*I ],
   /* 15 */ [ -171*I,-86-85*I,-86,-43+43*I,43*I,128-42*I,171-85*I,171-128*I,149-150*I,43-171*I ],
   /* 16 */ [ 171-171*I,-171*I,-86-85*I,-86,-43+43*I,171+86*I,256+86*I,299+43*I,299,214-128*I ],
   /* 17 */ [ 342,171-171*I,-171*I,-86-85*I,-86,85+256*I,171+342*I,256+342*I,299+299*I,342+85*I ],
   /* 18 */ [ 342+341*I,342,171-171*I,-171*I,-86-85*I,-171+341*I,-171+512*I,-85+598*I,598*I,256+427*I ],
   /* 19 */ [ 683*I,342+341*I,342,171-171*I,-171*I,-512+170*I,-683+341*I,-683+512*I,-597+598*I,-171+683*I ],
   /* 20 */ [ -683+683*I,683*I,342+341*I,342,171-171*I,-683-342*I,-1024-342*I,-1195-171*I,-1195,-854+512*I ],
   /* 21 */ [ -1366,-683+683*I,683*I,342+341*I,342,-341-1024*I,-683-1366*I,-1024-1366*I,-1195-1195*I,-1366-341*I ],
   /* 22 */ [ -1366-1365*I,-1366,-683+683*I,683*I,342+341*I,683-1365*I,683-2048*I,341-2390*I,-2390*I,-1024-1707*I ],
   /* 23 */ [ -2731*I,-1366-1365*I,-1366,-683+683*I,683*I,2048-682*I,2731-1365*I,2731-2048*I,2389-2390*I,683-2731*I ],
   /* 24 */ [ 2731-2731*I,-2731*I,-1366-1365*I,-1366,-683+683*I,2731+1366*I,4096+1366*I,4779+683*I,4779,3414-2048*I ],
   /* 25 */ [ 5462,2731-2731*I,-2731*I,-1366-1365*I,-1366,1365+4096*I,2731+5462*I,4096+5462*I,4779+4779*I,5462+1365*I ],
   /* 26 */ [ 5462+5461*I,5462,2731-2731*I,-2731*I,-1366-1365*I,-2731+5461*I,-2731+8192*I,-1365+9558*I,9558*I,4096+6827*I ],
   /* 27 */ [ 10923*I,5462+5461*I,5462,2731-2731*I,-2731*I,-8192+2730*I,-10923+5461*I,-10923+8192*I,-9557+9558*I,-2731+10923*I ],
   /* 28 */ [ -10923+10923*I,10923*I,5462+5461*I,5462,2731-2731*I,-10923-5462*I,-16384-5462*I,-19115-2731*I,-19115,-13654+8192*I ],
   /* 29 */ [ -21846,-10923+10923*I,10923*I,5462+5461*I,5462,-5461-16384*I,-10923-21846*I,-16384-21846*I,-19115-19115*I,-21846-5461*I ],
   /* 30 */ [ -21846-21845*I,-21846,-10923+10923*I,10923*I,5462+5461*I,10923-21845*I,10923-32768*I,5461-38230*I,-38230*I,-16384-27307*I ],
   /* 31 */ [ -43691*I,-21846-21845*I,-21846,-10923+10923*I,10923*I,32768-10922*I,43691-21845*I,43691-32768*I,38229-38230*I,10923-43691*I ],
   /* 32 */ [ 43691-43691*I,-43691*I,-21846-21845*I,-21846,-10923+10923*I,43691+21846*I,65536+21846*I,76459+10923*I,76459,54614-32768*I ],
   /* 33 */ [ 87382,43691-43691*I,-43691*I,-21846-21845*I,-21846,21845+65536*I,43691+87382*I,65536+87382*I,76459+76459*I,87382+21845*I ],
   /* 34 */ [ 87382+87381*I,87382,43691-43691*I,-43691*I,-21846-21845*I,-43691+87381*I,-43691+131072*I,-21845+152918*I,152918*I,65536+109227*I ],
   /* 35 */ [ 174763*I,87382+87381*I,87382,43691-43691*I,-43691*I,-131072+43690*I,-174763+87381*I,-174763+131072*I,-152917+152918*I,-43691+174763*I ],
   /* 36 */ [ -174763+174763*I,174763*I,87382+87381*I,87382,43691-43691*I,-174763-87382*I,-262144-87382*I,-305835-43691*I,-305835,-218454+131072*I ],
   /* 37 */ [ -349526,-174763+174763*I,174763*I,87382+87381*I,87382,-87381-262144*I,-174763-349526*I,-262144-349526*I,-305835-305835*I,-349526-87381*I ],
   /* 38 */ [ -349526-349525*I,-349526,-174763+174763*I,174763*I,87382+87381*I,174763-349525*I,174763-524288*I,87381-611670*I,-611670*I,-262144-436907*I ],
   /* 39 */ [ -699051*I,-349526-349525*I,-349526,-174763+174763*I,174763*I,524288-174762*I,699051-349525*I,699051-524288*I,611669-611670*I,174763-699051*I ],
   /* 40 */ [ 699051-699051*I,-699051*I,-349526-349525*I,-349526,-174763+174763*I,699051+349526*I,1048576+349526*I,1223339+174763*I,1223339,873814-524288*I ],
   /* 41 */ [ 1398102,699051-699051*I,-699051*I,-349526-349525*I,-349526,349525+1048576*I,699051+1398102*I,1048576+1398102*I,1223339+1223339*I,1398102+349525*I ],
   /* 42 */ [ 1398102+1398101*I,1398102,699051-699051*I,-699051*I,-349526-349525*I,-699051+1398101*I,-699051+2097152*I,-349525+2446678*I,2446678*I,1048576+1747627*I ],
   /* 43 */ [ 2796203*I,1398102+1398101*I,1398102,699051-699051*I,-699051*I,-2097152+699050*I,-2796203+1398101*I,-2796203+2097152*I,-2446677+2446678*I,-699051+2796203*I ],
   /* 44 */ [ -2796203+2796203*I,2796203*I,1398102+1398101*I,1398102,699051-699051*I,-2796203-1398102*I,-4194304-1398102*I,-4893355-699051*I,-4893355,-3495254+2097152*I ],
   /* 45 */ [ -5592406,-2796203+2796203*I,2796203*I,1398102+1398101*I,1398102,-1398101-4194304*I,-2796203-5592406*I,-4194304-5592406*I,-4893355-4893355*I,-5592406-1398101*I ],
   /* 46 */ [ -5592406-5592405*I,-5592406,-2796203+2796203*I,2796203*I,1398102+1398101*I,2796203-5592405*I,2796203-8388608*I,1398101-9786710*I,-9786710*I,-4194304-6990507*I ],
   /* 47 */ [ -11184811*I,-5592406-5592405*I,-5592406,-2796203+2796203*I,2796203*I,8388608-2796202*I,11184811-5592405*I,11184811-8388608*I,9786709-9786710*I,2796203-11184811*I ],
   /* 48 */ [ 11184811-11184811*I,-11184811*I,-5592406-5592405*I,-5592406,-2796203+2796203*I,11184811+5592406*I,16777216+5592406*I,19573419+2796203*I,19573419,13981014-8388608*I ],
   /* 49 */ [ 22369622,11184811-11184811*I,-11184811*I,-5592406-5592405*I,-5592406,5592405+16777216*I,11184811+22369622*I,16777216+22369622*I,19573419+19573419*I,22369622+5592405*I ],
   /* 50 */ [ 22369622+22369621*I,22369622,11184811-11184811*I,-11184811*I,-5592406-5592405*I,-11184811+22369621*I,-11184811+33554432*I,-5592405+39146838*I,39146838*I,16777216+27962027*I ]
 ]};

gp_inline__location="../dragon.tex:38442";
 \\ for k>=6
 P1_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][1]);
 P2_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][2]);
 P3_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][3]);
 P4_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][4]);
 P5_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][5]);
 P6_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][6]);
 P7_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][7]);
 P8_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][8]);
 P9_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][9]);
 P10_samples = vector(#gen_convex_hull_values-6,i, gen_convex_hull_values[i+6][10]);

gp_inline__location="../dragon.tex:38534";
 P1(k) = {
   k>=0 || error("P1 is for k>=0, got ",k);
   -1/3 * (b^(k+3) + p(k+3));
 }

gp_inline__location="../dragon.tex:38543";
 P2_formula(k) = -1/3*( b^(k+2) + p(k+2) );
 P2(k) = {
   k>=0 || error("P2 is for k>=0, got ",k);
   P2_formula(k);
 }

gp_inline__location="../dragon.tex:38551";
 P3_formula(k) = -1/3*( b^(k+1) + p(k+1) );
 P3(k) = {
   k>=0 || error("P3 is for k>=0, got ",k);
   P3_formula(k);
 }

gp_inline__location="../dragon.tex:38560";
 P4(k) = {
   k>=0 || error("P4 is for k>=0, got ",k);
   -1/3 * (b^k + p(k));
 }

gp_inline__location="../dragon.tex:38567";
 P5(k) = {
   k>=0 || error("P5 is for k>=0, got ",k);
   -1/3 * (b^(k-1) + p(k-1));
 }

gp_inline__location="../dragon.tex:38580";
 P6(k) = {
   k>=0 || error("P6 is for k>=0, got ",k);
   1/3 * (  (2+I)*b^k     + I*p(k+1));
 }

gp_inline__location="../dragon.tex:38610";
 P7(k) = {
   k>=0 || error("P7 is for k>=0, got ",k);
   (  (3+I)*b^k     + I*p(k  )) /3;
 }

gp_inline__location="../dragon.tex:38632";
 P8(k) = {
   k>=0 || error("P8 is for k>=0, got ",k);
   1/3 * ((3 + 4*I) * b^(k-1)  + I*p(k-1));
 }

gp_inline__location="../dragon.tex:38658";
 P9(k) = {
   k>=0 || error("P9 is for k>=0, got ",k);
   (   7*I *b^(k-2) + I*p(k-2)) /3;
 }

gp_inline__location="../dragon.tex:38678";
 P10(k) = {
   k>=0 || error("P10 is for k>=0");
   (  (4+I)*b^(k-1) +   p(k)  ) /3;
 }

gp_inline__location="../dragon.tex:38715";
 p_vector = [ -1, -b, -b^2, -b^3-3, \
               1,  b,  b^2,  b^3+3 ];
 p(m) = vector_modulo(p_vector,m);

gp_inline__location="../dragon.tex:38719";
 A118831_annotation_vector = {[0,1,-1,-1,0,-1,1,1]};

gp_inline__location="../dragon.tex:38772";
 hull_k0 = [0, 1];
 hull_k1 = [0, 1, 1+I];
 hull_k2 = [0, 1, 1+I, 2*I];
 hull_k3 = [0, 1, 1+I, 2*I, -2+2*I, -2+I];
 hull_k4 = [1, 1+I, 2*I, -3+2*I, -4, -4-I, -3-I];
 hull_k5 = [1, 1+I, 2*I, -3+2*I, -5, -5-I, -4-5*I, -3-5*I, -2-4*I];
 hull_initial = [hull_k0, hull_k1, hull_k2, hull_k3, hull_k4, hull_k5];
 \\ Return a vector of complex number vertices of the convex hull,
 \\ going anti-clockwise around: P10, P9, ..., P1.
 hull(k) = {
   if(k<6, hull_initial[k+1],
           [ P10(k), P9(k), P8(k), P7(k), P6(k),
              P5(k), P4(k), P3(k), P2(k), P1(k) ]);
 }

gp_inline__location="../dragon.tex:38877";
 Benedek_Panzone_P1  = (2 + 2*I)/3;
 Benedek_Panzone_P2  = (    2*I)/3;
 Benedek_Panzone_P3  = (-1 +  I)/3;
 Benedek_Panzone_P4  = (-1     )/3;
 Benedek_Panzone_P5  = (-1 -  I)/6;
 Benedek_Panzone_P6  = (2  -  I)/3;
 Benedek_Panzone_P7  = (3  -  I)/3;
 Benedek_Panzone_P8  = (7  -  I)/6;
 Benedek_Panzone_P9  = (7      )/6;
 Benedek_Panzone_P10 = (5 + 3*I)/6;
 P1_limit =  2/3 - 2/3*I;
 P2_limit =      - 2/3*I;
 P3_limit = -1/3 - 1/3*I;
 P4_limit = -1/3;
 P5_limit = -1/6 + 1/6*I;
 P6_limit =  2/3 + 1/3*I;
 P7_limit =  1   + 1/3*I;
 P8_limit =  7/6 + 1/6*I;
 P9_limit =  7/6;
 P10_limit = 5/6 - 1/2*I;

gp_inline__location="../dragon.tex:39377";
 P5_sub_P4_ref(k) = (P5(k) - P4(k))/b^(k+1);
 P5_sub_P4(k) = 1/6 + (p(k) - p(k-1))/(3*b^(k+1));

gp_inline__location="../dragon.tex:39408";
 P6_above_P5(k) = \
   1/6 + 1/3* vector_modulo([1, -1,-1, 1],k) * (1/2)^ceil(k/2);

gp_inline__location="../dragon.tex:39476";
 p_numerator(k) = -90 + (k-1)*45;
 p_denominator(k) = (k+1)*45;

gp_inline__location="../dragon.tex:39496";
 p_diff_div(k) = (p(k-1) - p(k))/b^(k+1);

gp_inline__location="../dragon.tex:39521";
 P7b(k) = b^(k+1) - I*P7(k);
 P8b(k) = b^(k+1) - I*P8(k);

gp_inline__location="../dragon.tex:39546";
 P1_by_mutual(k) = b^k - I*P7(k-1);
 P2_by_mutual(k) =         P1(k-1);
 P3_by_mutual(k) =         P2(k-1);
 P4_by_mutual(k) =         P3(k-1);
 P5_by_mutual(k) =         P4(k-1);
 P6_by_mutual(k) = b^k - I*P2(k-1);
 P7_by_mutual(k) = b^k - I*P3(k-1);
 P8_by_mutual(k) = b^k - I*P4(k-1);
 P9_by_mutual(k) = b^k - I*P5(k-1);
 P10_by_mutual(k) = b^k - I*P6(k-1);

gp_inline__location="../dragon.tex:39569";
 g_b_power_plus(x,n) = 1/(1-b*x)*b^n;
 g_b_power(x) = g_b_power_plus(x,0);

gp_inline__location="../dragon.tex:39573";
 g_p_plus(x,n) = 1/(1-x^8) * Polrev(vector(8,k,k--; p(k+n)));

gp_inline__location="../dragon.tex:39576";
 gP1(x) = -1/3*(g_b_power_plus(x,3) + g_p_plus(x,3));
 gP2(x) = -1/3*(g_b_power_plus(x,2) + g_p_plus(x,2));
 gP3(x) = -1/3*(g_b_power_plus(x,1) + g_p_plus(x,1));
 gP4(x) = -1/3*(g_b_power_plus(x,0) + g_p_plus(x,0));
 gP5(x) = -1/3*(g_b_power_plus(x,-1) + g_p_plus(x,-1));
 gP6(x) =  1/3*((2+I)*g_b_power_plus(x,0) + I*g_p_plus(x,1));
 gP7(x) =  1/3*((3+I)*g_b_power_plus(x,0) + I*g_p_plus(x,0));
 gP8(x) =  1/3*((3+4*I)*g_b_power_plus(x,-1) + I*g_p_plus(x,-1));
 gP9(x) =  1/3*((  7*I)*g_b_power_plus(x,-2) + I*g_p_plus(x,-2));
 gP10(x) =  1/3*((4+I)*g_b_power_plus(x,-1) + g_p_plus(x,0));

gp_inline__location="../dragon.tex:39598";
 gP_vector = [gP1(x), gP2(x), gP3(x), gP4(x), gP5(x), \
              gP6(x), gP7(x), gP8(x), gP9(x), gP10(x)];

gp_inline__location="../dragon.tex:39612";
 \\  1    2    3    4    5    6    7  8  9 10
 gP_matrix = {
   [ 1,   0,   0,   0,   0,   0, I*x, 0, 0, 0;  /* 1 */
    -x,   1,   0,   0,   0,   0,   0, 0, 0, 0;  /* 2 */
     0,  -x,   1,   0,   0,   0,   0, 0, 0, 0;  /* 3 */
     0,   0,  -x,   1,   0,   0,   0, 0, 0, 0;  /* 4 */
     0,   0,   0,  -x,   1,   0,   0, 0, 0, 0;  /* 5 */
     0, I*x,   0,   0,   0,   1,   0, 0, 0, 0;  /* 6 */
     0,   0, I*x,   0,   0,   0,   1, 0, 0, 0;  /* 7 */
     0,   0,   0, I*x,   0,   0,   0, 1, 0, 0;  /* 8 */
     0,   0,   0,   0, I*x,   0,   0, 0, 1, 0;  /* 9 */
     0,   0,   0,   0,   0, I*x,   0, 0, 0, 1   /* 10 */
   ]; }
 gP_matrix_vector = {
   [ g_b_power(x) - 1 + P1(0),  /*  1 */
                        P2(0),  /*  2 */
                        P3(0),  /*  3 */
                        P4(0),  /*  4 */
                        P5(0),  /*  5 */
     g_b_power(x) - 1 + P6(0),  /*  6 */
     g_b_power(x) - 1 + P7(0),  /*  7 */
     g_b_power(x) - 1 + P8(0),  /*  8 */
     g_b_power(x) - 1 + P9(0),  /*  9 */
     g_b_power(x) - 1 + P10(0)  /* 10 */
   ]; }

gp_inline__location="../dragon.tex:39639";
 gP_vector_by_matsolve = \
   Vec(matsolve(gP_matrix, Col(gP_matrix_vector)));

gp_inline__location="../dragon.tex:39719";
 P1_by_terms(k) = {
   my(r = (k-6)%4, q = (k-6-r)/4);
   my(total = (-1)^q*P1(6+r), i=k-1, s=1);
   for(j=1,q,   \\ q many terms
       total += s*b^i; i-=4; s*=-1);
   if(i != r+9 - 4, error("oops, expected i=",r+9-4," got ",i));
   total;
 }

gp_inline__location="../dragon.tex:39756";
 P1_by_sum(k) = {
   my(r=(k-6)%4, q=(k-6-r)/4);
   (-1)^q * P1(r+6)
   + b^(r+9) * sum(j=0,q-1, (b^4)^(q-1-j)*(-1)^j);
 }

gp_inline__location="../dragon.tex:39764";
 P1_from_power(k) = {
   my(r=(k-6)%4, q=(k-6-r)/4);
   (-1)^q * P1(r+6)
   + b^(r+9) * ((b^4)^q - (-1)^q) / (b^4 - (-1));
 }

gp_inline__location="../dragon.tex:39779";
 P1_by_power(k) = {
   my(r=(k-6)%4, q=(k-6-r)/4);
   (-1)^q * P1(r+6)
   - 1/3 * b^(r+9) * ((b^4)^q - (-1)^q);
 }

gp_inline__location="../dragon.tex:39787";
 P1_by_power_r_q(k) = {
   my(r=(k-6)%4, q=(k-6-r)/4);
   - 1/3 * (  b^(r+9) * (b^4)^q
            - b^(r+9) * (-1)^q
            - 3*(-1)^q * P1(r+6)   );
 }

gp_inline__location="../dragon.tex:39806";
 P1_by_net(k) = {
   my(r=(k-6)%4, q=(k-6-r)/4);
   - 1/3 * (  b^(k+3)
            - b^(r+9) * (-1)^q
            - 3*(-1)^q * P1(r+6)   );
 }

gp_inline__location="../dragon.tex:39847";
 p_of_k_plus_3_from_P1_right(k) = {
   my(r=(k-6)%4); my(q=(k-6-r)/4);
   - b^(r+9) * (-1)^q
   - 3*(-1)^q * P1(r+6);
 }

gp_inline__location="../dragon.tex:40059";
 P6_to_P2_offset(k) = b/6*(b*p(k+1) - p(k+2));

gp_inline__location="../dragon.tex:40086";
 P7_P3_offset(k) = 1/6*b*(b*p(k) - p(k+1));

gp_inline__location="../dragon.tex:40099";
 P7_P3_offset_vector = [0, 0, 1/2+1/2*I, 1/2-1/2*I, 0, 0, -1/2-1/2*I, -1/2+1/2*I];

gp_inline__location="../dragon.tex:40104";
 P7_from_P3_offset(k) = b^k - b/2*P3(k) + P7_P3_offset(k);

gp_inline__location="../dragon.tex:40107";
 b_p_minus_p1_on3(k) = (b*p(k) - p(k+1))/3;
 b_p_minus_p1_on3_samples = [0, 0, 1, -I, 0, 0, -1, I];

gp_inline__location="../dragon.tex:40112";
 P7_with_b_p(k) = b^k - b/2*P3(k) + 1/2*b*( (b*p(k) - p(k+1))/3 );

gp_inline__location="../dragon.tex:40117";
 rotate_R(z,k) = b^k - 1/2*b*z;
 P6_minus_P2_R(k) = P6(k) - rotate_R(P2(k),k);
 P7_minus_P3_R(k) = P7(k) - rotate_R(P3(k),k);
 P8_minus_P4_R(k) = P8(k) - rotate_R(P4(k),k);
 P9_minus_P5_R(k) = P9(k) - rotate_R(P5(k),k);
 P10_minus_P6_R(k) = P10(k) - rotate_R(P6(k),k);

gp_inline__location="../dragon.tex:40289";
 P1N_factor = {(8)/(15)};

gp_inline__location="../dragon.tex:40294";
 P1N_vector = {[7,-1,-2,-4]};
 P1N(k) = P1N_factor*2^k + 1/15*vector_modulo(P1N_vector,k);

gp_inline__location="../dragon.tex:40300";
 P1N_samples = {[1,1,2,4,9,17,34,68,137,273,546,1092]};

gp_inline__location="../dragon.tex:40309";
 A115451(n) = P1N(n);

gp_inline__location="../dragon.tex:40321";
 P1N_binary_vector(k) = {
   k--; concat(concat_repeat([1,0,0,0],k\4),
               vector_modulo([[1],[1,0],[1,0,0],[1,0,0,1]],k));
 }
 P1N_by_binary(k) = from_binary_vector(P1N_binary_vector(k));

gp_inline__location="../dragon.tex:40331";
 P2N_factor = {(4)/(15)};

gp_inline__location="../dragon.tex:40336";
 P2N_vector = {[-4,7,-1,-2]};
 P2N(k) = P2N_factor*2^k + 1/15*vector_modulo(P2N_vector,k);

gp_inline__location="../dragon.tex:40345";
 P3N_factor = {(2)/(15)};

gp_inline__location="../dragon.tex:40350";
 P3N_vector = {[-2,-4,7,-1]};
 P3N(k) = P3N_factor*2^k + 1/15*vector_modulo(P3N_vector,k);

gp_inline__location="../dragon.tex:40360";
 P4N_factor = {(1)/(15)};

gp_inline__location="../dragon.tex:40365";
 P4N_vector = {[-1,-2,-4,7]};
 P4N(k) = P4N_factor*2^k + 1/15*vector_modulo(P4N_vector,k);

gp_inline__location="../dragon.tex:40375";
 P5N_factor = {(1)/(30)};

gp_inline__location="../dragon.tex:40380";
 P5N_vector = {[7,-1,-2,-4]};
 P5N(k) = P5N_factor*2^k + 1/15*vector_modulo(P5N_vector,k);

gp_inline__location="../dragon.tex:40390";
 P6N_factor = {(13)/(15)};

gp_inline__location="../dragon.tex:40395";
 P6N_vector = {[2,4,-7,1]};
 P6N(k) = P6N_factor*2^k + 1/15*vector_modulo(P6N_vector,k);

gp_inline__location="../dragon.tex:40403";
 P6N_samples = {[1,2,3,7,14,28,55,111,222,444,887,1775]};

gp_inline__location="../dragon.tex:40410";
 P7N_factor = {(14)/(15)};

gp_inline__location="../dragon.tex:40415";
 P7N_vector = {[1,2,4,-7]};
 P7N(k) = P7N_factor*2^k + 1/15*vector_modulo(P7N_vector,k);

gp_inline__location="../dragon.tex:40423";
 P7N_samples = {[1,2,4,7,15,30,60,119,239,478,956,1911]};

gp_inline__location="../dragon.tex:40430";
 P8N_factor = {(29)/(30)};

gp_inline__location="../dragon.tex:40435";
 P8N_vector = {[-7,1,2,4]};
 P8N(k) = P8N_factor*2^k + 1/15*vector_modulo(P8N_vector,k);

gp_inline__location="../dragon.tex:40445";
 P9N_factor = {(59)/(60)};

gp_inline__location="../dragon.tex:40450";
 P9N_vector = {[4,-7,1,2]};
 P9N(k) = P9N_factor*2^k + 1/15*vector_modulo(P9N_vector,k);

gp_inline__location="../dragon.tex:40460";
 P10N_factor = {(17)/(30)};

gp_inline__location="../dragon.tex:40465";
 P10N_vector = {[-1,-2,-4,7]};
 P10N(k) = P10N_factor*2^k + 1/15*vector_modulo(P10N_vector,k);

gp_inline__location="../dragon.tex:40494";
 gP1N(x) = 1/((1+x)*(1+x^2)*(1-2*x));

gp_inline__location="../dragon.tex:40576";
 PN_vector = [P1N,P2N,P3N,P4N,P5N,P6N,P7N,P8N,P9N,P10N];

gp_inline__location="../dragon.tex:40755";
 HA_initial_vector = {[0,(1)/(2)]};

gp_inline__location="../dragon.tex:40762";
 HAf = {7/6};

gp_inline__location="../dragon.tex:40767";
 HA_half_vector = {[22,29,22,31]};

gp_inline__location="../dragon.tex:40772";
 HA_constant_vector = {[1,2,3,2]};

gp_inline__location="../dragon.tex:40778";
 HA_formula(k) = {
   7/6 * 2^k
   - 1/12 * vector_modulo(HA_half_vector,k) * 2^floor(k/2)
   + 1/6  * vector_modulo(HA_constant_vector,k);
 }
 HA(k) = {
   k>=0 || error("HA() is for k>=0");
   if(k<#HA_initial_vector, HA_initial_vector[k+1], HA_formula(k));
 }

gp_inline__location="../dragon.tex:40811";
HA_samples_text = {[0,(1)/(2),(3)/(2),(9)/(2),(23)/(2),28,(121)/(2),129,(539)/(2),559,(2273)/(2),2307]};

gp_inline__location="../dragon.tex:40839";
 A341029(n) = 2*HA(n);

gp_inline__location="../dragon.tex:40860";
 gHA(x) = {
   1/2 + (1/4)*x
   + (1/3)/(1-x)
   - (1/6)/(1 + x^2)
   + (1/12)*x/(1 + 2*x^2)
   - (11/6 + 5/2*x)/(1-2*x^2)
   + (7/6)/(1-2*x);
 }

gp_inline__location="../dragon.tex:40903";
 gA341029(x) = 2*gHA(x);

gp_inline__location="../dragon.tex:40946";
 HAf_sample = {(01666/10000)};

gp_inline__location="../dragon.tex:40956";
 /* Anti-clockwise around, with their conjugate. */
 Benedek_Panzone_hull = [ \
   Benedek_Panzone_P1,   \
   Benedek_Panzone_P2,   \
   Benedek_Panzone_P3,   \
   Benedek_Panzone_P4,   \
   Benedek_Panzone_P5,   \
   Benedek_Panzone_P6,   \
   Benedek_Panzone_P7,   \
   Benedek_Panzone_P8,   \
   Benedek_Panzone_P9,   \
   Benedek_Panzone_P10 ];

gp_inline__location="../dragon.tex:40970";
 \\ vector of complex number hull vertices,
 \\ in order P10, P9, ..., P1, which is same as hull(k)
 hull_fractal = Vecrev(conj(Benedek_Panzone_hull));

gp_inline__location="../dragon.tex:41001";
 eHA_formula(k) = {
   1/12*vector_modulo([15, 14, 13, 18],k) * 2^floor(k/2)
   - 1/6*vector_modulo([0, 1, 4, 3],k);
 }
 eHA(k) = if(k<=1,1/2, eHA_formula(k));

gp_inline__location="../dragon.tex:41011";
 eHA_samples = {[1/2,1/2,3/2,5/2,5,9/2,8,(23)/(2),20,(37)/(2)]};

gp_inline__location="../dragon.tex:41059";
 Hdiam_squared_formula(k) = \
   5/2*2^k - vector_modulo([3, 4],k)*2^floor(k/2) + 1;
 Hdiam_squared(k) = if(k==0,1, Hdiam_squared_formula(k));

gp_inline__location="../dragon.tex:41064";
 Hdiam_inexact(k) = sqrt(Hdiam_squared(k));
 P3_sub_P7_norm(k) = norm(P3(k)-P7(k));
 P3_sub_P8_norm(k) = norm(P3(k)-P8(k));

gp_inline__location="../dragon.tex:41072";
 Hdiam_squared_samples = {[1,2,5,13,29,65,137,289,593,1217,2465]};

gp_inline__location="../dragon.tex:41123";
 pmax_norm = vecmax(vector(8,m, norm(1/3*p(m))));
 pmax_inexact = sqrt(pmax_norm);

gp_inline__location="../dragon.tex:41182";
 Hdiam_diff(k) = (sqrt(5/2) - sqrt(85/36))*sqrt(2)^k - 4*pmax_inexact;

gp_inline__location="../dragon.tex:41334";
 Hdiam_rotation(k) = I^-ceil(k/2);

gp_inline__location="../dragon.tex:41340";
 Hdiam_x(k) = real( (P8(k)-P3(k))*Hdiam_rotation(k) );

gp_inline__location="../dragon.tex:41346";
 Hdiam_x_powers(k) = vector_modulo([3/2, 1],k) * 2^ceil(k/2) - 1;

gp_inline__location="../dragon.tex:41370";
 Hdiam_y(k) = abs(imag( (P8(k)-P3(k))*Hdiam_rotation(k) ));

gp_inline__location="../dragon.tex:41374";
 Hdiam_y_powers(k) = 1/2 * 2^ceil(k/2);

gp_inline__location="../dragon.tex:41439";
 vector_chop_end(v,n) = v[1 .. #v-n];

gp_inline__location="../dragon.tex:41505";
 Hdiamf = geom_sqrt_as_quad(5/2);
 Hdiamf_sample = {(1581138/1000000)};

gp_inline__location="../dragon.tex:41532";
 SdistN_by_dragon_points(k) = \
   my(n); vecmax(apply(norm,dragon_points(k)),&n); n-1;

gp_inline__location="../dragon.tex:41536";
 EdistN_by_dragon_points(k) = {
   my(e = b^k, n);
   vecmax(apply(z->norm(e-z),dragon_points(k)),&n); n-1;
 }

gp_inline__location="../dragon.tex:41605";
 Sdist_half = {[13,8,8,16]};

gp_inline__location="../dragon.tex:41610";
 Sdist_constant = {[5,1,2,4]};

gp_inline__location="../dragon.tex:41616";
 SdistSquared_formula(k) = {
   25/18 * 2^k
   - 1/9 * vector_modulo(Sdist_half,k) * 2^floor(k/2)
   + 1/9 * vector_modulo(Sdist_constant,k);
 }
 SdistSquared(k) = if(k==0,1, SdistSquared_formula(k));

gp_inline__location="../dragon.tex:41628";
 SdistSquared_samples = {[1,2,4,8,17,41,82,164,333,697]};

gp_inline__location="../dragon.tex:41649";
 Edist_half = {[5,10,7,5]};

gp_inline__location="../dragon.tex:41654";
 Edist_constant = {[2,4,5,1]};

gp_inline__location="../dragon.tex:41658";
 EdistSquared(k) = {
   17/9 * 2^k
   - 2/9 * vector_modulo(Edist_half,k) * 2^floor(k/2)
   + 1/9 * vector_modulo(Edist_constant,k);
 }

gp_inline__location="../dragon.tex:41668";
 EdistSquared_samples = {[1,2,5,13,26,52,109,233,466,932]};

gp_inline__location="../dragon.tex:41682";
 odd_part(n) = if(n==0,0, n / 2^valuation(n,2));

gp_inline__location="../dragon.tex:41722";
 Sdist_rotation(k) = I^-ceil(k/2);
 Sdist_x(k) = real( P8(k)*Sdist_rotation(k) );
 Sdist_y(k) = imag( P8(k)*Sdist_rotation(k) );

gp_inline__location="../dragon.tex:41736";
 Edist_rotation(k) = I^-ceil(k/2);
 Edist_x(k) = real( (b^k-P3(k))*Edist_rotation(k) );
 Edist_y(k) = imag( (b^k-P3(k))*Edist_rotation(k) );

gp_inline__location="../dragon.tex:41753";
 Sdist_limit = 5/6 * geom_sqrt_as_quad(2);

gp_inline__location="../dragon.tex:41757";
 Sdist_limit_sample = {(1178511/1000000)};

gp_inline__location="../dragon.tex:41773";
 Edist_limit = 1/3 * geom_sqrt_as_quad(17);

gp_inline__location="../dragon.tex:41776";
 Edist_limit_sample = {(1374368/1000000)};

gp_inline__location="../dragon.tex:41803";
 Pv_generated_samples = {[
   [1,1],  /* k=0 */
   [1,1,1],  /* k=1 */
   [1,1,2,1],  /* k=2 */
   [1,1,1,1,1,2],  /* k=3 */
   [1,1,1,1,1,1,3],  /* k=4 */
   [1,3,1,1,1,1,1,1,1],  /* k=5 */
   [3,1,3,1,1,3,1,1,1,1],  /* k=6 */
   [3,3,1,3,1,1,3,1,1,3],  /* k=7 */
   [7,3,3,1,1,3,1,3,1,1],  /* k=8 */
   [3,7,3,3,1,3,3,1,1,3],  /* k=9 */
   [7,3,7,3,1,7,3,3,1,3],  /* k=10 */
   [7,7,3,7,1,3,7,3,1,7],  /* k=11 */
   [15,7,7,3,1,7,3,7,1,3],  /* k=12 */
   [7,15,7,7,1,7,7,3,1,7],  /* k=13 */
   [15,7,15,7,1,15,7,7,1,7],  /* k=14 */
   [15,15,7,15,1,7,15,7,1,15],  /* k=15 */
   [31,15,15,7,1,15,7,15,1,7],  /* k=16 */
   [15,31,15,15,1,15,15,7,1,15],  /* k=17 */
   [31,15,31,15,1,31,15,15,1,15],  /* k=18 */
   [31,31,15,31,1,15,31,15,1,31],  /* k=19 */
   [63,31,31,15,1,31,15,31,1,15],  /* k=20 */
   [31,63,31,31,1,31,31,15,1,31],  /* k=21 */
   [63,31,63,31,1,63,31,31,1,31],  /* k=22 */
   [63,63,31,63,1,31,63,31,1,63],  /* k=23 */
   [127,63,63,31,1,63,31,63,1,31],  /* k=24 */
   [63,127,63,63,1,63,63,31,1,63],  /* k=25 */
   [127,63,127,63,1,127,63,63,1,63],  /* k=26 */
   [127,127,63,127,1,63,127,63,1,127],  /* k=27 */
   [255,127,127,63,1,127,63,127,1,63],  /* k=28 */
   [127,255,127,127,1,127,127,63,1,127],  /* k=29 */
   [255,127,255,127,1,255,127,127,1,127]  /* k=30 */
 ]};
 Pgaps_generated_samples = {[
   [0,0],  /* k=0 */
   [0,0,0],  /* k=1 */
   [0,0,0,0],  /* k=2 */
   [0,0,0,1,0,0],  /* k=3 */
   [0,0,1,0,0,1,0],  /* k=4 */
   [1,0,0,0,1,0,0,1,0],  /* k=5 */
   [1,1,0,0,1,0,0,0,1,0],  /* k=6 */
   [1,1,1,0,1,1,0,0,1,0],  /* k=7 */
   [1,1,1,1,1,1,1,0,1,1],  /* k=8 */
   [3,1,1,1,1,1,1,1,1,1],  /* k=9 */
   [3,3,1,1,1,1,1,1,1,1],  /* k=10 */
   [3,3,3,1,1,3,1,1,1,1],  /* k=11 */
   [3,3,3,3,1,3,3,1,1,3],  /* k=12 */
   [7,3,3,3,1,3,3,3,1,3],  /* k=13 */
   [7,7,3,3,1,3,3,3,1,3],  /* k=14 */
   [7,7,7,3,1,7,3,3,1,3],  /* k=15 */
   [7,7,7,7,1,7,7,3,1,7],  /* k=16 */
   [15,7,7,7,1,7,7,7,1,7],  /* k=17 */
   [15,15,7,7,1,7,7,7,1,7],  /* k=18 */
   [15,15,15,7,1,15,7,7,1,7],  /* k=19 */
   [15,15,15,15,1,15,15,7,1,15],  /* k=20 */
   [31,15,15,15,1,15,15,15,1,15],  /* k=21 */
   [31,31,15,15,1,15,15,15,1,15],  /* k=22 */
   [31,31,31,15,1,31,15,15,1,15],  /* k=23 */
   [31,31,31,31,1,31,31,15,1,31],  /* k=24 */
   [63,31,31,31,1,31,31,31,1,31],  /* k=25 */
   [63,63,31,31,1,31,31,31,1,31],  /* k=26 */
   [63,63,63,31,1,63,31,31,1,31],  /* k=27 */
   [63,63,63,63,1,63,63,31,1,63],  /* k=28 */
   [127,63,63,63,1,63,63,63,1,63],  /* k=29 */
   [127,127,63,63,1,63,63,63,1,63]  /* k=30 */
 ]};
 HBP_generated_samples = [2,3,5,7,9,12,19,26,37,50,75,102,149,202,299,406,597,810,1195,1622,2389,3242,4779,6486,9557,12970,19115,25942,38229,51882,76459];
 HBV_generated_samples = [2,3,5,7,9,11,16,20,24,28,38,46,54,62,82,98,114,130,170,202,234,266,346,410,474,538,698,826,954,1082,1402];
 HBVgaps_generated_samples = [0,0,0,1,2,3,4,6,9,12,14,18,24,30,34,42,54,66,74,90,114,138,154,186,234,282,314,378,474,570,634];
 HBS_generated_samples = [1,2,3,4,5,5,7,8,10,10,14,16,20,20,28,32,40,40,56,64,80,80,112,128,160,160,224,256,320,320,448];

gp_inline__location="../dragon.tex:41898";
 HB_ones(k) = {
   1/6 * vector_modulo([9, 10],k) * 2^floor(k/2)
   + 2/3 * vector_modulo([0, -1, 0, 1],k);
 }
 z_is_straight(z) = real(z)==0 || imag(z)==0;
 HB_ones_by_hull(k) = {
   vecsum(apply(abs, select(z_is_straight,
                            geom_sides_of_polygon(hull(k)))));
 }

gp_inline__location="../dragon.tex:41923";
 HB_twos(k) = {
   1/6 * vector_modulo([5, 9],k) * 2^floor(k/2)
   - 1/3 * vector_modulo([7, 6, 5, 6],k);
 }
 z_is_diagonal(z) = abs(real(z)) == abs(imag(z));
 HB_twos_by_hull(k) = {
   vecsum(apply(z-> my(n=norm(z)/2);
                issquare(n,&n) || error("norm "n);
                n,
          select(z_is_diagonal, geom_sides_of_polygon(hull(k)))));
 }

gp_inline__location="../dragon.tex:41942";
 HB_vector(k) = [ HB_ones(k), HB_twos(k), \
                  P910norm(k), P910norm(k+1) ];
 HB_formula(k) = HB_ones(k) + sqrt(2)*HB_twos(k) \
                 + sqrt(P910norm(k)) + sqrt(P910norm(k+1));
 HB_inexact(k) = if(k==0,2, k==1,2+sqrt(2), HB_formula(k));

gp_inline__location="../dragon.tex:41972";
 P910norm(k) = {
   13/36 * 2^k
   + 1/9 * vector_modulo([-2, 11, 2, -11],k) * 2^floor(k/2)
   + 1/9 * vector_modulo([1, 5],k);
 }

gp_inline__location="../dragon.tex:41997";
 P910norm_samples = {[2,1,5,17,25,37,89,205,377,701]};

gp_inline__location="../dragon.tex:42176";
 HB_rotation(k) = I^-ceil(k/2);

gp_inline__location="../dragon.tex:42182";
 P910norm_x(k) = real( (P9(k)-P10(k))*HB_rotation(k) );

gp_inline__location="../dragon.tex:42185";
 P910norm_x_multiply = {[2,5]};

gp_inline__location="../dragon.tex:42192";
 P910norm_x_constant = {[-1,2,1,-2]};
 P910norm_x_powers(k) = {
   1/6*vector_modulo(P910norm_x_multiply,k)*2^floor(k/2)
   + 1/3 * vector_modulo(P910norm_x_constant,k);
 }

gp_inline__location="../dragon.tex:42203";
 P910norm_x_samples = {[1,1,1,4,3,6,5,14,11,26,21,54]};

gp_inline__location="../dragon.tex:42216";
 P910norm_y(k) = imag( (P9(k)-P10(k))*HB_rotation(k) );

gp_inline__location="../dragon.tex:42219";
 P910norm_y_multiply = {[1,1/3]};

gp_inline__location="../dragon.tex:42225";
 P910norm_y_constant = {[0,1,0,-1]};
 P910norm_y_powers(k) = {
   1/2*vector_modulo(P910norm_y_multiply,k) * 2^floor(k/2)
   + 1/3 * vector_modulo([0, 1, 0, -1],k);
 }

gp_inline__location="../dragon.tex:42236";
 P910norm_y_samples = {[1,0,2,1,4,1,8,3,16,5,32,11]};

gp_inline__location="../dragon.tex:42353";
 HBf_vector = [ 3/2, 5/6*sqrt2, 1/6*sqrt13, 1/6*sqrt26 ];
 HBf_inexact = vecsum(HBf_vector*1.0);

gp_inline__location="../dragon.tex:42370";
 HBf_symbolic = 3/2 + 5/6*'sqrt2 + 1/6*'sqrt13 + 1/6*'sqrt2*'sqrt13;

gp_inline__location="../dragon.tex:42395";
 HBf_poly(x) = 81*x^4 - 486*x^3 + 693*x^2 - 282*x + 17;

gp_inline__location="../dragon.tex:42406";
 HBf_sample = {(4129273/1000000)};

gp_inline__location="../dragon.tex:42547";
 HBP_power_vector = {[14,19]};

gp_inline__location="../dragon.tex:42553";
 HBP_constant_vector = {[-2,-4,2,4]};

gp_inline__location="../dragon.tex:42561";
 HBP(k) = {
   if(k==1, return(3));
   1/6*(vector_modulo(HBP_power_vector,k) * 2^floor(k/2)
        + vector_modulo(HBP_constant_vector,k));
 }
 HBP_by_hull(k) = boundary_numint_of_polygon(hull(k));

gp_inline__location="../dragon.tex:42569";
 HBP_samples = {[2,3,5,7,9,12,19,26,37,50,75,102,149,202]};

gp_inline__location="../dragon.tex:42580";
 A062092(n) = (7*2^n - (-1)^n)/3;

gp_inline__location="../dragon.tex:42589";
 Hessenberg_matrix(n) = {
   matrix(n,n,i,j, if(i==1 || i==j, 1,
                      j==i-1, -1,
                      0));
 }

gp_inline__location="../dragon.tex:42680";
 HIP(k) = HA(k) - 1/2*HBP(k) + 1;

gp_inline__location="../dragon.tex:42687";
 HIP_half_vector = {[18,24,18,25]};

gp_inline__location="../dragon.tex:42694";
 HIP_constant_vector = {[4,5,4,3]};

gp_inline__location="../dragon.tex:42699";
 HIP_by_powers_formula(k) = {
   7/6 * 2^k
   - 1/6 * vector_modulo(HIP_half_vector,k) * 2^floor(k/2)
   + 1/3*vector_modulo(HIP_constant_vector,k);
 }
 HIP_by_powers(k) = if(k==0,0, HIP_by_powers_formula(k));

gp_inline__location="../dragon.tex:42708";
 HIP_samples = {[0,0,0,2,8,23,52,117,252,535,1100,2257]};

gp_inline__location="../dragon.tex:42719";
 HP(k) = HIP(k) + HBP(k);

gp_inline__location="../dragon.tex:42722";
 HP_initial = {[2,3]};

gp_inline__location="../dragon.tex:42729";
 HP_half_vector = {[4,5,4,6]};

gp_inline__location="../dragon.tex:42736";
 HP_constant_vector = {[3,3,5,5]};

gp_inline__location="../dragon.tex:42741";
 HP_by_powers_formula(k) = {
   7/6 * 2^k
   - 1/6 * vector_modulo(HP_half_vector,k) * 2^floor(k/2)
   + 1/3*vector_modulo(HP_constant_vector,k);
 }
 HP_by_powers(k) = \
   if(k<#HP_initial,HP_initial[k+1], HP_by_powers_formula(k));

gp_inline__location="../dragon.tex:42752";
 HP_samples = {[2,3,5,9,17,35,71,143,289,585,1175,2359]};

gp_inline__location="../dragon.tex:42840";
 HBV_initial = {[2,3]};

gp_inline__location="../dragon.tex:42846";
 HBV_vector = {[15,17,22,26]};

gp_inline__location="../dragon.tex:42856";
 HBV_formula(k) = {
   1/2 * vector_modulo(HBV_vector,k) * 2^floor(k/4)
   - 6;
 }
 HBV(k) = if(k<#HBV_initial,HBV_initial[k+1], HBV_formula(k));

gp_inline__location="../dragon.tex:42864";
 HBV_samples = {[2,3,5,7,9,11,16,20,24,28,38,46,54,62,82,98]};

gp_inline__location="../dragon.tex:42901";
 P1v(k)  = if(k==6,3, P7v(k-1) + 1 + P10v(k-1));

gp_inline__location="../dragon.tex:42906";
 P6v(k)  = if(k==6,3, P2v(k-1));

gp_inline__location="../dragon.tex:42911";
 P2v(k)  = if(k==6,1, P1v(k-1));

gp_inline__location="../dragon.tex:42915";
 P7v(k)  = if(k==6,1, P3v(k-1));

gp_inline__location="../dragon.tex:42919";
 P3v(k)  = if(k==6,3, P2v(k-1));

gp_inline__location="../dragon.tex:42923";
 P8v(k)  = if(k==6,1, P4v(k-1));

gp_inline__location="../dragon.tex:42927";
 P4v(k)  = if(k==6,1, P3v(k-1));

gp_inline__location="../dragon.tex:42931";
 P9v(k)  = if(k==6,1, P5v(k-1));

gp_inline__location="../dragon.tex:42936";
 P5v(k)  = if(k==6,1, 1);

gp_inline__location="../dragon.tex:42940";
 P10v(k) = if(k==6,1, P6v(k-1));

gp_inline__location="../dragon.tex:42942";
 P1v  = memoize(P1v );
 P2v  = memoize(P2v );
 P3v  = memoize(P3v );
 P4v  = memoize(P4v );
 P5v  = memoize(P5v );
 P6v  = memoize(P6v );
 P7v  = memoize(P7v );
 P8v  = memoize(P8v );
 P9v  = memoize(P9v );
 P10v = memoize(P10v);
 Pv_functions = [ P1v,P2v,P3v,P4v,P5v,P6v,P7v,P8v,P9v,P10v ];
 Pv(i,k) = Pv_functions[i](k);
 Pv_row(k) = apply(f->f(k), Pv_functions);

gp_inline__location="../dragon.tex:42956";
 Pv_generated_samples_6up = Pv_generated_samples[6+1 .. #Pv_generated_samples];

gp_inline__location="../dragon.tex:42995";
 \\  1    2    3   4   5   6   7  8  9 10
 gPv_matrix = {
   [ 1,   0,   0,  0,  0,  0, -x, 0, 0, -x;  /* 1 */
    -x,   1,   0,  0,  0,  0,  0, 0, 0, 0;  /* 2 */
     0,  -x,   1,  0,  0,  0,  0, 0, 0, 0;  /* 3 */
     0,   0,  -x,  1,  0,  0,  0, 0, 0, 0;  /* 4 */
     0,   0,   0,  0,  1,  0,  0, 0, 0, 0;  /* 5 */
     0,  -x,   0,  0,  0,  1,  0, 0, 0, 0;  /* 6 */
     0,   0,  -x,  0,  0,  0,  1, 0, 0, 0;  /* 7 */
     0,   0,   0, -x,  0,  0,  0, 1, 0, 0;  /* 8 */
     0,   0,   0,  0, -x,  0,  0, 0, 1, 0;  /* 9 */
     0,   0,   0,  0,  0, -x,  0, 0, 0, 1   /* 10 */
   ]; }
 gPv_matrix_vector = {
   [ P1v(6)*x^6 + x^7/(1-x),  /*  1 */
     P2v(6)*x^6,              /*  2 */
     P3v(6)*x^6,              /*  3 */
     P4v(6)*x^6,              /*  4 */
     x^6/(1-x),               /*  5 */
     P6v(6)*x^6,              /*  6 */
     P7v(6)*x^6,              /*  7 */
     P8v(6)*x^6,              /*  8 */
     P9v(6)*x^6,              /*  9 */
     P10v(6)*x^6              /* 10 */
   ]; }
 gPv_vector = Vec(matsolve(gPv_matrix, Col(gPv_matrix_vector)));

gp_inline__location="../dragon.tex:43031";
 P1v_vector = {[2,1,2,2]};

gp_inline__location="../dragon.tex:43038";
 P1v_by_powers(k) = vector_modulo(P1v_vector,k)*2^floor(k/4) - 1;

gp_inline__location="../dragon.tex:43041";
 P1v_samples = {[3,3,7,3,7,7,15,7,15,15]};

gp_inline__location="../dragon.tex:43055";
 HBV_by_Pv(k) = sum(i=1,10, Pv(i,k));

gp_inline__location="../dragon.tex:43077";
 HBS_initial = {[1,2,3,4,5,5]};

gp_inline__location="../dragon.tex:43094";
 HBS(k) = {
   if(k<#HBS_initial, HBS_initial[k+1],
      k%2==0,   ceil(1/2*P1v(k)) + ceil(1/2*P3v(k))
              + ceil(1/2*P6v(k)) + ceil(1/2*P8v(k)) ,
                ceil(1/2*P2v(k)) + ceil(1/2*P4v(k))
              + ceil(1/2*P7v(k)) + ceil(1/2*P10v(k)));
 }

gp_inline__location="../dragon.tex:43103";
 HBS_by_powers_initial = {[1,2,3]};

gp_inline__location="../dragon.tex:43109";
 HBS_vector = {[5,5,7,8]};

gp_inline__location="../dragon.tex:43119";
 HBS_by_powers_formula(k) = \
   1/2 * vector_modulo(HBS_vector,k) * 2^floor(k/4);
 HBS_by_powers(k) = \
   if(k<#HBS_by_powers_initial, HBS_by_powers_initial[k+1], \
      HBS_by_powers_formula(k));

gp_inline__location="../dragon.tex:43135";
 HBS_samples = {[1,2,3,4,5,5,7,8,10,10,14,16,20,20,28,32]};

gp_inline__location="../dragon.tex:43160";
 HBVgaps_initial = {[0,0,0,1,2]};

gp_inline__location="../dragon.tex:43166";
 HBVgaps_multiply = {[15,18,20,24]};

gp_inline__location="../dragon.tex:43176";
 HBVgaps_formula(k) = {
   1/4 * vector_modulo(HBVgaps_multiply,k) * 2^floor(k/4)
   - 6;
 }
 HBVgaps(k) = if(k<#HBVgaps_initial,HBVgaps_initial[k+1], \
                 HBVgaps_formula(k));

gp_inline__location="../dragon.tex:43185";
 gHBVgaps_formula(x) = {
   1/4 * subst(Polrev(HBVgaps_multiply,'x),'x,x) * gTwoPow(x^4)
   - 6*gOnes(x);
 }

gp_inline__location="../dragon.tex:43192";
 gHBVgaps(x) = 9/4 + 3/2*x + x^2 + x^3 + 1/2*x^4 \
               + gHBVgaps_formula(x);

gp_inline__location="../dragon.tex:43197";
 HBVgaps_samples = {[0,0,0,1,2,3,4,6,9,12,14,18,24,30]};

gp_inline__location="../dragon.tex:43210";
 A061776(n) = {
   if(n==0, 1,
      n%2==0, n\=2;  6*2^n - 6,
              n\=2;  9*2^n - 6);
 }

gp_inline__location="../dragon.tex:43218";
 gfunc_select_odd(gfunc) = 1/2*(gfunc(x) - gfunc(-x));
 gpol_select_odd(p) = 1/2*(p - subst(p,'x,-'x));
 gA061776(x) = (1+2*x)*(1+x^2)/((1-x)*(1-2*x^2)); \\ by Colin Barker

gp_inline__location="../dragon.tex:43244";
 P10_to_P8dash(k) = (b^k-I*P8(k-1) - P10(k-1))/b^k *sqrt2^k;
 P8dash(k) = b^(k+1) - I*P8(k);

gp_inline__location="../dragon.tex:43266";
 P1gaps(k)  = if(k==6,1, P7gaps(k-1) + 1 + P10gaps(k-1));
 P2gaps(k)  = if(k==6,1, P1gaps(k-1));
 P3gaps(k)  = if(k==6,0, P2gaps(k-1));
 P4gaps(k)  = if(k==6,0, P3gaps(k-1));
 P5gaps(k)  = if(k==6,1, 1);
 P6gaps(k)  = if(k==6,0, P2gaps(k-1));
 P7gaps(k)  = if(k==6,0, P3gaps(k-1));
 P8gaps(k)  = if(k==6,0, P4gaps(k-1));
 P9gaps(k)  = if(k==6,1, P5gaps(k-1));
 P10gaps(k) = if(k==6,0, P6gaps(k-1));
 P1gaps  = memoize(P1gaps );
 P2gaps  = memoize(P2gaps );
 P3gaps  = memoize(P3gaps );
 P4gaps  = memoize(P4gaps );
 P5gaps  = memoize(P5gaps );
 P6gaps  = memoize(P6gaps );
 P7gaps  = memoize(P7gaps );
 P8gaps  = memoize(P8gaps );
 P9gaps  = memoize(P9gaps );
 P10gaps = memoize(P10gaps);
 Pgaps_functions = [ P1gaps,P2gaps,P3gaps,P4gaps,P5gaps,P6gaps,P7gaps,P8gaps,P9gaps,P10gaps ];
 Pgaps(i,k) = Pgaps_functions[i](k);
 Pgaps_row(k) = apply(f->f(k), Pgaps_functions);
 Pgaps_generated_samples_6up = Pgaps_generated_samples[6+1 .. #Pgaps_generated_samples];

gp_inline__location="../dragon.tex:43428";
 MR_initial_vector = {[0,1,2,6,15,(192)/(5)]};
 MR_initial(k) = MR_initial_vector[k+1];

gp_inline__location="../dragon.tex:43445";
 MR_formula(k) = (3/2*2^ceil(k/2) - 1) * (2^ceil(k/2) - 1) / 2^(k%2);
 MR(k) = if(k<#MR_initial_vector, MR_initial(k), MR_formula(k));

gp_inline__location="../dragon.tex:43449";
 MR_angle_z(k) = {
   my(v = hull(k),
      angles = vector(#v,i,
                      vector_modulo(v,i) - vector_modulo(v,i-1)),
      areas = apply(z->if(z==0,0,geom_minrect_area_of_points_at_xydir(v,z)),
                    angles),
      i);
   vecmin(areas,&i);
   angles[i];
 }
 MR_by_angles(k) = \
   geom_minrect_area_of_points_at_xydir(hull(k), MR_angle_z(k));

gp_inline__location="../dragon.tex:43464";
 MR_samples = {[0,1,2,6,15,(192)/(5),77,(345)/(2),345,(1457)/(2),1457,(5985)/(2),5985]};

gp_inline__location="../dragon.tex:43616";
 z_to_slope(z) = if(real(z)!=0, z/real(z), \
                    imag(z)!=0, z/imag(z), z);
 slope(z1,z2) = z_to_slope(z2-z1);
 polygon_slopes(v) = \
   vector(#v,i, slope(vector_modulo(v,i-1), vector_modulo(v,i)));
 MR3_a_rect = {[ -2-4/10 + (1+2/10)*I,         \\ left corner
                    8/10   - 4/10*I,           \\ bottom corner
                   16/10  + (2 - 8/10)*I,      \\ right corner
                  -16/10  + (2 + 8/10)*I ]};   \\ top corner

gp_inline__location="../dragon.tex:43659";
 MR3_b_rect = {[ -5/2 + 3/2*I,   \\ left
                 0 - I,          \\ bottom
                 3/2 + 1/2*I,    \\ right
                 -1 + 3*I ]};    \\ top

gp_inline__location="../dragon.tex:43766";
 MR4_b_rect = {
   [ -4 - 2/5 - 4/5*I,    \\ left    w=1 h=2/5
     1 - 7/5 - 14/5*I,    \\ bottom  w=7 h=14/5
     -2*I + 8/5 + 16/5*I, \\ right   w=4 h=8/5
     -3+2*I + 3/5 +6/5*I  \\ top w=3 h/2+2*h==3 5/2*h=3 h=6/5
 ]};

gp_inline__location="../dragon.tex:43792";
 MR4_c_rect = {[ -5,               \\ left
                 -2 - 3*I,         \\ bottom
                 3/2 + 1/2*I,      \\ right
                 -3/2 + 7/2*I ]};  \\ top

gp_inline__location="../dragon.tex:43874";
 MR5_a_rect = {[ -7 -2*I,          \\ left
                 -7/2 - 11/2*I,    \\ bottom
                 2,                \\ right
                 -3/2 + 7/2*I ]};  \\ top

gp_inline__location="../dragon.tex:44038";
 MR_by_real_imag(k) = \
   2^k * real((P9(k) - P4(k))/b^k) * imag((P6(k) - P1(k))/b^k);

gp_inline__location="../dragon.tex:44045";
 MR_by_fractions(k) = \
   2^k * (3/2 - 1/2^ceil(k/2)) * (1 - 1/2^ceil(k/2));

gp_inline__location="../dragon.tex:44119";
 MR_diagonal(k) = 2^(k+1) * real(P8(k)/b^(k+1) - P2(k)/b^(k+1)) * imag(P4(k)/b^(k+1) - P1(k)/b^(k+1));

gp_inline__location="../dragon.tex:44125";
 MR_diagonal_half_vector = {[1,2,2,4]};

gp_inline__location="../dragon.tex:44134";
 periodic_1224(k) = vector_modulo([1,2,2,4],k);
 MR_diagonal_imag(k) = 5/3*2^ceil(k/2) - 2/3*periodic_1224(k);
 MR_diagonal_real(k) = (2^ceil(k/2) - 2^(k%2)/2)/2^(k%2);

gp_inline__location="../dragon.tex:44225";
 MR_two_real_f(k) = real( (P8(k)-P3(k))/(P6(k)-P5(k)) );
 MR_two_imag_f(k) = imag( (P5(k)-P1(k))/(P6(k)-P5(k)) );
 MR_two(k) = abs((P6(k)-P5(k))^2) \
           * MR_two_real_f(k) * MR_two_imag_f(k);

gp_inline__location="../dragon.tex:44244";
 MR_two_real_n(k) = real( (P8(k)-P3(k)) * conj(P6(k)-P5(k)) );
 MR_two_imag_n(k) = imag( (P5(k)-P1(k)) * conj(P6(k)-P5(k)) );
 MR_two_by_n(k) = MR_two_real_n(k) * MR_two_imag_n(k) \
                  / abs((P6(k)-P5(k))^2);

gp_inline__location="../dragon.tex:44263";
 MR_two_A_vector = {[-(427)/(169),-(498)/(169),-(418)/(169),-(516)/(169)]};
 MR_two_A_factor(k) = vector_modulo(MR_two_A_vector,k);

gp_inline__location="../dragon.tex:44271";
 MR_two_B_vector = {[(2231)/(3042),(358)/(507),(862)/(1521),(20)/(507)]};
 MR_two_B_factor(k) = vector_modulo(MR_two_B_vector,k);

gp_inline__location="../dragon.tex:44281";
 MR_two_C_vector = {[(1966)/(1521),(166)/(507),-(1459)/(1521),(172)/(507)]};
 MR_two_C_factor(k) = vector_modulo(MR_two_C_vector,k);

gp_inline__location="../dragon.tex:44292";
 MR_two_D_vector = {[(4)/(9),0]};
 MR_two_D_factor(k) = vector_modulo(MR_two_D_vector,k);

gp_inline__location="../dragon.tex:44300";
 MR_two_E_vector = {[(11)/(9),(4)/(9)]};
 MR_two_E_factor(k) = vector_modulo(MR_two_E_vector,k);

gp_inline__location="../dragon.tex:44307";
 MR_two_F_vector = {[(5)/(9),(1)/(9)]};
 MR_two_F_factor(k) = vector_modulo(MR_two_F_vector,k);

gp_inline__location="../dragon.tex:44313";
 MR_two_by_fraction(k) = \
   MR_two_sans_fraction(k) + MR_two_fraction_part(k);
 MR_two_sans_fraction(k) = \
   20/13*2^k + MR_two_A_factor(k)*2^floor(k/2);
 MR_two_fraction_part(k) = {
   (  MR_two_B_factor(k)*2^k
    + MR_two_C_factor(k)*2^floor(k/2)
    + MR_two_D_factor(k)
   )/( 13/18*2^k
       + MR_two_E_factor(k)*(-2)^floor(k/2)
       + MR_two_F_factor(k));
 }

gp_inline__location="../dragon.tex:44332";
 MR_two_diff(k) = 1/26*2^k + ([-9/338, -151/338, 9/338, -187/338][(k%4)+1])*2^floor(k/2) - 1/2^(k%2);

gp_inline__location="../dragon.tex:44413";
 MR_three_real_f(k) = real( (P7(k)-P2(k))/(P9(k)-P10(k)) );
 MR_three_imag_f(k) = imag( (P4(k)-P10(k))/(P9(k)-P10(k)) );
 MR_three(k) = abs((P9(k)-P10(k))^2) \
               * MR_three_real_f(k) * MR_three_imag_f(k);

gp_inline__location="../dragon.tex:44431";
 MR_three_real_n(k) = real( (P7(k)-P2(k)) * conj(P9(k)-P10(k)) );
 MR_three_imag_n(k) = imag( (P4(k)-P10(k)) * conj(P9(k)-P10(k)) );
 MR_three_by_n(k) = MR_three_real_n(k) * MR_three_imag_n(k) \
                    / abs((P9(k)-P10(k))^2);

gp_inline__location="../dragon.tex:44451";
 MR_three_A_vector = {[-(615)/(338),-(1109)/(338),-(867)/(338),-(1361)/(338)]};
 MR_three_A_factor(k) = vector_modulo(MR_three_A_vector,k);

gp_inline__location="../dragon.tex:44459";
 MR_three_B_vector = {[-(365)/(2028),(941)/(6084),(935)/(2028),(245)/(1521)]};
 MR_three_B_factor(k) = vector_modulo(MR_three_B_vector,k);

gp_inline__location="../dragon.tex:44469";
 MR_three_C_vector = {[(205)/(1014),(3179)/(3042),(289)/(1014),-(2321)/(3042)]};
 MR_three_C_factor(k) = vector_modulo(MR_three_C_vector,k);

gp_inline__location="../dragon.tex:44480";
 MR_three_D_vector = {[0,(4)/(9)]};
 MR_three_D_factor(k) = vector_modulo(MR_three_D_vector,k);

gp_inline__location="../dragon.tex:44487";
 MR_three_E_vector = {[-(2)/(9),(11)/(9)]};
 MR_three_E_factor(k) = vector_modulo(MR_three_E_vector,k);

gp_inline__location="../dragon.tex:44494";
 MR_three_F_vector = {[(1)/(9),(5)/(9)]};
 MR_three_F_factor(k) = vector_modulo(MR_three_F_vector,k);

gp_inline__location="../dragon.tex:44500";
 MR_three_by_fraction(k) = {
   45/26*2^k + MR_three_A_factor(k)*2^floor(k/2)
             + MR_three_fraction_part(k);
 }
 MR_three_fraction_part(k) = {
   (  MR_three_B_factor(k)*2^k
    + MR_three_C_factor(k)*2^floor(k/2)
    + MR_three_D_factor(k))
   / MR_three_denominator(k);
 }
 MR_three_denominator(k) = {
   13/36*2^k + MR_three_E_factor(k)*(-2)^floor(k/2)
             + MR_three_F_factor(k);
 }
 P910_norm(k) = abs( (P9(k)-P10(k))^2 );

gp_inline__location="../dragon.tex:44553";
 MRV_by_P1v(k) = P1v(k) + P3v(k) + P6v(k) + P8v(k) + 4;

gp_inline__location="../dragon.tex:44556";
 MRV_initial = {[2,3,5,7,9,5]};

gp_inline__location="../dragon.tex:44562";
 MRV_vector = {[10,7,14,10]};

gp_inline__location="../dragon.tex:44571";
 MRV_formula(k) = 1/2 * vector_modulo(MRV_vector,k) * 2^floor(k/4);
 MRV(k) = if(k<#MRV_initial,MRV_initial[k+1], MRV_formula(k));

gp_inline__location="../dragon.tex:44577";
 MRV_by_points(k) = \
   rectangle_points_at_angle(dragon_points(k), MR_angle_z(k));

gp_inline__location="../dragon.tex:44581";
 MRV_samples = {[2,3,5,7,9,5,14,10,20,14,28,20,40,28,56,40,80]};

gp_inline__location="../dragon.tex:44605";
 MRV_unduplicated_samples = {[14,20,28,40,56,80,112,160,224,320]};

gp_inline__location="../dragon.tex:44625";
 A063920(n) = (12-2*(-1)^n) * 2^floor(n/2); \\ by Ralf Stephan
 gA063920(x) = (10 + 14*x)/(1 - 2*x^2);

gp_inline__location="../dragon.tex:44632";
 A070875(n) = (6-(-1)^n)*2^((2*n+(-1)^n-1)/4); \\ by Bruno Berselli
 gA070875(x) = (5+7*x)/(1-2*x^2);  \\ by Bruno Berselli
 A070875_samples_starting_10 = A070875_samples[3..#A070875_samples];
 A070875_samples_starting_14 = A070875_samples[4..#A070875_samples];

gp_inline__location="../dragon.tex:44657";
 MRVgaps_by_P1gaps(k) = \
   P1gaps(k) + P3gaps(k) + P6gaps(k) + P8gaps(k) + 4;

gp_inline__location="../dragon.tex:44664";
 MRVgaps_initial = {[0,1,2,3,5]};

gp_inline__location="../dragon.tex:44669";
 MRVgaps_vector = {[5,5,7,7]};

gp_inline__location="../dragon.tex:44679";
 MRVgaps_formula(k) = \
   vector_modulo(MRVgaps_vector,k-5) * 2^floor((k-5)/4);
 MRVgaps(k) = if(k<#MRVgaps_initial,MRVgaps_initial[k+1], MRVgaps_formula(k));

gp_inline__location="../dragon.tex:44690";
 MRVgaps_samples = {[0,1,2,3,5,5,5,7,7,10,10,14,14,20,20,28,28]};

gp_inline__location="../dragon.tex:44716";
 points_bbox(v) = {
   my(vr=real(v),vi=imag(v));
   [vecmin(vr),vecmin(vi), vecmax(vr),vecmax(vi)];
 }

gp_inline__location="../dragon.tex:44722";
 \\ v is a Set() of integer complex number points.
 \\ Return a range [ymin,ymax] of those in column x.
 \\ If there are no points in the column the return empty [].
 points_column_range(v,x) = \
   vector_minmax(imag(select(z->real(z)==x,v)));
 points_row_range(v,y) = \
   vector_minmax(real(select(z->imag(z)==y,v)));
 vector_minmax(v) = if(#v,[vecmin(v),vecmax(v)],[]);

gp_inline__location="../dragon.tex:44731";
 \\ v is a vector of integer complex number points in the plane.
 \\ Return a new vector which is an XY convex hull by filling in
 \\ all points between any two in a row or a column.
 xyfill_points(v) = {
   my(xmin,ymin,xmax,ymax);
   [xmin,ymin, xmax,ymax]=points_bbox(v);
   v=Set(v);
   my(more=1);
   while(more,
       my(l=List([]));
       more=0;
       for(x=xmin,xmax,
           my(yrange=points_column_range(v,x));
           if(#yrange,
              for(y=yrange[1],yrange[2],
                  my(z=x+I*y);
                  if(!setsearch(v,z), listput(l,z)))));
       for(y=ymin,ymax,
           my(xrange=points_row_range(v,y));
           if(#xrange,
              for(x=xrange[1],xrange[2],
                  my(z=x+I*y);
                  if(!setsearch(v,z), listput(l,z)))));
        v=setunion(v,Set(l));  \\ print("add "l" to "v);
        more=#l);
   Set(v);
 }

gp_inline__location="../dragon.tex:44766";
 XYpoints_by_count(k) = #xyfill_points(dragon_points(k));
 XYpoints(k) = XYpoints_by_count(k);  /* PENDING */

gp_inline__location="../dragon.tex:44769";
 \\ v is a vector of XY convex hull fill
 \\ return a vector of its vertices
 xyfill_to_boundary(v) = {
   my(xmin,ymin,xmax,ymax);
   [xmin,ymin, xmax,ymax]=points_bbox(v);
   my(x=xmax,
      y=points_column_range(v,x)[1],
      z=x+I*y,
      d=1,l=List([]));
   for(i=1,4, if(setsearch(v,z+d),break()); d*=I;
              if(i==4,return(v)));
   my(zinit=z,dinit=d);
   while(1,
     listput(l,z);
     z+=d; d*=-I;
     while(!setsearch(v,z+d), d*=I);
     if(z==zinit&&d==dinit,break());
     );
   Vec(l);
 }

gp_inline__location="../dragon.tex:44794";
 xyhull_area_of_points(v) = \
   geom_area_of_polygon(xyfill_to_boundary(xyfill_points(v)));

gp_inline__location="../dragon.tex:44882";
 hull_width(k)  = {
   my(v=hull(k));
   v = real(v / w8_times_sqrt2^k);
   (vecmax(v) - vecmin(v)) * sqrt2^k;
 }
 hull_height(k)  = {
   my(v=hull(k));
   v = imag(v / w8_times_sqrt2^k);
   (vecmax(v) - vecmin(v)) * sqrt2^k;
 }

gp_inline__location="../dragon.tex:44912";
 XYhullB_formula(k) = {
   2* ( real((P8(k)-P3(k))/w8_times_sqrt2^k) * sqrt2^k
      + imag((P6(k)-P1(k))/w8_times_sqrt2^k) * sqrt2^k );
 }
 XYhullB(k) = if(k==0,2, XYhullB_formula(k));

gp_inline__location="../dragon.tex:44976";
 XYhullB_samples = \
   [2, 3*sqrt2, 6, 8*sqrt2, 16, 18*sqrt2, 36, 38*sqrt2];

gp_inline__location="../dragon.tex:45013";
 XYhullA_initial = {[0,0,1]};

gp_inline__location="../dragon.tex:45021";
 XYhullAf = {(1027)/(1008)};

gp_inline__location="../dragon.tex:45026";
 XYhullA_2_vector = {[23,22,22,23]};

gp_inline__location="../dragon.tex:45035";
 XYhullA_4_vector = {[16,-17,22,-26]};

gp_inline__location="../dragon.tex:45040";
 XYhullA_constant_vector = {[14,7]};

gp_inline__location="../dragon.tex:45046";
 XYhullA_formula(k) = {
   XYhullAf * 2^k
   - 1/9 * vector_modulo(XYhullA_2_vector,k)*2^floor(k/2)
   + 1/28 * vector_modulo(XYhullA_4_vector,k)*2^floor(k/4)
   + 1/18 * vector_modulo(XYhullA_constant_vector,k);
 }
 XYhullA(k) = if(k<=2, XYhullA_initial[k+1], \
                      XYhullA_formula(k));

gp_inline__location="../dragon.tex:45059";
 XYhullA_by_points(k) = {
   xyhull_area_of_points(dragon_points(k) * if(k%2==1,b,1))
                                          / if(k%2==1,2,1);
 }

gp_inline__location="../dragon.tex:45067";
 XYhullA_samples = {[0,0,1,5/2,8,22,48,(217)/(2),223,(961)/(2),969]};

gp_inline__location="../dragon.tex:45367";
 XYindentA_2_vector = {[4,2,2,-2]};

gp_inline__location="../dragon.tex:45372";
 XYindentA_4_vector = {[-4,-1,-2,10]};

gp_inline__location="../dragon.tex:45378";
 XYindentA_constant_vector = {[8,1,2,1]};
 XYindentA(k) = {
   k>=0 || error("XYindentA() is for k>=0");
   4/63 * 2^k
   + 1/9  * vector_modulo(XYindentA_2_vector,k)*2^floor(k/2)
   + 1/14 * vector_modulo(XYindentA_4_vector,k)*2^floor(k/4)
   - 1/36 * vector_modulo(XYindentA_constant_vector,k);
 }

gp_inline__location="../dragon.tex:45391";
 XYindentA_samples = {[0,1/4,1/2,3/4,2,(11)/(4),(11)/(2),(31)/(4),22,(143)/(4),(143)/(2)]};

gp_inline__location="../dragon.tex:45410";
 XYlength(k) = k--; geom_abs((P4(k+5)-P5(k+5))/b^k)*sqrt2^k;

gp_inline__location="../dragon.tex:45414";
 XYindentA_by_XYlength(k) = {
   k>=0 || error();
   if(k==0,return(0));
   if(k==1,return(1/4));
   if(k==2,return(1/2));
   if(k==3,return(3/4));
   \\ if(k==4,return(2));
   my(l=XYlength(k)-2*XYlength(k-4));
   l^2/4 + 2*XYindentA(k-4);
 }

gp_inline__location="../dragon.tex:45515";
 XYhullA_P2A(k) = P3(k) + (P3(k-4)-P2(k-4));
 XYhullA_P3B(k) = P2(k) - (P3(k-4)-P2(k-4));

gp_inline__location="../dragon.tex:45520";
 XYhullA_23AB(k)  = \
   ( real(XYhullA_P3B(k)/b^k) + I*imag(XYhullA_P2A(k)/b^k) )*b^k;

gp_inline__location="../dragon.tex:45524";
 XYhullA_P3T(k) = P6(k) + (P3(k-4)-P2(k-4))*(-I);
 XYhullA_T(k)  = \
   ( real(XYhullA_P3T(k)/b^k) + I*imag(P5(k)/b^k) )*b^k;

gp_inline__location="../dragon.tex:45539";
 XYhullA_P3E(k) = P9(k) + (P3(k-4)-P2(k-4))*(-I);
 XYhullA_E(k)  = \
   ( real(P10(k)/b^k) + I*imag(XYhullA_P3E(k)/b^k) )*b^k;

gp_inline__location="../dragon.tex:45547";
 XYhullA_T_polygon(k) = [P5(k),XYhullA_T(k),XYhullA_P3T(k),P6(k)];
 XYhullA_Tarea(k) = geom_area_of_polygon(XYhullA_T_polygon(k));

gp_inline__location="../dragon.tex:45553";
 XYhullA_E_polygon(k) = [P10(k),P9(k),XYhullA_P3E(k),XYhullA_E(k)];
 XYhullA_Earea(k) = geom_area_of_polygon(XYhullA_E_polygon(k));

gp_inline__location="../dragon.tex:45558";
 XYhullA_by_HA(k) = {
   if(k<8,XYhullA_samples[k+1],
     HA(k)
     -   XYindentA(k-2)
     - 3*XYindentA(k-4)
     - 2*XYindentA(k-6)
     - XYhullA_Tarea(k)
     - XYhullA_Earea(k);
   );
 }

gp_inline__location="../dragon.tex:45585";
 \\ at 45 deg relative to start to end
 hull_extent_leading(k)  = {
   my(v=hull(k));
   v = real(v / w8_times_sqrt2^(k+1));
   (vecmax(v) - vecmin(v)) * sqrt2^(k+1);
 }
 \\ at 135 deg relative to start to end
 hull_extent_opposite(k)  = {
   my(v=hull(k));
   v = imag(v / w8_times_sqrt2^(k+1));
   (vecmax(v) - vecmin(v)) * sqrt2^(k+1);
 }

gp_inline__location="../dragon.tex:45620";
 DXhullB(k) = {
   2* ( real((P7(k)-P2(k))/w8_times_sqrt2^(k+1)) * sqrt2^(k+1)
      + imag((P4(k)-P1(k))/w8_times_sqrt2^(k+1)) * sqrt2^(k+1) );
 }

gp_inline__location="../dragon.tex:45670";
 DXhullB_samples = \
   [2*sqrt2, 4, 5*sqrt2, 10, 13*sqrt2, 26, 27*sqrt2, 54];

gp_inline__location="../dragon.tex:45875";
 DXhullA_P7S(k) = b^(k-5) + P7(k-6)*(-I);
 DXhullA_S(k)  = \
   ( real(DXhullA_P7S(k)/b^(k+1)) + I*imag(P6(k)/b^(k+1)) )*b^(k+1);

gp_inline__location="../dragon.tex:45893";
 DXhullA_S_polygon(k) = [P5(k),DXhullA_P7S(k),DXhullA_S(k),P6(k)];
 DXhullA_Sarea(k) = geom_area_of_polygon(DXhullA_S_polygon(k));

gp_inline__location="../dragon.tex:45898";
 DXhullA_P1D(k) = P10(k) + (P1(k-6)-P2(k-6));
 DXhullA_D(k)  = \
  ( real(DXhullA_P1D(k)/b^(k+1)) + I*imag(P9(k)/b^(k+1)) )*b^(k+1);

gp_inline__location="../dragon.tex:45911";
 DXhullA_D_polygon(k) = [P10(k),P9(k),DXhullA_D(k),DXhullA_P1D(k)];
 DXhullA_Darea(k) = geom_area_of_polygon(DXhullA_D_polygon(k));

gp_inline__location="../dragon.tex:45915";
 DXhullA_by_HA(k) = {
   if(k<7, DXhullA_samples[k+1],
     HA(k)
     -   XYindentA(k-1)        \\ P1--P2
     - 2*XYindentA(k-3)        \\ P3--P4  and P6--P7
     - 2*XYindentA(k-5)        \\ P5--P7S and P8--P9
     -   XYindentA(k-7)        \\ P10--P1D
     - DXhullA_Sarea(k)
     - DXhullA_Darea(k);
   );
 }

gp_inline__location="../dragon.tex:45952";
 DXhullA_initial = {[0,0,1/2,3]};

gp_inline__location="../dragon.tex:45960";
 DXhullAf = {(557)/(576)};

gp_inline__location="../dragon.tex:45965";
 DXhullA_2_vector = {[143,286,121,242]};

gp_inline__location="../dragon.tex:45974";
 DXhullA_4_vector = {[-5,6,-6,8]};

gp_inline__location="../dragon.tex:45979";
 DXhullA_constant_vector = {[2,4,5,10]};

gp_inline__location="../dragon.tex:45985";
 DXhullA_formula(k) = {
   DXhullAf * 2^k
   - 1/72 * vector_modulo(DXhullA_2_vector,k)*2^floor(k/2)
   + 1/8  * vector_modulo(DXhullA_4_vector,k)*2^floor(k/4)
   + 1/9  * vector_modulo(DXhullA_constant_vector,k);
 }
 DXhullA(k) = if(k<=3, DXhullA_initial[k+1], \
                      DXhullA_formula(k));

gp_inline__location="../dragon.tex:46001";
 DXhullA_by_points(k) = {
   xyhull_area_of_points(dragon_points(k) * if(k%2==0,b,1))
                                          / if(k%2==0,2,1);
 }

gp_inline__location="../dragon.tex:46009";
 DXhullA_samples = {[0,0,1/2,3,(13)/(2),17,(95)/(2),100,(427)/(2),435,934]};

gp_inline__location="../dragon.tex:46110";
 XYhullAf_sample = {(1018849/1000000)};

gp_inline__location="../dragon.tex:46124";
 DXhullAf_sample = {(0967013/1000000)};

gp_inline__location="../dragon.tex:46135";
 XYhullBf = 5;

gp_inline__location="../dragon.tex:46140";
 DXhullBf = 11/3 * sqrt2;
 DXhullBf_sample = {(5185449/1000000)};

gp_inline__location="../dragon.tex:46167";
 XYindentAf = {1/7};

gp_inline__location="../dragon.tex:46242";
 XYhullAf_P3T = 7/12 + 1/4*I;

gp_inline__location="../dragon.tex:46246";
 XYhullAf_T = 7/12 + 1/6*I;

gp_inline__location="../dragon.tex:46250";
 XYhullAf_T_polygon=[P6_limit, P5_limit, XYhullAf_T, XYhullAf_P3T];
 XYhullAf_Tareaf = 17/288;

gp_inline__location="../dragon.tex:46255";
 XYhullAf_P3E = 13/12 - 1/12*I;

gp_inline__location="../dragon.tex:46259";
 XYhullAf_E = 5/6 - 1/12*I;

gp_inline__location="../dragon.tex:46263";
 XYhullAf_E_polygon=[P10_limit, P9_limit, XYhullAf_P3E, XYhullAf_E];
 XYhullAf_Eareaf = 17/288;

gp_inline__location="../dragon.tex:46283";
 DXhullAf_P7S = 0 + 1/6*I;

gp_inline__location="../dragon.tex:46288";
 DXhullAf_S = 1/4 - 1/12*I;

gp_inline__location="../dragon.tex:46294";
 DXhullAf_S_polygon = \
   [P6_limit, P5_limit, DXhullAf_P7S, DXhullAf_S];
 DXhullAf_Sareaf = 17/144;

gp_inline__location="../dragon.tex:46300";
 DXhullAf_P1D = 5/6 - 5/12*I;

gp_inline__location="../dragon.tex:46304";
 DXhullAf_D = 19/24 - 3/8*I;

gp_inline__location="../dragon.tex:46310";
 DXhullAf_D_polygon = \
   [P10_limit, P9_limit, DXhullAf_D, DXhullAf_P1D];
 DXhullAf_Dareaf = 17/576;

gp_inline__location="../dragon.tex:46341";
 XYindentSegsA(k) = {    \\ with curve segments included,
   k>=0 || error();   \\ so smaller indent
   if(k==0,return(0));
   if(k==1,return(0));
   if(k==2,return(1/2));
   if(k==3,return(1/4));
   2*XYindentSegsA(k-4)
   + 1/4*(    geom_abs(P2(k+2)-P3(k+2))
          - 2*geom_abs(P2(k-2)-P3(k-2)) )^2;
 }
 XYindentSegsA = memoize(XYindentSegsA);

gp_inline__location="../dragon.tex:46353";
 XYhullSegsA_formula(k) = {
   HA(k)
   -   XYindentSegsA(k-2)
   - 3*XYindentSegsA(k-4)
   - 2*XYindentSegsA(k-6)
   - XYhullA_Tarea(k)
   - XYhullA_Earea(k);
 }

gp_inline__location="../dragon.tex:46373";
 XYhullSegsA_diff_vector = {[0,7/8,0,5/4]};

gp_inline__location="../dragon.tex:46378";
 XYhullSegsA_diff(k) = \
   vector_modulo(XYhullSegsA_diff_vector,k) * 2^floor(k/4);

gp_inline__location="../dragon.tex:46384";
 XYhullSegsA_diff_samples = {[0,7/8,0,5/4,0,7/4,0,5/2,0,7/2]};

gp_inline__location="../dragon.tex:46471";
 GS(k) = (2/5 - 1/5*I)*b^k + GS_conj_part(k);
 GS_conj_part(k) = (1/10 + 1/5*I)*conj(b/2)^k;

gp_inline__location="../dragon.tex:46476";
 GS_samples = {[(1)/(2),(3+I)/(4),(2+3*I)/(4),(-3+9*I)/(8),(-13+6*I)/(8),(-39-13*I)/(16),(-26-51*I)/(16)]};
 GS_samples2 = [ 1/2, (3+1*I)/4, (2+3*I)/4, (-3+9*I)/8, (-13+6*I)/8, (-39-13*I)/16, (-26-51*I)/16 ];

gp_inline__location="../dragon.tex:46490";
 GSk1(k) = (1/10 - 3/10*I)* (b^(k+1) - conj(b/2)^(k+1));

gp_inline__location="../dragon.tex:46498";
 gGS(x) = (2/5-1/5*I)/(1-b*x) + (1/10+1/5*I)/(1-conj(b/2)*x);

gp_inline__location="../dragon.tex:46501";
 GS_by_dragon_midpoints(k) = geom_centroid_of_points(dragon_midpoints(k));

gp_inline__location="../dragon.tex:46537";
 GS_unfolded(k) = b^(k+1) + (-I)*GS(k);

gp_inline__location="../dragon.tex:46678";
 GS_expand_offset(d) = -I/4*(-I)^d;

gp_inline__location="../dragon.tex:46691";
 GS_by_expand(k) = if(k<1,return(GS(k))); \
   b*(GS(k-1) \
   + (1/2)^(k-1)*sum(d=0,3, GS_expand_offset(d)*Skd(k-1,d)));

gp_inline__location="../dragon.tex:46696";
 GS_by_expand_2(k) = if(k<1,return(GS(k))); \
   b*GS(k-1) \
   + b*(1/2)^(k-1)*sum(d=0,3, -I/4*(-I)^d* 1/4*(2^(k-1) \
                              + b^(k-1)*(-I)^d \
                              + conj(b)^(k-1)*(I)^d) );

gp_inline__location="../dragon.tex:46703";
 GS_by_expand_3(k) = if(k<1,return(GS(k))); \
   b*GS(k-1) \
   + b*(1/2)^(k-1)*sum(d=0,3, \
                     b^(k-1)*-I/4*(-I)^d*1/4*(-I)^d \
                     + conj(b)^(k-1)*-I/4*(-I)^d*1/4*(I)^d );

gp_inline__location="../dragon.tex:46719";
 GS_by_recurrence_from_segments_unsimplified(k) = \
   if(k<1,return(GS(k))); \
   b*GS(k-1) + b*(1/2)^(k-1) * -I/4*conj(b)^(k-1);

gp_inline__location="../dragon.tex:46731";
 GS_by_recurrence_from_segments(k) = {
   if(k<1,return(GS(k)));
   b*GS(k-1) + 1/2*(conj(b)/2)^k;
 }

gp_inline__location="../dragon.tex:46771";
 GSF(k) = GS(k) / b^k;

gp_inline__location="../dragon.tex:46780";
 GSF_simplified(k) = 2/5-1/5*I + (1/10+1/5*I)*(-I/2)^k;

gp_inline__location="../dragon.tex:46786";
 GSF_samples = {[(1)/(2),(2-I)/(4),(3-2*I)/(8),(6-3*I)/(16),(13-6*I)/(32),(26-13*I)/(64),(51-26*I)/(128)]};

gp_inline__location="../dragon.tex:46812";
 Gf = {(2)/(5)-(1)/(5)*I};

gp_inline__location="../dragon.tex:46902";
 GSF_from_GSFnum(k) = 1/2^(k+1) * (GSFnum(k+1) - I * GSFnum(k));

gp_inline__location="../dragon.tex:46909";
 GSFnum_vector = {[-2,1,2,-1]};

gp_inline__location="../dragon.tex:46913";
 GSFnum_periodic(k) = vector_modulo(GSFnum_vector,k);
 GSFnum(k) = 1/5 * (2^(k+1) + GSFnum_periodic(k));

gp_inline__location="../dragon.tex:46921";
 GSFnum_samples = {[0,1,2,3,6,13,26,51,102,205,410,819,1638,3277]};

gp_inline__location="../dragon.tex:46935";
 GSFnum_pattern_vector(n) = vector(n,i,((i-1)%4)<=1);
 GSFnum_pattern(k)=from_binary_vector(GSFnum_pattern_vector(k));
 GSFnum_pattern_samples = [ 0, 1, 3, 6, 12, 25, 51, 102, 204, 409, 819, 1638, 3276, 6553, 13107, 26214 ];

gp_inline__location="../dragon.tex:46957";
 GSFnum_samples_binary = {[0,1,10,11,110,1101,11010,110011,1100110,11001101]};

gp_inline__location="../dragon.tex:47007";
 GSk1_sub_JEQ(k) = GS(k+1) - JEQ(k);

gp_inline__location="../dragon.tex:47022";
 GSk1_sub_JEQ_unsimplified(k) = \
     (2/5 - 1/5*I)*b^(k+1) + (1/10+1/5*I)*(conj(b)/2)^(k+1) \
  - ( (3/5 + 1/5*I)*b^k - (1/10-3/10*I)*(-1)^k );

gp_inline__location="../dragon.tex:47035";
 GSk1_sub_JEQ_simplified(k) = \
   (1/10-3/10*I)*(-1)^k + (3/20+1/20*I)*(conj(b)/2)^k;

gp_inline__location="../dragon.tex:47079";
 complex_floor(z) = floor(real(z)) + I*floor(imag(z));

gp_inline__location="../dragon.tex:47131";
 GV(k) = (GS(k)*2^k + 0 + b^k/2) / (2^k + 1);

gp_inline__location="../dragon.tex:47134";
 GV2(k) = (GS(k)*2^k + 0 + b^k/2) / (2^k + 1);

gp_inline__location="../dragon.tex:47140";
 GV3(k) = GS(k) + (1/10 + 1/5*I)*(b^k - conj(b/2)^k) / (2^k + 1);

gp_inline__location="../dragon.tex:47226";
 fractal_G = 2/5 - 1/5*I;

gp_inline__location="../dragon.tex:47267";
 HG(k) = HGtotal(k) / HA(k);
 HG_by_points(k) = geom_centroid_of_polygon(hull(k));

gp_inline__location="../dragon.tex:47271";
 HG_samples = {[(2)/(3)+(1)/(3)*I,(4)/(9)+(7)/(9)*I,-(4)/(9)+(29)/(27)*I,-(37)/(23)+(40)/(69)*I,-(191)/(84)-(41)/(42)*I]};

gp_inline__location="../dragon.tex:47287";
 HGtotal_by_triangles(k) = {
   my(v=hull(k));
   sum(i=1,#v,
       my(z1=vector_modulo(v,i), z2=vector_modulo(v,i+1));
       geom_centroid_of_triangle(z1,z2)
       * geom_area_of_triangle(z1,z2));
 }

gp_inline__location="../dragon.tex:47297";
 HGtotal1 = {(1)/(3)+(1)/(6)*I};

gp_inline__location="../dragon.tex:47309";
 HGtotal_multiply_high = {(305)/(648)-(59)/(324)*I};

gp_inline__location="../dragon.tex:47317";
 HGtotal_multiply_half = {[(-79)/(108)+(25)/(72)*I,(-199)/(216)+(35)/(108)*I,(-83)/(108)+(11)/(72)*I,(-251)/(216)+(23)/(54)*I]};

gp_inline__location="../dragon.tex:47330";
 HGtotal_multiply_low = {[(1)/(108)-(4)/(27)*I,(-1)/(108),(7)/(27)+(11)/(108)*I,(61)/(216)-(1)/(8)*I]};

gp_inline__location="../dragon.tex:47347";
 HGtotal_constant_vector = {[7+4*I,12-2*I,4-7*I,-2-12*I,-7-4*I,-12+2*I,-4+7*I,2+12*I]};

gp_inline__location="../dragon.tex:47361";
 HGtotal_formula(k) = {
   b^k*(HGtotal_multiply_high * 2^k
        + vector_modulo(HGtotal_multiply_half,k)*2^floor(k/2)
        + vector_modulo(HGtotal_multiply_low,k)
       )
   + 1/162*vector_modulo(HGtotal_constant_vector,k);
 }
 HGtotal(k) = if(k==1, HGtotal1, HGtotal_formula(k));

gp_inline__location="../dragon.tex:47376";
 HGtotal_samples = {[(2+I)/(6),(4+7*I)/(6),(-12+29*I)/(6),(-111+40*I)/(6),(-382-164*I)/(6)]};

gp_inline__location="../dragon.tex:47400";
 HGf = HGtotal_multiply_high / (7/6);

gp_inline__location="../dragon.tex:47408";
 HGf_real_decimal = {(0403439/1000000)};

gp_inline__location="../dragon.tex:47414";
 HGf_imag_decimal = {-(0156084/1000000)};

gp_inline__location="../dragon.tex:47476";
 HGf_real_decimal_3 = {(0403/1000)};

gp_inline__location="../dragon.tex:47491";
 HGf_imag_decimal_3 = {-(0156/1000)};

gp_inline__location="../dragon.tex:47523";
 \\ v is a polygon vector and p is a point within it.
 \\ Return v rotated so that p is the first point.
 polygon_rotate_to_first(v,p) = {
   for(i=1,#v,
       if(p==v[i],
          return(if(i==1,v,concat(v[i..#v],v[1..i-1])))));
   error("polygon does not contain point ",p);
 }

gp_inline__location="../dragon.tex:47535";
 \\ Return 1 if points p1,p2,p3 are co-linear, return 0 if not.
 \\ The points can be in any order, but must be on a single line.
 \\ This is equivalent to a triangle of these points having 0 area.
 points_are_colinear(p1,p2,p3)= geom_area_of_triangle(p1,p2,p3)==0;

gp_inline__location="../dragon.tex:47542";
 \\ Return 1 if number x is between start and end, inclusive.
 is_between(start,x,end) = \
   (start <= x && x <= end) || (start >= x && x >= end);

gp_inline__location="../dragon.tex:47549";
 \\ Return 1 if point p is between pstart and pend, inclusive,
 \\ so on the line segment pstart to pend.
 point_is_between(pstart,p,pend) = {
   points_are_colinear(pstart,p,pend)
   && is_between(geom_point_x(pstart),
                 geom_point_x(p),
                 geom_point_x(pend))
   && is_between(geom_point_y(pstart),
                 geom_point_y(p),
                 geom_point_y(pend))
   && is_between(geom_point_z(pstart),
                 geom_point_z(p),
                 geom_point_z(pend));
 }

gp_inline__location="../dragon.tex:47571";
 \\ v is a polygon vector.
 \\ Return it with polygon vertices deleted when they fall
 \\ in between surrounding vertices, making them unnecessary.
 polygon_delete_between(v) = {
   if(#v<2,return(v));
   my(i=1); v=List(v);
   while(i<=#v && #v>=3,
         my(j=if(i+1>#v,i+1-#v,i+1),
            k=if(i+2>#v,i+2-#v,i+2));
         if(v[i]!=v[k] && point_is_between(v[i],v[j],v[k]),
            \\ print("delete ",[v[i],v[j],v[k]]);
            listpop(v,j),
            i++));
   if(#v==2 && v[1]==v[2], [v[1]],Vec(v));
 }

gp_inline__location="../dragon.tex:47587";
 my(h=1/2/sqrt2, t=[ [-1,-1], [1,-1], [-1,1] ]); \
 XYindent_polygon_initial = {[
   [0],
   [0, -1/2+1/2*I, I],
   [0, -1, -1+I],
   [0, 1/2+1/2*I, 1, 3/2+1/2*I, 2, 5/2+1/2*I, 3] *-1
 ]};

gp_inline__location="../dragon.tex:47600";
 \\ k is an XYindentA level.
 \\ from and to are complex number ends of an XYindentA side.
 \\ Return a vector of complex number vertices between from and to
 \\ which are the XY hull of that side.
 XYindent_polygon(k,from,to) = {
   \\ print("k="k"  from="from" to="to);
   if(k==0,from==to||error();
           return([from]));
   my(f=(to-from)/(P2(k+2)-P3(k+2)));
   abs(f)==1 || error("k="k" f="f);
   if(k<4,
      return(apply(z->z+from,f*XYindent_polygon_initial[k+1])));
   my(z4=(P3(k-2)-P2(k-2))*f);
   \\ print("f="f"  z4="z4"  side=",(to-from-2*z4) / conj(b));
   my(v=XYindent_polygon(k-4,from,from+z4));
   concat([ v,
            [ from + z4 + (to-from-2*z4) / conj(b) ],
            apply(z->z+to-from-z4,v) ]);
 }

gp_inline__location="../dragon.tex:47634";
 XYhull_polygon_by_points_raw(k) = {
   my(v=dragon_points(k));
   if(k%2,v*=b);
   v=xyfill_to_boundary(xyfill_points(v));
   if(k%2,v/=b);
   v;
 }
 XYhull_polygon_by_points(k) = {
   polygon_rotate_to_first
     (polygon_delete_between(XYhull_polygon_by_points_raw(k)),
      P1(k));
 }

gp_inline__location="../dragon.tex:47659";
 XYhull_polygon(k) = {
   if(k<=6,
      XYhull_polygon_by_points(k),
      concat([ XYindent_polygon(k-4,P1(k),P10(k)),
               [ XYhullA_E(k) ],
               XYindent_polygon(k-6, XYhullA_P3E(k),P9(k)),
               XYindent_polygon(k-4, P8(k),P7(k)),
               XYindent_polygon(k-6, P6(k),XYhullA_P3T(k)),
               [ XYhullA_T(k) ],
               XYindent_polygon(k-4, P5(k),P4(k)),
               XYindent_polygon(k-2, P3(k),P2(k))
             ]));
 }

gp_inline__location="../dragon.tex:47681";
 \\ number of vertices in the XY hull
 XYhullV_initial = [2, 5, 5, 13, 10, 21];
 XYhullV_formula(k)= vector_modulo([7,14,10,20],k)*2^floor(k/4) - 4;
 XYhullV(k) = if(k<#XYhullV_initial,XYhullV_initial[k+1], \
                 XYhullV_formula(k));

gp_inline__location="../dragon.tex:47692";
 weighted_centroid(v) = {
   my(a=geom_area_of_polygon(v));
   a>=0 || error();
   if(a,a*geom_centroid_of_polygon(v),0);
 }

gp_inline__location="../dragon.tex:47698";
 \\ weighted centroid of XYindentA of side P3--P2
 \\ area taken as a positive number
 XYindentGtotal_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k,P3(k+2),P2(k+2))));
 XYindentGtotal(k) = {
   (1060 - 316*I)/17577 * (2*b)^k
   + 1/189
     * vector_modulo([ 80-20*I,  22+12*I,  10+34*I,  12-34*I,
                      -80+20*I, -22-12*I, -10-34*I, -12+34*I],k)
     * 2^k
   + 1/21
     * vector_modulo([-6+2*I, -2-I, -2-6*I, -20+40*I,
                       6-2*I,  2+I,  2+6*I,  20-40*I],k)
     * 8^floor(k/4)
   + 1/18* vector_modulo([-1+2*I, -1-I],k) * conj(b)^k
   + 1/54* vector_modulo([-13+10*I, -2-I],k) * b^k
   + 1/2604
     * vector_modulo([192-440*I, 86+31*I, 110+234*I, -310-1420*I,
                     -192+440*I, -86-31*I,-110-234*I, 310+1420*I],k)
     * 2^floor(k/4)
   + 1/648 * vector_modulo([ 16-64*I,  7+3*I,  8+20*I,  3+11*I,
                            -16+64*I, -7-3*I, -8-20*I, -3-11*I],k)
   ;
 }

gp_inline__location="../dragon.tex:47725";
 XYindentGtotal_by_recurrence(k) = {
     (-XYindentGtotal(k-4)) + (P3(k+2)-(-P3(k+2-4)))*XYindentA(k-4)
   + (-XYindentGtotal(k-4)) + (P2(k+2)-(-P2(k+2-4)))*XYindentA(k-4)
   + weighted_centroid([XYhullA_P2A(k+2),
                        XYhullA_P3B(k+2),
                        XYhullA_23AB(k+2)]);
 }

gp_inline__location="../dragon.tex:47754";
 XYindentGtotal_for_P3_P2(k) = XYindentGtotal(k-2);
 XYindentGtotal_for_P3_P2_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-2,P3(k),P2(k))));

gp_inline__location="../dragon.tex:47760";
 XYindentGtotal_for_P5_P4(k) = XYindentGtotal(k-4);
 XYindentGtotal_for_P5_P4_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-4,P5(k),P4(k))));

gp_inline__location="../dragon.tex:47766";
 XYindentGtotal_for_P1_P10(k) = \
   -XYindentGtotal(k-4) + b^(k-1)*XYindentA(k-4);
 XYindentGtotal_for_P1_P10_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-4,P1(k),P10(k))));

gp_inline__location="../dragon.tex:47773";
 XYindentGtotal_for_P8_P7(k) = \
   -I*XYindentGtotal(k-4) + b^k*XYindentA(k-4);
 XYindentGtotal_for_P8_P7_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-4,P8(k),P7(k))));

gp_inline__location="../dragon.tex:47780";
 XYindentGtotal_for_P3E_P9(k) = \
   -I*XYindentGtotal(k-6) + b^k*XYindentA(k-6);
 XYindentGtotal_for_P3E_P9_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-6,XYhullA_P3E(k),P9(k))));

gp_inline__location="../dragon.tex:47787";
 XYindentGtotal_for_P6_P3T(k) = \
   I*XYindentGtotal(k-6) + (-2+I)*b^(k-3)*XYindentA(k-6);
 XYindentGtotal_for_P6_P3T_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-6,P6(k),XYhullA_P3T(k))));

gp_inline__location="../dragon.tex:47797";
 XYhullGtotal_by_parts(k) = {
   HGtotal(k)
   - XYindentGtotal_for_P3_P2(k)     \\ k-2
   - XYindentGtotal_for_P5_P4(k)     \\ k-4
   - XYindentGtotal_for_P1_P10(k)    \\ k-4
   - XYindentGtotal_for_P8_P7(k)     \\ k-4
   - XYindentGtotal_for_P3E_P9(k)    \\ k-6
   - XYindentGtotal_for_P6_P3T(k)    \\ k-6
   - weighted_centroid(XYhullA_T_polygon(k))
   - weighted_centroid(XYhullA_E_polygon(k));
 }

gp_inline__location="../dragon.tex:47811";
 XYhullGtotalf = 32467/83328 - 6209/35712*I;

gp_inline__location="../dragon.tex:47820";
 DXhull_polygon(k) = {
   if(k==0,return([0,1]));
   if(k==1,return([0,1/2+1/2*I,1,1/2*1/2*I,1+I]));
   if(k==2,return([0,1,1+I,I,2*I]));
   concat([ XYindent_polygon(k-3, P4(k),P3(k)),
            XYindent_polygon(k-1, P2(k),P1(k)),
            XYindent_polygon(k-7, P10(k),DXhullA_P1D(k)),
            [ DXhullA_D(k) ],
            XYindent_polygon(k-5, P9(k),P8(k)),
            XYindent_polygon(k-3, P7(k),P6(k)),
            [ DXhullA_S(k) ],
            XYindent_polygon(k-5, DXhullA_P7S(k),P5(k))
          ]);
 }

gp_inline__location="../dragon.tex:47840";
 XYindentGtotal_for_P2_P1(k) = XYindentGtotal(k-1);
 XYindentGtotal_for_P2_P1_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-1,P2(k),P1(k))));

gp_inline__location="../dragon.tex:47846";
 XYindentGtotal_for_P4_P3(k) = XYindentGtotal(k-3);
 XYindentGtotal_for_P4_P3_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-3,P4(k),P3(k))));

gp_inline__location="../dragon.tex:47852";
 XYindentGtotal_for_P9_P8(k) = \
   -I*XYindentGtotal(k-5) + b^k*XYindentA(k-5);
 XYindentGtotal_for_P9_P8_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-5,P9(k),P8(k))));

gp_inline__location="../dragon.tex:47859";
 XYindentGtotal_for_P7_P6(k) = \
   -I*XYindentGtotal(k-3) + b^k*XYindentA(k-3);
 XYindentGtotal_for_P7_P6_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-3,P7(k),P6(k))));

gp_inline__location="../dragon.tex:47866";
 XYindentGtotal_for_P10_P1D(k) = \
   XYindentGtotal(k-7) + (-3+2*I)*b^(k-4)*XYindentA(k-7);
 XYindentGtotal_for_P10_P1D_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-7,P10(k),DXhullA_P1D(k))));

gp_inline__location="../dragon.tex:47873";
 XYindentGtotal_for_P7S_P5(k) = XYindentGtotal(k-5);
 XYindentGtotal_for_P7S_P5_by_polygon(k) = \
   weighted_centroid(Vecrev(XYindent_polygon(k-5,DXhullA_P7S(k),P5(k))));

gp_inline__location="../dragon.tex:47882";
 DXhullGtotal_by_parts(k) = {
   HGtotal(k)
   - XYindentGtotal_for_P2_P1(k)     \\ k-1
   - XYindentGtotal_for_P4_P3(k)     \\ k-3
   - XYindentGtotal_for_P9_P8(k)     \\ k-5
   - XYindentGtotal_for_P7_P6(k)     \\ k-3
   - XYindentGtotal_for_P10_P1D(k)   \\ k-7
   - XYindentGtotal_for_P7S_P5(k)    \\ k-5
   - weighted_centroid(DXhullA_D_polygon(k))
   - weighted_centroid(DXhullA_S_polygon(k));
 }

gp_inline__location="../dragon.tex:47898";
 DXhullGtotalf = 130523/333312 - 173071/999936*I;

gp_inline__location="../dragon.tex:47913";
 XYhullGf = {(97401-43463*I)/(254696)};

gp_inline__location="../dragon.tex:47921";
 XYhullGf_real_sample = {(0382420/1000000)};

gp_inline__location="../dragon.tex:47927";
 XYhullGf_imag_sample = {-(0170646/1000000)};

gp_inline__location="../dragon.tex:47939";
 DXhullGf = {(391569-173071*I)/(966952)};

gp_inline__location="../dragon.tex:47946";
 DXhullGf_real_sample = {(0404951/1000000)};

gp_inline__location="../dragon.tex:47952";
 DXhullGf_imag_sample = {-(0178986/1000000)};

gp_inline__location="../dragon.tex:47976";
 GLQ(k) = 1/2*b^max(1,k);

gp_inline__location="../dragon.tex:47984";
 GLtotal_samples = {[
   1/2,
   3/2 + 1/2*I,
   2 + 3*I,
   -3 + 9*I,
   -16 + 6*I,
   -36 - 24*I,
   -14 - 122*I,
   194 - 230*I,
   730 - 38*I,
   1334 + 1262*I,
   82 + 4506*I,
   -7586 + 7782*I,
   -26318 + 202*I,
   -45170 - 44778*I,
   -430 - 152886*I,
   259310 - 260298*I,
   882898 - 1014*I,
   1499182 + 1497206*I,
   2130 + 5083146*I,
   -8621394 + 8626166*I
 ]};

gp_inline__location="../dragon.tex:48015";
 GL(k) = GLtotal(k)/L(k);

gp_inline__location="../dragon.tex:48037";
 GLtotal_formula(k) = {
     (2-6*I)/25 * (-1)^k
   - (2+I)/10 * conj(b)^k
   + (1/2*L(k) - (3+I)/5 * k + (31-33*I)/50) * b^k;
 }
 GLtotal(k) = if(k==0,return(1/2)); GLtotal_formula(k);

gp_inline__location="../dragon.tex:48047";
 GLtotal_samples_1 = {[(1)/(2),(3)/(2)+(1)/(2)*I,2+3*I,-3+9*I,-16+6*I,-36-24*I,-14-122*I]};

gp_inline__location="../dragon.tex:48084";
 gGLtotal(x) =                                           \
   -1/2 + I                                          \
   + 1/25 * (2 - 6*I)   / (1 + x)                    \
   - 1/10 * (2 + I)     / (1 - conj(b)*x)            \
   + 1/50 * (61 - 23*I) / (1 - b*x)                  \
   - 1/5  * (3 + I)     / (1 - b*x)^2                \
   + 1/2 * gL(b*x);

gp_inline__location="../dragon.tex:48171";
 GLtotal_by_recurrence(k) = {
   if(k<4,return(GLtotal_samples[k+1]));
   k -= 4;
     GLtotal(k+3)
   - GLtotal(k+1)  + (-1+I)*b^k*L(k+1)
   - GLtotal(k+1)  + (-2  )*b^k*L(k+1)
   + (-2-2*I)*b^k*R(k+1);
 }
 GLtotal_by_recurrence = memoize(GLtotal_by_recurrence);

gp_inline__location="../dragon.tex:48222";
 gGLtotal_by_recurrence(x) = {
   1/(1 - x*gGLtotal(x) + 2*x^3)
   *( x*( - GLtotal(0) - GLtotal(1)*x - GLtotal(2)*x^2)
      - 2*x^3*( - GLtotal(0))
      + (-3+I)*(gL(x*b) - 1)
      + (-3-I)*(gR(x*b) - 1) );
 }

gp_inline__location="../dragon.tex:48253";
  gGLtotal_as_fraction(x) = {
           (1/2
            - 1/2*I * x
            + (-1/2 + 1/2*I) * x^2
            + x^3
            + (7 - 7*I)   * x^4
            + (-8 - 4*I)  * x^5
            + 8           * x^6
            + (16 - 16*I) * x^7
           )
           / (
                (1+x)
              * (1 - conj(b)*x)
              * (1 -      b *x)^2
              * (1 - b*x - 2*b^3*x^3)
             );
   }

gp_inline__location="../dragon.tex:48392";
 GRQtotal_samples_by_path = {1/2*[
   1 + I*-1,   /* k=0 */
   4 + I*0,   /* k=1 */
   5 + I*3,   /* k=2 */
   1 + I*11,   /* k=3 */
   -23 + I*19,   /* k=4 */
   -71 + I*-5,   /* k=5 */
   -111 + I*-125,   /* k=6 */
   33 + I*-413,   /* k=7 */
   753 + I*-653,   /* k=8 */
   2353 + I*147,   /* k=9 */
   3729 + I*4275,   /* k=10 */
   -943 + I*13619,   /* k=11 */
   -24559 + I*21491,   /* k=12 */
   -78063 + I*-5261,   /* k=13 */
   -123503 + I*-141581   /* k=14 */
 ]};

gp_inline__location="../dragon.tex:48417";
 GRQ(k) = GRQtotal(k)/RQ(k);

gp_inline__location="../dragon.tex:48436";
 GRQtotal(k) = \
   if(k==0,return(1/2-1/2*I)); \
   (57-21*I)/82 \
   + b^k/82 * ( \
       ( 70 - 15*I) * RQ(k) \
     + (  3 + 14*I) * RQ(k+1) \
     + (-17 - 11*I) * RQ(k+2) \
     );

gp_inline__location="../dragon.tex:48454";
 GRQtotal_samples = {[(1-I)/(2),2,(5+3*I)/(2),(1+11*I)/(2),(-23+19*I)/(2),(-71-5*I)/(2)]};

gp_inline__location="../dragon.tex:48550";
 gGRQtotal(x) = -1/2 \
   + (1-1/2*I)*1/(1-x) \
   + x*(1+1/2*I)*1/(1-x)*gLQ(b*x);

gp_inline__location="../dragon.tex:48589";
 gRQ_k_plus_1(x) = (gRQ(x) - RQ(0))/x;

gp_inline__location="../dragon.tex:48595";
 gRQ_k_plus_2(x) = (gRQ(x) - RQ(1)*x - RQ(0))/x^2;

gp_inline__location="../dragon.tex:48625";
 gGRQtotal_by_gRQ(x) = \
   -1/2 \
   + (57 - 21*I)/82 * 1/(1 - x) \
   + 1/82*(  ( 70 - 15*I)*gRQ(b*x) \
           + (  3 + 14*I)*gRQ_k_plus_1(b*x) \
           + (-17 - 11*I)*gRQ_k_plus_2(b*x) );

gp_inline__location="../dragon.tex:48645";
 GRQtotal_by_recurrence(k) = \
   b*GRQtotal(k-1) + 2*b^3*GRQtotal(k-3) + 3/2 - 9/2*I;

gp_inline__location="../dragon.tex:48656";
 GRtotal_samples_by_path = {1/2*[
   1 + I*0,   /* k=0 */
   3 + I*1,   /* k=1 */
   4 + I*6,   /* k=2 */
   -6 + I*18,   /* k=3 */
   -52 + I*24,   /* k=4 */
   -136 + I*-40,   /* k=5 */
   -184 + I*-288,   /* k=6 */
   148 + I*-836,   /* k=7 */
   1608 + I*-1224,   /* k=8 */
   4732 + I*516,   /* k=9 */
   7256 + I*8856,   /* k=10 */
   -2420 + I*27380,   /* k=11 */
   -49832 + I*42552,   /* k=12 */
   -156436 + I*-11820,   /* k=13 */
   -245992 + I*-285000   /* k=14 */
 ]};

gp_inline__location="../dragon.tex:48680";
 GR(k) = GRtotal(k)/R(k);

gp_inline__location="../dragon.tex:48719";
 GRtotal_formula(k) = \
   (57-21*I)/41 \
   + (3+I)/25 * (-1)^k \
   - (2+I)/10 * conj(b)^k \
   + (-111 + 1573*I)/2050 * b^k \
   + (3 + I)/5 * k * b^k \
   + b^k/82 * ( \
       ( 70 - 15*I) * R(k) \
     + (  3 + 14*I) * R(k+1) \
     + (-17 - 11*I) * R(k+2) \
     );
 GRtotal(k) = if(k==0, 1/2, GRtotal_formula(k));

gp_inline__location="../dragon.tex:48745";
 GRtotal_samples = {[(1)/(2),(3+I)/(2),2+3*I,-3+9*I,-26+12*I,-68-20*I]};

gp_inline__location="../dragon.tex:48801";
 GRf_symbolic = (70 + 3*'r - 17*'r^2)/82 \
             + (-15 + 14*'r - 11*'r^2)/82*I;
 GRf = subst(GRf_symbolic,'r,r);
 GRf_limit_real_nfelt = 1/82*(70*one_nfelt + 3*r_nfelt - 17*r_squared_nfelt);
 GRf_limit_imag_nfelt = 1/82*(-15*one_nfelt + 14*r_nfelt - 11*r_squared_nfelt);

gp_inline__location="../dragon.tex:48817";
GRf_real_sample = {(0319629/1000000)};

gp_inline__location="../dragon.tex:48823";
GRf_imag_sample = {(0279118/1000000)};

gp_inline__location="../dragon.tex:49193";
 GBQ(k) = GBQtotal(k)/BQ(k);

gp_inline__location="../dragon.tex:49196";
 GLQtotal(k) = LQ(k)*GLQ(k);
 GBQtotal(k) = GLQtotal(k) + GRQtotal(k);

gp_inline__location="../dragon.tex:49217";
 GBQtotal_formula(k) = {
   (57-21*I)/82
   + b^k/164 * (
       (88 + 28*I) * BQ(k)
     - (63 +  7*I) * BQ(k+1)
     + (29 - 15*I) * BQ(k+2)
     );
 }

gp_inline__location="../dragon.tex:49235";
 GBQtotal_samples = {[1,(5)/(2)+(1)/(2)*I,(5)/(2)+(7)/(2)*I,-(7)/(2)+(19)/(2)*I,-(47)/(2)+(19)/(2)*I,-(111)/(2)-(45)/(2)*I]};

gp_inline__location="../dragon.tex:49258";
 GB(k) = GBtotal(k)/B(k);

gp_inline__location="../dragon.tex:49261";
 GBtotal(k) = GLtotal(k) + GRtotal(k);

gp_inline__location="../dragon.tex:49292";
 GBtotal_formula(k) = {
   (57-21*I)/41
   + (1-I)/5  * (-1)^k
   - (2+I)/5  * conj(b)^k
   + (-29 + 97*I)/205 * b^k
   + b^k/164 * (
       (88 + 28*I) * B(k)
     - (63 +  7*I) * B(k+1)
     + (29 - 15*I) * B(k+2)
     );
 }

gp_inline__location="../dragon.tex:49315";
 GBtotal_samples = {[1,3+I,4+6*I,-6+18*I,-42+18*I,-104-44*I]};

gp_inline__location="../dragon.tex:49352";
 GBf = (88 - 63*r + 29*r^2)/164 + (28 - 7*r - 15*r^2)/164*I;

gp_inline__location="../dragon.tex:49362";
 GBf_limit_real_nfelt = 1/164*(88*one_nfelt - 63*r_nfelt + 29*r_squared_nfelt);
 GBf_limit_imag_nfelt = 1/164*(28*one_nfelt - 7*r_nfelt - 15*r_squared_nfelt);

gp_inline__location="../dragon.tex:49373";
GBf_real_sample = {(0393625/1000000)};

gp_inline__location="../dragon.tex:49377";
GBf_imag_sample = {(0164611/1000000)};

gp_inline__location="../dragon.tex:49501";
 GJAtotal_samples_by_path = { 1/2 * [
    (-5) + (3)*I,   /* k=3 */
    (-16) + (-4)*I,   /* k=4 */
    (-21) + (-29)*I,   /* k=5 */
    (16) + (-92)*I,   /* k=6 */
    (195) + (-133)*I,   /* k=7 */
    (544) + (100)*I,   /* k=8 */
    (755) + (1099)*I,   /* k=9 */
    (-608) + (3204)*I,   /* k=10 */
    (-6445) + (4395)*I,   /* k=11 */
    (-18336) + (-3452)*I,   /* k=12 */
    (-25325) + (-37141)*I,   /* k=13 */
    (20064) + (-105980)*I,   /* k=14 */
    (213395) + (-145557)*I,   /* k=15 */
    (609120) + (115204)*I   /* k=16 */
 ]};

gp_inline__location="../dragon.tex:49527";
 GJA(k) = GJAtotal(k)/JA(k);

gp_inline__location="../dragon.tex:49531";
 GJA_samples = {[(-5+3*I)/(2),-4-I,(-21-29*I)/(6),(4-23*I)/(3),(195-133*I)/(22),(136+25*I)/(9)]};

gp_inline__location="../dragon.tex:49557";
 GJAtotal(k) = {
     if(k<3,error("GJAtotal() is for k>=3"));
       1/164*(-21 - 57*I)
     + 1/20 *(  1 - 3*I )*(-1)^k
     + 1/410*( 32 - I   )*b^k
     + 1/82 * b^k
     * (   (57 + 20*I)*JA(k)
         - ( 4 +  5*I)*JA(k+1)
         + ( 9 +    I)*JA(k+2) );
 }

gp_inline__location="../dragon.tex:49568";
 gGJAtotal(x) = {
          1/2*I
          + 1/164*(-21 - 57*I) /(1 - x)
          + 1/20 *(  1 - 3*I ) /(1 + x)
          + 1/410*( 32 - I   ) /(1 - b*x)
          + 1/82
          * (
               (57 + 20*I)*gJA(b*x)
             + (-4 -  5*I)*gJA_k_plus_1(b*x)
             + ( 9 +    I)*gJA_k_plus_2(b*x)
            )
 };
 gJA_k_plus_1(x) =  gJA(x)/x;
 gJA_k_plus_2(x) =  gJA_k_plus_1(x)/x;

gp_inline__location="../dragon.tex:49590";
 GJAtotal_samples = {[(-5+3*I)/(2),-8-2*I,(-21-29*I)/(2),8-46*I,(195-133*I)/(2),272+50*I]};

gp_inline__location="../dragon.tex:49660";
 gGJAtotal_by_LQ(x) = 1/(1-x) * ( - x*gGLQtotal(x) + x*gJEQ(x) + gJA(b*x) );

gp_inline__location="../dragon.tex:49669";
 gGLQtotal(x) = 1/2*I + 1/2*gLQ(b*x);

gp_inline__location="../dragon.tex:49679";
 gJEQ(x) = (3/5 + 1/5*I)/(1-b*x) - (1/10 - 3/10*I)/(1+x);

gp_inline__location="../dragon.tex:49701";
 GJAtotal_by_recurrence(k) = {
   if(k<=3,return(GJAtotal(k)));
   GJAtotal(k-1) + JEQ(k-1) + b^k*JA(k) - GLQtotal(k-1);
 }

gp_inline__location="../dragon.tex:49769";
 GJAtotal_by_three_GRQtotal(k) = \
   (2-I)/10 * ( \
       GRQtotal(k+1) \
     + 2*I* GRQtotal(k) \
     - 4*I* GRQtotal(k-1) \
     - b^(k+1) \
     + 1/2*conj(b) * (-1)^k \
   );

gp_inline__location="../dragon.tex:49819";
 GJAf = (57-4*r+9*r^2)/82 + (20-5*r+r^2)/82*I;

gp_inline__location="../dragon.tex:49822";
 GJAf_real_nfelt = 1/82*(57*one_nfelt - 4*r_nfelt + 9*r_squared_nfelt);
 GJAf_imag_nfelt = 1/82*(20*one_nfelt - 5*r_nfelt + r_squared_nfelt);

gp_inline__location="../dragon.tex:49853";
GJA_limit_real = {(092797/100000)};

gp_inline__location="../dragon.tex:49860";
GJA_limit_imag = {(017557/100000)};

gp_inline__location="../dragon.tex:50108";
GJAf_denominator = nfeltpow(cubic_nf, one_nfelt-r_nfelt,2) \
                 + r_squared_nfelt;

gp_inline__location="../dragon.tex:50210";
 \\ Return a vector of the midpoints of each segment in curve k.
 \\ Each has the segments centroid GS(k) subtracted so that the
 \\ centroid (vector sum) of these adjusted midpoints is 0.
 dragon_midpoints_at_centroid(k) = {
   my(centroid = GS(k));
   apply(z -> z-centroid, dragon_midpoints(k));
 }

gp_inline__location="../dragon.tex:50218";
 \\ Return inertia of curve k about an axis angle a from the X axis.
 Ika_by_points(k,a) = {
   my(v = dragon_midpoints_at_centroid(k)
          * 1/((b/sqrt(2))^k * exp(a*I)));
   sum(i=1,#v, imag(v[i])^2);
 }

gp_inline__location="../dragon.tex:50225";
 \\ Return inertia of curve k about the X axis.
 I_x_by_points(k) = {     /* I_x = sum y^2 + z^2 = sum y^2 */
   my(v = dragon_midpoints_at_centroid(k) * conj(b)^k);
   sum(i=1,#v, imag(v[i])^2) / 2^k;
 }
 I_y_by_points(k) = {     /* I_x = sum x^2 + z^2 = sum x^2 */
   my(v = dragon_midpoints_at_centroid(k) * conj(b)^k);
   sum(i=1,#v, real(v[i])^2) / 2^k;
 }
 I_xy_by_points(k) = {
   my(v = dragon_midpoints_at_centroid(k) * conj(b)^k);
   sum(i=1,#v, imag(v[i])*real(v[i])) / 2^k;
 }
 I_z_by_points(k) = {
   my(v = dragon_midpoints_at_centroid(k) * conj(b)^k);
   sum(i=1,#v, norm(v[i])) / 2^k;
 }
 I_x_by_points = memoize(I_x_by_points);
 I_y_by_points = memoize(I_y_by_points);
 I_z_by_points = memoize(I_z_by_points);
 I_xy_by_points = memoize(I_xy_by_points);

gp_inline__location="../dragon.tex:50247";
 \\ Return matrix of inertia of curve k.
 I_inertia_by_points(k) = {
  my(v = dragon_midpoints_at_centroid(k));
  my(m = geom_inertia_of_points(v));
  geom_inertia_rotate_xydir(m, b^k);  \\ endpoint on X axis
 }

gp_inline__location="../dragon.tex:50277";
 I_inertia(k) = {
   my(x=I_x(k), y=I_y(k), xy=I_xy(k), z=I_z(k));
   [  x,   -xy, 0;
     -xy,   y,  0;
      0,    0,  z  ];
 }

gp_inline__location="../dragon.tex:50308";
 I_x_multiply_vector = {[29,23,21,27]};

gp_inline__location="../dragon.tex:50313";
 I_x_constant_vector = {[(1)/(25),(1)/(100)]};

gp_inline__location="../dragon.tex:50318";
 I_x_formula(k) = 3/50 * 4^k \
      - 1/200 * vector_modulo(I_x_multiply_vector,k) * 2^k \
      - vector_modulo(I_x_constant_vector,k);
 I_x(k) = if(k==0,0, I_x_formula(k));

gp_inline__location="../dragon.tex:50326";
 I_x_samples = {[0,0,(1)/(2),(11)/(4),13,(231)/(4),239,(3863)/(4),3895,(62679)/(4)]};

gp_inline__location="../dragon.tex:50351";
 I_y_multiply_vector = {[1,27,49,23]};

gp_inline__location="../dragon.tex:50356";
 I_y_constant_vector = {[(1)/(100),(1)/(25)]};

gp_inline__location="../dragon.tex:50361";
 I_y_formula(k) = 7/50 * 4^k \
       - 1/200 * vector_modulo(I_y_multiply_vector,k) * 2^k \
       - vector_modulo(I_y_constant_vector,k);
 I_y(k) = if(k==0,0, I_y_formula(k));

gp_inline__location="../dragon.tex:50369";
 I_y_samples = {[0,(1)/(4),(5)/(4),8,(143)/(4),139,(2231)/(4),2279,(36695)/(4),36631]};

gp_inline__location="../dragon.tex:50393";
 I_xy_vector = {[-1,-7,1,7]};

gp_inline__location="../dragon.tex:50398";
 I_xy(k) = {
     3/100 * 4^k
   + 1/100 * vector_modulo(I_xy_vector,k) * 2^k
   - 1/50  * (-1)^k;
 }

gp_inline__location="../dragon.tex:50405";
 I_xy_samples = {[0,0,(1)/(2),(5)/(2),(15)/(2),(57)/(2),(247)/(2),(1001)/(2)]};

gp_inline__location="../dragon.tex:50426";
 I_z_vector = {[3,5,7,5]};

gp_inline__location="../dragon.tex:50431";
 I_z(k)= 1/5*4^k - 1/20*vector_modulo(I_z_vector,k)*2^k - 1/20;

gp_inline__location="../dragon.tex:50435";
 I_z_samples = {[0,(1)/(4),(7)/(4),(43)/(4),(195)/(4),(787)/(4),(3187)/(4),(12979)/(4)]};

gp_inline__location="../dragon.tex:50467";
 Ika(k,a) = \
   I_x(k)*cos(a)^2 - 2*I_xy(k)*cos(a)*sin(a) + I_y(k)*sin(a)^2;

gp_inline__location="../dragon.tex:50566";
 dG_inexact(k) = (GS(k) - GS(k-1)) *conj(w8_inexact)^k;
 dG_point(k) = geom_point_rotate_xydir(GS(k) - GS(k-1), conj(b)^k);
 point_to_vector2(p) = [geom_point_x(p), geom_point_y(p)];

gp_inline__location="../dragon.tex:50575";
 dG_inexact_by_powers(k) = \
     (3/10 + 1/10*I) * sqrt(2)^k \
   + (1/5 - 1/10*I) * (-I/sqrt(2))^k;

gp_inline__location="../dragon.tex:50648";
 xydir45 = [1; 1; 0];
 R45 = {[ 1/sqrt2,    -1/sqrt2,  0;
          1/sqrt2,     1/sqrt2,  0;
          0,              0,     1 ]};
 xydir_arg(p) = arg(geom_point_x(p)*1.0 + geom_point_y(p)*1.0*I);
 R90 = [0,-1,0;  1,0,0;  0,0,1];

gp_inline__location="../dragon.tex:50684";
 Ipoint_by_re_im(z) = {
   [ imag(z)^2,          - real(z)*imag(z), 0;
     - real(z)*imag(z),  real(z)^2,         0;
     0,                  0,                 norm(z) ];
 }
 Ipoint(p) = geom_inertia_of_point(p);

gp_inline__location="../dragon.tex:50715";
 I_inertia_by_parts(k) = {
   if(k==0,return([0,0,0; 0,0,0; 0,0,0]));
     R45^-1 * I_inertia(k-1) * R45
   + R45^-3 * I_inertia(k-1) * R45^3
   + 2^k * Ipoint(dG_point(k));
 }

gp_inline__location="../dragon.tex:50732";
 sG_inexact(k) = 2 * sqrt(2)^k * dG_inexact(k);

gp_inline__location="../dragon.tex:50739";
 sG(k) = (3/5 + 1/5*I) * 2^k + (2/5 - 1/5*I) * (-I)^k;

gp_inline__location="../dragon.tex:50747";
 sG_real_vector = {[2,-1,-2,1]};
 sG_real(k) = {
   k>=0 || error("sG_real() is for k>=0");
   3/5*2^k + 1/5*vector_modulo(sG_real_vector,k);
 }

gp_inline__location="../dragon.tex:50762";
 sG_real_binary_endings = [1,10,101,1010];

gp_inline__location="../dragon.tex:50774";
 sG_real_binary_vector(k) = {
   k-=1;
   concat(concat_repeat([1,0,0,1], k\4),
          digits(vector_modulo(sG_real_binary_endings,k)));
 }

gp_inline__location="../dragon.tex:50782";
 sG_real_samples = {[1,1,2,5,10,19,38,77,154,307,614]};

gp_inline__location="../dragon.tex:50799";
 sG_imag_vector = {[-1,-2,1,2]};
 sG_imag(k) = 1/5*2^k + 1/5*vector_modulo(sG_imag_vector,k);

gp_inline__location="../dragon.tex:50825";
 sG_imag_binary_endings = [11, 110, 1101, 11010];

gp_inline__location="../dragon.tex:50843";
 sG_imag_binary_vector(k) = {
   k-=4;
   concat([
     concat_repeat([1,1,0,0], k\4),
     digits(vector_modulo(sG_imag_binary_endings,k))
   ]);
 }

gp_inline__location="../dragon.tex:50854";
 sG_imag_samples = {[0,0,1,2,3,6,13,26,51,102,205]};

gp_inline__location="../dragon.tex:50874";
 I_x_by_mutual(k) = if(k==0,return(0)); \
   I_x(k-1) + I_y(k-1) + 1/4 * sG_imag(k)^2;

gp_inline__location="../dragon.tex:50882";
 I_y_by_mutual(k) = if(k==0,return(0)); \
   I_x(k-1) + I_y(k-1) + 1/4 * sG_real(k)^2;

gp_inline__location="../dragon.tex:50890";
 I_xy_by_mutual(k) = 1/4 * sG_real(k) * sG_imag(k);

gp_inline__location="../dragon.tex:50898";
 I_z_by_recurrence_sG(k) = {
   if(k==0,return(I_z(0)));
   2*I_z(k-1) + 1/4*norm(sG(k));
 }

gp_inline__location="../dragon.tex:50905";
 I_z_by_recurrence_dG(k) = {
   if(k==0,return(I_z(0)));
   2*I_z(k-1) + 2*2^(k-1) * geom_norm(dG_point(k));
 }

gp_inline__location="../dragon.tex:50924";
 I_z_by_sG_powers_of_2(k) = \
   1/4 * sum(j=1,k, 2^(k-j) * norm(sG(j)));

gp_inline__location="../dragon.tex:50939";
 I_x_by_I_z_previous(k) = if(k==0,return(0)); \
   I_z(k-1) + 1/4 * sG_imag(k)^2;

gp_inline__location="../dragon.tex:50945";
 I_y_by_I_z_previous(k) = if(k==0,return(0)); \
   I_z(k-1) + 1/4 * sG_real(k)^2;

gp_inline__location="../dragon.tex:50979";
 I_d_squared_xydir(k) = [I_x(k)-I_y(k), -2*I_xy(k)];
 I_d_xydir(k) = geom_xydir_half(I_d_squared_xydir(k));

gp_inline__location="../dragon.tex:50983";
 xydir_real_x(p) = {
   [ simplify(geom_point_x(p) * conj(geom_point_x(p))),
     geom_sqrt_as_quad(simplify(conj(geom_point_x(p))^2)
                       * simplify(geom_point_y(p)^2))
   ];
 }

gp_inline__location="../dragon.tex:50990";
 \\ return 1 if matrix m has its non-diagonals nearly_equal to 0
 nearly_diagonal(m) = {
   for(i=1,matsize(m)[1],
     for(j=1,matsize(m)[2],
       if(i!=j && ! nearly_equal(m[i,j],0), return(0))));
   1;
 }

gp_inline__location="../dragon.tex:51007";
 I_2arctan(k) = -2 * I_xy(k) / (I_x(k) - I_y(k));

gp_inline__location="../dragon.tex:51024";
 I_2arctan_by_sG(k) = \
   2*sG_real(k)*sG_imag(k) \
   / (sG_real(k)^2 - sG_imag(k)^2);

gp_inline__location="../dragon.tex:51038";
 I_alpha_min = atan(1/3);

gp_inline__location="../dragon.tex:51047";
 I_alpha_min_sample = {(18434948/1000000)};

gp_inline__location="../dragon.tex:51054";
 quadrant(a) = floor(a / (Pi/2)) % 4 + 1;

gp_inline__location="../dragon.tex:51066";
 I_alpha_max = I_alpha_min + Pi/2;
 I_alpha_max_sample = {(108434948/1000000)};

gp_inline__location="../dragon.tex:51169";
 I_horizontal(k) = {
   my(g = GSF(k));
   my(s = sG(k));
   g - imag(g)/imag(s) * s;
 }

gp_inline__location="../dragon.tex:51180";
 I_horizontal_vector = {[1,3,-1,-3]};

gp_inline__location="../dragon.tex:51186";
 I_horizontal_by_1(k) = {
   1
   + 1/10*(vector_modulo(I_horizontal_vector,k) - 1/2^k)
   /sG_imag(k);
 }

gp_inline__location="../dragon.tex:51210";
 sG_squared_as_point(k) = \
   my(z=sG(k)^2); [geom_point_x(z),geom_point_y(z)];

gp_inline__location="../dragon.tex:51232";
 sG_gcd_vector = {[1,1,-1,-1]};

gp_inline__location="../dragon.tex:51278";
 If = [3/50,-3/100,0; -3/100,7/50,0; 0,0,1/5];

gp_inline__location="../dragon.tex:51289";
 \\ If with unit mass, area 1/2

gp_inline__location="../dragon.tex:51293";
 If_principal = [1/20,0,0; 0,3/20,0; 0,0,1/5];

gp_inline__location="../dragon.tex:51323";
 If_Rh = (3/100)^(1/8);

gp_inline__location="../dragon.tex:51326";
 If_Rh_sample = {(0645119/1000000)};

gp_inline__location="../dragon.tex:51341";
 If_Rw = sqrt(3)*If_Rh;

gp_inline__location="../dragon.tex:51344";
 If_Rw_sample = {(1117379/1000000)};

gp_inline__location="../dragon.tex:51365";
 If_Eb = ( 1/(10*Pi*sqrt(3)) )^(1/4);
 If_ellipse_h = 2 / ( 10*Pi*sqrt(3) )^(1/4);

gp_inline__location="../dragon.tex:51368";
 If_Eb_sample = {(0368190/1000000)};

gp_inline__location="../dragon.tex:51382";
 If_Ea = sqrt(3)*If_Eb;

gp_inline__location="../dragon.tex:51385";
 If_Ea_sample = {(0637724/1000000)};

gp_inline__location="../dragon.tex:51489";
 If_Rarea = If_Rw * If_Rh;

gp_inline__location="../dragon.tex:51496";
 If_Rarea_sample = {(0720843/1000000)};

gp_inline__location="../dragon.tex:51508";
 If_Earea = geom_area_of_ellipse(If_Ea,If_Eb);

gp_inline__location="../dragon.tex:51516";
 If_Earea_sample = {(0737658/1000000)};

gp_inline__location="../dragon.tex:51524";
 \\ shift and rotate to G and alpha_min axes, but inexact
 z_to_G_axes(z) = (z - Gf) / (3+I) * abs(3+I);

gp_inline__location="../dragon.tex:51573";
 hull_fractal_at_centroid = apply(z->z-HGf, hull_fractal);
 hull_fractal_inertia = {
   \\ multiply 2 for mass=2*area
   2*geom_inertia_of_polygon(hull_fractal_at_centroid);
 }

gp_inline__location="../dragon.tex:51592";
 HI_x = {(9497)/(61236)};

gp_inline__location="../dragon.tex:51600";
 HI_y = {(40963)/(122472)};

gp_inline__location="../dragon.tex:51608";
 HI_xy = {(12743)/(244944)};

gp_inline__location="../dragon.tex:51621";
 HI_alpha_min_2fraction = {(12743)/(21969)};

gp_inline__location="../dragon.tex:51629";
 HI_alpha_min = 1/2*atan(HI_alpha_min_2fraction);
 HI_alpha_max = HI_alpha_min + Pi/2;

gp_inline__location="../dragon.tex:51644";
HI_alpha_min_sample = {(15057822/1000000)};

gp_inline__location="../dragon.tex:51729";
 HI_A = 21969;
 HI_B = 12743;
 HI_C = geom_sqrt_as_quad(HI_A^2 + HI_B^2);
 HI_p = sqrt(HI_C + HI_A)/2;
 HI_q = sqrt(HI_C - HI_A)/2;

gp_inline__location="../dragon.tex:51744";
 HI_y_intercept = imag(HGf) +(1-real(HGf))*tan(HI_alpha_min);
HI_y_intercept_sample = {(0004408/1000000)};

gp_inline__location="../dragon.tex:51756";
 HI_alpha_d = -( (HI_x - HI_y)/2 - HI_xy*I );
 HI_alpha_slope = sqrt(HI_alpha_d);

gp_inline__location="../dragon.tex:51773";
 HI_P3_intercept = imag(HGf) - (1/3+real(HGf))*tan(HI_alpha_min);
 HI_P3_intercept_diff = HI_P3_intercept - (-1/3);
 HI_P3_intercept_diff_sample = {-(00209660/10000000)};

gp_inline__location="../dragon.tex:51797";
 dragon_midpoint(n) = 1/2*(dragon_point(n) + dragon_point(n+1));

gp_inline__location="../dragon.tex:52101";
 MB(k) = 2*BQ(k);

gp_inline__location="../dragon.tex:52104";
 MB_samples = {[4,6,10,18,30,50,86,146,246,418]};

gp_inline__location="../dragon.tex:52116";
 gMB(x) = 2*gBQ(x);

gp_inline__location="../dragon.tex:52129";
 MI(k) = 1/2*(4*2^k - MB(k));

gp_inline__location="../dragon.tex:52135";
 MI_samples = {[0,1,3,7,17,39,85,183,389,815]};

gp_inline__location="../dragon.tex:52146";
 gMI(x) = 1/2*(4*gTwoPow(x) - gMB(x));

gp_inline__location="../dragon.tex:52160";
 MS(k) = MB(k) + MI(k);

gp_inline__location="../dragon.tex:52162";
 gMS(x) = gMB(x) + gMI(x);

gp_inline__location="../dragon.tex:52175";
 MS_samples = [ 4, 7, 13, 25, 47, 89, 171, 329, 635 ];

gp_inline__location="../dragon.tex:52328";
 MW(k) = MS(k) - (2^k-1);

gp_inline__location="../dragon.tex:52330";
 MW_samples = {[4,6,10,18,32,58,108,202,380,722]};

gp_inline__location="../dragon.tex:52336";
 gMW(x) = gMS(x) - gTwoPow(x) + gOnes(x);

gp_inline__location="../dragon.tex:52346";
 MWI(k) = MW(k) - MB(k);

gp_inline__location="../dragon.tex:52355";
 MWI_samples = {[0,0,0,0,2,8,22,56,134,304]};

gp_inline__location="../dragon.tex:52475";
 Mturn(n) = my(t=turn(n)); if(turn(n+1) == t, t, 0);

gp_inline__location="../dragon.tex:52484";
 Mturn_by_two_turn(n) = 1/2*(turn(n) + turn(n+1));

gp_inline__location="../dragon.tex:52491";
 Mturn_by_sBit(n) = 1 - sBitAboveLowest(n);

gp_inline__location="../dragon.tex:52495";
 Mturn_samples = {[1,0,0,1,0,-1,0,1,1,0,-1,0,0,-1,0,1,1]};

gp_inline__location="../dragon.tex:52500";
 Mturn_samples_more = [1, 0, 0, 1, 0, -1, 0, 1, 1, 0, -1, 0, 0, -1, 0, 1, 1, 0, 0, 1, 0, -1, -1, 0, 1, 0, -1, 0, 0, -1];

gp_inline__location="../dragon.tex:52513";
 Mturn_from_path_samples = [ 1,0,0,1,0,-1,0,1,1,0,-1,0,0,-1,0,1,1,0,0,1,0,-1,-1,0,1,0,-1,0,0,-1,0,1,1,0,0,1,0,-1,0,1,1,0,-1,0,0,-1,-1,0,1,0,0,1,0,-1,-1,0,1,0,-1,0,0,-1,0,1 ];

gp_inline__location="../dragon.tex:52525";
 gMturn(x) = x/(1-x) - gsBitAboveLowest(x);

gp_inline__location="../dragon.tex:52535";
 gMturn_by_paper(x,k) = (1+1/x)*gTurnLpred_to_k(x,k) - 1/(1-x);

gp_inline__location="../dragon.tex:52545";
 Mturn_constant = gMturn(1/2);

gp_inline__location="../dragon.tex:52552";
 Mturn_constant_decimal = {(0552208564/1000000000)};

gp_inline__location="../dragon.tex:52569";
 twindragon_points(k) = {
   k>=0 || error("twindragon_points() is for k>=0");
   my(v = dragon_points(k+1));
   my(end = v[#v]);
   v = v[^-1];
   concat(v, apply(c->(end - c), v));
 }

gp_inline__location="../dragon.tex:52578";
 twindragon_midpoints(k) = {
   k>=0 || error("twindragon_midpoints() is for k>=0");
   my(v = dragon_midpoints(k+1));
   my(end = b^(k+1));
   concat(v, apply(c->(end - c), v));
 }

gp_inline__location="../dragon.tex:52929";
 TB(k) = 2*R(k+1);
 gTB(x) = 2*1/x*(gR(x) - R(0));

gp_inline__location="../dragon.tex:52935";
 TB_samples = {[4,8,16,32,56,96,168,288,488,832,1416]};

gp_inline__location="../dragon.tex:52951";
 TBQ(k) = 2*RQ(k+1);
 gTBQ(x) = 2*gBQ(x);

gp_inline__location="../dragon.tex:52956";
 TBQ_samples = {[4,6,10,18,30,50,86,146,246,418,710]};

gp_inline__location="../dragon.tex:52973";
 TA(k) = 2*A(k+1) + LQ(k+1);

gp_inline__location="../dragon.tex:52982";
 TA_samples = {[1,2,4,8,18,40,86,184,390,816,1694]};

gp_inline__location="../dragon.tex:53013";
 gTA(x) = (1 - 2*x + x^2 - 2*x^3 + 4*x^4) \
        / ( (1 - x) * (1 - 2*x) * (1 - x - 2*x^3) );

gp_inline__location="../dragon.tex:53089";
 TD(k) = TA(k) - 1;
 gTD(x) = gTA(x) - gOnes(x);

gp_inline__location="../dragon.tex:53103";
 TS(k) = 2^(k+2) - 2*TD(k);
 gTS(x) = 4*gTwoPow(x) - 2*gTD(x);

gp_inline__location="../dragon.tex:53113";
 TS_by_S(k) = 2*S(k+1) - 2*(LQ(k+1)-1) - 2;

gp_inline__location="../dragon.tex:53206";
 TS_by_count(k) = vector_count_singles(twindragon_points(k));
 TS_by_count = memoize(TS_by_count);

gp_inline__location="../dragon.tex:53210";
 TD_by_count(k) = vector_count_duplicates(twindragon_points(k));
 TD_by_count = memoize(TD_by_count);

gp_inline__location="../dragon.tex:53232";
 TP(k) = TS(k) + TD(k);
 gTP(x) = gTS(x) + gTD(x);

gp_inline__location="../dragon.tex:53257";
 TP_samples = [ 4, 7, 13, 25, 47, 89, 171, 329, 635 ];

gp_inline__location="../dragon.tex:53291";
 n_binary_to_base(n,b) = fromdigits_any(binary(n),b);

gp_inline__location="../dragon.tex:53293";
 PlusPoint(n) = n_binary_to_base(n,I+1);
 PlusPoints(k) = vector(2^k,n,n--; PlusPoint(n));

gp_inline__location="../dragon.tex:53302";
 z_base_to_n(z,b) = {
   my(l=List([]));  \\ bits of n low to high
   while(z,
         z_is_integer(z)||error();
         my(bit=z_mod_b(z));
         listput(l,bit);
         my(new_z=(z-bit)/b);
         if(z==new_z,return(-1));  \\ no n for this z
         z=new_z);
   fromdigits(Vecrev(l),2);
 }
 PlusUnpoint(z) = z_base_to_n(z,I+1);

gp_inline__location="../dragon.tex:53316";
 \\ f is a fraction 0 <= f <= 1.
 \\ Return it transformed by a base change from 2 to the given b.
 frac_binary_to_base(f,b) = \
   vecper_frac_fromdigits(vecper_frac_digits(f,2),b);
 PlusFpoint(f) = frac_binary_to_base(f,I+1);

gp_inline__location="../dragon.tex:53327";
 PlusPoint_samples = {[0,1,1+I,2+I,2*I,1+2*I,1+3*I,2+3*I]};

gp_inline__location="../dragon.tex:53364";
 A146559(n) = {
   if(n%4==2,0, (-1)^((n+2)\4)*2^(n\2));
 }

gp_inline__location="../dragon.tex:53408";
 A290884(n) = imag(subst(Pol(binary(n-1)),'x,I+1));

gp_inline__location="../dragon.tex:53415";
 A290885(n) = -real(subst(Pol(binary(n-1)),'x,I+1));

gp_inline__location="../dragon.tex:53424";
 \\ could be fromdigits(), but it doesn't accept non-integer bases
 A290886(n) = norm(subst(Pol(binary(n-1)),'x,I+1));

gp_inline__location="../dragon.tex:53709";
 PlusToDragon(z) = z*(-1+I);
 DragonToPlus(z) = z/(-1+I);

gp_inline__location="../dragon.tex:53720";
 \\ all points in level k

gp_inline__location="../dragon.tex:53915";
 TW(k) = 2*(TBQ(k) + TD(k));

gp_inline__location="../dragon.tex:53925";
 TW_samples = {[8,14,26,50,94,178,342,658,1270]};

gp_inline__location="../dragon.tex:53932";
 gTW(x) = 2*(gTBQ(x) + gTD(x));

gp_inline__location="../dragon.tex:54127";
 \\ Return the i+1 location z which is dragon segment n.
 NdragonToPlus_z(n) = {
   my(z=dragon_point(n)*conj(b));
   my(dz=I^dir(n)/b);
   dz/=b;
   if(n%2==1, dz*=I);
   z + dz + I/2;
 }

gp_inline__location="../dragon.tex:54143";
 NdragonToPlus_by_z(n) = PlusUnpoint(NdragonToPlus_z(n));

gp_inline__location="../dragon.tex:54156";
 NdragonToPlus(n) = FlipAt10(2*n);

gp_inline__location="../dragon.tex:54161";
 NdragonToPlus_samples = {[0,1,3,5,7,6,11,13,15,14,12,10,23,22,27,29]};

gp_inline__location="../dragon.tex:54179";
 \\ return a bit-mask which can be XORed onto n for FlipAt10
 FlipAt10xor(n) = {
   my(v=binary(n),ret=vector(#v));
   for(i=1,#v-1, if(v[i]==1 && v[i+1]==0,
                    for(j=i,#v, ret[j]=1-ret[j])));
   fromdigits(ret,2);
 }
 FlipAt10(n) = bitxor(n,FlipAt10xor(n));

gp_inline__location="../dragon.tex:54193";
 FlipAt10_samples = {[0,1,1,3,3,2,5,7,7,6,6,4,11,10,13,15,15]};

gp_inline__location="../dragon.tex:54202";
 FlipAt10_binary_samples = {[0,1,1,11,11,10,101,111,111,110]};

gp_inline__location="../dragon.tex:54390";
 NdragonToPlus_state_table = {[ 0,1;
                                2,1;
                                2,3;
                                0,3 ]};
 NdragonToPlus_state_output = {[ 0,0;     \\ out 0
                                 0,1;     \\ out same
                                 1,1;     \\ out 1
                                 1,0 ]};  \\ out flip
 NdragonToPlus_transition(state,bit) = \
   NdragonToPlus_state_table[state+1,bit+1];
 NdragonToPlus_output(state,bit) = \
   NdragonToPlus_state_output[state+1,bit+1];
 NdragonToPlus_by_states(n) = {
   my(debug=0);
   if(n==0,return(0));
   my(v=concat([0,0],binary(n)));
   \\ while(#v<2,v=concat(0,v));
   my(o=vector(#v),state=v[1]*2+v[2]);
   if(debug,print("v="v" initial state "state));
   if(state>=2,state=bitxor(state,1));
   for(i=3,#v,
       my(bit=v[i]);
       if(debug,print("  at i="i" state "state" bit "bit" output "NdragonToPlus_output(state,bit)));
       o[i-2]=NdragonToPlus_output(state,bit);
       state=NdragonToPlus_transition(state,bit));
   if(debug,print("  final state "state" o="o));
   if(state>=2,state=bitxor(state,1));
   fromdigits(o,2) + state;
 }

gp_inline__location="../dragon.tex:54427";
 NdragonToPlus_by_states_2zeros(n) = {
   my(debug=0);
   my(v=binary(4*n),o=vector(#v),state=0);
   if(debug,print("v="v" initial state "state));
   for(i=1,#v,
       my(bit=v[i]);
       if(debug,print("  at i="i" state "state" bit "v[i]" output "flipping_state_output[state+1,v[i]+1]));
       o[i]=NdragonToPlus_output(state,bit);
       state=NdragonToPlus_transition(state,bit));
   fromdigits(o,2);
 }

gp_inline__location="../dragon.tex:54608";
 \\ Undo FlipAt10() flipping, with output having low bit "low".
 \\ FlipAt10() maps some n to the same output.  Must know the
 \\ low bit of the original n to get back to it.
 UnFlipAt10_for_low(n,low) = {
   my(v=concat(0,binary(n)));  \\ print("n="n" v="v);
   my(f=bitxor(low,v[#v]),o=v);
   forstep(i=#v,1,-1,  \\ low to high
       o[i]=bitxor(o[i],f);
       if(i<#v&&o[i]==1&&o[i+1]==0,  \\ print("10 at i=="i);
          f=1-f);
       );
   if(f==0,   \\ print("found low_f="low_f" "o);
      fromdigits(o,2),
      -1);
 }

gp_inline__location="../dragon.tex:54636";
 \\ undo flipping at and below each 10, demand low bit 0
 NplusToDragon(n) = UnFlipAt10_for_low(n,0)/2;

gp_inline__location="../dragon.tex:54688";
 PlusJump(k) = b^(k+1) - I;

gp_inline__location="../dragon.tex:54690";
 PlusJump_samples = {[1,I,-2+I,-4-I,-4-5*I]};

gp_inline__location="../dragon.tex:54718";
 PlusJump_vector = {[-2,-2,-2,0,2,2,2,0]};

gp_inline__location="../dragon.tex:54724";
 PlusJump_norm(k) = \
   2^(k+1) + vector_modulo(PlusJump_vector,k)*2^ceil(k/2) + 1;

gp_inline__location="../dragon.tex:54729";
 PlusJump_norm_complete_the_square(k) = {
   2*(sqrt2^k
      + vector_modulo([-1/2,-1/sqrt2,-1/2,0, 1/2,1/sqrt2,1/2,0],k)
     )^2
   + vector_modulo([1/2, 0, 1/2, 1],k);
 }

gp_inline__location="../dragon.tex:54750";
 PlusJump_norm_samples = [1,1,5,17,41, 9*9, 145,257,481, 31*31];

gp_inline__location="../dragon.tex:54842";
 PlusDist_inexact(k) = sum(j=0,k-1, 2^j * abs(PlusJump(k-1-j)));

gp_inline__location="../dragon.tex:54844";
 PlusDist_as_quads(k) = {
   my(v=vector(k,j,j--;  \\ j=0 to k-1 inclusive
               2^j * geom_sqrt_as_quad(PlusJump_norm(k-1-j))));
   v=Vecrev(v);
   if(#v >= 2, v[1] += v[2]; v=v[^2]);
   v;
 }

gp_inline__location="../dragon.tex:54858";
 PlusDist_samples_inexact = [0,1,3,6+sqrt(5),12+2*sqrt(5)+sqrt(17)];

gp_inline__location="../dragon.tex:54881";
 PlusMean_inexact(k) = PlusDist_inexact(k) / (2^k-1);

gp_inline__location="../dragon.tex:54923";
 PlusMean_vector = {[0,-2,-2,-2,0,2,2,2]};

gp_inline__location="../dragon.tex:54933";
 PlusMean_sum_root_part(j) = \
   1 + vector_modulo(PlusMean_vector,j) / 2^ceil(j/2) + 1/2^j;
 PlusMean_inexact_by_sum(k) = {
   2^k / (2^k - 1)
   * sum(j=1,k, 1/sqrt(2)^j * sqrt(PlusMean_sum_root_part(j)));
 }

gp_inline__location="../dragon.tex:54943";
 PlusMean_limit = PlusMean_inexact(1000);

gp_inline__location="../dragon.tex:54951";
 PlusMean_limit_sample = {(1932993/1000000)};

gp_inline__location="../dragon.tex:54981";
 PlusMean_sqrt2_sum(k) = sum(j=1,k, 1/sqrt(2)^j );

gp_inline__location="../dragon.tex:54984";
 PlusMean_sqrt2_sum_limit = 1 + sqrt2;

gp_inline__location="../dragon.tex:54988";
 PlusMean_sqrt2_sum_limit_sample = {(2414213/1000000)};

gp_inline__location="../dragon.tex:55037";
 PlusJumpManhattan_vector = {[-1,-1,-1,1,1,1,1,1]};
 PlusJumpManhattan(k) = \
   2*2^floor(k/2) + vector_modulo(PlusJumpManhattan_vector,k);

gp_inline__location="../dragon.tex:55054";
 PlusJumpManhattan_samples = {[1,1,3,5,9,9,17,17,31,31]};

gp_inline__location="../dragon.tex:55073";
 PlusDistManhattan_vector = {[193,131,7,-241,-227,-199,-143,-31]};
 PlusDistManhattan(k) = {
   572/255 * 2^k
   - vector_modulo([3, 4],k) * 2^floor(k/2)
   + 1/255 * vector_modulo(PlusDistManhattan_vector,k);
 }

gp_inline__location="../dragon.tex:55082";
 PlusDistManhattan_by_n(k) = {
   sum(n=1,2^k-1, Manhattan(PlusPoint(n)
                          - PlusPoint(n-1)));
 }

gp_inline__location="../dragon.tex:55091";
 PlusDistManhattan_samples = {[0,1,3,9,23,55,119,255,527,1085]};

gp_inline__location="../dragon.tex:55106";
 PlusMeanManhattan_limit = 572/255;

gp_inline__location="../dragon.tex:55111";
 PlusMeanManhattan_limit_sample = {(2243137/1000000)};

gp_inline__location="../dragon.tex:55135";
 gen_TS_odd_odd = [ 2,2,4,8,12,20,36,60,100,172];
 gen_TS_odd_even = [ 2,4,8,12,20,36,60,100,172,292];
 gen_TS_even_even = [ 2,4,6,10,18,30,50,86,146,246];
 gen_TS_a_dash_samples = [ 1,2,3,5,9,15,25,43,73,123];
 gen_TS_b_dash_samples = [ 1,1,2,4,6,10,18,30,50,86];
 gen_TS_c_dash_samples = [ 1,2,4,6,10,18,30,50,86,146];

gp_inline__location="../dragon.tex:55156";
 MinusPoint(n) = n_binary_to_base(n,I-1);
 MinusPoints(k) = vector(2^k,n,n--; MinusPoint(n));

gp_inline__location="../dragon.tex:55171";
 MinusUnpoint(z) = z_base_to_n(z,I-1);

gp_inline__location="../dragon.tex:55183";
 MinusFpoint(f) = frac_binary_to_base(f,I-1);
 MinusFpoint_of_vecper(v) = vecper_frac_fromdigits(v,I-1);

gp_inline__location="../dragon.tex:55223";
 MinusPoint_samples = {[0,1,-1+I,I,-2*I,1-2*I,-1-I,-I]};

gp_inline__location="../dragon.tex:55242";
 A318438(n) = real(MinusPoint(n));
 A318439(n) = imag(MinusPoint(n));

gp_inline__location="../dragon.tex:55251";
 A009116(n) = real((-1-I)^n);

gp_inline__location="../dragon.tex:55267";
 A108520(n) = imag((I-1)^(n+1));

gp_inline__location="../dragon.tex:55295";
 \\ A001057 alternating pos neg = 0, 1, -1, 2, -2, 3, -3, 4, -4
 A001057(n) = if(bittest(n,0), (n>>1)+1, -(n>>1));

gp_inline__location="../dragon.tex:55318";
 \\ A130472 alternating pos neg = 0, -1, 1, -2, 2, -3, 3, -4, 4
 A130472(n) = if(bittest(n,0), -(n>>1)-1, (n>>1));

gp_inline__location="../dragon.tex:55491";
 PlusOffsetV_by_sum(k) = {
   my(result=0);
   forstep(j=1,k-1,2, result += b^j);
   result;
 }

gp_inline__location="../dragon.tex:55499";
 PlusOffsetV(k) = {
   k>=0 || error("PlusOffsetV() is for k>=0");
   (-1 + 3*I)/5 * (1 - (2*I)^floor(k/2));
 }

gp_inline__location="../dragon.tex:55506";
 PlusOffsetV_by_power_unsimplified(k) = \
   (I+1)*((2*I)^floor(k/2) - 1)/(2*I - 1);

gp_inline__location="../dragon.tex:55511";
 FlipOddBits(n,k) = my(i=1); while(i<k, n = bitxor(n,2^i); i+=2); n;

gp_inline__location="../dragon.tex:55518";
 PlusOffsetV_samples = {[0,0,1+I,1+I,-1+3*I,-1+3*I,-5-I,-5-I,3-9*I,3-9*I]};

gp_inline__location="../dragon.tex:55539";
 A014985(n) = (1 - (-4)^n)/5;

gp_inline__location="../dragon.tex:55544";
 PlusOffsetV_by_Anum(k) = \
   (1+I)*(A014985(floor((k+2)/4)) + I* 2*A014985(floor(k/4)));

gp_inline__location="../dragon.tex:55585";
 FlipEvenBits(n,k) = my(i=0); while(i<k, n = bitxor(n,2^i); i+=2); n;

gp_inline__location="../dragon.tex:55630";
 PlusOffsetH_by_sum(k) = {
   my(ret=0);
   forstep(j=0,k-1,2, ret += b^j);
   ret;
 }

gp_inline__location="../dragon.tex:55638";
 PlusOffsetH(k) = {
   k>= 0 || error("PlusOffsetH() is for k>=0");
   (1 + 2*I)/5*(1 - (2*I)^ceil(k/2));
 }

gp_inline__location="../dragon.tex:55646";
 PlusOffsetH_samples = {[0,1,1,1+2*I,1+2*I,-3+2*I,-3+2*I,-3-6*I,-3-6*I]};

gp_inline__location="../dragon.tex:55789";
 PlusOffsetJ_by_sum(k) = {
   my(total=0);
   forstep(j=k-2,0,-2, total += b^j);
   total;
 }

gp_inline__location="../dragon.tex:55799";
 PlusOffsetJ_vector = {[1/5+2/5*I,-1/5+3/5*I]};
 PlusOffsetJ(k) = \
   ((-1/5 - 2/5*I)*b^k + vector_modulo(PlusOffsetJ_vector,k));

gp_inline__location="../dragon.tex:55813";
 PlusOffsetJ_by_min(k) = {
   my(h=PlusOffsetH(k), v=PlusOffsetV(k));
   if(norm(h)<norm(v), h, v);
 }

gp_inline__location="../dragon.tex:55826";
 PlusOffsetJ_by_HV(k) = \
   if(k%2==0, PlusOffsetH(k), PlusOffsetV(k));

gp_inline__location="../dragon.tex:55833";
 PlusOffsetJ_samples = {[0,0,1,1+I,1+2*I,-1+3*I,-3+2*I,-5-I,-3-6*I]};

gp_inline__location="../dragon.tex:55868";
 PlusOffsetVH(k) = if(k%2==0, PlusOffsetV(k), PlusOffsetH(k));
 PlusOffsetVH_by_max(k) = {
   my(h=PlusOffsetH(k), v=PlusOffsetV(k));
   if(norm(h)>norm(v), h, v);
 }

gp_inline__location="../dragon.tex:55884";
 gPlusOffsetJ_real(x) = x^2/(1 - x + 2*x^3);

gp_inline__location="../dragon.tex:55888";
 gPlusOffsetJ_imag(x) = x^3/((1-x)*(1-x+2*x^3));

gp_inline__location="../dragon.tex:55897";
 \\ Return a vector of digits which is n in base -4
 \\ using digits 0 to 3.
 digits_baseneg4(n) = {
   my(l=List([]));
   while(n,
     is_integer(n) || error();
     my(d=n%4); listput(l,d); n=(n-d)/(-4));
   Vecrev(l);
 }

gp_inline__location="../dragon.tex:55934";
 MinusXtoN_bits = {[0000,0001,1100,1101]};

gp_inline__location="../dragon.tex:55940";
 MinusXtoN(x) = {
   my(v=digits_baseneg4(x));
   v=apply(d->from_binary(MinusXtoN_bits[d+1]), v);
   fromdigits(v,16);
 }

gp_inline__location="../dragon.tex:55956";
 MinusXtoN_samples = {[0,1,12,13,464,465,476,477,448,449]};

gp_inline__location="../dragon.tex:55969";
 \\ my line of code in A066321
 A066321(n) = my(ret=0,p=0); while(n, ret+=[0,1,12,13][n%4+1]<<p; p+=4; n\=-4); ret;  /* works for negative n too */

gp_inline__location="../dragon.tex:55985";
 MinusXtoN_negative_samples = {[29,28,17,16,205,204,193,192,221,220]};

gp_inline__location="../dragon.tex:56018";
 CountOneBits_MinusXtoN_samples = {[0,1,2,3,4,5,6,7,3,4]};

gp_inline__location="../dragon.tex:56033";
 \\ my line of code in A066323
 A066323(n) = my(ret=0); while(n, ret+=n%4; n\=-4); ret;

gp_inline__location="../dragon.tex:56047";
 CountOneBits_MinusXtoN_negative_samples = {[4,3,2,1,5,4,3,2,6]};

gp_inline__location="../dragon.tex:56081";
 baseneg4_low_03s(n) = {
   my(ret=0);
   while(n,
     if(n%4!=3, return(ret));
     n\=-4; ret++;
     if(n%4!=0, return(ret));
     n\=-4; ret++);
   ret;
 }

gp_inline__location="../dragon.tex:56120";
 \\ All digits are integers.  The even position ones (least
 \\ significant is even) have factor I in Penney's form.
 Penney_imag_digits(n) = {
   my(l=List([]), b=8);
   while(n,
     my(d=n%8); if(d>1, d-=8); listput(l,d); n=(n-d)/8;
     if(n==0,break);
     my(d=n%8); if(d>3, d-=8); listput(l,d); n=(n-d)/-8);
   Vecrev(l);
 }

gp_inline__location="../dragon.tex:56142";
 Penney_imag_bits = {[from_binary(110100),    \\ -6i
                      from_binary(110111),
                      from_binary(110000),
                      from_binary(110011),
                      from_binary(   100),
                      from_binary(   111),
                      from_binary(     0),    \\ 0
                      from_binary(    11),
                      'none, 'none
                     ;
                      'none, 'none,
                      from_binary(10000),    \\ -4
                      from_binary(10001),
                      from_binary(11100),
                      from_binary(11101),
                      from_binary(    0),    \\ 0
                      from_binary(    1),
                      from_binary( 1100),
                      from_binary( 1101)]};
 MinusYtoN(y) = {
   my(v=Penney_imag_digits(y));
   for(i=0,#v-1,
     v[#v-i] = Penney_imag_bits[i%2+1, v[#v-i]+7]);
   fromdigits_any(v,64);
 }


gp_inline__location="../dragon.tex:56185";
 vector_is_strictly_monotonic(v) = \
   for(i=2,#v, v[i]>v[i-1] || return(0)); 1;

gp_inline__location="../dragon.tex:56582";
 AS_state_table = {[2,5;   \\ h1
                    3,6;   \\ h2
                    4,6;   \\ h3
                    1,1;   \\ h4
                    6,3;   \\ h5
                    6,6]}; \\ non
 AS_transition(state,bit) = AS_state_table[state,bit+1];
 AS_transitions(state,v) = \
   for(i=1,#v, state=AS_transition(state,v[i])); state;

gp_inline__location="../dragon.tex:56599";
 AS_X_pred(n) = {
   my(v=binary(n));
   while(#v%4, v=concat(0,v));
   AS_transitions(1,v) != 6;
 }

gp_inline__location="../dragon.tex:56611";
 plus_to_dragon(z) = z*(I-1) + 1/2+1/2*I;

gp_inline__location="../dragon.tex:56626";
 dragon_to_plus(z) = (z-1/2-1/2*I)/(I-1);

gp_inline__location="../dragon.tex:56650";
 AlignedRect_by_multiply(k) = {
   my(z = w8_times_sqrt2^k*(PlusOffsetJ(k+1)-PlusOffsetJ(k)));
   abs(real(z)*imag(z)) / 2^k;
 }

gp_inline__location="../dragon.tex:56660";
 AlignedRect_half = {[-4,7,-3,-1,4,-7,3,1]};

gp_inline__location="../dragon.tex:56666";
 AlignedRect_const = {[4,3,-4,-3]};
 AlignedRect(k) = {
   2/25 * 2^k
   + 1/25 * vector_modulo(AlignedRect_half,k)*2^floor(k/2)
   + 1/50 * vector_modulo(AlignedRect_const,k);
 }

gp_inline__location="../dragon.tex:56677";
 AlignedRect_samples = {[0,1/2,0,1/2,2,3/2,6,(21)/(2),18,(91)/(2),78,(325)/(2)]};

gp_inline__location="../dragon.tex:56705";
 OppositeRect_by_multiply(k) = {
   my(z = w8_times_sqrt2^(k+1)*(PlusOffsetJ(k+1)-PlusOffsetJ(k)));
   abs(real(z)*imag(z)) / 2^(k+1);
 }

gp_inline__location="../dragon.tex:56715";
 OppositeRect_half = {[-3,-1,4,-7,3,1,-4,7]};

gp_inline__location="../dragon.tex:56721";
 OppositeRect_const = {[3,-4,-3,4]};
 OppositeRect(k) = {
   3/50 * 2^k
   + 1/25 * vector_modulo(OppositeRect_half,k)*2^floor(k/2)
   + 1/50 * vector_modulo(OppositeRect_const,k);
 }

gp_inline__location="../dragon.tex:56732";
 OppositeRect_samples = {[0,0,1/2,0,3/2,2,5/2,10,(27)/(2),30,(133)/(2),114]};

gp_inline__location="../dragon.tex:56758";
 AlignedRect_limit = 2/25;

gp_inline__location="../dragon.tex:56768";
 OppositeRect_limit = 3/50;

gp_inline__location="../dragon.tex:56895";
 MinusJump(k) = -1/5 * ( (3+4*I)*(I-1)^(k+1) + (2 + I));

gp_inline__location="../dragon.tex:56899";
 MinusJump_samples = {[1,-2+I,-3*I,2+3*I,-6-I]};

gp_inline__location="../dragon.tex:56920";
 gA137426(x) = (2*x^2-x)/(2*x^3-x-1);  \\ per Harvey P. Dale
 A137426(n) = gf_term(gA137426(x),n);

gp_inline__location="../dragon.tex:56951";
 MinusJump_norm_vector = {[-6,2,2,-4,6,-2,-2,4]};

gp_inline__location="../dragon.tex:56957";
 MinusJump_norm(k) = {
   2^(k+1)
   + 1/5*vector_modulo(MinusJump_norm_vector,k) * 2^ceil(k/2)
   + 1/5;
 }

gp_inline__location="../dragon.tex:56965";
 MinusJump_norm_complete_the_square(k) = {
   2*(sqrt2^k
      + vector_modulo([-3/10,  1/10*sqrt2,  1/10, -2/10*sqrt2,
                        3/10, -1/10*sqrt2, -1/10,  2/10*sqrt2],k)
     )^2
   + vector_modulo([1/50, 4/25, 9/50, 1/25],k);
 }

gp_inline__location="../dragon.tex:56976";
 MinusJump_norm_samples = {[1,5,9,13,37,61,125,269,493,1037]};

gp_inline__location="../dragon.tex:57009";
 MinusDist_inexact(k) = sum(j=0,k-1, 2^j * abs(MinusJump(k-1-j)));

gp_inline__location="../dragon.tex:57011";
 MinusDist_as_quads(k) = {
   my(v=vector(k,j,j--;  \\ j=0 to k-1 inclusive
               2^j * geom_sqrt_as_quad(MinusJump_norm(k-1-j))));
   v = Vecrev(v);
   if(#v>=3, v[1] += v[3]; v=v[^3]);
   v;
 }

gp_inline__location="../dragon.tex:57044";
 MinusMean_inexact(k) = MinusDist_inexact(k) / (2^k - 1);

gp_inline__location="../dragon.tex:57054";
 MinusMean_by_b(k) = \
   2^k/(2^k-1) * sum(j=1,k, abs( 1/(I-1)^j + (2/5+1/5*I)/2^j ));

gp_inline__location="../dragon.tex:57067";
 MinusMean_vector = {[4,-6,2,2,-4,6,-2,-2]};

gp_inline__location="../dragon.tex:57076";
 MinusMean_sum_root_part(j) = {
   1 + 1/5*vector_modulo(MinusMean_vector,j) / 2^ceil(j/2)
     + 1/5 / 2^j;
 }
 MinusMean_inexact_by_sum(k) = {
   2^k / (2^k - 1)
   * sum(j=1,k, 1/sqrt(2)^j * sqrt(MinusMean_sum_root_part(j)));
 }

gp_inline__location="../dragon.tex:57087";
 MinusMean_limit = MinusMean_inexact(1000);

gp_inline__location="../dragon.tex:57092";
 MinusMean_limit_sample = {(2273168/1000000)};

gp_inline__location="../dragon.tex:57131";
 MinusJumpManhattan_vector = {[-3,1,-1,-3,3,-1,1,3]};
 MinusJumpManhattan(k) = {
   1/5*vector_modulo([8,7],k) * 2^ceil(k/2)
   + 1/5 * vector_modulo(MinusJumpManhattan_vector,k);
 }

gp_inline__location="../dragon.tex:57144";
 MinusJumpManhattan_samples = {[1,3,3,5,7,11,13,23,25,45]};

gp_inline__location="../dragon.tex:57156";
 MinusDistManhattan_by_sum(k) = \
   sum(j=0,k-1, 2^j*Manhattan(MinusJump(k-1-j)));

gp_inline__location="../dragon.tex:57160";
 MinusMeanManhattan_limit = {(46)/(17)};

gp_inline__location="../dragon.tex:57167";
 MinusDistManhattan_vector = {[25,-1,15,13,-25,1,-15,-13]};
 MinusDistManhattan(k) = {
   MinusMeanManhattan_limit * 2^k
   - 1/5 * vector_modulo([15, 22],k) * 2^floor(k/2)
   + 1/85 * vector_modulo(MinusDistManhattan_vector,k);
 }

gp_inline__location="../dragon.tex:57186";
 MinusDistManhattan_samples = {[0,1,5,13,31,69,149,311,645,1315]};

gp_inline__location="../dragon.tex:57206";
 MinusMeanManhattan_limit_sample = {(2705882/1000000)};

gp_inline__location="../dragon.tex:57226";
 MinusDistNorms_by_n(k) = {
   sum(n=1,2^k-1, norm(MinusPoint(n)
                     - MinusPoint(n-1)));
 }
 MinusDistNorms(k) = {
   (k-1/5) * 2^k - 1/5
   + 2/5 * vector_modulo([1,-1,0,1, -1,1,0,-1],k)*2^floor(k/2);
 }

gp_inline__location="../dragon.tex:57347";
 Gilbert_a(k) = if(k==0,1, Gilbert_a(k-1) + 2*Gilbert_c(k-1));
 Gilbert_b(k) = if(k==0,1, Gilbert_a(k-1));
 Gilbert_c(k) = if(k==0,0, Gilbert_b(k-1));
 Gilbert_a = memoize(Gilbert_a);
 Gilbert_matrix = [ 1,0,2; 1,0,0; 0,1,0 ];

gp_inline__location="../dragon.tex:57362";
 ComplexBoundary(k) = 2*(Gilbert_a(k) + Gilbert_b(k) + Gilbert_c(k));

gp_inline__location="../dragon.tex:57365";
 ComplexBoundary_samples = [ 4, 6, 10, 18, 30, 50, 86, 146, 246, 418, 710, 1202 ];

gp_inline__location="../dragon.tex:57394";
 Gilbert_a_samples = [ 1, 1, 3, 5, 7, 13, 23, 37, 63, 109, 183, 309 ];

gp_inline__location="../dragon.tex:57835";
 skin_l = 2*geom_sqrt_as_quad(2/5);

gp_inline__location="../dragon.tex:57840";
 skin_l_sample = {(1264911/1000000)};

gp_inline__location="../dragon.tex:57857";
 skin_B_inexact = 2.0*skin_l*(1 + 1/sqrt(2) + 1/2);

gp_inline__location="../dragon.tex:57901";
 twindragon_skin_p1 =  6/5 + 2/5*I;  \\ right side
 twindragon_skin_p2 =  4/5 + 8/5*I;  \\ anti-clockwise
 twindragon_skin_p3 =  1/5 + 7/5*I;
 twindragon_skin_p4 = -1/5 + 3/5*I;
 twindragon_skin_p5 =  1/5 - 3/5*I;
 twindragon_skin_p6 =  4/5 - 2/5*I;

gp_inline__location="../dragon.tex:57908";
 twindragon_skin_l_squared = norm(twindragon_skin_p1 - twindragon_skin_p2);

gp_inline__location="../dragon.tex:58542";
 TS_a_dash(k) = {
   k>=1 || error("TS_a_dash() is for k>=1");
   if(k==1,1, TS_a_dash(k-1) + TS_b_dash(k-1));
 }
 TS_b_dash(k) = {
   k>=1 || error("TS_b_dash() is for k>=1");
   if(k==1,1,                  TS_c_dash(k-1));
 }
 TS_c_dash(k) = {
   k>=1 || error("TS_c_dash() is for k>=1");
   if(k==1,1, 2*TS_a_dash(k-1) );
 }
 TS_a_dash = memoize(TS_a_dash);

gp_inline__location="../dragon.tex:58559";
 TS_dash_matrix = [ 1,1,0; 0,0,1; 2,0,0 ];

gp_inline__location="../dragon.tex:58562";
 TS_a_dash_by_matrix(k) = (TS_dash_matrix^(k-1) * [1;1;1])[1,1];
 TS_b_dash_by_matrix(k) = (TS_dash_matrix^(k-1) * [1;1;1])[2,1];
 TS_c_dash_by_matrix(k) = (TS_dash_matrix^(k-1) * [1;1;1])[3,1];

gp_inline__location="../dragon.tex:58572";
 gTS_a_dash(x) = x*gRQ(x);

gp_inline__location="../dragon.tex:58578";
 gTS_b_dash(x) = x*gLQ(x);

gp_inline__location="../dragon.tex:58584";
 gTS_c_dash(x) = gLQ(x) - 1;

gp_inline__location="../dragon.tex:58591";
 TS_a_b_c_from_zero(k) = TS_dash_matrix^k*[1/2;1/2;1];

gp_inline__location="../dragon.tex:58605";
 TS_by_dash(k) = 2*(TS_a_dash(k) + TS_b_dash(k) + TS_c_dash(k));
 gComplexBoundary(x) = gTS(x);

gp_inline__location="../dragon.tex:58713";
 complex_plus_side_to_dz = \
   /* a   b    c    d   e    f     g    h  */ \
     [I,  1,  1-I, -I, -1, -1+I,  1+I,-1-I];

gp_inline__location="../dragon.tex:58815";
 /* Return true if point n in base i+1 level k */
 /* has a neighbour on the given side=1..6     */
 complex_plus_dz_is_boundary(n,k, dz) = {
   my(n_hi = 2^k-1);
   if(n>n_hi, error("complex_plus_dz_is_boundary() n bigger than k=",k," limit ",n_hi));
   my(z = PlusPoint(n),
      z2 = z + dz,
      n2 = PlusUnpoint(z2));
   n2 < 0 || n2 > n_hi;
 }
 complex_plus_side_is_boundary(n,k,side) = \
   complex_plus_dz_is_boundary(n,k, \
     complex_plus_side_to_dz[side]);

gp_inline__location="../dragon.tex:58829";
                               /* bit 0 1 */
 complex_plus_LtoH_state_table = {[ 1,2;    /* 1 a */
                                    9,3;    /* 2 b */
                                    4,4;    /* 3 c */
                                    5,4;    /* 4 d */
                                    6,9;    /* 5 e */
                                    1,1;    /* 6 f */
                                    2,2;    /* 7 g */
                                    5,5;    /* 8 h */
                                    9,9 ]}; /* non */
 complex_plus_LtoH_transition(state,digit) = \
   complex_plus_LtoH_state_table[state,digit+1];
 complex_plus_LtoH_transitions(state,v) = {
   forstep(i=#v,1,-1,  /* low to high */
           state=complex_plus_LtoH_transition(state,v[i]));
   state;
 }
 complex_plus_side_is_boundary_by_states(n,k,side) = {
   my(v = binary_padded(n,k));
   complex_plus_LtoH_transitions(side,v) != 9;
 }
 gComplexNonBoundary(x) = 1/(1-2*x) - gComplexBoundary(x);

gp_inline__location="../dragon.tex:58978";
 PlusPredBa_from_bits(n,k) = {
   my(v = binary_padded(n,k), pos=#v);
   while(1,
     while(pos>=1 && v[pos]==0, pos--);  \\ run 0s
     pos--;                    \\ skip end run bit
     if(pos<1, return(1));
     if(v[pos]==0, return(0)); \\ bit after run must be 0
     pos -= 2;                 \\ skip bit after and x

gp_inline__location="../dragon.tex:58987";
     while(pos>=1 && v[pos]==1, pos--);  \\ run 1s
     pos--;                    \\ skip end run bit
     if(pos<1, return(1));
     if(v[pos]==1, return(0)); \\ bit after run must be 1
     pos -= 2;                 \\ skip bit after and x
   );
 }

gp_inline__location="../dragon.tex:59029";
 complex_plus_a_count_by_binomial(k) = \
   sum(h=0,2, \
     sum(t=0,k, \
       if(k-h-2*t>=t, 2^t*binomial(k-h-2*t,t))));
 complex_plus_a_count_by_points(k) = \
   sum(n=0,2^k-1, complex_plus_side_is_boundary(n,k, 1));

gp_inline__location="../dragon.tex:59047";
 complex_plus_a_count(k) = RQ(k);

gp_inline__location="../dragon.tex:59068";
 complex_plus_four_state_table = {[
       1, 2;   /* 1 a */
       7, 3;   /* 2 b */
       4, 4;   /* 3 c */
       5, 4;   /* 4 d */
       6, 7;   /* 5 e */
       1, 1;   /* 6 f */
       7, 7;   /* 7 non */
     1+8, 2+8;  /* 8 start */
     4+8, 5+8;  /* f1 */
     8+8, 7+8;  /* f2 */
     4+8,   1;  /* f3 */
     1,   5+8;  /* f4 */
     1,   6+8;  /* f5 */
     4,   7+8;  /* f6 */
     8+8,   4;  /* f7 */
     3+8,   4   /* f8 */
 ]};

gp_inline__location="../dragon.tex:59087";
 complex_plus_four_transition(state,bit) = \
   complex_plus_four_state_table[state,bit+1];
 complex_plus_four_is_enclosed_by_states(n,k) = {
   my(v = binary_padded(n,k),
      state = 0+8);  /* start */
   forstep(i=#v,1,-1,  /* low to high */
     state = complex_plus_four_transition(state,v[i]));
   state == 7;
 }

gp_inline__location="../dragon.tex:59097";
 complex_plus_four_is_enclosed(n,k) = {
      ! complex_plus_side_is_boundary(n,k, 1)  /* a */
   && ! complex_plus_side_is_boundary(n,k, 2)  /* b */
   && ! complex_plus_side_is_boundary(n,k, 4)  /* d */
   && ! complex_plus_side_is_boundary(n,k, 5); /* e */
 }

gp_inline__location="../dragon.tex:59108";
 {
   complex_plus_four_m = matrix(8+8,8+8);
   for(state=1,8+8,
     for(bit=0,1,
       complex_plus_four_m[complex_plus_four_transition(state,bit),
                           state]++));
 }
 complex_plus_four_m_start = vectorv(8+8,state, state==0+8);
 FourA_by_m(k) = \
   (complex_plus_four_m^k * complex_plus_four_m_start)[7];

gp_inline__location="../dragon.tex:59308";
 FourB_by_sum_formula(k) = \
   4*(1 + sum(l=3,k, complex_plus_a_count_by_binomial(k-l)));
 FourB_by_sum(k) = if(k<3,2^k, FourB_by_sum_formula(k));

gp_inline__location="../dragon.tex:59318";
 FourB(k) = R(k);

gp_inline__location="../dragon.tex:59332";
 FourA(k) = 2^k - FourB(k);
 gFourA(k) = 4*gAR(x);

gp_inline__location="../dragon.tex:59352";
 n_flip_all_bits(n,k) = 2^k-1 - n;

gp_inline__location="../dragon.tex:59358";
 complex_plus_four_Gray_state_table = {[
 \\ 0 1 bit
    3,2;    \\ 1 g0 start  in 1-based indexes
    4,6;    \\ 2 g1
    6,2;    \\ 3 g2
    3,5;    \\ 4 g3
    7,6;    \\ 5 g4
    6,7;    \\ 6 g5
    8,9;    \\ 7 g6
    6,5;    \\ 8 g7
    10,10;  \\ 9 g8
    10,10   \\ 10 g9 = non
 ]};
 complex_plus_four_Gray_transition(state,bit) = \
   complex_plus_four_Gray_state_table[state+1,bit+1] - 1;
 complex_plus_four_Gray_n_to_state(n,k) = {
   my(v = binary_padded(Gray(n),k), state=0);
   forstep(i=#v,1,-1,  \\ low to high
     state = complex_plus_four_Gray_transition(state,v[i]));
   state;
 }
 complex_plus_four_is_enclosed_by_Gray(n,k) = \
   complex_plus_four_Gray_n_to_state(n,k) == 9;

gp_inline__location="../dragon.tex:59384";
 {
   complex_plus_four_Gray_m = matrix(10,10);
   for(state=0,9,
       for(bit=0,1,
           complex_plus_four_Gray_m[complex_plus_four_Gray_transition(state,bit)+1, state+1]++));
 }
 complex_plus_four_Gray_m_start = vectorv(10,state, state==1);
 FourA_by_Gray_m(k) = {
   ( complex_plus_four_Gray_m^k
     * complex_plus_four_Gray_m_start )[10];
 }

gp_inline__location="../dragon.tex:59398";
 {
   complex_minus_four_Gray_state_table
     = complex_plus_four_Gray_state_table;
   for(i=1,9,
       complex_minus_four_Gray_state_table[i,1]
      = complex_plus_four_Gray_state_table[i,2];
       complex_minus_four_Gray_state_table[i,2]
      = complex_plus_four_Gray_state_table[i,1]);
 }
 complex_minus_four_Gray_transition(state,bit) = \
   complex_minus_four_Gray_state_table[state+1,bit+1] - 1;
 complex_minus_four_Gray_n_to_state(n,k) = {
   my(v = binary_padded(Gray(n),k), state=0);
   forstep(i=#v,1,-1, /* low to high */
     state = complex_minus_four_Gray_transition(state,v[i]));
   state;
 }
 complex_minus_four_is_enclosed_by_Gray(n,k) = complex_minus_four_Gray_n_to_state(n,k)==9;

gp_inline__location="../dragon.tex:59418";
 complex_minus_side_to_dz = \
   /* a   b    c    d  e   f      g   h  */ \
     [I, -1, -1-I, -I, 1, 1+I,  -1+I,1-I];

gp_inline__location="../dragon.tex:59433";
 complex_minus_dz_is_boundary(n,k, dz) = {
   my(n_hi = 2^k-1);
   if(n>n_hi, error("complex_minus_dz_is_boundary() n bigger than k=",k," limit ",n_hi));
   my(z = MinusPoint(n),
      z2 = z + dz,
      n2 = MinusUnpoint(z2));
   n2 < 0 || n2 > n_hi;
 }
 complex_minus_side_is_boundary(n,k,side) = {
   complex_minus_dz_is_boundary(n,k,
     complex_minus_side_to_dz[side]);
 }

gp_inline__location="../dragon.tex:59449";
 complex_minus_four_is_enclosed(n,k) = {
      ! complex_minus_side_is_boundary(n,k, 1)  /* a */
   && ! complex_minus_side_is_boundary(n,k, 2)  /* b */
   && ! complex_minus_side_is_boundary(n,k, 4)  /* d */
   && ! complex_minus_side_is_boundary(n,k, 5); /* e */
 }

gp_inline__location="../dragon.tex:59592";
 gen_complex_plus_NSEW_vector = [8,10,21,23];
 gen_complex_plus_NSEW_k = 5;

gp_inline__location="../dragon.tex:59643";
 complex_plus_eight_state_table = {[
     1, 2;   /* 1 a */
     7, 3;   /* 2 b */
     4, 4;   /* 3 c */
     5, 4;   /* 4 d */
     6, 7;   /* 5 e */
     1, 1;   /* 6 f */
     7, 7;   /* 7 non */
   1+16, 2+16; /* 8 start */
   4+8, 5+8;   /* 8+1  f1 */
   8+8, 7+8;   /* 8+2  f2 */
   4+8,   1;   /* 8+3  f3 */
   1,   5+8;   /* 8+4  f4 */
   1,   6+8;   /* 8+5  f5 */
   4,   7+8;   /* 8+6  f6 */
   8+8,   4;   /* 8+7  f7 */
   3+8,   4;   /* 8+8  f8 */
   1+8, 3+16;  /* 16+1  t1 */
   4+16, 2+8;  /* 16+2  t2 */
   1+8,  6+16; /* 16+3  t3 */
   5+16, 2+8;  /* 16+4  t4 */
   1+8,  8+16; /* 16+5  t5 */
   7+16, 2+8;  /* 16+6  t6 */
   4+8,   2;   /* 16+7  t7 */
     5,  7+8   /* 16+8  t8 */
  ]};

gp_inline__location="../dragon.tex:59670";
 complex_plus_eight_transition(state,bit) = \
   complex_plus_eight_state_table[state,bit+1];
 complex_plus_eight_transitions(state,v) = {
   forstep(i=#v,1,-1,  /* low to high */
     state = complex_plus_eight_transition(state,v[i]));
   state;
 }
 complex_plus_eight_is_enclosed_by_states(n,k) = {
   my(v = binary_padded(n,k));
   complex_plus_eight_transitions(0+8,v) == 7;
 }

gp_inline__location="../dragon.tex:59682";
 complex_plus_eight_is_enclosed(n,k) = {
      ! complex_plus_side_is_boundary(n,k, 1)  /* a */
   && ! complex_plus_side_is_boundary(n,k, 2)  /* b */
   && ! complex_plus_side_is_boundary(n,k, 3)  /* c */
   && ! complex_plus_side_is_boundary(n,k, 4)  /* d */
   && ! complex_plus_side_is_boundary(n,k, 5)  /* e */
   && ! complex_plus_side_is_boundary(n,k, 6)  /* f */
   && ! complex_plus_side_is_boundary(n,k, 7)  /* g */
   && ! complex_plus_side_is_boundary(n,k, 8); /* h */
 }
 EightA_by_count(k) = \
   sum(n=0,2^k-1, complex_plus_eight_is_enclosed(n,k));
 EightB_by_count(k) = \
   sum(n=0,2^k-1, ! complex_plus_eight_is_enclosed(n,k));

gp_inline__location="../dragon.tex:59698";
 {
   complex_plus_eight_m = matrix(24,24);
   for(state=1,24,
       for(bit=0,1,
           complex_plus_eight_m[complex_plus_eight_transition(state,bit), state]++));
 }
 complex_plus_eight_m_start = vectorv(24,state, state==0+8);
 EightA_by_m(k) = \
   (complex_plus_eight_m^k * complex_plus_eight_m_start)[7];

gp_inline__location="../dragon.tex:59895";
 complex_plus_four_by_eight_states(n,k) = {
   my(v = binary_padded(n,k));
   if(#v==0,return(0));
   my(state = if(v[#v]==0,1+8,2+8)); /* f1,f2 */
   v = v[^-1]; \\ sans low bit
   complex_plus_eight_transitions(state,v) == 7;
 }

gp_inline__location="../dragon.tex:59910";
 EightB_by_FourB_extra(k) = FourB(k) + 1/2*R(k-1) - 4;

gp_inline__location="../dragon.tex:59937";
 EightB_formula(k) = R(k) + 1/2*R(k-1) - 4;
 EightB(k) = if(k<4,2^k, EightB_formula(k));

gp_inline__location="../dragon.tex:59948";
 EightB_initial = vector(8,k,k--; EightB(k));
 EightB_by_recurrence(k) = \
   recurrence_eval(R_recurrence_coeffs,EightB_initial,k);

gp_inline__location="../dragon.tex:59955";
 EightB_samples = {[1,2,4,8,16,32,58,104,182,312,534]};

gp_inline__location="../dragon.tex:59969";
 gEightB(k) = \
      + 11/2 + 4*x + 3*x^2 + 2*x^3 \
      - 7 * 1/(1 - x) \
      + 1/2 * (5 + 5*x + 6*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:59982";
 EightA(k) = 2^k - EightB(k);

gp_inline__location="../dragon.tex:59990";
 EightA_by_recurrence = A_recurrence_maker(EightA);

gp_inline__location="../dragon.tex:60002";
 EightA_samples = {[0,0,0,0,0,0,6,24,74,200,490]};

gp_inline__location="../dragon.tex:60014";
 gEightA(k) = x^6 * (6+8*x^2) \
            / ( (1-x) * (1-2*x) * (1-x-2*x^3) );

gp_inline__location="../dragon.tex:60029";
 gEightA_partial_fractions(k) = \
            1/(1 - 2*x) \
      + 7 * 1/(1 - x) \
      - 1/2 * (5 + 5*x + 6*x^2)/(1 - x - 2*x^3) \
      - 11/2 - 4*x - 3*x^2 - 2*x^3;

gp_inline__location="../dragon.tex:60102";
 gen_complex_plus_eight_vector = [16,20,21,42,43,47];
 gen_complex_plus_eight_k = 6;

gp_inline__location="../dragon.tex:60194";
 complex_plus_six_is_enclosed(n,k) = {
      ! complex_plus_side_is_boundary(n,k, 1)  /* a */
   && ! complex_plus_side_is_boundary(n,k, 2)  /* b */
   && ! complex_plus_side_is_boundary(n,k, 3)  /* c */
   && ! complex_plus_side_is_boundary(n,k, 4)  /* d */
   && ! complex_plus_side_is_boundary(n,k, 5)  /* e */
   && ! complex_plus_side_is_boundary(n,k, 6); /* f */
 }
 SixA_by_count(k) = \
   sum(n=0,2^k-1, complex_plus_six_is_enclosed(n,k));

gp_inline__location="../dragon.tex:60205";
 complex_plus_six_by_eight_states(n,k) = {
   my(v = binary_padded(n,k));
   if(#v==0,return(0));
   my(state = if(v[#v]==0,3+16,4+16)); /* t3,t4 */
   v = v[^-1]; \\ sans low bit
   complex_plus_eight_transitions(state,v) == 7;
 }

gp_inline__location="../dragon.tex:60232";
 SixB_formula(k) = 1/2*R(k) + 2*R(k-2);
 SixB(k) = {
   k>=0 || error("SixB() is for k>=0");
   if(k<2,2^k, SixB_formula(k));
 }

gp_inline__location="../dragon.tex:60242";
 SixB_initial = vector(7,k,k--; SixB(k));
 SixB_by_recurrence(k) = \
   recurrence_eval(R_recurrence_coeffs,SixB_initial,k);

gp_inline__location="../dragon.tex:60250";
 SixB_samples = {[1,2,4,8,16,30,56,98,168,290,496,842]};

gp_inline__location="../dragon.tex:60265";
 gSixB(x) = {
   3 + 3*x + 2*x^2
   - 5 * 1/(1 - x)
   + (3 + x + 3*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:60280";
 SixA(k) = 2^k - SixB(k);

gp_inline__location="../dragon.tex:60284";
 SixA_by_recurrence = A_recurrence_maker(SixA);

gp_inline__location="../dragon.tex:60292";
 SixA_samples = {[0,0,0,0,0,2,8,30,88,222,528,1206]};

gp_inline__location="../dragon.tex:60304";
 gSixA(k) = x^5 * (2+8*x^2) \
            / ( (1-x) * (1-2*x) * (1-x-2*x^3) );

gp_inline__location="../dragon.tex:60320";
 complex_minus_six_is_enclosed(n,k) = {
      ! complex_minus_side_is_boundary(n,k, 1)  /* a */
   && ! complex_minus_side_is_boundary(n,k, 2)  /* b */
   && ! complex_minus_side_is_boundary(n,k, 3)  /* c */
   && ! complex_minus_side_is_boundary(n,k, 4)  /* d */
   && ! complex_minus_side_is_boundary(n,k, 5)  /* e */
   && ! complex_minus_side_is_boundary(n,k, 6); /* f */
 }

gp_inline__location="../dragon.tex:60343";
 SixB_over_FourB_limit = 1/2 + 2/r^2;
 SixB_over_FourB_limit_nfelt = 1/2*one_nfelt + 2*one_over_r_squared_nfelt;
 SixB_over_FourB_limit_polmod = 1/2 + 2/r_polmod^2;

gp_inline__location="../dragon.tex:60357";
 SixB_over_FourB_limit_sample = {(1195620/1000000)};

gp_inline__location="../dragon.tex:60370";
 EightB_over_FourB_limit = 1 + 1/(2*r);
 EightB_over_FourB_limit_nfelt = one_nfelt + 1/2*one_over_r_nfelt;

gp_inline__location="../dragon.tex:60376";
 EightB_over_FourB_limit_sample = {(1294877/1000000)};

gp_inline__location="../dragon.tex:60385";
 EightB_over_SixB_limit = EightB_over_FourB_limit / SixB_over_FourB_limit;

gp_inline__location="../dragon.tex:60390";
 EightB_over_SixB_limit_nfelt = nfeltdiv(cubic_nf, EightB_over_FourB_limit_nfelt, \
                                                   SixB_over_FourB_limit_nfelt);

gp_inline__location="../dragon.tex:60406";
 EightB_over_SixB_limit_sample = {(1083016/1000000)};

gp_inline__location="../dragon.tex:60435";
 MinusInc_state_table = {[ 7, 2;  \\ 1 = 1    flip
                           3, 3;  \\ 2 = -1-I
                           1, 4;  \\ 3 =  I   flip
                           3, 5;  \\ 4 = -I   flip
                           6, 7;  \\ 5 = -1   flip
                           4, 4;  \\ 6 = 1+I
                           7, 7;  \\ 7 =  0
                           1, 1;  \\ 8 = -1+I
                           5, 5   \\ 9 =  1-I
                        ]};
 MinusInc_dz_table = [ 1, -1-I, I, -I, -1, 1+I, 0, -1+I, 1-I ];
 MinusInc_flip_table = apply(z_mod_b,MinusInc_dz_table);

gp_inline__location="../dragon.tex:60449";
 MinusInc_transition(state,bit) = \
   MinusInc_state_table[state,bit+1];
 MinusInc_by_states(n,dz) = {
   n>=0||error("MinusInc_by_states() is for n>=0");
   my(state=select(elem->elem==dz,MinusInc_dz_table,1));
   #state==1||error("MinusInc_by_states() unknown dz=",dz);
   state=state[1];
   my(l=List([]));
   while(n||state!=7,    \\ print("at n="n" state="state" l="l);
     my(bit=bitand(n,1)); n>>=1;   \\ low to high
     listput(l,bitxor(bit,MinusInc_flip_table[state]));
     state=MinusInc_transition(state,bit));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:60591";
 MinusInc(n,dz) = MinusUnpoint(MinusPoint(n) + dz);

gp_inline__location="../dragon.tex:60691";
 Minus_dz_transition(dz,bit,mul) = {
   my(out=z_mod_b(mul*bit+dz));
   (dz+mul*bit-out)/(I-1);
 }

gp_inline__location="../dragon.tex:60715";
 MinusPredBa_from_PlusPredBa(n,k) = \
   PlusPredBa_from_bits(FlipEvenBits(n,k),k);

gp_inline__location="../dragon.tex:60862";
 MinusInc_distance_to_zero = {
   vector(#MinusInc_dz_table,state,
          my(n=0);
         while(MinusInc_dz_table[state]!=0,
            state=MinusInc_transition(state,0); n++);
          n);
 }

gp_inline__location="../dragon.tex:61025";
 MinusNeg_state_table = {[ 1, 2;  \\  1 = 0
                           3, 5;  \\  2 = 1+I
                           4, 4;  \\  3 = -I  flip
                           5, 5;  \\  4 =  I  flip
                           1, 1;  \\  5 =  1  flip
                           2, 2;  \\  6 = -1  flip
                           5, 10; \\  7 = -1+I
                           4, 11; \\  8 = -1-I
                           6, 4;  \\  9 =  1-I
                           3, 3;  \\ 10 =  2+I
                           9, 9   \\ 11 = 1+2*I
                        ]};
 MinusNeg_dz_table = {[ 0, 1+I, -I, I, 1, -1,
                       -1+I, -1-I, 1-I, 2+I, 1+2*I ]};

gp_inline__location="../dragon.tex:61041";
 MinusNeg_flip_table = apply(z_mod_b,MinusNeg_dz_table);
 MinusNeg_transition(state,bit) = \
   MinusNeg_state_table[state,bit+1];
 MinusNeg_transitions(state,v) = \
   for(i=1,#v, state=MinusNeg_transition(state,v[i])); state;
 MinusNeg_by_states(n,state=1) = {
   n>=0||error("MinusNeg_by_states() is for n>=0");
   my(l=List([]));
   while(n||state!=1,    \\ print("at n="n" state="state" l="l);
     my(bit=bitand(n,1)); n>>=1;   \\ low to high
     listput(l,bitxor(bit,MinusNeg_flip_table[state]));
     state=MinusNeg_transition(state,bit));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:61175";
 MinusNeg_by_dz(n) = {
   my(dz=0,l=List([]));
   while(n||dz,
      my(bit=bitand(n,1)); n>>=1;   \\ low to high
      my(out=z_mod_b(bit+dz));
      dz=Minus_dz_transition(dz,bit, -1);
      listput(l,out));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:61200";
 MinusNeg(n) = {
   my(v=concat([0,0,0,0],binary(n)),i=#v);
   while(i>0,
         if(v[i]==0,   i--,
            v[i-1]==1, v[i-2]=1-v[i-2]; i-=3,   \\ F 1 1
            v[i-2]=1-v[i-2];
            v[i-3]=1-v[i-3];
            v[i-4]=1-v[i-4]; i-=5));           \\ F F F 0 1
   fromdigits(v,2);
 }

gp_inline__location="../dragon.tex:61211";
 { MinusNeg_compact(n) = for(i=0,if(n,logint(n,2)),
     if(bittest(n,i),
        if(bittest(n,i+1), n=bitxor(n,4<<i); i+=2,
                           n=bitxor(n,28<<i); i+=4))); n; }

gp_inline__location="../dragon.tex:61233";
 \\ the value which must be XORed onto n to get MinusNeg(n)
 MinusNeg_xor_diff(n) = {
   my(ret=0);
   for(i=0,logint(n+1,2),
     if(bittest(n,i) && bittest(n,i+1),  ret+=4<<i; i+=2,
        bittest(n,i) && !bittest(n,i+1), ret+=28<<i; i+=4));
   ret;
 }

gp_inline__location="../dragon.tex:61246";
 MinusNeg_samples = {[0,29,58,7,116,25,14,3,232,21,50,239]};

gp_inline__location="../dragon.tex:61253";
 A340669(n) = MinusNeg(n);

gp_inline__location="../dragon.tex:61258";
 MinusNeg_binary_samples = {[0,11101,111010,111,1110100,11001,1110]};

gp_inline__location="../dragon.tex:61339";
 \\ return a list of the distinct bitxor(n,neg(n)) occurring in
 \\ base i-1 for 0 <= n,neg(n) < 2^k
 MinusNegXlist(k) = {
   my(m=Map(),limit=2^k-1);
   for(n=0,limit,
       my(neg=MinusNeg(n));
       if(neg<=limit,mapput(m,bitxor(n,neg),1)));
   Set(Mat(m)[,1]);
 }

gp_inline__location="../dragon.tex:61370";
 \\ runs of 1s are 11100 or 100
 MinusNegXpred(n) = {
   my(v=binary(n),i=1);
   while(1,
      if(i<=#v && v[i]==0,     i++,
         i+4<=#v && v[i]  ==1
                 && v[i+1]==1
                 && v[i+2]==1
                 && v[i+3]==0
                 && v[i+4]==0, i+=5,
         i+2<=#v && v[i]  ==1
                 && v[i+1]==0
                 && v[i+2]==0, i+=3,
         return(i==#v+1)));
 }

gp_inline__location="../dragon.tex:61392";
 MinusNegXpred_samples = {[1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,1]};

gp_inline__location="../dragon.tex:61400";
 MinusNegXpred_at_samples = {[0,4,8,16,28,32,36,56,64,68,72,112]};

gp_inline__location="../dragon.tex:61411";
 MinusNegXpred_at_binary_samples = {[0,100,1000,10000,11100,100000,100100]};

gp_inline__location="../dragon.tex:61433";
 poly_biggest_root(p) = {
   my(v=polroots(p),pos);
   vecmax(abs(v),&pos);
   v[pos];
 }

gp_inline__location="../dragon.tex:61439";
 MinusNegXdistinct(k) = {
   ([0, 1, 0, 0, 0;
     0, 0, 1, 0, 0;
     0, 0, 0, 1, 0;
     0, 0, 0, 0, 1;
     1, 0, 1, 0, 1] ^k) [5,5];
 }

gp_inline__location="../dragon.tex:61456";
 MinusNegXdistinct_r_sample = 1570147 / 10^6;

gp_inline__location="../dragon.tex:61473";
 MinusNegXdistinct_polynomial = x^5 - x^4 - x^2 - 1;
 MinusNegXdistinct_r = \
   real(poly_biggest_root(MinusNegXdistinct_polynomial));

gp_inline__location="../dragon.tex:61503";
 MinusNegXdistinct_by_pred(k) = sum(c=0,2^k-1, MinusNegXpred(c));

gp_inline__location="../dragon.tex:61519";
 MinusNegXdistinct_by_recurrence(k) = {
   if(k<5,#MinusNegXlist(k),
          MinusNegXdistinct(k-1)
        + MinusNegXdistinct(k-3)
        + MinusNegXdistinct(k-5));
 }

gp_inline__location="../dragon.tex:61530";
 MinusNegXdistinct_samples = {[1,1,1,2,3,5,8,12,19,30,47,74,116,182]};

gp_inline__location="../dragon.tex:61540";
 my(m=Mod('x,'x^5-'x^4-'x^2-1)); \
 A060961(n) = polcoeff(lift(m^(n+4)),4);

gp_inline__location="../dragon.tex:61556";
 gMinusNegXdistinct(k) = 1/(1 - x - x^3 - x^5);

gp_inline__location="../dragon.tex:61571";
 MinusNegXdistinct_by_power(k) = \
   0.5165813237241528886626736040*MinusNegXdistinct_r^k;
 MinusNegXdistinct_by_round(k) = \
   round(MinusNegXdistinct_by_power(k));

gp_inline__location="../dragon.tex:61594";
 \\ total bits flipped within 0 <= n,neg(n) < 2^k

gp_inline__location="../dragon.tex:61626";
 MinusNegXbits_vector = {[-29,32,-3,-26,29,-32,3,26]};

gp_inline__location="../dragon.tex:61641";
 MinusNegXbits(k) = {
   (2/5*k + 18/25) * 2^k
   + 1/75 * vector_modulo(MinusNegXbits_vector,k) * 2^floor(k/2)
   - 2/3 * imag( (1/2 + 1/2*sqrt7i)^(k+2) );
}

gp_inline__location="../dragon.tex:61659";
 MinusNegXbits_samples = {[0,3,7,15,37,83,201,459,1001,2211,4817]};

gp_inline__location="../dragon.tex:61674";
 gMinusNegXbits(x) = \
  (3*x - 2*x^2)/((1-2*x)^2 * (1 + 2*x + 2*x^2) * (1 - x + 2*x^2) );

gp_inline__location="../dragon.tex:61782";
 MinusNegPred(k,n) = #binary(n) <= k && #binary(MinusNeg(n)) <= k;

gp_inline__location="../dragon.tex:61826";
 MinusNegA_charpoly(x) = x^5 - x^4 - 2*x^2 - 8;

gp_inline__location="../dragon.tex:61833";
 MinusNegA_vector = {[2,-1,-1,3,-2,1,1,-3]};

gp_inline__location="../dragon.tex:61849";
 MinusNegA_formula(k) = {
     2/5  * 2^k
   + 2/15 * vector_modulo(MinusNegA_vector,k) * 2^floor(k/2)
   + 2/3  * imag( (1/2 + 1/2*sqrt7i)^(k+1) );
 }
 MinusNegA(k) = {
   k>=0 || error("MinusNegA() is for k>=0");
   MinusNegA_formula(k);
 }

gp_inline__location="../dragon.tex:61860";
 MinusNegNonA(k) = 2^k - MinusNegA(k);

gp_inline__location="../dragon.tex:61864";
 MinusNegA_samples = {[1,1,1,3,5,15,29,47,101,199,413,847]};

gp_inline__location="../dragon.tex:61880";
 MinusNegA_sqrt2_part(k) = \
   2/15 * vector_modulo(MinusNegA_vector,k) * 2^floor(k/2);

gp_inline__location="../dragon.tex:61885";
 MinusNegA_sqrt7i_part(k) = \
   (1/3 - 1/21*sqrt7i) * (1/2+1/2*sqrt7i)^k;

gp_inline__location="../dragon.tex:61893";
 gA078069(x) = (1-x)/(1+2*x+2*x^2);
 A078069(n) = ([-2,1;-2,0]^n*[1;-1])[1,1];

gp_inline__location="../dragon.tex:61901";
 gA107920(x) = x/(1-x+2*x^2);
 A107920(n) = ([1,1;-2,0]^n)[1,2];

gp_inline__location="../dragon.tex:61913";
 gMinusNegA(x) = 1/(1 - x - 2*x^3 - 8*x^5);

gp_inline__location="../dragon.tex:62018";
 { my(table=[4,-2,-2,6, -4,2,2,-6], p=Mod('x,2-'x+'x^2));
 MinusNegA_compact(n) =
   (6<<n + table[n%8+1]<<(n\2) + 5*vecsum(Vec(lift(p^n))))/15; }

gp_inline__location="../dragon.tex:62033";
 \\ not negatable within k bits
 MinusNegNotA(k) = 2^k - MinusNegA(k);
 gMinusNegNotA(x) = 1/(1-2*x) - gMinusNegA(x);

gp_inline__location="../dragon.tex:62217";
 MinusNegNeighbourPred(k,n,dz) = MinusNegPred(k,MinusInc(n,dz));

gp_inline__location="../dragon.tex:62279";
 z_is_MinusNeg(z,n_limit) = {
      MinusUnpoint(z)  <= n_limit
   && MinusUnpoint(-z) <= n_limit;
 }
 MinusNegB_by_points(k) = {
   my(n_limit=2^k-1);
   sum(n=0,n_limit,
       my(z=MinusPoint(n));
       if(z_is_MinusNeg(z,n_limit),
          sum(d=0,3,
              my(z2=z+I^d);
              ! z_is_MinusNeg(z2,n_limit))));
 }
 MinusNegA_by_points(k) = {
   my(n_limit=2^k-1);
   sum(n=0,n_limit,
       my(z=MinusPoint(n));
       z_is_MinusNeg(z,n_limit));
 }

gp_inline__location="../dragon.tex:62349";
 MinusNegB_by_pred(k) = {
   sum(n=0,2^k-1,
       sum(d=0,3,
           my(dz=I^d);
           MinusNegPred(k,n) && !MinusNegNeighbourPred(k,n,dz)));
 }

gp_inline__location="../dragon.tex:62360";
 MinusNegB_samples = {[4,4,4,8,12,36,56,80,136,228,460,784]};

gp_inline__location="../dragon.tex:62386";
 gMinusNegB_dragon_cubic_part(x) = \
   4/3 * (2 + x + 2*x^2)/(1 - x - 2*x^3);
 gMinusNegB(x) = {
   1/(1 - x + 2*x^2)
   + gMinusNegB_dragon_cubic_part(x)
   - (1 + x)              /(1 - x^2 - 2*x^3)
   + 2/3 * (2 + 2*x + x^2 + 4*x^3) / (1 + x + x^2 + x^3 + 2*x^4);
 }

gp_inline__location="../dragon.tex:62437";
 MinusNegB_cubic_poly(x) = x^3 - x - 2;
 MinusNegB_cubic_r = \
   real(poly_biggest_root(MinusNegB_cubic_poly(x)));

gp_inline__location="../dragon.tex:62451";
 MinusNegB_quartic_poly(x) = x^4 + x^3 + x^2 + x + 2;
 MinusNegB_quartic_r = \
   abs(poly_biggest_root(MinusNegB_quartic_poly(x)));

gp_inline__location="../dragon.tex:62506";
 singletons_Four_by_pred(pred,npred,k,n) = {
   sum(n=0,2^k-1,
       pred(k,n)
       && ! npred(k,n, 1)
       && ! npred(k,n,-1)
       && ! npred(k,n, I)
       && ! npred(k,n,-I));
 }
 singletons_Eight_by_pred(pred,npred,k,n) = {
   sum(n=0,2^k-1,
       pred(k,n)
       && ! npred(k,n, 1)
       && ! npred(k,n,-1)
       && ! npred(k,n, I)
       && ! npred(k,n,-I)
       && ! npred(k,n, 1+I)
       && ! npred(k,n, 1-I)
       && ! npred(k,n,-1+I)
       && ! npred(k,n,-1-I));
 }

gp_inline__location="../dragon.tex:62527";
 \\ no neighbours NSEW, so both completely isolated and those
 \\ which are hanging squares
 gMinusNeg_singletons_Four(x) = {
   -1/4
   + 1/6* 1/(1 - x)
   + 1/8* 1/(1 + x)
   + 1/16* (5 - x)/(1 - x + 2*x^2)
   + 1/16* (7 + 2*x + 5*x^2)/(1 - x^2 - 2*x^3)
   + 1/24*(5 + 19*x + 27*x^2 + 23*x^3)/(1 + x + x^2 + x^3 + 2*x^4);
 }

gp_inline__location="../dragon.tex:62544";
 \\ completely isolated, no neighbours in 8 directions
 gMinusNeg_singletons_Eight(x) = {
   -1/4
   + 1/3* 1/(1 - x)
   + 1/4* 1/(1 + x)
   + 3/16* (1 + x)/(1 - x + 2*x^2)
   + 1/16* (7 + 2*x - 3*x^2)/(1 - x^2 - 2*x^3)
   + 1/24*(1 + 11*x + 15*x^2 + 7*x^3)/(1 + x + x^2 + x^3 + 2*x^4);
 }

gp_inline__location="../dragon.tex:62562";
 two_diagonals_pred(pred,npred,k,n) = {
   pred(k,n)
   && ! npred(k,n, 1)    \\ no NSEW
   && ! npred(k,n,-1)
   && ! npred(k,n, I)
   && ! npred(k,n,-I)
   && ( npred(k,n, 1+I)  \\ 2 or more diagonals
      + npred(k,n, 1-I)
      + npred(k,n,-1+I)
      + npred(k,n,-1-I) ) >= 2;
 }

gp_inline__location="../dragon.tex:62578";
 pieces_Four_by_turns(pred,npred,k,n) = {
   sum(n=0,2^k-1,
       if(pred(k,n),
          sum(d=0,3,
              my(dz=I^d,
              east =npred(k,n,       dz),
              NE   =npred(k,n, (1+I)*dz),
              north=npred(k,n,   I  *dz));
              if(!east && !north,       1,
                 east && north && !NE, -1))))
   / 4;
 }
 pieces_Eight_by_turns(pred,npred,k,n) = {
   sum(n=0,2^k-1,
       if(pred(k,n),
          sum(d=0,3,
              my(dz=I^d,
              east =npred(k,n,       dz),
              NE   =npred(k,n, (1+I)*dz),
              north=npred(k,n,   I  *dz));
              if(!east && !north && !NE, 1,
                 !east && !north && NE, -1,
                 east && north && !NE,  -1))))
   / 4;
 }

gp_inline__location="../dragon.tex:62604";
 \\ pieces connected by NSEW sides only, so hanging squares or
 \\ other diagonal touches are separate pieces
 gMinusNeg_pieces_Four(x) = {
     1/12* 1/(1 - x)
   + 1/4*  1/(1 - x + 2*x^2)
   + 1/2*  (1 + x + x^2)/(1 - x^2 - 2*x^3)
   + 1/6*  (1 + 2*x + 3*x^2 + 4*x^3)/(1 + x + x^2 + x^3 + 2*x^4);
 }

gp_inline__location="../dragon.tex:62619";
 \\ pieces connected by any 8-neighbour, so hanging squares or
 \\ other diagonal touches are included in a given piece
 gMinusNeg_pieces_Eight(x) = {
     1/4*  1/(1 - x)
   + 1/8*  1/(1 + x)
   + 1/8* (1 + 2*x)/(1 - x + 2*x^2)
   + 1/2* (1 + x)/(1 - x^2 - 2*x^3);
 }

gp_inline__location="../dragon.tex:62634";
 gMinusNeg_hanging(x) = \
   gMinusNeg_singletons_Four(x) - gMinusNeg_singletons_Eight(x);

gp_inline__location="../dragon.tex:62668";
 MinusRot(n) = MinusUnpoint(I*MinusPoint(n));

gp_inline__location="../dragon.tex:62670";
 MinusRot_samples = {[0,3,6,29,12,15,58,1,24,27,30,933]};

gp_inline__location="../dragon.tex:62682";
 MinusRot_by_dz(n) = {
   my(dz=0,l=List([]));
   while(n||dz,
      my(bit=bitand(n,1)); n>>=1;   \\ low to high
      my(out=z_mod_b(bit+dz));
      \\ print("at i="i" dz="dz"  bit="bit" out="out);
      dz=Minus_dz_transition(dz,bit, I);
      listput(l,out));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:62699";
 MinusRot_state_to_dz = {[0,-1,-I,1,I,1-I,1+I,-1-I,-1+I,2]};
 MinusRot_state_table = {[  1, 4;     \\  1  0
                            7, 4;     \\  2  -1
                            5, 1;     \\  3  -I
                            1, 3;     \\  4  1
                            4, 6;     \\  5  I
                            2, 1;     \\  6  1-I
                            3, 6;     \\  7  1+I
                            5, 7;     \\  8  -1-I
                            4,10;     \\  9  -1+I
                            8, 3 ]};  \\ 10  2

gp_inline__location="../dragon.tex:62712";
 MinusRot_num_states = matsize(MinusRot_state_table)[1];

gp_inline__location="../dragon.tex:62718";
 MinusRot_state_to_flip = apply(z_mod_b,MinusRot_state_to_dz);

gp_inline__location="../dragon.tex:62720";
 MinusRot_transition(state,bit) = \
   MinusRot_state_table[state,bit+1];
 MinusRot_transitions(state,v) = \
   for(i=1,#v, state=MinusRot_transition(state,v[i])); state;
 MinusRot_by_states(n) = {
   n>=0||error("MinusRot_by_states() is for n>=0");
   my(state=1,l=List([]));
   while(n||state!=1,    \\ print("at n="n" state="state" l="l);
      my(bit=bitand(n,1)); n>>=1;   \\ low to high
      listput(l,bitxor(bit,MinusRot_state_to_flip[state]));
      state=MinusRot_transition(state,bit));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:62890";
 z_is_MinusRot(z,n_limit) = {
      MinusUnpoint(z)   <= n_limit
   && MinusUnpoint(I*z) <= n_limit;
 }
 MinusRotB_by_points(k) = {
   my(n_limit=2^k-1);
   sum(n=0,n_limit,
       my(z=MinusPoint(n));
       if(z_is_MinusRot(z,n_limit),
          sum(d=0,3,
              my(z2=z+I^d);
              ! z_is_MinusRot(z2,n_limit))));
 }
 MinusRotA_by_points(k) = {
   my(n_limit=2^k-1);
   sum(n=0,n_limit,
       my(z=MinusPoint(n));
       z_is_MinusRot(z,n_limit));
 }

gp_inline__location="../dragon.tex:63088";
 MinusRotPred(k,n) = #binary(n) <= k && #binary(MinusRot(n)) <= k;

gp_inline__location="../dragon.tex:63100";
 MinusRotA_by_pred(k) = sum(n=0,2^k-1, MinusRotPred(k,n));

gp_inline__location="../dragon.tex:63113";
 MinusRotA_vector = {[1,-1,0,1,-1,1,0,-1]};

gp_inline__location="../dragon.tex:63129";
 MinusRotA_formula(k) = {
   9/20 * 2^k
   + 1/10 * vector_modulo(MinusRotA_vector,k) * 2^floor(k/2)
   + 1/5;
 }
 MinusRotA(k) = if(k==0,1,MinusRotA_formula(k));

gp_inline__location="../dragon.tex:63147";
 gMinusRotA(x) = \
   (1 - x^2 - 2*x^3 + x^4)/( (1-x)*(1-2*x)*(1 + 2*x + 2*x^2) );

gp_inline__location="../dragon.tex:63155";
 MinusRotA_samples = {[1,1,2,4,7,15,29,57,117,229,461,925]};

gp_inline__location="../dragon.tex:63267";
 MinusRotNeighbourPred(k,n,dz) = MinusRotPred(k,MinusInc(n,dz));

gp_inline__location="../dragon.tex:63282";
 MinusRotB_by_pred(k) = {
   sum(n=0,2^k-1,
       sum(d=0,3,
           my(dz=I^d);
           MinusRotPred(k,n) && !MinusRotNeighbourPred(k,n,dz)));
 }

gp_inline__location="../dragon.tex:63293";
 MinusRotB_samples = {[4,4,6,12,18,32,58,94,168,294,484,852]};

gp_inline__location="../dragon.tex:63320";
 gMinusRotB_dragon_cubic_part(x) = \
   1/119* (359 + 169*x + 348*x^2)/(1 - x - 2*x^3);
 gMinusRotB(x) = {
   1
   + 1/(1 - x)
   + 1/17* (7 - 5*x + 6*x^2 + 3*x^3)/(1 + x^4)
   + gMinusRotB_dragon_cubic_part(x)
   + 1/7* (4 + 3*x - 2*x^2)/(1 + x + x^2 - x^3)
   - (2 + x + 2*x^2)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:63333";
 MinusRotB_cubic_r   = abs(poly_biggest_root(x^3 + x^2 + x - 1));
 MinusRotB_quartic_r = real(poly_biggest_root(x^4 - 2*x - 1));

gp_inline__location="../dragon.tex:63363";
 MinusRotB_over_ComplexBoundary_limit = (201 - 6*r - 5*r^2)/238;

gp_inline__location="../dragon.tex:63367";
 MinusRotB_over_ComplexBoundary_limit_sample = {(0741389/1000000)};

gp_inline__location="../dragon.tex:63392";
 \\ no neighbours NSEW, so both completely isolated and those
 \\ which are hanging squares
 gMinusRot_singletons_Four(x) = {
   5 - x
   - 2/3/(1 - x)
   + (-1/3 - 2/3*x)/(1 + x + x^2)
   - 1/2*x^2/(1 + x + x^2 - x^3)
   + 1/2*x/(1 + x^4)
   + (-3 + 5/2*x + 1/2*x^2 + 15/2*x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:63409";
 \\ completely isolated, no neighbours in 8 directions
 gMinusRot_singletons_Eight(x) = {
   1 + 2*x
   - 1/2/(1 - x)
   + (-1 - 3/2*x - 2*x^2)/(1 + x + x^2 - x^3)
   + 1/2/(1 + x^4)
   + (1 + x^2 - 3/2*x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:63426";
 \\ pieces connected by NSEW sides only, so hanging squares or
 \\ other diagonal touches are separate pieces
 gMinusRot_pieces_Four(x) = {
   4 - 3*x
   + 1/12/(1 - x)
   - 1/4/(1 - x)^2
   + (-1/4 + 1/2*x + 1/4*x^2)/(1 + x^4)
   + (-1/3 - 2/3*x)/(1 + x + x^2)
   + (3/2 + 9/4*x + 9/4*x^2)/(1 + x + x^2 - x^3)
   + (-15/4 + 7/2*x + 3/4*x^2 + 10*x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:63444";
 \\ pieces connected by any 8-neighbour, so hanging squares or
 \\ other diagonal touches are included in a given piece
 gMinusRot_pieces_Eight(x) = {
   1/4/(1 - x)
   - 1/4/(1 - x)^2
   + (1/4 + 1/4*x^2)/(1 + x^4)
   + (1/2 + 3/4*x + 3/4*x^2)/(1 + x + x^2 - x^3)
   + (1/4 + x + 5/4*x^2 + x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:63460";
 gMinusRot_hanging(x) = \
   gMinusRot_singletons_Four(x) - gMinusRot_singletons_Eight(x);

gp_inline__location="../dragon.tex:63474";
 MinusUnrot_state_table = {[ 1, 4;  \\ 1 =
                             4, 7;  \\ 2 =  flip
                             1, 5;  \\ 3 =  flip
                             3, 1;  \\ 4 =  flip
                             6, 4;  \\ 5 =  flip
                             2, 1;  \\ 6 =
                             3, 6   \\ 7 =
                           ]};

gp_inline__location="../dragon.tex:63483";
 MinusUnrot_flip_table = [ 0, 1,1,1,1, 0,0 ];
 MinusUnrot_dz_table   = [ 0, -I, 1, I, -1, 1+I, -1+I ];
 MinusUnrot_transition(state,bit) = \
   MinusUnrot_state_table[state,bit+1];
 MinusUnrot_by_states(n) = {
   n>=0||error("MinusUnrot_by_states() is for n>=0");
   my(state=1,l=List([]));
   while(n||state!=1,    \\ print("at n="n" state="state" l="l);
      my(bit=bitand(n,1)); n>>=1;   \\ low to high
      listput(l,bitxor(bit,MinusUnrot_flip_table[state]));
      state=MinusUnrot_transition(state,bit));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:63524";
 MinusUnrot(n) = MinusUnpoint(-I*MinusPoint(n));

gp_inline__location="../dragon.tex:63533";
 MinusUnrot_samples = {[0,7,14,1,28,235,2,29,56,63,470,57]};

gp_inline__location="../dragon.tex:63543";
 MinusUnrot_by_dz(n) = {
   my(dz=0,l=List([]));
   while(n||dz,
      my(bit=bitand(n,1)); n>>=1;   \\ low to high
      my(out=z_mod_b(bit+dz));
      \\ print("at i="i" dz="dz"  bit="bit" out="out);
      dz=Minus_dz_transition(dz,bit, -I);
      listput(l,out));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:63556";
 MinusUnrotA_by_n(k) = \
   my(limit=2^k-1); sum(n=0,limit, MinusUnrot(n)<=limit);

gp_inline__location="../dragon.tex:63577";
 MinusDouble(n) = MinusUnpoint(2*MinusPoint(n));

gp_inline__location="../dragon.tex:63584";
 MinusDouble_samples = {[0,12,24,116,48,60,232,4,96,108,120,3732]};

gp_inline__location="../dragon.tex:63647";
 MinusDouble_state_table = {[ 1, 8;    \\  1 =  0
                              1, 8;    \\  2 =  1
                              2, 5;    \\  3 =  I
                              6, 1;    \\  4 = -1
                              3, 4;    \\  5 = -I
                              5, 14;   \\  6 =  1 + I
                              2, 5;    \\  7 = -1 + I
                              3, 4;    \\  8 = -1 - I
                              4, 15;   \\  9 =  1 - I
                              9, 12;   \\ 10 = 2*I
                              6, 1;    \\ 11 = -2
                              7, 11;   \\ 12 = -2*I
                              9, 12;   \\ 13 =  1 + 2*I
                              10, 7;   \\ 14 = -1 - 2*I
                              13, 3;   \\ 15 = -2 - I
                           /* extras */
                               8,19;   \\ 16 =  2
                              12,21;   \\ 17 =  2+2*I
                              16, 9;   \\ 18 = -2+2*I
                              10, 7;   \\ 19 = -2-2*I
                              11,22;   \\ 20 =  2-2*I
                              23,24;   \\ 21 = -1-3*I
                              13, 3;   \\ 22 = -3-I
                              16, 9;   \\ 23 = -1+2*I
                              25, 2;   \\ 24 = -2+I
                               5,14    \\ 25 =  2+I
                        ]};
 MinusDouble_dz_table = {[ 0, 1, I, -1, -I,
                           1+I, -1+I, -1-I, 1-I,
                           2*I, -2, -2*I,
                           1+2*I, -1-2*I, -2-I,
                           /* extras */
                           2, 2+2*I, -2+2*I, -2-2*I, 2-2*I,
                           -1-3*I, -3-I, -1+2*I, -2+I, 2+I
                         ]};

gp_inline__location="../dragon.tex:63683";
 MinusDouble_dz_to_state(dz) = {
   for(state=1,#MinusDouble_dz_table,
       if(MinusDouble_dz_table[state]==dz, return(state)));
   100*dz;
 }
 MinusDouble_flip_table = apply(z_mod_b,MinusDouble_dz_table);
 MinusDouble_transition(state,bit) = \
   MinusDouble_state_table[state,bit+1];
 MinusDouble_transitions(state,v) = \
   for(i=1,#v,state=MinusDouble_transition(state,v[i])); state;
 MinusDouble_by_states(n,state=1) = {
   n>=0||error("MinusDouble_by_states() is for n>=0");
   my(l=List([]));
   while(n||state!=1,    \\ print("at n="n" state="state" l="l);
      my(bit=bitand(n,1)); n>>=1;   \\ low to high
      listput(l,MinusDouble_flip_table[state]);
      state=MinusDouble_transition(state,bit));
   fromdigits(Vecrev(l),2);
 }

gp_inline__location="../dragon.tex:63952";
 MinusDoublePred(k,n) = \
   #binary(n) <= k && #binary(MinusDouble(n)) <= k;

gp_inline__location="../dragon.tex:63962";
 MinusDoubleA_by_pred(k) = sum(n=0,2^k-1, MinusDoublePred(k,n));

gp_inline__location="../dragon.tex:63973";
 MinusDoubleA_half_vector = {[-1,3,-2,1,1,-3,2,-1]};

gp_inline__location="../dragon.tex:63981";
 MinusDoubleA_constant_vector = {[12,4,-2,6]};

gp_inline__location="../dragon.tex:63988";
 MinusDoubleA_formula(k) = {
   87/400 * 2^k
   + 1/100*vector_modulo(MinusDoubleA_half_vector,k) * 2^floor(k/2)
   + 1/25*vector_modulo(MinusDoubleA_constant_vector,k);
 }
 MinusDoubleA(k) = if(k<=2,1,MinusDoubleA_formula(k));

gp_inline__location="../dragon.tex:64003";
 MinusDoubleA_samples = {[1,1,1,2,4,7,14,28,56,112,222,446]};

gp_inline__location="../dragon.tex:64177";
 \\ how many bits length MinusDouble(n) exceeds length n,
 \\ or possibly shortens
 MinusDoubleExtend(n) = \
   #binary(MinusUnpoint(2*MinusPoint(n))) - #binary(n);

gp_inline__location="../dragon.tex:64204";
 \\ how many 0-bits needed for state to transition to state 1
 MinusDouble_zeros_to_zero(state) = {
   my(count=0);
   while(state!=1,count++;state=MinusDouble_transition(state,0));
   count;
 }

gp_inline__location="../dragon.tex:64221";
 MinusDoubleNeighbourPred(k,n,dz) = \
   MinusDoublePred(k,MinusInc(n,dz));
 MinusDoubleB_by_pred(k) = {
   sum(n=0,2^k-1,
     sum(d=0,3,
       my(dz=I^d);
       MinusDoublePred(k,n) && !MinusDoubleNeighbourPred(k,n,dz)));
 }

gp_inline__location="../dragon.tex:64234";
 MinusDoubleB_samples = {[4,4,4,6,10,16,26,46,80,136,230,394]};
 MinusDoubleB(k) = gf_term(gMinusDoubleB(x),k);

gp_inline__location="../dragon.tex:64259";
 gMinusDoubleB_constant_part(x) = {
   5/2 + x + x^2
   + 1/(1 - x)
   + 1/(1 + x^2)
   + 1/17*(2 + x + 9*x^2 - 4*x^3)/(1 + x^4);
 }
 gMinusDoubleB_cubic_part(x) = \
   1/34*(47 + 19*x + 52*x^2)/(1 - x - 2*x^3);
 gMinusDoubleB(x) = {
     gMinusDoubleB_constant_part(x)
   + (-2 - x^2 + 3*x^3)/(1 - 2*x^3 - x^4)  \\ like MinusRotB
   + gMinusDoubleB_cubic_part(x);
 }

gp_inline__location="../dragon.tex:64287";
 MinusDoubleB_over_ComplexBoundary_limit = (23 + 12*r - 7*r^2)/68;
 MinusDoubleB_over_ComplexBoundary_limit_sample = {(0341493/1000000)};

gp_inline__location="../dragon.tex:64308";
 \\ no neighbours NSEW, so both completely isolated and those
 \\ which are hanging squares
 gMinusDouble_singletons_Four(x) = {
   14 - 6*x + 5*x^2 - x^3
   - 2/3/(1 - x)
   + 1/2/(1 + x^2)
   + (1/2 + 1/2*x)/(1 + x^4)
   + (-1/3 + 1/3*x)/(1 + x + x^2)
   + (-13 + 13/2*x - 5/2*x^2 + 28*x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:64326";
 \\ completely isolated, no neighbours in 8 directions
 gMinusDouble_singletons_Eight(x) = {
   -3 + 3*x + x^2 + x^3
   - 1/2/(1 - x)
   + 1/2/(1 + x^2)
   + (1/2 - 1/2*x^3)/(1 + x^4)
   + (7/2 - 3/2*x + x^2 - 7*x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:64342";
 gMinusDouble_pieces_Four(x) = {
   17 - 10*x + 4*x^2 - 2*x^3
   + 4/3/(1 - x)
   - 1/4/(1 - x)^2
   + 1/4/(1 + x^2)
   + (-1/3 + 1/3*x)/(1 + x + x^2)
   + (1/4 + 3/4*x + 1/4*x^2 + 1/4*x^3)/(1 + x^4)
   + (-69/4 + 35/4*x - 13/4*x^2 + 149/4*x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:64357";
 gMinusDouble_pieces_Eight(x) = {
   -x
   + 3/2/(1 - x)
   - 1/4/(1 - x)^2
   + 1/4/(1 + x^2)
   + (1/4 + 1/4*x + 1/4*x^2 - 1/4*x^3)/(1 + x^4)
   + (-3/4 + 3/4*x + 1/4*x^2 + 9/4*x^3)/(1 - 2*x^3 - x^4);
 }

gp_inline__location="../dragon.tex:64371";
 gMinusDouble_hanging(x) = \
   gMinusDouble_singletons_Four(x)-gMinusDouble_singletons_Eight(x);

gp_inline__location="../dragon.tex:64390";
 \\ start=0, end=1, same order as twindragon_hull()
 T_P4_limit  = -1/3;
 T_P3_limit  = -1/3 - 1/3*I;
 T_P2_limit  =      - 2/3*I;
 T_P1_limit  =  2/3 - 2/3*I;
 T_P4o_limit =  4/3;            /* P4' */
 T_P3o_limit =  4/3 + 1/3*I;    /* P3' */
 T_P2o_limit =  1   + 2/3*I;    /* P2' */
 T_P1o_limit =  1/3 + 2/3*I;    /* P1' */
 twindragon_hull_fractal = {[
  T_P4_limit,  T_P3_limit,  T_P2_limit,  T_P1_limit,
  T_P4o_limit, T_P3o_limit, T_P2o_limit, T_P1o_limit
 ]};

gp_inline__location="../dragon.tex:64406";
 slope_is_straight(z) = z==1 || z==I;
 slope_is_diagonal(z) = z==1+I || z==1-I;
 polygon_slopes_are_all_straight_and_diagonal(v) = {
   for(i=1,#v,
       my(s = z_to_slope(vector_modulo(v,i)
                         - vector_modulo(v,i-1)));
       if(! (slope_is_straight(s) || slope_is_diagonal(s)),
          return(0)));
   1;
 }

gp_inline__location="../dragon.tex:64419";
 T_P1(k) = P1(k+1);
 T_P2(k) = P2(k+1);
 T_P3(k) = P3(k+1);
 T_P4(k) = P4(k+1);
 T_P1o(k) = b^(k+1) - P1(k+1);
 T_P2o(k) = b^(k+1) - P2(k+1);
 T_P3o(k) = b^(k+1) - P3(k+1);
 T_P4o(k) = b^(k+1) - P4(k+1);

gp_inline__location="../dragon.tex:64428";
 /* Anti-clockwise around */
 twindragon_hull(k) = {
   k>=0 || error("twindragon_hull() is for k>=0");
   if(k==0, return([ T_P3(k),
                     T_P1(k),
                     T_P3o(k),
                     T_P1o(k) ]));
   if(k==1, return([ T_P4(k),
                     T_P2(k),
                     T_P1(k),
                     T_P4o(k),
                     T_P2o(k),
                     T_P1o(k) ]));
   if(k==2, return([ T_P3(k),
                     T_P2(k),
                     T_P1(k),
                     T_P3o(k),
                     T_P2o(k),
                     T_P1o(k) ]));
   [ T_P4(k),
     T_P3(k),
     T_P2(k),
     T_P1(k),
     T_P4o(k),
     T_P3o(k),
     T_P2o(k),
     T_P1o(k) ];
 }

gp_inline__location="../dragon.tex:64837";
 T_P4_rotated_imag_from_P(k) = \
   imag( T_P4(k)*conj(w8_times_sqrt2)^(k+1) )/ sqrt2^(k+1);

gp_inline__location="../dragon.tex:64847";
 T_P4_rotated_imag(k) = if(k%4==2, -1/2*sqrt2, 0);

gp_inline__location="../dragon.tex:64936";
 THdiam_half_vector = {[56,64,28,56]};

gp_inline__location="../dragon.tex:64941";
 THdiam_constant_vector = {[16,20,4,8]};

gp_inline__location="../dragon.tex:64946";
 THdiam_squared(k) = {
   1/9 * ( 58*2^k
           - vector_modulo(THdiam_half_vector,k)*2^floor(k/2)
           + vector_modulo(THdiam_constant_vector,k)
         );
 }

gp_inline__location="../dragon.tex:64961";
 THdiam_by_T_P3(k) = norm(T_P3(k) - T_P3o(k));

gp_inline__location="../dragon.tex:64965";
 THdiam_by_P3(k) = norm( P3(k+1) - (b^(k+1)-P3(k+1)) );

gp_inline__location="../dragon.tex:64971";
 THdiam_samples = {[2,8,20,40,80,180,388,776,1552,3188,6500]};

gp_inline__location="../dragon.tex:65041";
 THdiam_diff(k) = \
   (sqrt(58/9) - sqrt(52/9))*sqrt(2)^k - 4*pmax_inexact;

gp_inline__location="../dragon.tex:65143";
 THdiam_even_rotation(k) = I^( -(k/2+1) );

gp_inline__location="../dragon.tex:65151";
 THdiam_z_even(k) = \
   (1/2*b^(k+1) - P3(k+1)) * THdiam_even_rotation(k);
 THdiam_x_even(k) = abs(real( THdiam_z_even(k) ));
 THdiam_y_even(k) = abs(imag( THdiam_z_even(k) ));

gp_inline__location="../dragon.tex:65159";
 THdiam_y_even_by_power(k) = 1/2*2^(k/2);

gp_inline__location="../dragon.tex:65311";
 THdiam_odd_rotation(k) = I^( -(k+1)/2 );

gp_inline__location="../dragon.tex:65317";
 THdiam_z_odd(k) = (1/2*b^(k+1) - P3(k+1)) * THdiam_odd_rotation(k);
 THdiam_x_odd(k) = real( THdiam_z_odd(k) );

gp_inline__location="../dragon.tex:65324";
 THdiam_x_odd_by_power(k) = \
   1/3*( 5*2^((k-1)/2) - vector_modulo([2,1],(k-1)/2) );

gp_inline__location="../dragon.tex:65333";
 THdiam_y_odd(k) = imag( THdiam_z_odd(k) );

gp_inline__location="../dragon.tex:65342";
 THdiam_y_odd_by_power(k) = \
   1/3*( 2^((k+1)/2) - (-1)^((k+1)/2) );

gp_inline__location="../dragon.tex:65349";
 THdiam_y(k) = if(k%2==0,THdiam_y_even(k),THdiam_y_odd(k));

gp_inline__location="../dragon.tex:65400";
 THdiam_x(k) = if(k%2==0,THdiam_x_even(k),THdiam_x_odd(k));

gp_inline__location="../dragon.tex:65438";
 THA_vector = {[(8)/(3),4,(10)/(3),4]};

gp_inline__location="../dragon.tex:65445";
 THA(k) = {
   10/3*2^k
   - vector_modulo(THA_vector,k)*2^floor(k/2)
   + 1/3;
 }

gp_inline__location="../dragon.tex:65452";
 THA_by_polygon(k) = geom_area_of_polygon(twindragon_hull(k));

gp_inline__location="../dragon.tex:65459";
 THA_samples = {[1,3,7,19,43,91,187,395,811,1643]};

gp_inline__location="../dragon.tex:65476";
 THdiamf = 1/3*geom_sqrt_as_quad(29);
 THdiamf_sample = {(1795054/1000000)};

gp_inline__location="../dragon.tex:65492";
 THAf = {(5)/(3)};

gp_inline__location="../dragon.tex:65716";
 gen_complex_plus_hull_samples = {[
   /* 0 */ [ 0 ],
   /* 1 */ [ 0,1 ],
   /* 2 */ [ 1,0,1+I,2+I ],
   /* 3 */ [ 2+I,1,0,2*I,1+3*I,2+3*I ],
   /* 4 */ [ 2+3*I,2+I,1,0,-2+2*I,-2+4*I,-1+5*I,5*I ],
   /* 5 */ [ 5*I,2+3*I,2+I,1,-4,-6+2*I,-6+4*I,-5+5*I ],
   /* 6 */ [ -5+5*I,5*I,2+3*I,2+I,-3-4*I,-8-4*I,-10-2*I,-10 ],
   /* 7 */ [ -10,-5+5*I,5*I,2+3*I,2-7*I,-3-12*I,-8-12*I,-10-10*I ],
   /* 8 */ [ -10-10*I,-10,-5+5*I,5*I,10-5*I,10-15*I,5-20*I,-20*I ],
   /* 9 */ [ -20*I,-10-10*I,-10,-5+5*I,16+5*I,26-5*I,26-15*I,21-20*I ],
   /* 10 */ [ 21-20*I,-20*I,-10-10*I,-10,11+21*I,32+21*I,42+11*I,42+I ],
   /* 11 */ [ 42+I,21-20*I,-20*I,-10-10*I,-10+32*I,11+53*I,32+53*I,42+43*I ],
   /* 12 */ [ 42+43*I,42+I,21-20*I,-20*I,-42+22*I,-42+64*I,-21+85*I,85*I ],
   /* 13 */ [ 85*I,42+43*I,42+I,21-20*I,-64-20*I,-106+22*I,-106+64*I,-85+85*I ],
   /* 14 */ [ -85+85*I,85*I,42+43*I,42+I,-43-84*I,-128-84*I,-170-42*I,-170 ]
 ]};
 gen_complex_plus_hull_samples_area = [ 0, 0, 1, 5, 15, 35, 79, 175, 375, 775, 1591, 3255, 6615, 13335, 26839 ];

gp_inline__location="../dragon.tex:65783";
 CP1(k) = -I*P1(k) + coff(k);

gp_inline__location="../dragon.tex:65786";
 CP1dash(k) = -I*(b^k-1) - CP1(k);

gp_inline__location="../dragon.tex:65789";
 CP2(k) = -I*P2(k) + coff(k-1);

gp_inline__location="../dragon.tex:65792";
 CP2dash(k) = -I*(b^k-1) - CP2(k);

gp_inline__location="../dragon.tex:65795";
 CP3(k) = -I*P3(k) + coff(k-2);

gp_inline__location="../dragon.tex:65798";
 CP3dash(k) = -I*(b^k-1) - CP3(k);

gp_inline__location="../dragon.tex:65801";
 CP4(k) = -I*P4(k) + coff(k-3);

gp_inline__location="../dragon.tex:65804";
 CP4dash(k) = -I*(b^k-1) - CP4(k);

gp_inline__location="../dragon.tex:65814";
 coff(m) = if(m%8>=0 && m%8<=3, I, 0);

gp_inline__location="../dragon.tex:65816";
 A131078_annotation_vector = {[1,1,1,1,0,0,0,0]};

gp_inline__location="../dragon.tex:65833";
 CP_hull(k) = [ CP1(k),CP2(k),CP3(k),CP4(k), \
                CP1dash(k),CP2dash(k),CP3dash(k),CP4dash(k) ];
 gen_complex_plus_hull_samples_k4 = \
   gen_complex_plus_hull_samples[5..-1];

gp_inline__location="../dragon.tex:65912";
 CHA(k) = {
   5/3 * 2^k
   - vector_modulo([10/3, 5, 11/3, 5],k) * 2^floor(k/2)
   + 5/3;
 }

gp_inline__location="../dragon.tex:65918";
 CHA_samples = {[0,0,1,5,15,35,79,175,375,775,1591]};

gp_inline__location="../dragon.tex:66075";
 THBP_by_MaxReIm(k) = {
   2*(  MaxReIm(P1(k+1)-P2(k+1))
      + MaxReIm(P2(k+1)-P3(k+1))
      + MaxReIm(P3(k+1)-P4(k+1))
      + MaxReIm(P4(k+1)-T_P1o(k)) );
 }
 THBP_by_hull(k) = boundary_numint_of_polygon(twindragon_hull(k));

gp_inline__location="../dragon.tex:66086";
 THBP(k) = vector_modulo([6,8],k)*2^floor(k/2) - 2;

gp_inline__location="../dragon.tex:66090";
 THBP_samples = {[4,6,10,14,22,30,46,62,94]};

gp_inline__location="../dragon.tex:66102";
 A027383(n) = {
   n>=0 || error("A027383() is for n>=0");
   if(n%2==0, n\=2; 3*2^n - 2,
              n\=2; 4*2^n - 2);
 }

gp_inline__location="../dragon.tex:66121";
 THIP(k) = THA(k) - 1/2*THBP(k) + 1;

gp_inline__location="../dragon.tex:66126";
 THIP_half_vector = {[17,24,19,24]};

gp_inline__location="../dragon.tex:66131";
 THIP_by_powers(k) = {
   10/3*2^k
    - 1/3*vector_modulo(THIP_half_vector,k)*2^floor(k/2)
    + 7/3;
 }

gp_inline__location="../dragon.tex:66142";
 THIP_samples = {[0,1,3,13,33,77,165,365,765]};

gp_inline__location="../dragon.tex:66155";
 THP(k) = THIP(k) + THBP(k);

gp_inline__location="../dragon.tex:66160";
 THP_half_vector = {[1,0,-1,0]};

gp_inline__location="../dragon.tex:66165";
 THP_by_powers(k) = {
   10/3*2^k
   + vector_modulo([1/3,0,-1/3,0],k)*2^floor(k/2)
   + 1/3;
 }

gp_inline__location="../dragon.tex:66173";
 THP_samples = {[4,7,13,27,55,107,211,427,859]};

gp_inline__location="../dragon.tex:66183";
 \\ \\ per R. J. Mathar in A136408
 gA136408(x) =  \
   (1 - x + 2*x^2 - 3*x^3)/((1-x) * (1-2*x) * (1 + 2*x^2));

gp_inline__location="../dragon.tex:66327";
 TMR_half_vector = {[34,38,38,34]};

gp_inline__location="../dragon.tex:66332";
 TMR_constant_vector = {[8,4]};

gp_inline__location="../dragon.tex:66336";
 TMR(k) = 1/9* (35*2^k \
    - vector_modulo(TMR_half_vector,k) * 2^floor(k/2) \
    + vector_modulo(TMR_constant_vector,k));

gp_inline__location="../dragon.tex:66345";
 TMR_samples = {[1,4,8,24,48,108,216,468,936,1924,3848,7844]};

gp_inline__location="../dragon.tex:66418";
 TMR_by_real_imag(k) = 2^k \
  * imag( (b^(k+1)-P2(k+1) - P2(k+1)) / b^k) \
  * real( (b^(k+1)-P4(k+1) - P4(k+1)) / b^k);

gp_inline__location="../dragon.tex:66432";
 TMRdiag(k) = 2^(k+1) \
     * imag( (b^(k+1)-P2(k+1) - P2(k+1)) / b^(k+1) ) \
     * real( (b^(k+1)-P4(k+1) - P4(k+1)) / b^(k+1) );

gp_inline__location="../dragon.tex:66442";
 TMRdiag_half_vector = {[26,26,28,28]};

gp_inline__location="../dragon.tex:66447";
 TMRdiag_constant_vector = {[4,8]};

gp_inline__location="../dragon.tex:66451";
 TMRdiag_simplified(k) = 1/9 * ( 40*2^k  \
     - vector_modulo(TMRdiag_half_vector,k) * 2^ceil(k/2) \
     + vector_modulo(TMRdiag_constant_vector,k));

gp_inline__location="../dragon.tex:66459";
 TMRdiag_samples = {[2,4,12,24,60,120,260,520,1092,2184]};

gp_inline__location="../dragon.tex:66480";
 TMR_diff_unsimplified(k) = \
   1/9 * ( 40*2^k  \
          - [26, 26, 28, 28][(k)%4+1] * 2^ceil(k/2) \
          + [4, 8][(k)%2+1]) \
  - 1/9* ( 35*2^k \
          - 2^ceil(k/2) * [34, 19, 38, 17][(k%4)+1] \
          + [8,4][(k%2)+1]);

gp_inline__location="../dragon.tex:66495";
 TMR_diff(k) = 1/9 * ( 5*2^k  \
          + [8, -7, 10, -11][(k)%4+1] * 2^ceil(k/2) \
          + [-4, 4][(k)%2+1]);

gp_inline__location="../dragon.tex:66513";
 TMR_diff_1(k) = 1/9*(5*2^k - 11*2^ceil(k/2) - 4);

gp_inline__location="../dragon.tex:66522";
 TMR_diff_2(k) = 1/9*(4*4*2^ceil(k/2) + 1*4 - 11*2^ceil(k/2) - 4);

gp_inline__location="../dragon.tex:66553";
 TXYhullA_by_THA(k) = {
   if(k==0,return(0));
   THA(k) - 2*XYindentA(k+1) - 2*XYindentA(k-1);
 }

gp_inline__location="../dragon.tex:66562";
 TXYhullA_2_vector = {[13,26,14,28]};

gp_inline__location="../dragon.tex:66568";
 TXYhullA_4_vector = {[-4,6,-9,10]};

gp_inline__location="../dragon.tex:66574";
 TXYhullA_constant_vector = {[1,2]};
 TXYhullA(k) = {
   190/63*2^k
   - 2/9 * vector_modulo(TXYhullA_2_vector,k) * 2^floor(k/2)
   + 1/7 * vector_modulo(TXYhullA_4_vector,k) * 2^floor(k/4)
   + 4/9 * vector_modulo(TXYhullA_constant_vector,k);
 }

gp_inline__location="../dragon.tex:66586";
 TXYhullA_by_points(k) = {
   xyhull_area_of_points(twindragon_points(k) * if(k%2==0,b,1))
                                              / if(k%2==0,2,1);
 }

gp_inline__location="../dragon.tex:66595";
 TXYhullA_samples = {[0,2,5,14,36,76,166,340,724,1456]};

gp_inline__location="../dragon.tex:66613";
 TDXhullA_by_THA(k) = {
   if(k==0,return(1));
   if(k==1,return(2));
   THA(k) - 2*XYindentA(k) - 2*XYindentA(k-2);
 }

gp_inline__location="../dragon.tex:66623";
 TDXhullA_2_vector = {[17,19,19,17]};

gp_inline__location="../dragon.tex:66629";
 TDXhullA_4_vector = {[5,-4,6,-9]};

gp_inline__location="../dragon.tex:66635";
 TDXhullA_constant_vector = {[2,1]};
 TDXhullA(k) = {
   200/63*2^k
   - 2/9 * vector_modulo(TDXhullA_2_vector,k) * 2^floor(k/2)
   + 1/7 * vector_modulo(TDXhullA_4_vector,k) * 2^floor(k/4)
   + 4/9 * vector_modulo(TDXhullA_constant_vector,k);
 }

gp_inline__location="../dragon.tex:66647";
 TDXhullA_by_points(k) = {
   xyhull_area_of_points(twindragon_points(k) * if(k%2==1,b,1))
                                              / if(k%2==1,2,1);
 }

gp_inline__location="../dragon.tex:66656";
 TDXhullA_samples = {[1,2,6,17,38,84,172,374,756,1556]};

gp_inline__location="../dragon.tex:66672";
 TXYhullAf = {(95)/(63)};
 TXYhullAf_sample = {(1507/1000)};

gp_inline__location="../dragon.tex:66690";
 TDXhullAf = {(100)/(63)};
 TDXhullAf_sample = {(1587/1000)};

gp_inline__location="../dragon.tex:66799";
 twindragon_centroid(k) = 1/2*b^(k+1);
 twindragon_midpoints_at_centroid(k) = {
   my(centroid = twindragon_centroid(k));
   apply(z -> z-centroid, twindragon_midpoints(k));
 }

gp_inline__location="../dragon.tex:66805";
 TI_angle_by_points(k,a) = {
   my(v=twindragon_midpoints_at_centroid(k));
   v *= 1/((b/sqrt(2))^(k+1) * exp(a*I));  /* rotate */
   sum(i=1,#v, imag(v[i])^2);
 }

gp_inline__location="../dragon.tex:66811";
 TI_inertia_by_points(k) = {
  my(m=geom_inertia_of_points(twindragon_midpoints_at_centroid(k)));
  geom_inertia_rotate_xydir(m, b^(k+1));  \\ endpoint on X axis
 }

gp_inline__location="../dragon.tex:66816";
 TI_x_by_points(k) = {    /* TI_x = sum y^2 + z^2 = sum y^2 */
   my(v=twindragon_midpoints_at_centroid(k));
   v *= conj(b)^(k+1);  /* rotate */
   sum(i=1,#v, imag(v[i])^2) / 2^(k+1);
 }
 TI_y_by_points(k) = {    /* TI_x = sum x^2 + z^2 = sum x^2 */
   my(v=twindragon_midpoints_at_centroid(k));
   v *= conj(b)^(k+1);  /* rotate */
   sum(i=1,#v, real(v[i])^2) / 2^(k+1);
 }
 TI_xy_by_points(k) = {
   my(v=twindragon_midpoints_at_centroid(k));
   v *= conj(b)^(k+1);  /* rotate */
   sum(i=1,#v, imag(v[i])*real(v[i])) / 2^(k+1);
 }
 TI_z_by_points(k) = {
   my(v=twindragon_midpoints_at_centroid(k));
   sum(i=1,#v, norm(v[i]));
 }

gp_inline__location="../dragon.tex:66849";
 TI(k) = {[  TI_x(k), -TI_xy(k), 0;
            -TI_xy(k), TI_y(k),  0;
             0,        0,       TI_z(k) ]};

gp_inline__location="../dragon.tex:66875";
 TI_x_multiply_vector = {[3,1,7,9]};

gp_inline__location="../dragon.tex:66879";
 TI_x(k) = {
   k>=0 || error("TI_x() is for k>=0");
   4/5 * 4^k
   - 1/10 * vector_modulo(TI_x_multiply_vector,k) * 2^k;
 }

gp_inline__location="../dragon.tex:66887";
 TI_x_samples = {[(1)/(2),3,10,44,200,816,3232,12992]};

gp_inline__location="../dragon.tex:66907";
 TI_y_multiply_vector = {[7,9,3,1]};

gp_inline__location="../dragon.tex:66911";
 TI_y(k) = {
   k>=0 || error("TI_y() is for k>=0");
   6/5 * 4^k
   - 1/10 * vector_modulo(TI_y_multiply_vector,k) * 2^k;
 }

gp_inline__location="../dragon.tex:66919";
 TI_y_samples = {[(1)/(2),3,18,76,296,1200,4896,19648]};

gp_inline__location="../dragon.tex:66939";
 TI_xy_vector = {[-2,1,2,-1]};

gp_inline__location="../dragon.tex:66944";
 TI_xy(k) = {
   k>=0 || error("TI_xy() is for k>=0");
   2/5*4^k  + 1/5*vector_modulo(TI_xy_vector,k)*2^k;
 }

gp_inline__location="../dragon.tex:66957";
 TI_xy_samples = {[0,2,8,24,96,416,1664,6528]};

gp_inline__location="../dragon.tex:66992";
 TI_z(k) = {
   k>=0 || error("TI_z() is for k>=0");
   2*4^k - 2^k;
 }

gp_inline__location="../dragon.tex:66999";
 TI_z_samples = {[1,6,28,120,496,2016,8128,32640]};

gp_inline__location="../dragon.tex:67015";
 A171476(n) = 2^n*(2^(n+1) - 1);

gp_inline__location="../dragon.tex:67032";
 A006516(n) = 2^(n-1)*(2^n - 1);

gp_inline__location="../dragon.tex:67039";
 TI_inertia(k) = {
   my(x=TI_x(k), y=TI_y(k), xy=TI_xy(k), z=TI_z(k));
   [  x,   -xy, 0;
     -xy,   y,  0;
      0,    0,  z  ];
 }

gp_inline__location="../dragon.tex:67049";
 TI_angle(k,a) = {
       TI_x(k)  * cos(a)^2
   - 2*TI_xy(k) * cos(a)*sin(a)
   +   TI_y(k)  * sin(a)^2;
 }

gp_inline__location="../dragon.tex:67068";
 TI_Delta_inexact(k) = \
   ( 1/2*b^(k+1) - GS(k+1) )* conj(w8_inexact)^(k+1);
 TI_Delta_Im(k) = {
   imag( (1/2*b^(k+1)-GS(k+1))*conj(w8_times_sqrt2)^(k+1) )
   / sqrt2^(k+1);
 }
 TI_Delta_Re(k) = {
   real( (1/2*b^(k+1)-GS(k+1))*conj(w8_times_sqrt2)^(k+1) )
   / sqrt2^(k+1);
 }

gp_inline__location="../dragon.tex:67117";
 TI_Delta_norm(k) = TI_Delta_Im(k)^2+TI_Delta_Re(k)^2;

gp_inline__location="../dragon.tex:67224";
 TI_by_parts_centroid_matrix = {[0,0,0;0,1,0;0,0,1]};

gp_inline__location="../dragon.tex:67379";
 TI_arctan_fraction(k) = -2*TI_xy(k) / (TI_x(k) - TI_y(k));

gp_inline__location="../dragon.tex:67384";
 TI_alpha_min_by_arctan(k) = 1/2*atan(TI_arctan_fraction(k));

gp_inline__location="../dragon.tex:67391";
 TI_alpha_min_numerator_vector = {[0,-2,0,2]};

gp_inline__location="../dragon.tex:67397";
 TI_x_subtract_TI_y(k) = -2/5 * 4^k \
   - 1/5 * vector_modulo([-2, -4, 2, 4],k) * 2^k;
 TI_xy_by_TI_x_subtract_TI_y(k) = \
   -TI_x_subtract_TI_y(k)  + vector_modulo([0,1,0,-1],k) * 2^k;
 TI_arctan_fraction_simplified(k) = {
   2
   + vector_modulo(TI_alpha_min_numerator_vector,k) * 2^k
     / (TI_x(k) - TI_y(k));
 }

gp_inline__location="../dragon.tex:67415";
 TI_alpha_min = 1/2*atan(2);

gp_inline__location="../dragon.tex:67428";
TI_alpha_min_sample = {(31717474/1000000)};

gp_inline__location="../dragon.tex:67445";
 phi = (sqrt5+1)/2;
 one_over_phi = 1/phi;

gp_inline__location="../dragon.tex:67448";
one_over_phi_sample = {(0618033/1000000)};

gp_inline__location="../dragon.tex:67474";
phi_sample = {(1618033/1000000)};

gp_inline__location="../dragon.tex:67491";
 TI_alpha_max = 1/2*TI_alpha_min + Pi/2;

gp_inline__location="../dragon.tex:67526";
 \\ TIf is unit length start to end, mass 2, area 1
 TIf = {[ 1/5, -1/10, 0;
         -1/10, 3/10, 0;
           0,    0,  1/2 ]};

gp_inline__location="../dragon.tex:67566";
 TIf_principal = {[ 1/4 - 1/20*sqrt5, 0, 0;
                    0, 1/4 + 1/20*sqrt5, 0;
                    0, 0, 1/2 ]};

gp_inline__location="../dragon.tex:67584";
 TI_min = geom_inertia_Ix(TIf_principal);
 TI_max = geom_inertia_Iy(TIf_principal);

gp_inline__location="../dragon.tex:67590";
 TIf_principal_Ix = geom_inertia_Ix(TIf_principal);
 TIf_principal_Iy = geom_inertia_Iy(TIf_principal);

gp_inline__location="../dragon.tex:67606";
TI_min_sample = {(0138196/1000000)};

gp_inline__location="../dragon.tex:67633";
TI_max_sample = {(0361803/1000000)};

gp_inline__location="../dragon.tex:67664";
 twindragon_hull_at_centroid(k) = {
   my(G=1/2*b^(k+1));
   apply(z->z-G, twindragon_hull(k));
 }

gp_inline__location="../dragon.tex:67677";
 twindragon_hull_fractal_at_centroid = \
   apply(z->z-1/2, twindragon_hull_fractal);

gp_inline__location="../dragon.tex:67684";
 \\ density mass = 2*area same as dragon and twindragon
 \\ rotating about the hull centroid, and X axis directed
 \\ on the twindragon start to end line
 THI(k) = {
   2*geom_inertia_rotate_xydir
     (geom_inertia_of_polygon(twindragon_hull_at_centroid(k)),
      b^(k+1));
 }

gp_inline__location="../dragon.tex:67699";
 THIf = \
   2*geom_inertia_of_polygon(twindragon_hull_fractal_at_centroid);

gp_inline__location="../dragon.tex:67731";
 THI_x = {(95)/(243)};

gp_inline__location="../dragon.tex:67737";
 THI_y = {(271)/(486)};

gp_inline__location="../dragon.tex:67743";
 THI_xy = {(23)/(162)};

gp_inline__location="../dragon.tex:67753";
 THI_alpha_fraction = {(46)/(27)};
 \\ negative so first quadrant and half gives minimum on x
 THI_d_squared_xydir = -( (THI_x - THI_y) - 2*THI_xy*I );
 THI_d_xydir = geom_xydir_half(THI_d_squared_xydir);
 matrix_is_diagonal(m) = {
   for(i=1,matsize(m)[1],
     for(j=1,matsize(m)[2],
       if(i!=j && m[i,j]!=0, return(0))));
   1;
 }

gp_inline__location="../dragon.tex:67774";
 THI_alpha_min = 1/2*atan(THI_alpha_fraction);

gp_inline__location="../dragon.tex:67779";
THI_alpha_min_sample = {(29794459/1000000)};

gp_inline__location="../dragon.tex:67871";
 BlobR_generated_samples = [ 0,0,0,0,4,7,14,27,48,83,146,247,420,719,1222,2067,3512 ];
 BlobL_generated_samples = [ 0,0,0,0,0,3,6,11,20,39,66,111,192,331,558,947,1612 ];
 BlobB_generated_samples = [ 0,0,0,0,4,10,20,38,68,122,212,358,612,1050,1780,3014,5124 ];
 BlobAR_generated_samples = [ 0,0,0,0,0,1,2,5,13,30,65,142,304,639,1332,2759,5675 ];
 BlobAL_generated_samples = [ 0,0,0,0,1,2,4,9,20,41,85,176,361,736,1498,3039,6150 ];
 BlobSegments_generated_samples = [ 0,0,0,0,4,11,22,47,100,203,406,815,1636,3275,6550,13103,26212 ];
 BlobS_generated_samples = [ 0,0,0,0,3,6,11,20,35,62,107,180,307,526,891,1508,2563 ];
 BlobD_generated_samples = [ 0,0,0,0,1,3,6,14,33,71,150,318,665,1375,2830,5798,11825 ];
 BlobP_generated_samples = [ 0,0,0,0,4,9,17,34,68,133,257,498,972,1901,3721,7306,14388 ];
 BlobHorizontals_generated_samples = [ 0,0,0,0,2,3,6,11,18,31,54,91,154,263,446,755,1282 ];
 BlobVerticals_generated_samples = [ 0,0,0,0,2,4,6,10,18,32,54,90,154,264,446,754,1282 ];
 BlobLines_generated_samples = [ 0,0,0,0,4,7,12,21,36,63,108,181,308,527,892,1509,2564 ];
 BlobRQ_generated_samples = [ 0,0,0,0,4,5,9,15,26,43,75,125,212,361,613,1035,1758 ];
 BlobLQ_generated_samples = [ 0,0,0,0,0,3,4,7,11,21,34,57,97,167,280,475,807 ];
 BlobBQ_generated_samples = [ 0,0,0,0,4,8,13,22,37,64,109,182,309,528,893,1510,2565 ];

gp_inline__location="../dragon.tex:68512";
 BlobList(k) = {
   k>=0 || error("BlobList() is for k>=0");
   concat(vector(max(0,k-3),i, i+3),    /*  4  to k, inclusive */
          vector(max(0,k-5),i, k-1-i)); /* k-2 to 4, inclusive */
 }

gp_inline__location="../dragon.tex:68564";
 BlobCount(k) = {
   k>=0 || error("BlobCount() is for k>=0");
   if(k<4,0, k==4,1, 2*k-8);
 }

gp_inline__location="../dragon.tex:68569";
 BlobCount_samples = {[0,0,0,0,1,2,4,6,8,10,12]};

gp_inline__location="../dragon.tex:68587";
 BridgeCount(k) = if(k<=4, 0, 2*k-9);

gp_inline__location="../dragon.tex:68591";
 BridgeCount_samples = {[0,0,0,0,0,1,3,5,7,9,11]};

gp_inline__location="../dragon.tex:68613";
 BlobN_offsets = {[3,6,12,9]};

gp_inline__location="../dragon.tex:68620";
 BlobN_formula(k) = 2/5*2^k + 1/5*vector_modulo(BlobN_offsets,k);
 BlobN(k) = {
   k>=4 || error("BlobN() is for k>=4");
   BlobN_formula(k);
 }

gp_inline__location="../dragon.tex:68627";
 BlobN_generated_samples = [ 7,14,28,53,103,206,412,821,1639,3278,6556,13109 ];
 BlobNend_generated_samples = [ 11,25,50,100,203,409,818,1636,3275,6553,13106,26212 ];

gp_inline__location="../dragon.tex:68634";
 BlobN_samples = {[7,14,28,53,103,206,412,821,1639,3278]};

gp_inline__location="../dragon.tex:68646";
 BlobN_binary_endings = [111, 1110, 11100,             110101];

gp_inline__location="../dragon.tex:68649";
 BlobN_binary_vector(k) = {
   k>=4 || error();
   concat(concat_repeat([1,1,0,0], (k-4)\4),
          digits(vector_modulo(BlobN_binary_endings,k)));
 }

gp_inline__location="../dragon.tex:68660";
 BlobN_samples_binary = {[111,1110,11100,110101,1100111,11001110]};

gp_inline__location="../dragon.tex:68681";
 gBlobN_formula(x) = \
   + 2/5* 1/(1-2*x) - 1/10*(9 + 3*x)/(1+x^2) + 3/2* 1/(1-x);
 gBlobN(x) = gBlobN_formula(x) -1 - 2*x - 4*x^2 - 5*x^3;

gp_inline__location="../dragon.tex:68686";
 gBlobN_quadratic(x) = \
   5*( - 1/10*(9 + 3*x)/(1+x^2) + 3/2* 1/(1-x) );

gp_inline__location="../dragon.tex:68722";
 bridge_type_next(s) = \
   if(s=="OL", "ER", \
      s=="ER", "EL", \
      s=="EL", "OR", \
      s=="OR", "OL", \
      error("unrecognised bridge type ",s));

gp_inline__location="../dragon.tex:68729";
 blob_end_types(k) = \
   [ vector_modulo(["OL","ER","EL","OR"],k), \
     vector_modulo(["OR","OL","ER","EL"],k) ];

gp_inline__location="../dragon.tex:68743";
 BlobN_vector = {[0,0,3,3]};

gp_inline__location="../dragon.tex:68751";
 BlobN_by_recurrence_k_plus_1(k) = {
   if(k+1<4,error("BlobN_by_recurrence_k_plus_1() is for k+1>=4"));
   if(k+1==4,7,
      2*BlobN(k) - vector_modulo(BlobN_vector,k));
 }
 BlobN_by_recurrence(k) = BlobN_by_recurrence_k_plus_1(k-1);

gp_inline__location="../dragon.tex:68805";
 RLpred_state_table = {[ 1,2;      /* b1 */
                         6,3;      /* b2 */
                         4,11;     /* b3 */
                         5,7;      /* b4 */
                         11,2;     /* b5 */
                         10,8;     /* b6 */
                         9,10;     /* b7 */
                         11,10;    /* b8 */
                         10,11;    /* b9 */
                         11,11;    /* b10 */
                         11,11 ]}; /* 11=blob */
 RLpred_transition(state,digit) = RLpred_state_table[state,digit+1];

gp_inline__location="../dragon.tex:68928";
 RLpred_transitions(s,v) = \
   for(i=1,#v, s=RLpred_transition(s,v[i])); s;
 RLpred_state_by_high_to_low(n) = RLpred_transitions(1,binary(n));
 RLpred(n) = RLpred_state_by_high_to_low(n) != 11;

gp_inline__location="../dragon.tex:68956";
 RLpred_endings0 = {[100,1011,11001,110010]};

gp_inline__location="../dragon.tex:68961";
 RLpred_endings1 = {[101,1100,11010,110011]};

gp_inline__location="../dragon.tex:68966";
 RLpred_endings2 = {[110,1101,11011,110100]};
 RLpred_endings = \
   concat([RLpred_endings0,RLpred_endings1,RLpred_endings2]);

gp_inline__location="../dragon.tex:68993";
 BlobN_other_vector = {[4,8,16,4]};
 BlobN_other(k) = BlobN(k) + vector_modulo(BlobN_other_vector,k);

gp_inline__location="../dragon.tex:69000";
 BlobN_other_samples = {[11,22,44,57,107,214,428,825]};

gp_inline__location="../dragon.tex:69037";
 BlobNend_offsets = {[9,3,6,12]};
 BlobNend_formula(k) = \
   4/5*2^k - 1/5*vector_modulo(BlobNend_offsets,k);
 BlobNend(k) = {
   k>=4 || error("BlobNend() is for k>=4");
   BlobNend_formula(k);
 }

gp_inline__location="../dragon.tex:69049";
 BlobNend_samples = {[11,25,50,100,203,409,818,1636,3275,6553]};

gp_inline__location="../dragon.tex:69064";
 BlobNend_binary_endings = [1, 10, 100,             1011];

gp_inline__location="../dragon.tex:69066";
 BlobNend_binary_vector(k) = {
   k>=4 || error();
   k--;
   concat(concat_repeat([1,1,0,0], k\4),
          digits(vector_modulo(BlobNend_binary_endings,k)));
 }

gp_inline__location="../dragon.tex:69079";
 BlobNend_samples_binary = {[1011,11001,110010,1100100,11001011]};

gp_inline__location="../dragon.tex:69090";
 gBlobNend_formula(x) = \
   + 4/5* 1/(1-2*x) - (3/10 - 9/10*x)/(1 + x^2) - 3/2/(1 - x);
 gBlobNend(x) = 1 - x - 2*x^2 - 4*x^3 + gBlobNend_formula(x);

gp_inline__location="../dragon.tex:69123";
 BlobSegments_limit = {2/5};

gp_inline__location="../dragon.tex:69129";
 BlobSegments_offsets = {[12,9,18,21]};

gp_inline__location="../dragon.tex:69134";
 BlobSegments_formula(k) = {
   BlobSegments_limit*2^k
     - 1/5*vector_modulo(BlobSegments_offsets,k);
 }
 BlobSegments(k) = if(k<4,0, BlobSegments_formula(k));

gp_inline__location="../dragon.tex:69148";
 BlobSegments_binary_endings= [100, 1011, 10110,            101111];

gp_inline__location="../dragon.tex:69150";
 BlobSegments_binary_vector(k) = {
   if(k<4, [],
      concat(concat_repeat([1,1,0,0], (k-4)\4),
             digits(vector_modulo(BlobSegments_binary_endings,k))));
 }

gp_inline__location="../dragon.tex:69162";
 BlobSegments_samples = {[0,0,0,0,4,11,22,47,100,203,406]};

gp_inline__location="../dragon.tex:69180";
 gBlobSegments(x) = \
   x^4 * (2/5*16/(1-2*x) + 1/5*(3+6*x)/(1+x^2) - 3/(1-x) );

gp_inline__location="../dragon.tex:69184";
 gBlobSegments_quadratic(x) = 1/5*(3+6*x)/(1+x^2) - 3/(1-x);

gp_inline__location="../dragon.tex:69203";
 BlobSegments_cancelled_initial = [ -2, -1, -2, -1];

gp_inline__location="../dragon.tex:69238";
 NonBlobSegments_initial = {[1,2,4,8,12]};

gp_inline__location="../dragon.tex:69245";
 NonBlobSegments(k) = {
   if(k<#NonBlobSegments_initial, NonBlobSegments_initial[k+1],
      6*k-13);
 }
 TotalBlobSegments(k) = \
   my(v=BlobList(k)); sum(j=1,#v,BlobSegments(v[j]));

gp_inline__location="../dragon.tex:69254";
 gNonBlobSegments(x) = 6*x^5*1/(1-x)^2 + 11*x^5/(1-x) \
   + 1 + 2*x + 4*x^2 + 8*x^3 + 12*x^4;

gp_inline__location="../dragon.tex:69261";
 NonBlobSegments_samples = {[1,2,4,8,12,17,23,29,35,41]};

gp_inline__location="../dragon.tex:69563";
 Bridge_after_k_limit = 4/5;

gp_inline__location="../dragon.tex:69580";
 BridgeLN(k) = BlobN(k) - vector_modulo([1,2],k);

gp_inline__location="../dragon.tex:69583";
 BridgeLN_samples = {[6,12,27,51,102,204,411,819]};

gp_inline__location="../dragon.tex:69594";
 BridgeRN(k) = BlobN(k) - vector_modulo([2,1],k);

gp_inline__location="../dragon.tex:69597";
 BridgeRN_samples = {[5,13,26,52,101,205,410,820]};

gp_inline__location="../dragon.tex:69612";
 BridgeLother_by_other(k) = {
   my(ao=dragon_n_to_arm_and_other(BridgeLN(k)));
   if(!(ao[1]==1),error("oops, BridgeLother_by_other()"));
   ao[2];
 }

gp_inline__location="../dragon.tex:69621";
 BridgeLother_vector = {[-2,-4,7,-1]};
 BridgeLother(k) = \
   2/15 * 2^k + 1/15*vector_modulo(BridgeLother_vector,k);

gp_inline__location="../dragon.tex:69646";
 BridgeRother_vector = {[-7,1,2,4]};
 BridgeRother(k) = \
   22/15 * 2^k + 1/15*vector_modulo(BridgeRother_vector,k);

gp_inline__location="../dragon.tex:69657";
 BridgeRother_samples = {[23,47,94,188,375,751,1502]};

gp_inline__location="../dragon.tex:69827";
 \\ locations z of left and right side bridge points
 BridgeRpoint(k) = dragon_point(BridgeRN(k));
 BridgeLpoint(k) = dragon_point(BridgeLN(k));

gp_inline__location="../dragon.tex:69845";
 BlobStart_generated_samples = [ -2+I*1,-3+I*-1,-2+I*-4,1+I*-6,6+I*-5,11+I*1,10+I*12,-1+I*22,-22+I*21,-43+I*-1,-42+I*-44,1+I*-86,86+I*-85,171+I*1,170+I*172,-1+I*342,-342+I*341 ];
 BlobEnd_generated_samples = [ -2+I*1,-3+I*-2,-1+I*-5,4+I*-6,10+I*-1,11+I*10,1+I*21,-20+I*22,-42+I*1,-43+I*-42,-1+I*-85,84+I*-86,170+I*-1,171+I*170,1+I*341,-340+I*342,-682+I*1 ];

gp_inline__location="../dragon.tex:69860";
 BlobStart(k) = 1/3*(conj(b)*b^k + boff(k));
 BlobStart_limit = 1/3 * conj(b);

gp_inline__location="../dragon.tex:69865";
 BlobStart_samples = {[-2+I,-3-I,-2-4*I,1-6*I,6-5*I,11+I,10+12*I]};

gp_inline__location="../dragon.tex:69895";
 BlobEnd(k) = 1/3*(2*b^k - I* boff(k-1));
 BlobEnd_limit   = 2/3;          \\ of middle biggest blob

gp_inline__location="../dragon.tex:69901";
 BlobEnd_samples = {[-2+I,-3-2*I,-1-5*I,4-6*I,10-I,11+10*I,1+21*I]};

gp_inline__location="../dragon.tex:69921";
 boff_vector_1 = {[2+I,1+3*I,-2+4*I,-3+2*I]};

gp_inline__location="../dragon.tex:69930";
 boff_vector_2 = {[-2-I,-1-3*I,2-4*I,3-2*I]};

gp_inline__location="../dragon.tex:69939";
 boff_vector = concat(boff_vector_1, boff_vector_2);
 boff(m) = vector_modulo(boff_vector,m);

gp_inline__location="../dragon.tex:69984";
 BlobStart_vector = {[0,0,1,1,0,0,-1,-1]};

gp_inline__location="../dragon.tex:69995";
 BlobEnd_vector = {[I,0,0,-I,-I,0,0,I]};

gp_inline__location="../dragon.tex:70080";
 BridgeDelta_by_difference(k) = BlobStart(k+1) - BlobEnd(k);

gp_inline__location="../dragon.tex:70083";
 BridgeDelta_vector_1 = {[1+2*I,-1+2*I,-2+I,-2-I]};

gp_inline__location="../dragon.tex:70092";
 BridgeDelta_vector_2 = {[-1-2*I,1-2*I,2-I,2+I]};

gp_inline__location="../dragon.tex:70101";
 BridgeDelta_vector \
   = concat(BridgeDelta_vector_1, BridgeDelta_vector_2);
 BridgeDelta(m) = vector_modulo(BridgeDelta_vector,m);

gp_inline__location="../dragon.tex:70187";
 BlobDelta(k) = BlobEnd(k) - BlobStart(k);
 BlobDelta_limit = 1/3 + 1/3*I;

gp_inline__location="../dragon.tex:70200";
 BlobDelta_samples = {[0,-I,1-I,3,4+4*I,9*I,-9+9*I,-19,-20-20*I]};

gp_inline__location="../dragon.tex:70220";
 oct_vector = [1,b,I,-conj(b), -1,-b,-I,conj(b)];

gp_inline__location="../dragon.tex:70223";
 oct(m) = vector_modulo(oct_vector,m);

gp_inline__location="../dragon.tex:70232";
 BlobDeltaLen_vector = {[4,5,5,7]};

gp_inline__location="../dragon.tex:70238";
 BlobDeltaLen(k) = \
   1/3*(2^ceil(k/2) - vector_modulo(BlobDeltaLen_vector,k));

gp_inline__location="../dragon.tex:70243";
 BlobDeltaLen_samples = {[0,1,1,3,4,9,9,19,20,41,41,83,84,169,169]};

gp_inline__location="../dragon.tex:70327";
 Delta_sum_k = {5};

gp_inline__location="../dragon.tex:70342";
 Delta_sum(k) = {
   + (-2+I)
   + sum(j=4,k, BlobDelta(j) + BridgeDelta(j))
   + I * (-2+I)
   + I * sum(j=4,k-2, BlobDelta(j) + BridgeDelta(j))
   - BridgeDelta(k);
 }

gp_inline__location="../dragon.tex:70374";
 cos_quarter(n) = {
   vector_modulo([  1,  1/2*sqrt2, 0, -1/2*sqrt2,
                   -1, -1/2*sqrt2, 0,  1/2*sqrt2 ], n);
 }
 sin_quarter(n) = {
   vector_modulo([ 0,  1/2*sqrt2,  1,  1/2*sqrt2,
                   0, -1/2*sqrt2, -1, -1/2*sqrt2 ], n);
 }

gp_inline__location="../dragon.tex:70388";
 Ngai_Nguyen_c(n) = {
   if(n>=1,
      [     1/3*sqrt2^(2*( -(n-1)/2 )) * cos_quarter(n-3),
        1 + 1/3*sqrt2^(2*( -(n-1)/2 )) * sin_quarter(n-3) ],
      n = -n;
      [     1/3*sqrt2^(2*( -(n-1)/2 )) * cos_quarter(n+3),
            1/3*sqrt2^(2*( -(n-1)/2 )) * sin_quarter(n+3) ]);
 }

gp_inline__location="../dragon.tex:70402";
 Ngai_Nguyen_c_z(n) = {
   if(n>=1,
      I*(1 - 1/3*conj(b)^(1-n)),
      n = -n;
           - 1/3*conj(b)^(1-n) );
 }

gp_inline__location="../dragon.tex:70498";
 Ngai_Nguyen_c_by_BlobStart_negative(k,n) = \
   I * conj(BlobStart(k+n)/b^k);

gp_inline__location="../dragon.tex:70512";
 Ngai_Nguyen_c_by_BlobEnd_negative(k,n) = \
   I * conj(BlobEnd(k-1+n)/b^k);

gp_inline__location="../dragon.tex:70530";
 Ngai_Nguyen_c_by_BlobStart_positive(k,n) = \
   I*conj(1 - I*BlobStart(k-n)/b^k);

gp_inline__location="../dragon.tex:70543";
 Ngai_Nguyen_c_by_BlobEnd_positive(k,n) = \
   I*conj(1 - I*BlobEnd(k-1-n)/b^k);

gp_inline__location="../dragon.tex:71017";
 GeomLength_by_blobs(k) = {
   NonBlobSegments(k)
   + vecsum(apply(j->geom_abs(BlobDelta(j)),
                  BlobList(k)));
 }

gp_inline__location="../dragon.tex:71037";
 GeomLength_formula(k) = {
   (1 + sqrt2) * sqrt2^k
   + (4 - 3/2*sqrt2) * k
   + vector_modulo([-8 + 2*sqrt2, -10 + 7/2*sqrt2],k);
 }
 GeomLength(k) = if(k<4,2^k, GeomLength_formula(k));

gp_inline__location="../dragon.tex:71056";
 GeomLength_samples = [1,2,4,8,12,18, \
   24+sqrt2, 34+sqrt2, 40+6*sqrt2, 58+6*sqrt2 ];

gp_inline__location="../dragon.tex:71100";
 GeomLength_limit = 1 + sqrt2;

gp_inline__location="../dragon.tex:71105";
 GeomLength_limit_sample = {(2414213/1000000)};

gp_inline__location="../dragon.tex:71157";
 GeomLengthRat_formula(k) = \
   2^ceil(k/2) + 4*k - vector_modulo([8, 10],k);
 GeomLengthRat(k) = if(k<4,2^k, GeomLengthRat_formula(k));

gp_inline__location="../dragon.tex:71164";
 GeomLengthRat_samples = {[1,2,4,8,12,18,24,34,40,58,64,98,104,170]};

gp_inline__location="../dragon.tex:71181";
 GeomLengthSqrt_formula(k) = 2^floor(k/2) - 3*floor(k/2) + 2;
 GeomLengthSqrt(k) = if(k<4,0, GeomLengthSqrt_formula(k));

gp_inline__location="../dragon.tex:71186";
 GeomLengthSqrt_samples = {[0,0,0,0,0,0,1,1,6,6,19,19,48,48]};

gp_inline__location="../dragon.tex:71230";
 \\ Rnear_point_data(k) returns [norm, n1, n2, ...]
 \\ which is the norm of the minimum distance to the middle
 \\ and the n point numbers which attain that minimum.
 Rnear_point_data(k) = {
   my(v = dragon_points(k));
   my(midpoint = b^k/2); v = apply(z->z-midpoint, v);
   my(l=List([]), min_norm = 2^k);
   for(i=1,#v,
       if(! Rpred(i-1), next());
       my(v_norm = norm(v[i]));
       if(v_norm <  min_norm,
            min_norm=v_norm;
            l=List([v_norm, i-1]),
          v_norm == min_norm,
            listput(l, i-1)));
   Vec(l);
 }
 Rnear_point_data = memoize(Rnear_point_data);
 Rnear_squared_by_points(k) = Rnear_point_data(k)[1];
 Rnear_by_points(k) = geom_sqrt_as_quad(Rnear_squared_by_points(k));
 RnearN_vector_by_points(k) = Rnear_point_data(k)[^1];

gp_inline__location="../dragon.tex:71252";
 /* Rnear_z(k) as offset from 1/2*b^k */
 Rnear_z_samples = [ -1/2, 1/2-1/2*I, 0, 0, \
                     0,    -1,        -I, 1-I, \
                     2, 3+2*I,       5*I, -5+5*I, \
                    -10, -11-10*I,  -21*I, 21-21*I ];
 Rnear_z(k) = {
   if(k<4, Rnear_z_samples[k+1]);
   1/6*b^k
   + 1/3*vector_modulo([-2, 1-2*I, -I, 1-I, 2, -1+2*I, I, -1+I],k);
 }

gp_inline__location="../dragon.tex:71264";
 hull_PQ_num_vertices(k) = if(k==0,4, k==1,5, k==2,7, k==3,9,  10);

gp_inline__location="../dragon.tex:71290";
 Rnear_formula(k) = {
   if(k%4==1, geom_sqrt_as_quad(Rnear_m(k)^2 + 1/2),
              Rnear_m(k));
 }
 Rnear(k) = if(k==0,1/2, Rnear_formula(k));

gp_inline__location="../dragon.tex:71300";
 gRnear_squared(x) = gRnear_m_squared(x) + 1/2*x / (1-x^4);

gp_inline__location="../dragon.tex:71316";
 Rnear_samples = {[
   1/2,
   1/2*sqrt2,
   0, 0, 0, 1,
   1,
   sqrt2,
   2,
   geom_sqrt_as_quad(13),
   5,
   5*sqrt2,
   10,
   geom_sqrt_as_quad(221)
 ]};

gp_inline__location="../dragon.tex:71346";
 gA241892(x) = {           \\ by R. J. Mathar in OEIS
   -x^2*(1 -2*x + 8*x^3)
   / ( (x-1)*(4*x-1)*(2*x+1)*(2*x-1)*(1+x) );
 }

gp_inline__location="../dragon.tex:71369";
 \\ adapted from code in A241892 by Kival Ngaokrajang
 A241892_by_ceil(n) = {
   if(n==0,return(0));
   n--;
   my(b=ceil(2*(2^n-1)/3),
      a=floor(b^2/2));
   if(Mod(n,2)==1, a=a+1);
   a;
 }

gp_inline__location="../dragon.tex:71399";
 Rnear_m(k) = \
   1/6*(sqrt2^k - vector_modulo([4, sqrt2, 2, 2*sqrt2],k));
 gRnear_m(x) = \
   1/6*( 1/(1-sqrt2*x) - Polrev([4, sqrt2, 2, 2*sqrt2])/(1-x^4) );
 gRnear_m_squared(x) = {
   (1/4 - 1/2*x - 5/4*x^4 + 3*x^5 + x^8)
   / (1 - 2*x - 5*x^4 + 10*x^5 + 4*x^8 - 8*x^9);
 }

gp_inline__location="../dragon.tex:71422";
 Rnear_m_samples = {[
   -1/2,
   0,0,0,0,
   1/2*sqrt2,
   1,
   sqrt2,
   2,
   5/2 * sqrt2,
   5,
   5*sqrt2,
   10
 ]};

gp_inline__location="../dragon.tex:71690";
 PQ1(k) = {
   k>=0 || error("PQ1 is for k>=0, got ",k);
   -1/3 * (b^(k+3) + pq(k+3));
 }
 PQ2(k) = {
   k>=0 || error("PQ2 is for k>=0, got ",k);
   -1/3 * (b^(k+2) + pq(k+2));
 }
 PQ10(k) = {
   k>=0 || error("PQ10 is for k>=0, got ",k);
   (  (4+I)*b^(k-1) +   pq(k)  ) /3;
 }

gp_inline__location="../dragon.tex:71704";
 pq(m) = I*p(m+2);

gp_inline__location="../dragon.tex:71706";
 pq_vector =  [2, 2-I, I, -1+I,   -2,   -2+I, -I, 1-I];

gp_inline__location="../dragon.tex:71711";
 PQ1_samples = vector(#gen_convex_hull_values_PQ-6,i, \
                 gen_convex_hull_values_PQ[i+6][1]);

gp_inline__location="../dragon.tex:71715";
 PQ2_samples = vector(#gen_convex_hull_values_PQ-6,i, \
                 gen_convex_hull_values_PQ[i+6][2]);

gp_inline__location="../dragon.tex:71719";
 PQ10_samples = vector(#gen_convex_hull_values_PQ-6,i, \
                 gen_convex_hull_values_PQ[i+6][10]);

gp_inline__location="../dragon.tex:71736";
 PQ5(k) = {
   k>=0 || error("PQ5 is for k>=0");
   -1/3 * (b^(k-1) + pq(k-1));
 }
 PQ6(k) = {
   k>=0 || error("PQ6 is for k>=0");
    1/3 * ( (2+I)*b^k  + I*pq(k+1));
 }
 PQ5a(k) = -I*PQ5(k);
 PQ6a(k) = -I*PQ6(k);
 PQ6a_sub_PQ5a_z(k) = (PQ6a(k) - PQ5a(k)) * conj(w8_times_sqrt2)^k;
 PQ6a_sub_PQ5a_re(k) = real(PQ6a_sub_PQ5a_z(k)) / sqrt2^k;

gp_inline__location="../dragon.tex:71755";
 PQ1b(k) = (1-I)*b^k - PQ1(k);
 PQ2b(k) = (1-I)*b^k - PQ2(k);
 PQ1b_distance(k) = -imag(PQ1b(k)*conj(w8_times_sqrt2)^k) / sqrt2^k;

gp_inline__location="../dragon.tex:71778";
 PQ7(k) = {
   k>=0 || error("PQ7 is for k>=0");
   (  (3+I)*b^k     + I*pq(k  )) /3;
 }

gp_inline__location="../dragon.tex:71787";
 PQ7c(k) = (1-I)*b^k + I*PQ7(k);

gp_inline__location="../dragon.tex:71795";
 Rnear_PQ7c_z(k) = (1/2*b^k - PQ7c(k)) * conj(w8_times_sqrt2)^k;
 Rnear_PQ7c_re(k) = real(Rnear_PQ7c_z(k))/sqrt2^k;
 Rnear_PQ7c_im(k) = imag(Rnear_PQ7c_z(k))/sqrt2^k;
 Rnear_squared_by_PQ7c(k) = Rnear_PQ7c_re(k)^2 + Rnear_PQ7c_im(k)^2;

gp_inline__location="../dragon.tex:71809";
 Rnear_m_by_BlobEnd(k) = {
   real( (BlobEnd(k) - 1/2*b^k)
         / w8_times_sqrt2^k )
   * sqrt2^k;
 }

gp_inline__location="../dragon.tex:71818";
 Rnear_z_by_BlobEnd(k) = {
   BlobEnd(k) - 1/2*b^k
   + vector_modulo([I,  0, -1, -1-I,
                   -I,  0,  1,  1+I,
                    I,  0, -1, -1-I,
                   -I,  0,  1,  1+I ],k);
 }

gp_inline__location="../dragon.tex:71845";
 Rnear_limit = 1/6;

gp_inline__location="../dragon.tex:71893";
 TRnear(k) = 2*Rnear(k+1);

gp_inline__location="../dragon.tex:71981";
 one_third_over_sqrt2_sample = {(0235702/1000000)};

gp_inline__location="../dragon.tex:72371";
 BlobB_recurrence_k = {10};
 BlobB_recurrence_terms = [2, -2, 4, -3, 2, -2];
 BlobB_recurrence_maker(f) = \
   (k)-> sum(i=1,#BlobB_recurrence_terms, \
       BlobB_recurrence_terms[i] * f(k-i));
 BlobB(k) = if(k < BlobB_recurrence_k, BlobB_samples[k+1], \
               BlobB_by_recurrence_formula(k));
 BlobB = memoize(BlobB);
 BlobB_by_recurrence_formula = BlobB_recurrence_maker(BlobB);

gp_inline__location="../dragon.tex:72383";
 BlobB_samples = {[0,0,0,0,4,10,20,38,68,122,212]};

gp_inline__location="../dragon.tex:72402";
 gBlobB(x) = x^4 * (4+2*x+8*x^2 + 2*x^3 + 4*x^4 + 4*x^5) \
                 / ( (1-x-2*x^3) * (1+x^2) * (1-x) );

gp_inline__location="../dragon.tex:72415";
 gBlobB_partial_fractions(x) = \
    4 + 2*x + 4*x^2 + 2*x^3 \
    + 2 / (1 - x - 2*x^3) \
    + 2*x / (1 + x^2) \
    -  6  / (1 - x);

gp_inline__location="../dragon.tex:72422";
 gBlobB_partial_fractions_x4(x) = \
    x^4 * ( (10 + 4*x + 12*x^2) / (1 - x - 2*x^3) \
           + 2*x / (1 + x^2) \
           -  6  / (1 - x) );

gp_inline__location="../dragon.tex:72471";
 dNonBlobSegments_initial = {[1,2,4,4,5]};

gp_inline__location="../dragon.tex:72477";
 dNonBlobSegments(k) = if(k<#dNonBlobSegments_initial, dNonBlobSegments_initial[k+1], 6);

gp_inline__location="../dragon.tex:72535";
 BlobB_by_alternating_4(k) = {
     (B(k)   - B(k-1))  - dNonBlobSegments(k-1)
   - (B(k-2) - B(k-3))  + dNonBlobSegments(k-3)
   + (B(k-4) - B(k-5))  - dNonBlobSegments(k-5)
   - (B(k-6) - B(k-7))  + dNonBlobSegments(k-7)
   + BlobB(k-8);
 }

gp_inline__location="../dragon.tex:72545";
 BlobB_by_alternating_expansion(k) = {
   my(total=0,s=1);
   while(k>=2,
        total += s * (B(k)-B(k-1));
        total -= s * 2*dNonBlobSegments(k-1);
        k-=2; s*=-1);
   if(BlobB(k)!=0,error("oops"));
   total;
 }

gp_inline__location="../dragon.tex:72580";
 BlobB_alternating_initial = {[2,2,2,6]};

gp_inline__location="../dragon.tex:72584";
 BlobB_alternating_periodic = {[6,4,6,8]};

gp_inline__location="../dragon.tex:72590";
 BlobB_by_alternating_B(k) = {
   sum(j=0,k, B(j)*vector_modulo([1,-1,-1,1], k-j))
   - if(k<4, BlobB_alternating_initial[k+1],
             vector_modulo(BlobB_alternating_periodic,k));
 }

gp_inline__location="../dragon.tex:72657";
 BlobB_by_JA_vector = {[4,2,4,6]};

gp_inline__location="../dragon.tex:72662";
 BlobB_by_JA(k) = 4*JA(k) - vector_modulo(BlobB_by_JA_vector,k);

gp_inline__location="../dragon.tex:72668";
 BlobB_by_dJA(k) = 2*dJA(k+2) - vector_modulo([6,4,6,8],k);

gp_inline__location="../dragon.tex:72748";
 BlobL_k = {8};

gp_inline__location="../dragon.tex:72752";
 BlobL_formula(k) = BlobL(k-4) + L(k-3);
 BlobL(k) = \
   if(k<BlobL_k, return(BlobL_samples[k+1])); \
   BlobL_formula(k);
 BlobL = memoize(BlobL);

gp_inline__location="../dragon.tex:72771";
 BlobL_by_recurrence_k = {11};
 BlobL_by_recurrence_formula(k) = {
         BlobL(k-1)
   + 2 * BlobL(k-3)
   +     BlobL(k-4)
   -     BlobL(k-5)
   - 2 * BlobL(k-7);
 }
 BlobL_by_recurrence(k) = {
   if(k<BlobL_by_recurrence_k,BlobL_samples[k+1],
      BlobL_by_recurrence_formula(k));
 }

gp_inline__location="../dragon.tex:72787";
 BlobL_samples = {[0,0,0,0,0,3,6,11,20,39,66,111,192]};

gp_inline__location="../dragon.tex:72812";
 gBlobL(x) = x^4 * (3*x + 3*x^2 + 5*x^3 + 3*x^4 + 4*x^5 + 2*x^6) / ( (1-x)*(1+x)*(1+x^2)*(1-x-2*x^3) );

gp_inline__location="../dragon.tex:72822";
 gBlobL_partial_fractions(x) = {
   2 + x + 2*x^2 + x^3
   - 5/2 * 1/(1 - x)
   - 1/4 * 1/(1 + x)
   + x/(1 + x^2)
   + 1/4* (3 - 2*x + 2*x^2)/(1 - x - 2*x^3); }

gp_inline__location="../dragon.tex:72830";
 gBlobL_quadratic_part(x) = {
   - 5/2 * 1/(1 - x)
   - 1/4 * 1/(1 + x)
   + x/(1 + x^2); }

gp_inline__location="../dragon.tex:72843";
 BlobR_k = {8};

gp_inline__location="../dragon.tex:72847";
 BlobR_formula(k) = BlobR(k-4) + L(k-1) - L(k-2) + L(k-3);
 BlobR(k) = \
   if(k<BlobR_k, return(BlobR_samples[k+1])); \
   BlobR_formula(k);
 BlobR = memoize(BlobR);

gp_inline__location="../dragon.tex:72856";
 BlobR_by_recurrence_k = {11};

gp_inline__location="../dragon.tex:72862";
 BlobR_by_recurrence_formula(k) = {
         BlobR(k-1)
   + 2 * BlobR(k-3)
   +     BlobR(k-4)
   -     BlobR(k-5)
   - 2 * BlobR(k-7);
 }
 BlobR_by_recurrence(k) = {
   if(k<BlobR_by_recurrence_k,BlobR_samples[k+1],
      BlobR_by_recurrence_formula(k));
 }

gp_inline__location="../dragon.tex:72874";
 BlobR_samples = {[0,0,0,0,4,7,14,27,48,83,146,247,420]};

gp_inline__location="../dragon.tex:72898";
 gBlobR(x) = {
   x^4 * (4 + 3*x + 7*x^2 + 5*x^3 + 3*x^4 + 4*x^5 + 2*x^6)
   / (1 - x - 2*x^3 - x^4 + x^5 + 2*x^7);
 }

gp_inline__location="../dragon.tex:72912";
 gBlobR_partial_fractions(x) = {
   2 + x + 2*x^2 + x^3
   - 7/2 * 1/(1 - x)
   + 1/4 * 1/(1 + x)
   + x/(1 + x^2)
   + 1/4 * (5 + 2*x - 2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:72941";
 L_from_Blob_R_L(k) = {
   k>=0 || error("L_from_Blob_R_L() is for k>=0");
   sum(j=4,k,BlobL(j)) + sum(j=4,k-2,BlobR(j)) + NonBlobSegments(k);
 }

gp_inline__location="../dragon.tex:72956";
 R_from_Blob_R_L(k) = {
   k>=0 || error("R_from_Blob_R_L() is for k>=0");
   sum(j=4,k,BlobR(j)) + sum(j=4,k-2,BlobL(j)) + NonBlobSegments(k);
 }

gp_inline__location="../dragon.tex:73025";
 BlobL_by_unsimplified_recurrence(k) = \
   BlobL(k-4) + (L(k) - L(k-1)) - (R(k-2) - R(k-3));

gp_inline__location="../dragon.tex:73058";
 BlobR_by_unsimplified_recurrence(k) = \
   BlobR(k-4) + (R(k) - R(k-1)) - (L(k-2) - L(k-3));

gp_inline__location="../dragon.tex:73101";
 gBlobR_from_BlobB(x) = {
   3/4*gBlobB(x) - 1/4*gBlobB(x)/x + 1/8*gBlobB(x)/x^2
   + 1/4 * 1/(1 - x)
   + 1/4 * 1/(1 + x)
   + (1/2 - 1/4*x)/(1 + x^2)
   - 1 + 1/4*x - 1/2*x^2 - 1/2*x^3;
 }

gp_inline__location="../dragon.tex:73113";
 gBlobL_from_BlobB(x) = {
   1/4*gBlobB(x) + 1/4*gBlobB(x)/x - 1/8*gBlobB(x)/x^2
   - 1/4 * 1/(1 - x)
   - 1/4 * 1/(1 + x)
   + (-1/2 + 1/4*x)/(1 + x^2)
   + 1 - 1/4*x + 1/2*x^2 + 1/2*x^3;
 }

gp_inline__location="../dragon.tex:73130";
 BlobR_from_BlobB_vector = {[1,-(1)/(4),0,(1)/(4)]};
 BlobR_from_BlobB(k) = {
   if(k<4,return(0));
   3/4*BlobB(k) - 1/4*BlobB(k+1) + 1/8*BlobB(k+2)
   + vector_modulo(BlobR_from_BlobB_vector,k);
 }

gp_inline__location="../dragon.tex:73148";
 BlobL_from_BlobB_vector = {[1,-(1)/(4),0,(1)/(4)]};
 BlobL_from_BlobB(k) = {
   if(k<4,return(0));
   1/4*BlobB(k) + 1/4*BlobB(k+1) - 1/8*BlobB(k+2)
   - vector_modulo(BlobL_from_BlobB_vector,k);
 }

gp_inline__location="../dragon.tex:73172";
 BlobR_over_BlobB_limit = 3/4 - 1/4*r + 1/8*r^2;

gp_inline__location="../dragon.tex:73175";
 BlobR_over_BlobB_sample = {(0685486/1000000)};

gp_inline__location="../dragon.tex:73182";
 BlobR_over_BlobB_limit_nfelt = \
   3/4*one_nfelt - 1/4*r_nfelt + 1/8*r_squared_nfelt;

gp_inline__location="../dragon.tex:73193";
 BlobL_over_BlobB_limit = 1/4 + 1/4*r - 1/8*r^2;
 BlobL_over_BlobB_limit_nfelt = \
   1/4*one_nfelt + 1/4*r_nfelt - 1/8*r_squared_nfelt;

gp_inline__location="../dragon.tex:73206";
 BlobL_over_BlobB_sample = {(0314513/1000000)};

gp_inline__location="../dragon.tex:73300";
 BlobBQ_recurrence_k = {10};
 BlobBQ_formula(k) = \
   BlobBQ(k-1) - BlobBQ(k-2) + 3*BlobBQ(k-3) + 2*BlobBQ(k-5);
 BlobBQ(k) = \
   if(k<BlobBQ_recurrence_k,BlobBQ_samples[k+1], BlobBQ_formula(k));
 BlobBQ = memoize(BlobBQ);

gp_inline__location="../dragon.tex:73309";
 BlobBQ_samples = {[0,0,0,0,4,8,13,22,37,64,109,182,309]};

gp_inline__location="../dragon.tex:73327";
 gBlobBQ(x) = {
   -1 - 2*x - x^2 - 2*x^3 - x^4
   + x/(1 + x^2)
   + 1/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:73393";
 BQ_from_BlobList(k) = my(v=BlobList(k)); \
   sum(j=1,#v, BlobBQ(v[j])) + NonBlobBQ(k);

gp_inline__location="../dragon.tex:73399";
 NonBlobBQ_samples = {[2,3,5,9,11,13]};

gp_inline__location="../dragon.tex:73405";
 NonBlobBQ(k) = if(k<#NonBlobBQ_samples,NonBlobBQ_samples[k+1], 14);

gp_inline__location="../dragon.tex:73414";
 dNonBlobBQ_by_diff(k) = NonBlobBQ(k+1) - NonBlobBQ(k);
 dNonBlobBQ_vector = [1,2,4,2,2,1];
 dNonBlobBQ(k) = if(k<#dNonBlobBQ_vector,dNonBlobBQ_vector[k+1], 0);

gp_inline__location="../dragon.tex:73422";
 BlobBQ_from_BQ_recurrence(k) = \
   BQ(k)-BQ(k-1) - BlobBQ(k-2) - dNonBlobBQ(k-1);

gp_inline__location="../dragon.tex:73434";
 BlobBQ_by_dJA(k) = dJA(k+2) + vector_modulo([0,1,0,-1],k);

gp_inline__location="../dragon.tex:73452";
 BlobLQ_recurrence_k = {11};
 BlobLQ_formula(k) = \
   2*BlobLQ(k-3) + 3*BlobLQ(k-4) + 2*BlobLQ(k-5) + 2*BlobLQ(k-6);
 BlobLQ(k) = \
   if(k<BlobLQ_recurrence_k,BlobLQ_samples[k+1], BlobLQ_formula(k));
 BlobLQ = memoize(BlobLQ);

gp_inline__location="../dragon.tex:73461";
 BlobLQ_samples = {[0,0,0,0,0,3,4,7,11,21,34,57,97]};

gp_inline__location="../dragon.tex:73480";
 gBlobLQ(x) = {
   -x - x^3 - x^4
   - 3/8 * 1/(1 + x)
   + 1/2*x/(1 + x^2)
   + 1/8 * (3 - 2*x + 2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:73495";
 BlobRQ_recurrence_k = {10};
 BlobRQ_formula(k) = \
   2*BlobRQ(k-3) + 3*BlobRQ(k-4) + 2*BlobRQ(k-5) + 2*BlobRQ(k-6);
 BlobRQ(k) = \
   if(k<BlobRQ_recurrence_k,BlobRQ_samples[k+1], BlobRQ_formula(k));
 BlobRQ = memoize(BlobRQ);

gp_inline__location="../dragon.tex:73504";
 BlobRQ_samples = {[0,0,0,0,4,5,9,15,26,43,75,125,212]};

gp_inline__location="../dragon.tex:73524";
 gBlobRQ(x) = {
   -1 - x - x^2 - x^3
   + 3/8 * 1/(1 + x)
   + 1/2*x/(1 + x^2)
   + 1/8 * (5 + 2*x - 2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:73535";
 BlobLQ_by_LQ_RQ(k) = \
   LQ(k)-LQ(k-1) - (RQ(k-2)-RQ(k-3)) + BlobLQ(k-4);
 BlobRQ_by_RQ_LQ(k) = \
   RQ(k)-RQ(k-1) - (LQ(k-2)-LQ(k-3)) + BlobRQ(k-4);

gp_inline__location="../dragon.tex:73549";
 BlobB_to_BlobBQ_offset_vector = {[0,0,0,0,4]};

gp_inline__location="../dragon.tex:73557";
 BlobB_to_BlobBQ_offset(k) = {
   if(k < #BlobB_to_BlobBQ_offset_vector,
      BlobB_to_BlobBQ_offset_vector[k+1],
      6);
 }
 BlobB_from_BlobBQ(k) = 2*BlobBQ(k) - BlobB_to_BlobBQ_offset(k);

gp_inline__location="../dragon.tex:73572";
 BlobL_to_BlobLQ_offset(k) = if(k<=4,0, vector_modulo([2,3],k));
 BlobL_from_BlobLQ(k) = 2*BlobLQ(k) - BlobL_to_BlobLQ_offset(k);

gp_inline__location="../dragon.tex:73583";
 BlobR_to_BlobRQ_offset(k) = \
   if(k<=3,0, vector_modulo([4,3],k));
 BlobR_from_BlobRQ(k) = 2*BlobRQ(k) - BlobR_to_BlobRQ_offset(k);

gp_inline__location="../dragon.tex:73686";
 PreBlobRQ(k) = {
   k>=4 || error("PreBlobRQ() is for k>=4");
   4 + sum(j=4,k-1, BlobRQ(j));
 }

gp_inline__location="../dragon.tex:73694";
 PreBlobRQ_by_BlobRQ_constants = {[-1,1,0,1]};

gp_inline__location="../dragon.tex:73707";
 PreBlobRQ_samples = {[4,8,13,22,37,63,106,181,306,518]};

gp_inline__location="../dragon.tex:73714";
 gPreBlobRQ(x) = {
   -x - 2*x^2 - 3*x^3
   + 1/8/(1 - x) - 3/16/(1 + x) + (-1/4 - 1/4*x)/(1 + x^2)
   + (5/16 + 5/8*x + 7/8*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:73728";
 PreBlobLQ(k) = {
   k>=4 || error("PreBlobLQ() is for k>=4");
   3 + sum(j=4,k-1, BlobLQ(j));
 }

gp_inline__location="../dragon.tex:73739";
 PreBlobLQ_by_BlobLQ_constants = {[0,-1,1,-1]};

gp_inline__location="../dragon.tex:73751";
 PreBlobLQ_samples = {[3,3,6,10,17,28,49,83,140,237]};

gp_inline__location="../dragon.tex:73760";
 gPreBlobLQ(x) = {
   -x^2 - x^3 + x^4
   - 1/8/(1 - x) + 3/16/(1 + x) + (-1/4 - 1/4*x)/(1 + x^2)
   + (3/16 + 3/8*x + 1/8*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:73778";
 PreBlobBQ(k) = PreBlobLQ(k) + PreBlobRQ(k);

gp_inline__location="../dragon.tex:73786";
 PreBlobBQ_by_BlobBQ_constants = {[-1,0,1,0]};

gp_inline__location="../dragon.tex:73802";
 PreBlobBQ_by_JA_constants = {[0,0,1,1]};

gp_inline__location="../dragon.tex:73813";
 PreBlobBQ_samples = {[7,11,19,32,54,91,155,264,446,755]};

gp_inline__location="../dragon.tex:73822";
 gPreBlobBQ(k) = {
   -x - 3*x^2 - 4*x^3 + x^4
   + (-1/2 - 1/2*x)/(1 + x^2)
   + (1/2 + x + x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:73994";
 BlobA(k) = sum(j=0,k, vector_modulo([1,-1,-1,1],j)*A(k-j));
 BlobA = memoize(BlobA);

gp_inline__location="../dragon.tex:73997";
 BlobCount_by_BlobA_non_zero(k) = \
   my(v=BlobList(k)); sum(j=1,#v, BlobA(v[j])>0);

gp_inline__location="../dragon.tex:74015";
 BlobA_recurrence_k = {6};
 BlobA_recurrence_terms = [3, -3, 5, -6, 2, -4];
 BlobA_recurrence_maker(f) = \
   (k)-> sum(i=1,#BlobA_recurrence_terms, \
             BlobA_recurrence_terms[i] * f(k-i));
 BlobA_by_recurrence_formula = BlobA_recurrence_maker(BlobA);
 BlobA_by_recurrence(k) = \
   if(k < BlobA_recurrence_k, BlobA(k), \
      BlobA_by_recurrence_formula(k));

gp_inline__location="../dragon.tex:74028";
 BlobA_samples = {[0,0,0,0,1,3,6,14,33,71,150]};

gp_inline__location="../dragon.tex:74047";
 gBlobA(x) = x^4/((1+x^2)*(1-2*x)*(1-x-2*x^3));

gp_inline__location="../dragon.tex:74059";
 gBlobA_quadratic(x) = (3+x)/(1+x^2);

gp_inline__location="../dragon.tex:74069";
 A_from_BlobList(k) = my(v=BlobList(k)); sum(j=1,#v, BlobA(v[j]));

gp_inline__location="../dragon.tex:74163";
 BlobA_by_AL(k) = {
   my(total=0,s=1);
   forstep(j=k,0,-2, total+=s*AL(j); s*=-1);
   total;
 }

gp_inline__location="../dragon.tex:74199";
 gBlobA_quadratic_samples = {[3,1,-3,-1,3,1,-3,-1,3,1,-3,-1]};

gp_inline__location="../dragon.tex:74230";
 BlobA_by_dJA_vector = {[3,1,-3,-1]};

gp_inline__location="../dragon.tex:74245";
 BlobA_by_JA_vector = {[1,2,4,3]};

gp_inline__location="../dragon.tex:74281";
 BlobAf(n) = 1/5*1/2^n;

gp_inline__location="../dragon.tex:74299";
 A_fractal = 1/2;

gp_inline__location="../dragon.tex:74353";
 BlobAL(k) = \
   sum(j=0,k, vector_modulo([AL(j), -AL(j), -AR(j), AR(j)], k-j));
 BlobAL = memoize(BlobAL);

gp_inline__location="../dragon.tex:74374";
 BlobAL_recurrence_k = {8};
 BlobAL_recurrence_terms = [3, -2, 2, -3, -3, 2, -2, 4];
 BlobAL_recurrence_maker(f) = \
   (k)-> sum(i=1,#BlobAL_recurrence_terms, \
       BlobAL_recurrence_terms[i] * f(k-i));
 BlobAL_by_recurrence_formula = BlobAL_recurrence_maker(BlobAL);
 BlobAL_by_recurrence(k) = \
   if(k < BlobAL_recurrence_k, BlobAL_samples[k+1], \
      BlobAL_by_recurrence_formula(k));

gp_inline__location="../dragon.tex:74387";
 BlobAL_samples = {[0,0,0,0,1,2,4,9,20,41,85,176,361,736,1498]};

gp_inline__location="../dragon.tex:74406";
 gBlobAL(x) = x^4 * (1 - x - x^3) \
   /( (1-x)*(1+x)*(1+x^2)*(1-2*x)*(1-x-2*x^3));

gp_inline__location="../dragon.tex:74422";
 gBlobAL_partial_fractions(x) = \
   - 1/8*  1/(1 - x) \
   + 1/16* 1/(1 + x) \
   + 1/20* (3 + x)/(1 + x^2) \
   + 1/10* 1/(1 - 2*x) \
   - 1/16* (3 - 2*x + 2*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:74444";
 BlobAR(k) = \
   sum(j=0,k, vector_modulo([AR(j), -AR(j), -AL(j), AL(j)], k-j));
 BlobAR = memoize(BlobAR);

gp_inline__location="../dragon.tex:74453";
 BlobAR_recurrence_k = {8};

gp_inline__location="../dragon.tex:74457";
 BlobAR_by_recurrence_formula = BlobAL_recurrence_maker(BlobAR);
 BlobAR_by_recurrence(k) = {
   if(k<BlobAR_recurrence_k, BlobAR(k),
      BlobAR_by_recurrence_formula(k));
 }

gp_inline__location="../dragon.tex:74466";
 BlobAR_samples = {[0,0,0,0,0,1,2,5,13,30,65,142,304,639,1332]};

gp_inline__location="../dragon.tex:74483";
 gBlobAR(x) = x^5 * (1 - x + x^2) \
                 /( (1-x)*(1+x)*(1+x^2)*(1-2*x)*(1-x-2*x^3));

gp_inline__location="../dragon.tex:74499";
 gBlobAR_partial_fractions(x) = \
     1/8*  1/(1 - x) \
   - 1/16* 1/(1 + x) \
   + 1/20* (3 + x)/(1 + x^2) \
   + 1/10* 1/(1 - 2*x) \
   - 1/16* (5 + 2*x - 2*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:74630";
 BlobAL_from_AL_coefficients = {[+1,-1,0,-1]};

gp_inline__location="../dragon.tex:74638";
 BlobAL_from_AL(k) = \
  sum(j=0,k, AL(k-j)*vector_modulo(BlobAL_from_AL_coefficients,j));

gp_inline__location="../dragon.tex:74649";
 BlobAR_from_AL_coefficients = {[0,+1,-1,+1]};

gp_inline__location="../dragon.tex:74654";
 BlobAR_from_AL(k) = \
  sum(j=0,k, AL(k-j)*vector_modulo(BlobAR_from_AL_coefficients,j));

gp_inline__location="../dragon.tex:74673";
 BlobAL_from_AR_coefficients = {[-2,+1,-1,+2]};

gp_inline__location="../dragon.tex:74682";
 BlobAL_from_AR(k) = {
   AR(k+1) +
   sum(j=0,k, AR(j)*vector_modulo(BlobAL_from_AR_coefficients,k-j));
 }

gp_inline__location="../dragon.tex:74699";
 BlobAR_from_AR_coefficients = {[+1,-2,+2,-1]};

gp_inline__location="../dragon.tex:74706";
 BlobAR_from_AR(k) = \
   sum(j=0,k, AR(k-j)*vector_modulo(BlobAR_from_AR_coefficients,j));

gp_inline__location="../dragon.tex:74711";
 BlobAR_from_AR_recurrence(k) = \
   AR(k) - 2*AR(k-1) + 2*AR(k-2) - AR(k-3) + BlobAR(k-4);

gp_inline__location="../dragon.tex:74730";
 BlobAL_by_2pow_vector = {[1,-3,4,3]};

gp_inline__location="../dragon.tex:74736";
 BlobAL_by_2pow_formula(k) = {
   1/10*2^k
   - 1/10*vector_modulo(BlobAL_by_2pow_vector,k)
   - 1/2*BlobLQ(k);
 }
 BlobAL_by_2pow(k) = if(k==4,1, BlobAL_by_2pow_formula(k));

gp_inline__location="../dragon.tex:74753";
 BlobAR_by_2pow_vector = {[4,3,1,-3]};

gp_inline__location="../dragon.tex:74757";
 BlobAR_by_2pow(k) = {
   1/10*2^k
   + 1/10*vector_modulo(BlobAR_by_2pow_vector,k)
   - 1/2*BlobRQ(k);
 }

gp_inline__location="../dragon.tex:74780";
 BlobAL_sub_BlobAR_formula(k) = \
   BlobLQ(k-1) - vector_modulo([0,0,1,0],k);
 BlobAL_sub_BlobAR(k) = \
   if(k<4,0, k==4,1, k==5,1, BlobAL_sub_BlobAR_formula(k));

gp_inline__location="../dragon.tex:74791";
 BlobAL_sub_BlobAR_samples = {[0,0,0,0,1,1,2,4,7,11,20,34,57,97,166]};

gp_inline__location="../dragon.tex:74945";
 BlobA_from_join(k) = \
   JA(k-1) + BlobA(k-1) + 2*sum(j=0,k-3, BlobA(j));

gp_inline__location="../dragon.tex:74956";
 BlobAL_from_join(k) = \
   JA(k-1) + BlobAR(k-1) + sum(j=0,k-3, BlobA(j));

gp_inline__location="../dragon.tex:75221";
 JAblobRQ(k) = {
   k>=6 || error("JAblobRQ() is for k>=6");
   JA(k) - PreBlobRQ(k-2);
 }

gp_inline__location="../dragon.tex:75226";
 JAblobRQ_samples = {[2,3,5,9,17,28,48,82,140,237]};

gp_inline__location="../dragon.tex:75238";
 gJAblobRQ(x) = {
   1/2 + x
   -5/8/(1 - x) + 3/16/(1 + x) - (1/4 + 1/4*x)/(1 + x^2)
   + (3/16 - 1/8*x + 1/8*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:75261";
 JAblobRQ_constants = {[14,11,5,5]};

gp_inline__location="../dragon.tex:75284";
 JAblobRQ_limit = 1/14*(4 - 2*r + 3*r^2);
 JAblobRQ_nfelt = \
   1/14*( 4*one_nfelt - 2*r_nfelt + 3*r_squared_nfelt );
 JAblobRQ_limit_sample = {(0659581/1000000)};

gp_inline__location="../dragon.tex:75423";
 BlobRQ_sub_JAblobRQ_sub_1(k) = BlobRQ(k) - JAblobRQ(k+2) - 1;

gp_inline__location="../dragon.tex:75425";
 BlobRQ_sub_JAblobRQ_sub_1_samples = {[1,1,3,5,8,14,26,42,71,123]};

gp_inline__location="../dragon.tex:75435";
 gBlobRQ_sub_JAblobRQ_sub_1(x) = {
   -3/8/(1 - x) + 3/16/(1 + x) + (-1/4 + 1/4*x)/(1 + x^2)
   + (7/16 - 1/8*x - 3/8*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:75543";
 gen_blob_parts_start = 6 + I*-5;

gp_inline__location="../dragon.tex:75545";
 gen_blob_parts_end = 10 + I*-1;

gp_inline__location="../dragon.tex:75696";
 BlobPartsTstartf = {3/4-1/4*I};

gp_inline__location="../dragon.tex:75700";
 BlobPartsTstart(k) = BlobPartsTstartf * b^k;

gp_inline__location="../dragon.tex:75706";
 BlobPartsTendf = {1/2-1/2*I};

gp_inline__location="../dragon.tex:75710";
 BlobPartsTend(k) = BlobPartsTendf * b^k;

gp_inline__location="../dragon.tex:75996";
 BlobPartsAoriginf = {1/4-1/4*I};

gp_inline__location="../dragon.tex:76002";
 BlobPartsAorigin(k) = BlobPartsAoriginf * b^k;

gp_inline__location="../dragon.tex:76006";
 BlobPartsBoriginf = {1/2};

gp_inline__location="../dragon.tex:76010";
 BlobPartsBorigin(k) = BlobPartsBoriginf * b^k;

gp_inline__location="../dragon.tex:76140";
 BlobPartsMoriginf = {3/4-1/4*I};

gp_inline__location="../dragon.tex:76146";
 BlobPartsMorigin(k) = BlobPartsMoriginf * b^k;

gp_inline__location="../dragon.tex:76337";
 BlobSegments_by_parts(k) = \
   BlobSegments(k-2) + 2*BlobSegments(k-4) + 2^(k-2) + 6;

gp_inline__location="../dragon.tex:76344";
 \\ number of segments in twindragon k
 TwinSegments(k) = 4*2^k;

gp_inline__location="../dragon.tex:76364";
 BlobA_by_parts(k) = {
   BlobA(k-2) + 2*BlobA(k-4) + TA(k-4)
   + 3*LQ(k-8) + 4*RQ(k-8)
   + JA(k-8)
   + JA(k-7);
 }

gp_inline__location="../dragon.tex:76396";
 BlobA_by_parts_BQ(k) = BlobA(k-2) + 2*BlobA(k-4) + TA(k-4) \
                       + 4*BQ(k-8) -1;

gp_inline__location="../dragon.tex:76418";
 BlobA_by_parts_2(k) = \
   BlobA(k-2) + 2*BlobA(k-4)  + 2^(k-3) - dJA(k-1);

gp_inline__location="../dragon.tex:76443";
 BlobAL_by_parts(k) = BlobAR(k-2) + 2*BlobAL(k-4) + 2^(k-4);

gp_inline__location="../dragon.tex:76458";
 BlobAR_by_parts(k) = BlobAL(k-2) + 2*BlobAR(k-4) + 2*A(k-4) \
                    + 3*LQ(k-8) + 4*RQ(k-8) \
                    + JA(k-8) \
                    + JA(k-7);
 gBlobAR_by_parts_extras(x) = \
   3*gLQ(x)*x^8 + 4*gRQ(x)*x^8 + gJA(x)*x^8 + gJA(x)*x^7;

gp_inline__location="../dragon.tex:76472";
 BlobAR_by_parts2(k) = \
   BlobAL(k-2) + 2*BlobAR(k-4)  + 2^(k-4) - dJA(k-1);

gp_inline__location="../dragon.tex:76672";
 to_blob_01(z) = (z - BlobStart_limit) / BlobDelta_limit;

gp_inline__location="../dragon.tex:77025";
 MidMNs_limit = {(7)/(10)};

gp_inline__location="../dragon.tex:77030";
 MidMNs_vector = {[-1,-2,-4,7]};
 MidMNs(k) = \
   MidMNs_limit*2^k + 1/5*vector_modulo(MidMNs_vector,k);

gp_inline__location="../dragon.tex:77037";
 MidMNs_samples = {[22,44,91,179,358,716,1435]};

gp_inline__location="../dragon.tex:77060";
 MidSN_limit = {(13)/(30)};

gp_inline__location="../dragon.tex:77065";
 MidSN_vector = {[1,2,4,-7]};
 MidSN(k) = \
   MidSN_limit*2^k + 1/15*vector_modulo(MidSN_vector,k);

gp_inline__location="../dragon.tex:77076";
 MidSN_samples = {[14,28,55,111,222,444,887]};

gp_inline__location="../dragon.tex:77095";
 MidMNe_limit = {(7)/(10)};

gp_inline__location="../dragon.tex:77100";
 MidMNe_vector = {[4,-7,1,2]};
 MidMNe(k) = \
   MidMNe_limit*2^k + 1/5*vector_modulo(MidMNe_vector,k);

gp_inline__location="../dragon.tex:77107";
 MidMNe_samples = {[21,45,90,180,357,717,1434]};

gp_inline__location="../dragon.tex:77130";
 MidEN_limit = {(23)/(30)};

gp_inline__location="../dragon.tex:77135";
 MidEN_vector = {[-4,7,-1,-2]};
 MidEN(k) = \
   MidEN_limit*2^k + 1/15*vector_modulo(MidEN_vector,k);

gp_inline__location="../dragon.tex:77146";
 MidEN_samples = {[25,49,98,196,393,785,1570]};

gp_inline__location="../dragon.tex:77518";
 MidTA(k) = my(ret=0); forstep(i=k-4,0,-2, ret += TA(i)); ret;

gp_inline__location="../dragon.tex:77522";
 MidBlobA(k) = my(ret=0); forstep(i=k-4,0,-2, ret += BlobA(i)); ret;

gp_inline__location="../dragon.tex:77526";
 MidA(k) = 2*MidBlobA(k) + MidTA(k);

gp_inline__location="../dragon.tex:77530";
 MidA_shortfall(k) = BlobA(k) - MidA(k);

gp_inline__location="../dragon.tex:77538";
 gMidA_shortfall(x) = {
   -1/2 - x
   + 5/4/(1 - x) - 1/4/(1 + x)
   - 1/2/(1 - x)^2
   + 1/2*x/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:77550";
 BlobTAlist(k) = {
   if(k<4,return([]));
   my(t=vector(k-4+1));
   t[k-4  +1]=1;
   my(s=BlobTAlist(k-2));
   for(i=1,#s, t[i]+=s[i]);
   my(s=BlobTAlist(k-4));
   for(i=1,#s, t[i]+=2*s[i]);
   t;
 }
 BlobTAlist = memoize(BlobTAlist);

gp_inline__location="../dragon.tex:77956";
 BlobTA_by_recurrence(k) = \
   if(k<4,0, BlobTA(k-2) + 2*BlobTA(k-4) + TA(k-4));

gp_inline__location="../dragon.tex:77963";
 BlobTA_half = {[2/3,5/6]};

gp_inline__location="../dragon.tex:77969";
 BlobTA_const = {[2,1,1,2]};

gp_inline__location="../dragon.tex:77976";
 BlobTA(k) = {
   if(k<4,return(0));
   BlobA(k)
   - 2 * RQ(k-4)
   + vector_modulo(BlobTA_half,k) * 2^floor(k/2)
   - 1/3*vector_modulo(BlobTA_const,k);
  }

gp_inline__location="../dragon.tex:77987";
 BlobTA_samples = {[0,0,0,0,1,2,5,10,25,54,121,258,561,1182]};

gp_inline__location="../dragon.tex:78009";
 BlobTAdiff_half = {[2/3,5/6]};

gp_inline__location="../dragon.tex:78015";
 BlobTAdiff_const = {[2,1,1,2]};

gp_inline__location="../dragon.tex:78019";
 BlobTAdiff(k) = {
   if(k<4,return(0));
   2 * RQ(k-4)
   - vector_modulo(BlobTAdiff_half,k) * 2^floor(k/2)
   + 1/3*vector_modulo(BlobTAdiff_const,k);
  }

gp_inline__location="../dragon.tex:78030";
 BlobTAdiff_samples = {[0,0,0,0,0,1,1,4,8,17,29,60,104,193]};

gp_inline__location="../dragon.tex:78055";
 gBlobTA(x) = {
   x^4 * ( 1 - 2*x + x^2 - 2*x^3 + 4*x^4 )
   /(   (1 - x)
      * (1 - 2*x)
      * (1 + x^2)
      * (1 - 2*x^2)
      * (1 - x - 2*x^3) );
 }

gp_inline__location="../dragon.tex:78066";
 gBlobTA_partial(x) = {
   -1/2/(1 - x)
   + 1/5/(1 - 2*x)
   + (2/15 + 4/15*x)/(1 + x^2)
   + (2/3 + 5/6*x)/(1 - 2*x^2)
   + (-1/2 - 1/2*x - 1/2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:78102";
 BlobTnum_by_recurrence(k) = \
   if(k<4,0, BlobTnum(k-2) + 2*BlobTnum(k-4) + 1);

gp_inline__location="../dragon.tex:78108";
 BlobTnum(k) = floor( 1/3*2^floor(k/2) );

gp_inline__location="../dragon.tex:78112";
 BlobTnum_by_modulo(k) = \
   1/3*(2^floor(k/2) - vector_modulo([1, 1, 2, 2],k));

gp_inline__location="../dragon.tex:78118";
 BlobTnum_samples = {[0,0,0,0,1,1,2,2,5,5,10,10,21,21]};

gp_inline__location="../dragon.tex:78147";
 BlobAcl_generated_samples = \
   [0,1,3/2,5,7,16,69/2,76,140,295,1231/2,1275,2537];
 BlobAcr_generated_samples = \
   [1,2,9/2,9,26,55,231/2,242,525,1080,4429/2,4523,9288];

gp_inline__location="../dragon.tex:78210";
 BlobAcl_initial_k = {4};

gp_inline__location="../dragon.tex:78217";
 BlobAcl_multiply = {[1,1,2,2]};

gp_inline__location="../dragon.tex:78223";
 BlobAcl_constant = {[-59,17,-101,-67]};

gp_inline__location="../dragon.tex:78231";
 BlobAcl_formula(k) = {
   2/45 * 2^k
   + 1/9 * vector_modulo(BlobAcl_multiply,k) * 2^ceil(k/2)
   + 1/90 * vector_modulo(BlobAcl_constant,k)
   - 1/2* BlobLQ(k);
 }
 BlobAcl(k) = if(k<=BlobAcl_initial_k,0, BlobAcl_formula(k));

gp_inline__location="../dragon.tex:78244";
 BlobAcl_samples = {[0,0,0,0,0,1,3/2,5,7,16,(69)/(2),76,140,295,(1231)/(2),1275]};

gp_inline__location="../dragon.tex:78262";
 BlobAcr_initial_k = {3};

gp_inline__location="../dragon.tex:78269";
 BlobAcr_multiply = {[1,1,2,2]};

gp_inline__location="../dragon.tex:78275";
 BlobAcr_constant = {[86,37,74,13]};

gp_inline__location="../dragon.tex:78281";
 BlobAcr_formula(k) = {
   7/45 * 2^k
   - 1/9 * vector_modulo(BlobAcr_multiply,k) * 2^ceil(k/2)
   + 1/90 * vector_modulo(BlobAcr_constant,k)
   - 1/2* BlobRQ(k);
 }
 BlobAcr(k) = if(k<=BlobAcr_initial_k,0, BlobAcr_formula(k));

gp_inline__location="../dragon.tex:78293";
 BlobAcr_samples = {[0,0,0,0,1,2,9/2,9,26,55,(231)/(2),242,525,1080,(4429)/(2),4523]};

gp_inline__location="../dragon.tex:78347";
 BlobAcl_by_recurrence(k) = {
   BlobAcr(k-2)  + 2*BlobAcl(k-4)
   + BlobDeltaLen(k-2) + vector_modulo([3/2, 2],k);
 }

gp_inline__location="../dragon.tex:78377";
 BlobAcr_by_recurrence(k) = {
   BlobAcl(k-2)
   + 2*BlobAcr(k-4)
   - BlobDeltaLen(k-2)
   - vector_modulo([3/2, 2],k)
   + TA(k-4)
   + 4*BQ(k-8) - 1;
 }

gp_inline__location="../dragon.tex:78470";
 BlobAcr_by_difference(k) = BlobA(k) - BlobAcl(k);

gp_inline__location="../dragon.tex:78474";
 BlobAcl_by_BlobL(k) = {
   if(k<4,return(0));
   2/45 * 2^k
   + 1/9 * vector_modulo([1, 1, 2, 2],k) * 2^ceil(k/2)
   - 1/180 * vector_modulo([208, 101, 292, 269],k)
   - 1/4* BlobL(k);
 }

gp_inline__location="../dragon.tex:78498";
 Acl_half_vector = {[1,1,1,2]};

gp_inline__location="../dragon.tex:78506";
Acl_constant_vector = {[6,4,5,7]};

gp_inline__location="../dragon.tex:78512";
 Acl_formula(k) = {
   1/6 * 2^k
   + 1/3 * vector_modulo(Acl_half_vector,k) * 2^floor(k/2)
   - 1/6 * vector_modulo(Acl_constant_vector,k)
   - 1/2*LQ(k);
 }
 Acl(k) = if(k<=3,0, Acl_formula(k));

gp_inline__location="../dragon.tex:78523";
 Acl_samples = {[0,0,0,0,0,1,7/2,(21)/(2),22,47,(215)/(2),(477)/(2),494,1031]};

gp_inline__location="../dragon.tex:78543";
 Acr_half_vector = {[1,1,1,2]};

gp_inline__location="../dragon.tex:78551";
Acr_constant_vector = {[9,7,8,10]};

gp_inline__location="../dragon.tex:78557";
 Acr_formula(k) = {
   1/3 * 2^k
   - 1/3 * vector_modulo(Acr_half_vector,k) * 2^floor(k/2)
   + 1/6 * vector_modulo(Acr_constant_vector,k)
   - 1/2*RQ(k);
 }
 Acr(k) = if(k<=3,0, Acr_formula(k));

gp_inline__location="../dragon.tex:78568";
 Acr_samples = {[0,0,0,0,1,3,(15)/(2),(35)/(2),45,105,(455)/(2),(971)/(2),1045,2201]};

gp_inline__location="../dragon.tex:78589";
 gAcl(x) = {       \\ 15 term recurrence
   1 + 1/2*x + 1/2*x^2 + 1/2*x^3
   - 11/12           / (1 - x)
   + (-1/12 + 1/4*x) / (1 + x^2)
   + (1/3 + 1/2*x)   / (1 - 2*x^2)
   - 1/6*x            / (1 + 2*x^2)
   + 1/6   / (1 - 2*x)
   + (-1/2 - 1/2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:78600";
 BlobAclCumul_formula(k) = {
   4/45 * 2^k
   + 1/9 * vector_modulo([6, 8, 6, 10],k) * 2^floor(k/2)
   - 7/12 * k
   + 1/180 * vector_modulo([-1, 48, 41, -33],k)
   - 1/4*BlobLQ(k+3);
 }
 BlobAclCumul(k) = if(k<2,0, BlobAclCumul_formula(k));

gp_inline__location="../dragon.tex:78614";
 BlobAcrCumul_formula(k) = {
   14/45 * 2^k
   - 1/9 * vector_modulo([6, 8, 6, 10],k) * 2^floor(k/2)
   + 7/12 * k
   + 1/180 * vector_modulo([19, 33, 31, 42],k)
   - 1/4*BlobRQ(k+3);
 }
 BlobAcrCumul(k) = if(k<2,0, BlobAcrCumul_formula(k));

gp_inline__location="../dragon.tex:78674";
 Acr_by_imbalance(k) = \
   1/2*A(k) +1/2*BlobAcdiff(k) +1/2*BlobAcdiff(k-1);

gp_inline__location="../dragon.tex:78699";
 BlobAcdiff_half_vector = {[2,4,4,8]};

gp_inline__location="../dragon.tex:78706";
BlobAcdiff_constant_vector = {[10,2,22,8]};

gp_inline__location="../dragon.tex:78712";
 BlobAcdiff_formula(k) = {
   1/9 * 2^k
   - 1/9 * vector_modulo(BlobAcdiff_half_vector,k) * 2^floor(k/2)
   + 1/9 * vector_modulo(BlobAcdiff_constant_vector,k)
   - BlobLQ(k-1);
 }
 BlobAcdiff(k) = \
   if(k<=3,0, k==4||k==5,1, BlobAcdiff_formula(k));

gp_inline__location="../dragon.tex:78728";
 BlobAcdiff_samples = {[0,0,0,0,1,1,3,4,19,39,81,166,385,785]};

gp_inline__location="../dragon.tex:78736";
 gBlobAcdiff(x) = {
   -1 - x^2
   + 7/6/(1 - x)
   + 17/72/(1 + x)
   + (-1/6 - 1/3*x)/(1 + x^2)
   + (-1/3 - 2/3*x)/(1 - 2*x^2)
   + (1/9 + 2/9*x)/(1 + 2*x^2)
   + 1/9/(1 - 2*x)
   + (-1/8 - 1/4*x + 1/4*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:78798";
 BlobAcumul(k) = sum(j=0,k,BlobA(j));

gp_inline__location="../dragon.tex:78911";
 AunfOut_by_Acl(k) = Acl(k-1) - BlobAcl(k-2);

gp_inline__location="../dragon.tex:78923";
 AunfOut_half_vector = {[2,1,1,2]};

gp_inline__location="../dragon.tex:78929";
AunfOut_constant_vector = {[4,23,1,92]};

gp_inline__location="../dragon.tex:78934";
 AunfOut_formula(k) = {
   13/180 * 2^k
   + 1/9 * vector_modulo(AunfOut_half_vector,k) * 2^floor(k/2)
   - 1/90 * vector_modulo(AunfOut_constant_vector,k)
   - 1/2 * BlobRQ(k);
 }
 AunfOut(k) = if(k==0||k==2,0, AunfOut_formula(k));

gp_inline__location="../dragon.tex:78950";
 AunfOut_samples = {[0,0,0,0,0,0,1,(5)/(2),9,17,40,(183)/(2),204,418]};

gp_inline__location="../dragon.tex:78974";
 AunfIn_half_vector = {[1,1,1,2]};

gp_inline__location="../dragon.tex:78980";
AunfIn_constant_vector = {[6,4,5,7]};
 AunfIn_formula(k) = {
   1/12 * 2^k
   - 1/3 * vector_modulo(AunfIn_half_vector,k) * 2^floor(k/2)
   + 1/6 * vector_modulo(AunfIn_constant_vector,k);
 }
 AunfIn(k) = if(k<4,0, AunfIn_formula(k));

gp_inline__location="../dragon.tex:78993";
 AunfIn_samples = {[0,0,0,0,1,2,7/2,(13)/(2),17,38,(151)/(2),(301)/(2),321,662]};

gp_inline__location="../dragon.tex:79148";
 BlobS(k) = if(k<4,0, 1/2*BlobB(k) + 1);

gp_inline__location="../dragon.tex:79152";
 BlobS_recurrence_k = {9};

gp_inline__location="../dragon.tex:79156";
 BlobS_by_recurrence_formula = BlobB_recurrence_maker(BlobS);
 BlobS_by_recurrence(k) = \
   if(k < BlobS_recurrence_k, BlobS(k), \
      BlobS_by_recurrence_formula(k));

gp_inline__location="../dragon.tex:79161";
 BlobS_samples = {[0,0,0,0,3,6,11,20,35,62,107,180,307,526]};

gp_inline__location="../dragon.tex:79182";
 gBlobS(x) = x^4 * (3 + 5*x^2 - 2*x^3 + 2*x^4) \
          / ( (1-x-2*x^3) * (1+x^2) * (1-x) );

gp_inline__location="../dragon.tex:79194";
 gBlobS_partial_fractions(x) = \
   1 + x^2 \
   - 2 / (1 - x) \
   + x / (1 + x^2) \
   + 1 / (1 - x - 2*x^3);

gp_inline__location="../dragon.tex:79201";
 gBlobS_partial_fractions_x4(x) = \
    x^4 * ( (5 + 2*x + 6*x^2) / (1 - x - 2*x^3) \
           + x / (1 + x^2) \
           - 2 /  (1 - x) );

gp_inline__location="../dragon.tex:79212";
 BlobD(k) = BlobA(k);
 gBlobD(x) = gBlobA(x);

gp_inline__location="../dragon.tex:79232";
 BlobP(k) = BlobS(k) + BlobD(k);

gp_inline__location="../dragon.tex:79234";
 BlobP_samples = {[0,0,0,0,4,9,17,34,68,133,257,498,972]};

gp_inline__location="../dragon.tex:79252";
 gBlobP(x) = x^4*(4 - 7*x + 5*x^2 - 12*x^3 + 6*x^4 - 4*x^5) \
                /( (1-2*x)*(1-x-2*x^3)*(1+x^2)*(1-x) );

gp_inline__location="../dragon.tex:79265";
 gBlobP_partial_fractions(x) = {
    1 + x^2
    - 2 /  (1 - x)
    + 1/10 * (3 + 11*x) / (1 + x^2)
    + 1/5* 1 / (1 - 2*x)
    + 1/2* 1 / (1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:79274";
 gBlobP_partial_fractions_x4(x) = \
    1/10*x^4*(  32 / (1-2*x) \
              + (25 + 10*x + 30*x^2) / (1 - x - 2*x^3) \
              + (3 + 11*x) / (1 + x^2) \
              - 20 /  (1 - x) );

gp_inline__location="../dragon.tex:79281";
 BlobP_by_dJA(k) = {
   if(k<4,0,
      1/5*2^k
      - 1/10*vector_modulo([17, 9, 23, 31],k)
      + 1/2 * dJA(k+2));
 }

gp_inline__location="../dragon.tex:79367";
 BlobHorizontals_vector = {[1,0,1,2]};

gp_inline__location="../dragon.tex:79373";
 BlobHorizontals(k) = {
   k>=0 || error("BlobHorizontals() is for k>=0");
   if(k<4,0,
      1/2*(BlobS(k) + vector_modulo(BlobHorizontals_vector,k)));
 }

gp_inline__location="../dragon.tex:79381";
 BlobHorizontals_samples = {[0,0,0,0,2,3,6,11,18,31,54,91]};

gp_inline__location="../dragon.tex:79399";
 gBlobHorizontals(x) = 1/2*(gBlobS(x) + x^4*(1+x^2+2*x^3)/(1-x^4));

gp_inline__location="../dragon.tex:79411";
 BlobVerticals_vector = {[1,2,1,0]};

gp_inline__location="../dragon.tex:79416";
 BlobVerticals(k) = {
   k>=0 || error("BlobVerticals() is for k>=0");
   if(k<4,0,
      1/2*(BlobS(k) + vector_modulo(BlobVerticals_vector,k)));
 }

gp_inline__location="../dragon.tex:79423";
 BlobVerticals_samples = {[0,0,0,0,2,4,6,10,18,32,54,90]};

gp_inline__location="../dragon.tex:79438";
 gBlobVerticals(x) = 1/2*(gBlobS(x) + x^4*(1+2*x+x^2)/(1-x^4));

gp_inline__location="../dragon.tex:79450";
 BlobLines(k) = BlobVerticals(k) + BlobHorizontals(k);

gp_inline__location="../dragon.tex:79453";
 BlobLines_samples = {[0,0,0,0,4,7,12,21,36,63,108,181]};

gp_inline__location="../dragon.tex:79466";
 gBlobLines(x) = gBlobVerticals(x) + gBlobHorizontals(x);

gp_inline__location="../dragon.tex:79503";
 g1012(x) = 1/(1-x^2) + 2*x^3/(1-x^4);
 g1210(x) = 1/(1-x^2) + 2*x/(1-x^4);

gp_inline__location="../dragon.tex:79544";
 Lines_by_blobs(k) = {
     sum(j=4,k,   BlobLines(j))
   + sum(j=4,k-2, BlobLines(j))
   + BridgeCount(k) + 12;
 }

gp_inline__location="../dragon.tex:79577";
 Horizontals_by_blobs(k) = \
     sum(j=4,k,   BlobHorizontals(j) + vector_modulo([1,1,0,0],j)) \
   + sum(j=4,k-2, BlobVerticals(j)   + vector_modulo([0,0,1,1],j)) \
   - vector_modulo([1,1,0,0],k) + 6;

gp_inline__location="../dragon.tex:79596";
 Verticals_by_blobs(k) = {
     sum(j=4,k,   BlobVerticals(j)   + vector_modulo([0,0,1,1],j))
   + sum(j=4,k-2, BlobHorizontals(j) + vector_modulo([1,1,0,0],j))
   - vector_modulo([0,0,1,1],k)
   + 6;
 }

gp_inline__location="../dragon.tex:79613";
 \\ vector of complex number points which are the midpoint of
 \\ each segment of blob k
 blob_midpoints(k) = \
   dragon_midpoints(k)[BlobN(k)+1 .. BlobN(k+1)-4+1];

gp_inline__location="../dragon.tex:79628";
 gen_blob_hull_values = {[
   /* 4 */ [ -3+2*I,-2+2*I,-2+1*I,-3+1*I ],
   /* 5 */ [ -5,-4,-2-1*I,-2-2*I,-4-2*I,-5-1*I ],
   /* 6 */ [ -5-5*I,-5-4*I,-1-3*I,-3*I,-4*I,-1-6*I,-4-6*I ],
   /* 7 */ [ -10*I,-1-9*I,-1-8*I,1-5*I,3-3*I,4-3*I,5-7*I,5-8*I,3-10*I ],
   /* 8 */ [ 11-10*I,8-10*I,7-9*I,6-6*I,6,7+1*I,8+1*I,11-1*I,13-3*I,13-8*I ],
   /* 9 */ [ 21,19-2*I,16-2*I,10+1*I,10+1*I,6+5*I,6+8*I,7+9*I,10+10*I,10+10*I,16+10*I,21+5*I ],
   /* 10 */ [ 21+21*I,21+16*I,19+14*I,13+12*I,9+11*I,11*I,-2+13*I,-2+16*I,1+22*I,1+22*I,5+26*I,16+26*I ],
   /* 11 */ [ 42*I,5+37*I,5+32*I,1+24*I,-1+21*I,-11+11*I,-16+11*I,-18+13*I,-20+19*I,-21+23*I,-21+32*I,-11+42*I ],
   /* 12 */ [ -43+42*I,-32+42*I,-27+37*I,-22+22*I,-22+22*I,-22,-27-5*I,-32-5*I,-40-1*I,-43+1*I,-53+11*I,-53+32*I ],
   /* 13 */ [ -85,-75+10*I,-64+10*I,-42-1*I,-42-1*I,-22-21*I,-22-32*I,-27-37*I,-42-42*I,-42-42*I,-64-42*I,-85-21*I ],
   /* 14 */ [ -85-85*I,-85-64*I,-75-54*I,-45-44*I,-41-43*I,-43*I,10-53*I,10-64*I,-1-86*I,-1-86*I,-21-106*I,-64-106*I ],
   /* 15 */ [ -170*I,-21-149*I,-21-128*I,-1-88*I,1-85*I,43-43*I,64-43*I,74-53*I,84-83*I,85-87*I,85-128*I,43-170*I ],
   /* 16 */ [ 171-170*I,128-170*I,107-149*I,86-86*I,86-86*I,86,107+21*I,128+21*I,168+1*I,171-1*I,213-43*I,213-128*I ]
 ]};
 gen_blob_hull_values_BlobHA = [1,9/2,23/2,57/2,125/2,267/2,559/2,1161/2,2357/2,4779/2,9663/2,19497/2,39125/2];

gp_inline__location="../dragon.tex:79655";
 blob_hull_by_gen(k) = gen_blob_hull_values[k-3];
 BP1_by_gen(k)     = gen_blob_hull_values[k-3][1];
 BP2_by_gen(k)     = gen_blob_hull_values[k-3][2];
 BP3_by_gen(k)     = gen_blob_hull_values[k-3][3];
 BP4dash_by_gen(k) = gen_blob_hull_values[k-3][4];
 BP4_by_gen(k)     = gen_blob_hull_values[k-3][5];
 BP5_by_gen(k)     = gen_blob_hull_values[k-3][6];
 BP6_by_gen(k)     = gen_blob_hull_values[k-3][7];
 BP7_by_gen(k)     = gen_blob_hull_values[k-3][8];
 BP8dash_by_gen(k) = gen_blob_hull_values[k-3][9];
 BP8_by_gen(k)     = gen_blob_hull_values[k-3][10];
 BP9_by_gen(k)     = gen_blob_hull_values[k-3][11];
 BP10_by_gen(k)    = gen_blob_hull_values[k-3][12];

gp_inline__location="../dragon.tex:79670";
 blob_hull_count_by_pattern(k) = vector_modulo([11,10,11,12],k);

gp_inline__location="../dragon.tex:79688";
 Ngai_Nguyen_blob_hull = {[
    -2/3 + 2/3 *I,  \\ e1
    -2/3 + 1/2 *I,  \\ e2
   -7/12 + 5/12*I,  \\ e3
    -1/3 + 1/3 *I,  \\ e4  blob start
           1/3 *I,  \\ e5
    1/12 + 5/12*I,  \\ e6  with correction to x = +1/12
    1/12 + 1/2 *I,  \\ e7
           2/3 *I,  \\ e8  blob end
    -1/6 + 5/6 *I,  \\ e9
    -1/2 + 5/6*I    \\ e10
 ]};

gp_inline__location="../dragon.tex:79777";
 BP1(k) = P1(k);
 BP1_limit = P1_limit;

gp_inline__location="../dragon.tex:79782";
 BP2_limit = {1/2-2/3*I};

gp_inline__location="../dragon.tex:79789";
 BP2(k) = (1/2-2/3*I)*b^k + 1/3*p(k-2);

gp_inline__location="../dragon.tex:79793";
 BP3_limit = {(5)/(12)-(7)/(12)*I};

gp_inline__location="../dragon.tex:79800";
 BP3(k) = (5/12-7/12*I)*b^k + 1/3*p(k-3);

gp_inline__location="../dragon.tex:79807";
 BP4dash_vector = {[0,0,4+I,2+3*I,0,0,-4-I,-2-3*I]};
 BP4dash(k) = BP4(k) + vector_modulo(BP4dash_vector,k);

gp_inline__location="../dragon.tex:79818";
 BP4_by_BlobStart_vector = {[-I,-1,-1-I,-I,I,1,1+I,I]};
 BP4_by_BlobStart(k) = \
   BlobStart(k) + vector_modulo(BP4_by_BlobStart_vector,k);

gp_inline__location="../dragon.tex:79829";
 BP4_limit = {1/3-1/3*I};

gp_inline__location="../dragon.tex:79835";
 BP4_vector = {[2-2*I,-2+3*I,-5+I,-3-I,-2+2*I,2-3*I,5-I,3+I]};
 BP4(k) = (1/3-1/3*I)*b^k + 1/3*vector_modulo(BP4_vector,k);

gp_inline__location="../dragon.tex:79845";
 BP5_limit = {1/3};

gp_inline__location="../dragon.tex:79852";
 BP5(k) = 1/3*b^k  + 1/3*I*p(k+2);

gp_inline__location="../dragon.tex:79857";
 BP6_limit = {(5)/(12)+(1)/(12)*I};

gp_inline__location="../dragon.tex:79865";
 BP6(k) = (5/12+1/12*I)*b^k + 1/3*I*p(k+1);

gp_inline__location="../dragon.tex:79869";
 BP7_limit = {1/2+(1)/(12)*I};

gp_inline__location="../dragon.tex:79877";
 BP7(k) = (1/2+1/12*I)*b^k + 1/3*I*p(k);

gp_inline__location="../dragon.tex:79884";
 BP8dash_vector = {[-3+2*I,0,0,1-4*I,3-2*I,0,0,-1+4*I]};
 BP8dash(k) = BP8(k) + vector_modulo(BP8dash_vector,k);

gp_inline__location="../dragon.tex:79894";
 BP8_by_BlobEnd_vector = {[1,-1,I,-1+I,-1,1,-I,1-I]};
 BP8_by_BlobEnd(k) = \
   BlobEnd(k) + vector_modulo(BP8_by_BlobEnd_vector,k);

gp_inline__location="../dragon.tex:79903";
 BP8_limit = {2/3};

gp_inline__location="../dragon.tex:79908";
 BP8_vector = {[1-3*I,-2-2*I,3+2*I,1+5*I,-1+3*I,2+2*I,-3-2*I,-1-5*I]};
 BP8(k) = 2/3*b^k + 1/3*vector_modulo(BP8_vector,k);

gp_inline__location="../dragon.tex:79917";
 BP9_limit = {5/6-1/6*I};

gp_inline__location="../dragon.tex:79924";
 BP9(k) = (5/6-1/6*I)*b^k + 1/3*p(k+9);

gp_inline__location="../dragon.tex:79929";
 BP10_limit = P10_limit;

gp_inline__location="../dragon.tex:79932";
 BP10(k) = P10(k);

gp_inline__location="../dragon.tex:79938";
 blob_hull_BP4dash_exists_by_pattern(k) = (k%4==2 || k%4==3);
 blob_hull_BP4dash_same_by_pattern(k) = \
   ! blob_hull_BP4dash_exists_by_pattern(k);

gp_inline__location="../dragon.tex:79949";
 blob_hull_BP8dash_exists_by_pattern(k) = (k%4==0 || k%4==3);
 blob_hull_BP8dash_same_by_pattern(k) = \
   ! blob_hull_BP8dash_exists_by_pattern(k);

gp_inline__location="../dragon.tex:80051";
 blob_hull(k) = {   \\ anti-clockwise around from BP1
   if(k==4,
      [ BP1(k), BP10(k),
        BP9(k), BP8(k),
        -2+I,  \\ start,end no vertex as such
        BP3(k), BP2(k) ],
      [ BP1(k), BP10(k), BP9(k), BP8(k), BP8dash(k),
        BP7(k), BP6(k), BP5(k), BP4(k), BP4dash(k),
        BP3(k), BP2(k) ]);
 }
 blob_hull_fractal = {  \\ anti-clockwise around from BP1
   [ BP1_limit, BP10_limit, BP9_limit, BP8_limit,
     BP7_limit, BP6_limit, BP5_limit, BP4_limit,
     BP3_limit, BP2_limit
   ]};

gp_inline__location="../dragon.tex:80638";
 BP1a(k)     = BlobPartsAorigin(k) + (-1)*BP1(k-4);
 BP2a(k)     = BlobPartsAorigin(k) + (-1)*BP2(k-4);
 BP3a(k)     = BlobPartsAorigin(k) + (-1)*BP3(k-4);
 BP4a(k)     = BlobPartsAorigin(k) + (-1)*BP4(k-4);
 BP4adash(k) = BlobPartsAorigin(k) + (-1)*BP4dash(k-4);
 BP5a(k)     = BlobPartsAorigin(k) + (-1)*BP5(k-4);
 BP6a(k)     = BlobPartsAorigin(k) + (-1)*BP6(k-4);
 BP7a(k)     = BlobPartsAorigin(k) + (-1)*BP7(k-4);
 BP8a(k)     = BlobPartsAorigin(k) + (-1)*BP8(k-4);
 BP8adash(k) = BlobPartsAorigin(k) + (-1)*BP8dash(k-4);
 BP9a(k)     = BlobPartsAorigin(k) + (-1)*BP9(k-4);
 BP10a(k)    = BlobPartsAorigin(k) + (-1)*BP10(k-4);

gp_inline__location="../dragon.tex:80655";
 BP1b(k)     = BlobPartsBorigin(k) + (-1)*BP1(k-4);
 BP2b(k)     = BlobPartsBorigin(k) + (-1)*BP2(k-4);
 BP3b(k)     = BlobPartsBorigin(k) + (-1)*BP3(k-4);
 BP4b(k)     = BlobPartsBorigin(k) + (-1)*BP4(k-4);
 BP4bdash(k) = BlobPartsBorigin(k) + (-1)*BP4dash(k-4);
 BP5b(k)     = BlobPartsBorigin(k) + (-1)*BP5(k-4);
 BP6b(k)     = BlobPartsBorigin(k) + (-1)*BP6(k-4);
 BP7b(k)     = BlobPartsBorigin(k) + (-1)*BP7(k-4);
 BP8b(k)     = BlobPartsBorigin(k) + (-1)*BP8(k-4);
 BP8bdash(k) = BlobPartsBorigin(k) + (-1)*BP8dash(k-4);
 BP9b(k)     = BlobPartsBorigin(k) + (-1)*BP9(k-4);
 BP10b(k)    = BlobPartsBorigin(k) + (-1)*BP10(k-4);

gp_inline__location="../dragon.tex:80672";
 BP1m(k)     = BlobPartsMorigin(k) + (-I)*BP1(k-2);
 BP2m(k)     = BlobPartsMorigin(k) + (-I)*BP2(k-2);
 BP3m(k)     = BlobPartsMorigin(k) + (-I)*BP3(k-2);
 BP4m(k)     = BlobPartsMorigin(k) + (-I)*BP4(k-2);
 BP5m(k)     = BlobPartsMorigin(k) + (-I)*BP5(k-2);
 BP6m(k)     = BlobPartsMorigin(k) + (-I)*BP6(k-2);
 BP7m(k)     = BlobPartsMorigin(k) + (-I)*BP7(k-2);
 BP8m(k)     = BlobPartsMorigin(k) + (-I)*BP8(k-2);
 BP8mdash(k) = BlobPartsMorigin(k) + (-I)*BP8dash(k-2);
 BP9m(k)     = BlobPartsMorigin(k) + (-I)*BP9(k-2);
 BP10m(k)    = BlobPartsMorigin(k) + (-I)*BP10(k-2);

gp_inline__location="../dragon.tex:80686";
 BP_P1t(k)   = BlobPartsTstart(k) + P1(k+1 - 4);
 BP_P2t(k)   = BlobPartsTstart(k) + P2(k+1 - 4);
 BP_P3t(k)   = BlobPartsTstart(k) + P3(k+1 - 4);
 BP_P4t(k)   = BlobPartsTstart(k) + P4(k+1 - 4);

gp_inline__location="../dragon.tex:80693";
 BP_P1tdash(k)   = BlobPartsTend(k) - P1(k+1 - 4);
 BP_P2tdash(k)   = BlobPartsTend(k) - P2(k+1 - 4);
 BP_P3tdash(k)   = BlobPartsTend(k) - P3(k+1 - 4);
 BP_P4tdash(k)   = BlobPartsTend(k) - P4(k+1 - 4);

gp_inline__location="../dragon.tex:80728";
 BP1_by_recurrence(k) = BP_P2tdash(k);

gp_inline__location="../dragon.tex:80733";
 BP4_by_recurrence(k) = BP4a(k);

gp_inline__location="../dragon.tex:80738";
 BP8dash_by_recurrence(k) = BP8bdash(k);

gp_inline__location="../dragon.tex:80745";
 BP2_by_recurrence(k) = BP_P3tdash(k);

gp_inline__location="../dragon.tex:80750";
 BP5_by_recurrence(k) = BP10m(k);

gp_inline__location="../dragon.tex:80755";
 BP8_by_recurrence(k) = BP8b(k);

gp_inline__location="../dragon.tex:80761";
 BP3_by_recurrence(k) = BP_P4tdash(k);

gp_inline__location="../dragon.tex:80766";
 BP6_by_recurrence(k) = BP1m(k);

gp_inline__location="../dragon.tex:80771";
 BP9_by_recurrence(k) = BP_P4t(k);

gp_inline__location="../dragon.tex:80777";
 BP4dash_by_recurrence(k) = BP4adash(k);

gp_inline__location="../dragon.tex:80783";
 BP7_by_recurrence(k) = BP2m(k);

gp_inline__location="../dragon.tex:80788";
 BP10_by_recurrence(k) = BP_P1tdash(k);

gp_inline__location="../dragon.tex:80820";
 BlobHAf = {(29)/(96)};

gp_inline__location="../dragon.tex:80825";
 BlobHA_half_vector = {[11,16,11,14]};

gp_inline__location="../dragon.tex:80832";
 BlobHA_constant_vector = {[-1,1,-3,-5]};

gp_inline__location="../dragon.tex:80837";
 BlobHA_formula(k) = {
   29/96 * 2^k
   - 1/12 * vector_modulo(BlobHA_half_vector,k)*2^floor(k/2)
   + 1/6  * vector_modulo(BlobHA_constant_vector,k);
 }
 BlobHA(k) = if(k<=3,0, BlobHA_formula(k));

gp_inline__location="../dragon.tex:80854";
 BlobHA_samples = {[0,0,0,0,1,9/2,(23)/(2),(57)/(2),(125)/(2),(267)/(2),(559)/(2)]};

gp_inline__location="../dragon.tex:80873";
 BlobHAf_sample = {(030208333/100000000)};

gp_inline__location="../dragon.tex:80896";
 BlobHB_symbolic_by_hull(k) = {
   my(v=blob_hull(k));
   v=geom_sides_of_polygon(v);
   v=apply(geom_abs,v);
   v=apply(to_symbolic,v);
   vecsum(v);
 }

gp_inline__location="../dragon.tex:80911";
 blob_hull_fractal_sides = geom_sides_of_polygon(blob_hull_fractal);

gp_inline__location="../dragon.tex:80944";
 BP3_sub_BP4dash_norm(k) = {
   5/72*(2^k
         + vector_modulo([-8, 8, -16, -32],k)* 2^floor(k/2)
         + vector_modulo([16, 8, 64, 128],k) );
 }

gp_inline__location="../dragon.tex:80951";
 BP3_sub_BP4dash_norm_2(k) = {
   5/72*(2^k
         + vector_modulo([-8, 4*sqrt2, -16, -16*sqrt2],k)* sqrt2^k
         + vector_modulo([16, 8, 64, 128],k) );
 }

gp_inline__location="../dragon.tex:80963";
 BP3_sub_BP4dash_norm_by_product(k) = {
   5/72*(sqrt2^k + vector_modulo([-4, 2*sqrt2, -8, -8*sqrt2],k)
        )^2;
 }

gp_inline__location="../dragon.tex:80971";
 BP3_sub_BP4dash_abs_symbolic(k) = {
   1/12*'sqrt10 * 'sqrt2^k
   + vector_modulo([-1/3 * 'sqrt10,
                     1/3 * 'sqrt5,
                    -2/3 * 'sqrt10,
                    -4/3 * 'sqrt5
                    ],k);
 }

gp_inline__location="../dragon.tex:80992";
 BP4dash_sub_BP4_norm(k) = vector_modulo([0,0,17,13],k);

gp_inline__location="../dragon.tex:80995";
 BP8dash_sub_BP8_norm(k) = vector_modulo([13,0,0,17],k);

gp_inline__location="../dragon.tex:81001";
 blob_hull_45s_by_sum(k) = {
     geom_abs(BP1(k)-BP2(k))   \\ 8 of
   + geom_abs(BP2(k)-BP3(k))
   + geom_abs(BP4(k)-BP5(k))
   + geom_abs(BP5(k)-BP6(k))
   + geom_abs(BP6(k)-BP7(k))
   + geom_abs(BP8(k)-BP9(k))
   + geom_abs(BP9(k)-BP10(k))
   + geom_abs(BP10(k)-BP1(k));
 }
 blob_hull_45s_symbolic(k) = {
   (11/12 + 1/2*'sqrt2) * sqrt2^k
   + vector_modulo([1/3 - 2*'sqrt2,
                    1 - 8/3*'sqrt2,
                    -4/3 - 3*'sqrt2,
                    -2 - 7/3*'sqrt2],k);
 }

gp_inline__location="../dragon.tex:81041";
 BlobHB_const_vector = {[1,3,-4,-6]};

gp_inline__location="../dragon.tex:81045";
 BlobHB_sqrt2_vector = {[6,8,9,7]};

gp_inline__location="../dragon.tex:81053";
 BlobHB_sqrt5_vector = {[-4,1,1,-4]};

gp_inline__location="../dragon.tex:81059";
 BlobHB_sqrt10_vector = {[1,1,2,2]};

gp_inline__location="../dragon.tex:81067";
 BlobHB_sqrt13_vector = {[1,0,0,1]};

gp_inline__location="../dragon.tex:81073";
 BlobHB_sqrt17_vector = {[0,0,1,1]};

gp_inline__location="../dragon.tex:81078";
 BlobHBf_symbolic = {
   ( 11/12
     + 1/2  * 'sqrt2
     + 1/12 * 'sqrt5
     + 1/12 * 'sqrt10 );
 }
 BlobHB_symbolic_formula(k) = {
   BlobHBf_symbolic * 'sqrt2^k
   + 1/3 * vector_modulo(BlobHB_const_vector,k)
   - 1/3 * vector_modulo(BlobHB_sqrt2_vector,k) * 'sqrt2
   + 1/3 * vector_modulo(BlobHB_sqrt5_vector,k) * 'sqrt5
   - 1/3 * vector_modulo(BlobHB_sqrt10_vector,k) * 'sqrt10
   + vector_modulo(BlobHB_sqrt13_vector,k)*'sqrt13
   + vector_modulo(BlobHB_sqrt17_vector,k)*'sqrt17;
 }
 BlobHB_symbolic(k) = if(k==4,4, BlobHB_symbolic_formula(k));

gp_inline__location="../dragon.tex:81099";
 BlobHB_inexact(k) = symbolic_to_inexact(BlobHB_symbolic(k));

gp_inline__location="../dragon.tex:81120";
 BlobHB_samples = {[
   4,
   5 + 'sqrt2 +   'sqrt5,
   6 + 'sqrt2 +   'sqrt5           + 'sqrt17,
   6          + 5*'sqrt2 + 'sqrt13 + 'sqrt17
 ]};

gp_inline__location="../dragon.tex:81148";
 BlobHBf_inexact = \
   11/12 + 1/2*sqrt(2) + 1/12*sqrt(5) + 1/12*sqrt(10);

gp_inline__location="../dragon.tex:81152";
 BlobHBf_symbolic25 =subst(BlobHBf_symbolic,'sqrt10,'sqrt2*'sqrt5);

gp_inline__location="../dragon.tex:81169";
 BlobHBpoly(x) = 5184*x^4 - 19008*x^3 + 19872*x^2 - 5928*x + 479;

gp_inline__location="../dragon.tex:81175";
 BlobHBf_sample = {(2073635/1000000)};

gp_inline__location="../dragon.tex:81213";
 BlobHdiam_squared_formula(k) = \
   5/8*2^k - vector_modulo([3/2, 2],k)*2^floor(k/2) + 1;
 BlobHdiam_squared(k) = if(k==4,2, BlobHdiam_squared_formula(k));
 BlobHdiam_inexact(k) = sqrt(BlobHdiam_squared(k));

gp_inline__location="../dragon.tex:81221";
 BP1_sub_BP6_norm(k) = norm(BP1(k)-BP6(k));

gp_inline__location="../dragon.tex:81225";
 BP2_sub_BP8_norm(k) = norm(BP2(k)-BP8(k));

gp_inline__location="../dragon.tex:81230";
 BlobHdiam_squared_samples = {[2,13,29,65,137,289,593,1217,2465]};

gp_inline__location="../dragon.tex:81241";
 blob_points(k) = dragon_points(k)[BlobN(k)+1 .. BlobN(k+1)-3+1];

gp_inline__location="../dragon.tex:81293";
 BlobHdiamf = geom_sqrt_as_quad(5/8);

gp_inline__location="../dragon.tex:81296";
 BlobHdiamf_sample = {(0790569/1000000)};

gp_inline__location="../dragon.tex:81342";
 BlobHdiam_rotation(k) = Hdiam_rotation(k);
 BlobHdiam_x(k) = abs(real( (BP6(k)-BP1(k))*BlobHdiam_rotation(k)));
 BlobHdiam_y(k) = abs(imag( (BP6(k)-BP1(k))*BlobHdiam_rotation(k)));

gp_inline__location="../dragon.tex:81371";
 BlobHdiam_y_powers(k) = \
   vector_modulo([3/4, 1],k) * 2^floor(k/2) - 1;

gp_inline__location="../dragon.tex:82114";
 BlobGS(k) = BlobGStotal(k) / BlobSegments(k);

gp_inline__location="../dragon.tex:82118";
 BlobGS_samples = {[-(5)/(2)+(3)/(2)*I,-(39)/(11)-(25)/(22)*I,-(105)/(44)-(205)/(44)*I,(211)/(94)-(326)/(47)*I]};

gp_inline__location="../dragon.tex:82135";
 BlobGStotal_by_sum(k) = \
   sum(j=BlobN(k), BlobN(k+1)-4, dragon_midpoint(j));

gp_inline__location="../dragon.tex:82145";
 BlobGStotal_half_vector = {[-39+7*I,-23+9*I,-51+23*I,-67+21*I]};

gp_inline__location="../dragon.tex:82161";
 BlobGStotal_constant_vector = {[24+16*I,-26-11*I,5-39*I,-31-68*I,-24-16*I,26+11*I,-5+39*I,31+68*I]};

gp_inline__location="../dragon.tex:82175";
 BlobGStotal(k) = {
  (8 - 4*I)/35 * (2*b)^k
  + 1/30*vector_modulo(BlobGStotal_half_vector,k)*b^k
  + 1/42*vector_modulo(BlobGStotal_constant_vector,k);
 }

gp_inline__location="../dragon.tex:82188";
 BlobGStotal_samples = {[-10+6*I,-39-(25)/(2)*I,-(105)/(2)-(205)/(2)*I,(211)/(2)-326*I]};

gp_inline__location="../dragon.tex:82213";
 GStotal(k) = 2^k * GS(k);

gp_inline__location="../dragon.tex:82247";
 GStotal_from_BlobGStotal(k) = {
   sum(j=4,k, BlobGStotal(j) + 3*BridgeMiddle(j))
   + (-I)*sum(j=4,k-2, BlobGStotal(j) + 3*BridgeMiddle(j))
   - 3*BridgeMiddle(k)
   + b^k * BlobN(k-1)
   + (1 + (-I)) * (-1 + 15/2*I);
 }

gp_inline__location="../dragon.tex:82255";
 initial7_midpoint_sum = vecsum(dragon_midpoints(4)[1..7]);

gp_inline__location="../dragon.tex:82270";
 BridgeMiddle(k) = (BlobEnd(k) + BlobStart(k+1))/2;

gp_inline__location="../dragon.tex:82279";
 BridgeMiddle_vector = {[-1,-1+2*I,I,2+I,1,1-2*I,-I,-2-I]};

gp_inline__location="../dragon.tex:82284";
 BridgeMiddle_by_power(k) = 2/3*b^k + 1/6*vector_modulo(BridgeMiddle_vector,k);

gp_inline__location="../dragon.tex:82291";
 BridgeMiddle_samples = {[-(5)/(2),-(5)/(2)-3*I,-(11)/(2)*I,5-(11)/(2)*I,(21)/(2)]};

gp_inline__location="../dragon.tex:82326";
 BlobGStotal_factors_vector = {[1,-1,I,-I,-1,1,-I,I]};

gp_inline__location="../dragon.tex:82355";
 BlobGSf = 4/7 - 2/7*I;

gp_inline__location="../dragon.tex:83598";
 BlobHG(k) = BlobHGtotal(k) / BlobHA(k);
 BlobHG_by_points(k) = geom_centroid_of_polygon(blob_hull(k));

gp_inline__location="../dragon.tex:83603";
 BlobHG_samples = {[-(5)/(2)+(3)/(2)*I,-(32)/(9)-(29)/(27)*I,-(55)/(23)-(316)/(69)*I,(128)/(57)-7*I,(3488)/(375)-(599)/(125)*I]};

gp_inline__location="../dragon.tex:83619";
 BlobHGtotal_by_triangles(k) = {
   my(v=blob_hull(k));
   sum(i=1,#v,
       my(z1=vector_modulo(v,i), z2=vector_modulo(v,i+1));
       geom_centroid_of_triangle(z1,z2)
       * geom_area_of_triangle(z1,z2));
 }

gp_inline__location="../dragon.tex:83630";
 BlobHGtotal_k4 = {-5/2+3/2*I};

gp_inline__location="../dragon.tex:83642";
 BlobHGtotal_multiply_high = {(599)/(3456)-(29)/(324)*I};

gp_inline__location="../dragon.tex:83650";
 BlobHGtotal_multiply_half = {[(-47)/(96)+(29)/(108)*I,(-37)/(48)+(10)/(27)*I,(-157)/(288)+(233)/(864)*I,(-191)/(288)+(313)/(864)*I]};

gp_inline__location="../dragon.tex:83663";
 BlobHGtotal_multiply_low = {[(-17)/(72)-(11)/(108)*I,(11)/(72)+(1)/(216)*I,(-7)/(72)+(13)/(108)*I,(-29)/(72)+(7)/(216)*I]};

gp_inline__location="../dragon.tex:83676";
 BlobHGtotal_constant_vector = {[84+I,4-19*I,-17-66*I,-64-85*I,-84-I,-4+19*I,17+66*I,64+85*I]};

gp_inline__location="../dragon.tex:83690";
 BlobHGtotal_formula(k) = {
   b^k*(BlobHGtotal_multiply_high * 2^k
        + vector_modulo(BlobHGtotal_multiply_half,k)*2^floor(k/2)
        + vector_modulo(BlobHGtotal_multiply_low,k)
       )
   + 1/162*vector_modulo(BlobHGtotal_constant_vector,k);
 }
 BlobHGtotal(k) = if(k==4,BlobHGtotal_k4, BlobHGtotal_formula(k));

gp_inline__location="../dragon.tex:83706";
 BlobHGtotal_samples = {[(-5+3*I)/(2),(-96-29*I)/(6),(-165-316*I)/(6),(384-1197*I)/(6),(3488-1797*I)/(6)]};

gp_inline__location="../dragon.tex:83736";
 BlobHGf = {(599)/(1044)-(8)/(27)*I};

gp_inline__location="../dragon.tex:83744";
 BlobHGf_real_decimal = {(0573754/1000000)};

gp_inline__location="../dragon.tex:83750";
 BlobHGf_imag_decimal = {-(0296296/1000000)};

gp_inline__location="../dragon.tex:83775";
  BlobHGf_sub_BlobGSf = BlobHGf - BlobGSf;
 BlobHGf_sub_BlobGSf_real_decimal = {(0002326/1000000)};

gp_inline__location="../dragon.tex:83784";
 BlobHGf_sub_BlobGSf_imag_decimal = {-(0010582/1000000)};

gp_inline__location="../dragon.tex:83810";
 \\ vector of complex number points which are the midpoints of
 \\ the segments of blob k, shifted so 0 is their centroid
 blob_midpoints_at_centroid(k) = {
   my(centroid = BlobGS(k));
   apply(z -> z-centroid, blob_midpoints(k));
 }

gp_inline__location="../dragon.tex:83818";
 \\ inertia matrix of segment midpoints of all segments in blob k,
 \\ with origin at their centroid
 BlobI_by_points(k) = {
   my(v=blob_midpoints_at_centroid(k));
   my(m=geom_inertia_of_points(v));
   geom_inertia_rotate_xydir(m, b^k);
 }
 BlobI_by_points = memoize(BlobI_by_points);

gp_inline__location="../dragon.tex:83853";
 \\ complex number points n=from to n=to inclusive
 dragon_points_range(from,to) = \
   vector(to-from+1,n, dragon_point(n+from-1));

gp_inline__location="../dragon.tex:83873";
 BlobI(k) = {
   [  BlobI_x(k),  -BlobI_xy(k), 0;
     -BlobI_xy(k),  BlobI_y(k),  0;
      0,            0,           BlobI_z(k) ];
 }

gp_inline__location="../dragon.tex:83890";
 BlobI_x_4_factor = {(53)/(4165)};

gp_inline__location="../dragon.tex:83895";
 BlobI_x_2_factor = {-(1)/(8820)};
 BlobI_x_2_vector = {[1875,1009,1227,2093]};

gp_inline__location="../dragon.tex:83907";
 BlobI_x_half_factor = {(1)/(441)};
 BlobI_x_half_vector = {[159,146,180,503]};

gp_inline__location="../dragon.tex:83919";
 BlobI_x_const_factor = {-(1)/(299880)};
 BlobI_x_const_vector = {[239861,81122,289859,565558]};

gp_inline__location="../dragon.tex:83929";
 BlobI_x_fhalf_factor = {(1)/(882)};
 BlobI_x_fhalf_vector = {[304,135,-55,2079]};

gp_inline__location="../dragon.tex:83940";
 BlobI_x_fconst_factor = {-(1)/(1764)};
 BlobI_x_fconst_vector = {[2422,477,1114,9531]};

gp_inline__location="../dragon.tex:83949";
 BlobI_x(k) = {
   BlobI_x_4_factor                           * 4^k
   + BlobI_x_2_factor /*neg*/
     * vector_modulo(BlobI_x_2_vector,k)      * 2^k
   + BlobI_x_half_factor
     * vector_modulo(BlobI_x_half_vector,k)   * 2^floor(k/2)
   + BlobI_x_const_factor /*neg*/
     * vector_modulo(BlobI_x_const_vector,k)
   + ( BlobI_x_fhalf_factor
       * vector_modulo(BlobI_x_fhalf_vector,k)   * 2^floor(k/2)
     + BlobI_x_fconst_factor
       * vector_modulo(BlobI_x_fconst_vector,k)
     ) / BlobSegments(k);
 }

gp_inline__location="../dragon.tex:83968";
 BlobI_x_samples = {[1/2,(115)/(11),(4001)/(88),(8725)/(47),(39227)/(50)]};

gp_inline__location="../dragon.tex:83986";
 BlobI_y_4_factor = {(23)/(4165)};

gp_inline__location="../dragon.tex:83990";
 BlobI_y_2_factor = {-(1)/(8820)};
 BlobI_y_2_vector = {[815,1229,1807,1393]};

gp_inline__location="../dragon.tex:84001";
 BlobI_y_half_factor = {(1)/(441)};
 BlobI_y_half_vector = {[146,220,314,367]};

gp_inline__location="../dragon.tex:84011";
 BlobI_y_const_factor = {-(1)/(299880)};
 BlobI_y_const_vector = {[176501,143202,347779,253918]};

gp_inline__location="../dragon.tex:84021";
 BlobI_y_fhalf_factor = {(1)/(882)};
 BlobI_y_fhalf_vector = {[-72,407,585,259]};

gp_inline__location="../dragon.tex:84032";
 BlobI_y_fconst_factor = {-(1)/(1764)};
 BlobI_y_fconst_vector = {[630,1229,3546,1199]};

gp_inline__location="../dragon.tex:84042";
 BlobI_y(k) = {
   BlobI_y_4_factor * 4^k
   + BlobI_y_2_factor
     * vector_modulo(BlobI_y_2_vector,k)   * 2^k
   + BlobI_y_half_factor
     * vector_modulo(BlobI_y_half_vector,k)   * 2^floor(k/2)
   + BlobI_y_const_factor
     * vector_modulo(BlobI_y_const_vector,k)
   + (   BlobI_y_fhalf_factor
         * vector_modulo(BlobI_y_fhalf_vector,k)   * 2^floor(k/2)
       + BlobI_y_fconst_factor
         * vector_modulo(BlobI_y_fconst_vector,k) )/BlobSegments(k);
 }

gp_inline__location="../dragon.tex:84059";
 BlobI_y_samples = {[1/2,(31)/(11),(1249)/(88),(3577)/(47),(17147)/(50)]};

gp_inline__location="../dragon.tex:84076";
 BlobI_xy_4_factor = {-(8)/(4165)};

gp_inline__location="../dragon.tex:84080";
 BlobI_xy_2_factor = {-(1)/(4410)};
 BlobI_xy_2_vector = {[253,181,257,329]};

gp_inline__location="../dragon.tex:84090";
 BlobI_xy_half_factor = {(1)/(882)};
 BlobI_xy_half_vector = {[337,158,358,326]};

gp_inline__location="../dragon.tex:84100";
 BlobI_xy_const_factor = {(1)/(59976)};
 BlobI_xy_const_vector = {[-20635,2290,-30467,13622]};

gp_inline__location="../dragon.tex:84110";
 BlobI_xy_fhalf_factor = {(1)/(294)};
 BlobI_xy_fhalf_vector = {[68,-83,-59,-245]};

gp_inline__location="../dragon.tex:84121";
 BlobI_xy_fconst_factor = {(1)/(588)};
 BlobI_xy_fconst_vector = {[-14,241,430,1125]};

gp_inline__location="../dragon.tex:84130";
 BlobI_xy(k) = {
   BlobI_xy_4_factor * 4^k
   + BlobI_xy_2_factor
     * vector_modulo(BlobI_xy_2_vector,k)   * 2^k
   + BlobI_xy_half_factor
     * vector_modulo(BlobI_xy_half_vector,k)  * 2^floor(k/2)
   + BlobI_xy_const_factor
     * vector_modulo(BlobI_xy_const_vector,k)
   + (   BlobI_xy_fhalf_factor
        * vector_modulo(BlobI_xy_fhalf_vector,k)   * 2^floor(k/2)
      + BlobI_xy_fconst_factor
        * vector_modulo(BlobI_xy_fconst_vector,k) )/BlobSegments(k);
 }

gp_inline__location="../dragon.tex:84147";
 BlobI_xy_samples = {[0,-(57)/(22),-(783)/(88),-(1783)/(47),-(3369)/(25)]};

gp_inline__location="../dragon.tex:84166";
 BlobI_z_4_factor = {(76)/(4165)};

gp_inline__location="../dragon.tex:84171";
 BlobI_z_2_factor = {-(1)/(4410)};
 BlobI_z_2_vector = {[1345,1119,1517,1743]};

gp_inline__location="../dragon.tex:84182";
 BlobI_z_half_factor = {(1)/(441)};
 BlobI_z_half_vector = {[305,366,494,870]};

gp_inline__location="../dragon.tex:84192";
 BlobI_z_const_factor = {-(1)/(149940)};
 BlobI_z_const_vector = {[208181,112162,318819,409738]};

gp_inline__location="../dragon.tex:84202";
 BlobI_z_fhalf_factor = {(1)/(441)};
 BlobI_z_fhalf_vector = {[116,271,265,1169]};

gp_inline__location="../dragon.tex:84213";
 BlobI_z_fconst_factor = {-(1)/(882)};
 BlobI_z_fconst_vector = {[1526,853,2330,5365]};

gp_inline__location="../dragon.tex:84222";
 BlobI_z(k) = {
   BlobI_z_4_factor * 4^k
   + BlobI_z_2_factor
     * vector_modulo(BlobI_z_2_vector,k)   * 2^k
   + BlobI_z_half_factor
     * vector_modulo(BlobI_z_half_vector,k) * 2^floor(k/2)
   + BlobI_z_const_factor
     * vector_modulo(BlobI_z_const_vector,k)
   + (  BlobI_z_fhalf_factor
        * vector_modulo(BlobI_z_fhalf_vector,k)   * 2^floor(k/2)
      + BlobI_z_fconst_factor
        * vector_modulo(BlobI_z_fconst_vector,k)  )/BlobSegments(k);
 }

gp_inline__location="../dragon.tex:84239";
 BlobI_z_samples = {[1,(146)/(11),(2625)/(44),(12302)/(47),(28187)/(25)]};

gp_inline__location="../dragon.tex:84386";
 blob_inertia_bridge_a_N(k) = BlobN(k) + BlobSegments(k-4);
 blob_inertia_bridge_a_points(k) = {
   my(n=blob_inertia_bridge_a_N(k));
   my(v=[dragon_point(n), dragon_point(n+1),
         dragon_point(n+2), dragon_point(n+3) ]);
   v=apply(z->z-v[1], v);
   geom_points_rotate_xydir(v, conj(b)^k);
 }
 blob_inertia_bridge_a_points_even = \
   [[0, 0], [0, 1], [1, 1], [1, 2]];
 blob_inertia_bridge_a_points_odd = {
   [[0, 0], [1/2*sqrt2, 1/2*sqrt2],
            [0, sqrt2],
            [1/2*sqrt2, 3/2*sqrt2]];
 }

gp_inline__location="../dragon.tex:84406";
 blob_inertia_bridge_a_midpoints_even = \
   vector_differences(blob_inertia_bridge_a_points_even);
 blob_inertia_bridge_a_midpoints_odd = \
   vector_differences(blob_inertia_bridge_a_points_odd);

gp_inline__location="../dragon.tex:84411";
 blob_inertia_bridge_b_n(k) = BlobNend(k) - BlobSegments(k-4);
 blob_inertia_bridge_b_points(k) = {
   my(n=blob_inertia_bridge_b_n(k));
   my(v=[dragon_point(n-3), dragon_point(n-2),
         dragon_point(n-1), dragon_point(n) ]);
   v=apply(z->z-v[1], v);
   geom_points_rotate_xydir(v, conj(b)^k);
 }
 blob_inertia_bridge_b_points_even = \
   [[0, 0], [1, 0], [1, 1], [2, 1]];
 blob_inertia_bridge_b_points_odd = {
   [[0, 0], [1/2*sqrt2, 1/2*sqrt2],
            [sqrt2, 0],
            [3/2*sqrt2, 1/2*sqrt2]];
 }

gp_inline__location="../dragon.tex:84516";
 BridgeIa_by_cases(k) = {
   if(k%2==0,
        Ipoint( 1/2 + 1/2*I)
      + Ipoint(-1/2 - 1/2*I),
        geom_inertia_of_point([0, 1/2*sqrt2])
      + geom_inertia_of_point([0, -1/2*sqrt2]));
 }

gp_inline__location="../dragon.tex:84528";
 BridgeIa_even = [1/2, -1/2, 0; -1/2, 1/2, 0; 0,0,1 ];

gp_inline__location="../dragon.tex:84533";
 BridgeIa_odd = {[1,0,0;0,0,0;0,0,1]};

gp_inline__location="../dragon.tex:84540";
 BridgeIa(k) = if(k%2==0, BridgeIa_even, BridgeIa_odd);

gp_inline__location="../dragon.tex:84543";
 BridgeIa_by_points(k) = {
   my(n=BlobN(k)+BlobSegments(k-4));
   my(v=dragon_points_range(n,n+3));
   v=vector_midpoints(v);
   my(centroid=geom_centroid_of_points(v));
   v=apply(z->z-centroid,v);
   v=geom_points_rotate_xydir(v,conj(b)^k);
   geom_inertia_of_points(v);
 }

gp_inline__location="../dragon.tex:84565";
 BridgeIb_by_cases(k) = {
   if(k%2==0,  BridgeIa(k),
        geom_inertia_of_point([1/2*sqrt2, 0])
      + geom_inertia_of_point([-1/2*sqrt2, 0]));
 }

gp_inline__location="../dragon.tex:84572";
 BridgeIb_odd = {[0,0,0;0,1,0;0,0,1]};

gp_inline__location="../dragon.tex:84579";
 BridgeIb(k) = if(k%2==0, BridgeIa(k), BridgeIb_odd);

gp_inline__location="../dragon.tex:84582";
 BridgeIb_by_points(k) = {
   my(n=BlobNend(k)-BlobSegments(k-4));
   my(v=dragon_points_range(n-3,n));
   v=vector_midpoints(v);
   my(centroid=geom_centroid_of_points(v));
   v=apply(z->z-centroid,v);
   v=geom_points_rotate_xydir(v,conj(b)^k);
   geom_inertia_of_points(v);
 }

gp_inline__location="../dragon.tex:84611";
 blob_inertia_Ga(k) = BlobPartsAorigin(k) + (-1)*BlobGS(k-4);
 blob_inertia_GtoGa(k) = blob_inertia_Ga(k) - BlobGS(k);

gp_inline__location="../dragon.tex:84621";
 blob_inertia_Gb(k) = BlobPartsBorigin(k) + (-1)*BlobGS(k-4);
 blob_inertia_GtoGb(k) = blob_inertia_Gb(k) - BlobGS(k);

gp_inline__location="../dragon.tex:84630";
 blob_inertia_Gm(k) = BlobPartsMorigin(k) + (-I)*BlobGS(k-2);
 blob_inertia_GtoGm(k) = blob_inertia_Gm(k) - BlobGS(k);

gp_inline__location="../dragon.tex:84644";
 blob_inertia_Ba(k) = BlobPartsAorigin(k) + (-1)*BridgeMiddle(k-4);
 blob_inertia_GtoBa(k) = blob_inertia_Ba(k) - BlobGS(k);

gp_inline__location="../dragon.tex:84653";
 blob_inertia_Bb(k) = BlobPartsBorigin(k) + (-1)*BridgeMiddle(k-5);
 blob_inertia_GtoBb(k) = blob_inertia_Bb(k) - BlobGS(k);

gp_inline__location="../dragon.tex:84664";
 BlobPartsTmiddle_by_mean(k) = \
   1/2 * (BlobPartsTstart(k) + BlobPartsTend(k));

gp_inline__location="../dragon.tex:84669";
 BlobPartsTmiddlef = {5/8-3/8*I};

gp_inline__location="../dragon.tex:84674";
 BlobPartsTmiddle(k) = BlobPartsTmiddlef * b^k;

gp_inline__location="../dragon.tex:84682";
 blob_inertia_GtoTmid(k) = BlobPartsTmiddle(k) - BlobGS(k);

gp_inline__location="../dragon.tex:84690";
 BlobPartsTC(k) = (1/2 - 1/4*I)*b^k;  \\ attachment
 BlobPartsTC2(k) = (3/4 - 1/2*I)*b^k; \\ bottom

gp_inline__location="../dragon.tex:84694";
 BlobPartsAend(k)   = BlobPartsAorigin(k) + (-1)*BlobEnd(k-4);
 BlobPartsBstart(k) = BlobPartsBorigin(k) + (-1)*BlobStart(k-4);
 BlobPartsMstart(k) = BlobPartsMorigin(k) + (-I)*BlobStart(k-2);
 BlobPartsMend(k)   = BlobPartsMorigin(k) + (-I)*BlobEnd(k-2);

gp_inline__location="../dragon.tex:84699";
 blob_inertia_Ba_by_mean(k) = \
   (BlobPartsAend(k) + BlobPartsMend(k))/2;

gp_inline__location="../dragon.tex:84703";
 blob_inertia_Bb_by_mean(k) = \
   (BlobPartsBstart(k) + BlobPartsMstart(k))/2;

gp_inline__location="../dragon.tex:84757";
 BlobI_by_recurrence(k) = {
   if(k<8, return(BlobI_by_points(k)));
   BlobI(k-2)
   + BlobSegments(k-2)
     * geom_inertia_of_point(
       geom_point_rotate_xydir(blob_inertia_GtoGm(k),conj(b)^k))
   +
   BlobI(k-4)
   + BlobSegments(k-4)
     * geom_inertia_of_point(
       geom_point_rotate_xydir(blob_inertia_GtoGa(k),conj(b)^k))
   +
   BlobI(k-4)
   + BlobSegments(k-4)
     * geom_inertia_of_point(
       geom_point_rotate_xydir(blob_inertia_GtoGb(k),conj(b)^k))
   +
   R45 * TI(k-4) * R45^-1
   + 4 * 2^(k-4)
     * geom_inertia_of_point(
       geom_point_rotate_xydir(blob_inertia_GtoTmid(k),conj(b)^k))
   +
   BridgeIa(k)
   + 3
     * geom_inertia_of_point(
       geom_point_rotate_xydir(blob_inertia_GtoBa(k),conj(b)^k))
   +
   BridgeIb(k)
   + 3
     * geom_inertia_of_point(
       geom_point_rotate_xydir(blob_inertia_GtoBb(k),conj(b)^k))
   ;
 }

gp_inline__location="../dragon.tex:84819";
 BlobI_by_sum(k) = {
   my(centroid = BlobGS(k));
   my(rotate = conj(w8_times_sqrt2)^k);
   my(m=sum(n=BlobN(k), BlobN(k+1)-4,
            my(z=(dragon_midpoint(n)-centroid)*rotate);
            geom_inertia_of_point(z)));
   m /= 2^k;
 }

gp_inline__location="../dragon.tex:84834";
 BlobI_x_times_BlobSegments_samples = {[2,115,(4001)/(4),8725,78454,666301,(21457681)/(4)]};

gp_inline__location="../dragon.tex:84851";
 BlobI_y_times_BlobSegments_samples = {[2,31,(1249)/(4),3577,34294,280913,(9098193)/(4)]};

gp_inline__location="../dragon.tex:84864";
 BlobI_xy_times_BlobSegments_samples = {[0,-(57)/(2),-(783)/(4),-1783,-13476,-(211789)/(2),-(3347519)/(4)]};

gp_inline__location="../dragon.tex:84897";
 BlobIf_factor = {(1)/(4165)};

gp_inline__location="../dragon.tex:84901";
 BlobIf_integers = {[53,8,0;8,23,0;0,0,76]};

gp_inline__location="../dragon.tex:84907";
 BlobIf = BlobIf_factor * BlobIf_integers;

gp_inline__location="../dragon.tex:84960";
 inertia_scale_area(M,f) = M*f^4;

gp_inline__location="../dragon.tex:84966";
 blob_inertia_GtoGa_limit = {-(5)/(28)-(1)/(28)*I};
 blob_inertia_Ga_limit = BlobPartsAoriginf + 1/4*BlobGSf;

gp_inline__location="../dragon.tex:84974";
 blob_inertia_GtoGm_limit = {-(3)/(28)+(5)/(28)*I};
 blob_inertia_Gm_limit = BlobPartsMoriginf - 1/2*BlobGSf;

gp_inline__location="../dragon.tex:84982";
 blob_inertia_GtoGb_limit = {(1)/(14)+(3)/(14)*I};
 blob_inertia_Gb_limit = BlobPartsBoriginf + 1/4*BlobGSf;

gp_inline__location="../dragon.tex:84992";
 blob_inertia_GtoTmid_limit = {(3)/(56)-(5)/(56)*I};

gp_inline__location="../dragon.tex:85514";
 If_by_sum(k) = {
   sum(j=0,k,
       1/4^j * R45^(-j) * BlobIf * R45^j
       + 2/5 * 1/2^j * Ipoint(BlobGSf/b^j  - Gf))
   +
   sum(j=2,k,
       1/4^j * R45^(-j-2) * BlobIf * R45^(j+2)
       + 2/5 * 1/2^j * Ipoint(1 - I*BlobGSf/b^j  - Gf));
 }

gp_inline__location="../dragon.tex:85540";
 If_mass_by_sum(k) = {
   sum(j=0,k,
       + 2/5 * 1/2^j)
   +
   sum(j=2,k,
       + 2/5 * 1/2^j);
 }

gp_inline__location="../dragon.tex:85557";
 BlobI_d_squared_xydir(k) = [BlobI_x(k)-BlobI_y(k), -2*BlobI_xy(k)];
 BlobI_d_xydir(k) = geom_xydir_half(BlobI_d_squared_xydir(k));

gp_inline__location="../dragon.tex:85563";
 BlobI_d_squared_xydir_limit = [53-23, -2*-8] / 4165;
 BlobI_d_xydir_limit = geom_xydir_half(BlobI_d_squared_xydir_limit);

gp_inline__location="../dragon.tex:85583";
 BlobI_alpha_max_by_half = 1/2 * atan( -2*-8 / (53-23) );

gp_inline__location="../dragon.tex:85585";
 BlobI_alpha_max = atan(1/4);
BlobI_alpha_max_sample = {(14036243/1000000)};

gp_inline__location="../dragon.tex:85603";
 BlobI_alpha_min = BlobI_alpha_max + Pi/2;
BlobI_alpha_min_sample = {(104036243/1000000)};

gp_inline__location="../dragon.tex:85724";
 blob_inertia_max_above_Tstart(k) = {
   my(G=BlobGS(k));
   G + (1+1/4*I) * real(BlobPartsTstart(k) - G);
 }
 blob_hull_above_Tstart(k) = BlobPartsTstart(k) + P2(k-12);

gp_inline__location="../dragon.tex:85745";
 BlobI_principal_limit_factor = {(1)/(4165)};

gp_inline__location="../dragon.tex:85749";
 BlobI_principal_limit_integers = {[55,0,0;0,21,0;0,0,76]};

gp_inline__location="../dragon.tex:85755";
 BlobI_principal_limit = \
   BlobI_principal_limit_factor * BlobI_principal_limit_integers;

gp_inline__location="../dragon.tex:85775";
 blob_hull_fractal_at_centroid = \
   apply(z->z-BlobHGf, blob_hull_fractal);
 blob_hull_fractal_inertia = {
   \\ multiply 2 for mass=2*area
   2*geom_inertia_of_polygon(blob_hull_fractal_at_centroid);
 }

gp_inline__location="../dragon.tex:85794";
 BlobHI_x = {(24281)/(1119744)};

gp_inline__location="../dragon.tex:85802";
 BlobHI_y = {(37471)/(3608064)};

gp_inline__location="../dragon.tex:85810";
 BlobHI_xy = {-(2213)/(746496)};

gp_inline__location="../dragon.tex:85816";
 BlobHI_z = BlobHI_x + BlobHI_y;

gp_inline__location="../dragon.tex:85824";
 BlobHI_alpha_max_fraction = {(192531)/(366910)};
 BlobHI_alpha_max = 1/2*atan(BlobHI_alpha_max_fraction);

gp_inline__location="../dragon.tex:85836";
BlobHI_alpha_max_sample = {(13843813/1000000)};

gp_inline__location="../dragon.tex:85847";
 BlobHI_d_squared_xydir = [BlobHI_x-BlobHI_y, -2*BlobHI_xy];
 BlobHI_d_xydir = geom_xydir_half(BlobHI_d_squared_xydir);

gp_inline__location="../dragon.tex:85871";
 HQ1_generated_samples = [0,0,0,0,1,2,5,10,17,30,53,90,153,262,445,754,1281];
 HQ2_generated_samples = [0,0,0,0,0,0,1,2,5,10,17,30,53,90,153,262,445];
 HQ4_generated_samples = [0,0,0,0,0,0,0,1,2,5,10,17,30,53,90,153,262];
 HQA_generated_samples = [0,0,0,0,1,2,6,13,24,45,80,137,236,405,688,1169,1988];
 HQ1L_generated_samples = [0,0,0,0,0,0,2,4,6,12,22,36,62,108,182,308,526];
 HQ2L_generated_samples = [0,0,0,0,0,0,0,0,2,4,6,12,22,36,62,108,182];
 HQ4L_generated_samples = [0,0,0,0,0,0,0,0,0,2,4,6,12,22,36,62,108];
 HQAL_generated_samples = [0,0,0,0,0,0,2,4,8,18,32,54,96,166,280,478,816];
 HQ1R_generated_samples = [0,0,0,0,1,2,3,6,11,18,31,54,91,154,263,446,755];
 HQ2R_generated_samples = [0,0,0,0,0,0,1,2,3,6,11,18,31,54,91,154,263];
 HQ4R_generated_samples = [0,0,0,0,0,0,0,1,2,3,6,11,18,31,54,91,154];
 HQAR_generated_samples = [0,0,0,0,1,2,4,9,16,27,48,83,140,239,408,691,1172];
 BlobHQ1_generated_samples = [0,0,0,0,1,1,2,4,5,9,18,28,45,81,138,228,389];
 BlobHQ2_generated_samples = [0,0,0,0,0,0,1,1,2,4,5,9,18,28,45,81,138];
 BlobHQ4_generated_samples = [0,0,0,0,0,0,0,1,1,2,4,5,9,18,28,45,81];
 BlobHQA_generated_samples = [0,0,0,0,1,1,3,6,8,15,27,42,72,127,211,354,608];
 BlobHQ1L_generated_samples = [0,0,0,0,0,0,1,1,1,3,6,8,14,26,43,71,123];
 BlobHQ2L_generated_samples = [0,0,0,0,0,0,0,0,1,1,1,3,6,8,14,26,43];
 BlobHQ4L_generated_samples = [0,0,0,0,0,0,0,0,0,1,1,1,3,6,8,14,26];
 BlobHQAL_generated_samples = [0,0,0,0,0,0,1,1,2,5,8,12,23,40,65,111,192];
 BlobHQ1R_generated_samples = [0,0,0,0,1,1,1,3,4,6,12,20,31,55,95,157,266];
 BlobHQ2R_generated_samples = [0,0,0,0,0,0,1,1,1,3,4,6,12,20,31,55,95];
 BlobHQ4R_generated_samples = [0,0,0,0,0,0,0,1,1,1,3,4,6,12,20,31,55];
 BlobHQAR_generated_samples = [0,0,0,0,1,1,2,5,6,10,19,30,49,87,146,243,416];

gp_inline__location="../dragon.tex:85955";
 HQ1L(k) = if(k<3,0, 2*JA(k-3));
 gHQ1L(x) = 2 * x^3*gJA(x);

gp_inline__location="../dragon.tex:85959";
 HQ1L_samples = {[0,0,0,0,0,0,2,4,6,12,22,36,62,108]};

gp_inline__location="../dragon.tex:85973";
 HQ1R(k) = if(k<1,0, JA(k-1));
 gHQ1R(x) = x*gJA(x);

gp_inline__location="../dragon.tex:85977";
 HQ1R_samples = {[0,0,0,0,1,2,3,6,11,18,31,54,91,154]};

gp_inline__location="../dragon.tex:85988";
 HQ(k) = HQ1L(k) + HQ1R(k);
 gHQ1(x) = gHQ1L(x) + gHQ1R(x);

gp_inline__location="../dragon.tex:85999";
 HQ1_by_JA_formula(k) = JA(k) - 1;
 HQ1_by_JA(k) = if(k<3,0, HQ1_by_JA_formula(k));

gp_inline__location="../dragon.tex:86004";
 HQ1_samples = {[0,0,0,0,1,2,5,10,17,30,53,90,153,262]};

gp_inline__location="../dragon.tex:86092";
 HQ1L_k_plus_4_from_breakdown(k) = HQ1L(k+3) + 2*HQ1L(k+1) + if(k<2,0,2);
 HQ1L_from_breakdown(k) = if(k<4,0, HQ1L_k_plus_4_from_breakdown(k-4));

gp_inline__location="../dragon.tex:86179";
 HQ1R_k_plus_1_by_unfold(k) = HQ1R(k) + HQ1L(k) + if(k<3,0,1);
 HQ1R_by_unfold(k) = if(k<1,0, HQ1R_k_plus_1_by_unfold(k-1));

gp_inline__location="../dragon.tex:86202";
 BlobHQ1_recurrence_k = {8};

gp_inline__location="../dragon.tex:86206";
 BlobHQ1(k)=if(k<BlobHQ1_recurrence_k,BlobHQ1_samples[k+1], \
               BlobHQ1_formula(k));
 BlobHQ1 = memoize(BlobHQ1);
 BlobHQ1_formula = BlobA_recurrence_maker(BlobHQ1);

gp_inline__location="../dragon.tex:86211";
 BlobHQ1_samples = {[0,0,0,0,1,1,2,4,5,9,18,28,45,81,138,228]};
 gBlobHQ1(x) = (1-x)/(1+x^2) * gHQ1(x); /* alternating sum */

gp_inline__location="../dragon.tex:86226";
 BlobHQ1L_recurrence_k = {8};

gp_inline__location="../dragon.tex:86230";
 BlobHQ1L(k) = \
   if(k < BlobHQ1L_recurrence_k, BlobHQ1L_samples[k+1], \
      BlobHQ1L_formula(k));
 BlobHQ1L = memoize(BlobHQ1L);
 BlobHQ1L_formula = BlobAL_recurrence_maker(BlobHQ1L);

gp_inline__location="../dragon.tex:86236";
 BlobHQ1L_samples = {[0,0,0,0,0,0,1,1,1,3,6,8,14,26,43,71]};
 gBlobHQ1L(x) = 1/(1-x^4) * (gHQ1L(x) - x*gHQ1L(x) - x^2*gHQ1R(x) + x^3*gHQ1R(x));

gp_inline__location="../dragon.tex:86249";
 BlobHQ1R_recurrence_k = {10};

gp_inline__location="../dragon.tex:86253";
 BlobHQ1R(k) = \
   if(k < BlobHQ1R_recurrence_k, BlobHQ1R_samples[k+1], \
      BlobHQ1R_formula(k));
 BlobHQ1R = memoize(BlobHQ1R);
 BlobHQ1R_formula = BlobAL_recurrence_maker(BlobHQ1R);

gp_inline__location="../dragon.tex:86259";
 BlobHQ1R_samples = {[0,0,0,0,1,1,1,3,4,6,12,20,31,55,95,157]};
 gBlobHQ1R(x) = 1/(1-x^4) * (gHQ1R(x) - x*gHQ1R(x) - x^2*gHQ1L(x) + x^3*gHQ1L(x));

gp_inline__location="../dragon.tex:86276";
 HQ1_from_BlobHQ1(k) = \
   my(v=BlobList(k)); sum(j=1,#v, BlobHQ1(v[j]));

gp_inline__location="../dragon.tex:86280";
 HQ1L_from_BlobHQ1L_and_BlobHQ1R(k) = \
   sum(j=4,k, BlobHQ1L(j)) + sum(j=4,k-2, BlobHQ1R(j));

gp_inline__location="../dragon.tex:86284";
 HQ1R_from_BlobHQ1L_and_BlobHQ1R(k) = \
   sum(j=4,k, BlobHQ1R(j)) + sum(j=4,k-2, BlobHQ1L(j));

gp_inline__location="../dragon.tex:86288";
 BlobHQ1L_by_mutual_recurrence(k) = \
   if(k<2,return(BlobHQ1L(k))); \
   HQ1L(k)-HQ1L(k-1) - BlobHQ1R(k-2);
 BlobHQ1R_by_mutual_recurrence(k) = \
   if(k<2,return(BlobHQ1R(k))); \
   HQ1R(k)-HQ1R(k-1) - BlobHQ1L(k-2);

gp_inline__location="../dragon.tex:86297";
 BlobHQ1L_by_four_recurrence(k) = \
   if(k<4,return(BlobHQ1L(k))); \
   BlobHQ1L(k-4) + (HQ1L(k)-HQ1L(k-1)) - (HQ1R(k-2)-HQ1R(k-3));
 BlobHQ1R_by_four_recurrence(k) = \
   if(k<4,return(BlobHQ1R(k))); \
   BlobHQ1R(k-4) + (HQ1R(k)-HQ1R(k-1)) - (HQ1L(k-2)-HQ1L(k-3));

gp_inline__location="../dragon.tex:86394";
 HQ2L(k) = if(k<2,0, HQ1L(k-2));
 gHQ2L(x) = x^2*gHQ1L(x);

gp_inline__location="../dragon.tex:86402";
 HQ2R(k) = if(k<2,0, HQ1R(k-2));
 gHQ2R(x) = x^2*gHQ1R(x);

gp_inline__location="../dragon.tex:86410";
 HQ2(k) = if(k<2,0, HQ(k-2));
 gHQ2(x) = x^2*gHQ1(x);

gp_inline__location="../dragon.tex:86517";
 HQ4L(k) = if(k<3,0, HQ1L(k-3));
 gHQ4L(x) = x^3*gHQ1L(x);

gp_inline__location="../dragon.tex:86525";
 HQ4R(k) = if(k<3,0, HQ1R(k-3));
 gHQ4R(x) = x^3*gHQ1R(x);

gp_inline__location="../dragon.tex:86533";
 HQ4(k) = if(k<3,0, HQ(k-3));
 gHQ4(x) = x^3*gHQ1(x);

gp_inline__location="../dragon.tex:86558";
 HQA(k) =  (HQ(k) - HQ2(k) - HQ4(k)) \
        + 2*(HQ2(k) - HQ4(k)) \
        + 4*HQ4(k);
 gHQA(x) = (gHQ1(x) - gHQ2(x) - gHQ4(x)) \
        + 2*(gHQ2(x) - gHQ4(x)) \
        + 4*gHQ4(x);

gp_inline__location="../dragon.tex:86570";
 HQA_samples = {[0,0,0,0,1,2,6,13,24,45,80,137,236,405]};

gp_inline__location="../dragon.tex:86589";
 HQA_by_B_formula(k) = 5/8*B(k) + 1/8*B(k+1) - 1/4*B(k+2) - 7/2;
 HQA_by_B(k) = if(k<4,0, k==4,1, k==5,2, HQA_by_B_formula(k));
 gHQA_by_gB(x) = \
   5/8*gB(x) + 1/8*x^-1*(gB(x)-2) - 1/4*x^-2*(gB(x)-2-4*x) \
   - (7/2)/(1 - x) \
   + 15/4 + 4*x + 7/2*x^2 + 2*x^3 + 2*x^4 + x^5;

gp_inline__location="../dragon.tex:86608";
 HQA_over_B_limit = 5/2 + 1/2*r - r^2;

gp_inline__location="../dragon.tex:86610";
 HQA_over_B_limit_sample = {(0472680/1000000)};

gp_inline__location="../dragon.tex:86622";
 HQA_over_B_limit_nfelt = \
   5/2*one_nfelt + 1/2*r_nfelt - r_squared_nfelt;

gp_inline__location="../dragon.tex:86649";
 eight_over_r_pow_8_sample = {(0117073/1000000)};

gp_inline__location="../dragon.tex:86653";
 eight_over_r_pow_8 = 8/r^8;

gp_inline__location="../dragon.tex:86660";
 HQAL(k) =  (HQ1L(k) - HQ2L(k) - HQ4L(k)) \
        + 2*(HQ2L(k) - HQ4L(k)) \
        + 4*HQ4L(k);
 gHQAL(x) = (gHQ1L(x) - gHQ2L(x) - gHQ4L(x)) \
        + 2*(gHQ2L(x) - gHQ4L(x)) \
        + 4*gHQ4L(x);

gp_inline__location="../dragon.tex:86669";
 HQAR(k) =  (HQ1R(k) - HQ2R(k) - HQ4R(k)) \
        + 2*(HQ2R(k) - HQ4R(k)) \
        + 4*HQ4R(k);
 gHQAR(x) = (gHQ1R(x) - gHQ2R(x) - gHQ4R(x)) \
        + 2*(gHQ2R(x) - gHQ4R(x)) \
        + 4*gHQ4R(x);

gp_inline__location="../dragon.tex:86678";
 HQAL_by_L_formula(k) = 5/8*L(k) + 1/8*L(k+1) - 1/4*L(k+2) - 3;
 HQAL_by_L(k) = if(k<6,0, HQAL_by_L_formula(k));
 gHQAL_by_gL(x) = \
   5/8*gL(x) + 1/8*x^-1*(gL(x)-1) - 1/4*x^-2*(gL(x)-1-2*x) \
   - 3*x^4/(1 - x) \
   + 1/8 + 1/4*x - 1/2*x^2 - 3/2*x^3 + 2*x^4 + x^5;

gp_inline__location="../dragon.tex:86690";
 HQAR_by_R_formula(k) = 5/8*R(k) + 1/8*R(k+1) - 1/4*R(k+2) - 1/2;
 HQAR_by_R(k) = if(k<4,0, HQAR_by_R_formula(k));
 gHQAR_by_gR(x) = \
   5/8*gR(x) + 1/8*x^-1*(gR(x)-1) - 1/4*x^-2*(gR(x)-1-2*x) \
   - 1/2*x^4/(1 - x) \
   + 1/8 + 1/4*x + 1/2*x^2;

gp_inline__location="../dragon.tex:86707";
 BlobHQ2_recurrence_k = 10;
 BlobHQ2(k) = \
   if(k<BlobHQ2_recurrence_k, \
      BlobHQ2_generated_samples[k+1],\
      BlobHQ2_formula(k));
 BlobHQ2 = memoize(BlobHQ2);
 BlobHQ2_formula = BlobA_recurrence_maker(BlobHQ2);
 gBlobHQ2(x) = (1-x)/(1+x^2) * gHQ2(x); /* alternating sum */

gp_inline__location="../dragon.tex:86720";
 BlobHQ2L_recurrence_k = 10;
 BlobHQ2L(k) = \
   if(k < BlobHQ2L_recurrence_k, \
      BlobHQ2L_generated_samples[k+1], \
      BlobHQ2L_formula(k));
 BlobHQ2L = memoize(BlobHQ2L);
 BlobHQ2L_formula = BlobAL_recurrence_maker(BlobHQ2L);
 gBlobHQ2L(x) = 1/(1-x^4) * (gHQ2L(x) - x*gHQ2L(x) - x^2*gHQ2R(x) + x^3*gHQ2R(x));

gp_inline__location="../dragon.tex:86731";
 BlobHQ2R_recurrence_k = 12;
 BlobHQ2R(k) = \
   if(k < BlobHQ2R_recurrence_k, \
      BlobHQ2R_generated_samples[k+1], \
      BlobHQ2R_formula(k));
 BlobHQ2R = memoize(BlobHQ2R);
 BlobHQ2R_formula = BlobAL_recurrence_maker(BlobHQ2R);
 gBlobHQ2R(x) = 1/(1-x^4) * (gHQ2R(x) - x*gHQ2R(x) - x^2*gHQ2L(x) + x^3*gHQ2L(x));

gp_inline__location="../dragon.tex:86746";
 BlobHQ4_recurrence_k = 11;
 BlobHQ4(k) = \
   if(k<BlobHQ4_recurrence_k, \
      BlobHQ4_generated_samples[k+1],\
      BlobHQ4_formula(k));
 BlobHQ4 = memoize(BlobHQ4);
 BlobHQ4_formula = BlobA_recurrence_maker(BlobHQ4);
 gBlobHQ4(x) = (1-x)/(1+x^2) * gHQ4(x); /* alternating sum */

gp_inline__location="../dragon.tex:86759";
 BlobHQ4L_recurrence_k = 11;
 BlobHQ4L(k) = \
   if(k < BlobHQ4L_recurrence_k, \
      BlobHQ4L_generated_samples[k+1], \
      BlobHQ4L_formula(k));
 BlobHQ4L = memoize(BlobHQ4L);
 BlobHQ4L_formula = BlobAL_recurrence_maker(BlobHQ4L);
 gBlobHQ4L(x) = 1/(1-x^4) * (gHQ4L(x) - x*gHQ4L(x) - x^2*gHQ4R(x) + x^3*gHQ4R(x));

gp_inline__location="../dragon.tex:86770";
 BlobHQ4R_recurrence_k = 13;
 BlobHQ4R(k) = \
   if(k < BlobHQ4R_recurrence_k, \
      BlobHQ4R_generated_samples[k+1], \
      BlobHQ4R_formula(k));
 BlobHQ4R = memoize(BlobHQ4R);
 BlobHQ4R_formula = BlobAL_recurrence_maker(BlobHQ4R);
 gBlobHQ4R(x) = 1/(1-x^4) * (gHQ4R(x) - x*gHQ4R(x) - x^2*gHQ4L(x) + x^3*gHQ4L(x));

gp_inline__location="../dragon.tex:86784";
 BlobHQA(k) =  (BlobHQ1(k) - BlobHQ2(k) - BlobHQ4(k)) \
        + 2*(BlobHQ2(k) - BlobHQ4(k)) \
        + 4*BlobHQ4(k);
 gBlobHQA(x) = (gBlobHQ1(x) - gBlobHQ2(x) - gBlobHQ4(x)) \
        + 2*(gBlobHQ2(x) - gBlobHQ4(x)) \
        + 4*gBlobHQ4(x);

gp_inline__location="../dragon.tex:86793";
 BlobHQAL(k) =  (BlobHQ1L(k) - BlobHQ2L(k) - BlobHQ4L(k)) \
        + 2*(BlobHQ2L(k) - BlobHQ4L(k)) \
        + 4*BlobHQ4L(k);
 gBlobHQAL(x) = (gBlobHQ1L(x) - gBlobHQ2L(x) - gBlobHQ4L(x)) \
        + 2*(gBlobHQ2L(x) - gBlobHQ4L(x)) \
        + 4*gBlobHQ4L(x);

gp_inline__location="../dragon.tex:86802";
 BlobHQAR(k) =  (BlobHQ1R(k) - BlobHQ2R(k) - BlobHQ4R(k)) \
        + 2*(BlobHQ2R(k) - BlobHQ4R(k)) \
        + 4*BlobHQ4R(k);
 gBlobHQAR(x) = (gBlobHQ1R(x) - gBlobHQ2R(x) - gBlobHQ4R(x)) \
        + 2*(gBlobHQ2R(x) - gBlobHQ4R(x)) \
        + 4*gBlobHQ4R(x);

gp_inline__location="../dragon.tex:86824";
 BlobHQA_by_BlobB_vector = {[13,7,11,17]};

gp_inline__location="../dragon.tex:86828";
 four_BlobHQA_by_BlobB_formula(k) = \
   5/2*BlobB(k) + 1/2*BlobB(k+1) - BlobB(k+2) \
   + vector_modulo(BlobHQA_by_BlobB_vector,k);
 four_BlobHQA_by_BlobB(k) = if(k<5, 4*BlobHQA(k), \
                          four_BlobHQA_by_BlobB_formula(k));

gp_inline__location="../dragon.tex:86860";
 BlobPB(k) = BlobB(k) - if(k==4,0, BlobHQA(k));

gp_inline__location="../dragon.tex:86862";
BlobPB_samples = {[0,0,0,0,4,9,17,32,60,107,185,316]};

gp_inline__location="../dragon.tex:86879";
 gBlobPB(x) = {
   -6 * 1/(1-x)
   + 1/2 * (-1 + 3*x)/(1 + x^2)
   + 1/2*(2 + 2*x + x^2)/(1-x-2*x^3)
   + 11/2 + 5/2*x + 3*x^2 + 3*x^3 + 2*x^4;
 }

gp_inline__location="../dragon.tex:86894";
 BlobPE(k) = BlobP(k) - BlobPB(k);

gp_inline__location="../dragon.tex:86896";
 BlobPE_samples = {[0,0,0,0,0,0,0,2,8,26,72,182]};

gp_inline__location="../dragon.tex:86905";
 gBlobPE(x) = {
   4 * 1/(1-x)
   + 1/5 * (4 - 2*x)/(1 + x^2)
   - 1/2*(1 + 2*x + x^2)/(1-x-2*x^3)
   + 1/5 * 1/(1 - 2*x)
   - 9/2 - 5/2*x - 2*x^2 - 3*x^3 - 2*x^4;
 }

gp_inline__location="../dragon.tex:86940";
 NonBlobPoints_formula(k) = 4*k - 4;
 NonBlobPoints(k) = if(k<=3, 2^k+1, NonBlobPoints_formula(k));

gp_inline__location="../dragon.tex:86948";
NonBlobPoints_samples = {[2,3,5,9,12,16,20,24,28,32]};

gp_inline__location="../dragon.tex:86966";
 PB(k) = {
   my(v=BlobList(k));
   sum(j=1,#v, BlobPB(v[j])) + NonBlobPoints(k);
 }
 PB = memoize(PB);

gp_inline__location="../dragon.tex:86975";
 PB_by_HQA(k) = B(k) - HQA(k) - 8*k + 24;

gp_inline__location="../dragon.tex:86978";
PB_samples = {[2,3,5,9,16,29,54,99,180,323,572,999,1728]};

gp_inline__location="../dragon.tex:86993";
 gPB(x) = {
   69/2 * 1/(1-x)
   - 8  * 1/(1-x)^2
   + 1/4 * (13 + 9*x + 14*x^2)/(1-x-2*x^3)
   - 111/4 - 21*x - 29/2*x^2 - 9*x^3 - 5*x^4 - 2*x^5;
 }

gp_inline__location="../dragon.tex:87001";
 gPB_by_B(x) = gB(x) - gHQA(x) - 8/(1-x)^2 + 32/(1-x) \
   - 24 - 17*x - 11*x^2 - 7*x^3 - 3*x^4 - x^5;

gp_inline__location="../dragon.tex:87012";
 PE(k) = P(k) - PB(k);

gp_inline__location="../dragon.tex:87014";
 PE_samples = {[0,0,0,0,0,0,0,2,10,38,118,326,830]};

gp_inline__location="../dragon.tex:87034";
 gPE(x) = {
   -34 * 1/(1-x)
   + 8 * 1/(1-x)^2
   + 1/2 * 1/(1-2*x)
   - 1/4*(9 + 7*x + 10*x^2)/(1-x-2*x^3)
   + 111/4 + 21*x + 29/2*x^2 + 9*x^3 + 5*x^4 + 2*x^5;
 }

gp_inline__location="../dragon.tex:87222";
 DB(k) = PB(k) - S(k);
 gDB(x) = gPB(x) - gS(x);

gp_inline__location="../dragon.tex:87228";
DB_samples = {[0,0,0,0,1,4,11,26,57,114,217,398,709]};

gp_inline__location="../dragon.tex:87239";
 BlobDB(k) = BlobPB(k) - BlobS(k);

gp_inline__location="../dragon.tex:87244";
BlobDB_samples = {[0,0,0,0,1,3,6,12,25,45,78,136,233]};

gp_inline__location="../dragon.tex:87266";
 S_from_PB(k) = 1/29*(16*PB(k) + 24*PB(k+1) - 14*PB(k+2) \
                      + 208*k - 721);

gp_inline__location="../dragon.tex:87278";
 S_over_PB_limit = 16/29 + 24/29*r - 14/29*r^2;
 S_over_PB_limit_sample = {(0567002/1000000)};

gp_inline__location="../dragon.tex:87294";
 DB_over_PB_limit = 13/29 - 24/29*r + 14/29*r^2;
 DB_over_PB_limit_sample = {(0432997/1000000)};

gp_inline__location="../dragon.tex:87308";
 gS_from_PB(x) = {
   745/29 + 558/29*x + 378/29*x^2 + 236/29*x^3
   + 128/29*x^4 + 32/29*x^5
   - (929/29)/(1 - x)
   + (208/29)/(1 - x)^2
   + 16/29*gPB(x)
   + 24/29*(gPB(x)-2)/x
   - 14/29*(gPB(x)-2-3*x)/x^2;
 }

gp_inline__location="../dragon.tex:87328";
 DBnH(k) = DB(k) - HQA(k);
 gDBnH(x) = gDB(x) - gHQA(x);

gp_inline__location="../dragon.tex:87335";
 DBnH_samples = {[0,0,0,0,0,2,5,13,33,69,137,261]};

gp_inline__location="../dragon.tex:87356";
 HQA_from_DB(k) = 1/19*(-27*DB(k) + 16*DB(k+1) + 2*DB(k+2) \
                        - 72*k + 313);

gp_inline__location="../dragon.tex:87374";
 DBnH_from_DB(k) = 1/19*(46*DB(k) - 16*DB(k+1) - 2*DB(k+2) \
                         + 72*k - 313);

gp_inline__location="../dragon.tex:87386";
 HQA_over_DB_limit = -27/19 + 16/19*r + 2/19*r^2;
 HQA_over_DB_limit_nfelt = \
   -27/19*one_nfelt + 16/19*r_nfelt + 2/19*r_squared_nfelt;
 HQA_over_DB_limit_sample = {(0309483/1000000)};

gp_inline__location="../dragon.tex:87409";
 DBnH_over_DB_limit = 46/19 - 16/19*r - 2/19*r^2;
 DBnH_over_DB_limit_sample = {(0690516/1000000)};

gp_inline__location="../dragon.tex:87437";
 HQA_from_PB(k) = 1/29*(3*PB(k) + 48*PB(k+1) - 28*PB(k+2) \
                        + 184*k - 804);

gp_inline__location="../dragon.tex:87456";
 DBnH_from_PB(k) = 1/29*(10*PB(k) - 72*PB(k+1) + 42*PB(k+2) \
                        - 392*k + 1525);

gp_inline__location="../dragon.tex:87468";
 HQA_over_PB_limit = 3/29 + 48/29*r - 28/29*r^2;
 HQA_over_PB_limit_sample = {(0134005/1000000)};

gp_inline__location="../dragon.tex:87485";
 DBnH_over_PB_limit = 10/29 - 72/29*r + 42/29*r^2;
 DBnH_over_PB_limit_sample = {(0298991/1000000)};

gp_inline__location="../dragon.tex:87498";
 BlobDBnH(k) = BlobDB(k) - BlobHQA(k);

gp_inline__location="../dragon.tex:87516";
 PL(k) = L(k)+1 - HQAL(k);

gp_inline__location="../dragon.tex:87518";
PL_samples = {[2,3,5,9,13,21,35,57,93,155,261]};

gp_inline__location="../dragon.tex:87532";
 gPL(x) = 4*1/(1 - x) \
   + 1/4*(6 + 3*x + 5*x^2)/(1 - x - 2*x^3) \
   - 7/2 - 13/4*x - 5/2*x^2 - 3/2*x^3 - 2*x^4 - x^5;

gp_inline__location="../dragon.tex:87544";
 PR(k) = R(k)+1 - HQAR(k);

gp_inline__location="../dragon.tex:87546";
PR_samples = {[2,3,5,9,16,27,45,76,129,218]};

gp_inline__location="../dragon.tex:87560";
 gPR(x) = 1/2*1/(1 - x) \
   + 1/4*(7 + 6*x + 9*x^2)/(1 - x - 2*x^3) \
   - 1/4 - 3/4*x - x^2 - 1/2*x^3;

gp_inline__location="../dragon.tex:87701";
 Pboth_initial = {[2,3,5,9,13,19]};

gp_inline__location="../dragon.tex:87715";
 Pboth_formula(k) = 8*k - 22;
 Pboth(k) = if(k<=5, Pboth_initial[k+1], Pboth_formula(k));

gp_inline__location="../dragon.tex:87728";
 PR_k_plus_1_by_PB(k) = PB(k) + Pboth(k) \
   - if(k<=2,1, k==3||k==4,2, k==5,3, 4);

gp_inline__location="../dragon.tex:87751";
 gPL_by_PB(x) = {
   gPB(x)
   + 1/2 * 1/x*(gPB(x) - 2)
   - 1/2 * 1/x^2*(gPB(x) - 2 - 3*x)
   - 69/2 * 1/(1 - x)
   + 8/(1-x)^2
   + 55/2 + 41/2*x + 14*x^2 + 9*x^3 + 4*x^4 + x^5;
 }

gp_inline__location="../dragon.tex:87768";
 PL_plus_PR_by_PB(k) = PB(k) + Pboth(k);

gp_inline__location="../dragon.tex:87792";
 PR_over_PB_limit = 1/r;
 PR_over_PB_limit_sample = {(0589754/1000000)};

gp_inline__location="../dragon.tex:87805";
 PL_over_PB_limit = 1 - 1/r;
 PL_over_PB_limit_sample = {(0410245/1000000)};

gp_inline__location="../dragon.tex:87819";
 THQA(k) = 2*HQAR(k+1) + if(k==0,0, k==1,2, k==2,4, 6);

gp_inline__location="../dragon.tex:87843";
 TPB(k) = TB(k)-2*HQAR(k+1) - if(k==0,0, k==1,1, k==2,3, k==3,5, 6);
 gTPB(x) = gTB(x) - 2*1/x*gHQAR(x) \
   - (x + 3*x^2 + 5*x^3 + 6*x^4*gOnes(x));

gp_inline__location="../dragon.tex:87848";
 TPB_samples = {[4,7,13,25,46,82,144,250,428,730]};

gp_inline__location="../dragon.tex:87860";
 TPE(k) = TP(k) - TPB(k);
 gTPE(x) = gTP(x) - gTPB(x);

gp_inline__location="../dragon.tex:87864";
 TPE_samples = {[0,0,0,0,1,7,27,79,207,503]};

gp_inline__location="../dragon.tex:87894";
 TDB(k) = TD(k) - TPE(k);
 gTDB(x) = gTD(x) - gTPE(x);

gp_inline__location="../dragon.tex:87901";
 TDB_by_TPB_sub_S(k) = TPB(k) - TS(k);

gp_inline__location="../dragon.tex:87907";
 TDB_samples = {[0,1,3,7,16,32,58,104,182,312]};

gp_inline__location="../dragon.tex:87924";
 TDB_by_EightB(k) = EightB(k) - if(k<4,1,0);

gp_inline__location="../dragon.tex:88024";
 TP_generated_samples = [ 4,7,13,25,47,89,171 ];
 TD_generated_samples = [ 0,1,3,7,17,39,85 ];
 TS_generated_samples = [ 4,6,10,18,30,50,86 ];
 TPB_generated_samples = [ 4,7,13,25,46,82,144 ];
 TPE_generated_samples = [ 0,0,0,0,1,7,27 ];
 TDB_generated_samples = [ 0,1,3,7,16,32,58 ];

gp_inline__location="../dragon.tex:88128";
 TR1_initial = {[1,2,3,4]};

gp_inline__location="../dragon.tex:88133";
 TR1_factor = {(53)/(100)};

gp_inline__location="../dragon.tex:88138";
 TR1_multiply_vector = {[(-3)/(10),(2)/(5),(3)/(10),(-2)/(5)]};

gp_inline__location="../dragon.tex:88145";
 TR1_constant_vector = {[(43)/(25),(1)/(25),(-43)/(25),(-1)/(25)]};

gp_inline__location="../dragon.tex:88153";
 TR1(k) = {
   if(k<4, return(TR1_initial[k+1]));
   TR1_factor * 2^k
   + k*vector_modulo(TR1_multiply_vector,k)
   +   vector_modulo(TR1_constant_vector,k);
 }

gp_inline__location="../dragon.tex:88162";
 TR2_initial = {[1,0,1,3]};

gp_inline__location="../dragon.tex:88168";
 TR2_factor = {(11)/(50)};

gp_inline__location="../dragon.tex:88173";
 TR2_multiply_vector = {[(-3)/(10),(2)/(5),(3)/(10),(-2)/(5)]};

gp_inline__location="../dragon.tex:88180";
 TR2_constant_vector = {[(43)/(25),(1)/(25),(-43)/(25),(-1)/(25)]};

gp_inline__location="../dragon.tex:88188";
 TR2(k) = {
   if(k<4, return(TR2_initial[k+1]));
   TR2_factor * 2^k
   - k*vector_modulo(TR2_multiply_vector,k)
   -   vector_modulo(TR2_constant_vector,k);
 }

gp_inline__location="../dragon.tex:88197";
 TR8_initial = {[0,1,0,1]};

gp_inline__location="../dragon.tex:88202";
 TR8_factor = {(61)/(300)};

gp_inline__location="../dragon.tex:88207";
 TR8_multiply_vector = {[(1)/(20),(7)/(20),(-1)/(20),(-7)/(20)]};

gp_inline__location="../dragon.tex:88214";
 TR8_constant_vector = {[(41)/(75),(-377)/(300),(-107)/(150),(427)/(300)]};

gp_inline__location="../dragon.tex:88222";
 TR8(k) = {
   if(k<4, return(TR8_initial[k+1]));
   TR8_factor * 2^k
   + k*vector_modulo(TR8_multiply_vector,k)
   +   vector_modulo(TR8_constant_vector,k);
 }

gp_inline__location="../dragon.tex:88234";
 TR9_factor = {(1)/(20)};

gp_inline__location="../dragon.tex:88239";
 TR9_constant_vector = {[(-4)/(5),(-3)/(5),(4)/(5),(3)/(5)]};

gp_inline__location="../dragon.tex:88247";
 TR9(k) = {
   if(k<4, return(0));
   TR9_factor * 2^k + vector_modulo(TR9_constant_vector,k);
 }

gp_inline__location="../dragon.tex:88254";
 TR10_initial = {[0,1,3,3]};

gp_inline__location="../dragon.tex:88260";
 TR10_factor = {(113)/(300)};

gp_inline__location="../dragon.tex:88265";
 TR10_multiply_vector = {[(-7)/(20),(1)/(20),(7)/(20),(-1)/(20)]};

gp_inline__location="../dragon.tex:88272";
 TR10_constant_vector = {[(28)/(75),(209)/(300),(-31)/(150),(-259)/(300)]};

gp_inline__location="../dragon.tex:88280";
 TR10(k) = {
   if(k<4, return(TR10_initial[k+1]));
   TR10_factor * 2^k
   + k*vector_modulo(TR10_multiply_vector,k)
   +   vector_modulo(TR10_constant_vector,k);
 }

gp_inline__location="../dragon.tex:88289";
 TR11_initial = {[0,0,1,3]};

gp_inline__location="../dragon.tex:88295";
 TR11_factor = {(16)/(75)};

gp_inline__location="../dragon.tex:88300";
 TR11_multiply_vector = {[(-1)/(20),(-7)/(20),(1)/(20),(7)/(20)]};

gp_inline__location="../dragon.tex:88307";
 TR11_constant_vector = {[(-16)/(75),(-23)/(300),(7)/(150),(73)/(300)]};

gp_inline__location="../dragon.tex:88315";
 TR11(k) = {
   if(k<4, return(TR11_initial[k+1]));
   TR11_factor * 2^k
   + k*vector_modulo(TR11_multiply_vector,k)
   +   vector_modulo(TR11_constant_vector,k);
 }

gp_inline__location="../dragon.tex:88324";
 TR3(k) = if(k<1,0,TR11(k-1));

gp_inline__location="../dragon.tex:88327";
 TR6(k) = if(k<4,0,TR11(k-4));

gp_inline__location="../dragon.tex:88330";
 TR4(k) = if(k<2,0,TR11(k-2));

gp_inline__location="../dragon.tex:88333";
 TR7(k) = if(k<5,0,TR11(k-5));

gp_inline__location="../dragon.tex:88336";
 TR5(k) = if(k<3,0,TR11(k-3));

gp_inline__location="../dragon.tex:88339";
 TR12(k) = if(k<1,0,TR11(k-1));

gp_inline__location="../dragon.tex:88342";
 TR14(k) = if(k<3,0,TR11(k-3));

gp_inline__location="../dragon.tex:88346";
 TR13(k) = if(k<2,0,TR11(k-2));

gp_inline__location="../dragon.tex:88349";
 TR15(k) = if(k<4,0,TR11(k-4));

gp_inline__location="../dragon.tex:88351";
 TR_function_vector = {[
   TR1, TR2, TR3, TR4, TR5, TR6, TR7,
   TR8, TR9, TR10, TR11, TR12, TR13, TR14, TR15
 ]};
 TR(k,a) = TR_function_vector[a](k);

gp_inline__location="../dragon.tex:88360";
 TR1_samples = {[1,2,3,4,9,19,34,65,135,275,544,1081]};

gp_inline__location="../dragon.tex:88367";
 TR2_samples = {[1,0,1,3,3,5,14,31,57,109,224,455]};

gp_inline__location="../dragon.tex:88374";
 TR3_samples = {[0,0,0,1,3,3,5,14,30,54,106,219,441]};

gp_inline__location="../dragon.tex:88381";
 TR4_samples = {[0,0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88387";
 TR5_samples = {[0,0,0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88393";
 TR6_samples = {[0,0,0,0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88399";
 TR7_samples = {[0,0,0,0,0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88405";
 TR8_samples = {[0,1,0,1,4,7,12,25,53,106,207,414]};

gp_inline__location="../dragon.tex:88412";
 TR9_samples = {[0,0,0,0,0,1,4,7,12,25,52,103,204]};

gp_inline__location="../dragon.tex:88419";
 TR10_samples = {[0,1,3,3,5,13,26,47,94,194,389,770,1539]};

gp_inline__location="../dragon.tex:88426";
 TR11_samples = {[0,0,1,3,3,5,14,30,54,106,219,441,873]};

gp_inline__location="../dragon.tex:88433";
 TR12_samples = {[0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88439";
 TR13_samples = {[0,0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88445";
 TR14_samples = {[0,0,0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88451";
 TR15_samples = {[0,0,0,0,0,0,1,3,3,5,14,30,54,106]};

gp_inline__location="../dragon.tex:88456";
 point_left_of_line(p, l1,l2) = imag( (p-l1)/(l2-l1) ) >= 0;
 point_in_convex(p,polygon) = {
   for(i=1,#polygon-1,
     point_left_of_line(p, polygon[i],polygon[i+1]) || return(0));
   point_left_of_line(p, polygon[#polygon],polygon[1]);
 }
 TR_polygon_list = {[
   [ 0, 1/2 - 1/2*I, 1 ],   \\ 1
   [ 0, 1, 1/2 + 1/2*I ],   \\ 2
   [ 1, 1+I, 1/2 + 1/2*I ],   \\ 3
   [ 1, 3/2 + 1/2*I, 1+I ],   \\ 4
   [ 1, 2, 3/2 + 1/2*I ],    \\ 5
   [ 1, 3/2 - 1/2*I, 1+I ],  \\ 6
   [ 1, 1-I, 3/2 - 1/2*I ],    \\ 7
   [ 1, 1/2 - 1/2*I, 1-I ],    \\ 8
   [ -I, 1-I, 1/2 - 1/2*I ],    \\ 9
   [ 0, -I, 1/2 - 1/2*I ],    \\ 10
   [ 0, -1/2 - 1/2*I, -I ],    \\ 11
   [ 0, -1, -1/2 - 1/2*I ],    \\ 12
   [ 0, -1/2 + 1/2*I, -1 ],    \\ 13
   [ 0, I, -1/2 + 1/2*I ],    \\ 14
   [ 0, 1/2 + 1/2*I, I ]     \\ 15
 ]};
 points_in_convex(p_list,polygon) = {
   for(i=1,#p_list,
     point_in_convex(p_list[i],polygon) || return(0));
   1;
 }
 fsegment_to_regions(s,e) = {
   vector(2,rep,
          my(m=s + (e-s)*(1/2 + 1/2*I*if(rep==1,-1,1)), r=0,
             p_list=[s,e,m]);
          for(i=1,#TR_polygon_list,
            if(points_in_convex(p_list,TR_polygon_list[i]),
               r=i; break()));
          r);
 }
 TR_counts_by_segments(k) = {
   my(v=dragon_points(k) / b^k,
      ret=vector(15));
   for(i=1,#v-1,
     my(r1,r2);
     [r1,r2]=fsegment_to_regions(v[i],v[i+1]);
     ret[r1]++;
     ret[r2]++);
   ret;
 }

gp_inline__location="../dragon.tex:88537";
 gTR1(x) = \
   53/100 * 1/(1-2*x) \
   + 1/25 * (58 - 9*x)/(1+x^2) \
   - 1/5 * (3 - 4*x)/(1+x^2)^2 \
   - 5/4 + 1/2*x + 2*x^2 + x^3;

gp_inline__location="../dragon.tex:88553";
 gTR2(x) = \
   11/50*1/(1-2*x) \
   - 1/25*(58-9*x)/(1+x^2) \
   + 1/5*(3 - 4*x)/(1+x^2)^2 \
   + 5/2 - x^2;

gp_inline__location="../dragon.tex:88569";
 gTR8(x) = \
   61/300*1/(1-2*x) \
   + 1/100*(53-169*x)/(1+x^2) \
   + 1/10*(1 + 7*x)/(1+x^2)^2 \
   - 1/12/(1+x) \
   - 3/4 + 3/2*x - x^3;

gp_inline__location="../dragon.tex:88586";
 gTR9(x) = \
   1/20*1/(1-2*x) \
   - 1/5*(4+3*x)/(1+x^2) \
   + 3/4 + 1/2*x - x^2 - x^3;

gp_inline__location="../dragon.tex:88601";
 gTR10(x) = \
     113/300 * 1/(1-2*x) \
   + 1/12 * 1/(1+x) \
   + 1/100 * (99 + 73*x)/(1+x^2) \
   + 1/10 * (-7 + x)/(1+x^2)^2 \
   - (3/4 + 1/2*x - x^2 - x^3);

gp_inline__location="../dragon.tex:88616";
 gTR11(x) = \
     16/75 * 1/(1-2*x) \
   - 1/12 * 1/(1+x) \
   + 1/100 * (-3 + 19*x)/(1+x^2) \
   - 1/10 * (1 + 7*x)/(1+x^2)^2;

gp_inline__location="../dragon.tex:88626";
 gTR3(x) = x*gTR11(x);

gp_inline__location="../dragon.tex:88631";
 gTR6(x) = x^4*gTR11(x);

gp_inline__location="../dragon.tex:88635";
 gTR4(x) = x^2*gTR11(x);

gp_inline__location="../dragon.tex:88639";
 gTR7(x) = x^5*gTR11(x);

gp_inline__location="../dragon.tex:88643";
 gTR5(x) = x^3*gTR11(x);

gp_inline__location="../dragon.tex:88647";
 gTR12(x) = x*gTR11(x);

gp_inline__location="../dragon.tex:88653";
 gTR14(x) = x^3*gTR11(x);

gp_inline__location="../dragon.tex:88657";
 gTR13(x) = x^2*gTR11(x);

gp_inline__location="../dragon.tex:88662";
 gTR15(x) = x^4*gTR11(x);

gp_inline__location="../dragon.tex:88665";
 gTR3_partial_fractions(x) = \
     8/75 * 1/(1-2*x) \
   + 1/12 * 1/(1+x) \
   - 1/100 * (89 + 3*x)/(1+x^2) \
   + 1/10 * (7 - x)/(1+x^2)^2;

gp_inline__location="../dragon.tex:88795";
 TR1_by_mutual(k) = if(k==0,return(TR1(k))); \
   TR1(k-1) + TR2(k-1) + TR3(k-1) + TR8(k-1);

gp_inline__location="../dragon.tex:88802";
 TR2_by_mutual(k) = if(k==0,return(TR2(k))); \
   TR9(k-1) + TR10(k-1) + TR15(k-1);

gp_inline__location="../dragon.tex:88825";
 TR8_by_mutual(k) = if(k==0,return(TR8(k))); \
   TR2(k-1) + TR3(k-1) + TR4(k-1) + TR5(k-1);

gp_inline__location="../dragon.tex:88833";
 TR9_by_mutual(k) = if(k==0,return(TR9(k))); \
   TR4(k-1) + TR5(k-1) + TR6(k-1) + TR7(k-1);

gp_inline__location="../dragon.tex:88841";
 TR10_by_mutual(k) = if(k==0,return(TR10(k))); \
   TR1(k-1) + TR6(k-1) + TR7(k-1) + TR8(k-1);

gp_inline__location="../dragon.tex:88872";
 TR_all_regions(k) = sum(j=1,15, TR(k,j));

gp_inline__location="../dragon.tex:88879";
 TR_matrix = matrix(15,15);
 TR_matrix_store(from,to,value) = {
   if(TR_matrix[from,to], error("oops, TR_matrix ",from,",",to," already set"));
   TR_matrix[from,to] = value;
 }
 TR_initial = vectorv(15,a, a<=2);
 TR_vector(k) = TR_matrix^k * TR_initial;
 TR_vector = memoize(TR_vector);
 TR_by_matrix(k,a) = TR_vector(k)[a];

gp_inline__location="../dragon.tex:88919";
 TR_matrix_store(1,1, 1);
 TR_matrix_store(1,2, 1);
 TR_matrix_store(1,3, 1);
 TR_matrix_store(1,8, 1);

gp_inline__location="../dragon.tex:88928";
 TR_matrix_store(2,9,  1);
 TR_matrix_store(2,10, 1);
 TR_matrix_store(2,15, 1);

gp_inline__location="../dragon.tex:88934";
 TR_matrix_store(3,11, 1);

gp_inline__location="../dragon.tex:88938";
 TR_matrix_store(4,12, 1);

gp_inline__location="../dragon.tex:88942";
 TR_matrix_store(5,13, 1);

gp_inline__location="../dragon.tex:88946";
 TR_matrix_store(6,14, 1);

gp_inline__location="../dragon.tex:88950";
 TR_matrix_store(7,15, 1);

gp_inline__location="../dragon.tex:88957";
 TR_matrix_store(8,2, 1);
 TR_matrix_store(8,3, 1);
 TR_matrix_store(8,4, 1);
 TR_matrix_store(8,5, 1);

gp_inline__location="../dragon.tex:88967";
 TR_matrix_store(9,4, 1);
 TR_matrix_store(9,5, 1);
 TR_matrix_store(9,6, 1);
 TR_matrix_store(9,7, 1);

gp_inline__location="../dragon.tex:88977";
 TR_matrix_store(10,1, 1);
 TR_matrix_store(10,6, 1);
 TR_matrix_store(10,7, 1);
 TR_matrix_store(10,8, 1);

gp_inline__location="../dragon.tex:88985";
 TR_matrix_store(11,9, 1);
 TR_matrix_store(11,10, 1);

gp_inline__location="../dragon.tex:88990";
 TR_matrix_store(12,11, 1);

gp_inline__location="../dragon.tex:88994";
 TR_matrix_store(13,12, 1);

gp_inline__location="../dragon.tex:88998";
 TR_matrix_store(14,13, 1);

gp_inline__location="../dragon.tex:89002";
 TR_matrix_store(15,14, 1);

gp_inline__location="../dragon.tex:89022";
 TR_gf_column = (matid(15) - TR_matrix*x)^-1 * TR_initial;

gp_inline__location="../dragon.tex:89069";
 TR_limits = [159,66,32,16,8,4,2,61,15,113,64,32,16,8,4] / 300;

gp_inline__location="../dragon.tex:89141";
 TR_left_triangle = [66,8,32,113, 16,4,61];

gp_inline__location="../dragon.tex:89167";
 TR_right_triangle = [159,4,16,64, 2,8,32, 15];

gp_inline__location="../dragon.tex:89215";
 TR_squares = [24,102,24, 96,348,6];

gp_inline__location="../dragon.tex:89272";
 TR_diagonals = [48,12, 12,225,63,  48,177,15];

gp_inline__location="../dragon.tex:89422";
 gen_edge_count_samples_DegCount1 = [2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2];
 gen_edge_count_samples_DegCount2 = [0,1,3,7,13,23,41,71,121,207,353,599,1017,1727,2929,4967,8425];
 gen_edge_count_samples_DegCount4 = [0,0,0,0,1,4,11,28,67,152,335,724,1539,3232,6727,13900,28555];
 gen_edge_count_samples_EdgeCount11 = [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];
 gen_edge_count_samples_EdgeCount12 = [0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2];
 gen_edge_count_samples_EdgeCount22 = [0,0,2,6,10,16,26,40,62,100,162,264,438,732,1226,2064,3486];
 gen_edge_count_samples_EdgeCount24 = [0,0,0,0,4,12,28,60,116,212,380,668,1156,1988,3404,5804,9876];
 gen_edge_count_samples_EdgeCount44 = [0,0,0,0,0,2,8,26,76,198,480,1114,2500,5470,11752,24898,52172];
 gen_edge_count_samples_EdgeCount44b = [0,0,0,0,0,1,5,13,29,61,117,213,381,669,1157,1989,3405];
 gen_edge_count_samples_EdgeCount44e = [0,0,0,0,0,1,3,13,47,137,363,901,2119,4801,10595,22909,48767];

gp_inline__location="../dragon.tex:89434";
 gen_edge_count_samples_total = gen_edge_count_samples_EdgeCount11 \
                              + gen_edge_count_samples_EdgeCount12 \
                              + gen_edge_count_samples_EdgeCount22 \
                              + gen_edge_count_samples_EdgeCount24 \
                              + gen_edge_count_samples_EdgeCount44;

gp_inline__location="../dragon.tex:89623";
 DegCount1(k) = 2;

gp_inline__location="../dragon.tex:89627";
 DegCount2(k) = S(k) - 2;

gp_inline__location="../dragon.tex:89629";
 DegCount2_samples = {[0,1,3,7,13,23,41,71,121,207]};

gp_inline__location="../dragon.tex:89638";
 DegCount4(k) = D(k);

gp_inline__location="../dragon.tex:89657";
 EdgeCount11(k) = if(k==0,1, 0);
 gEdgeCount11(x) = 1;

gp_inline__location="../dragon.tex:89666";
 EdgeCount12(k) = if(k==0,0, 2);
 gEdgeCount12(x) = 2*x/(1-x);

gp_inline__location="../dragon.tex:89675";
 EdgeCount22_formula(k) = BQ1(k) + 2*k - 5;
 EdgeCount22(k) = if(k<=1,0, EdgeCount22_formula(k));

gp_inline__location="../dragon.tex:89681";
 EdgeCount22_samples = {[0,0,2,6,10,16,26,40,62,100,162,264]};

gp_inline__location="../dragon.tex:89690";
 gEdgeCount22(x) = {
   3 + x
   - 6 * 1/(1 - x)
   + 2 * 1/(1 - x)^2
   + (1 + x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:89707";
 EdgeCount24_formula(k) = 2*BQ(k) - 2*BQ1(k) - 4*k + 4;
 EdgeCount24(k) = if(k<2,0, EdgeCount24_formula(k));

gp_inline__location="../dragon.tex:89713";
 EdgeCount24_samples = {[0,0,0,0,4,12,28,60,116,212,380,668]};

gp_inline__location="../dragon.tex:89722";
 gEdgeCount24(x) = {
   -4 - 2*x
   + 6 * 1/(1 - x)
   - 4 * 1/(1 - x)^2
   + (2 + 2*x + 2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:89738";
 EdgeCount44_formula(k) = 2^k + BQ1(k) - 2*BQ(k) + 2*k - 1;
 EdgeCount44(k) = if(k<2,0, EdgeCount44_formula(k));

gp_inline__location="../dragon.tex:89745";
 EdgeCount44_samples = {[0,0,0,0,0,2,8,26,76,198,480,1114]};

gp_inline__location="../dragon.tex:89757";
 gEdgeCount44(x) = {
      2 + x
      - 2 * 1/(1 - x)
      + 2 * 1/(1 - x)^2
      + 1/(1 - 2*x)
      - (3 + 2*x + 3*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:89841";
 EdgeCount22_by_BQ1(k) = BQ1(k) + BridgeCount(k) + 4;

gp_inline__location="../dragon.tex:89861";
 EdgeCount24_from_BQ23(k) = \
   2*BQ2(k) + 2*BQ3(k) - 2*BlobCount(k) - 12;

gp_inline__location="../dragon.tex:89876";
 EdgeCount24_from_22(k) = 2*(BQ(k)-2) - 2*EdgeCount22(k) - EdgeCount12(k);

gp_inline__location="../dragon.tex:89890";
 EdgeCount_total(k) = {
     EdgeCount11(k)
   + EdgeCount12(k)
   + EdgeCount22(k)
   + EdgeCount24(k)
   + EdgeCount44(k);
 }

gp_inline__location="../dragon.tex:89919";
 EdgeCount44b_formula(k) = BQ3(k) - 4*k + 12;
 EdgeCount44b(k) = if(k<5,0, EdgeCount44b_formula(k));

gp_inline__location="../dragon.tex:89924";
 EdgeCount44b_samples = {[0,0,0,0,0,1,5,13,29,61,117,213]};

gp_inline__location="../dragon.tex:89944";
 EdgeCount_boundary_total(k) = {
     EdgeCount11(k)
   + EdgeCount12(k)
   + EdgeCount22(k)
   + EdgeCount24(k)
   + EdgeCount44b(k);
 }

gp_inline__location="../dragon.tex:89967";
 EdgeCount44e_formula(k) = 2^k - B(k) + 6*k - 13;
 EdgeCount44e(k) = if(k<5,0, EdgeCount44e_formula(k));

gp_inline__location="../dragon.tex:89974";
 EdgeCount44e_samples = {[0,0,0,0,0,1,3,13,47,137,363,901]};

gp_inline__location="../dragon.tex:90014";
 Diameter_formula(k) = {
         vector_modulo([3,4],k)*2^floor(k/2)
   + k - vector_modulo([4,3],k);
 }

gp_inline__location="../dragon.tex:90019";
 Diameter(k) = if(k==0,1, Diameter_formula(k));

gp_inline__location="../dragon.tex:90024";
 Diameter_samples = {[1,2,4,8,12,18,26,36,52,70,102,136,200,266]};

gp_inline__location="../dragon.tex:90031";
 \\ from devel/dragon-nauty.c try_dragon_diameter()
 \\ House of Graphs computes the same for k <= 8
 Diameter_samples_from_C = \
   [1,2, 4,8,12,18,26,36,52,70,102,136,200,266,394,524,780,1038];

gp_inline__location="../dragon.tex:90045";
 A275970(n) = 3*2^n + n - 1;

gp_inline__location="../dragon.tex:90054";
 A083706(n) = 2^(n+1) + n - 1;

gp_inline__location="../dragon.tex:90076";
 gDiameter(x) = \
   2 \
   - 1/2 * 1/(1+x) \
   - 9/2 * 1/(1-x) \
   + 1/(1-x)^2 \
   + (3+4*x)/(1 - 2*x^2);

gp_inline__location="../dragon.tex:90088";
 gTwoPow_floor(x) = (1+x)/(1 - 2*x^2);
 g_3_or_4(x) = (7/2)/(1-x) - (1/2)/(1+x);

gp_inline__location="../dragon.tex:90214";
 BlobDiameter_vector = [2,5,8,12,18,26,36,52,70];  /* starting k=4, generated by Graph.pm */
 BlobDiameter_exactly(k) = {
   if(k<4, error());
   my(i = k-3);
   if(i<=#BlobDiameter_vector, BlobDiameter_vector[i],
      error());
   }

gp_inline__location="../dragon.tex:90496";
 BlobDiameterBound_recurrence(k) = {
   if(k<4, error());
   if(k==4,2, k==5,5, k==6,8, k==7,12,
      k==8,18, k==9,26, k==10,36, k==11,52,
      2*BlobDiameterBound_recurrence(k-2) + 7);
 }

gp_inline__location="../dragon.tex:90506";
 BlobDiameterBound_multiply_vector = {[(43)/(32),(59)/(32)]};

gp_inline__location="../dragon.tex:90515";
 BlobDiameterBound_k = {10};

gp_inline__location="../dragon.tex:90520";
 BlobDiameterBound_formula(k) = {
   vector_modulo(BlobDiameterBound_multiply_vector,k)
    * 2^floor(k/2) - 7;
 }
 BlobDiameterBound(k) = {
   if(k<BlobDiameterBound_k,BlobDiameter_exactly(k),
      BlobDiameterBound_formula(k));
 }

gp_inline__location="../dragon.tex:90581";
 TailLen_by_sum(k) = {
   if(k<4, error("TailLen_by_sum() is for k>=4, got ",k));
                  Manhattan(BlobDelta(k))
   + sum(j=4,k-2, Manhattan(BlobDelta(j)))
   + if(k>=6, 3*(k-5))
   + if(k==4, 5)
   + if(k>=5, 7);
 }

gp_inline__location="../dragon.tex:90590";
 TailLen_by_sum2(k) = {
   if(k<4, error());
   Manhattan(BlobDelta(k))
   + sum(j=4,k-2,
           Manhattan(BlobDelta(j))
           + 3)  \\ bridge after
   + if(k==4, 5, 7);
 }

gp_inline__location="../dragon.tex:90602";
 TailLen_multiply_vector = {[(5)/(3),2]};

gp_inline__location="../dragon.tex:90610";
 TailLen_sub_vector = {[(11)/(3),(5)/(2),(13)/(3),(5)/(2)]};
 TailLen(k) = {
   if(k<4, error());
   vector_modulo(TailLen_multiply_vector,k) * 2^floor(k/2)
   + 1/2*k
   - vector_modulo(TailLen_sub_vector,k);
 }

gp_inline__location="../dragon.tex:90622";
 TailLen_samples = {[5,8,12,17,27,34,54,67,109,132]};

gp_inline__location="../dragon.tex:90632";
 BlobDiameter_4_to_9 = {[2,5,8,12,18,26]};

gp_inline__location="../dragon.tex:90644";
 TailLen_Diff_multiply_vector = {[(31)/(96),(5)/(32)]};

gp_inline__location="../dragon.tex:90651";
 TailLen_Diff_sub_vector = {[(10)/(3),(9)/(2),(8)/(3),(9)/(2)]};

gp_inline__location="../dragon.tex:90657";
 TailLen_Diff(k) = {
   if(k<4, error());
   vector_modulo(TailLen_Diff_multiply_vector,k) * 2^floor(k/2)
   + 1/2*k
   + vector_modulo(TailLen_Diff_sub_vector,k);
 }

gp_inline__location="../dragon.tex:90691";
 BlobPathLen(k) = if(k<4,0, Manhattan(BlobDelta(k)));

gp_inline__location="../dragon.tex:90719";
 dDiameter_by_difference(k) = Diameter(k+1) - Diameter(k);

gp_inline__location="../dragon.tex:90734";
 dDiameter_formula(k) = 2^ceil(k/2) + vector_modulo([2,0],k);
 dDiameter(k) = if(k==0,1, dDiameter_formula(k));

gp_inline__location="../dragon.tex:90742";
 dDiameter_samples = {[1,2,4,4,6,8,10,16,18,32,34,64,66]};

gp_inline__location="../dragon.tex:90765";
 A228693(n) = vpar_indomsets_count_max(n);

gp_inline__location="../dragon.tex:90775";
 gdDiameter(x) = -2 + (1 + 2*x)/(1 - 2*x^2) + 2/(1-x^2);
 gA228693(x) = {   \\ Colin Barker
   -(x^4+x^3+x^2-x-1)
   / ((x-1)*(x+1)*(2*x^2-1));
 }

gp_inline__location="../dragon.tex:90812";
 BlobBnohang(k) = BlobB(k) - 4*BlobHQA(k);
 BlobLnohang(k) = BlobL(k) - 4*BlobHQAL(k);
 BlobRnohang(k) = BlobR(k) - 4*BlobHQAR(k);
 gBlobBnohang(x) = gBlobB(x) - 4*gBlobHQA(x);
 gBlobLnohang(x) = gBlobL(x) - 4*gBlobHQAL(x);
 gBlobRnohang(x) = gBlobR(x) - 4*gBlobHQAR(x);

gp_inline__location="../dragon.tex:90820";
 BoundaryPathLen_by_diameter_samples = [1,2,4,8,12,20,28,44,64,96,148];

gp_inline__location="../dragon.tex:90890";
 BoundaryPathLen(k) = my(v=BlobList(k)); \
   NonBlobSegments(k) + sum(i=1,#v,my(j=v[i]); BlobLnohang(j));

gp_inline__location="../dragon.tex:90901";
 BoundaryPathLen_by_BlobBnohang_vector = {[(17)/(2),(31)/(4),9,(31)/(4)]};

gp_inline__location="../dragon.tex:90910";
 BoundaryPathLen_by_BlobBnohang_formula(k) = \
   1/8*BlobBnohang(k+4) \
   + 4*k \
   - vector_modulo(BoundaryPathLen_by_BlobBnohang_vector,k);
 BoundaryPathLen_by_BlobBnohang(k) = \
   if(k<4, 2^k, BoundaryPathLen_by_BlobBnohang_formula(k));

gp_inline__location="../dragon.tex:90919";
 BoundaryPathLen_by_JA_formula(k) = \
   JA(k) + 2*JA(k-1) + 4*k - vector_modulo([8,7],k);
 BoundaryPathLen_by_JA(k) = \
   if(k<4,2^k, BoundaryPathLen_by_JA_formula(k));

gp_inline__location="../dragon.tex:90926";
 BoundaryPathLen_samples = {[1,2,4,8,12,20,28,44,64,96,148,236,376]};

gp_inline__location="../dragon.tex:90944";
 gBoundaryPathLen(x) = \
   - 13 * 1/(1 - x) \
   + 4 * 1/(1-x)^2 \
   - 1/2 * 1/(1+x) \
   + 1/2 * (1 + 2*x)/(1 - x - 2*x^3) \
   + 10 + 5*x + 4*x^2 + 2*x^3;

gp_inline__location="../dragon.tex:90961";
 BlobLnohang_samples = {[0,3,2,7,12,19,34,63,100,171]};

gp_inline__location="../dragon.tex:90978";
 BlobBnohang_samples = {[0,6,8,14,36,62,104,190,324,542]};

gp_inline__location="../dragon.tex:91000";
 BlobRnohang_samples = {[0,3,6,7,24,43,70,127,224,371]};

gp_inline__location="../dragon.tex:91010";
 BlobRnohang_sub_BlobLnohang(k) = BlobRnohang(k) - BlobLnohang(k);

gp_inline__location="../dragon.tex:91013";
 BlobRnohang_sub_BlobLnohang_initial = {[0,0,4,0,12]};

gp_inline__location="../dragon.tex:91020";
 BlobRnohang_sub_BlobLnohang_vector = {[16,8,8,8]};

gp_inline__location="../dragon.tex:91024";
 BlobRnohang_sub_BlobLnohang_k = {9};
 BlobRnohang_sub_BlobLnohang_by_BlobR_formula(k) = {
   4*BlobR(k-5)
   + vector_modulo(BlobRnohang_sub_BlobLnohang_vector,k);
 }

gp_inline__location="../dragon.tex:91032";
 BlobRnohang_sub_BlobLnohang_by_BlobR(k) = {
   if(k < 4, 0,
      k < BlobRnohang_sub_BlobLnohang_k,
        BlobRnohang_sub_BlobLnohang_initial[k-3],
      BlobRnohang_sub_BlobLnohang_by_BlobR_formula(k));
 }

gp_inline__location="../dragon.tex:91045";
 gBlobRnohang_sub_BlobLnohang(x) = gBlobRnohang(x) - gBlobLnohang(x);

gp_inline__location="../dragon.tex:91049";
 gBlobRnohang_sub_BlobLnohang_by_parts(x) = \
   4 + 6*x + 4*x^3 + 4*x^4 \
   + (-4)/(1 - x) \
   + (1)/(1 + x) \
   + (-1 + 4*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:91056";
 gBlobRnohang_sub_BlobLnohang_by_gBlobR(x) = \
   -16 - 8*x - 8*x^2 - 8*x^3 - 16*x^4 \
      - 8*x^5 - 4*x^6 - 8*x^7 - 4*x^8 \
   + 10*1/(1 - x) \
   + 2*1/(1 + x) \
   + 4*1/(1 + x^2) \
   + 4*x^5*gBlobR(x);

gp_inline__location="../dragon.tex:91141";
 BoundaryTail(k) = \
   if(k<4,return(0)); \
   BlobLnohang(k) + sum(j=4,k-2, BlobLnohang(j) + 3) \
   + if(k==4,5,7);
 gBoundaryTail(x) = \
   gBlobLnohang(x) + 1/(1-x)*gBlobLnohang(x)*x^2 \
   + 3/(1-x)^2 - 11/(1-x) \
   + 8 + 5*x + 2*x^2 - x^3 + x^4;

gp_inline__location="../dragon.tex:91152";
 BoundaryTail_samples = {[5,10,12,23,33,50,80,131,205,342]};

gp_inline__location="../dragon.tex:91192";
 BoundaryTail_diff_vector = {[15,21,11,17]};

gp_inline__location="../dragon.tex:91202";
 BoundaryTail_diff(k) = \
   BoundaryTail(k) - ( 1/2*BlobBnohang(k) + 5 );
 BoundaryTail_diff_by_dJA(k) = \
   if(k<6,return(BoundaryTail_diff(k))); \
   1/4* ( dJA(k-4) \
         + 18 * dJA(k-5) \
         - 10 * dJA(k-6) \
         + 8*(k-6)  \
         + vector_modulo(BoundaryTail_diff_vector,k) \
        );

gp_inline__location="../dragon.tex:91216";
 gBoundaryTail_diff(x) = \
   gBoundaryTail(x) - 1/2*gBlobBnohang(x);
 gBoundaryTail_diff_by_dJA(x) = \
   1/4*(   1 * gdJA(x)*x^4 \
        + 18 * gdJA(x)*x^5 \
        - 10 * gdJA(x)*x^6 \
        + 13 - x + x^2 - 13*x^3 + x^4 - 5*x^5 \
        + (-20)/(1 - x) \
        + (8)/(1 - x)^2 \
        + (-3)/(1 + x) \
        + (2 +2*x)/(1 + x^2) );

gp_inline__location="../dragon.tex:91252";
 BlobR_sub_BlobL_vector = [6,4,2,4];

gp_inline__location="../dragon.tex:91259";
 BlobR_sub_BlobL(k) = BlobR(k) - BlobL(k);
 BlobR_sub_BlobL_by_BlobL_formula(k) = \
   2*BlobL(k-1) + vector_modulo(BlobR_sub_BlobL_vector,k);
 BlobR_sub_BlobL_by_BlobL(k) = if(k<5,BlobR_sub_BlobL(k), BlobR_sub_BlobL_by_BlobL_formula(k));

gp_inline__location="../dragon.tex:91270";
 gBlobR_sub_BlobL(x) = \
   -1/(1-x) \
   + 1/2 * 1/(1+x) \
   + 1/2 * (1 + 2*x - 2*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:91282";
 \\ Cheeger constant of a path of n vertices
 PathCheeger(n) = 1 / floor(n/2);

gp_inline__location="../dragon.tex:91310";
 Cheeger_initial = {[1,1,1/2,1/4]};

gp_inline__location="../dragon.tex:91318";
 Cheeger(k) = if(k<=3, Cheeger_initial[k+1], 1/BlobPrecedingP(k));

gp_inline__location="../dragon.tex:91336";
 BlobPrecedingP_by_sum(k) = 7 + sum(j=4,k-1,BlobP(j)+2);

gp_inline__location="../dragon.tex:91342";
 BlobPrecedingP_vector = {[26,37,54,43]};

gp_inline__location="../dragon.tex:91346";
 BlobPrecedingP(k) = 1/5*2^k + 1/8*BlobB(k+2) + 1/20*vector_modulo(BlobPrecedingP_vector,k);

gp_inline__location="../dragon.tex:91355";
 BlobPrecedingP_samples = {[7,13,24,43,79,149,284,543,1043,2017]};

gp_inline__location="../dragon.tex:91370";
 gBlobPrecedingP(x) = 7*x^4/(1-x) + x*1/(1-x)*gBlobP(x) + 2*x^5/(1-x)^2;

gp_inline__location="../dragon.tex:91374";
 gBlobPrecedingP_by_sum(x) = \
   7*x^4/(1-x) + 1/(1-x)*( x*gBlobP(x) + 2*x^5/(1-x) );

gp_inline__location="../dragon.tex:91388";
 gBlobPrecedingP_partial_fractions(x) = {
   -1 - 2*x - 4*x^2 - 5*x^3
   + 5/4* 1/(1 - x)
   + 1/10* (-7 - 4*x)/(1 + x^2)
   + 1/5* 1/(1 - 2*x)
   + 1/4*(1 + 2*x + 2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:91424";
 BlobPrecedingP_half_diff_vector = {[(3)/(10),(3)/(5),(17)/(10),(7)/(5)]};

gp_inline__location="../dragon.tex:91430";
 BlobPrecedingP_half_diff(k) = \
   1/20 * 2^k \
   + 1/2*dJA(k-1) \
   - vector_modulo(BlobPrecedingP_half_diff_vector,k);

gp_inline__location="../dragon.tex:91441";
 gBlobPrecedingP_half_diff(x) = \
   1/20 * 1/(1-2*x) \
   + 1/2 * gdJA(x)*x \
   + (5/4 + 2*x + 4*x^2 + 5*x^3) \
   - 1/(1 - x) \
   + (7/10 + 2/5*x)/(1 + x^2);

gp_inline__location="../dragon.tex:91475";
 BlobPrecedingP_quarter_diff_vector = {[(17)/(40),(29)/(40),(73)/(40),(61)/(40)]};

gp_inline__location="../dragon.tex:91480";
 BlobPrecedingP_quarter_diff(k) = \
   3/40 * 2^k \
   + 1/4*dJA(k) \
   + 3/8*dJA(k+1) \
   + vector_modulo(BlobPrecedingP_quarter_diff_vector,k);

gp_inline__location="../dragon.tex:91493";
 gBlobPrecedingP_quarter_diff(x) = \
   3/40 * 1/(1-2*x) \
   + 3/8 * gdJA(x)/x \
   + 1/4 * gdJA(x) \
   + (-1 - 2*x - 4*x^2 - 5*x^3) \
   + 9/8 * 1/(1 - x) \
   + (-7/10 - 2/5*x)/(1 + x^2);

gp_inline__location="../dragon.tex:91528";
 BlobPrecedingP_from_P_delta_vector = {[(7)/(20),(13)/(20),(7)/(4),(29)/(20)]};

gp_inline__location="../dragon.tex:91533";
 preceding_delta(k) = {
   if(k<4,error("preceding_delta() is for k>=4"));
   if(k==4,5, k==5,15, k==6,13,
      preceding_delta(k-1) + 2*preceding_delta(k-3));
 }
 preceding_delta = memoize(preceding_delta);

gp_inline__location="../dragon.tex:91541";
 BlobPrecedingP_from_P_delta(k) = \
   2/5*P(k) \
   + 1/20 * preceding_delta(k) \
   + vector_modulo(BlobPrecedingP_from_P_delta_vector,k);

gp_inline__location="../dragon.tex:91558";
 preceding_delta_samples = {[5,15,13,23,53,79,125,231]};

gp_inline__location="../dragon.tex:91564";
 gBlobPrecedingP_from_P(x) = \
   2/5*gP(x) \
   - 1/20 * (3 - 6*x - 2*x^2) /(1 - x - 2*x^3)\
   + 21/20* 1/(1 - x) \
   - (7/10 + 2/5*x)/(1 + x^2) \
   - (5*x^3 + 4*x^2 + 2*x + 1);

gp_inline__location="../dragon.tex:91592";
 BlobPrecedingP_from_BlobS(k) = 1/5*2^k + 1/4*BlobS(k+2) \
   + vector_modulo([21/20, 8/5, 49/20, 19/10],k);

gp_inline__location="../dragon.tex:91597";
 gBlobPrecedingP_from_P_dJA(x) = \
   2/5*gP(x) \
   - 3/5*gdJA(x)*x^4 \
   + 1/4*gdJA(x) \
   - (23/20 + 37/20*x + 4*x^2 + 53/10*x^3) \
   + 21/20* 1/(1 - x) \
   - (7/10 + 2/5*x)/(1 + x^2);

gp_inline__location="../dragon.tex:91606";
 gBlobPrecedingP_from_P_S(x) = \
   2/5*gP(x) \
   + ( -9/20 * gS(x) \
       + 1/2 * x*gS(x) \
       + 1/2 * x^2*gS(x) ) \
   - (1/4 + 3/2*x + 4*x^2 + 5*x^3) \
   + 21/20* 1/(1 - x) \
   - (7/10 + 2/5*x)/(1 + x^2);

gp_inline__location="../dragon.tex:91629";
 gBlobPrecedingP_from_BlobS(x) = {
   1/5*1/(1-2*x)
   + 1/4*gBlobS(x)/x^2
   + (7/4)* 1/(1 - x)
   - (5/4 + 2*x + 4*x^2 + 5*x^3)
   - (7/10 + 3/20*x)/(1 + x^2);
 }

gp_inline__location="../dragon.tex:91638";
 gBlobPrecedingP_from_P_BlobS(x) = \
   2/5*gP(x) \
   - 3/5*gBlobS(x)*x^6 \
   + 1/4*gBlobS(x)*x^2 \
   - (9/20 + 4/5*x + 61/20*x^2 + 47/10*x^3 - 19/20*x^4 - 9/5*x^5 - 3/5*x^6 - 3/5*x^8) \
   + 7/20* 1/(1 - x) \
   - (7/10 + 3/4*x)/(1 + x^2);

gp_inline__location="../dragon.tex:91663";
 TEndLength_power_vector = {[10,14]};

gp_inline__location="../dragon.tex:91671";
 TEndLength_constant_vector = {[16,11,14,13]};

gp_inline__location="../dragon.tex:91680";
 TEndLength_formula(k) = {
  1/3 * (vector_modulo(TEndLength_power_vector,k)*2^floor(k/2)
         - vector_modulo(TEndLength_constant_vector,k))
  + k;
 }
 TEndLength(k) = if(k==0,2, TEndLength_formula(k));

gp_inline__location="../dragon.tex:91689";
 TEndLength_samples = {[2,2,4,8,12,20,28,40,56,80]};

gp_inline__location="../dragon.tex:91854";
 TMiddle_end(k) = b^(k+1) - I*BlobStart(k-1);
 TMiddle_start(k) = I*BlobStart(k-1);
 TMiddle(k) = TMiddle_end(k) - TMiddle_start(k);

gp_inline__location="../dragon.tex:91858";
 TMiddle_samples = {[2-4*I,6-2*I,8+4*I,4+14*I,-10+20*I]};

gp_inline__location="../dragon.tex:91900";
 TEndLength_by_blobs_formula(k) = {
   2*(7 + sum(j=4,k-2, Manhattan(BlobDelta(j)) + 3))
   + Manhattan(TMiddle(k));
 }
 TEndLength_by_blobs(k) = \
   if(k>=6, TEndLength_by_blobs_formula(k), TEndLength(k));

gp_inline__location="../dragon.tex:91940";
 Diameter_of_k_plus_1_sub_TEndLength_constant_vector = {[5,1,4,2]};

gp_inline__location="../dragon.tex:91946";
 Diameter_of_k_plus_1_sub_TEndLength_formula(k) = {
   2/3*( 2^ceil(k/2)
         + vector_modulo(Diameter_of_k_plus_1_sub_TEndLength_constant_vector,k) );
 }
 Diameter_of_k_plus_1_sub_TEndLength(k) = \
   if(k==0,0, Diameter_of_k_plus_1_sub_TEndLength_formula(k));

gp_inline__location="../dragon.tex:91958";
 Diameter_of_k_plus_1_sub_TEndLength_samples = {[0,2,4,4,6,6,8,12,14,22,24,44,46,86,88]};

gp_inline__location="../dragon.tex:91989";
 \\* per formula by Paul Barry in A052953
 A052953(n) = (2^(n+1)-(-1)^(n+1))/3+1;

gp_inline__location="../dragon.tex:92019";
 TGeomLength_blobs_sum(k) = \
   2*(7 + sum(j=4,k-2, geom_sqrt_as_quad(norm(BlobDelta(j))) + 3));

gp_inline__location="../dragon.tex:92040";
 TGeomLength_constant = {[
   -52 + 20*sqrt2,
   -68 + 29*sqrt2,
   -56 + 22*sqrt2,
   -64 + 31*sqrt2
 ]};
 TGeomLength_blobs(k) = {
   + (2/3 + 1/3*sqrt2) * sqrt2^(k+1)
   + (4 - 3/2*sqrt2)*k
   + 1/6*vector_modulo(TGeomLength_constant,k);
 }

gp_inline__location="../dragon.tex:92059";
 TMiddle_norm_half = {[44,40,40,80]};

gp_inline__location="../dragon.tex:92065";
 TMiddle_norm_constant = {[52,20,40,80]};

gp_inline__location="../dragon.tex:92069";
 TMiddle_norm(k) = {
   (1/3)^2 *(5 * 2^(k+1)
             - vector_modulo(TMiddle_norm_half,k) * 2^floor(k/2)
             + vector_modulo(TMiddle_norm_constant,k));
 }

gp_inline__location="../dragon.tex:92076";
 TGeomLength_inexact(k) = \
   TGeomLength_blobs(k) + abs(TMiddle(k));

gp_inline__location="../dragon.tex:92088";
 TGeomLength_limit_inexact = 1/3*( 2 + sqrt(2) + sqrt(5) );

gp_inline__location="../dragon.tex:92092";
 TGeomLength_limit_sample = {(1883427/1000000)};

gp_inline__location="../dragon.tex:92116";
 TGeomLength_over_GeomLength_limit_sample = {(0780141/1000000)};

gp_inline__location="../dragon.tex:92120";
 TGeomLength_over_GeomLength_limit_inexact = \
   TGeomLength_limit_inexact / GeomLength_limit;

gp_inline__location="../dragon.tex:92149";
 TMiddle_y_by_imag(k) = \
   imag( TMiddle(k) * conj(w8_times_sqrt2)^(k+1) ) / sqrt2^(k+1);

gp_inline__location="../dragon.tex:92158";
 TMiddle_y(k) = 1/3 * sqrt2^(k+1) \
   - vector_modulo([1/3*sqrt2, 2/3, 2/3*sqrt2, 4/3],k);

gp_inline__location="../dragon.tex:92167";
 TMiddle_x_by_real(k) = \
   real( TMiddle(k) * conj(w8_times_sqrt2)^(k+1) ) / sqrt2^(k+1);

gp_inline__location="../dragon.tex:92176";
 TMiddle_x(k) = 2*TMiddle_y(k) - vector_modulo([sqrt2, 0,0,0],k);

gp_inline__location="../dragon.tex:92195";
 TMiddle_norm_by_y(k) = {
   if(k==0,
      5*TMiddle_y(k)^2 + 2*sqrt2*TMiddle_y(k) + 2,
      5*TMiddle_y(k)^2); TMiddle_y(k)^2 + TMiddle_x(k)^2;
 }

gp_inline__location="../dragon.tex:92592";
 vector_strip_trailing(v,x) = \
   forstep(i=#v,1,-1, if(v[i]!=x, return(v[1..i]))); [];

gp_inline__location="../dragon.tex:92595";
 TA_n_is_right(k,n) = k>=1 && (n&1)==1;
 TA_n_is_left(k,n) = k>=1 && (n&1)==0;
 TA_n_vector_is_upper(v) = {      \\ 10 1111
   v = vector_strip_trailing(v,1);  \\ strip trailing 1s
   #v>=2 && v[#v-1]==1 && v[#v]==0;
 }
 TA_n_vector_is_lower(v) = {    \\ 01 0000
   v = vector_strip_trailing(v,0);  \\ strip trailing 0s
   #v>=2 && v[#v-1]==0 && v[#v]==1;
 }
 TA_n_is_upper(k,n) = TA_n_vector_is_upper(binary_padded(n,k));
 TA_n_is_lower(k,n) = TA_n_vector_is_lower(binary_padded(n,k));

gp_inline__location="../dragon.tex:92804";
 TA_complex_s(k) = 0;

gp_inline__location="../dragon.tex:92815";
 TA_complex_a_formula(k) = 2^(k-1) - 1;
 TA_complex_a(k) = if(k==0,0, TA_complex_a_formula(k));

gp_inline__location="../dragon.tex:92828";
 TA_complex_c_formula(k) = 2^(k-1);
 TA_complex_c(k) = if(k==0,0, TA_complex_c_formula(k));

gp_inline__location="../dragon.tex:92836";
 TA_complex_e(k) = 2^k - 1;

gp_inline__location="../dragon.tex:92888";
 \\ upper 101111
 \\ lower 010000
 TA_complex_u(k) = b^(k-1) + sum(i=0,k-3,b^i);  \\ total k bits
 TA_complex_d(k) = b^(k-2);
 TA_complex_u_sub_d(k) = TA_complex_u(k) - TA_complex_d(k);

gp_inline__location="../dragon.tex:92932";
 mask_lowest_zero_and_below(n) = bitxor(n,n+1);
 \\ Return vertex number downwards from n, or -1 if nothing upwards.
 TAVertexToLower(n) = {
   my(mask = mask_lowest_zero_and_below(n));
   if(bitand(n,mask+1) != 0,
      n - mask,  /* l */
      -1);
 }

gp_inline__location="../dragon.tex:92967";
 mask_lowest_one_and_below(n) = bitxor(n,n-1);
 \\ Return vertex number upwards from n, or -1 if nothing upwards.
 TAVertexToUpper(n) = {
   my(mask = mask_lowest_one_and_below(n));
   if(bitand(n,mask+1) == 0,
      n + mask,  /* u */
      -1);
 }

gp_inline__location="../dragon.tex:92985";
 \\ n is a complex base i+1 point number.
 \\ Return a vector of the neighbours of that vertex in the
 \\ twindragon area tree.
 \\ Every vertex has 1 to 3 neighbours so the vector returned
 \\ has length 1 to 3.
 \\ The order of the vertices in the return is unspecified.
 TA_n_to_neighbours(n) = {
   my(l = List([bitxor(n,1)])); /* horizontal */
   my(n2 = TAVertexToUpper(n));
   if(n2>=0, listput(l,n2));
   n2 = TAVertexToLower(n);
   if(n2>=0, listput(l,n2));
   Vec(l);
 }

gp_inline__location="../dragon.tex:93039";
 TA_n_to_edge_by_xor(n, direction) = {
   my(transitions = bitxor(n, 2*n + direction));
   my(mask = bitxor(transitions, transitions-1));
   if(bitand(transitions, mask+1) != 0,
      bitxor(n, 2*mask+1),
      -1);
 }

gp_inline__location="../dragon.tex:93085";
 TADegCount0(k) = if(k==0,1, 0);

gp_inline__location="../dragon.tex:93097";
 TADegCount1_formula(k) = 2^(k-2) + 2;
 TADegCount1(k) = if(k==0,0, k<=2,2, TADegCount1_formula(k));

gp_inline__location="../dragon.tex:93103";
 TADegCount1_samples = {[0,2,2,4,6,10,18,34,66,130]};

gp_inline__location="../dragon.tex:93114";
 TADegCount2_formula(k) = 2^(k-1) - 2;
 TADegCount2(k) = if(k<=1,0, k==2,2, TADegCount2_formula(k));

gp_inline__location="../dragon.tex:93120";
 TADegCount2_samples = {[0,0,2,2,6,14,30,62,126,254]};

gp_inline__location="../dragon.tex:93132";
 TADegCount3_formula(k) = 2^(k-2);
 TADegCount3(k) = if(k<=2,0, TADegCount3_formula(k));

gp_inline__location="../dragon.tex:93137";
 TADegCount3_samples = {[0,0,0,2,4,8,16,32,64,128]};

gp_inline__location="../dragon.tex:93144";
 TADegCount_vector = \
   [TADegCount0, TADegCount1, TADegCount2, TADegCount3];
 TADegCount(k,d) = \
   if(d<#TADegCount_vector, TADegCount_vector[d+1](k), 0);

gp_inline__location="../dragon.tex:93264";
 TA_n_to_degree(k,n) = {
   if(n>=2^k, error("TA_n_to_degree() n=",n," bigger than 2^",k));
   TA_n_is_left(k,n) + TA_n_is_right(k,n)
   + TA_n_is_upper(k,n) + TA_n_is_lower(k,n);
 }
 TADegCount_by_n(k,d) = {
   my(count=[0,0,0,0]);
   for(n=0,2^k-1, count[1 + TA_n_to_degree(k,n)]++);
   count[d+1];
 }

gp_inline__location="../dragon.tex:93315";
 TADegPred3(k,n) = k>=3 && (n%8==2 || n%8==5);

gp_inline__location="../dragon.tex:93347";
 TADegCount2_by_sum(k) = 2*( sum(j=0,k-2,2^j) - TADegCount3(k) );

gp_inline__location="../dragon.tex:93350";
 TA_n_is_degree2(k,n) = {
      ( TA_n_is_upper(k,n) && n%8!=5 && n%8!=2 )
   || ( TA_n_is_lower(k,n) && n%8!=2 && n%8!=5 );
 }

gp_inline__location="../dragon.tex:93372";
 TADegCount1_by_sum(k) = 2*(2 + sum(j=0,k-4,2^j));

gp_inline__location="../dragon.tex:93390";
 TADegCount1_by_A3left(k) = 2*A3left(k+1) + 2;

gp_inline__location="../dragon.tex:93408";
 TAEdgeCount_by_degrees(k) = 1/2*sum(d=0,3, d*TADegCount(k,d));

gp_inline__location="../dragon.tex:93436";
 TADegree(k,n) = {
   if(n>=2^k, error("TADegree() n=",n," bigger than 2^",k));
   if(k>=1, 1)
   + if(k>=1, BitAboveLowestZero(n))
   + if(n>0 && n!=2^(k-1), 1 - BitAboveLowestOne(n));
 }

gp_inline__location="../dragon.tex:93458";
 TADegree_infinite(n) = {
   if(n==0, return(1));
   2 + BitAboveLowestZero(n) - BitAboveLowestOne(n);
 }
 TA_n_to_degree_infinite(n) = \
   TA_n_to_degree(length(binary(n))+3, n);

gp_inline__location="../dragon.tex:93469";
 TADegree_infinite_samples = {[1,2,3,1,2,3,2,1,2,2,3,2,1,3,2,1,2,2,3,1,2,3,2]};

gp_inline__location="../dragon.tex:93492";
 TADegree_infinite_by_delta(n) = {
   if(n==0, return(1));
   2 + dBitAboveLowest(n);
 }

gp_inline__location="../dragon.tex:93506";
 dBitAboveLowest(n) = {
   if(n<1, error("dBitAboveLowest() is for n >= 1"));
   BitAboveLowestZero(n) - BitAboveLowestOne(n);
 }

gp_inline__location="../dragon.tex:93523";
 dBitAboveLowest_samples = {[0,1,-1,0,1,0,-1,0,0,1,0,-1,1,0,-1,0,0,1,-1,0]};

gp_inline__location="../dragon.tex:93543";
 A021913(n) = vector_modulo([0,0,1,1],n);

gp_inline__location="../dragon.tex:93838";
 gen_TAEdgeCount11_samples = [0,1,0,0,0,0,0,0,0,0,0,0,0];
 gen_TAEdgeCount12_samples = [0,0,2,2,4,6,10,18,34,66,130,258,514];
 gen_TAEdgeCount22_samples = [0,0,1,0,1,5,13,29,61,125,253,509,1021];
 gen_TAEdgeCount13_samples = [0,0,0,2,2,4,8,16,32,64,128,256,512];
 gen_TAEdgeCount23_samples = [0,0,0,2,6,12,24,48,96,192,384,768,1536];
 gen_TAEdgeCount33_samples = [0,0,0,1,2,4,8,16,32,64,128,256,512];

gp_inline__location="../dragon.tex:93866";
 TAEdgeCount12_by_recurrence(k) = 2*TAEdgeCount12(k-1) - 2;

gp_inline__location="../dragon.tex:93876";
 TAEdgeCount22_by_recurrence(k) = 2*TAEdgeCount22(k-1) + 3;

gp_inline__location="../dragon.tex:93880";
 TAEdgeCount11_by_recurrence(k) = 2*TAEdgeCount11(k-1);
 TAEdgeCount13_by_recurrence(k) = 2*TAEdgeCount13(k-1);
 TAEdgeCount23_by_recurrence(k) = 2*TAEdgeCount23(k-1);
 TAEdgeCount33_by_recurrence(k) = 2*TAEdgeCount33(k-1);

gp_inline__location="../dragon.tex:93894";
 TAEdgeCount11(k) = if(k==1,1, 0);

gp_inline__location="../dragon.tex:93904";
 TAEdgeCount12_formula(k) = 2^(k-3) + 2;
 TAEdgeCount12(k) = if(k<=1,0, k<=3,2, TAEdgeCount12_formula(k));

gp_inline__location="../dragon.tex:93911";
 TAEdgeCount12_samples = {[0,0,2,2,4,6,10,18,34,66,130]};

gp_inline__location="../dragon.tex:93925";
 TAEdgeCount22_formula(k) = 2^(k-2) - 3;
 TAEdgeCount22(k) = if(k==2,1, k<=3,0, TAEdgeCount22_formula(k));

gp_inline__location="../dragon.tex:93932";
 TAEdgeCount22_samples = {[0,0,1,0,1,5,13,29,61,125,253]};

gp_inline__location="../dragon.tex:93947";
 TAEdgeCount13_formula(k) = 2^(k-3);
 TAEdgeCount13(k) = if(k<=2,0, k==3,2, TAEdgeCount13_formula(k));

gp_inline__location="../dragon.tex:93953";
 TAEdgeCount13_samples = {[0,0,0,2,2,4,8,16,32,64,128]};

gp_inline__location="../dragon.tex:93968";
 TAEdgeCount23_formula(k) = 3*2^(k-3);
 TAEdgeCount23(k) = if(k<=2,0, k==3,2, TAEdgeCount23_formula(k));

gp_inline__location="../dragon.tex:93974";
 TAEdgeCount23_samples = {[0,0,0,2,6,12,24,48,96,192,384]};

gp_inline__location="../dragon.tex:93989";
 TAEdgeCount33_formula(k) = 2^(k-3);
 TAEdgeCount33(k) = if(k<=2,0, TAEdgeCount33_formula(k));

gp_inline__location="../dragon.tex:93995";
 TAEdgeCount33_samples = {[0,0,0,1,2,4,8,16,32,64,128]};

gp_inline__location="../dragon.tex:94012";
 TAEdgeCount_vector = [TAEdgeCount11, TAEdgeCount12, TAEdgeCount22, TAEdgeCount13, TAEdgeCount23, TAEdgeCount33];
 TAEdgeCount_by_parts(k) = sum(i=1,#TAEdgeCount_vector, TAEdgeCount_vector[i](k));

gp_inline__location="../dragon.tex:94040";
 TAZagrebM2_by_degrees(k) = {
   1*1 * TAEdgeCount11(k)   \\ 1,1
 + 1*2 * TAEdgeCount12(k)   \\ 1,2
 + 2*2 * TAEdgeCount22(k)   \\ 2,2
 + 1*3 * TAEdgeCount13(k)   \\ 1,3
 + 2*3 * TAEdgeCount23(k)   \\ 2,3
 + 3*3 * TAEdgeCount33(k);  \\ 3,3
 }

gp_inline__location="../dragon.tex:94051";
 TAZagrebM2_initial = {[0,1,8,31]};

gp_inline__location="../dragon.tex:94058";
 TAZagrebM2_formula(k) = 5*2^k - 8;
 TAZagrebM2(k) = if(k<4,TAZagrebM2_initial[k+1], TAZagrebM2_formula(k));

gp_inline__location="../dragon.tex:94070";
 TAZagrebM2_samples = {[0,1,8,31,72,152,312,632,1272]};

gp_inline__location="../dragon.tex:94087";
 TAEdgeCount_matrix(k) = {[
   1,1, TAEdgeCount11(k);
   1,2, TAEdgeCount12(k);
   2,2, TAEdgeCount22(k);
   1,3, TAEdgeCount13(k);
   2,3, TAEdgeCount23(k);
   3,3, TAEdgeCount33(k)
 ]};

gp_inline__location="../dragon.tex:94097";
 TAZagrebM2_from_matrix(m) = {
   my(s = matsize(m));
   sum(i=1,s[1], m[i,1]*m[i,2] * m[i,3]);
 }

gp_inline__location="../dragon.tex:94148";
 TAdiameter(k) = LQ(k+1) - 1;

gp_inline__location="../dragon.tex:94162";
 TAdiameter_samples = {[0,1,3,5,9,17,29,49,85,145]};

gp_inline__location="../dragon.tex:94413";
 TA_ecc(k) = RQ(k) - 1;

gp_inline__location="../dragon.tex:94416";
 TA_ecc_samples = {[0,1,2,4,8,14,24,42,72,122]};

gp_inline__location="../dragon.tex:94602";
 TAheight(k) = TAdiameter(k);

gp_inline__location="../dragon.tex:94613";
 gen_TAW_samples = [0,1,10,68,488,3536,23968,162624,1119872,7613696,51534336];
 gen_TAW_count_pairs_samples = [1,3,10,36,136,528,2080,8256,32896,131328,524800];
 gen_TAW_count_distinct_pairs_samples = [0,1,6,28,120,496,2016,8128,32640,130816,523776];
 gen_TAwS_samples = [0,1,6,22,80,296,1024,3488,12032,41088,139264];
 gen_TAwC_samples = [0,1,4,18,72,248,864,3040,10368,35200,120320];

gp_inline__location="../dragon.tex:94655";
 TAW_by_recurrence(k) = {
   if(k<5, return(TAW(k)));
   10*TAW(k-1) - 32*TAW(k-2) + 160*TAW(k-3)
   - 768*TAW(k-4) + 1024*TAW(k-5);
 }

gp_inline__location="../dragon.tex:94672";
 TAW(k) = {
   k>=0 || error("TAW() is for k>=0");
   (1/136*LQ(k) + 19/136*LQ(k+1) + 9/272*LQ(k+2) - 1/8)*4^k
   - 3/34*2^k;
 }

gp_inline__location="../dragon.tex:94680";
 TAW_from_RQ(k) = {
   k>=0 || error("TAW_from_RQ() is for k>=0");
   (1/17*RQ(k) - 9/68*RQ(k+1) + 19/136*RQ(k+2) - 1/8)*4^k
   - 3/34*2^k;
 }

gp_inline__location="../dragon.tex:94688";
 TAW_samples = {[0,1,10,68,488,3536,23968]};

gp_inline__location="../dragon.tex:94712";
 gTAW(x) = (x - 32*x^4) \
   / ( (1-2*x)*(1-4*x)*(1-4*x-128*x^3) );

gp_inline__location="../dragon.tex:94726";
 gTAW_partial_fractions(x) = \
   -3/34*1/(1-2*x)           \
   - 1/8*1/(1-4*x)           \
   + 1/136*(29 + 112*x + 768*x^2)/(1-4*x-128*x^3);

gp_inline__location="../dragon.tex:94737";
 gTAW_over_2ksub1(x) = {
   -3/17/(1 - x)
   - 1/4/(1 - 2*x)
   + (29/68 + 14/17*x + 48/17*x^2)/(1 - 2*x - 16*x^3);
 }

gp_inline__location="../dragon.tex:94746";
 gTAW_over_4k(x) = {
   -3/34/(1 - 1/2*x)
   - 1/8/(1 - x)
   + (29/136 + 7/34*x + 6/17*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:94823";
 TAwS_samples = {[0,1,6,22,80,296]};

gp_inline__location="../dragon.tex:94839";
 gTAwS(x) = \
   -5/8/(1 - 2*x) + (5/8 + x + 4*x^2)/(1 - 2*x - 16*x^3);
 gTAwS_over_2ksub2(x) = \
   -5/2/(1-x) + (5/2 + 2*x + 4*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:94852";
 TAwC_samples = {[0,1,4,18,72,248]};

gp_inline__location="../dragon.tex:94870";
 gTAwC(x) = \
   -5/8/(1 - 2*x) + (5/8 + x + 2*x^2)/(1 - 2*x - 16*x^3);
 gTAwC_over_2ksub2(x) = \
   -5/2/(1 - x) + (5/2 + 2*x + 2*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:94896";
 TAwS(k) = {
   if(k==0,return(0));
   TAwS(k-1) + 2^(k-1)*RQ(k-1) + TAwC(k-1);
 }
 TAwS = memoize(TAwS);

gp_inline__location="../dragon.tex:94906";
 TAwC(k) = {
   if(k==0,return(0));
   TAwS(k-1) + 2^(k-1)*LQ(k-1) + TAwC(k-1);
 }
 TAwC = memoize(TAwC);

gp_inline__location="../dragon.tex:94926";
 TAwSC(k) = TAwS(k) + TAwC(k);

gp_inline__location="../dragon.tex:94935";
 gTAwSC(x) = \
   -5/4/(1 - 2*x) + (5/4 + 2*x + 6*x^2)/(1 - 2*x - 16*x^3);
 gTAwSC_over_2ksub1(x) = \
   -5/2/(1 - x) + (5/2 + 2*x + 3*x^2)/(1 - x - 2*x^3);

gp_inline__location="../dragon.tex:94968";
 TAwSC_samples = {[0,2,10,40,152,544,1888]};

gp_inline__location="../dragon.tex:95177";
 TAW_k3_pairs_sum(k,vec) = {
   sum(v=1,2^k,
   sum(i=1,#vec, my(t=vec[i]);
       (8*t+1)*(2^(k+3) - (8*t+1))));
 }

gp_inline__location="../dragon.tex:95191";
 TAW_k3_pairs_sum2(k,vec) = {
   16*4^k + 12*2^k
   + 128*1/2*sum(v=1,2^k,
        sum(i=1,#vec, my(t=vec[i]); t*(2^k - t)));
 }

gp_inline__location="../dragon.tex:95247";
 \\ u,v are neighbouring vertices in vpar
 \\ return [usize,vsize] sizes of the subtrees at u and v
 \\ each side of their u--v edge
 subtree_sizes_across_edge(vpar,u,v) = {
   if(vpar[u]!=v, my(t=u);u=v;v=t);
   if(vpar[u]!=v, error("not neighbours"));
   my(size=vpar_subtree_size(vpar,u));
   [size,#vpar-size];
 }

gp_inline__location="../dragon.tex:95257";
 \\ return the TAW total crossings of vertical edges
 TAW_across_verticals(k) = {
   my(vpar=TA_vpar(k));
   sum(v=1,#vpar,
       my(neighbours=vpar_neighbours_of_vertex(vpar,v));
       sum(i=1,#neighbours,
           my(to=neighbours[i],
              vec=subtree_sizes_across_edge(vpar,v,to));
           if(bitxor(v-1,to-1)==1, 0, 1/2)
           * vec[1]*vec[2]));
 }

gp_inline__location="../dragon.tex:95280";
 \\ return the TAW total crossings of vertical edges
 TAW_across_horizontals(k) = {
   my(vpar=TA_vpar(k));
   sum(v=1,#vpar,
       my(neighbours=vpar_neighbours_of_vertex(vpar,v));
       sum(i=1,#neighbours,
           my(to=neighbours[i],
              vec=subtree_sizes_across_edge(vpar,v,to));
           if(bitxor(v-1,to-1)==1, 1/2, 0) *
           vec[1]*vec[2]));
 }

gp_inline__location="../dragon.tex:95342";
 TAWvert(k) = if(k==0,0, 4*TAW(k-1));

gp_inline__location="../dragon.tex:95346";
 TAWvert_samples = {[0,0,4,40,272,1952,14144]};

gp_inline__location="../dragon.tex:95365";
 TAWhoriz(k) = if(k==0,0, k==1,1, k==2,6, \
                  128*TAW(k-3) + 4^(k-1) + 3*2^(k-1));

gp_inline__location="../dragon.tex:95370";
 TAWhoriz_samples = {[0,1,6,28,216,1584,9824]};

gp_inline__location="../dragon.tex:95400";
 TAWvhdiff(k) = TAWvert(k) - TAWhoriz(k);

gp_inline__location="../dragon.tex:95409";
 TAWvhdiff_recurrence(k) = \
   4*TAWvhdiff(k-1) + 128*TAWvhdiff(k-3) + 4^(k-1) + 9*2^(k-1);

gp_inline__location="../dragon.tex:95417";
 TAWvhdiff_samples = {[0,-1,-2,12,56,368,4320]};

gp_inline__location="../dragon.tex:95436";
 tree_directions_by_rule(vpar) = {
   my(dir=vector(#vpar,i,-1),
      degrees=vpar_degrees_vector(vpar),
      neighbours=vpar_neighbours_vector(vpar),
      rep=0);
   my(get_dir=(dir,u,v)->
      if(vpar[u]==v,dir[u],
         vpar[v]==u,dir[v],
         error("not neighbours")));
   my(set_dir=(dir,u,v,d)->
      \\ print("set "u"--"v" d="d);
      if(vpar[u]==v,dir[u]=d,
         vpar[v]==u,dir[v]=d,
         error("not neighbours"));
      dir);
   for(v=1,#vpar,
       if(degrees[v]==1, \\ leaf horizontal
          dir=set_dir(dir,v,neighbours[v][1],0)));
   while(#select(d->d<0,dir) && rep++<#vpar,
     for(v=1,#vpar,
         if(degrees[v]==2,
            for(i=1,2,
                my(to=neighbours[v][i],d=get_dir(dir,v,to));
                \\ print("deg2 v="v" to="to" d="d);
                if(d>=0,
                   dir=set_dir(dir,v,neighbours[v][3-i],1-d))));
         if(degrees[v]==3,
            my(seen=vector(3));
            for(i=1,3,
                seen[2+get_dir(dir,v,neighbours[v][i])]++);
            if(seen[2]+seen[3]==2,
               my(d=if(seen[2]==0,0,1));
               \\ print("deg3 v="v" to "neighbours[v]" d="d);
               for(i=1,3,
                   if(get_dir(dir,v,neighbours[v][i])<0,
                      dir=set_dir(dir,v,neighbours[v][i],d)))));
     ));
   dir;
 }
 tree_directions_by_number(vpar) = \
   vector(#vpar,v,if(vpar[v]==0,-1, bitxor(v-1,vpar[v]-1)==1,0, 1));

gp_inline__location="../dragon.tex:95480";
 TAWtimes2_by_sizes_across_edges(vpar) = {
   sum(v=1,#vpar,
       my(neighbours=vpar_neighbours_of_vertex(vpar,v));
       sum(i=1,#neighbours,
           my(vec=subtree_sizes_across_edge(vpar,v,neighbours[i]));
           vec[1]*vec[2]));
 }

gp_inline__location="../dragon.tex:95491";
 TA_subtree_size(v) = \
   vpar_subtree_size(TA_vpar(#binary(v-1)),v);

gp_inline__location="../dragon.tex:95496";
 supertree_vertices(vpar,v) = \
   setminus([1..#vpar], vpar_subtree_vertices(vpar,v));
 TA_supertree_vertices(v) = \
   supertree_vertices(TA_vpar(#binary(v-1)),v);

gp_inline__location="../dragon.tex:95507";
 supertree_size(vpar,v) = #vpar - vpar_subtree_size(vpar,v);

gp_inline__location="../dragon.tex:95545";
 TAW_count_distinct(k) = 1/2*(4^k - 2^k);

gp_inline__location="../dragon.tex:95575";
 TAW_mean(k) = TAW(k)/(TAW_count_distinct(k)*TAdiameter(k));

gp_inline__location="../dragon.tex:95580";
 TAW_mean_limit = 1/68*1/r + 19/68 + 9/136*r;
 TAW_mean_limit_nfelt = \
   1/68*one_over_r_nfelt + 19/68*one_nfelt + 9/136*r_nfelt;

gp_inline__location="../dragon.tex:95592";
 TAW_mean_sample = {(0400294/1000000)};

gp_inline__location="../dragon.tex:95629";
 TA_n_has_edge(n1,n2) = {
      n2 == bitxor(n1, 1)
   || n2 == TAVertexToUpper(n1)
   || n2 == TAVertexToLower(n1);
 }

gp_inline__location="../dragon.tex:95639";
 \\ Return the Laplacian matrix of twindragon area tree k.
 \\ Rows and columns are numbered by the tree vertex numbering.
 TA_Laplacian_matrix(k) = vpar_Laplacian_matrix(TA_vpar(k));

gp_inline__location="../dragon.tex:95660";
 \\ m is a Laplacian matrix of a tree.
 \\ Return the Wiener index of the tree using the eigenvalues of m
 \\ (at floats).
 Wiener_of_tree_Laplacian_matrix(m) = {
   my(p = charpoly(m), n=poldegree(p));
   polcoeff(p,0) == 0
     || error("oops, expected low coeff ==0");
   p/=x;
   polcoeff(p,0) != 0
     || error("oops, expected second low coeff !=0");
   n * vecsum(apply(x->1/x, polroots(p)));
 }
 TAW_by_Laplacian(k) = \
   Wiener_of_tree_Laplacian_matrix(TA_Laplacian_matrix(k));

gp_inline__location="../dragon.tex:95684";
 gen_TAtwS_samples = [0,1,3,12,33,101,311,983,3231,10719];
 gen_TAtwC_samples = [0,1,3,10,31,89,271,871,2815,9247];
 gen_TATW_samples = [0,1,3,22,93,459,2423,13807,84447,533439];

gp_inline__location="../dragon.tex:95701";
 TATW_initial = {[0,1,3,22]};

gp_inline__location="../dragon.tex:95715";
 TATW_formula(k) = 1/16*TAW(k) + 7/32*4^k + 15/32*2^k - 1;
 TATW(k) = if(k<4,TATW_initial[k+1],TATW_formula(k));

gp_inline__location="../dragon.tex:95721";
 TATW_samples = {[0,1,3,22,93,459,2423,13807]};

gp_inline__location="../dragon.tex:95730";
 gTATW(x) = {
   5/16 + 1/8*x - 2*x^2 + x^3
   - 1/(1 - x)
   + 63/136/(1 - 2*x)
   + 27/128/(1 - 4*x)
   + (29/2176 + 7/136*x + 6/17*x^2)/(1 - 4*x - 128*x^3);
 }

gp_inline__location="../dragon.tex:95754";
 TAtwS_samples = {[0,1,3,12,33,101]};

gp_inline__location="../dragon.tex:95775";
 TAtwC_samples = {[0,1,3,10,31,89]};

gp_inline__location="../dragon.tex:95810";
 TAtwS_formula(k) = {
   TAtwS(k-1) - (RQ(k-1)-1)
    + (TADegCount1(k-1) - 1)*RQ(k-1)
    + TAtwC(k-1);
 }
 TAtwS(k) = if(k>=4, TAtwS_formula(k), gen_TAtwS_samples[k+1]);
 TAtwS = memoize(TAtwS);

gp_inline__location="../dragon.tex:95835";
 TAtwC_formula(k) = {
   TAtwS(k-1) - (LQ(k-1)-1)
    + (TADegCount1(k-1) - 1)*LQ(k-1)
    + TAtwC(k-1);
 }
 TAtwC(k) = if(k>=4, TAtwC_formula(k), gen_TAtwC_samples[k+1]);
 TAtwC = memoize(TAtwC);

gp_inline__location="../dragon.tex:95857";
 TAtwSC(k) = TAtwS(k) + TAtwC(k);

gp_inline__location="../dragon.tex:95886";
 TAtwC_by_LQ(k) = {
   if(k<4,error("TAtwC_by_LQ() is for k>=4"));
   TAtwSC(k-1) + 2^(k-3)*LQ(k-1) + 1;
 }

gp_inline__location="../dragon.tex:95917";
 TATW_by_parts(k) = {
   if(k<4,error("TATW_by_parts() is for k>=4"));
   if(k==4, return(93));
     2 * ( TATW(k-1) - TAtwC(k-1) )
   + 2 * ( TADegCount1(k-1) - 1) * TAtwC(k-1)
   + (TADegCount1(k-1) - 1)^2;
 }

gp_inline__location="../dragon.tex:95938";
 TATW_by_sum(k) = {
     2*4^(k-3)
   + (2*k + 15)*2^(k-3)
   - 1
   + 2^(k-2) * sum(j=3,k-1, TAtwC(j));
 }

gp_inline__location="../dragon.tex:95968";
 TATW_distinct_count(k) = binomial(TADegCount1(k), 2);
 TATW_mean(k) = \
   TATW(k) / (TATW_distinct_count(k) * TAdiameter(k));

gp_inline__location="../dragon.tex:95984";
 TAparentDir_matrix = {[ 1, 2;     \\ 1=upper
                         3, 2;     \\ 2=left
                         4, 3;     \\ 3=lower
                         4, 1 ]};  \\ 4=right
 TAparentDir_transition(state,bit) = \
   TAparentDir_matrix[state,bit+1];
 TAparentDir_transitions(state,v) = {
   for(i=1,#v,  /* high to low */
       state=TAparentDir_transition(state,v[i]));
   state;
 }
 TAparentDir_initial_state = 1;
 TAparentDir(n) = {
   n>=1 || error("TAparentDir() is for n>=1, got ",n);
   TAparentDir_transitions(TAparentDir_initial_state,
                           binary(n)) % 4;
 }
 TAparent(n) = TAstepDir(n, TAparentDir(n));

gp_inline__location="../dragon.tex:96084";
 TAparentDir_samples = {[2,3,2,0,3,3,2,0,1,0,3,0,3,3,2,0,1]};

gp_inline__location="../dragon.tex:96106";
 TAstepDir(n,d) = {
   if(d==1,TAVertexToUpper(n),
      d==3,TAVertexToLower(n),
      d==0 && n%2==0, bitxor(n,1),
      d==2 && n%2==1, bitxor(n,1),
      -1);
 }

gp_inline__location="../dragon.tex:96119";
 TAparent_samples = {[0,1,2,5,2,5,6,9,10,11,4,13,10,13,14,17,18]};

gp_inline__location="../dragon.tex:96231";
 \\ return vpar[1..n] tree k
 TA_vpar(k) = vector(2^k,n,n--; if(n,TAparent(n)+1));

gp_inline__location="../dragon.tex:96346";
 FlipBelow10_xor_mask(n) = {
   my(v=binary(n),ret=vector(#v));
   for(i=2,#v, if(v[i-1]==1 && v[i]==0,
                  for(j=i+1,#v, ret[j]=1-ret[j])));
   fromdigits(ret,2);
 }
 FlipBelow10(n) = bitxor(n,FlipBelow10_xor_mask(n));

gp_inline__location="../dragon.tex:96358";
 FlipBelow10_samples = {[0,1,2,3,5,4,6,7,11,10,9,8,13,12,14,15,23,22,21]};

gp_inline__location="../dragon.tex:96367";
 FlipBelow10_binary_samples = {[0,1,10,11,101,100,110,111,1011,1010]};

gp_inline__location="../dragon.tex:96398";
 \\ all runs >=2 bits long, except the lowest
 FlipBelow10xorPred(n) = {
   my(v=vector_run_lengths(binary(n)));
   for(i=1,#v-1,if(v[i]<2,return(0)));
   1;
 }

gp_inline__location="../dragon.tex:96499";
 UnFlipBelow10(n) = {
   n>=0 || error("UnFlipBelow10() is for n>=0, got ",n);
   my(v=binary(n));
   for(i=2,#v, if(v[i-1]==1 && v[i]==0,
                  for(j=i+1,#v, v[j]=1-v[j])));
   fromdigits(v,2);
 }

gp_inline__location="../dragon.tex:96514";
 UnFlipBelow10_samples = {[0,1,2,3,5,4,6,7,11,10,9,8,13,12,14,15,23,22,20]};

gp_inline__location="../dragon.tex:96526";
 UnFlipBelow10_binary_samples = {[0,1,10,11,101,100,110,111,1011,1010]};

gp_inline__location="../dragon.tex:96535";
 UnFlipBelow10_xor_mask(n) = {
   my(v=binary(n),ret=vector(#v));
   for(i=2,#v, if(v[i-1]==1 && v[i]==0,
                  for(j=i+1,#v, ret[j]=1-ret[j];v[j]=1-v[j])));
   fromdigits(ret,2);
 }

gp_inline__location="../dragon.tex:96565";
 \\ all runs >=2 bits long, except the lowest
 UnFlipBelow10xorPred(n) = {
   my(v=vector_run_lengths(binary(n)));
   for(i=1,#v-1,if(v[i]<2,return(0)));
   1;
 }

gp_inline__location="../dragon.tex:96576";
 FlipBelow10_eq_UnFlipBelow10_pred(n) = {
   my(v=binary(n));
   for(i=1,#v-1,
       if(v[i]==1&&v[i+1]==0,
          for(i=i+2,#v-2,
              if(v[i]!=v[i+1],return(0)));
          break()));
   1;
 }

gp_inline__location="../dragon.tex:96591";
 \\ count how many n of k many bits have
 \\ FlipBelow10(n) == UnFlipBelow10(n)
 FlipBelow10_eq_UnFlipBelow10_k_by_pred(k) = {
   if(k==0,0,
      sum(n=2^(k-1),2^k-1, FlipBelow10(n) == UnFlipBelow10(n)));
 }

gp_inline__location="../dragon.tex:96628";
 FlipBelow10_eq_UnFlipBelow10_k_formula(k) = 4*(k-2);
 FlipBelow10_eq_UnFlipBelow10_k(k) = {
   if(k==0,0, k==1||k==2, 2^(k-1),
      FlipBelow10_eq_UnFlipBelow10_k_formula(k));
 }

gp_inline__location="../dragon.tex:96710";
 \\ v=TA_parents_vector(k) returns a vector v where v[n] is the
 \\ parent vertex of n, for n=1 to 2^k-1 inclusive.
 TA_parents_vector(k) = {
   my(limit=2^k-1, parents=vector(limit,i,-1), pending=List([0]));
   while(#pending,
         my(p=pending[#pending]);
         listpop(pending);
         my(neighbours=TA_n_to_neighbours(p));
         for(i=1,#neighbours,
             my(c=neighbours[i]);
             if(c<1||c>limit,next());
             if(parents[c]>=0,next());
             parents[c]=p;
             listput(pending,c)));
   parents;
 }

gp_inline__location="../dragon.tex:96728";
 TAparentDir_LtoH_matrix = {[ 2,12;     \\ s1
                              3, 4;     \\ s2
                              3, 5;     \\ s3
                              6, 4;     \\ s4
                              7,11;     \\ s5
                             12, 7;     \\ s6
                              8, 9;     \\ s7
                              8, 1;     \\ s8
                             10, 9;     \\ s9
                             11, 2;     \\ s10
                             11,11;     \\ 11=yes
                             12,12 ]};  \\ 12=non
 TAparentDir_LtoH_accepting_set = Set([5,7, 8,9,10, 11]);
 TAparentDir_LtoH_transition(state,bit) = \
   TAparentDir_LtoH_matrix[state,bit+1];
 TAparentDir_LtoH_transitions(state,v) = {
   for(i=1,#v, state=TAparentDir_LtoH_transition(state,v[i]));
   state;
 }
 TAparentDir_LtoH_state_is_accepting(state) = \
   setsearch(TAparentDir_LtoH_accepting_set,state)!=0;
 TAparentDir_LtoH_dir_to_initial_vector = [1,8,10,9];
 TAparentDir_LtoH_dir_to_initial(dir) = \
   TAparentDir_LtoH_dir_to_initial_vector[dir+1];
 TAparentDir_LtoH(n,state) = {
   n>=1 || error("TAparentDir_LtoH() is for n>=1, got ",n);
   TAparentDir_LtoH_state_is_accepting(
     TAparentDir_LtoH_transitions(state, Vecrev(binary(n))));
 }

gp_inline__location="../dragon.tex:96973";
 TAparentTurn(n) = {
   my(delta=(TAparentDir(n)-TAparentDir(n-1))%4);
   \\if(delta>1, delta-=4);
   delta;
 }

gp_inline__location="../dragon.tex:96998";
 TAtospineDir_initial_state  =  4;
 TAtospineDir(n) = {
   n>=0 || error("TAtospineDir() is for n>=0, got ",n);
   TAparentDir_transitions(TAtospineDir_initial_state,binary(n)) % 4;
 }
 TAtospine(n) = TAstepDir(n, TAtospineDir(n));

gp_inline__location="../dragon.tex:97007";
 TAtospineDir_samples = {[0,1,1,2,1,2,3,2,1,2,3,2,0,3,3,2,1,2]};

gp_inline__location="../dragon.tex:97020";
 TAtospine_samples = {[1,2,5,2,11,4,5,6,23,8,9,10,13,10,13,14,47,16]};

gp_inline__location="../dragon.tex:97034";
 TAspine(m) = my(n=0); for(i=1,m,n=TAtospine(n)); n;

gp_inline__location="../dragon.tex:97039";
 TAspine_samples = {[0,1,2,5,4,11,10,9,8,23,22,21,18,17,16,47,46,45]};

gp_inline__location="../dragon.tex:97139";
 dTAspine(m) = TAspine(m+1) - TAspine(m);

gp_inline__location="../dragon.tex:97143";
 xdTAspine(m) = bitxor(TAspine(m+1), TAspine(m));

gp_inline__location="../dragon.tex:97145";
 xdTAspineLen(m) = length(binary(xdTAspine(m))); \\ num bits flip

gp_inline__location="../dragon.tex:97161";
 \\ Return a vector of the binary exponents of n.
 \\ So vector v = [k1,k2,...] where n == 2^k1 + 2^k2 + ...
 \\ The exponents are high to low k1 > k2 > ...
 \\ which is like binary() gives.
 binary_exponents(n) = {
   my(v=binary(n));
   apply(i->#v-i, Vec(select(bit->bit,v, 1)));
 }

gp_inline__location="../dragon.tex:97251";
 TAdepth(n) = {
   my(v=binary(n),i=1,depth=0);
   while(i<=#v,

     if(i<=#v && v[i]==1,
        depth += RQ(#v-i); i++;
        while(i<=#v && v[i]==1,
          depth += LQ(#v-i); i++));

     i++; \\ skip 0111
     while(i<=#v && v[i]==1, i++);

     if(i<=#v && v[i]==0,
        depth += RQ(#v-i); i++;
        while(i<=#v && v[i]==0,
          depth += LQ(#v-i); i++));

     i++; \\ skip 1000
     while(i<=#v && v[i]==0, i++);
   );
   depth;
 }
 TAdepths_vector_by_vpar(k) = vpar_depths_vector(TA_vpar(k));

gp_inline__location="../dragon.tex:97283";
 TAdepth_samples = {[0,1,2,3,4,3,4,5,8,7,6,5,8,7,8,9,14]};

gp_inline__location="../dragon.tex:97336";
 TAdepth_by_UnFlipBelow10(n) = {
   my(v=binary(UnFlipBelow10(n)),i=1,depth=0);
   while(i<=#v,

     if(i<=#v && v[i]==1,             \\ run 1s
        depth += RQ(#v-i); i++;
        while(i<=#v && v[i]==1,
          depth += LQ(#v-i); i++));

     while(i<=#v && v[i]==0, i++);    \\ run 0s
   );
   depth;
 }

gp_inline__location="../dragon.tex:97362";
 TAdepthStates_matrix = {[ 1, 2;     \\ 1=s
                           3, 2;     \\ 2=a
                           4, 3;     \\ 3=e
                           4, 1 ]};  \\ 4=c
 TAdepthStates_across = [0,0,1,1];
 TAdepthStates_transition(state,bit) = \
   TAdepthStates_matrix[state,bit+1];
 TAdepthStates_output(state,bit) = \
   if(TAdepthStates_across[state],1-bit,bit);

gp_inline__location="../dragon.tex:97372";
 TAdepth_by_states(n) = {
   my(v=binary(n),depth=0,state=1);
   for(i=1,#v,  /* bits high to low */
       my(bit=v[i],
          out=bitxor(bit,TAdepthStates_across[state]));
       if(out, depth += if(state%2, RQ(#v-i), LQ(#v-i)));
       state=TAdepthStates_transition(state,bit));
   depth;
 }

gp_inline__location="../dragon.tex:97459";
 TAancestors(n) = {
   my(l=List([n]));
   while(n, n=TAparent(n); listput(l,n));
   Vec(l);
 }

gp_inline__location="../dragon.tex:97467";
 UnFlipBelow10_by_path_to_n(n) = {
   my(v=TAancestors(n),ret=0);
   v=select(a->a!=0,v);
   while(#v > 1,
     my(m=vecmax(v)); if(!m,break());
     my(highbit=2^(#binary(m)-1));
     \\ print(v"  "highbit);
     ret+=highbit;
     v=select(a->bitand(a,highbit),v);
     v=apply(a->bitxor(a,highbit),v);
     );
   \\ print(v);
   ret;
 }

gp_inline__location="../dragon.tex:97492";
 \\ d is a depth in the twindragon area tree, starting root d=0.
 \\ Return a vector of complex base i+1 point numbers n which are
 \\ the vertices at depth d.
 TA_depth_to_n_list(d) = {
   my(seen=List([0]), vertices=List([0]));
   for(i=1,d,
       \\ print("i="i" vertices=",vertices);
       my(new_vertices = List([]));
       for(p=1,#vertices,
          my(n = vertices[p],
             neighbours = TA_n_to_neighbours(n));
          \\ print("  n="n" neighbours=",neighbours);
          for(j=1,#neighbours,
             my(n2 = neighbours[j]);
             my(pos=setsearch(seen,n2,1));
             if(pos, listput(new_vertices,n2);
                     listinsert(seen,n2, pos))));
       vertices = new_vertices;
      );
   vecsort(Vec(vertices));
 }

gp_inline__location="../dragon.tex:97557";
 WidthS_formula(k,d) = WidthS(k-1,d) + WidthC(k-1,d-RQ(k-1));
 WidthC_formula(k,d) = WidthS(k-1,d) + WidthC(k-1,d-LQ(k-1));

gp_inline__location="../dragon.tex:97561";
 WidthS(k,d) = {
   k>=0 || error("WidthS() is for k>=0");
   if(d<0,0, k==0,d==0, WidthS_formula(k,d));
 }
 WidthC(k,d) = {
   k>=0 || error("WidthC() is for k>=0");
   if(d<0,0, k==0,d==0, WidthC_formula(k,d));
 }

gp_inline__location="../dragon.tex:97570";
 WidthS_list(k) = vector(TAdiameter(k)+1,d,d--; WidthS(k,d));
 WidthC_list(k) = vector(TA_ecc(k)+1,    d,d--; WidthC(k,d));

gp_inline__location="../dragon.tex:97578";
 WidthS_0_samples = {[1]};

gp_inline__location="../dragon.tex:97585";
 WidthS_1_samples = {[1,1]};

gp_inline__location="../dragon.tex:97592";
 WidthS_2_samples = {[1,1,1,1]};

gp_inline__location="../dragon.tex:97599";
 WidthS_3_samples = {[1,1,1,2,2,1]};

gp_inline__location="../dragon.tex:97606";
 WidthS_4_samples = {[1,1,1,2,2,2,1,2,3,1]};

gp_inline__location="../dragon.tex:97613";
 WidthS_5_samples = {[1,1,1,2,2,2,1,2,3,2,1,1,2,3,2,2,3,1]};

gp_inline__location="../dragon.tex:97620";
 WidthS_maximum_max_and_depth(k) = {
   my(v = WidthS_list(k),
      m = vecmax(v),
      d = select(i->v[i]==m, [1..#v]));
   if(#d==1, d=d[1]);
   [m,d];
 }
 WidthS_maximum_max_and_depth = memoize(WidthS_maximum_max_and_depth);
 WidthS_maximum(k)          = WidthS_maximum_max_and_depth(k)[1];
 WidthS_maximum_at_depth(k) = WidthS_maximum_max_and_depth(k)[2];

gp_inline__location="../dragon.tex:97716";
 \\ Make a vector of vectors which are all the WidthS runs.
 \\ Each element vector is  values RQ(i) or LQ(i).  The RQ values
 \\ are indicated by being negative.  vecsum(abs(e)) == d.
 \\
 WidthS_make_runs(k,d) = {
   my(l = List([vector(k+1)]));
   forstep(p=k,1,-1,
     \\ print("p="p" for RQ="RQ(p-1)" LQ="LQ(p-1));
     my(new_l = List([]));
     for(i=1,#l,
         my(v=l[i], t=vecsum(abs(v)));
         \\ print("  consider v="v"  sum t="t);
         if(v[p+1]==0,
            \\ print("below gap, try RQ");
            if(t+RQ(p-1) <= d,
               v[p] = -RQ(p-1); listput(new_l,v)));
         if(v[p+1],
            \\ print("below RQ or LQ, try an LQ");
            if(t+LQ(p-1) <= d,
               v[p] = LQ(p-1); listput(new_l,v)));
         v[p] = 0;
         listput(new_l,v);   \\ always add a gap
      );
      l = new_l;
   );
   l = Vec(l);
   \\ print("final l="l);
   l = select((v)->vecsum(abs(v))==d, l);
   l = apply((v)->vector_shorten_to(v,k), l); \\ strip top sentinels
   l = apply(Vecrev, l);           \\ high to low
   l;
 }
 WidthS_from_runs(k,d) = length(WidthS_make_runs(k,d));

gp_inline__location="../dragon.tex:97918";
 \\ Return the k to use in WidthS(k,d) for infinite tree.
 \\ This is RQ(k) > d >= RQ(k-1).
 WidthS_infinity_k(d) = \
   for(k=0,oo, if(RQ(k)>d, return(k)));

gp_inline__location="../dragon.tex:97927";
 WidthS_infinity(d) = WidthS(WidthS_infinity_k(d), d);
 WidthC_infinity(d) = \
   my(k=1); while(d >= LQ(k-1), k++); WidthC(k+5,d);

gp_inline__location="../dragon.tex:97935";
 WidthS_infinity_samples = {[1,1,1,2,2,2,1,2,3,2,1,1,2,3,2,3,4,2,2,2]};

gp_inline__location="../dragon.tex:97966";
 WidthS_infinity_generated_samples = [1,1,1,2,2,2,1,2,3,2,1,1,2,3,2,3,4,2,2,2,2,2,3,4,3,4,3,3,5,3,2,1,2,3];

gp_inline__location="../dragon.tex:97997";
 WidthS_is_zero(k,d) = {
   k>=0 || error("WidthS_is_zero() is for k>=0");
   d<0 || d > TAdiameter(k);
 }
 WidthC_is_zero(k,d) = {
   k>=0 || error("WidthC_is_zero() is for k>=0");
   d<0 || d > TA_ecc(k);
 }

gp_inline__location="../dragon.tex:98010";
 WidthS_is_one(k,d) = {
   k>=0 || error("WidthS_is_one() is for k>=0");
   if(k==0,return(d==0));
   my(drem = d - RQ(k-1));
   if(WidthS_is_zero(k-1,d),    return(WidthC_is_one(k-1,drem)));
   if(WidthC_is_zero(k-1,drem), return(WidthS_is_one(k-1,d)));
   0;  \\ both S,C non-zero
 }
 WidthC_is_one(k,d) = {
   k>=0 || error("WidthC_is_one() is for k>=0");
   if(k==0,return(d==0));
   if(WidthS_is_zero(k-1,d), return(WidthC_is_one(k-1,d-LQ(k-1))));
   if(WidthC_is_zero(k-1,d-LQ(k-1)), return(WidthS_is_one(k-1,d)));
   0;  \\ both S,C non-zero
 }

gp_inline__location="../dragon.tex:98030";
 WidthS_infinity_is_one(d) = \
   WidthS_is_one(WidthS_infinity_k(d), d);

gp_inline__location="../dragon.tex:98035";
 \\ dJA_threes() is sum dJA(k) + dJA(k-3) + ...
 dJA_threes(k) = my(total=0); \
   forstep(i=k,0,-3, total+=dJA(i)); total;
 gdJA_threes(x) = {
   -1/6 * 1/(1 - x)
   + 1/3 * (2 + x)/(1 + x + x^2)
   + (-1/2 + x + x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:98079";
 DOne(m) = {
   if(m==0,0,
      m%3==0, JA(m+3),
      m%3==1, JA(m+3) - 1,
              JA(m+2));
 }
 DOne_A_by_sum(m) = sum(i=0,m,RQ(3*i));
 DOne_B_by_sum(m) = -1 + sum(i=0,m,RQ(3*i+1));
 DOne_C_by_sum(m) =      sum(i=0,m,RQ(3*i+1));
 DOne_by_sum(m) = {
   if(m==0,0,
      m%3==0, DOne_A_by_sum(m\3),
      m%3==1, DOne_B_by_sum(m\3),
              DOne_C_by_sum(m\3));
 }

gp_inline__location="../dragon.tex:98098";
 DOne_samples = {[0,1,2,6,10,11,31,53,54,154,262,263,755,1281,1282]};

gp_inline__location="../dragon.tex:98123";
 gDOne(x) = {
   -1
   - x/(1-x^3)
   - 1/2* 1/(1-x)
   + 1/2* (3+2*x+2*x^2)/(1-x-2*x^3)
   - x^2/( 1 - 7*x^3 + 12*x^6 - 8*x^9 );
 }

gp_inline__location="../dragon.tex:98136";
 gDOne_partial_fractions(x) = {
   -1
   - 5/6 * 1/(1 - x)
   + 1/3 * (1 - x)/(1 + x + x^2)
   + (7/6 + x + x^2)/(1 - x - 2*x^3)
   + 1/3 * (1 + 2*x - 2*x^3)/(1 + x + x^2 - 4*x^3 - 2*x^4 + 4*x^6);
 }

gp_inline__location="../dragon.tex:98317";
 LQ_k_sub_2_add_to_JA(k) = dJA_threes(k-5)-vector_modulo([0,0,1],k);

gp_inline__location="../dragon.tex:98331";
 JA_k_sub_1_add_to_LQ_k_sub_2(k) = 1 + JA(k-2);

gp_inline__location="../dragon.tex:98346";
 dJA_k_sub_1_add_to_JA_k_sub_1_minus_1(k) = \
   - vector_modulo([2,1,1],k) + dJA_threes(k-3);

gp_inline__location="../dragon.tex:98359";
 JA_k_sub_2_add_to_dJA_k_sub_1_vector = {[1,1,0]};

gp_inline__location="../dragon.tex:98367";
 \\ amount to add to JA(k-2) to reach dJA(k-1),
 \\ ie. dJA(k-1) - JA(k-2)
 JA_k_sub_2_add_to_dJA_k_sub_1(k) = {
   dJA_threes(k-5)
   + vector_modulo(JA_k_sub_2_add_to_dJA_k_sub_1_vector,k);
 }

gp_inline__location="../dragon.tex:98433";
 w3 = -1/2 + 1/2*sqrt3i;

gp_inline__location="../dragon.tex:98455";
 gdJA_1mod3(x) = \
   1/3*(gdJA(x) + w3^2*gdJA(x*w3) + w3^4*gdJA(x*w3^2));

gp_inline__location="../dragon.tex:98546";
 WidthS_infinity_sum(d) = sum(j=0,d, WidthS_infinity(j));

gp_inline__location="../dragon.tex:98563";
 DOneV_formula(m) = {
   if(m%3==0, JND(m+3),
      m%3==1, JND(m+3) - 1,
              JND(m+2));
 }
 DOneV(m) = if(m==0,0, DOneV_formula(m));

gp_inline__location="../dragon.tex:98573";
 DOneV_by_powers(m) = {
   if(m%3==0, 1/7*(2^(m+3)-vector_modulo([1,2,4],m)),
      m%3==1, 1/7*(2^(m+3)-vector_modulo([8,9,11],m)),
              1/7*(2^(m+2)-vector_modulo([4,1,2],m)));
 }

gp_inline__location="../dragon.tex:98583";
 DOneV_samples = {[0,1,2,9,17,18,73,145,146,585,1169,1170]};

gp_inline__location="../dragon.tex:98598";
 DOneV_binary_samples = {[0,1,10,1001,10001,10010,1001001,10010001,10010010]};

gp_inline__location="../dragon.tex:98662";
 DOneN_list_by_vpar(k) = {
   my(depths=vpar_depths_vector(TA_vpar(k)),l=List([]));
   for(m=0,#depths,
       my(d=DOne(m));
       my(nv=select(nd->nd==d,depths,1)); \\ indices
       if(#nv==0,break());
       if(#nv!=1,error());
       listput(l,nv[1]-1));
   Vec(l);
 }

gp_inline__location="../dragon.tex:98724";
 DOneN_formula(m) = {
   if(m%3==0, 1/3*(2^(m+2) - vector_modulo([1,2],m)) ,
      m%3==1, 1/3*(2^(m+2) + vector_modulo([2,-5],m)),
              1/3*(2^(m+1) - vector_modulo([2,1],m)) );
 }
 DOneN(m) = if(m==0,0, DOneN_formula(m));

gp_inline__location="../dragon.tex:98738";
 vector_is_monotonic_increasing(v) = \
   for(i=1,#v-1, if(!(v[i]<v[i+1]),return(0))); 1;

gp_inline__location="../dragon.tex:98743";
 DOneN_samples = {[0,1,2,10,22,21,85,169,170,682,1366,1365]};

gp_inline__location="../dragon.tex:98758";
 DOneN_binary_samples = {[0,1,10,1010,10110,10101,1010101,10101001,10101010]};

gp_inline__location="../dragon.tex:98848";
 TAindnum(k) = if(k==0,1, 2^(k-1));

gp_inline__location="../dragon.tex:98863";
 TAindRatio(k) = if(k==0,1,1/2);

gp_inline__location="../dragon.tex:98896";
 TAdomnum_initial = {[1,1,2,4,7]};

gp_inline__location="../dragon.tex:98906";
 TAdomnum_formula(k) = 13*2^(k-5) + 1;
 TAdomnum(k) = if(k<=4,TAdomnum_initial[k+1], TAdomnum_formula(k));

gp_inline__location="../dragon.tex:98912";
 TAdomnum_samples = {[1,1,2,4,7,14,27,53,105,209,417]};

gp_inline__location="../dragon.tex:99028";
 TAdomRatio_initial = {[1,1/2,1/2,1/2,(7)/(16)]};

gp_inline__location="../dragon.tex:99034";
 TAdomRatio_limit = {(13)/(32)};

gp_inline__location="../dragon.tex:99041";
 TAdomRatio_formula(k) = TAdomRatio_limit + 1/2^k;
 TAdomRatio(k) = if(k<=4,TAdomRatio_initial[k+1], \
                    TAdomRatio_formula(k));

gp_inline__location="../dragon.tex:99089";
 TAindomnum(k) = TAdomnum(k);

gp_inline__location="../dragon.tex:99137";
 \\ with +1 for 1-based vpar
 gen_TA_indomnum_k5_set1 = Set([1,3,7,16,14,10,5,32,30,26,17,19,23,28]);

gp_inline__location="../dragon.tex:99215";
 TAtotdomnum_formula(k) = 2^(k-1);
 TAtotdomnum(k) = if(k==0,-1, k==1,2, TAtotdomnum_formula(k));

gp_inline__location="../dragon.tex:99225";
 TAtotdomnum_samples = {[2,2,4,8,16]};

gp_inline__location="../dragon.tex:99242";
 TAtotdomnumCount_initial = {[0,1,1,1,1,9]};

gp_inline__location="../dragon.tex:99254";
 TAtotdomnumCount_formula(k) = 1/4 * 30^(2^(k-5));
 TAtotdomnumCount(k) = {
   if(k<=5,TAtotdomnumCount_initial[k+1],
      TAtotdomnumCount_formula(k));
 }

gp_inline__location="../dragon.tex:99265";
 TAtotdomnumCount_samples = {[0,1,1,1,1,9,225,202500,164025000000]};

gp_inline__location="../dragon.tex:99324";
 \\ with +1 for 1-based vpar
 gen_TA_totdomnum_k5_set1 = Set([2,3,6,7,10,11,14,15,18,19,22,23,26,27,30,31]);

gp_inline__location="../dragon.tex:99572";
 TAtotdomnum_k4_flags_list = {[
   [ 0,1,1,0,0,1,1,0, 0,1,1,0,0,1,1,0 ]  \\ unique
 ]};

gp_inline__location="../dragon.tex:99585";
 vector_swap_entries(v,i,j) = my(t=v[i]); v[i]=v[j]; v[j]=t; v;
 TAtotdomnum_k5_flags_list = {List([
   [0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,
    0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0]
 ])};
 \\ 8 <--> 22
 listput(TAtotdomnum_k5_flags_list, \
   vector_swap_entries(TAtotdomnum_k5_flags_list[1], 8+1,22+1));
 \\ 9 <--> 23
 listput(TAtotdomnum_k5_flags_list, \
   vector_swap_entries(TAtotdomnum_k5_flags_list[1], 9+1,23+1));
 \\ 8 <--> 22 and 9 <--> 23
 listput(TAtotdomnum_k5_flags_list, \
   vector_swap_entries(TAtotdomnum_k5_flags_list[2], 9+1,23+1));

gp_inline__location="../dragon.tex:99682";
 TAsemitotdomnum(k) = if(k==0,-1, k==1,2, TAdomnum(k));

gp_inline__location="../dragon.tex:99724";
 TAdisdomnum_formula(k) = 2*TAdomnum(k);
 TAdisdomnum(k) = if(k==0,-1, TAdisdomnum_formula(k));

gp_inline__location="../dragon.tex:99729";
 TAdisdomnum_samples = {[2,4,8,14,28,54,106]};

gp_inline__location="../dragon.tex:99750";
 TAdisdomnumCount_initial = {[0,1,2,8,36]};

gp_inline__location="../dragon.tex:99761";
 TAdisdomnumCount_formula(k) = 4 * 5332^(2^(k-5));
 TAdisdomnumCount(k) = {
   if(k<=4, TAdisdomnumCount_initial[k+1],
            TAdisdomnumCount_formula(k));
 }

gp_inline__location="../dragon.tex:99777";
 TAdisdomnumCount_samples = {[0,1,2,8,36,21328,113720896]};

gp_inline__location="../dragon.tex:99828";
 \\ with +1 for 1-based vpar
 gen_TA_disdomnum_k5_setA = Set([1,4,7,16,13,10,5,32,29,26,17,20,23,28]);
 gen_TA_disdomnum_k5_setB = Set([2,3,8,15,14,9,12,31,30,25,18,19,24,21]);

gp_inline__location="../dragon.tex:100400";
 xy_to_odd_turn_matrix = {[ 0,-1;    \\ x=0  y=0,1
                            1, 0 ]}; \\ x=1  y=0,1

gp_inline__location="../dragon.tex:100424";
 Ba2_generated_samples = [4,8,12,24,44,72,124,216,364];
 Ba3_generated_samples = [6,12,16,32,60,96,164,288,484];
 Ba4_generated_samples = [8,16,16,32,64,96,160,288,480];

gp_inline__location="../dragon.tex:100533";
 W_formula(k) = if(k==0,2, 2*L(k-1));
 W(k) = if(k==1,4, W_formula(k));

gp_inline__location="../dragon.tex:100538";
 W_samples = {[2,4,4,8,16,24,40,72,120,200,344]};

gp_inline__location="../dragon.tex:100554";
 gW(x) = 2*(x+1)/(1-x-2*x^3);

gp_inline__location="../dragon.tex:100569";
 WQ(k) = 1/2*W(k);

gp_inline__location="../dragon.tex:100845";
 W_over_Lplus1_limit = 2 /r^2;

gp_inline__location="../dragon.tex:100852";
 W_over_Lplus1_nfelt = {
   one_nfelt - nfeltpow(cubic_nf,r_nfelt,-3)
             - 4*nfeltpow(cubic_nf,r_nfelt,-7);
 }

gp_inline__location="../dragon.tex:100865";
 W_over_Lplus1_sample = {(0695620/1000000)};

gp_inline__location="../dragon.tex:100885";
 Ba2(k) = B(k) + W(k);

gp_inline__location="../dragon.tex:100887";
 Ba2_samples = {[4,8,12,24,44,72,124,216,364,616,1052]};

gp_inline__location="../dragon.tex:100899";
 Ba2_from_L_R(k) = if(k<2,4*2^k, R(k+1) + 2*L(k-1));

gp_inline__location="../dragon.tex:100902";
 gBa2(k) = 4 + 8*x + x^2 *( (14 + 12*x + 20*x^2)/(1 - x - 2*x^3) - 2/(1-x) );

gp_inline__location="../dragon.tex:100923";
 Aa2(k) = 2*A(k) + JA(k+1);

gp_inline__location="../dragon.tex:100927";
 Aa2_samples = {[0,0,1,2,5,14,33,74,165,358,761]};

gp_inline__location="../dragon.tex:101105";
 Ba3(k) = B(k) + 2*W(k);

gp_inline__location="../dragon.tex:101107";
 Ba3_samples = {[6,12,16,32,60,96,164,288,484,816,1396]};

gp_inline__location="../dragon.tex:101114";
 gBa3(k) = gBa2(k) + gW(k);

gp_inline__location="../dragon.tex:101126";
 Aa3(k) = 3*A(k) + 2*JA(k+1);

gp_inline__location="../dragon.tex:101130";
 Aa3_samples = {[0,0,2,4,9,24,55,120,263,564,1187]};

gp_inline__location="../dragon.tex:101225";
 Ba4(k) = 4*W(k);

gp_inline__location="../dragon.tex:101227";
 Ba4_samples = {[8,16,16,32,64,96,160,288,480,800]};

gp_inline__location="../dragon.tex:101243";
 gBa4(x) = 4*gW(x);

gp_inline__location="../dragon.tex:101249";
 Aa4(k) = 2*2^k - 1/4*Ba4(k);

gp_inline__location="../dragon.tex:101255";
 Aa4_samples = {[0,0,4,8,16,40,88,184,392,824]};

gp_inline__location="../dragon.tex:101274";
  Ba3_sub_Ba4(k) = Ba3(k) - Ba4(k);
 gBa3_sub_Ba4(x) = gBa3(x) - gBa4(x);
 Ba3_sub_Ba4_samples = {[-2,-4,0,0,-4,0,4,0,4,16,20,32,68,112]};

gp_inline__location="../dragon.tex:101289";
  Ba3_sub_Ba4_from_BlobL_vector = {[20,24,20,8]};

gp_inline__location="../dragon.tex:101295";
 Ba3_sub_Ba4_from_BlobL(k) = \
   8*BlobL(k-6) + vector_modulo(Ba3_sub_Ba4_from_BlobL_vector,k);

gp_inline__location="../dragon.tex:101317";
 B3_over_B4_limit = 1/16*r^4 + 1/2;
 B3_over_B4_nfelt = \
   1/16*nfeltpow(cubic_nf,r_nfelt,4) + 1/2*one_nfelt;

gp_inline__location="../dragon.tex:101336";
 B3_over_B4_limit_sample = {(1016648/1000000)};

gp_inline__location="../dragon.tex:101353";
 BQa3(k) = BQ(k) + 2*WQ(k);
 BQa4(k) = 4*WQ(k);
 BQa3_BQa4_diff(k) = BQa3(k) - BQa4(k);

gp_inline__location="../dragon.tex:101527";
 three_inward_B(k) = 2*L(k+1) + R(k) + L(k);

gp_inline__location="../dragon.tex:101529";
 three_inward_B_samples = {[6,12,24,40,68,120,204,344,588,1000,1692,2872]};

gp_inline__location="../dragon.tex:101537";
 three_inward_BQ(k) = 2*LQ(k+1) + RQ(k) + LQ(k);
 gBQ3I(x) = 2*1/x*(gLQ(x)-1) + gRQ(x) + gLQ(x);

gp_inline__location="../dragon.tex:101545";
 three_inward_BQ_samples = {[4,7,13,21,35,61,103,173,295,501,847,1437]};

gp_inline__location="../dragon.tex:101553";
 three_inward_A(k) = 3*A(k) + 2*JA(k);

gp_inline__location="../dragon.tex:101555";
 three_inward_A_samples = {[0,0,0,2,7,18,45,106,237,518,1113,2354]};

gp_inline__location="../dragon.tex:101693";
 four_inward_B(k) = 4*L(k+1);

gp_inline__location="../dragon.tex:101695";
 four_inward_B_samples = {[8,16,32,48,80,144,240,400,688,1168,1968,3344]};

gp_inline__location="../dragon.tex:101711";
 four_inward_BQ(k) = 4*LQ(k+1);

gp_inline__location="../dragon.tex:101713";
 four_inward_BQ_samples = {[4,8,16,24,40,72,120,200,344,584,984,1672]};

gp_inline__location="../dragon.tex:101731";
 four_inward_A(k) = 4*A(k) + 4*JA(k);

gp_inline__location="../dragon.tex:101736";
 four_inward_A_samples = {[0,0,0,4,12,28,68,156,340,732,1556,3260]};

gp_inline__location="../dragon.tex:101764";
 hull_4I(k) = {   /* anti-clockwise */
   vector_unique(concat(vector(4,d,d--;
     I^d * [b^k - P4(k),
            b^k - P3(k),
            b^k - P2(k)])));
 }

gp_inline__location="../dragon.tex:101790";
 hull_4I_count(k) = length(hull_4I(k));

gp_inline__location="../dragon.tex:101977";
 H4IA_multiply_vector = {[10,18,10,14]};

gp_inline__location="../dragon.tex:101982";
 H4IA_constant_vector = {[2,2,0,0]};

gp_inline__location="../dragon.tex:101986";
 H4IA(k) = {
   1/3* ( 14 * 2^k
          - vector_modulo(H4IA_multiply_vector,k) * 2^floor(k/2)
          + vector_modulo(H4IA_constant_vector,k) );
 }

gp_inline__location="../dragon.tex:101995";
 H4IA_samples = {[2,4,12,28,62,126,272,560,1142]};

gp_inline__location="../dragon.tex:102013";
 H4ID_half = {[40,80,56,40]};

gp_inline__location="../dragon.tex:102018";
 H4ID_add = {[8,16,20,4]};

gp_inline__location="../dragon.tex:102022";
 H4ID(k) = {
   1/9 * (68 * 2^k
          - vector_modulo(H4ID_half,k) * 2^floor(k/2)
          + vector_modulo(H4ID_add,k)  );
 }

gp_inline__location="../dragon.tex:102036";
 H4ID_samples = {[4,8,20,52,104,208,436,932,1864,3728]};

gp_inline__location="../dragon.tex:102045";
 H4ID_x(k) = abs(real(hull_4I(k)[2] / I^floor(k/2)));
 H4ID_y(k) = abs(imag(hull_4I(k)[2] / I^floor(k/2)));

gp_inline__location="../dragon.tex:102063";
 vector_max_pair_norm_descending(v) = {
   my(l=List([]));
   for(i=1,#v, for(j=i+1,#v, listput(l, norm(v[i]-v[j]))));
   Vecrev(vecsort(Vec(l)));
 }

gp_inline__location="../dragon.tex:102249";
 Acycle(k) = if(k==0,1, 2^(k+1) + 4*A(k-1));

gp_inline__location="../dragon.tex:102251";
 Acycle_samples = {[1,4,8,16,32,68,144,300,624,1292]};

gp_inline__location="../dragon.tex:102280";
 fpoint_by_limit(f,k) = dragon_n_to_z(floor(f * 2^k))/b^k;

gp_inline__location="../dragon.tex:102501";
 fpoint_of_KM_sum(k) = 1/2 + sum(j=0,k-1, (-1)^j * 1/2^2^j);

gp_inline__location="../dragon.tex:102506";
 fpoint_of_KM_decimal_sample = {(0808609/1000000)};

gp_inline__location="../dragon.tex:102522";
 A275975_vector(len) = {
   my(ret=0,s=10^len);
   for(j=0,oo,
     my(t=s/2^(2^j));   \\ print(t/s" "t" "t*1.0);
     if(frac(ret)+t<1 && frac(ret)-t>=0,
        return(digits(floor(ret))));
     ret += (-1)^j*t);
 }

gp_inline__location="../dragon.tex:102537";
 fpoint_KM_binary_sample = {(0110011110/1000000000)};

gp_inline__location="../dragon.tex:102581";
 Shallit_C_sum(u,k) = sum(j=0,k,(-1)^j/u^2^j);

gp_inline__location="../dragon.tex:102600";
 fpoint_of_PaperConst_to_n(n) = dragon_fpoint(PaperConst_to_n(n));

gp_inline__location="../dragon.tex:102615";
 fpoint_of_PaperConst_real_sample = {(0666666/1000000)};

gp_inline__location="../dragon.tex:102625";
 fpoint_of_PaperConst_imag_sample = {(0184069/1000000)};

gp_inline__location="../dragon.tex:102636";
 fpoint_of_PaperConst_real_binary_sample = {(0101010/1000000)};

gp_inline__location="../dragon.tex:102645";
 fpoint_of_PaperConst_imag_binary_sample = {(0001011110/1000000000)};

gp_inline__location="../dragon.tex:102806";
 fraction_transform(f) = if(f<=1/2, 2*f, 2*(1-f));

gp_inline__location="../dragon.tex:102834";
 \\ den is a denominator (an integer).
 \\ Fractional points 0/(2^k*den) through (2^k*den)/(2^k*den) are
 \\ considered, so numerators 0 to 2^k*den.
 \\ The return is a Map() of location z -> List() of numerators.
 fractional_location_map(den,k) = {
   my(m=Map()); den *= 2^k;
   for(num=0,den,
       my(z=dragon_fpoint(num/den));
       my(l=if(mapisdefined(m,z), mapget(m,z), List([])));
       listput(l,num);
       mapput(m,z,l));
   m;
 }

gp_inline__location="../dragon.tex:102848";
 \\ den is a denominator (an integer).
 \\ Fractional points 0/(2^k*den) through (2^k*den)/(2^k*den) are
 \\ considered, so numerators 0 to 2^k*den.
 \\ The return is a vector [count1, count2, ccount3] which are
 \\ counts of how many locations there are visited by 1, 2 or 3
 \\ of these fractional points respectively.
 fractional_location_counts(den,k) = {
   my(m=Mat(fractional_location_map(den,k)));
   my(counts=vector(3));
   for(i=1,matsize(m)[1], counts[#m[i,2]]++);
   counts;
 }

gp_inline__location="../dragon.tex:102861";
 \\ v is a vector of numerators of fractions v[i]/(2^k*den),
 \\ where k is the smallest integer giving fractions <=1.
 \\ Return true if all the v fractions are the same location.
 triple_is_same_location(v,den) = {
  v /= den * 2^length(binary(vecmax(v)));
  v = apply(dragon_fpoint,v);
  vector_is_all_equal(v);
 }

gp_inline__location="../dragon.tex:103029";
 seventh_135_z = {2/5-1/5*I};

gp_inline__location="../dragon.tex:103203";
 seventh_13_17_19_z = {3/5-(3)/(10)*I};

gp_inline__location="../dragon.tex:103418";
 SeventhTriples_by_count(k) = \
 fractional_location_counts(7,k)[3];
 SeventhTriples_pairs_by_count(k) = \
   fractional_location_counts(7,k)[2];
 SeventhTriples_singles_by_count(k) = \
   fractional_location_counts(7,k)[1];
 SeventhTriples_total_by_count(k) = \
   vecsum(fractional_location_counts(7,k));

gp_inline__location="../dragon.tex:103439";
 SeventhTriples(k) = A(k+2);

gp_inline__location="../dragon.tex:103443";
 gSeventhTriples(x) = gA(x)/x^2;

gp_inline__location="../dragon.tex:103546";
 Sevenths135(k) = 2*Deven(k) + if(k==0,0, 2^(k-1)-1);

gp_inline__location="../dragon.tex:103673";
 Sevenths246(k) = AR(k+2);

gp_inline__location="../dragon.tex:103820";
 \\ den is a denominator (an integer), 7 or 15.
 \\ Return true if num occurs as a fractional triple point,
 \\ so f = num/(den*2^k) is one of a triple visit to its location.
 \\ This is done by a naive search of surrounding segments and
 \\ all f/den offsets into them.
 fractional_is_triple(num,den) = {
   my(debug=0);
   my(k=max(8,length(binary(num))+3),
      denk=den*2^k,
      target_z=dragon_fpoint(num/denk),
      n=num\den,
      z1=dragon_point(n),
      d=dir(n),
      z2=z1+I^d,
      zv=[z1, z1+I^(d-1), z1+I^(d+1),
          z2, z2+I^(d+2-1), z2+I^(d+2+1)],
      seen_n_map=Map(),
      num_list=List([]));
   for(x=-2,3, for(y=-2,2,
     my(z=z1 + I^d*x + I^(d+1)*y);
     my(n_list=z_to_n_list(z));
     if(debug,print("  n_list "n_list));
     for(j=1,#n_list,
       for(n=max(0,n_list[j]-1), n_list[j]+1,
         if(mapisdefined(seen_n_map,n),next());
         mapput(seen_n_map,n,1);
         if(debug,print("   n="n));
         for(f=1,den-1,
           my(try_num=n*den+f);
           if(debug,print("  try_num "try_num));
           if(dragon_fpoint(try_num/denk)==target_z,
             if(debug,print("    yes"));
             listput(num_list,try_num)))))));
   num_list=Vec(num_list);
   num_list=vector_unique(num_list);
   if(#num_list>3,error("oops, count>3 "num_list));
   #num_list==3;
 }

gp_inline__location="../dragon.tex:103883";
 Sevenths_union_samples = \
     [13,17,19,26,27,31,33,34,37,38,39,43,52,54];

gp_inline__location="../dragon.tex:103892";
 Sevenths_union_diffs_samples = \
     [4,2,7,1,4,2,1,3,1,1,4,9,2];

gp_inline__location="../dragon.tex:103905";
 vector_counts(v) = {
   my(counts=vector(vecmax(v)));
   for(i=1,#v, counts[v[i]]++);
   counts;
 }

gp_inline__location="../dragon.tex:103914";
 sevenths_triples_list_k(k) = {
   my(den=7*2^k, m=Map());
   for(num=0,den,
     my(z=dragon_fpoint(num/den), v=[]);
     mapisdefined(m,z,&v);
     mapput(m,z,concat(v,[num])));
   m=Vec(Mat(m)[,2]);
   m=select(v-> #v<=3||error(); #v==3, m);
   if(#m, m=concat(m));
   vecsort(m);
 }

gp_inline__location="../dragon.tex:103929";
 sevenths_diffs(k) = vector_differences(sevenths_triples_list_k(k));

gp_inline__location="../dragon.tex:103934";
 Sevenths_diffs_occurring = {[1,2,3,4,7,(9/1)]};

gp_inline__location="../dragon.tex:104109";
 sevenths_state_table = {[
   2,3; 4,5; 6,7; 4,5; 8,9; 10,11; 12,13; 10,14; 15,16; 17,18;
   19,20; 21,22; 23,13; 19,20; 24,25; 26,27; 17,28; 29,30; 31,32;
   33,34; 35,36; 37,38; 39,22; 35,36; 40,41; 42,43; 44,27; 29,45;
   46,47; 44,27; 46,48; 49,50; 51,52; 53,54; 55,56; 57,58; 59,60;
   53,54; 35,36; 59,61; 62,63; 64,65; 66,67; 68,43; 44,27; 17,18;
   69,67; 69,70; 71,72; 73,74; 75,76; 77,78; 79,80; 81,54; 55,82;
   83,84; 85,86; 15,16; 46,48; 87,78; 87,78; 88,89; 49,74; 75,90;
   91,92; 31,93; 73,74; 64,65; 31,93; 73,94; 75,76; 95,50; 75,72;
   73,74; 75,76; 95,94; 71,96; 33,34; 55,82; 97,34; 98,80; 83,99;
   100,101; 62,102; 64,65; 103,20; 71,96; 55,82; 83,104; 95,105;
   42,43; 44,27; 49,50; 73,94; 71,72; 95,50; 100,52; 55,82; 62,102;
   75,76; 77,78; 49,94; 31,32; 62,63; 73,94 ]};
 sevenths_state_triples_matrix = {[
   0,0,0,0,0,0;0,0,0,0,0,0;0,0,0,0,0,0;0,0,0,0,0,0;1,0,0,0,0,0;
   0,0,1,0,1,0;0,0,0,0,0,0;0,0,1,0,1,0;1,1,0,0,0,0;0,0,1,0,1,1;
   0,0,1,1,1,0;1,0,0,0,0,0;0,0,0,0,0,0;0,0,1,1,1,0;1,0,0,0,0,0;
   1,1,0,1,0,0;0,0,1,0,1,1;1,1,0,1,0,0;0,0,1,1,1,1;0,0,1,0,1,1;
   1,1,0,0,0,0;0,0,1,0,1,0;1,0,0,0,0,0;1,1,0,0,0,0;1,0,1,0,1,0;
   1,0,1,0,1,1;1,1,0,1,0,0;1,1,0,1,0,0;0,0,1,0,1,1;1,1,0,1,0,0;
   0,0,1,0,1,1;1,1,1,1,1,1;1,1,1,1,1,0;0,0,1,0,1,1;1,1,0,1,0,0;
   1,0,0,0,0,0;0,0,1,1,1,0;0,0,1,0,1,1;1,1,0,0,0,0;0,0,1,1,1,0;
   1,1,1,0,1,1;1,1,1,0,1,1;1,1,1,1,1,0;1,0,1,0,1,1;1,1,0,1,0,0;
   0,0,1,0,1,1;1,1,1,1,1,0;1,1,1,1,1,0;1,1,1,1,1,1;1,1,1,1,1,1;
   1,1,1,1,1,1;0,0,1,1,1,1;1,1,0,1,0,0;0,0,1,0,1,1;1,1,0,1,0,0;
   1,0,1,0,1,1;1,0,1,0,1,0;1,1,0,0,0,0;0,0,1,0,1,1;0,0,1,1,1,1;
   0,0,1,1,1,1;1,1,0,1,0,0;1,1,1,1,1,1;1,1,1,1,1,1;1,1,0,1,0,0;
   0,0,1,1,1,1;1,1,1,1,1,1;1,1,1,0,1,1;0,0,1,1,1,1;1,1,1,1,1,1;
   1,1,1,1,1,1;1,1,1,1,1,1;1,1,1,1,1,1;1,1,1,1,1,1;1,1,1,1,1,1;
   1,1,1,1,1,1;1,1,1,1,1,1;0,0,1,0,1,1;1,1,0,1,0,0;0,0,1,0,1,1;
   1,1,0,1,0,0;1,0,1,0,1,1;1,1,1,1,1,0;1,1,1,0,1,1;1,1,1,0,1,1;
   0,0,1,1,1,0;1,1,1,1,1,1;1,1,0,1,0,0;1,0,1,0,1,1;1,1,1,1,1,1;
   1,0,1,0,1,1;1,1,0,1,0,0;1,1,1,1,1,1;1,1,1,1,1,1;1,1,1,1,1,1;
   1,1,1,1,1,1;1,1,1,1,1,0;1,1,0,1,0,0;1,1,1,0,1,1;1,1,1,1,1,1;
   0,0,1,1,1,1;1,1,1,1,1,1;0,0,1,1,1,1;1,1,1,0,1,1;1,1,1,1,1,1 ]};
 sevenths_state_diffs_matrix = {[
   0,0,0,0,0,0,0,0,0;0,0,0,0,0,0,0,0,0;0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0;0,0,0,1,0,0,0,0,0;0,1,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0;0,1,0,0,0,0,1,0,0;1,0,0,1,0,0,0,0,0;
   1,1,1,0,0,0,0,0,0;2,0,0,1,0,0,0,0,0;0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0;2,0,0,1,0,0,0,0,0;0,0,0,0,0,0,0,0,1;
   1,1,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0;1,1,0,1,0,0,0,0,0;1,0,0,0,0,0,1,0,0;
   0,1,0,1,0,0,0,0,0;0,0,0,0,0,0,0,0,0;1,0,0,0,0,0,1,0,0;
   0,3,0,0,0,0,0,0,0;1,2,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;4,0,1,0,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0;1,1,0,0,0,0,0,0,1;0,0,0,1,0,0,0,0,0;
   2,0,1,0,0,0,0,0,0;1,1,0,1,0,0,0,0,0;1,0,0,0,0,0,1,0,0;
   2,0,1,0,0,0,0,0,0;3,2,0,0,0,0,0,0,0;3,1,1,0,0,0,0,0,0;
   4,1,0,0,0,0,0,0,0;1,2,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;
   1,1,1,0,0,0,0,0,0;4,1,0,0,0,0,0,0,0;4,1,0,0,0,0,0,0,0;
   5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0;1,3,0,0,0,0,0,0,0;0,2,0,0,0,0,1,0,0;
   1,0,0,1,0,0,0,0,0;1,2,0,0,0,0,0,0,0;3,0,0,1,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   5,0,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;3,1,0,0,0,0,0,0,0;
   5,1,0,0,0,0,0,0,0;3,1,1,0,0,0,0,0,0;3,1,0,0,0,0,0,0,0;
   5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;1,1,0,1,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;
   1,3,0,0,0,0,0,0,0;4,0,1,0,0,0,0,0,0;3,2,0,0,0,0,0,0,0;
   3,1,1,0,0,0,0,0,0;2,0,0,1,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0;1,3,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   1,2,0,1,0,0,0,0,0;1,1,0,1,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   4,0,1,0,0,0,0,0,0;1,1,0,1,0,0,0,0,0;3,2,0,0,0,0,0,0,0;
   5,1,0,0,0,0,0,0,0;3,0,0,1,0,0,0,0,0;5,1,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0;3,2,0,0,0,0,0,0,0;5,1,0,0,0,0,0,0,0 ]};

gp_inline__location="../dragon.tex:104182";
 gSeventhsDiff(diff) = {
   my(gfs=state_table_to_gfs(sevenths_state_table));
   sum(state=1,#gfs,
       gfs[state] * sevenths_state_diffs_matrix[state,diff]);
 }

gp_inline__location="../dragon.tex:104188";
 \\ triples = vector of flags like [1,1,1,1,1,1] which are desired
 \\ 7ths 1 to 6.
 \\ Return gf which is how segments is exactly this set of triples.
 gSeventhsTriples(triples) = {
   my(gfs=state_table_to_gfs(sevenths_state_table));
   sum(state=1,#gfs,
       if(sevenths_state_triples_matrix[state,]==triples,
          gfs[state]));
 }

gp_inline__location="../dragon.tex:104198";
 \\ sorted list of the 7ths differences in curve k
 sevenths_diffs_by_states(k) = {
   concat(vector(9,diff,
          vector(gf_term(gSeventhsDiff(diff),k),i,diff)));
 }

gp_inline__location="../dragon.tex:104253";
 vector_select_bitwise(v,n) = {
   my(l=List([]));
   for(i=1,#v, if(bittest(n,i-1), listput(l,v[i])));
   Vec(l);
 }

gp_inline__location="../dragon.tex:104263";
 setunion_many(v) = {
   my(ret=if(#v,v[1],[]));
   for(i=2,#v, ret=setunion(ret,v[i]));
   ret;
 }

gp_inline__location="../dragon.tex:104271";
 Sevenths_within_list = [ [1], [1,2], [3,5], [3,5,6], [4] ];
 sets_all_unions(v) = {
   vector_unique(
   vector(2^#Sevenths_within_list,n,n--;
          setunion_many(vector_select_bitwise(v,n)))
   );
 }
 Sevenths_within_combinations=sets_all_unions(Sevenths_within_list);
 Sevenths_within_differences = {
  vecsort(vector_unique(concat(apply(vector_differences,
                                  Sevenths_within_combinations))));
 }

gp_inline__location="../dragon.tex:104301";
 SeventhsDiff7_samples = {[0,0,0,1,2,3,4,5,6]};

gp_inline__location="../dragon.tex:104379";
 SeventhsDiff9_samples = {[0,0,0,0,1,2,3,4,5]};

gp_inline__location="../dragon.tex:104535";
 SeventhsAll(k) = gf_term(gSeventhsAll(x),k);
 SeventhsNotAll(k) = 2^k - SeventhsAll(k);

gp_inline__location="../dragon.tex:104538";
 gSeventhsAll(x) = gSeventhsTriples([1,1,1,1,1,1]);

gp_inline__location="../dragon.tex:104545";
 SeventhsAll_samples = {[0,0,0,0,0,1,4,17,56,157]};

gp_inline__location="../dragon.tex:104571";
 gSeventhsNotAll(x) = 1/(1-2*x) - gSeventhsAll(x);

gp_inline__location="../dragon.tex:104577";
 SeventhsNotAll_samples = {[1,2,4,8,16,31,60,111,200,355]};

gp_inline__location="../dragon.tex:104604";
 TSeventhTriples(k) = TA(k+2);

gp_inline__location="../dragon.tex:104607";
 twindragon_fractional_location_counts(den,k) = {
   my(m=Map());
   den *= 2^(k+1);
   for(num=0,den-1,
      my(z=dragon_fpoint(num/den));
      for(rev=0,1,
          mapput(m,z, 1 + mapget_or_zero(m,z));
          z = 1-z));
   m=Mat(m);
   my(counts=vector(3));
   for(i=1,matsize(m)[1], counts[m[i,2]]++);
   counts;
 }

gp_inline__location="../dragon.tex:104670";
 twindragon_triple_numerators(den,k) = {
   my(m=Map());
   den *= 2^(k+1);
   for(num=0,den-1,
      my(z=dragon_fpoint(num/den));
      for(rev=0,1,
          my(l);
          if(mapisdefined(m,z),
             l=mapget(m,z),
             l=List([]));
          listput(l,num);
          mapput(m,z,l);
          z=1-z));
   my(v=Vec(Mat(m)[,2])); \\ lists
   v=select(l->#l==3,v); \\ print(v);
   v=apply(l->Vec(l),v);
   Set(concat(v));
 }

gp_inline__location="../dragon.tex:104709";
 TSevenths_union_samples = \
     [3,5,6,10,12,13,17,19,20,24,26,27,31,33,34,37];

gp_inline__location="../dragon.tex:104722";
 TSevenths_union_diffs_samples = \
     [2,1,4,2,1,4,2,1,4,2,1,4,2,1,3];

gp_inline__location="../dragon.tex:104794";
 zf_Plus_to_Minus(z) = conj(z) + (-1/5 + 2/5*I);
 zf_Minus_to_Plus(z) = conj(z) + ( 1/5 + 2/5*I);

gp_inline__location="../dragon.tex:105037";
 A260748_samples_length = \
   vecmin([#A260748_samples, #A260749_samples, #A260750_samples]);
 A260748_samples_triplets = vector(A260748_samples_length,i, \
   [A260748_samples[i], A260749_samples[i], A260750_samples[i]]);

gp_inline__location="../dragon.tex:105079";
 is_A260482(n) = {
   my(debug=0);
   my(r); [n,r]=divrem(n,5);
   my(z,dz);
   if(n%2==0, z=dragon_point(n); dz=I^dir(n),
              z=dragon_point(n+1); dz=-I^dir(n); r=5-r);
   if(debug,print("n="n" r="r" at z="z" dz="dz));
   if(r==0, 0,
      r==1,    segment_is_traversed(z, z+I*dz)
            && segment_is_traversed(z, z-I*dz),
      r==2,    segment_is_traversed(z, z+I*dz)
            && segment_is_traversed(z+(1-I)*dz, z-I*dz),
      r==4,    segment_is_traversed(z, z+I*dz)
            && segment_is_traversed(z+(1-I)*dz, z+dz),
      r==3,    segment_is_traversed(z+(1-I)*dz, z+dz));
 }

gp_inline__location="../dragon.tex:105102";
 gen_fifteenths_difference_values = {[
   [  ],
   [ 8,2 ],
   [ 8,2,3,11,2,3,4,1 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,8 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,4,1,3,4,2,20,8,2,3,2,
     8,1,2,3,1,3,1,1,3,2,11,4,5,1,4,3,2,11,3,2,8 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,4,1,3,4,2,20,8,2,3,2,
     8,1,2,3,1,3,1,1,3,2,11,4,5,1,4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,
     3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,3,1,1,2,2,1,
     2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,3,1,4,2,3,2,8,1,2,3,4,1,
     21,5,1,4,3,2,11,3,2,8 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,4,1,3,4,2,20,8,2,3,2,
     8,1,2,3,1,3,1,1,3,2,11,4,5,1,4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,
     3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,3,1,1,2,2,1,
     2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,3,1,4,2,3,2,8,1,1,1,3,4,
     1,2,3,2,2,1,1,1,2,1,1,3,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,
     2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,
     2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,1,
     2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,2,2,3,1,2,2,1,1,1,3,2,2,
     1,4,1,5,4,11,2,3,1,1,3,1,3,2,1,8,2,3,2,8,20,2,4,3,1,4,2,3,2,8,
     1,2,3,4,1,21,5,1,4,3,2,11,3,2,8 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,4,1,3,4,2,20,8,2,3,2,
     8,1,2,3,1,3,1,1,3,2,11,4,5,1,4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,
     3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,3,1,1,2,2,1,
     2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,3,1,4,2,3,2,8,1,1,1,3,4,
     1,2,3,2,2,1,1,1,2,1,1,3,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,
     2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,
     2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,1,
     2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,2,2,3,1,2,2,1,1,1,3,2,2,
     1,4,1,5,4,11,2,3,1,1,2,1,1,3,2,1,8,2,3,1,1,4,1,3,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,
     2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,
     1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,
     3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,
     1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,4,1,2,3,2,3,1,1,2,1,1,1,2,2,3,2,1,4,3,1,1,1,8,2,3,2,4,1,3,
     4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,1,2,1,2,2,1,1,3,1,1,3,2,11,3,
     1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,2,2,1,1,1,3,2,
     2,1,4,1,5,4,11,2,3,1,1,3,1,3,2,1,8,2,3,2,8,20,2,4,3,1,4,2,3,2,
     8,1,2,3,4,1,21,5,1,4,3,2,11,3,2,8 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,4,1,3,4,2,20,8,2,3,2,
     8,1,2,3,1,3,1,1,3,2,11,4,5,1,4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,
     3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,3,1,1,2,2,1,
     2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,3,1,4,2,3,2,8,1,1,1,3,4,
     1,2,3,2,2,1,1,1,2,1,1,3,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,
     2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,
     2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,1,
     2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,2,2,3,1,2,2,1,1,1,3,2,2,
     1,4,1,5,4,11,2,3,1,1,2,1,1,3,2,1,8,2,3,1,1,4,1,3,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,
     2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,
     1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,
     3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,
     1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,4,1,2,3,2,3,1,1,2,1,1,1,2,2,3,2,1,4,3,1,1,1,8,2,3,2,4,1,3,
     4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,1,3,2,11,
     3,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,2,2,1,
     1,1,3,2,2,1,1,1,2,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,
     1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,
     2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,
     1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,
     1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,
     8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,
     2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,2,
     2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,
     1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,3,1,4,1,1,3,2,8,1,2,3,1,1,2,1,1,3,2,11,4,5,1,4,1,2,2,
     3,1,1,1,2,2,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,2,
     2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,
     1,2,2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,
     1,1,1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,3,1,1,2,1,1,1,2,2,3,2,1,4,3,
     1,1,1,8,2,3,2,4,1,3,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,1,2,1,2,
     2,1,1,3,1,1,3,2,11,3,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,
     2,2,3,1,2,2,1,1,1,3,2,2,1,4,1,5,4,11,2,3,1,1,3,1,3,2,1,8,2,3,
     2,8,20,2,4,3,1,4,2,3,2,8,1,2,3,4,1,21,5,1,4,3,2,11,3,2,8 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,4,1,3,4,2,20,8,2,3,2,
     8,1,2,3,1,3,1,1,3,2,11,4,5,1,4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,
     3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,3,1,1,2,2,1,
     2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,3,1,4,2,3,2,8,1,1,1,3,4,
     1,2,3,2,2,1,1,1,2,1,1,3,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,
     2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,
     2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,1,
     2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,2,2,3,1,2,2,1,1,1,3,2,2,
     1,4,1,5,4,11,2,3,1,1,2,1,1,3,2,1,8,2,3,1,1,4,1,3,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,
     2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,
     1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,
     3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,
     1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,4,1,2,3,2,3,1,1,2,1,1,1,2,2,3,2,1,4,3,1,1,1,8,2,3,2,4,1,3,
     4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,1,3,2,11,
     3,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,2,2,1,
     1,1,3,2,2,1,1,1,2,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,
     1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,
     2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,
     1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,
     1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,
     8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,
     2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,2,
     2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,
     1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,3,1,4,1,1,3,2,8,1,2,3,1,1,2,1,1,3,2,11,4,5,1,4,1,2,2,
     3,1,1,1,2,2,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,
     2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,1,1,
     1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,
     2,1,1,1,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,
     2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,3,1,1,2,
     1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,
     20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,
     2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,3,1,1,
     2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,
     2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,
     2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,
     20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,
     2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,
     1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,1,
     3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,3,2,1,4,
     1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,
     1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,
     1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,
     20,2,4,1,2,1,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,2,3,2,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,
     1,1,1,2,2,3,1,1,1,2,2,1,2,1,2,2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,
     2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,1,2,1,1,1,2,2,3,
     1,1,1,2,2,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,
     1,3,11,2,3,1,1,3,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,2,2,1,4,1,20,1,
     1,4,3,1,4,2,3,2,8,1,1,1,3,4,1,2,3,2,2,1,1,1,2,1,1,3,2,3,2,1,4,
     1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,
     3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,2,
     2,3,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,
     2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,2,2,3,1,1,1,2,
     2,1,2,1,2,2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,
     2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,
     2,1,1,1,2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,2,2,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,3,1,4,1,1,3,2,8,1,2,3,1,1,2,1,1,3,2,11,4,5,1,
     4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,
     3,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,
     1,2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,2,3,1,1,1,
     2,2,1,2,1,2,2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,
     1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,3,1,1,2,1,1,1,2,2,3,
     2,1,4,3,1,1,1,8,2,3,2,4,1,3,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,
     1,2,1,2,2,1,1,3,1,1,3,2,11,3,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,
     1,3,1,1,2,2,3,1,2,2,1,1,1,3,2,2,1,4,1,5,4,11,2,3,1,1,3,1,3,2,
     1,8,2,3,2,8,20,2,4,3,1,4,2,3,2,8,1,2,3,4,1,21,5,1,4,3,2,11,3,
     2,8 ],
   [ 8,2,3,11,2,3,4,1,5,21,1,4,3,2,1,8,2,3,2,4,1,3,4,2,20,8,2,3,2,
     8,1,2,3,1,3,1,1,3,2,11,4,5,1,4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,
     3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,3,1,1,2,2,1,
     2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,3,1,4,2,3,2,8,1,1,1,3,4,
     1,2,3,2,2,1,1,1,2,1,1,3,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,
     2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,
     2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,2,1,
     2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,2,2,3,1,2,2,1,1,1,3,2,2,
     1,4,1,5,4,11,2,3,1,1,2,1,1,3,2,1,8,2,3,1,1,4,1,3,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,
     2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,
     1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,
     1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,
     3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,
     1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,4,1,2,3,2,3,1,1,2,1,1,1,2,2,3,2,1,4,3,1,1,1,8,2,3,2,4,1,3,
     4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,1,3,2,11,
     3,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,2,2,1,
     1,1,3,2,2,1,1,1,2,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,
     1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,
     2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,
     1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,
     1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,
     8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,
     2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,2,
     2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,
     1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,3,1,4,1,1,3,2,8,1,2,3,1,1,2,1,1,3,2,11,4,5,1,4,1,2,2,
     3,1,1,1,2,2,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,
     2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,2,3,1,1,1,2,1,1,
     1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,
     2,1,1,1,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,
     2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,3,1,1,2,
     1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,
     20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,
     2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,3,1,1,
     2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,
     2,20,8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,
     2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,
     20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,
     2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,
     1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,1,
     3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,3,2,1,4,
     1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,
     1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,
     1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,
     20,2,4,1,2,1,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,2,3,2,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,
     1,1,1,2,2,3,1,1,1,2,2,1,2,1,2,2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,
     2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,1,2,1,1,1,2,2,3,
     1,1,1,2,2,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,
     1,3,11,2,3,1,1,3,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,2,2,1,4,1,20,1,
     1,4,3,1,4,2,3,2,8,1,1,1,3,4,1,2,3,2,2,1,1,1,2,1,1,3,2,3,2,1,4,
     1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,
     3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,
     2,2,3,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,
     1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     2,2,1,1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,
     1,2,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,
     1,3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,
     1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,
     1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,
     2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,
     2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,
     1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,1,3,2,
     8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,3,2,1,4,1,2,
     1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,
     1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,
     1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,3,11,2,3,1,1,2,1,
     1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,1,3,2,8,1,1,1,3,1,1,2,1,1,1,
     2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,2,2,1,1,1,3,2,
     2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,4,1,1,20,1,4,1,2,2,1,2,1,
     2,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,
     2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,
     1,1,2,1,4,1,1,20,1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,
     1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,1,
     3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,
     2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,1,
     4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,2,
     3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,2,1,4,1,2,
     1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,1,2,1,4,2,20,8,2,3,2,8,1,1,1,
     3,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,
     1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,4,1,2,3,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,8,
     2,3,1,1,4,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,1,
     3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,2,
     1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,
     8,20,2,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,2,2,1,4,1,20,1,1,4,1,
     3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,
     4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,3,1,1,1,8,2,3,1,
     1,4,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,1,2,1,
     1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,1,2,
     2,3,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,1,2,1,1,1,2,2,3,
     2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,1,4,
     1,2,2,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,
     2,2,3,1,2,2,1,1,1,3,2,2,1,4,1,5,4,11,2,3,1,1,2,1,1,3,2,1,8,2,
     3,1,1,4,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,3,1,4,1,1,
     3,2,8,1,1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,3,2,1,4,
     1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,1,3,1,4,2,20,8,2,3,11,2,3,1,3,
     1,4,1,1,20,1,4,1,2,2,1,2,1,2,2,1,1,1,3,2,2,1,1,1,2,1,4,1,1,20,
     1,4,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,
     4,1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,
     1,2,1,4,1,2,3,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,
     8,2,3,1,1,4,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,
     1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,
     2,8,20,2,4,1,2,1,1,1,2,2,3,1,1,1,2,2,1,2,1,2,2,1,4,1,20,1,1,4,
     1,3,1,3,2,11,3,2,8,20,2,4,1,3,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,
     1,4,1,2,3,2,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,3,1,1,1,8,2,3,
     1,1,4,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,1,3,2,11,3,1,1,4,1,2,
     1,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,1,1,3,2,2,1,
     1,1,2,1,4,1,1,3,11,2,3,1,1,3,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,2,
     2,1,4,1,20,1,1,4,3,1,4,2,3,2,8,1,1,1,3,4,1,2,3,2,2,1,1,1,2,1,
     1,3,2,3,2,1,4,1,2,1,1,1,2,1,1,1,2,1,1,1,3,2,2,1,1,3,1,4,2,20,
     8,2,3,11,2,3,1,3,1,4,1,1,3,11,2,3,1,1,2,1,1,1,2,2,1,2,1,2,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,2,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,3,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,
     4,1,2,1,1,1,2,2,3,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,1,
     2,1,1,3,1,1,1,2,1,1,1,3,1,3,1,1,1,8,2,3,2,8,20,2,4,1,2,1,1,1,
     2,2,3,1,1,1,2,2,1,2,1,2,2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,
     20,2,4,1,3,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,2,1,1,
     1,2,1,1,3,1,1,1,2,1,1,1,2,1,1,3,1,1,1,8,2,3,1,1,4,1,3,1,1,2,2,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,4,1,1,3,2,8,1,2,3,1,1,2,1,
     1,3,2,11,4,5,1,4,1,2,2,3,1,1,1,2,2,1,3,2,2,1,1,1,2,1,4,2,20,8,
     2,3,2,8,1,1,1,3,1,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,3,1,1,1,2,1,1,
     1,3,1,1,2,1,1,1,2,1,2,2,1,1,1,2,1,2,2,1,4,1,20,1,1,4,1,2,1,1,
     1,2,2,3,1,1,1,2,2,1,2,1,2,2,1,4,1,20,1,1,4,1,3,1,3,2,11,3,2,8,
     20,2,4,1,3,1,1,2,2,3,1,1,1,2,2,1,2,1,1,1,2,1,4,1,2,3,2,3,1,1,
     2,1,1,1,2,2,3,2,1,4,3,1,1,1,8,2,3,2,4,1,3,4,1,1,20,1,4,1,2,2,
     1,2,1,1,1,2,2,1,2,1,2,2,1,1,3,1,1,3,2,11,3,1,1,4,1,3,1,3,2,11,
     3,2,8,20,2,4,1,3,1,1,2,2,3,1,2,2,1,1,1,3,2,2,1,4,1,5,4,11,2,3,
     1,1,3,1,3,2,1,8,2,3,2,8,20,2,4,3,1,4,2,3,2,8,1,2,3,4,1,21,5,1,
     4,3,2,11,3,2,8 ]
   ]};

gp_inline__location="../dragon.tex:105604";
 fifteenths_triples_list_k(k) = {
   my(den=15*2^k, m=Map());
   for(num=0,den,
     my(z=dragon_fpoint(num/den), v=[]);
     mapisdefined(m,z,&v);
     mapput(m,z,concat(v,[num])));
   m=Vec(Mat(m)[,2]);
   m=select(v-> #v<=3||error(); #v==3, m);
   if(#m, m=concat(m));
   vecsort(m);
 }

gp_inline__location="../dragon.tex:105618";
 fifteenths_diffs(k) = \
   vector_differences(fifteenths_triples_list_k(k));

gp_inline__location="../dragon.tex:106132";
 fifteenth_13_21_23_z = {1/2-1/6*I};

gp_inline__location="../dragon.tex:106180";
 vector_differences_wraparound(v) = \
   vector(#v,i, v[if(i==#v,1,i+1)] - v[i]);

gp_inline__location="../dragon.tex:106337";
 FifteenthTriples_formula(k) = \
   4*2^k + 2*k - 1 - 2*B(k) + 2*dJA(k-1);
 FifteenthTriples(k) = {
   k>=0 || error("FifteenthTriples is for k>=0");
   if(k==0,0, FifteenthTriples_formula(k));
 }

gp_inline__location="../dragon.tex:106347";
 FifteenthTriples_samples = {[0,1,3,7,17,43,105,247,565,1259,2745]};

gp_inline__location="../dragon.tex:106361";
 gFifteenthTriples(x) = {
     1/(1 - x)
   + 2/(1 - x)^2
   + 4/(1 - 2*x)
   - (7 + 5*x + 8*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:106434";
 other(n) = {
   my(ao=dragon_n_to_arm_and_other(n));
   if(ao[1]==0, ao[2], -1);
 }
 is_odd_D_first(n) = n%2 && DpredInf(n) && n<other(n);

gp_inline__location="../dragon.tex:106465";
 Fifteenths_union_samples = \
     [13,21,23,26,37,39,42,46,47,52,73,74,78];

gp_inline__location="../dragon.tex:106477";
 Fifteenths_union_diffs_samples = \
     [8,2,3,11,2,3,4,1,5,21,1,4];

gp_inline__location="../dragon.tex:106501";
 Fifteenths_diffs = {[1,2,3,4,5,8,11,20,(21/1)]};

gp_inline__location="../dragon.tex:106683";
 fifteenths_state_table = {[
   2,3; 4,5; 6,7; 8,9; 10,11; 12,13; 14,15; 8,9; 10,16; 17,18;
   19,20; 21,22; 23,24; 25,26; 27,28; 19,20; 21,29; 30,31; 32,33;
   34,35; 36,37; 38,39; 40,41; 42,43; 44,45; 46,47; 48,49; 27,28;
   38,39; 50,41; 42,51; 52,53; 54,55; 56,57; 58,59; 60,37; 61,62;
   63,64; 65,66; 67,68; 69,70; 71,72; 73,74; 75,76; 77,78; 79,80;
   81,82; 83,84; 46,47; 85,68; 73,86; 75,76; 77,87; 88,89; 90,91;
   92,93; 94,95; 96,97; 58,59; 98,37; 63,64; 99,100; 101,102;
   103,104; 105,106; 107,108; 109,102; 110,111; 112,113; 114,115;
   116,117; 118,119; 120,121; 122,123; 124,125; 126,127; 128,129;
   130,131; 132,133; 134,135; 136,121; 122,137; 138,139; 140,78;
   109,102; 122,141; 130,142; 143,144; 145,146; 147,148; 149,150;
   151,152; 153,154; 155,156; 157,158; 159,160; 94,95; 98,37;
   105,161; 162,59; 36,37; 38,163; 164,165; 166,158; 167,160;
   168,169; 170,161; 162,59; 60,37; 164,165; 171,172; 173,174;
   175,176; 177,178; 179,180; 181,182; 183,184; 185,186; 187,188;
   189,190; 191,192; 193,194; 122,141; 124,195; 196,197; 198,199;
   200,201; 202,203; 204,205; 206,207; 208,209; 210,102; 110,211;
   212,213; 214,188; 215,190; 122,123; 124,195; 216,217; 128,129;
   122,141; 208,209; 210,102; 110,218; 219,220; 214,221; 222,223;
   224,225; 226,227; 183,228; 229,230; 231,232; 233,106; 234,235;
   236,237; 238,239; 240,178; 179,239; 241,242; 243,154; 168,169;
   244,97; 65,245; 85,237; 246,247; 248,178; 241,242; 155,156;
   249,178; 250,160; 248,228; 183,251; 252,253; 254,182; 229,228;
   255,256; 257,182; 183,228; 258,259; 260,261; 262,182; 183,182;
   229,228; 183,263; 264,265; 266,267; 268,72; 73,74; 269,270;
   224,271; 272,273; 73,274; 275,276; 191,192; 196,277; 278,279;
   280,281; 282,283; 284,285; 286,287; 288,289; 258,242; 243,290;
   291,292; 293,294; 295,53; 54,55; 296,297; 162,59; 98,37;
   171,298; 173,265; 231,299; 300,72; 269,270; 278,279; 200,201;
   171,301; 257,230; 231,299; 73,86; 269,270; 224,302; 198,199;
   280,303; 264,174; 183,228; 183,228; 229,182; 183,304; 226,227;
   255,305; 306,160; 170,106; 107,108; 210,102; 110,307; 308,259;
   260,228; 262,182; 262,182; 175,309; 233,106; 250,160; 107,108;
   308,259; 114,256; 310,182; 240,228; 258,242; 183,311; 262,230;
   266,312; 229,228; 229,178; 179,239; 181,182; 229,182; 175,176;
   177,228; 183,228; 229,182; 183,251; 313,253; 254,304; 226,227;
   183,314; 282,117; 124,125; 315,302; 280,316; 317,318; 118,119;
   122,137; 124,125; 315,271; 280,319; 317,320; 284,285; 286,148;
   149,312; 229,182; 183,321; 313,322; 187,221; 323,223; 224,225;
   324,113; 260,182; 234,325; 236,68; 326,327; 328,72; 73,86;
   75,76; 92,93; 168,169; 183,251; 255,115; 329,117; 183,182;
   280,281; 149,150; 183,330; 179,331; 258,242; 171,332; 257,182;
   255,305; 181,182; 183,182; 183,182; 229,230; 183,333; 198,199;
   149,334; 313,253; 254,184; 149,334; 254,321; 183,311; 266,267;
   269,270; 264,174; 107,108; 112,113; 260,314; 335,117; 181,182;
   183,251; 260,182; 183,182; 183,261; 183,311; 229,182 ]};
 fifteenths_state_diffs_matrix = {[
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,2,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,2,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   0,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,2,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   2,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1;
   1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   2,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,2,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,2,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,0,0,1,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,2,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   3,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   0,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   3,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   3,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   3,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   3,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   5,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   3,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,3,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   1,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   2,1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   3,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0;
   2,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   6,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   5,3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   2,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,2,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   4,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   7,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   8,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0;
   6,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0;
   9,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ]};

gp_inline__location="../dragon.tex:107068";
 gFifteenthsDiff(diff) = {
   my(gfs=state_table_to_gfs(fifteenths_state_table));
   sum(state=1,#gfs,
       gfs[state] * fifteenths_state_diffs_matrix[state,diff]);
 }

gp_inline__location="../dragon.tex:107074";
 \\ sorted list of the 15ths differences in curve k
 fifteenths_diffs_by_states(k) = {
   concat(vector(21,diff,
          vector(gf_term(gFifteenthsDiff(diff),k),i,diff)));
 }

gp_inline__location="../dragon.tex:107133";
 FifteenthsDiff21_samples = {[0,0,0,1,1,2,2,2,2]};

gp_inline__location="../dragon.tex:107158";
 FifteenthsDiff2(k) = gf_term(gFifteenthsDiff(2),k);

gp_inline__location="../dragon.tex:107171";
 fifteenths_diff_2_samples = {[0,1,2,5,12,33,84,197,448]};

gp_inline__location="../dragon.tex:107193";
 fifteenths_diff_5_samples = {[0,0,0,1,2,3,4,5,6]};

gp_inline__location="../dragon.tex:107445";
 gen_fifths_difference_values = {[
   [  ],
   [  ],
   [ 6,1 ],
   [ 6,1,12,1,1,5 ],
   [ 6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,6 ],
   [ 6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,2,2,2,1,3,10,6,1,3,6,1,2,1,1,
     1,2,1,1,1,9,4,5,1,1,12,1,6 ],
   [ 6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,2,2,2,1,3,10,6,1,3,6,1,2,1,1,
     1,2,1,1,1,9,4,5,1,1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,
     2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,5,10,3,1,2,2,2,
     1,9,1,2,1,1,5,10,4,5,1,1,12,1,6 ],
   [ 6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,2,2,2,1,3,10,6,1,3,6,1,2,1,1,
     1,2,1,1,1,9,4,5,1,1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,
     2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,5,10,3,1,2,2,2,
     1,9,1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,5,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,4,1,1,5,
     4,9,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,1,2,2,2,1,9,1,2,1,1,5,10,4,
     5,1,1,12,1,6 ],
   [ 6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,2,2,2,1,3,10,6,1,3,6,1,2,1,1,
     1,2,1,1,1,9,4,5,1,1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,
     2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,5,10,3,1,2,2,2,
     1,9,1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,5,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,4,1,1,5,
     4,9,1,1,1,2,1,1,1,2,1,6,3,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,2,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,
     1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,
     1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,9,3,1,2,2,1,1,1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,
     1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,9,1,2,2,2,1,3,10,5,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,9,3,1,2,2,1,1,1,9,3,1,6,10,3,
     1,2,2,1,1,1,4,1,2,1,4,1,1,5,4,9,1,1,1,2,1,1,1,2,1,6,3,1,6,10,
     3,1,2,2,2,1,9,1,2,1,1,5,10,4,5,1,1,12,1,6 ],
   [ 6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,2,2,2,1,3,10,6,1,3,6,1,2,1,1,
     1,2,1,1,1,9,4,5,1,1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,
     2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,5,10,3,1,2,2,2,
     1,9,1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,5,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,4,1,1,5,
     4,9,1,1,1,2,1,1,1,2,1,6,3,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,2,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,
     1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,
     1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,9,3,1,2,2,1,1,1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,
     1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,9,1,2,2,2,1,3,10,5,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,9,3,1,2,2,1,1,1,4,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,
     1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,2,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,
     1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,
     10,6,1,3,9,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,3,6,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,
     3,9,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,5,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,10,3,1,2,2,1,1,1,9,3,
     1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,6,3,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,
     3,6,1,2,1,1,1,2,1,1,1,9,4,5,1,1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,
     1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,5,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,10,3,1,
     2,2,1,1,1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,
     1,2,1,1,1,3,5,1,1,2,1,9,1,2,2,2,1,3,10,5,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,9,3,1,2,2,1,1,1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,
     2,1,4,1,1,5,4,9,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,1,2,2,2,1,9,1,
     2,1,1,5,10,4,5,1,1,12,1,6 ],
   [ 6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,2,2,2,1,3,10,6,1,3,6,1,2,1,1,
     1,2,1,1,1,9,4,5,1,1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,
     2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,5,10,3,1,2,2,2,
     1,9,1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,
     1,3,10,5,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,4,1,1,5,
     4,9,1,1,1,2,1,1,1,2,1,6,3,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,2,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,
     1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,
     1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,9,3,1,2,2,1,1,1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,
     1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,9,1,2,2,2,1,3,10,5,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,9,3,1,2,2,1,1,1,4,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,
     1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,2,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,
     1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,
     10,6,1,3,9,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,3,6,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,6,1,
     3,9,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,5,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,10,3,1,2,2,1,1,1,9,3,
     1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,6,3,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,
     3,6,1,2,1,1,1,2,1,1,1,9,4,5,1,1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,
     1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,5,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,5,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,3,6,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,
     6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,10,
     6,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,
     4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,3,6,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,4,1,1,1,
     2,2,1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,4,1,1,1,
     2,2,1,3,10,5,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,4,1,1,1,2,2,1,3,9,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     2,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,2,1,
     4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,
     4,1,1,1,2,2,1,3,10,5,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,
     1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,6,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,10,3,1,2,2,
     1,1,1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,1,2,
     1,1,1,2,1,1,1,2,1,1,1,2,1,6,3,1,2,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,9,3,1,2,2,1,1,1,4,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,4,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     5,10,3,1,2,2,2,1,9,1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,1,1,
     2,1,4,1,1,1,2,2,1,3,10,6,1,3,9,1,1,1,2,2,1,3,9,1,1,1,2,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,
     1,1,2,1,6,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,1,
     2,1,1,1,2,1,1,1,2,1,1,1,2,1,6,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,
     1,1,2,1,1,5,10,3,1,2,2,1,1,1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,
     1,1,2,1,1,5,3,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,6,3,1,2,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,2,1,3,6,1,2,1,1,1,2,1,1,1,9,4,5,1,
     1,4,1,2,1,4,1,1,1,2,2,1,3,10,6,1,3,6,1,2,1,1,1,2,1,1,1,2,1,1,
     1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,5,10,3,1,2,2,
     1,1,1,4,1,2,1,1,1,2,1,1,5,10,3,1,2,2,1,1,1,9,3,1,6,10,3,1,2,2,
     1,1,1,4,1,2,1,1,1,2,1,1,5,3,1,1,1,2,1,1,1,3,5,1,1,2,1,9,1,2,2,
     2,1,3,10,5,1,1,2,1,1,1,2,1,1,1,2,1,1,1,2,1,1,1,9,3,1,2,2,1,1,
     1,9,3,1,6,10,3,1,2,2,1,1,1,4,1,2,1,4,1,1,5,4,9,1,1,1,2,1,1,1,
     2,1,6,3,1,6,10,3,1,2,2,2,1,9,1,2,1,1,5,10,4,5,1,1,12,1,6 ]
   ]};

gp_inline__location="../dragon.tex:107620";
 fifths_triples_list_k(k) = \
   select(t->t%3==0, fifteenths_triples_list_k(k)) / 3;

gp_inline__location="../dragon.tex:107626";
 fifths_diffs(k) = vector_differences(fifths_triples_list_k(k));

gp_inline__location="../dragon.tex:107718";
 Fifths_union_samples = \
    [7,13,14,26,27,28,33,37,47,52,53,54,56,57,66,67,69,71,73,74,77];

gp_inline__location="../dragon.tex:107733";
 Fifths_union_diffs_samples = \
     [6,1,12,1,1,5,4,10,5,1,1,2,1,9,1,2,2,2,1,3];

gp_inline__location="../dragon.tex:107751";
 fifths_state_table = {[
   2,3; 4,5; 6,7; 8,9; 10,11; 12,13; 14,15; 8,9; 10,16; 17,18;
   19,20; 21,22; 23,24; 25,26; 27,28; 19,20; 21,29; 30,31; 32,33;
   34,35; 36,37; 38,39; 40,41; 42,43; 44,45; 46,47; 48,49; 27,28;
   38,39; 50,41; 42,51; 52,53; 54,55; 56,57; 58,35; 59,37; 60,61;
   62,63; 64,65; 66,67; 68,69; 70,71; 72,73; 74,75; 76,77; 78,79;
   80,81; 82,83; 46,47; 84,67; 72,85; 74,75; 76,86; 87,88; 89,90;
   91,92; 93,94; 95,96; 97,37; 62,63; 98,99; 100,101; 102,103;
   104,105; 106,107; 36,108; 109,110; 111,112; 113,114; 115,116;
   117,118; 119,120; 121,85; 122,123; 124,125; 126,127; 128,129;
   130,131; 132,133; 134,120; 121,73; 122,135; 136,77; 36,108;
   121,137; 128,138; 139,140; 141,142; 143,144; 145,146; 147,148;
   149,150; 151,152; 153,154; 155,156; 93,94; 97,37; 104,157;
   158,35; 36,37; 38,159; 160,161; 162,154; 163,156; 164,165;
   166,167; 158,35; 38,159; 160,168; 169,170; 171,172; 173,174;
   175,176; 177,178; 179,180; 181,182; 183,184; 185,186; 187,188;
   189,190; 191,192; 122,193; 194,195; 196,197; 198,199; 200,201;
   202,203; 204,205; 206,107; 59,108; 109,207; 208,209; 210,186;
   211,188; 212,125; 126,127; 121,137; 206,107; 59,108; 213,214;
   215,216; 210,217; 218,219; 220,221; 222,223; 224,146; 225,226;
   227,228; 229,230; 231,232; 233,234; 235,236; 237,238; 177,239;
   179,240; 241,150; 164,165; 166,242; 64,243; 84,234; 244,245;
   246,176; 179,240; 151,152; 247,248; 249,156; 164,165; 244,245;
   246,250; 251,252; 253,254; 255,256; 257,258; 259,260; 261,262;
   224,263; 257,264; 265,266; 267,180; 251,256; 257,268; 251,269;
   270,271; 272,273; 274,275; 72,73; 74,276; 277,278; 279,280;
   72,281; 282,283; 189,190; 284,285; 286,287; 288,289; 290,291;
   292,293; 294,295; 296,297; 225,240; 241,298; 299,300; 301,302;
   303,53; 54,55; 56,304; 169,305; 171,271; 306,307; 308,71;
   74,276; 286,287; 160,168; 169,309; 261,310; 306,307; 72,85;
   74,276; 311,195; 196,312; 313,314; 270,172; 224,263; 257,258;
   225,180; 181,315; 222,316; 317,318; 319,156; 164,165; 166,230;
   106,107; 59,108; 213,320; 175,321; 265,146; 267,262; 224,263;
   265,146; 322,228; 229,230; 93,94; 106,107; 175,321; 113,260;
   323,262; 237,258; 224,146; 225,240; 224,263; 257,268; 251,324;
   267,226; 325,256; 257,268; 251,326; 225,262; 224,263; 257,238;
   177,239; 179,180; 251,256; 224,146; 173,174; 175,327; 224,146;
   225,180; 224,263; 251,252; 147,254; 328,315; 222,223; 224,329;
   290,116; 117,118; 330,195; 196,197; 288,331; 332,333; 117,118;
   121,73; 122,123; 334,278; 286,287; 288,335; 332,336; 292,293;
   294,337; 338,326; 225,180; 251,339; 340,341; 185,217; 342,219;
   220,221; 222,343; 344,326; 231,345; 233,67; 346,347; 348,275;
   72,85; 74,75; 164,165; 251,252; 222,223; 259,114; 349,116;
   251,326; 181,315; 196,197; 292,293; 294,144; 145,146; 251,350;
   224,263; 257,351; 352,297; 225,240; 169,353; 173,174; 257,268;
   179,180; 251,326; 222,316; 251,326; 224,263; 257,268; 224,354;
   196,197; 338,252; 147,254; 328,182; 196,197; 338,252; 255,339;
   220,221; 222,316; 251,324; 225,310; 272,273; 74,276; 173,174;
   175,250; 106,107; 111,112; 265,329; 355,116; 179,180; 251,252;
   224,263; 257,356; 251,326; 224,266; 225,180; 173,174 ]};
 fifths_state_diffs_matrix = {[
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,1,0,0,0,0,0,0; 1,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,1,0,0,0,0,0,0; 1,0,0,0,0,0,0,0,0,0,0,1;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   2,0,0,0,1,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 2,0,0,0,1,0,0,0,0,0,0,0;
   0,0,0,1,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,1,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,1,0,0,0,0,0,0,0;
   2,1,0,0,0,0,0,0,0,0,0,0; 1,0,0,0,0,0,0,0,1,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 1,0,0,0,0,1,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,1,0,0,0,0,0,0,0; 2,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 1,1,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,1,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,1,0,0,0,0,0,0; 1,0,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,1,0,0,0,0,0,0; 1,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,0,0,0,0,0,0,0,1,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,1,0,0,0,0,0,0,0,0;
   0,0,0,0,1,0,0,0,0,0,0,0; 2,0,0,0,0,0,0,0,0,0,0,1;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,1,0,0,0,0,0,0; 1,1,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,1,0,0,0,0,0,0,0,0;
   0,0,0,0,1,0,0,0,0,0,0,0; 2,0,0,1,0,0,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 1,0,0,1,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,1,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 1,0,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,1,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   2,0,0,0,1,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,1,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 1,1,0,0,0,0,0,0,1,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 1,1,0,0,0,0,0,0,0,0,0,0;
   2,0,0,0,1,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,1,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,1,0,0,0,0,0,0,0,0;
   0,0,0,0,1,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 2,0,0,0,1,0,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,1,0,0,0,0,0,0,0,0,0; 0,0,0,0,1,0,0,0,0,0,0,0;
   2,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,1,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 1,1,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,1,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,1,0,0,0,0,0,0,0; 2,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,0,0,1,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,1,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,1,0,0; 0,0,0,0,1,0,0,0,0,0,0,0;
   2,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,0,0,0,0,1,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0,0,0,0,0; 1,0,0,0,0,1,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,1,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 3,0,0,1,0,0,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 1,0,0,1,0,0,0,0,0,0,0,0;
   2,0,0,0,1,0,0,0,0,0,0,0; 0,0,0,1,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,1,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 1,1,0,0,0,0,0,0,1,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,1,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,0,0,0,0,1,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0,0,0,0,0; 1,2,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,1,1,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,1,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,1,0,0,0,0,0,0,0,0,0; 0,0,0,0,1,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,1,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,1,0,0,0,0,0,0; 1,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,1,0,0,0,0,0,0,0,0,0; 2,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 1,0,0,1,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0,0,0,0,0; 1,2,0,0,0,0,0,0,0,0,0,0;
   3,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0,0,0,0,0; 1,0,0,0,0,1,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 3,0,0,1,0,0,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   2,0,0,0,1,0,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,0,1,0,0,0,0,0,0,0,0,0;
   0,0,0,0,1,0,0,0,0,0,0,0; 2,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 1,1,1,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,0,0,0,0,0,0,0,1,0,0,0;
   0,0,1,0,0,0,0,0,0,0,0,0; 3,0,0,1,0,0,0,0,0,0,0,0;
   2,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 3,0,0,1,0,0,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,1,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,1,1,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,0,0,0,1,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,1,1,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,1,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,1,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   2,0,0,0,1,0,0,0,0,0,0,0; 1,2,0,0,0,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0,0,0,0; 1,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 2,0,0,0,1,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 3,0,0,1,0,0,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   2,0,0,0,1,0,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,0,0,0,0,1,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 0,0,0,0,0,1,0,0,0,0,0,0;
   1,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,0,0,0,0,0,0,1,0,0,0; 0,0,0,0,0,0,0,0,0,0,0,0;
   0,0,0,1,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,0,1,0,0,0,0,0,0,0,0; 2,0,0,0,1,0,0,0,0,0,0,0;
   0,0,1,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,0,1,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,0,0,1,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,0,0,1,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   1,2,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 0,0,1,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   0,0,0,0,0,0,0,0,1,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0;
   3,1,0,0,0,0,0,0,0,0,0,0; 3,1,0,0,0,0,0,0,0,0,0,0 ]};

gp_inline__location="../dragon.tex:107984";
 gFifthsDiff(diff) = {
   my(gfs=state_table_to_gfs(fifths_state_table));
   sum(state=1,#gfs,
       gfs[state] * fifths_state_diffs_matrix[state,diff]);
 }

gp_inline__location="../dragon.tex:107990";
 \\ sorted list of the 5ths differences in curve k
 fifths_diffs_by_states(k) = {
   concat(vector(12,diff,
          vector(gf_term(gFifthsDiff(diff),k),i,diff)));
 }

gp_inline__location="../dragon.tex:108041";
 Fifths_diffs = {[1,2,3,4,5,6,9,10,12]};

gp_inline__location="../dragon.tex:108426";
 FifthsDiff12_samples = {[0,0,0,1,1,2,2,2,2]};

gp_inline__location="../dragon.tex:108499";
 fBpred_hullstouch_state_table = {[2,3;2,4;5,6;5,7;8,9;10,11;12,13;
   14,15;16,17;18,19;20,11;18,21;22,23;14,24;25,26;27,28;29,30;
   31,32;33,30;34,19;35,36;37,38;39,23;25,40;8,41;42,40;8,43;44,45;
   46,47;48,49;50,51;52,53;27,54;55,32;27,56;57,58;59,60;61,45;
   62,38;42,23;63,45;62,64;63,65;66,67;46,68;46,65;69,17;70,71;
   72,49;50,73;74,75;62,76;12,77;78,17;50,79;59,17;70,80;81,65;
   46,82;42,26;27,68;83,60;27,84;61,65;46,65;85,65;46,45;83,65;
   66,58;86,80;87,30;86,71;88,36;46,89;57,90;91,17;92,23;66,82;
   88,75;74,36;66,65;81,45;46,67;83,45;46,58;50,80;66,47;66,89;
   85,17;44,65;27,90;37,64]};
 fNonRpred_hullstouch_accepting = {[17,29,30,36,46,47,48,49,50,57,
   58,65,66,69,70,71,72,73,74,80,81,85,86,87,88,89]};
 fNonLpred_hullstouch_accepting = {[8,14,15,23,24,25,26,27,38,39,
   40,41,42,43,45,46,60,61,62,63,64,65,67,68,83,84]};
 fNonBpred_hullstouch_accepting = {[46,65]};
 fNonRpred_hullstouch_counts = [0,0,0,0,1,4,12,34,90,222,522,1186,2622,5678,12106,25498,53190,110118,226594,463986,946302,1923710,3900186,7889866,15931510,32120406,64677266,130094626,261444206,525016366,1053640970,2113400186,4237174630];
 fNonLpred_hullstouch_counts = [0,0,0,1,3,9,25,61,139,309,675,1449,3071,6445,13411,27713,56951,116501,237419,482345,977439,1976509,3989715,8041681,16188935,32556901,65417403,131349625,263572207,528624653,1059759267,2123774497,4254765527];
 fNonBpred_hullstouch_counts = [0,0,0,0,0,0,1,5,23,81,247,673,1695,4041,9255,20577,44751,95705,202039,422225,875359,1803273,3695815,7543169,15343471,31123129,62986071,127226801,256581247,516770409,1039658727,2089691361,4196973199];
 fNonRpred_hullstouch_minimized_size = 30;
 fNonLpred_hullstouch_minimized_size = 32;
 fNonBpred_hullstouch_minimized_size = 91;
 fNonBpred_hullstouch_contains = {[
   [],
   [],
   [],
   [],
   [],
   [],
   [[1,0,1,1,0,0]],
   [[0,1,0,1,1,0,0],[1,0,1,0,0,1,1],[1,0,1,0,1,1,0],[1,0,1,1,0,0,0],[1,0,1,1,0,0,1]],
   [[0,0,1,0,1,1,0,0],[0,1,0,1,0,0,1,1],[0,1,0,1,0,1,1,0],[0,1,0,1,1,0,0,0],[0,1,0,1,1,0,0,1],[0,1,1,0,1,1,1,1],[0,1,1,1,0,0,0,0],[0,1,1,1,0,1,1,0],[1,0,0,1,0,1,1,0],[1,0,0,1,1,0,1,1],[1,0,1,0,0,1,1,0],[1,0,1,0,0,1,1,1],[1,0,1,0,1,0,0,1],[1,0,1,0,1,0,1,0],[1,0,1,0,1,1,0,0],[1,0,1,0,1,1,0,1],[1,0,1,0,1,1,1,1],[1,0,1,1,0,0,0,0],[1,0,1,1,0,0,0,1],[1,0,1,1,0,0,1,0],[1,0,1,1,0,0,1,1],[1,1,0,0,0,1,0,0],[1,1,0,1,0,0,1,1]]
 ]};

gp_inline__location="../dragon.tex:108532";
 fBpred_surround_state_table = {[2,3;4,5;6,7;4,5;8,9;10,11;12,13;
   10,14;15,16;17,18;19,20;21,22;23,13;24,25;26,27;28,29;17,30;
   31,32;33,34;35,36;37,38;39,40;41,22;33,34;35,36;37,38;42,43;
   44,45;46,29;31,47;48,49;50,51;52,53;54,55;56,57;58,59;60,61;
   62,63;64,65;58,59;66,67;68,69;70,71;72,73;74,75;76,77;78,79;
   17,18;80,81;76,82;83,79;17,18;84,85;86,87;88,89;90,91;92,93;
   94,95;96,59;97,98;99,100;101,102;103,104;52,53;105,106;97,107;
   62,63;52,108;109,110;111,112;113,114;115,116;117,118;119,120;
   121,89;122,123;74,75;76,82;124,29;125,126;88,89;74,127;128,129;
   125,126;130,114;131,132;90,133;134,135;136,137;90,114;138,139;
   140,141;142,36;143,144;145,146;147,95;97,148;149,150;151,152;
   153,154;122,123;155,156;26,27;157,79;158,159;35,36;149,100;
   80,160;161,159;35,36;143,112;99,150;162,114;90,114;90,91;
   113,133;128,129;117,51;52,108;163,137;90,114;90,164;117,118;
   128,45;52,108;163,165;90,114;122,123;74,127;134,135;115,166;
   90,114;121,89;90,114;90,114;90,164;130,114;90,114;90,114;
   131,167;168,139;169,170;60,171;172,173;174,170;58,59;60,175;
   176,173;177,152;70,71;90,114;178,179;111,112;180,137;181,182;
   142,36;44,129;131,167;168,183;130,114;90,91;131,132;134,87;
   90,133;88,89;113,114;138,139;162,114;90,91;92,93;99,150;151,152;
   70,71;131,167;172,173;177,152;131,132;115,141;142,36;162,164;
   52,53;54,184;121,89;130,114]};
 fNonRpred_surround_eventually_accepting = {[20,25,35,36,40,43,56,
   57,58,59,60,70,71,85,86,88,90,91,92,93,94,95,96,97,98,99,106,
   110,111,112,113,114,115,121,127,130,131,132,134,135,137,138,139,
   140,141,142,143,144,145,146,147,148,149,150,151,152,153,156,158,
   160,161,162,166,167,168,169,170,171,172,173,174,175,176,177,178,
   179,184]};
 fNonLpred_surround_eventually_accepting = {[10,17,18,29,30,31,32,
   33,45,46,47,48,49,50,51,52,53,55,56,64,68,73,74,75,76,77,78,79,
   80,81,82,83,84,85,87,88,89,90,91,101,108,114,115,117,118,119,
   120,121,122,123,124,125,126,127,128,129,130,132,133,134,135,136,
   137,138,139,151,160,161,163,164,165,167,169,181,183,184]};
 fNonBpred_surround_eventually_accepting = {[56,85,88,90,91,114,
   115,121,127,130,132,134,135,137,138,139,151,160,161,167,169,184
   ]};
 fNonRpred_surround_eventually_counts = [0,0,0,0,1,4,12,34,90,222,522,1186,2622,5678,12106,25498,53190,110118,226594,463986,946302,1923710,3900186,7889866,15931510,32120406,64677266,130094626,261444206,525016366,1053640970,2113400186,4237174630];
 fNonLpred_surround_eventually_counts = [0,0,0,1,3,9,25,61,139,309,675,1449,3071,6445,13411,27713,56951,116501,237419,482345,977439,1976509,3989715,8041681,16188935,32556901,65417403,131349625,263572207,528624653,1059759267,2123774497,4254765527];
 fNonBpred_surround_eventually_counts = [0,0,0,0,0,0,1,5,23,81,247,673,1695,4041,9255,20577,44751,95705,202039,422225,875359,1803273,3695815,7543169,15343471,31123129,62986071,127226801,256581247,516770409,1039658727,2089691361,4196973199];

gp_inline__location="../dragon.tex:108578";
 state_machine_transitions(state_table,state,v) = \
   for(i=1,#v, state=state_table[state,v[i]+1]); state;
 state_machine_contains(state_table,accepting_set,v) = {
   my(state=state_machine_transitions(state_table,1,v));
   setsearch(accepting_set,state) != 0;
 }
 state_machine_accepted_strings(state_table,accepting_set,k) = {
   my(l=List([]));
   forvec(v=vector(k,i,[0,matsize(state_table)[2]-1]),
     if(state_machine_contains(state_table,accepting_set,v),
        listput(l, v)));
   Vec(l);
 }

gp_inline__location="../dragon.tex:108601";
 state_machine_contains_vecper(state_table,accepting_set,fv) = {
   my(state=state_machine_transitions(state_table,1,
                                      vecper_fixed(fv)));
   my(seen=Map());
   until(mapisdefined(seen,state),
     mapput(seen,state,1);
     state=state_machine_transitions(state_table,state,
                                     vecper_periodic(fv)));
   setsearch(accepting_set,state) != 0;
 }

gp_inline__location="../dragon.tex:108651";
 fRpred_offsets = [-1,+11,+7];

gp_inline__location="../dragon.tex:108678";
 fLpred_offsets = [+1,-11,-7];

gp_inline__location="../dragon.tex:108708";
 SpredLeft(k,n) = 0<n && n<2^k && Spred_k(k,n) && turn(n)==1;

gp_inline__location="../dragon.tex:108720";
 SpredRight(k,n) = 0<n && n<2^k && Spred_k(k,n) && turn(n)==-1;

gp_inline__location="../dragon.tex:108726";
 fNonRpred_of_frac(f) = {
   (0 <= f && f <= 1) || error("fNonRpred_of_frac is for 0<=f<=1");
   state_machine_contains_vecper(fBpred_hullstouch_state_table,
                                 fNonRpred_hullstouch_accepting,
                                 vecper_frac_digits(f,2));
 }
 fRpred_of_frac(f) = ! fNonRpred_of_frac(f);

gp_inline__location="../dragon.tex:108734";
 fNonLpred_of_frac(f) = {
   (0 <= f && f <= 1) || error("fNonLpred_of_frac is for 0<=f<=1");
   state_machine_contains_vecper(fBpred_hullstouch_state_table,
                                 fNonLpred_hullstouch_accepting,
                                 vecper_frac_digits(f,2));
 }
 fLpred_of_frac(f) = ! fNonLpred_of_frac(f);

gp_inline__location="../dragon.tex:108742";
 fNonBpred_of_frac(f) = {
   (0 <= f && f <= 1) || error("fNonBpred_of_frac is for 0<=f<=1");
   state_machine_contains_vecper(fBpred_hullstouch_state_table,
                                 fNonBpred_hullstouch_accepting,
                                 vecper_frac_digits(f,2));
 }
 fBpred_of_frac(f) = ! fNonBpred_of_frac(f);

gp_inline__location="../dragon.tex:108834";
 fifteenths_in_k(k,offset_list) = {
   my(l=List([]));
   for(n=0,2^k,
     for(i=1,#offset_list,
       my(f=(2*n+offset_list[i])/2^k);
       if(f<0,next);
       if(f>1,break);
       listput(l,f)));
   Set(l);
 }

gp_inline__location="../dragon.tex:109382";
 hullsnontouch_min_distance = 30/180;

gp_inline__location="../dragon.tex:109795";
 fBpred_surround_segs_outer = {[
   [-1+I*-1,I], [-1+I*-1,1], [0+I*-2,I], [0+I*-2,1], [1+I*-1,-I],
   [1+I*-1,1], [2+I*0,-I], [2+I*0,I], [1+I*1,1], [1+I*1,-1],
   [-1+I*1,1], [-1+I*1,-I]
 ]};

gp_inline__location="../dragon.tex:110019";
 fNonR(k) = 2^k - fR(k);

gp_inline__location="../dragon.tex:110023";
 gfNonR(x) = 1/(1 - 2*x) - gfR(x);

gp_inline__location="../dragon.tex:110032";
 fNonR_samples = {[0,0,0,0,1,4,12,34,90,222,522,1186]};

gp_inline__location="../dragon.tex:110039";
 fR_initial_vector = {[1,2,4,8,15,28]};

gp_inline__location="../dragon.tex:110048";
 fR_formula(k) = R(k) + SixB(k-3) - 2*k + 8;
 fR(k) = {
   k>=0 || error("fR() is for k>=0, got ",k);
   if(k<=5, fR_initial_vector[k+1], fR_formula(k));
 }

gp_inline__location="../dragon.tex:110060";
 fR_samples = {[1,2,4,8,15,28,52,94,166,290,502,862]};

gp_inline__location="../dragon.tex:110066";
 gfR(x) = {
   -11/4 - 3/2*x - 1/2*x^2
   + 3/(1 - x) - 2/(1 - x)^2
   + (11/4 + 7/4*x + 3*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:110087";
 fNonL(k) = 2^k - fL(k);

gp_inline__location="../dragon.tex:110089";
 gfNonL(x) = 1/(1 - 2*x) - gfL(x);

gp_inline__location="../dragon.tex:110095";
 fNonL_samples = {[0,0,0,1,3,9,25,61,139,309,675,1449]};

gp_inline__location="../dragon.tex:110103";
 fL_initial_vector = {[1,2,4,7,13,23,39,67]};

gp_inline__location="../dragon.tex:110111";
 fL_formula(k) = L(k) + 2*SixB(k-5) - 2*k + 17;
 fL(k) = {
   k>=0 || error("fL() is for k>=0, got ",k);
   if(k<=7, fL_initial_vector[k+1], fL_formula(k));
 }

gp_inline__location="../dragon.tex:110119";
 gfL(x) = {
   -31/4 - 6*x - 9/2*x^2 - 3*x^3 - x^4
   + 9/(1 - x)
   - 2/(1 - 2*x + x^2)
   + (7/4 + 5/4*x + 5/2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:110145";
 fL_samples = {[1,2,4,7,13,23,39,67,117,203,349,599]};

gp_inline__location="../dragon.tex:110158";
 fNonB(k) = 2^k - fB(k);

gp_inline__location="../dragon.tex:110160";
 gfNonB(x) = 1/(1 - 2*x) - gfB(x);

gp_inline__location="../dragon.tex:110166";
 fNonB_samples = {[0,0,0,0,0,0,1,5,23,81,247,673]};

gp_inline__location="../dragon.tex:110175";
 fB_initial_vector = {[1,2,4,8,16,32,63]};

gp_inline__location="../dragon.tex:110183";
 fB_formula(k) = B(k) + SixB(k-2) - 16*k + 61;
 fB(k) = {
   k>=0 || error("fB() is for k>=0, got ",k);
   if(k<=6,fB_initial_vector[k+1],fB_formula(k));
 }

gp_inline__location="../dragon.tex:110195";
 gfB(x) = {
   -115/2 - 87/2*x - 31*x^2 - 20*x^3 - 11*x^4 - 5*x^5 - 2*x^6
   + 70/(1 - x) - 16/(1 - 2*x + x^2)
   + (9/2 + 3*x + 11/2*x^2)/(1 - x - 2*x^3);
 }

gp_inline__location="../dragon.tex:110209";
 fB_samples = {[1,2,4,8,16,32,63,123,233,431,777,1375]};

gp_inline__location="../dragon.tex:110236";
 fRL_sub_fB_initial_vector = {[1,2,4,7,12,19,28]};

gp_inline__location="../dragon.tex:110245";
 fRL_sub_fB_formula(k) = 12*k - 46;
 fRL_sub_fB(k) = {
   k>=0 || error("fRL_sub_fB() is for k>=0, got ",k);
   if(k<=6,fRL_sub_fB_initial_vector[k+1],fRL_sub_fB_formula(k));
 }

gp_inline__location="../dragon.tex:110329";
 fNonRnew(k) = if(k==0,0, fNonR(k) - 2*fNonR(k-1));

gp_inline__location="../dragon.tex:110331";
 gfNonRnew(x) = gfNonR(x) - 2*x*gfNonR(x);

gp_inline__location="../dragon.tex:110334";
 fNonRnew_samples = {[0,0,0,0,1,2,4,10,22,42,78,142,250]};

gp_inline__location="../dragon.tex:110347";
 fNonLnew(k) = if(k==0,0, fNonL(k) - 2*fNonL(k-1));

gp_inline__location="../dragon.tex:110349";
 fNonLnew_samples = {[0,0,0,1,1,3,7,11,17,31,57,99,173]};

gp_inline__location="../dragon.tex:110354";
 gfNonLnew(x) = gfNonL(x) - 2*x*gfNonL(x);

gp_inline__location="../dragon.tex:110365";
 fNonBnew(k) = if(k==0,0, fNonB(k) - 2*fNonB(k-1));

gp_inline__location="../dragon.tex:110367";
 gfNonBnew(x) = gfNonB(x) - 2*x*gfNonB(x);

gp_inline__location="../dragon.tex:110370";
 fNonBnew_samples = {[0,0,0,0,0,0,1,3,13,35,85,179,349]};

gp_inline__location="../dragon.tex:110431";
 gf_cubic_part(g) = {
   my(v=pol_partial_fractions(g,[1 - x - 2*x^3]));
   for(i=1,#v,
     if(denominator(v[i]) % (1 - x - 2*x^3) == 0,
        return(v[i])));
   0;
 }

gp_inline__location="../dragon.tex:110442";
 gf_cubic_in_terms_of(g,v) = {
   g=gf_cubic_part(g);
   v=apply(gf_cubic_part,v);
   my(f=lindep(concat([g],v) * (1-x-2*x^3)));
   if(f[1],f/=-f[1]);
   f;
 }

gp_inline__location="../dragon.tex:110493";
 fBpred_hullstouch_gfs = \
   state_table_to_gfs(fBpred_hullstouch_state_table);

gp_inline__location="../dragon.tex:110510";
 fBpred_surround_gfs = \
   state_table_to_gfs(fBpred_surround_state_table);

gp_inline__location="../dragon.tex:110583";
 fBridge_samples = {[(1)/(20),(1)/(10),(1)/(5),(2)/(5),(3)/(5),(4)/(5),(9)/(10),(19)/(20)]};

gp_inline__location="../dragon.tex:110591";
 fBridge_starts_to_k(k) = vector(k+1,i,i--; 2/(5*2^i));
 fBridge_ends_to_k(k)   = vector(k+1,i,i--; 1-2/(5*2^i));
 fBridge_to_k(k) = {
   concat(Vecrev(fBridge_starts_to_k(k)),
          fBridge_ends_to_k(k));
 }

gp_inline__location="../dragon.tex:110663";
 PaperConst_vector(n) = vector(n,i,Paper(i));

gp_inline__location="../dragon.tex:113284";
 fVisits_expand_bit_matrix = {[
   [1],   [6];      \\ s1
   [2,3], [7];      \\ s2
   [4],   [];       \\ s3
   [7],   [];       \\ s4
   [5,6], [];       \\ s5
   [8,9], [9,10];   \\ s6
   [],    [11];     \\ s7
   [11],  [1];      \\ s8
   [],    [2];      \\ s9
   [],    [4,5];    \\ s10
   [],    [3] ]};   \\ s11

gp_inline__location="../dragon.tex:114040";
 CentrelineHex_state_table = {
   \\ 0 1 2 3 4 5 6 7 8 9 A B C D E F
   [  1,3,4,4,4,4,4,4,4,4,4,2,1,3,4,2;  \\ 1 = h
      4,4,4,4,4,4,4,4,4,4,4,2,1,3,4,2;  \\ 2 = a2
      1,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4;  \\ 3 = d2
      4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4   \\ 4 = non
   ]};
 CentrelineHex_transition(state,digit) = \
   CentrelineHex_state_table[state,digit+1];
 CentrelineHex_state(k,n) = {
   k%4 == 0
     || error("CentrelineHex_state() is for k multiple of 4");
   my(v=digits_padded(n,k/4,16), state=1);
   for(i=1,#v, state=CentrelineHex_transition(state,v[i]));
   state;
 }

gp_inline__location="../dragon.tex:114057";
 CentrelineHexSegmentPred(k,n) = CentrelineHex_state(k,n) != 4;

gp_inline__location="../dragon.tex:114062";
 CentrelineSegments_state_to_CentrelineHex_state = \
   [ 1, 0, 0, 0,  0, 0, 0,  0, 2, 3, 4 ];
 \\  h,s1,s2,s3, e1,e2,e3, hr,a2,d2, non
 \\  1, 2, 3, 4,  5, 6, 7,  8, 9,10, 11

gp_inline__location="../dragon.tex:114070";
 CentrelineHex_state_to_CentrelineSegments_state = {
   [ CentrelineSegments_state_h,
     CentrelineSegments_state_a2,
     CentrelineSegments_state_d2,
     CentrelineSegments_state_non
   ]};

gp_inline__location="../dragon.tex:114093";
 CentrelineHexPointPred_accepting_table = [1,0,1,0];
 CentrelineHexPointPred(k,n) = \
  CentrelineHexPointPred_accepting_table[CentrelineHex_state(k,n)];

gp_inline__location="../dragon.tex:114168";
 gCentrelineHorizontals(x) = {
   my(gfs=state_table_to_gfs(CentrelineSegments_state_table),
      g=  gfs[CentrelineSegments_state_h]
        + gfs[CentrelineSegments_state_hr]);
   subst(g,'x,x);
 }

gp_inline__location="../dragon.tex:114180";
 gCentrelineHexHorizontals(x) = {
   my(g=state_table_to_gfs(CentrelineHex_state_table)[1]);
   subst(g,'x,x);
 }

gp_inline__location="../dragon.tex:114244";
 state_machine_minmax_vecper(table,state,prefer_bit) = {
   my(debug=0);
   if(debug, print("state_machine_minmax_vecper() state "state" prefer "prefer_bit));
   my(states=List([]),
      bits=List([]),
      non=matsize(table)[1]);  \\ last state
   if(debug, print("  non "non));
   while(1,
     for(i=1,#states-1,
       if(state==states[i],
          bits=Vec(bits);
          if(debug, print("  repeat at i="i));
          if(debug, print("  bits "bits));
          return([bits[1..i-1], bits[i..#bits-1]])));
     my(bit=if(table[state,prefer_bit+1] != non,
               prefer_bit, !prefer_bit));
     listput(bits, bit);
     state = table[state,bit+1];
     if(debug, print("  bit "bit" new state "state));
     listput(states,state));
 }

gp_inline__location="../dragon.tex:114434";
 ffixed_se_initials = [ [0,4], [8,16] ];

gp_inline__location="../dragon.tex:114436";
 ffixed_se_expand_even1_index(j) = {
   j%2==0 || error("ffixed_se_expand_even1_index() must j even");
   3*j/2;
 }
 ffixed_se_expand_even1(se) = {
   my(s,e); [s,e] = se;
   [2*s, 2*e-4];
 }

gp_inline__location="../dragon.tex:114447";
 ffixed_se_expand_even2_index(j) = {
   j%2==0 || error("ffixed_se_expand_even2_index() must j even");
   3*j/2 + 1;
 }
 ffixed_se_expand_even2(se,next_se) = {
   my(s,e); [s,e] = se;
   my(next_s = next_se[1]);
   [2*e, 2*next_s];
 }

gp_inline__location="../dragon.tex:114459";
 ffixed_se_expand_odd_index_formula(j) = (3*j+1)/2;
 ffixed_se_expand_odd_index(j) = {
   j%2==1 || error("ffixed_se_expand_odd_index() must j odd");
   ffixed_se_expand_odd_index_formula(j);
 }
 ffixed_se_expand_odd(se) = {
   my(s,e); [s,e] = se;
   [2*e-4, 2*e];
 }

gp_inline__location="../dragon.tex:114477";
 \\ ffixed as vector [ [s,e], [s,e], ... ] or run start/ends
 \\ Limit to len many runs, if len>=0.
 \\ Limit to bits many bits, if bits>=0.
 ffixed_se_vector(len,bits=-1) = {
   len>=0 || bits>=0
     || error("ffixed_se_vector() must len or bits >= 0");
   my(l=List(ffixed_se_initials),
      i=1);
   while(   if(len<0,1,  #l<len)
         && if(bits<0,1, l[#l][1]<bits),
         i++;
         \\ print("i="i" elem "l[i]);
         my(j=i-1);
         if(j%2==0,
           #l == ffixed_se_expand_even1_index(j) || error();
           listput(l, ffixed_se_expand_even1(l[i]));
           #l == ffixed_se_expand_even2_index(j) || error();
           listput(l, ffixed_se_expand_even2(l[i],l[i+1]));
           ,
           #l == ffixed_se_expand_odd_index(j) || error();
           listput(l, ffixed_se_expand_odd(l[i]));
   ));
   if(len>=0, while(#l>len, listpop(l)));
   if(bits>=0, while(#l && l[#l][1]>=bits, listpop(l)));
   Vec(l);
 }

gp_inline__location="../dragon.tex:114514";
 ffixed_se(j) = ffixed_se_vector(j+1)[j+1];
 ffixed_se_to_run(se) = {
   my(s,e); [s,e] = se;
   1/2^s - 3/2^e;
 }

gp_inline__location="../dragon.tex:114520";
 \\ Return a vector of 0,1 bits of ffixed.
 \\ "runs" is the number of runs in the return.
 \\ "bits" is the number of bits in the return.
 \\ runs can be -1 to use just the bits.
 \\ bits can be -1 to use just the runs.
 \\ If both runs and bits given then the longer is used.
 ffixed_bits_vector(runs,bits=-1) = {
   my(v=ffixed_se_vector(runs,bits),
      ret=vector(max(if(runs>=0, v[#v][2]),
                     if(bits>=0, bits))));
   for(i=1,#v,
     for(j=v[i][1]+1, v[i][2]-2,
       if(j>#ret, break(2));
       ret[j]=1);
     if(v[i][2]>#ret, break);
     ret[v[i][2]] = 1);
   ret;
 }

gp_inline__location="../dragon.tex:114544";
 \\ Return ffixed as a rational with "bits" many bits below the
 \\ binary point.
 ffixed_frac(bits) = fromdigits(ffixed_bits_vector(-1,bits),2)/2^bits;

gp_inline__location="../dragon.tex:114551";
 \\ Return an upper bound on ffixed which is "bits" many bits below
 \\ the binary point and a bound 1/2^bits for the rest.
 ffixed_frac_upper_bound(bits) = ffixed_frac(bits) + 1/2^bits;

gp_inline__location="../dragon.tex:114572";
 ffixed_run(j) = 1/2^ffixed_s(j) - 3/2^ffixed_e(j);

gp_inline__location="../dragon.tex:114582";
 ffixed_binary_sample = {(011010000111111010000/100000000000000000000)};

gp_inline__location="../dragon.tex:114587";
 ffixed_binary_sample_in_binary = \
   from_binary(ffixed_binary_sample*10^20) / 2^20;

gp_inline__location="../dragon.tex:114593";
 ffixed_decimal_sample = {(0816360476/1000000000)};

gp_inline__location="../dragon.tex:114651";
 ffixed_s(j) = {
   if(j==0,return(0));
   my(h,r); [h,r]=divrem(j,3);
   if(r==0, 2*ffixed_s(2*h),
      r==1, 2*ffixed_e(2*h),
      r==2, 2*ffixed_e(2*h+1) - 4,
      error());
 }
 ffixed_s_parent(j) = {
   my(h,r); [h,r]=divrem(j,3);
   if(r==0, [2*h,   's],
      r==1, [2*h,   'e],
      r==2, [2*h+1, 'e],
      error());
 }

gp_inline__location="../dragon.tex:114667";
 ffixed_e(j) = {
   if(j==0,return(4));
   my(h,r); [h,r]=divrem(j,3);
   if(r==0, 2*ffixed_e(2*h) - 4,
      r==1, 2*ffixed_s(2*h+1),
      r==2, 2*ffixed_e(2*h+1),
      error());
 }
 ffixed_e_parent(j) = {
   my(h,r); [h,r]=divrem(j,3);
   if(r==0, [2*h,   'e],
      r==1, [2*h+1, 's],
      r==2, [2*h+1, 'e],
      error());
 }

gp_inline__location="../dragon.tex:114732";
 ffixed_s_samples = {[0,8,28,56,64,116,128,224,236,256,440]};

gp_inline__location="../dragon.tex:114747";
 ffixed_e_samples = {[4,16,32,60,112,120,220,232,240,436,448]};

gp_inline__location="../dragon.tex:114826";
 ffixed_fpoint_of_se(se) = {
   my(s,e); [s,e] = se;
   s%4==0 || error("ffixed_fpoint_of_se() s not multiple of 4, got "s);
   e%4==0 || error("ffixed_fpoint_of_se() e not multiple of 4, got "e);
     (-1)^(s/4) / 2^(s/2)
   + (-1)^(e/4) / 2^(e/2);
 }

gp_inline__location="../dragon.tex:115547";
 ffixed_is_candidate(k,x, rot=1) = {
   my(debug=0);
   my(x_limit=2^k);
   x < x_limit || error("ffixed_is_candidate() too big x="x);
   my(d=I^k*rot, n_limit=2^(2*k));
   if(debug, print("x="to_binary(x)" d="d));
   for(offset=0,1,
     forstep(s=-1,1,2,  \\ -1 or 1
       my(z=(x+offset)*d,
          an=dragon_unpoint(z,s),
          arm=an[1], n=an[2]);
       if(debug, print("offset="offset" s="s" arm "arm));
       if(arm==0,
         if(debug, print("n="to_binary(n)));
         my(hi=n>>k);
         if(n<=n_limit && (hi == x
                           || (x==x_limit-1 && hi == x_limit)),
           return(1)))));
   0;
 }

gp_inline__location="../dragon.tex:115578";
 ffixed_candidates_extend(k,v, rot=1) = {
   k++;  /* k+1 */
   my(l=List([]));
   for(i=1,#v,
     for(bit=0,1,
       my(x=2*v[i]+bit);
       if(ffixed_is_candidate(k,x,rot),
         listput(l,x))));
   Vec(l);
 }

gp_inline__location="../dragon.tex:115590";
 ffixed_candidates_at(k,rot=1) = {
   my(v=[0]);
   for(k=0,k-1, v=ffixed_candidates_extend(k,v,rot));
   v;
 }

gp_inline__location="../dragon.tex:115967";
 ffixed_k_and_n(len) = {
   my(v=ffixed_se_vector(len),
      k=v[#v][2]);
   [k, vecsum(apply(ffixed_se_to_run, v)) * 2^k];
 }
 ffixed_112_x = ffixed_k_and_n(5)[2];

gp_inline__location="../dragon.tex:115978";
 ffixed_112_n = dragon_unpoint(ffixed_112_x,-1)[2];

gp_inline__location="../dragon.tex:116162";
 ffixed_candidates_extend_list(k,v, len) = {
   my(ret=List([ v ]));
   for(k=k,k+len-2,
     listput(ret, ffixed_candidates_extend(k,ret[#ret])));
   Vec(ret);
 }

gp_inline__location="../dragon.tex:116171";
 ffixed_middle_candidates_list(len) = {
   concat([ [0], [1], [3], [6] ],
          ffixed_candidates_extend_list(4,[13],len-4))[1..len];
 }

gp_inline__location="../dragon.tex:116180";
 \\ x is an integer for a segment x/2^k to (x+1)/2^k of the
 \\ real axis of the fractal.
 \\ Return a vector of n which as f = n/2^(2*k) are at those
 \\ x or x+1 points.
 \\ This means those point numbers n in curve level 2*k which
 \\ are at x*I^k or (x+1)*I^k.
 \\ If both x and x+1 are double-visited then this is four of n.
 \\
 ffixed_x_to_n_list(k,x) = {
   my(ret=List([]),
      d=I^k,
      n_limit=2^(2*k));
   for(offset=0,1,
     forstep(s=-1,1, 2,  \\ -1 or 1
       my(z=(x+offset)*d,
          an=dragon_unpoint(z,s),
          arm=an[1], n=an[2]);
       if(arm==0,
         my(hi=n>>k);
         if(n<=n_limit && (hi == x
                           || (x==x_limit-1 && hi == x_limit)),
           listput(ret,n)))));
   Vec(ret);
 }

gp_inline__location="../dragon.tex:118179";
 \\ x-f min
 xf_min   = -7/15;
 xf_min_f =  2/15;

gp_inline__location="../dragon.tex:118186";
 \\ x-f max
 xf_max   =  4/15;
 xf_max_f = 17/30;

gp_inline__location="../dragon.tex:118284";
 e_back_to_e(j) = {
   if(j%3==0 || j%3==2, return(ffixed_e(j)));
   my(pow=1);
   j = (2*j+1)/3;    is_integer(j) || error();
   while(1,
     pow *= 2;
     if(j%3!=0,
        return(pow * if(j%3==1, 2*ffixed_e((2*j-2)/3),
                                2*ffixed_e((2*j-1)/3) - 4)));
     j=2*j/3;  is_integer(j) || error();
   );
 }

gp_inline__location="../dragon.tex:118329";
 \\ Return a vector of len many values of u_m, starting from u_0.
 ffixed_u_vector(len) = {
   my(v=vector(len), t=0, m=2);
   if(t==len,return(v));
   v[t++] = 0;
   if(t==len,return(v));
   v[t++] = 4;
   while(t!=len,
     v[t++] = 2*v[m];        \\ 2 mod 3
     if(t==len,break);
     v[t++] = 2*v[m++];       \\ 0 mod 3
     if(t==len,break);
     v[t++] = 2*v[m++] - 4);   \\ 1 mod 3
   v;
 }

gp_inline__location="../dragon.tex:118352";
 ffixed_u(m) = {
   m>=0 || error("ffixed_u() is for m>=0");
   if(m==0, 0,
      my(t=0,p=4);
      while(m>1, if(m%3==1,t+=p); m=round(2*m/3);p*=2);
      p-t);
 }

gp_inline__location="../dragon.tex:118361";
 ffixed_u_parent(m) = {
   m>=0 || error("ffixed_u_parent() is for m>=0");
   my(h,r); [h,r]=divrem(m,3);
   if(r==0, 2*h,
      r==1, 2*h+1,
      r==2, 2*h+1,
      error());
 }

gp_inline__location="../dragon.tex:118391";
 ffixed_u_samples = {[0,4,8,16,28,32,56,60,64,112]};

gp_inline__location="../dragon.tex:118467";
 gu(x,num_terms) = subst(Ser(ffixed_u_vector(num_terms)),'x,x);

gp_inline__location="../dragon.tex:118624";
 ffixed_u_fromindex_vector(len) = {
   vector(len,m,m--;
          my(h=m\3);
          if(m%3==0, 2*h,
             m%3==1, 2*h+1,
             m%3==2, 2*h+1,
             error()));
 }

gp_inline__location="../dragon.tex:118792";
 \\ with k=0 for first row
 ffixed_row_w(k) = {
   k>=0 || error("ffixed_row_w() is for k>=0, got ",k);
   my(w=1);
   for(i=1,k,   \\ k many times
     w=ffixed_row_w_next(w));
   w;
 }
 ffixed_row_w_next(w) = ceil(3/2*w);

gp_inline__location="../dragon.tex:118802";
 \\ Return a vector of len many entries [ w_0, w_1, ...]
 ffixed_row_w_vector(len,start=1) = {
   my(ret=vector(len), w=start, upto=0);
   for(i=1,len,
     ret[upto++]=w;
     w += (w>>1) + bittest(w,0));
   ret;
 }

gp_inline__location="../dragon.tex:118813";
 ffixed_row_w_samples = {[1,2,3,5,8,12,18,27,41,62,93]};

gp_inline__location="../dragon.tex:118820";
 A061419(n) = ffixed_row_w(n-1);

gp_inline__location="../dragon.tex:118877";
 wparity(k) = ffixed_row_w(k) % 2;

gp_inline__location="../dragon.tex:118879";
 wparity_vector(len,start=1) = {
   my(ret=vector(len), w=start, upto=0);
   for(i=1,len,
     ret[upto++] = bitand(w,1);
     w += (w>>1) + bittest(w,0));
   ret;
 }

gp_inline__location="../dragon.tex:118892";
 wparity_samples = {[1,0,1,1,0,0,0,1,1,0,1,0,0,1,1,0,1,0]};

gp_inline__location="../dragon.tex:118902";
 A205083(n) = {
   n>=1 || error("A205083() is for n>=1");
   if(n==1,1, wparity(n-2));
 }

gp_inline__location="../dragon.tex:118917";
 \\ A070885 = 3*w
 \\ iteration per Stephen Wolfram as at
 \\ http://mathworld.wolfram.com/WolframSequences.html
 A070885(n) = {
   n>=1 || error("A070885() is for n>=0");
   if(n==1,1,
      my(p=A070885(n-1));
      if(p%2==0, 3/2*p, 3/2*(p+1)));
 }

gp_inline__location="../dragon.tex:119098";
 \\ log base 3, floating point
 log3(x) = log(x)/log(3);

gp_inline__location="../dragon.tex:119106";
 log_2_of_3on2_sample = {(0584962/1000000)};

gp_inline__location="../dragon.tex:119146";
 ffixed_w_j_peak_sample = {(0630929/1000000)};

gp_inline__location="../dragon.tex:119226";
 \\ at what index j does w[j] exceed its mask
 \\ when aiming for w[k] mod 2
 ffixed_row_w_exceed_mask(k) = {
   my(w=1, mask=(1<<k)-1);
   for(i=0,k+1,
     w += (w>>1) + bitand(w,1);
     if(w > mask, return(i));
     mask >>= 1);
   'oops;
 }

gp_inline__location="../dragon.tex:119251";
 mask_to_bits(n,len) = bitand(n, (1<<len)-1);

gp_inline__location="../dragon.tex:119253";
 ffixed_row_w_mod_2_by_bitmask(k) = {
   my(w=1,j=0);
   while(j<k,
     w += (w>>1) + bitand(w,1);
     j++;
     w = mask_to_bits(w, k-j+1));   \\ w[j] masked
   w;
 }

gp_inline__location="../dragon.tex:119280";
 vector_alternate_terms(v,offset=0) = \
   vector((#v+1-offset)\2,i, v[2*i-1+offset]);

gp_inline__location="../dragon.tex:119382";
 vector_pos_run_length(v,pos) = {
   for(i=pos,#v,
     if(v[i]!=v[pos], return(i-pos)));
   'noend;
 }

gp_inline__location="../dragon.tex:119429";
 high_many_bits(n,len) = {
   if(n,
      my(got=logint(n,2)+1);
      if(got>len, n>>=(got-len)));
   n;
 }

gp_inline__location="../dragon.tex:119598";
 ffixed_u_by_six(m) = {
   my(h=m\6);
   if(m<=1, [0,4][m+1],
      m%6==0,  2*ffixed_u(4*h),
      m%6==1,  2*ffixed_u(4*h+1) - 4,
      m%6==2,  2*ffixed_u(4*h+1),
      m%6==3,  2*ffixed_u(4*h+2),
      m%6==4,  2*ffixed_u(4*h+3) - 4,
      m%6==5,  2*ffixed_u(4*h+3),
      error());
 }

gp_inline__location="../dragon.tex:119620";
 negbin(n) = {
   my(l=List([]));
   while(n>1,
     my(bit=-bitand(n,1));
     listput(l,bit);
     n=(n-bit)/2);
   if(n,listput(l,n));
   Vecrev(l);
 }

gp_inline__location="../dragon.tex:119838";
 ffixed_uDepth(m) = {
   m>=1 || error("ffixed_uDepth() is for m>=1");
   if(m==1, 0, ffixed_uDepth(floor((2*m+1)/3)) + 1);
 }

gp_inline__location="../dragon.tex:119845";
 ffixed_uDepth_samples = {[0,1,2,3,3,4,4,4,5,5,5,5,6]};

gp_inline__location="../dragon.tex:119852";
 A061420(n) = ffixed_uDepth(n+1);

gp_inline__location="../dragon.tex:119895";
ffixed_row_dw(k) = ffixed_row_w(k+1) - ffixed_row_w(k);

gp_inline__location="../dragon.tex:119905";
 ffixed_row_dw_samples = {[1,1,2,3,4,6,9,14,21,31]};

gp_inline__location="../dragon.tex:119978";
 ffixed_u_of_w_k_plus_1_samples = {[8,16,28,56,112,220,436,868,1736]};

gp_inline__location="../dragon.tex:119988";
 ffixed_w_k_plus_1_samples = {[2,3,4,6,9,13,19,28,42]};

gp_inline__location="../dragon.tex:120021";
 \\ Return k many terms of w mod 2 interpreted as binary.
 \\ Here can give flip=1 for 0<->1 flip of digits.
 \\ Here can give base other than 2.
 wbin(k,flip=0,base=2) = {
   my(v=wparity_vector(k));
   if(flip, v=apply(d->1-d, v));
   fromdigits_any(v,base);
 }

gp_inline__location="../dragon.tex:120044";
 wbin_binary_samples = {[0,1,10,101,1011,10110,101100]};

gp_inline__location="../dragon.tex:120052";
 wbin_samples = {[0,1,2,5,11,22,44,88,177]};

gp_inline__location="../dragon.tex:120131";
 ffixed_u_wkplus1_limit_binary_sample = {(11011000110/10000000000)};

gp_inline__location="../dragon.tex:120136";
 decimal_fraction_to_binary_fraction(f) = {
   my(p=1);
   while(denominator(f)!=1, p/=2; f*=10);
   fromdigits(digits(f),2) * p;
 }

gp_inline__location="../dragon.tex:120148";
 ffixed_u_wkplus1_limit_sample = {(1693949/1000000)};

gp_inline__location="../dragon.tex:120174";
 ffixed_ones(n) = vecsum(ffixed_bits_vector(-1,n));

gp_inline__location="../dragon.tex:120177";
 ffixed_ones_samples = {[0,1,2,2,3,3,3,3,3,4,5,6,7,8,9]};

gp_inline__location="../dragon.tex:120194";
 ffixed_ones_k(k) = ffixed_ones(2^(k+2));

gp_inline__location="../dragon.tex:120202";
 ffixed_ones_k_by_w(k) = {
   my(w=ffixed_row_w(k));
   sum(j=0,ceil(w/2)-1,
       ffixed_u(2*j+1) - ffixed_u(2*j) - 1);
 }

gp_inline__location="../dragon.tex:120221";
 ffixed_ones_k_samples = {[3,3,10,13,16,66,167,390,443,533]};

gp_inline__location="../dragon.tex:121322";
 ffixed_ones_proportion_vector(len) = {
   my(u=ffixed_u_vector(len),o=0,
      ones=u);
   for(i=1,#u,
     if(i%2==0, o+=u[i]-u[i-1]-1);
     ones[i]=if(u[i],o/u[i]));
   ones;
 }

gp_inline__location="../dragon.tex:121346";
 ffixed_w_upper_bound(k) = \
   if(k==0,1, 3/2*ffixed_w_upper_bound(k-1) + 1/2);

gp_inline__location="../dragon.tex:121392";
 ffixed_mean_run(n) = vecsum(ffixed_l_vector(n)) / n;

gp_inline__location="../dragon.tex:121400";
 ffixed_mean_gap(n) = vecsum(ffixed_g_vector(n)) / n;

gp_inline__location="../dragon.tex:121476";
 half3on2_low_digit(n) = [0, -1/2, 1/2][n%3+1];

gp_inline__location="../dragon.tex:121487";
 half3on2_digits_reduce(m,a) = (m-a)/(3/2);

gp_inline__location="../dragon.tex:121502";
 half3on2_digits(m) = {
   my(l=List([]));
   while(m>1,
     is_integer(m) || error();
     my(a=half3on2_low_digit(m));
     listput(l,a);
     m=half3on2_digits_reduce(m,a));
   if(m,listput(l,m));
   Vecrev(l);
 }

gp_inline__location="../dragon.tex:121587";
 ffixed_u_by_half3on2_convert_a(a) = {
   if(a==-1/2, -1,
      a==1/2,  0,
               a);
 }
 ffixed_u_by_half3on2(m) = {
   my(v=half3on2_digits(m));
   v=apply(ffixed_u_by_half3on2_convert_a, v);
   for(i=1,#v,  /* should now be high 1, rest 0 or -1 */
     v[i]==0 || v[i]==if(i==1,1,-1) || error());
   from_binary_vector(v) * 4;
 }

gp_inline__location="../dragon.tex:121640";
 ffixed_u_to_m(u) = {
   if(u==0, return(0));
   my(k=high_bit_k(u-1), m=1);
   u = -u;
   while(k>=2,
     is_integer(m) || error();
     m = if(bittest(u,k), (3*m-1)/2,
            m%2==0,       3*m/2,
                          (3*m+1)/2);
     k--;);
   is_integer(m) || error();
   m;
 }

gp_inline__location="../dragon.tex:121697";
 ffixed_u_to_m_and_remainder(n) = {
   my(p=logint(max(4,n-1),2), m=1);
   n=2^(p+1)-n;
   while(p>=2, if(m%2&&n>=2^p, n-=2^p;m=(3*m-1)/2, m=ceil(3*m/2)); p--);
   [m,n];
 }

gp_inline__location="../dragon.tex:121726";
 ffixed_bit(n) = {
   my(p=logint(max(4,n-1),2), m=1);
   n=2^(p+1)-n;
   while(p>=2, if(m%2&&n>=2^p, n-=2^p;m=(3*m-1)/2, m=ceil(3*m/2)); p--);
   m%2 && n!=1;
 }

gp_inline__location="../dragon.tex:121734";
 ffixed_u_to_m_ceil(u) = {
   my(debug=0);
   u>=1 || error();
   my(p=max(2,logint(u,2)),
      m=1);
   u=-u;
   while(p>=2,
     if(debug,print("bit="to_binary(bit)" m="m" rem="to_binary(rem)));
     is_integer(m) || error();
     if(m%2==0, m=3*m/2,
        bittest(u,p), m=(3*m-1)/2,
        m = (3*m+1)/2);
     p--);
   is_integer(m) || error();
   [m];
 }

gp_inline__location="../dragon.tex:121825";
 \\ constant C from (3/2)^0 down to (3/2)^-k inclusive
 ffixed_row_w_C(k) = ffixed_row_w(k) / (3/2)^k;

gp_inline__location="../dragon.tex:121864";
 ffixed_row_w_C_sample = {(1622270/1000000)};

gp_inline__location="../dragon.tex:121920";
 fromdigits_fractional(v,base) = fromdigits_any(v,base) / base^#v;

gp_inline__location="../dragon.tex:121972";
 half3on2_increment(v) = {
   forstep(i=#v,1,-1,
     if(v[i]==0,    v[i]=-1/2,
        v[i]==-1/2, v[i]=1/2; break,
        v[i]==1/2,  v[i]=0,
        v[i]==1, i==1||error(); v[1]=1/2; v=concat(1,v); break,
        error()));
   v;
 }

gp_inline__location="../dragon.tex:122011";
 vector_common_suffix_length(v1,v2) = \
   vector_common_prefix_length(Vecrev(v1),Vecrev(v2));
 vector_common_prefix_length(v1,v2) = {
   my(len=0);
   for(i=1,min(#v1,#v2), if(v1[i]==v2[i], len=i, break));
   len;
 }
 vector_different_suffix_length(v1,v2) = \
   vector_different_prefix_length(Vecrev(v1),Vecrev(v2));
 vector_different_prefix_length(v1,v2) = {
   my(len=0);
   for(i=1,min(#v1,#v2), if(v1[i]!=v2[i], len=i, break));
   len;
 }

gp_inline__location="../dragon.tex:122028";
 half3on2_increment_carry_length(m) = {
   vector_different_suffix_length(half3on2_digits(m),
                                  half3on2_digits(m+1));
 }

gp_inline__location="../dragon.tex:122053";
 uProp(m) = {
   m>=1 || error("uProp() is for m>=1");
   if(m%3==1, 1, 1+uProp(floor((2*m+1)/3)));
 }

gp_inline__location="../dragon.tex:122061";
 uProp_samples = {[1,2,3,1,4,2,1,5,3,1,2,6,1,4,2,1,3,7,1]};

gp_inline__location="../dragon.tex:122073";
 A087088(n) = uProp(n);

gp_inline__location="../dragon.tex:122109";
 A006999(n) = my(ret=0); for(i=1,n, ret += floor(ret/2)+1); ret;

gp_inline__location="../dragon.tex:122113";
 \\ gaps filling construction by Benoit Cloitre in A087088
 A087088_by_expand(k) = {
   my(v=[]);
   for(i=1,k,
     my(l=List([]), pos=1);
     while(1,
       listput(l,1);
       if(pos>#v,break); listput(l,v[pos]+1); pos++;
       if(pos>#v,break); listput(l,v[pos]+1); pos++);
     v=Vec(l));
   v;
 }

gp_inline__location="../dragon.tex:122139";
 select_new_high_positions(func,len, start=0) = {
   my(ret=vector(len), pos=0, i=start, hi=-oo);
   while(pos < len,
     my(value=func(i));
     if(value>hi, hi=value; ret[pos++]=i);
     i++);
   ret;
 }

gp_inline__location="../dragon.tex:122200";
 ffixed_uB(m) = {
   m>=0 || error("ffixed_uB() is for m>=0");
   my(ret=0, p=4);
   while(m>1, if(m%3==2,ret+=p); m=round(2*m/3); p*=2);
   ret;
 }

gp_inline__location="../dragon.tex:122232";
 ffixed_uuB(m) = [ffixed_u(m), ffixed_uB(m)];

gp_inline__location="../dragon.tex:122234";
 \\ uuB is a vector [u, uB].
 \\ Return corresponding next [u, uB].
 ffixed_uuB_next(uuB) = {
   my(debug=0);
   my(u=uuB[1], B=uuB[2]);
   if(debug, printf("u        %12s\n",to_binary(u)));
   if(debug, printf("B        %12s\n",to_binary(B)));
   my(mask = bitxor(u, u-1));
   \\ if(u==0,mask=0);
   my(high = bitand(u,-u));
   if(debug, printf("u-1      %12s\n",to_binary(u-1)));
   if(debug, printf("u+1      %12s\n",to_binary(u+1)));
   if(debug, printf("mask     %12s\n",to_binary(mask)));
   if(debug, printf("mask hi  %12s\n",to_binary(high)));
   if(debug, printf("low B    %12s\n",to_binary(bitand(B,mask))));
   u = u + bitand(B,mask) + 4;
   if(debug, printf("new u    %12s\n",to_binary(u)));

   if(debug, printf("B sans   %12s\n",to_binary(bitand(B, bitneg(mask)))));
   bitand(high,B)==0 || error();
   B = high + bitand(B, bitneg(mask));
   if(debug, printf("new B    %12s\n",to_binary(B)));

   [u, B];
 }

gp_inline__location="../dragon.tex:122324";
 ffixed_uB_by_half3on2_convert_a(a) = {
   if(a==0 || a==-1/2 || a==1, 0,
      a==1/2, 1,
      error("unrecognised digit"));
 }
 half3on2_digits_to_uB(v) = \
   apply(ffixed_uB_by_half3on2_convert_a, v);

gp_inline__location="../dragon.tex:122339";
 ffixed_uB_samples = {[0,0,4,8,16,20,32,40,44,64,80,84,88,128]};

gp_inline__location="../dragon.tex:122501";
 \\ n is an integer.  Return a vector of digits of n written in
 \\ fractional base 3/2 using digits 0,1,2 "ZOT".
 zot3on2_digits(n) = {
   n>=0 || error("zot3on2_digits() is for n>=0");
   my(l=List([]));
   while(n,
     my(d=n%3);
     listput(l,d);
     n=2*(n-d)/3);
   Vecrev(l);
 }

gp_inline__location="../dragon.tex:122526";
 \\ A244040 sum digits in ZOT 3/2
 A244040(n) = vecsum(zot3on2_digits(n));

gp_inline__location="../dragon.tex:122573";
 \\ Return a vector of digits of n in base 3/2 with "balanced"
 \\ digits -1,0,1.
 bal3on2_digits(n) = {
   my(l=List([]));
   while(n,
     is_integer(n) || error();
     my(d=n%3); if(n>2 && d==2, d=-1);
     listput(l,d);
     n=2*(n-d)/3);
   Vecrev(l);
 }

gp_inline__location="../dragon.tex:122599";
 ffixed_du_vector(len) = \
   vector_differences(ffixed_u_vector(len+1));

gp_inline__location="../dragon.tex:122610";
 ffixed_du_samples = {[4,4,8,12,4,24,4,4,48,4]};

gp_inline__location="../dragon.tex:122675";
 \\ recursive cases
 ffixed_du_by_divrem(m) = {
   m>=0 || error("ffixed_du_by_divrem() is for m>=0");
   if(m==0, 4,
      m==1, 4,
      my(h,r); [h,r]=divrem(m,3);
      if(r==0, 2*ffixed_du(2*h) - 4,
         r==1, 4,
         r==2, 2*ffixed_du(2*h+1),
         error()));
 }

gp_inline__location="../dragon.tex:122689";
 \\ using a loop
 ffixed_du(m) = {
   m>=0 || error("ffixed_du() is for m>=0");
   my(s=0,   \\ total subtractions
      p=4);  \\ 4*2^depth to subtract in 3h case
   while(m>1,
     \\ print("m="m" ["m%3"] s="s" p="p);
     if(m%3==0,s+=p,
        m%3==1,break);
     m=round(2*m/3);      \\ 3h->2h, 3h+2->2h+1
     p*=2);
   \\ print("final p="p);
   p-s;
 }

gp_inline__location="../dragon.tex:122729";
 gdu(x,num_terms) = subst(Ser(ffixed_du_vector(num_terms)),'x,x);

gp_inline__location="../dragon.tex:122790";
 \\ Return a bit mask of all bits of n up to its highest.
 \\ Eg. 1001 -> 1111.
 mask_to_high_bit(n) = if(n, (2<<logint(n,2)) - 1);

gp_inline__location="../dragon.tex:122957";
 ffixed_w_starting_by_search(w) = {
   for(s=1,w,
     my(sw=s);
     while(sw <=w,
       if(sw==w, return(s));
       sw=ceil(3/2*sw)));
   error("oops");
 }

gp_inline__location="../dragon.tex:122968";
 ffixed_w_starting(w) = while(w%3!=1, w=floor(2/3*w)); w;

gp_inline__location="../dragon.tex:123023";
 ffixed_du_of_w_samples = {[4,8,12,24,48,92,180,356,712,1424]};

gp_inline__location="../dragon.tex:123079";
 du4pred(m) = {
   m>=0 || error("du4pred() is for m>=0");
   m==0
   || (TernaryLowestNon0(m) + TernaryCountLow0s(m)) % 2;
 }
 TernaryLowestNon0(n) = {
   n>=1 || error("TernaryLowestNon0() is for n>=1");
   while(n%3==0, n\=3); n%3;
 }
 TernaryCountLow0s(n) = {
   n>=1 || error("TernaryCountLow0s() is for n>=1");
   valuation(n,3);
 }

gp_inline__location="../dragon.tex:123095";
 TernaryLowestNon2(n) = while(n%3==2, n\=3); n%3;
 TernaryCountLow2s(n) = my(ret=0); while(n%3==2, ret++;n\=3); ret;

gp_inline__location="../dragon.tex:123102";
 du4pred_samples = {[1,1,0,0,1,0,1,1,0,1,1,0,0,1,0]};

gp_inline__location="../dragon.tex:123119";
 du4pred_eq1_samples = {[0,1,4,6,7,9,10,13,15,16,19,22,24,25]};

gp_inline__location="../dragon.tex:123134";
 du4pred_eq0_samples = {[2,3,5,8,11,12,14,17,18,20,21,23,26]};

gp_inline__location="../dragon.tex:123148";
 TernaryLowestNon0_samples = {[1,2,1,1,2,2,1,2,1,1,2]};

gp_inline__location="../dragon.tex:123162";
 TernaryCountLow0s_samples = {[0,0,1,0,0,1,0,0,2,0,0]};

gp_inline__location="../dragon.tex:123307";
 du4pred_by_expansions(k) = {
   my(v=[1]);
   for(i=1,k,
     v=concat(apply(b->if(b==0,[1,1,0],[0,1,0]), v)));
   v;
 }

gp_inline__location="../dragon.tex:123340";
 \\ from my terdragon.tex
 AltTurnLpred_samples = [ 1,0,0,1,0,1,1,0,1,1,0,0,1,0,1,1,0 ];

gp_inline__location="../dragon.tex:123361";
 AltTerdragonDir(n) = {
   my(v=digits(n,3));
   sum(i=0,#v-1, if(v[#v-i]==1, if(i%2==0, 1, -1)));
 }

gp_inline__location="../dragon.tex:123385";
 \\ Return a vector of len many values of l_m, starting from l_0.
 ffixed_l_vector(len) = {
   my(v=ffixed_du_vector(2*len-1));
   vector(len,j,j--; v[2*j +1]);
 }

gp_inline__location="../dragon.tex:123412";
 ffixed_l(j) = ffixed_du(2*j);

gp_inline__location="../dragon.tex:123418";
 ffixed_l_samples = {[4,8,4,4,48,4,92,8,4,180,8,4,4,32,4]};

gp_inline__location="../dragon.tex:123445";
 l4pred(j) = {
   j>=0 || error("l4pred() is for j>=0");
   j==0
   || (1 - du4pred(j));
 }

gp_inline__location="../dragon.tex:123462";
 l4pred_samples = {[1,0,1,1,0,1,0,0,1,0,0,1,1,0,1]};

gp_inline__location="../dragon.tex:123486";
 l4pred_by_expansions(k) = {
   my(v=[1]);
   for(i=1,k,
     v=concat(apply(b->if(b==0,[1,0,1],[0,0,1]), v)));
   v;
 }

gp_inline__location="../dragon.tex:123524";
 evenoddtree_vpar(rows) = {
   if(rows<=0, return([]));
   my(vpar=List([0]), p=0, width=1);
   for(i=2,rows,
     my(new_end=#vpar);
     for(j=1,width,
       listput(vpar,p++);
       if(j%2, listput(vpar,p)));
     width=ceil(3/2*width));
   Vec(vpar);
 }

gp_inline__location="../dragon.tex:123560";
 evenoddtree_matchnum(n) = {
   \\ rows 0 to n-1 inclusive
   my(ret=0);
   forstep(j=n-2,0,-2, ret += ffixed_row_w(j));
   ret;
 }

gp_inline__location="../dragon.tex:123584";
 evenoddtree_indnum(n) = evenoddtree_matchnum(n+1);

gp_inline__location="../dragon.tex:123603";
 evenoddtree_domnum(n) = {
   \\ rows 0 to n-1 inclusive
   my(ret=if(n%3==1,1,0));
   forstep(j=n-2,0,-3, ret += ffixed_row_w(j));
   ret;
 }

gp_inline__location="../dragon.tex:123627";
 ffixed_se_unexpand_odd_index(j) = (2*j-1)/3;

gp_inline__location="../dragon.tex:123647";
 \\ Return a vector length "len" of ffixed gap lengths.
 ffixed_g_vector(len) = {
   my(v=ffixed_du_vector(2*len+2));
   vector(len,j,j--; v[2*j+1 +1]);
 }

gp_inline__location="../dragon.tex:123663";
 ffixed_g(j) = ffixed_du(2*j+1);

gp_inline__location="../dragon.tex:123669";
 ffixed_g_samples = {[4,12,24,4,4,8,4,4,16,4,12,8,4,356,8]};

gp_inline__location="../dragon.tex:123703";
 g4pred(j) = \
   (1/2*TernaryLowestNon1(j) + 1 + TernaryCountLow1s(j)) % 2;
 TernaryLowestNon1(n) = {
   n>=0 || error("TernaryLowestNon1() is for n>=0");
   while(n%3==1, n\=3); n%3;
 }
 TernaryCountLow1s(n) = {
   n>=0 || error("TernaryCountLow1s() is for n>=0");
   my(ret=0); while(n%3==1, n\=3;ret++); ret;
 }
 A253786(n) = valuation(2*n-1,3);

gp_inline__location="../dragon.tex:123732";
 g4pred_samples = {[1,0,0,1,1,0,1,1,0,1,0,0,1,0,0]};

gp_inline__location="../dragon.tex:123749";
 A189706(n) = {
   n>=1 || error("A189706() is for n>=0");
   n--; my(ret=0); while(n%3==1, n\=3; ret=!ret); if(n%3==0,ret,!ret);
 }

gp_inline__location="../dragon.tex:123763";
 ffixed_geq4_j_samples = {[0,3,4,6,7,9,12,15,16,18,21,24,25,27]};

gp_inline__location="../dragon.tex:123775";
 ffixed_gne4_j_samples = {[1,2,5,8,10,11,13,14,17,19,20,22,23,26]};

gp_inline__location="../dragon.tex:123787";
 TernaryLowestNon1_samples = {[0,0,2,0,0,2,0,2,2,0,0]};

gp_inline__location="../dragon.tex:123800";
 TernaryCountLow1s_samples = {[0,1,0,0,2,0,0,1,0,0,1]};

gp_inline__location="../dragon.tex:123839";
 ternary_1s(k) = (3^k-1)/2;

gp_inline__location="../dragon.tex:123846";
 \\ Return 1 if n in ternary is all 1-digits.
 \\ n=0 is reckoned as no digits and the return is true,
 \\ being 0 many 1-digits.
 is_ternary_all_1s(n) = {
   my(v=digits(n,3));
   for(i=1,#v, if(v[i]!=1, return(0)));
   1;
 }

gp_inline__location="../dragon.tex:123863";
 A113047(n) = (binomial(3*n,n)/(2*n+1)) % 3;

gp_inline__location="../dragon.tex:123869";
 ploth_dir_func(len,dir_func,p=I) = {
   my(x=vector(len), y=x, z=0);
   for(i=0,len-1,
     x[i+1]=real(z); y[i+1]=imag(z);
     z += p^dir_func(i));
   plothraw(x,y,1);
 }

gp_inline__location="../dragon.tex:123880";
 ploth_turn_func(len,turn_func,p=I) = {
   my(x=vector(len), y=x, d=0, z=0);
   for(i=1,len,
     x[i]=real(z); y[i]=imag(z);
     z += p^d;
     d += turn_func(i));
   plothraw(x,y,1);
 }

gp_inline__location="../dragon.tex:123894";
 TernaryFlip01(n) = {
   my(v=digits(n,3));
   for(i=1,#v, if(v[i]!=2, v[i]=1-v[i]));
   fromdigits(v,3);
 }

gp_inline__location="../dragon.tex:123942";
 AltDir(n) = {
   my(v=digits(n,3));
   sum(i=0,#v-1, if(v[#v-i]==1, if(i%2==0, 1, -1)));
 }

gp_inline__location="../dragon.tex:123984";
 one_minus_ffixed_binary_sample = {(000101111000000101111/100000000000000000000)};

gp_inline__location="../dragon.tex:123990";
 one_minus_ffixed_binary_sample_in_binary = \
   from_binary(one_minus_ffixed_binary_sample*10^20) / 2^20;

gp_inline__location="../dragon.tex:124000";
 one_minus_ffixed_decimal_sample = {(0183639523/1000000000)};

gp_inline__location="../dragon.tex:124106";
 hull_fractal_second_half = apply(z->1+z, hull_fractal/b/I);

gp_inline__location="../dragon.tex:124349";
 \\ draw_direction = 1,I,-1,-I direction
 \\ draw_list = List() of complex number points, starting at 0
 \\
 draw_start() = draw_list=List([0]); draw_direction=1;
 draw_line_segment() = listput(draw_list, draw_list[#draw_list] + draw_direction);
 draw_turn_left() = draw_direction *= I;
 draw_turn_right() = draw_direction *= -I;
 draw_turn(direction) = draw_direction *= I^direction;

gp_inline__location="../dragon.tex:124358";
 draw_turns_points(k) = {
   draw_start();
   for(n=1,2^k,
       draw_line_segment();
       if(BitAboveLowestOne(n)==0, draw_turn_left(),
                                   draw_turn_right()));
   Vec(draw_list);
 }

gp_inline__location="../dragon.tex:124444";
 draw_mutual_left(k) = {
   if(k==0, draw_line_segment(),
      draw_mutual_left(k-1);
      draw_turn_left();
      draw_mutual_right(k-1));
 }
 draw_mutual_right(k) = {
   if(k==0, draw_line_segment(),
      draw_mutual_left(k-1);
      draw_turn_right();
      draw_mutual_right(k-1));
 }
 draw_mutual_points(k) = \
   draw_start(); draw_mutual_left(k); Vec(draw_list);

gp_inline__location="../dragon.tex:124483";
 draw_parameter(k,turn) = {
   if(k==0, draw_line_segment(),
      draw_parameter(k-1, 1);
      draw_turn(turn);
      draw_parameter(k-1, -1));
 }
 draw_parameter_points(k) = \
   draw_start(); draw_parameter(k,1); Vec(draw_list);

gp_inline__location="../dragon.tex:124613";
 draw_towards_middle(k,start,end) = \
   if(k==0, listput(draw_list,[start,end]), \
      my(middle= 1/2*(end+start) - I*1/2*(end-start)); \
      draw_towards_middle(k-1,start,middle); \
      draw_towards_middle(k-1,end,  middle));
 draw_towards_middle_points(k) = draw_list=List([]); \
   draw_towards_middle(k,0,b^k); \
   draw_list=Vec(draw_list); \
   Vec(draw_list);
 dragon_segments(k) = my(v=dragon_points(k)); \
   vector(#v-1,i, [ v[i],v[i+1] ]);
 segments_vector_sort(v) = vecsort(apply((s)->vecsort(s,cmp),v), cmp);

gp_inline__location="../dragon.tex:124628";
 UnGray(g) = {
   my(v=binary(g),r=0);
   for(i=2,#v,  \\ high to low
       v[i] = bitxor(v[i],v[i-1]));
   fromdigits(v,2);
 }

gp_inline__location="../dragon.tex:124692";
 gen_plotter_k = 3;
 gen_plotter_middle_n_sequence = [0,1,3,2,7,6,4,5];
 gen_plotter_move_norms = [0,1,5,1,5,1,5,1];

gp_inline__location="../dragon.tex:124739";
 Endf = {(3-I)/(5)};

gp_inline__location="../dragon.tex:124745";
 End(k) = {
   k>=0 || error("End() is for k>=0");
   (3-I)/5*b^k + (2+I)/5*(-I)^k;
 }

gp_inline__location="../dragon.tex:124751";
 End_samples = {[1,1,I,-1+2*I,-2+I,-3-2*I,-2-5*I,3-6*I]};

gp_inline__location="../dragon.tex:124785";
 EndN(k) = {
   k>=0 || error("EndN() is for k>=0");
   2/3*2^k + 1/3*(-1)^k;
 }

gp_inline__location="../dragon.tex:124795";
 EndN_samples = {[1,1,3,5,11,21,43,85,171,341,683]};

gp_inline__location="../dragon.tex:124810";
 EndN_binary_vector(k) = {
   if(k==0,return([1]));
   my(end=vector_modulo([[1,1],[1]],k));
   k -= #end;
   concat([ concat_repeat([1,0], k/2), end ]);
 }

gp_inline__location="../dragon.tex:124852";
 MoveEnd(k) = if(k==0,0,  b^k - End(k-1));

gp_inline__location="../dragon.tex:124867";
 Move(k) = {
   if(k==0,0,
     2*Move(k-1)
     + MaxReIm(MoveEnd(k)));
 }
 Move = memoize(Move);

gp_inline__location="../dragon.tex:124885";
 MaxReIm(z) = max(abs(real(z)),abs(imag(z)));

gp_inline__location="../dragon.tex:124890";
 move_max_half = {[2,(14)/(5)]};

gp_inline__location="../dragon.tex:124897";
 move_max_constant = {[5,-7,20,6,-5,7,-20,-6]};

gp_inline__location="../dragon.tex:124904";
 Move_formula(k) = {
   33/17 * 2^k
   - vector_modulo(move_max_half,k)*2^floor(k/2)
   + 1/85 * vector_modulo(move_max_constant,k);
 }

gp_inline__location="../dragon.tex:124912";
 Move_samples = {[0,1,4,10,23,51,108,226,465,949,1924,3886,7823]};

gp_inline__location="../dragon.tex:124938";
 End_k1(k) = if(k==0,1, k==1,1+I, b^k + (-I)*End_k1(k-1));
 End_k1_formula(k) = if(k==0,1, (3-I)/5*b^k + (-3+I)/5*(-I)^k);

gp_inline__location="../dragon.tex:124942";
 Move_k1(k) = {
   if(k==0,0,
      k==1,0,
      2*Move_k1(k-1)
      + MaxReIm(b^k - End_k1(k-1)));
 }
 Move_k1 = memoize(Move_k1);

gp_inline__location="../dragon.tex:124950";
 Move_k1_formula(k) = {
   if(k==0,return(0));
   45/34 * 2^k
   - vector_modulo([ 2, 14/5 ],k)*2^floor(k/2)
   + vector_modulo([3/17, 13/85, -5/17, 1/85, -3/17, -13/85, 5/17, -1/85],k);
 }

gp_inline__location="../dragon.tex:124969";
 MoveEnd_norm(k) = {
  4/5 * (2^k
         + vector_modulo([0,-1,+1,-1, 0,1,-1,1],k)*2^floor(k/2)
         + 1/4);
 }

gp_inline__location="../dragon.tex:124985";
 MoveDist_inexact(k) = sum(j=0,k-1, 2^j * abs(MoveEnd(k-j)));

gp_inline__location="../dragon.tex:124995";
 \\ Return a vector of quads whose sum is MoveDist(k).
 MoveDist_as_quads(k) = {
   my(v=vector(k,j,j--;  \\ j=0 to k-1 inclusive
               2^j * geom_abs(MoveEnd(k-j))));
   v = Vecrev(v);     \\ low to high discriminants
   if(#v>=3, v[2] += v[3]; v=v[^3]);   \\ combine 2nd and 3rd
   v;
 }

gp_inline__location="../dragon.tex:125027";
 MoveMean_inexact(k) = MoveDist_inexact(k) / (2^k - 1);

gp_inline__location="../dragon.tex:125040";
 MoveMean_inexact_by_b(k) = {
   2^k / (2^k - 1)
   * sum(j=1,k, abs( (4-2*I)/5*1/b^j + (1+2*I)/5*1/(-2*I)^j));
 }

gp_inline__location="../dragon.tex:125058";
 MoveMean_vector = {[0,-1,1,-1,0,1,-1,1]};

gp_inline__location="../dragon.tex:125069";
 MoveMean_root_part(j) = {
   1 + vector_modulo(MoveMean_vector,j) * 1/2^ceil(j/2)
     + 1/4 * 1/2^j;
 }
 MoveMean_inexact_by_sum(k) = {
   2^k / (2^k - 1)
   * 2/sqrt(5)
   * sum(j=1,k, 1/sqrt(2)^j * sqrt(MoveMean_root_part(j)));
 }

gp_inline__location="../dragon.tex:125082";
 MoveMean_limit = MoveMean_inexact(1000);

gp_inline__location="../dragon.tex:125086";
 MoveMean_limit_sample = {(2109117/1000000)};

gp_inline__location="../dragon.tex:125178";
another_Edist_limit_sample = {(1374368/1000000)};

gp_inline__location="../dragon.tex:125185";
 hull_vertex_max_0 = geom_sqrt_as_quad(vecmax(apply(norm,Benedek_Panzone_hull),&hull_vertex_max_0_p));
 hull_vertex_max_1 = geom_sqrt_as_quad(vecmax(apply(z->norm(1-z),Benedek_Panzone_hull),&hull_vertex_max_1_p));

gp_inline__location="../dragon.tex:125319";
 R_lsys_map = {Map(["R", ["R","F", "+", "L"];
                    "L", ["T","F","-"];
                    "T", ["R","F","+", "U","F","-"];
                    "U", ["V","F","-","F","-","F","+"];
                    "V", ["T","F","-","F","+","V"]
                    ])};
 R_lsys(k,v=["R","F"]) = {
   for(i=1,k,
     v=concat(apply(s-> my(to);
                        if(mapisdefined(R_lsys_map,s,&to),to,[s]),
                    v)));
   v;
 }

gp_inline__location="../dragon.tex:125386";
 Rturn_vector_by_lsys(k) = \
   concat(apply(s->if(s=="+",[1], s=="-",[-1], []), R_lsys(k)));

gp_inline__location="../dragon.tex:125418";
 \\ turn +1 left or -1 right after segment type
 Rpred_state_to_turn = {[
    1,  \\ 1e
    1,  \\ 1o
   -1,  \\ 2eA
    1,  \\ 2eB
   -1,  \\ 3oA
   -1,  \\ 3oB
    1,  \\ 3oC
   -1,  \\ 3eA
   -1,  \\ 3eB
    1,  \\ 3eC
    0   \\ non
 ]};

gp_inline__location="../dragon.tex:125433";
 \\ Return a vector of the Rpred state of each segment
 \\ n=0 to n=2^k-1 in curve level k.
 Rpred_states_vector(k) = {
   my(v=[Rpred_1e]);
   for(i=1,k,
     v=concat(apply(state->Rpred_state_table[state,], v)));
   v;
 }

gp_inline__location="../dragon.tex:125444";
 Rturn_vector_by_Rpred_states(k) = {
   my(v=Rpred_states_vector(k));
   v=select(state->state!=Rpred_non, v);
   apply(state->Rpred_state_to_turn[state], v[^#v]);
 }

gp_inline__location="../dragon.tex:125544";
 TconnRQ(k) = RQ(k) + LQ(k) + RQ(k) - JA(k);

gp_inline__location="../dragon.tex:125550";
 TconnRQ_samples = {[3,5,8,13,22,37,62,105,178,301,510]};

gp_inline__location="../dragon.tex:125912";
 skin_C(k) = if(k<=0,1, skin_C(k-1) + 2*skin_C(k-3));
 skin_C = memoize(skin_C);

gp_inline__location="../dragon.tex:128201";
 BlobMid_limit = (BlobStart_limit + BlobEnd_limit)/2;

gp_inline__location="../dragon.tex:128492";

 \\ Kempner-Mahler number continued fraction terms cumulative
 A073088(n) = {
   n>=1 || error("A073088() is for n>=1");
   if(n==1,0, 2*TurnRunStart(n-2) - 1);
 }

gp_inline__location="../dragon.tex:128538";
 A073089(n) = {
   n>=1 || error("A073089() is for n>=1");
   if(n==1,0, (n + BitAboveLowestOne(n-1)) % 2);
 }

gp_inline__location="../dragon.tex:129399";
 PlusRadius(k) = {
   my(r=0);
   for(n=0,2^k-1,
       my(nr=norm(PlusPoint(n)));
       if(nr>r, r=nr);
      );
   r;
 }

gp_inline__location="../dragon.tex:129436";
 \\ is_variable(str) returns true if str is the name of a variable,
 \\ meaning a "foo" not equal to its own symbol 'foo.
 is_variable(str) = eval(str)!=eval(Str("'",str));

gp_inline__location="../dragon.tex:129441";
 \\ exceptions b=1+I, p(k), r, s(m).
 char_variables_allowed = Set(["b","p","r","s"]);
 check_char_variables() = {
   my(char_variables_ok = 1);
   for(ch=Vecsmall("a")[1], Vecsmall("z")[1],
       my(str = Strchr(ch));
       if(is_variable(str) && ! setsearch(char_variables_allowed,str),
          print(str," = ",eval(str)); char_variables_ok = 0));
   char_variables_ok;
 }

kill(gp_inline__location);
